/*===========================================================================*/
/*   (Eval/evaluate_comp.scm)                                                */
/*   Bigloo (4.3h)                                                           */
/*   Inria -- Sophia Antipolis (c)       Mon 11 May 2020 12:14:39 PM CEST    */
/*===========================================================================*/
/* COMPILATION: (/home/serrano/prgm/project/bigloo/bigloo/bin/bigloo -srfi enable-gmp -srfi bigloo-unsafe -O3 -fcfa-arithmetic -q -lib-dir /home/serrano/prgm/project/bigloo/bigloo/lib/bigloo/4.3h -rm -copt -w -lib-dir /home/serrano/prgm/project/bigloo/bigloo/lib/bigloo/4.3h -mklib -cc gcc -fsharing -q -no-hello -unsafe -safee -O4 -c Eval/evaluate_comp.scm -indent -o objs/obj_u/Eval/evaluate_comp.c) */
/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo.h>

#ifdef __cplusplus
extern "C"
{
#endif

/* object type definitions */
	typedef struct BgL_ev_exprz00_bgl
	{
		header_t header;
		obj_t widening;
	}                 *BgL_ev_exprz00_bglt;

	typedef struct BgL_ev_varz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_namez00;
		obj_t BgL_effz00;
		obj_t BgL_typez00;
	}                *BgL_ev_varz00_bglt;

	typedef struct BgL_ev_globalz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		obj_t BgL_namez00;
		obj_t BgL_modz00;
	}                   *BgL_ev_globalz00_bglt;

	typedef struct BgL_ev_littz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_valuez00;
	}                 *BgL_ev_littz00_bglt;

	typedef struct BgL_ev_ifz00_bgl
	{
		header_t header;
		obj_t widening;
		struct BgL_ev_exprz00_bgl *BgL_pz00;
		struct BgL_ev_exprz00_bgl *BgL_tz00;
		struct BgL_ev_exprz00_bgl *BgL_ez00;
	}               *BgL_ev_ifz00_bglt;

	typedef struct BgL_ev_listz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_argsz00;
	}                 *BgL_ev_listz00_bglt;

	typedef struct BgL_ev_orz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_argsz00;
	}               *BgL_ev_orz00_bglt;

	typedef struct BgL_ev_andz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_argsz00;
	}                *BgL_ev_andz00_bglt;

	typedef struct BgL_ev_prog2z00_bgl
	{
		header_t header;
		obj_t widening;
		struct BgL_ev_exprz00_bgl *BgL_e1z00;
		struct BgL_ev_exprz00_bgl *BgL_e2z00;
	}                  *BgL_ev_prog2z00_bglt;

	typedef struct BgL_ev_hookz00_bgl
	{
		header_t header;
		obj_t widening;
		struct BgL_ev_exprz00_bgl *BgL_ez00;
	}                 *BgL_ev_hookz00_bglt;

	typedef struct BgL_ev_trapz00_bgl
	{
		header_t header;
		obj_t widening;
		struct BgL_ev_exprz00_bgl *BgL_ez00;
	}                 *BgL_ev_trapz00_bglt;

	typedef struct BgL_ev_setlocalz00_bgl
	{
		header_t header;
		obj_t widening;
		struct BgL_ev_exprz00_bgl *BgL_ez00;
		struct BgL_ev_varz00_bgl *BgL_vz00;
	}                     *BgL_ev_setlocalz00_bglt;

	typedef struct BgL_ev_setglobalz00_bgl
	{
		header_t header;
		obj_t widening;
		struct BgL_ev_exprz00_bgl *BgL_ez00;
		obj_t BgL_locz00;
		obj_t BgL_namez00;
		obj_t BgL_modz00;
	}                      *BgL_ev_setglobalz00_bglt;

	typedef struct BgL_ev_defglobalz00_bgl
	{
		header_t header;
		obj_t widening;
		struct BgL_ev_exprz00_bgl *BgL_ez00;
		obj_t BgL_locz00;
		obj_t BgL_namez00;
		obj_t BgL_modz00;
	}                      *BgL_ev_defglobalz00_bglt;

	typedef struct BgL_ev_bindzd2exitzd2_bgl
	{
		header_t header;
		obj_t widening;
		struct BgL_ev_varz00_bgl *BgL_varz00;
		struct BgL_ev_exprz00_bgl *BgL_bodyz00;
	}                        *BgL_ev_bindzd2exitzd2_bglt;

	typedef struct BgL_ev_unwindzd2protectzd2_bgl
	{
		header_t header;
		obj_t widening;
		struct BgL_ev_exprz00_bgl *BgL_ez00;
		struct BgL_ev_exprz00_bgl *BgL_bodyz00;
	}                             *BgL_ev_unwindzd2protectzd2_bglt;

	typedef struct BgL_ev_withzd2handlerzd2_bgl
	{
		header_t header;
		obj_t widening;
		struct BgL_ev_exprz00_bgl *BgL_handlerz00;
		struct BgL_ev_exprz00_bgl *BgL_bodyz00;
	}                           *BgL_ev_withzd2handlerzd2_bglt;

	typedef struct BgL_ev_synchroniza7eza7_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_ev_exprz00_bgl *BgL_mutexz00;
		struct BgL_ev_exprz00_bgl *BgL_prelockz00;
		struct BgL_ev_exprz00_bgl *BgL_bodyz00;
	}                          *BgL_ev_synchroniza7eza7_bglt;

	typedef struct BgL_ev_binderz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_varsz00;
		obj_t BgL_valsz00;
		struct BgL_ev_exprz00_bgl *BgL_bodyz00;
	}                   *BgL_ev_binderz00_bglt;

	typedef struct BgL_ev_letz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_varsz00;
		obj_t BgL_valsz00;
		struct BgL_ev_exprz00_bgl *BgL_bodyz00;
		obj_t BgL_boxesz00;
	}                *BgL_ev_letz00_bglt;

	typedef struct BgL_ev_letza2za2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_varsz00;
		obj_t BgL_valsz00;
		struct BgL_ev_exprz00_bgl *BgL_bodyz00;
		obj_t BgL_boxesz00;
	}                   *BgL_ev_letza2za2_bglt;

	typedef struct BgL_ev_letrecz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_varsz00;
		obj_t BgL_valsz00;
		struct BgL_ev_exprz00_bgl *BgL_bodyz00;
	}                   *BgL_ev_letrecz00_bglt;

	typedef struct BgL_ev_labelsz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_varsz00;
		obj_t BgL_valsz00;
		obj_t BgL_envz00;
		obj_t BgL_stkz00;
		struct BgL_ev_exprz00_bgl *BgL_bodyz00;
		obj_t BgL_boxesz00;
	}                   *BgL_ev_labelsz00_bglt;

	typedef struct BgL_ev_gotoz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_ev_varz00_bgl *BgL_labelz00;
		struct BgL_ev_labelsz00_bgl *BgL_labelsz00;
		obj_t BgL_argsz00;
	}                 *BgL_ev_gotoz00_bglt;

	typedef struct BgL_ev_appz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_ev_exprz00_bgl *BgL_funz00;
		obj_t BgL_argsz00;
		obj_t BgL_tailzf3zf3;
	}                *BgL_ev_appz00_bglt;

	typedef struct BgL_ev_absz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		obj_t BgL_wherez00;
		obj_t BgL_arityz00;
		obj_t BgL_varsz00;
		struct BgL_ev_exprz00_bgl *BgL_bodyz00;
		int BgL_siza7eza7;
		obj_t BgL_bindz00;
		obj_t BgL_freez00;
		obj_t BgL_innerz00;
		obj_t BgL_boxesz00;
	}                *BgL_ev_absz00_bglt;


	static obj_t BGl_z62zc3z04anonymousza33199ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	BGL_EXPORTED_DECL obj_t
		BGl_compilez00zz__evaluate_compz00(BgL_ev_exprz00_bglt);
	static obj_t BGl_z62zc3z04anonymousza33750ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza33661ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza33629ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza33467ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_compzd2oldzd2callz00zz__evaluate_compz00(BgL_ev_appz00_bglt,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza32950ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza32861ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza32845ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza32756ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza32829ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	extern obj_t BGl_ev_letrecz00zz__evaluate_typesz00;
	static obj_t BGl_z62zc3z04anonymousza33010ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza33915ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza32773ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza31777ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	extern obj_t BGl_ev_letz00zz__evaluate_typesz00;
	static obj_t BGl_subzd2stkzd2zz__evaluate_compz00(obj_t, obj_t);
	extern bool_t BGl_integerzf3zf3zz__r4_numbers_6_5_fixnumz00(obj_t);
	static obj_t BGl_z62zc3z04anonymousza33827ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza33738ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	extern obj_t BGl_assqz00zz__r4_pairs_and_lists_6_3z00(obj_t, obj_t);
	static obj_t BGl_Eze70ze7zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62zc3z04anonymousza33933ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza32880ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza31973ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_objectzd2initzd2zz__evaluate_compz00();
	static obj_t BGl_z62zc3z04anonymousza33577ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	extern obj_t BGl_2za2za2zz__r4_numbers_6_5z00(obj_t, obj_t);
	extern obj_t BGl_2zb2zb2zz__r4_numbers_6_5z00(obj_t, obj_t);
	extern obj_t BGl_2zd2zd2zz__r4_numbers_6_5z00(obj_t, obj_t);
	extern obj_t BGl_2zf2zf2zz__r4_numbers_6_5z00(obj_t, obj_t);
	static obj_t BGl_z62zc3z04anonymousza32017ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	extern bool_t BGl_2zc3zc3zz__r4_numbers_6_5z00(obj_t, obj_t);
	extern bool_t BGl_2zd3zd3zz__r4_numbers_6_5z00(obj_t, obj_t);
	extern bool_t BGl_2ze3ze3zz__r4_numbers_6_5z00(obj_t, obj_t);
	extern obj_t BGl_memqz00zz__r4_pairs_and_lists_6_3z00(obj_t, obj_t);
	static obj_t BGl_z62zc3z04anonymousza33861ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza32865ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza32849ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza31958ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza33489ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62compzd2ev_or1413zb0zz__evaluate_compz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza32971ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza31991ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza32793ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza32777ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_symbol5801z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_symbol5803z00zz__evaluate_compz00 = BUNSPEC;
	extern obj_t bstring_to_symbol(obj_t);
	static obj_t BGl_symbol5809z00zz__evaluate_compz00 = BUNSPEC;
	extern bool_t BGl_isazf3zf3zz__objectz00(obj_t, obj_t);
	extern obj_t make_vector(long, obj_t);
	static obj_t BGl_symbol5817z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_symbol5819z00zz__evaluate_compz00 = BUNSPEC;
	extern obj_t BGl_ev_labelsz00zz__evaluate_typesz00;
	static obj_t BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_bindzd2framezd2zz__evaluate_compz00(obj_t, obj_t, long, long,
		obj_t, obj_t);
	static obj_t BGl_z62zc3z04anonymousza33953ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_appendzd221011zd2zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_methodzd2initzd2zz__evaluate_compz00();
	static obj_t BGl_symbol5821z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_recze70ze7zz__evaluate_compz00(obj_t, obj_t, long);
	static obj_t BGl_symbol5824z00zz__evaluate_compz00 = BUNSPEC;
	static bool_t BGl_recze71ze7zz__evaluate_compz00(obj_t);
	static obj_t BGl_symbol5827z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_z62zc3z04anonymousza33106ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_symbol5829z00zz__evaluate_compz00 = BUNSPEC;
	extern obj_t BGl_ev_absz00zz__evaluate_typesz00;
	static obj_t BGl_z62zc3z04anonymousza32974ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza33776ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza32869ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	extern obj_t BGl_everrorz00zz__everrorz00(obj_t, obj_t, obj_t, obj_t);
	static obj_t BGl_symbol5831z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_symbol5833z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_symbol5835z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_symbol5837z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_symbol5839z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_z62zc3z04anonymousza32959ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza33688ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza32797ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_symbol5841z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_symbol5843z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_symbol5845z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_symbol5847z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_symbol5849z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_z62zc3z04anonymousza32039ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_reset_profilez00zz__evaluate_compz00();
	static obj_t BGl_freezd2collectzd2zz__evaluate_compz00(obj_t, obj_t, obj_t);
	static obj_t BGl_z62zc3z04anonymousza31996ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_symbol5851z00zz__evaluate_compz00 = BUNSPEC;
	extern obj_t BGl_ev_ifz00zz__evaluate_typesz00;
	static obj_t BGl_symbol5853z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_symbol5855z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_symbol5857z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_z62zc3z04anonymousza33036ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_symbol5859z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_z62zc3z04anonymousza32993ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_symbol5861z00zz__evaluate_compz00 = BUNSPEC;
	extern obj_t BGl_errorz00zz__errorz00(obj_t, obj_t, obj_t);
	static obj_t BGl_symbol5863z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_z62zc3z04anonymousza33231ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_symbol5865z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_z62zc3z04anonymousza32324ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_symbol5867z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_z62zc3z04anonymousza32146ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_symbol5869z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_z62compzd2ev_labels1433zb0zz__evaluate_compz00(obj_t, obj_t,
		obj_t);
	extern obj_t BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00(obj_t, long, obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62zc3z04anonymousza32978ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62exitz62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_symbol5871z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_z62zc3z04anonymousza33321ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_symbol5873z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_symbol5875z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_symbol5877z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_symbol5879z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_catchzd2trampolinezd2zz__evaluate_compz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_symbol5881z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_symbol5883z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_symbol5885z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_symbol5887z00zz__evaluate_compz00 = BUNSPEC;
	extern obj_t BGl_ev_gotoz00zz__evaluate_typesz00;
	static obj_t BGl_symbol5889z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_z62zc3lexintza1zz__evaluate_compz00(obj_t, obj_t, obj_t);
	static obj_t BGl_z62zc3z04anonymousza33976ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_symbol5891z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_symbol5893z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_z62zc3z04anonymousza33307ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_ozd2ze3sze70zd6zz__evaluate_compz00(obj_t);
	static obj_t BGl_z62runz62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62zc3z04anonymousza33799ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_zc3z04exitza33331ze3ze70z60zz__evaluate_compz00(obj_t, obj_t,
		obj_t);
	extern obj_t BGl_unwindzd2untilz12zc0zz__bexitz00(obj_t, obj_t);
	static obj_t BGl_z62zc3z04anonymousza33889ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	extern bool_t BGl_numberzf3zf3zz__r4_numbers_6_5z00(obj_t);
	static obj_t BGl_z62zc3z04anonymousza33341ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static double BGl_evalzd2floatzd2arithz00zz__evaluate_compz00(obj_t, obj_t);
	extern int bgl_debug();
	extern obj_t BGl_ev_orz00zz__evaluate_typesz00;
	static obj_t BGl_pushzd2boxeszd2argszd2onzd2spz00zz__evaluate_compz00(obj_t,
		obj_t, obj_t, long, obj_t);
	extern obj_t BGl_ev_varz00zz__evaluate_typesz00;
	extern obj_t create_struct(obj_t, int);
	static obj_t BGl_z62compzd2ev_bindzd2exit1425z62zz__evaluate_compz00(obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62zc3z04anonymousza32362ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_get_profilez00zz__evaluate_compz00();
	extern obj_t BGl_evarityzd2errorzd2zz__everrorz00(obj_t, obj_t, int, int);
	extern long bgl_list_length(obj_t);
	static obj_t BGl_z62zc3z04anonymousza33270ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_gczd2rootszd2initz00zz__evaluate_compz00();
	extern obj_t BGl_evwarningz00zz__everrorz00(obj_t, obj_t);
	static obj_t BGl_z62zc3z04anonymousza33997ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static bool_t BGl_needzd2shiftzd2zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62run5710z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62run5712z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62run5714z62zz__evaluate_compz00(obj_t, obj_t);
	extern obj_t BGl_evmodulezd2findzd2globalz00zz__evmodulez00(obj_t, obj_t);
	extern obj_t BGl_ev_andz00zz__evaluate_typesz00;
	static obj_t BGl_z62run5716z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62run5718z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62zc3z04anonymousza33255ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza32364ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62compzd2ev_withzd2handler1429z62zz__evaluate_compz00(obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62zc3z04anonymousza33077ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62run5720z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62run5722z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62run5724z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62run5726z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62zc3z04anonymousza33450ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62run5728z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62run5730z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62mainz62zz__evaluate_compz00(obj_t, obj_t, obj_t, obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62run5732z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62run5734z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62zc3z04anonymousza33702ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62run5736z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62zc3z04anonymousza31831ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62run5738z62zz__evaluate_compz00(obj_t, obj_t);
	extern obj_t BGl_ev_appz00zz__evaluate_typesz00;
	static obj_t BGl_z62run5740z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62run5742z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_lnamez00zz__evaluate_compz00(obj_t);
	static obj_t BGl_z62run5744z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62zc3z04anonymousza33541ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62run5746z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62compzd2ev_letza21421z12zz__evaluate_compz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62run5748z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62zc3z04anonymousza33509ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza33169ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	extern obj_t BGl_genericzd2addzd2methodz12z12zz__objectz00(obj_t, obj_t,
		obj_t, obj_t);
	extern obj_t BGl_bigloozd2typezd2errorz00zz__errorz00(obj_t, obj_t, obj_t);
	static obj_t BGl_z62compzd2ev_litt1409zb0zz__evaluate_compz00(obj_t, obj_t,
		obj_t);
	extern obj_t BGl_exitdzd2popzd2protectz12z12zz__bexitz00(obj_t);
	static obj_t BGl_z62run5750z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62run5752z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62run5754z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62zc3z04anonymousza32813ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza31922ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62run5756z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62run5758z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62compz62zz__evaluate_compz00(obj_t, obj_t, obj_t);
	static obj_t BGl_z62zc3z04anonymousza32368ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	extern obj_t BGl_ev_synchroniza7eza7zz__evaluate_typesz00;
	extern obj_t BGl_uncompilez00zz__evaluate_uncompz00(BgL_ev_exprz00_bglt);
	static obj_t BGl_z62run5760z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62run5762z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62zc3z04anonymousza33810ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62run5764z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62run5766z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62run5768z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62main5709z62zz__evaluate_compz00(obj_t, obj_t, obj_t,
		obj_t, obj_t, obj_t);
	static obj_t BGl_z62run5770z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62run5772z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62run5774z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62zc3z04anonymousza31924ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62run5776z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62run5778z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62zc3z04anonymousza32548ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62main5711z62zz__evaluate_compz00(obj_t, obj_t, obj_t,
		obj_t, obj_t, obj_t);
	static obj_t BGl_z62main5713z62zz__evaluate_compz00(obj_t, obj_t, obj_t,
		obj_t, obj_t, obj_t);
	static obj_t BGl_z62main5715z62zz__evaluate_compz00(obj_t, obj_t, obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62main5717z62zz__evaluate_compz00(obj_t, obj_t, obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62main5719z62zz__evaluate_compz00(obj_t, obj_t, obj_t,
		obj_t, obj_t);
	extern obj_t BGl_evmodulezd2bindzd2globalz12z12zz__evmodulez00(obj_t, obj_t,
		obj_t, obj_t);
	extern obj_t BGl_usez00zz__evaluate_usez00(BgL_ev_exprz00_bglt, obj_t);
	static obj_t BGl_z62run5780z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62run5782z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62zc3z04anonymousza33561ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62run5784z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62run5786z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62run5788z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62main5721z62zz__evaluate_compz00(obj_t, obj_t, obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62main5723z62zz__evaluate_compz00(obj_t, obj_t, obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62main5725z62zz__evaluate_compz00(obj_t, obj_t, obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62main5727z62zz__evaluate_compz00(obj_t, obj_t, obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62main5729z62zz__evaluate_compz00(obj_t, obj_t, obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62run5790z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62run5792z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62zc3z04anonymousza33651ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza32833ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza31942ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62run5794z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62zc3z04anonymousza32817ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza33457ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_za2za2azd2labelza2za2zd2zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_z62main5731z62zz__evaluate_compz00(obj_t, obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62main5733z62zz__evaluate_compz00(obj_t, obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62main5735z62zz__evaluate_compz00(obj_t, obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62main5737z62zz__evaluate_compz00(obj_t, obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62main5739z62zz__evaluate_compz00(obj_t, obj_t, obj_t,
		obj_t);
	static obj_t
		BGl_iszd2constantzd2funzf3zf3zz__evaluate_compz00(BgL_ev_exprz00_bglt, long,
		obj_t, obj_t);
	static obj_t BGl_makezd2statezd2zz__evaluate_compz00();
	static obj_t BGl_z62zc3z04anonymousza33903ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza32761ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza31854ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza33385ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	extern obj_t BGl_ev_defglobalz00zz__evaluate_typesz00;
	static obj_t BGl_z62main5741z62zz__evaluate_compz00(obj_t, obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62main5743z62zz__evaluate_compz00(obj_t, obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62main5745z62zz__evaluate_compz00(obj_t, obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62main5747z62zz__evaluate_compz00(obj_t, obj_t, obj_t);
	static obj_t BGl_pushzd2nargszd2onzd2spzd2zz__evaluate_compz00(obj_t, obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62main5749z62zz__evaluate_compz00(obj_t, obj_t, obj_t);
	static obj_t BGl_z62compzd2ev_trap1395zb0zz__evaluate_compz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_requirezd2initializa7ationz75zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_z62zc3z04anonymousza33475ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza31928ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62main5751z62zz__evaluate_compz00(obj_t, obj_t, obj_t);
	static obj_t BGl_z62main5753z62zz__evaluate_compz00(obj_t, obj_t, obj_t);
	static obj_t BGl_z62main5755z62zz__evaluate_compz00(obj_t, obj_t, obj_t);
	static obj_t BGl_z62main5757z62zz__evaluate_compz00(obj_t, obj_t, obj_t);
	static obj_t BGl_z62main5759z62zz__evaluate_compz00(obj_t, obj_t, obj_t);
	extern obj_t BGl_typezd2errorzd2zz__errorz00(obj_t, obj_t, obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62main5761z62zz__evaluate_compz00(obj_t, obj_t, obj_t);
	static obj_t BGl_z62main5763z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62main5765z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62main5767z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62main5769z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62zc3z04anonymousza33001ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	extern obj_t BGl_registerzd2genericz12zc0zz__objectz00(obj_t, obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62compzd2ev_prog21417zb0zz__evaluate_compz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza33760ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza32853ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza32837ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza33639ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	extern obj_t BGl_listzd2ze3vectorz31zz__r4_vectors_6_8z00(obj_t);
	static obj_t BGl_z62main5771z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62main5773z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62main5775z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62main5777z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62main5779z62zz__evaluate_compz00(obj_t);
	static obj_t BGl_toplevelzd2initzd2zz__evaluate_compz00();
	static obj_t BGl_z62zc3z04anonymousza33850ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza32781ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza32765ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza33729ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62main5781z62zz__evaluate_compz00(obj_t);
	static obj_t BGl_z62main5783z62zz__evaluate_compz00(obj_t);
	static obj_t BGl_z62main5785z62zz__evaluate_compz00(obj_t);
	static obj_t BGl_z62main5787z62zz__evaluate_compz00(obj_t, obj_t, obj_t,
		obj_t, obj_t, obj_t);
	static obj_t BGl_z62main5789z62zz__evaluate_compz00(obj_t, obj_t, obj_t,
		obj_t, obj_t, obj_t);
	extern obj_t BGl_formatz00zz__r4_output_6_10_3z00(obj_t, obj_t);
	static obj_t BGl_z62zc3z04anonymousza32871ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	extern obj_t BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(obj_t, obj_t);
	static obj_t BGl_genericzd2initzd2zz__evaluate_compz00();
	extern obj_t BGl_stringzd2copyzd2zz__r4_strings_6_7z00(obj_t);
	static obj_t BGl_z62main5791z62zz__evaluate_compz00(obj_t, obj_t, obj_t,
		obj_t, obj_t, obj_t);
	static obj_t BGl_z62main5793z62zz__evaluate_compz00(obj_t, obj_t, obj_t,
		obj_t, obj_t, obj_t);
	extern obj_t BGl_ev_prog2z00zz__evaluate_typesz00;
	static obj_t BGl_z62zc3z04anonymousza32202ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza33004ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	extern obj_t BGl_evtypezd2errorzd2zz__everrorz00(obj_t, obj_t, obj_t, obj_t);
	extern obj_t BGl_ev_bindzd2exitzd2zz__evaluate_typesz00;
	static obj_t BGl_z62zc3z04anonymousza33837ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza32857ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza33497ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza31877ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	extern obj_t bgl_reverse_bang(obj_t);
	static long BGl_za2za2siza7ezd2stackza2za2z75zz__evaluate_compz00;
	static obj_t BGl_z62zc3z04anonymousza33022ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza32204ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza32874ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza32785ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza33587ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza32769ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	extern obj_t BGl_ev_unwindzd2protectzd2zz__evaluate_typesz00;
	static obj_t BGl_z62zc3z04anonymousza32116ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	extern obj_t BGl_ev_letza2za2zz__evaluate_typesz00;
	static obj_t BGl_z62zc3z04anonymousza32060ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza33024ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	extern obj_t BGl_evmodulezd2namezd2zz__evmodulez00(obj_t);
	static obj_t BGl_z62compzd2ev_let1419zb0zz__evaluate_compz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza32981ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza32965ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza33678ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62compzd2ev_goto1435zb0zz__evaluate_compz00(obj_t, obj_t,
		obj_t);
	extern obj_t BGl_ev_trapz00zz__evaluate_typesz00;
	static obj_t BGl_z62zc3z04anonymousza32877ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	extern obj_t BGl_bigloozd2typezd2errorzf2locationzf2zz__errorz00(obj_t, obj_t,
		obj_t, obj_t, obj_t);
	static bool_t BGl_makezd2boxeszd2zz__evaluate_compz00(obj_t, obj_t, obj_t);
	static obj_t BGl_z62zc3z04anonymousza32208ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_indexz00zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62zc3z04anonymousza32789ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza31898ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_symbol5924z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t
		BGl_globalzd2funzd2valuez00zz__evaluate_compz00(BgL_ev_exprz00_bglt);
	static bool_t BGl_freezd2restorezd2zz__evaluate_compz00(obj_t, obj_t, long);
	static obj_t BGl_z62compzd2ev_global1403zb0zz__evaluate_compz00(obj_t, obj_t,
		obj_t);
	extern obj_t BGl_ev_setglobalz00zz__evaluate_typesz00;
	static obj_t BGl_z62zc3z04anonymousza32984ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza33786ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza32968ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_symbol5932z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_z62zc3z04anonymousza31989ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62compzd2ev_synchroniza7e1431z17zz__evaluate_compz00(obj_t,
		obj_t, obj_t);
	static obj_t BGl_symbol5943z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_symbol5945z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_symbol5947z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_z62zc3z04anonymousza33118ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_symbol5949z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl__indexz00zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_inlinezd2callzd2zz__evaluate_compz00(obj_t,
		BgL_ev_exprz00_bglt, obj_t, obj_t);
	static obj_t BGl_z62zc3z04anonymousza32244ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza32082ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	BGL_EXPORTED_DECL obj_t BGl_findzd2statezd2zz__evaluate_compz00();
	static obj_t BGl_symbol5799z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_z62compzd2ev_var1397zb0zz__evaluate_compz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza33878ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_compzd2withzd2pushz00zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62compzd2ev_app1437zb0zz__evaluate_compz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62compilez62zz__evaluate_compz00(obj_t, obj_t);
	extern bool_t bigloo_string_lt(obj_t, obj_t);
	static obj_t BGl_za2za2prof_resultsza2za2z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_z62zc3z04anonymousza32084ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62findzd2statezb0zz__evaluate_compz00(obj_t);
	BGL_EXPORTED_DECL obj_t
		BGl_modulezd2initializa7ationz75zz__evaluate_compz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__evaluate_usez00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__evaluate_uncompz00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__evaluate_typesz00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__evmodulez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__everrorz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__evcompilez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__evenvz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__expandz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__prognz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__readerz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__ppz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(long,
		char *);
	extern obj_t
		BGl_modulezd2initializa7ationz75zz__r5_control_features_6_4z00(long,
		char *);
	extern obj_t
		BGl_modulezd2initializa7ationz75zz__r4_control_features_6_9z00(long,
		char *);
	extern obj_t
		BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__r4_symbols_6_4z00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__r4_booleans_6_1z00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__r4_equivalence_6_2z00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__r4_characters_6_6z00(long,
		char *);
	extern obj_t
		BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_flonum_dtoaz00(long,
		char *);
	extern obj_t
		BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_flonumz00(long, char *);
	extern obj_t
		BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5z00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__srfi4z00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__threadz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__objectz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__paramz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__bitz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__dssslz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__osz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__bignumz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__bexitz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__structurez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__tvectorz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__biglooz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__errorz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__typez00(long, char *);
	extern obj_t BGl_sortz00zz__r4_vectors_6_8z00(obj_t, obj_t);
	extern obj_t BGl_ev_globalz00zz__evaluate_typesz00;
	static obj_t BGl_z62zc3z04anonymousza32174ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza33600ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	extern obj_t BGl_integerzd2ze3stringz31zz__r4_numbers_6_5_fixnumz00(long,
		long);
	static obj_t BGl_z62zc3z04anonymousza33155ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza33317ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza32426ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	extern obj_t BGl_ev_littz00zz__evaluate_typesz00;
	static obj_t BGl_z62compzd2ev_and1415zb0zz__evaluate_compz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_loczd2typezd2errorz00zz__evaluate_compz00(obj_t, obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62zc3z04anonymousza33334ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza33156ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza33318ze3ze5zz__evaluate_compz00(obj_t);
	static obj_t BGl_cnstzd2initzd2zz__evaluate_compz00();
	static obj_t BGl_importedzd2moduleszd2initz00zz__evaluate_compz00();
	static obj_t BGl_z62zc3z04anonymousza31804ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza33335ze3ze5zz__evaluate_compz00(obj_t);
	static obj_t BGl_z62zc3z04anonymousza32088ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	extern obj_t BGl_ev_withzd2handlerzd2zz__evaluate_typesz00;
	static obj_t BGl_z62compzd2ev_abs1439zb0zz__evaluate_compz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza32801ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza33085ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62compzd2ev_letrec1423zb0zz__evaluate_compz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza32284ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	extern bool_t BGl_evmodulezf3zf3zz__evmodulez00(obj_t);
	static obj_t BGl_compzd2call0zd2zz__evaluate_compz00(obj_t,
		BgL_ev_exprz00_bglt, obj_t, obj_t, obj_t, obj_t, long);
	static obj_t BGl_compzd2call1zd2zz__evaluate_compz00(obj_t,
		BgL_ev_exprz00_bglt, obj_t, obj_t, obj_t, obj_t, long, obj_t);
	static obj_t BGl_compzd2call2zd2zz__evaluate_compz00(obj_t,
		BgL_ev_exprz00_bglt, obj_t, obj_t, obj_t, obj_t, long, obj_t, obj_t);
	static obj_t BGl_compzd2call3zd2zz__evaluate_compz00(obj_t,
		BgL_ev_exprz00_bglt, obj_t, obj_t, obj_t, obj_t, long, obj_t, obj_t, obj_t);
	static obj_t BGl_compzd2call4zd2zz__evaluate_compz00(obj_t,
		BgL_ev_exprz00_bglt, obj_t, obj_t, obj_t, obj_t, long, obj_t, obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza33370ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62compzd2ev_if1411zb0zz__evaluate_compz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza33192ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	extern obj_t BGl_ev_exprz00zz__evaluate_typesz00;
	static obj_t BGl_z62comp1389z62zz__evaluate_compz00(obj_t, obj_t, obj_t);
	static obj_t BGl_z62zc3z04anonymousza33712ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza32821ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza33534ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza32805ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62compzd2ev_setlocal1399zb0zz__evaluate_compz00(obj_t,
		obj_t, obj_t);
	static obj_t BGl_zc3z04exitza33308ze3ze70z60zz__evaluate_compz00(obj_t, obj_t,
		obj_t, long, obj_t);
	extern bool_t BGl_2zc3zd3z10zz__r4_numbers_6_5z00(obj_t, obj_t);
	static obj_t BGl_compilezd2floatzd2arithz00zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62zc3z04anonymousza32482ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza33519ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza33179ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_subrzd2callzd2withzd2pushzd2zz__evaluate_compz00(obj_t,
		obj_t, obj_t, obj_t, obj_t);
	static obj_t BGl_z62compzd2ev_defglobal1407zb0zz__evaluate_compz00(obj_t,
		obj_t, obj_t);
	static obj_t BGl_compz00zz__evaluate_compz00(BgL_ev_exprz00_bglt, obj_t);
	static obj_t BGl_z62zc3z04anonymousza33609ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62compzd2ev_unwindzd2prote1427z62zz__evaluate_compz00(obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62compzd2ev_setglobal1405zb0zz__evaluate_compz00(obj_t,
		obj_t, obj_t);
	extern bool_t BGl_2ze3zd3z30zz__r4_numbers_6_5z00(obj_t, obj_t);
	extern obj_t BGl_ev_setlocalz00zz__evaluate_typesz00;
	static obj_t BGl_z62zc3z04anonymousza33553ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_arithzd2expressionzd2zz__evaluate_compz00(BgL_ev_appz00_bglt,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza32841ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza32825ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza33376ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza32809ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t *__cnst;


	   
		 
		DEFINE_STATIC_BGL_PROCEDURE(BGl_zc3lexintzd2envz11zz__evaluate_compz00,
		BgL_bgl_za762za7c3lexintza7a1za75953z00,
		BGl_z62zc3lexintza1zz__evaluate_compz00, 0L, BUNSPEC, 2);
	extern obj_t BGl_zd2zd2envz00zz__r4_numbers_6_5z00;
	extern obj_t BGl_zd3zd2envz01zz__r4_numbers_6_5z00;
	extern obj_t BGl_f64vectorzd2refzd2envz00zz__srfi4z00;
	extern obj_t BGl_ze3zd3fxzd2envze2zz__r4_numbers_6_5_fixnumz00;
	   
		 
		DEFINE_EXPORT_BGL_PROCEDURE(BGl_compilezd2envzd2zz__evaluate_compz00,
		BgL_bgl_za762compileza762za7za7_5954z00,
		BGl_z62compilez62zz__evaluate_compz00, 0L, BUNSPEC, 1);
	extern obj_t BGl_zc3fxzd2envz11zz__r4_numbers_6_5_fixnumz00;
	extern obj_t BGl_zc3zd3flzd2envzc2zz__r4_numbers_6_5_flonumz00;
	extern obj_t BGl_ze3zd2envz31zz__r4_numbers_6_5z00;
	extern obj_t BGl_zf2zd2envz20zz__r4_numbers_6_5z00;
	extern obj_t BGl_zd2fxzd2envz00zz__r4_numbers_6_5_fixnumz00;
	   
		 
		DEFINE_EXPORT_BGL_PROCEDURE(BGl_findzd2statezd2envz00zz__evaluate_compz00,
		BgL_bgl_za762findza7d2stateza75955za7,
		BGl_z62findzd2statezb0zz__evaluate_compz00, 0L, BUNSPEC, 0);
	extern obj_t BGl_zb2flzd2envz60zz__r4_numbers_6_5_flonumz00;
	extern obj_t BGl_ze3fxzd2envz31zz__r4_numbers_6_5_fixnumz00;
	extern obj_t BGl_ze3zd3flzd2envze2zz__r4_numbers_6_5_flonumz00;
	extern obj_t BGl_zc3flzd2envz11zz__r4_numbers_6_5_flonumz00;
	extern obj_t BGl_zc3zd3zd2envzc2zz__r4_numbers_6_5z00;
	   
		 
		DEFINE_STRING(BGl_string5800z00zz__evaluate_compz00,
		BgL_bgl_string5800za700za7za7_5956za7, "all", 3);
	      DEFINE_STRING(BGl_string5802z00zz__evaluate_compz00,
		BgL_bgl_string5802za700za7za7_5957za7, "label-tag", 9);
	      DEFINE_STRING(BGl_string5804z00zz__evaluate_compz00,
		BgL_bgl_string5804za700za7za7_5958za7, "bounce", 6);
	      DEFINE_STRING(BGl_string5805z00zz__evaluate_compz00,
		BgL_bgl_string5805za700za7za7_5959za7, "non non non", 11);
	      DEFINE_STRING(BGl_string5806z00zz__evaluate_compz00,
		BgL_bgl_string5806za700za7za7_5960za7, " in ", 4);
	      DEFINE_STRING(BGl_string5807z00zz__evaluate_compz00,
		BgL_bgl_string5807za700za7za7_5961za7, "eval", 4);
	      DEFINE_STRING(BGl_string5808z00zz__evaluate_compz00,
		BgL_bgl_string5808za700za7za7_5962za7, "internal error: not found", 25);
	extern obj_t BGl_zf2fxzd2envz20zz__r4_numbers_6_5_fixnumz00;
	   
		 
		DEFINE_STRING(BGl_string5810z00zz__evaluate_compz00,
		BgL_bgl_string5810za700za7za7_5963za7, "at", 2);
	      DEFINE_STRING(BGl_string5811z00zz__evaluate_compz00,
		BgL_bgl_string5811za700za7za7_5964za7, "", 0);
	      DEFINE_STRING(BGl_string5812z00zz__evaluate_compz00,
		BgL_bgl_string5812za700za7za7_5965za7,
		"/tmp/bigloo/runtime/Eval/evaluate_comp.scm", 42);
	      DEFINE_STRING(BGl_string5813z00zz__evaluate_compz00,
		BgL_bgl_string5813za700za7za7_5966za7, "&compile", 8);
	      DEFINE_STRING(BGl_string5814z00zz__evaluate_compz00,
		BgL_bgl_string5814za700za7za7_5967za7, "ev_expr", 7);
	      DEFINE_STRING(BGl_string5815z00zz__evaluate_compz00,
		BgL_bgl_string5815za700za7za7_5968za7, "expecting ~a, got ~a", 20);
	      DEFINE_STRING(BGl_string5816z00zz__evaluate_compz00,
		BgL_bgl_string5816za700za7za7_5969za7, "wrong number of argument", 24);
	      DEFINE_STRING(BGl_string5818z00zz__evaluate_compz00,
		BgL_bgl_string5818za700za7za7_5970za7, "mcell", 5);
	      DEFINE_STRING(BGl_string5820z00zz__evaluate_compz00,
		BgL_bgl_string5820za700za7za7_5971za7, "internal", 8);
	      DEFINE_STRING(BGl_string5822z00zz__evaluate_compz00,
		BgL_bgl_string5822za700za7za7_5972za7, "impossible", 10);
	      DEFINE_STRING(BGl_string5823z00zz__evaluate_compz00,
		BgL_bgl_string5823za700za7za7_5973za7, "procedure", 9);
	      DEFINE_STRING(BGl_string5825z00zz__evaluate_compz00,
		BgL_bgl_string5825za700za7za7_5974za7, "user", 4);
	      DEFINE_STRING(BGl_string5826z00zz__evaluate_compz00,
		BgL_bgl_string5826za700za7za7_5975za7, "invalid byte code", 17);
	      DEFINE_STRING(BGl_string5828z00zz__evaluate_compz00,
		BgL_bgl_string5828za700za7za7_5976za7, "+", 1);
	extern obj_t BGl_za2fxzd2envz70zz__r4_numbers_6_5_fixnumz00;
	   
		 
		DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5901z00zz__evaluate_compz00,
		BgL_bgl_za762compza7d2ev_var5977z00,
		BGl_z62compzd2ev_var1397zb0zz__evaluate_compz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5902z00zz__evaluate_compz00,
		BgL_bgl_za762compza7d2ev_set5978z00,
		BGl_z62compzd2ev_setlocal1399zb0zz__evaluate_compz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5903z00zz__evaluate_compz00,
		BgL_bgl_za762compza7d2ev_glo5979z00,
		BGl_z62compzd2ev_global1403zb0zz__evaluate_compz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_GENERIC(BGl_compzd2envzd2zz__evaluate_compz00,
		BgL_bgl_za762compza762za7za7__ev5980z00, BGl_z62compz62zz__evaluate_compz00,
		0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5904z00zz__evaluate_compz00,
		BgL_bgl_za762compza7d2ev_set5981z00,
		BGl_z62compzd2ev_setglobal1405zb0zz__evaluate_compz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5905z00zz__evaluate_compz00,
		BgL_bgl_za762compza7d2ev_def5982z00,
		BGl_z62compzd2ev_defglobal1407zb0zz__evaluate_compz00, 0L, BUNSPEC, 2);
	      DEFINE_STRING(BGl_string5830z00zz__evaluate_compz00,
		BgL_bgl_string5830za700za7za7_5983za7, "number", 6);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5906z00zz__evaluate_compz00,
		BgL_bgl_za762compza7d2ev_lit5984z00,
		BGl_z62compzd2ev_litt1409zb0zz__evaluate_compz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5907z00zz__evaluate_compz00,
		BgL_bgl_za762compza7d2ev_if15985z00,
		BGl_z62compzd2ev_if1411zb0zz__evaluate_compz00, 0L, BUNSPEC, 2);
	      DEFINE_STRING(BGl_string5832z00zz__evaluate_compz00,
		BgL_bgl_string5832za700za7za7_5986za7, "-", 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5908z00zz__evaluate_compz00,
		BgL_bgl_za762compza7d2ev_or15987z00,
		BGl_z62compzd2ev_or1413zb0zz__evaluate_compz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5909z00zz__evaluate_compz00,
		BgL_bgl_za762compza7d2ev_and5988z00,
		BGl_z62compzd2ev_and1415zb0zz__evaluate_compz00, 0L, BUNSPEC, 2);
	      DEFINE_STRING(BGl_string5834z00zz__evaluate_compz00,
		BgL_bgl_string5834za700za7za7_5989za7, "*", 1);
	      DEFINE_STRING(BGl_string5836z00zz__evaluate_compz00,
		BgL_bgl_string5836za700za7za7_5990za7, "/", 1);
	      DEFINE_STRING(BGl_string5838z00zz__evaluate_compz00,
		BgL_bgl_string5838za700za7za7_5991za7, "<", 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5910z00zz__evaluate_compz00,
		BgL_bgl_za762compza7d2ev_pro5992z00,
		BGl_z62compzd2ev_prog21417zb0zz__evaluate_compz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5911z00zz__evaluate_compz00,
		BgL_bgl_za762compza7d2ev_let5993z00,
		BGl_z62compzd2ev_let1419zb0zz__evaluate_compz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5912z00zz__evaluate_compz00,
		BgL_bgl_za762compza7d2ev_let5994z00,
		BGl_z62compzd2ev_letza21421z12zz__evaluate_compz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5913z00zz__evaluate_compz00,
		BgL_bgl_za762compza7d2ev_let5995z00,
		BGl_z62compzd2ev_letrec1423zb0zz__evaluate_compz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5914z00zz__evaluate_compz00,
		BgL_bgl_za762compza7d2ev_bin5996z00,
		BGl_z62compzd2ev_bindzd2exit1425z62zz__evaluate_compz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5915z00zz__evaluate_compz00,
		BgL_bgl_za762compza7d2ev_unw5997z00,
		BGl_z62compzd2ev_unwindzd2prote1427z62zz__evaluate_compz00, 0L, BUNSPEC, 2);
	      DEFINE_STRING(BGl_string5840z00zz__evaluate_compz00,
		BgL_bgl_string5840za700za7za7_5998za7, ">", 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5916z00zz__evaluate_compz00,
		BgL_bgl_za762compza7d2ev_wit5999z00,
		BGl_z62compzd2ev_withzd2handler1429z62zz__evaluate_compz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5917z00zz__evaluate_compz00,
		BgL_bgl_za762compza7d2ev_syn6000z00,
		BGl_z62compzd2ev_synchroniza7e1431z17zz__evaluate_compz00, 0L, BUNSPEC, 2);
	      DEFINE_STRING(BGl_string5842z00zz__evaluate_compz00,
		BgL_bgl_string5842za700za7za7_6001za7, "<=", 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5918z00zz__evaluate_compz00,
		BgL_bgl_za762compza7d2ev_lab6002z00,
		BGl_z62compzd2ev_labels1433zb0zz__evaluate_compz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5919z00zz__evaluate_compz00,
		BgL_bgl_za762compza7d2ev_got6003z00,
		BGl_z62compzd2ev_goto1435zb0zz__evaluate_compz00, 0L, BUNSPEC, 2);
	      DEFINE_STRING(BGl_string5844z00zz__evaluate_compz00,
		BgL_bgl_string5844za700za7za7_6004za7, ">=", 2);
	      DEFINE_STRING(BGl_string5846z00zz__evaluate_compz00,
		BgL_bgl_string5846za700za7za7_6005za7, "=", 1);
	      DEFINE_STRING(BGl_string5848z00zz__evaluate_compz00,
		BgL_bgl_string5848za700za7za7_6006za7, "+fx", 3);
	extern obj_t BGl_zd2flzd2envz00zz__r4_numbers_6_5_flonumz00;
	   
		 
		DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5920z00zz__evaluate_compz00,
		BgL_bgl_za762compza7d2ev_app6007z00,
		BGl_z62compzd2ev_app1437zb0zz__evaluate_compz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5921z00zz__evaluate_compz00,
		BgL_bgl_za762compza7d2ev_abs6008z00,
		BGl_z62compzd2ev_abs1439zb0zz__evaluate_compz00, 0L, BUNSPEC, 2);
	      DEFINE_STRING(BGl_string5850z00zz__evaluate_compz00,
		BgL_bgl_string5850za700za7za7_6009za7, "fixnum", 6);
	      DEFINE_STRING(BGl_string5852z00zz__evaluate_compz00,
		BgL_bgl_string5852za700za7za7_6010za7, "-fx", 3);
	      DEFINE_STRING(BGl_string5854z00zz__evaluate_compz00,
		BgL_bgl_string5854za700za7za7_6011za7, "*fx", 3);
	      DEFINE_STRING(BGl_string5856z00zz__evaluate_compz00,
		BgL_bgl_string5856za700za7za7_6012za7, "/fx", 3);
	      DEFINE_STRING(BGl_string5858z00zz__evaluate_compz00,
		BgL_bgl_string5858za700za7za7_6013za7, "<fx", 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5935z00zz__evaluate_compz00,
		BgL_bgl_za762za7c3za704anonymo6014za7,
		BGl_z62zc3z04anonymousza32959ze3ze5zz__evaluate_compz00, 0L, BUNSPEC, 1);
	      DEFINE_STRING(BGl_string5860z00zz__evaluate_compz00,
		BgL_bgl_string5860za700za7za7_6015za7, ">fx", 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5936z00zz__evaluate_compz00,
		BgL_bgl_za762za7c3za704anonymo6016za7,
		BGl_z62zc3z04anonymousza32965ze3ze5zz__evaluate_compz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5937z00zz__evaluate_compz00,
		BgL_bgl_za762za7c3za704anonymo6017za7,
		BGl_z62zc3z04anonymousza32968ze3ze5zz__evaluate_compz00, 0L, BUNSPEC, 1);
	      DEFINE_STRING(BGl_string5862z00zz__evaluate_compz00,
		BgL_bgl_string5862za700za7za7_6018za7, "<=fx", 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5938z00zz__evaluate_compz00,
		BgL_bgl_za762za7c3za704anonymo6019za7,
		BGl_z62zc3z04anonymousza32971ze3ze5zz__evaluate_compz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5939z00zz__evaluate_compz00,
		BgL_bgl_za762za7c3za704anonymo6020za7,
		BGl_z62zc3z04anonymousza32974ze3ze5zz__evaluate_compz00, 0L, BUNSPEC, 1);
	      DEFINE_STRING(BGl_string5864z00zz__evaluate_compz00,
		BgL_bgl_string5864za700za7za7_6021za7, ">=fx", 4);
	      DEFINE_STRING(BGl_string5866z00zz__evaluate_compz00,
		BgL_bgl_string5866za700za7za7_6022za7, "=fx", 3);
	      DEFINE_STRING(BGl_string5868z00zz__evaluate_compz00,
		BgL_bgl_string5868za700za7za7_6023za7, "+fl", 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5940z00zz__evaluate_compz00,
		BgL_bgl_za762za7c3za704anonymo6024za7,
		BGl_z62zc3z04anonymousza32978ze3ze5zz__evaluate_compz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5941z00zz__evaluate_compz00,
		BgL_bgl_za762za7c3za704anonymo6025za7,
		BGl_z62zc3z04anonymousza32981ze3ze5zz__evaluate_compz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5942z00zz__evaluate_compz00,
		BgL_bgl_za762za7c3za704anonymo6026za7,
		BGl_z62zc3z04anonymousza32984ze3ze5zz__evaluate_compz00, 0L, BUNSPEC, 1);
	      DEFINE_STRING(BGl_string5870z00zz__evaluate_compz00,
		BgL_bgl_string5870za700za7za7_6027za7, "flonum", 6);
	      DEFINE_STRING(BGl_string5872z00zz__evaluate_compz00,
		BgL_bgl_string5872za700za7za7_6028za7, "-fl", 3);
	      DEFINE_STRING(BGl_string5874z00zz__evaluate_compz00,
		BgL_bgl_string5874za700za7za7_6029za7, "*fl", 3);
	      DEFINE_STRING(BGl_string5876z00zz__evaluate_compz00,
		BgL_bgl_string5876za700za7za7_6030za7, "/fl", 3);
	      DEFINE_STRING(BGl_string5878z00zz__evaluate_compz00,
		BgL_bgl_string5878za700za7za7_6031za7, "<fl", 3);
	      DEFINE_STRING(BGl_string5880z00zz__evaluate_compz00,
		BgL_bgl_string5880za700za7za7_6032za7, ">fl", 3);
	      DEFINE_STRING(BGl_string5882z00zz__evaluate_compz00,
		BgL_bgl_string5882za700za7za7_6033za7, "<=fl", 4);
	      DEFINE_STRING(BGl_string5884z00zz__evaluate_compz00,
		BgL_bgl_string5884za700za7za7_6034za7, ">=fl", 4);
	      DEFINE_STRING(BGl_string5886z00zz__evaluate_compz00,
		BgL_bgl_string5886za700za7za7_6035za7, "=fl", 3);
	      DEFINE_STRING(BGl_string5888z00zz__evaluate_compz00,
		BgL_bgl_string5888za700za7za7_6036za7, "car", 3);
	extern obj_t BGl_carzd2envzd2zz__r4_pairs_and_lists_6_3z00;
	   
		 
		DEFINE_STRING(BGl_string5890z00zz__evaluate_compz00,
		BgL_bgl_string5890za700za7za7_6037za7, "pair", 4);
	      DEFINE_STRING(BGl_string5892z00zz__evaluate_compz00,
		BgL_bgl_string5892za700za7za7_6038za7, "cdr", 3);
	extern obj_t BGl_cadrzd2envzd2zz__r4_pairs_and_lists_6_3z00;
	   
		 
		DEFINE_STRING(BGl_string5894z00zz__evaluate_compz00,
		BgL_bgl_string5894za700za7za7_6039za7, "cadr", 4);
	extern obj_t BGl_ze3zd3zd2envze2zz__r4_numbers_6_5z00;
	   
		 
		DEFINE_STRING(BGl_string5896z00zz__evaluate_compz00,
		BgL_bgl_string5896za700za7za7_6040za7, "comp1389", 8);
	      DEFINE_STRING(BGl_string5897z00zz__evaluate_compz00,
		BgL_bgl_string5897za700za7za7_6041za7, "internal error: not defined for",
		31);
	      DEFINE_STRING(BGl_string5898z00zz__evaluate_compz00,
		BgL_bgl_string5898za700za7za7_6042za7, "&comp", 5);
	extern obj_t BGl_ze3flzd2envz31zz__r4_numbers_6_5_flonumz00;
	extern obj_t BGl_zf2flzd2envz20zz__r4_numbers_6_5_flonumz00;
	extern obj_t BGl_za2flzd2envz70zz__r4_numbers_6_5_flonumz00;
	extern obj_t BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00;
	extern obj_t BGl_zd3fxzd2envz01zz__r4_numbers_6_5_fixnumz00;
	extern obj_t BGl_eqzf3zd2envz21zz__r4_equivalence_6_2z00;
	extern obj_t BGl_cdrzd2envzd2zz__r4_pairs_and_lists_6_3z00;
	extern obj_t BGl_fixnumzd2ze3flonumzd2envze3zz__r4_numbers_6_5z00;
	extern obj_t BGl_za2zd2envz70zz__r4_numbers_6_5z00;
	extern obj_t BGl_zc3zd3fxzd2envzc2zz__r4_numbers_6_5_fixnumz00;
	   
		 
		DEFINE_STRING(BGl_string5900z00zz__evaluate_compz00,
		BgL_bgl_string5900za700za7za7_6043za7, "comp", 4);
	extern obj_t BGl_zb2zd2envz60zz__r4_numbers_6_5z00;
	   
		 
		DEFINE_STRING(BGl_string5922z00zz__evaluate_compz00,
		BgL_bgl_string5922za700za7za7_6044za7, "internal error", 14);
	      DEFINE_STRING(BGl_string5923z00zz__evaluate_compz00,
		BgL_bgl_string5923za700za7za7_6045za7, "must be dead code", 17);
	      DEFINE_STRING(BGl_string5925z00zz__evaluate_compz00,
		BgL_bgl_string5925za700za7za7_6046za7, "notyet", 6);
	      DEFINE_STRING(BGl_string5926z00zz__evaluate_compz00,
		BgL_bgl_string5926za700za7za7_6047za7, "synchronize", 11);
	      DEFINE_STRING(BGl_string5927z00zz__evaluate_compz00,
		BgL_bgl_string5927za700za7za7_6048za7, "mutex", 5);
	      DEFINE_STRING(BGl_string5928z00zz__evaluate_compz00,
		BgL_bgl_string5928za700za7za7_6049za7, "set!", 4);
	      DEFINE_STRING(BGl_string5929z00zz__evaluate_compz00,
		BgL_bgl_string5929za700za7za7_6050za7, "read-only variable", 18);
	extern obj_t BGl_zd3flzd2envz01zz__r4_numbers_6_5_flonumz00;
	   
		 
		DEFINE_STRING(BGl_string5930z00zz__evaluate_compz00,
		BgL_bgl_string5930za700za7za7_6051za7,
		"\nRedefinition of compiled variable -- ", 38);
	      DEFINE_STRING(BGl_string5931z00zz__evaluate_compz00,
		BgL_bgl_string5931za700za7za7_6052za7, "Unbound variable", 16);
	      DEFINE_STRING(BGl_string5933z00zz__evaluate_compz00,
		BgL_bgl_string5933za700za7za7_6053za7, "@", 1);
	      DEFINE_STRING(BGl_string5934z00zz__evaluate_compz00,
		BgL_bgl_string5934za700za7za7_6054za7, "Uninitialized variable", 22);
	      DEFINE_STRING(BGl_string5944z00zz__evaluate_compz00,
		BgL_bgl_string5944za700za7za7_6055za7, "get_sp", 6);
	      DEFINE_STRING(BGl_string5946z00zz__evaluate_compz00,
		BgL_bgl_string5946za700za7za7_6056za7, "reset_profile", 13);
	      DEFINE_STRING(BGl_string5948z00zz__evaluate_compz00,
		BgL_bgl_string5948za700za7za7_6057za7, "get_profile", 11);
	      DEFINE_STRING(BGl_string5950z00zz__evaluate_compz00,
		BgL_bgl_string5950za700za7za7_6058za7, "reset_stack", 11);
	      DEFINE_STRING(BGl_string5951z00zz__evaluate_compz00,
		BgL_bgl_string5951za700za7za7_6059za7, "internal error: unknown command",
		31);
	      DEFINE_STRING(BGl_string5952z00zz__evaluate_compz00,
		BgL_bgl_string5952za700za7za7_6060za7, "__evaluate_comp", 15);
	extern obj_t BGl_zc3zd2envz11zz__r4_numbers_6_5z00;
	extern obj_t BGl_zb2fxzd2envz60zz__r4_numbers_6_5_fixnumz00;
	   
		 
		DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5895z00zz__evaluate_compz00,
		BgL_bgl_za762comp1389za762za7za76061z00,
		BGl_z62comp1389z62zz__evaluate_compz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5899z00zz__evaluate_compz00,
		BgL_bgl_za762compza7d2ev_tra6062z00,
		BGl_z62compzd2ev_trap1395zb0zz__evaluate_compz00, 0L, BUNSPEC, 2);

/* GC roots registration */
	static obj_t bgl_gc_roots_register()
	{
#if defined( BGL_GC_ROOTS )
#define ADD_ROOT( addr ) (addr > roots_max ? roots_max = addr : (addr < roots_min ? roots_min = addr : 0))
		void *roots_min = (void *) ULONG_MAX, *roots_max = 0;
		     ADD_ROOT((void *) (&BGl_symbol5801z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol5803z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol5809z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol5817z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol5819z00zz__evaluate_compz00));
		   
			 ADD_ROOT((void *) (&BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol5821z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol5824z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol5827z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol5829z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol5831z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol5833z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol5835z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol5837z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol5839z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol5841z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol5843z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol5845z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol5847z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol5849z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol5851z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol5853z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol5855z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol5857z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol5859z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol5861z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol5863z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol5865z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol5867z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol5869z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol5871z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol5873z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol5875z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol5877z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol5879z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol5881z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol5883z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol5885z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol5887z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol5889z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol5891z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol5893z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_za2za2azd2labelza2za2zd2zz__evaluate_compz00));
		   
			 ADD_ROOT((void
				*) (&BGl_requirezd2initializa7ationz75zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol5924z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol5932z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol5943z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol5945z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol5947z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol5949z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol5799z00zz__evaluate_compz00));
		   
			 ADD_ROOT((void
				*) (&BGl_za2za2prof_resultsza2za2z00zz__evaluate_compz00));
#undef ADD_ROOT
		if   (roots_max > 0)
			     GC_add_roots(roots_min, ((void **) roots_max) + 1);
#endif
		     return BUNSPEC;
	}



/* module-initialization */
	BGL_EXPORTED_DEF obj_t
		BGl_modulezd2initializa7ationz75zz__evaluate_compz00(long
		BgL_checksumz00_18379, char *BgL_fromz00_18380)
	{
		{
			if (CBOOL(BGl_requirezd2initializa7ationz75zz__evaluate_compz00))
				{
					BGl_requirezd2initializa7ationz75zz__evaluate_compz00 =
						BBOOL(((bool_t) 0));
					BGl_gczd2rootszd2initz00zz__evaluate_compz00();
					BGl_cnstzd2initzd2zz__evaluate_compz00();
					BGl_importedzd2moduleszd2initz00zz__evaluate_compz00();
					BGl_genericzd2initzd2zz__evaluate_compz00();
					BGl_methodzd2initzd2zz__evaluate_compz00();
					return BGl_toplevelzd2initzd2zz__evaluate_compz00();
				}
			else
				{
					return BUNSPEC;
				}
		}

	}



/* cnst-init */
	obj_t BGl_cnstzd2initzd2zz__evaluate_compz00()
	{
		{	/* Eval/evaluate_comp.scm 15 */
			BGl_symbol5799z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5800z00zz__evaluate_compz00);
			BGl_symbol5801z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5802z00zz__evaluate_compz00);
			BGl_symbol5803z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5804z00zz__evaluate_compz00);
			BGl_symbol5809z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5810z00zz__evaluate_compz00);
			BGl_symbol5817z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5818z00zz__evaluate_compz00);
			BGl_symbol5819z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5820z00zz__evaluate_compz00);
			BGl_symbol5821z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5822z00zz__evaluate_compz00);
			BGl_symbol5824z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5825z00zz__evaluate_compz00);
			BGl_symbol5827z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5828z00zz__evaluate_compz00);
			BGl_symbol5829z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5830z00zz__evaluate_compz00);
			BGl_symbol5831z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5832z00zz__evaluate_compz00);
			BGl_symbol5833z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5834z00zz__evaluate_compz00);
			BGl_symbol5835z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5836z00zz__evaluate_compz00);
			BGl_symbol5837z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5838z00zz__evaluate_compz00);
			BGl_symbol5839z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5840z00zz__evaluate_compz00);
			BGl_symbol5841z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5842z00zz__evaluate_compz00);
			BGl_symbol5843z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5844z00zz__evaluate_compz00);
			BGl_symbol5845z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5846z00zz__evaluate_compz00);
			BGl_symbol5847z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5848z00zz__evaluate_compz00);
			BGl_symbol5849z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5850z00zz__evaluate_compz00);
			BGl_symbol5851z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5852z00zz__evaluate_compz00);
			BGl_symbol5853z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5854z00zz__evaluate_compz00);
			BGl_symbol5855z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5856z00zz__evaluate_compz00);
			BGl_symbol5857z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5858z00zz__evaluate_compz00);
			BGl_symbol5859z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5860z00zz__evaluate_compz00);
			BGl_symbol5861z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5862z00zz__evaluate_compz00);
			BGl_symbol5863z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5864z00zz__evaluate_compz00);
			BGl_symbol5865z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5866z00zz__evaluate_compz00);
			BGl_symbol5867z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5868z00zz__evaluate_compz00);
			BGl_symbol5869z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5870z00zz__evaluate_compz00);
			BGl_symbol5871z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5872z00zz__evaluate_compz00);
			BGl_symbol5873z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5874z00zz__evaluate_compz00);
			BGl_symbol5875z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5876z00zz__evaluate_compz00);
			BGl_symbol5877z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5878z00zz__evaluate_compz00);
			BGl_symbol5879z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5880z00zz__evaluate_compz00);
			BGl_symbol5881z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5882z00zz__evaluate_compz00);
			BGl_symbol5883z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5884z00zz__evaluate_compz00);
			BGl_symbol5885z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5886z00zz__evaluate_compz00);
			BGl_symbol5887z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5888z00zz__evaluate_compz00);
			BGl_symbol5889z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5890z00zz__evaluate_compz00);
			BGl_symbol5891z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5892z00zz__evaluate_compz00);
			BGl_symbol5893z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5894z00zz__evaluate_compz00);
			BGl_symbol5924z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5925z00zz__evaluate_compz00);
			BGl_symbol5932z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5933z00zz__evaluate_compz00);
			BGl_symbol5943z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5944z00zz__evaluate_compz00);
			BGl_symbol5945z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5946z00zz__evaluate_compz00);
			BGl_symbol5947z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5948z00zz__evaluate_compz00);
			return (BGl_symbol5949z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5950z00zz__evaluate_compz00), BUNSPEC);
		}

	}



/* gc-roots-init */
	obj_t BGl_gczd2rootszd2initz00zz__evaluate_compz00()
	{
		{	/* Eval/evaluate_comp.scm 15 */
			return bgl_gc_roots_register();
		}

	}



/* toplevel-init */
	obj_t BGl_toplevelzd2initzd2zz__evaluate_compz00()
	{
		{	/* Eval/evaluate_comp.scm 15 */
			{	/* Eval/evaluate_comp.scm 114 */
				BGL_LONGLONG_T BgL_arg1483z00_1352;

				{	/* Eval/evaluate_comp.scm 114 */
					BGL_LONGLONG_T BgL_res4321z00_6412;

					BgL_res4321z00_6412 = LONG_TO_LLONG(((long) 0));
					BgL_arg1483z00_1352 = BgL_res4321z00_6412;
				}
				{	/* Eval/evaluate_comp.scm 114 */
					obj_t BgL_list1484z00_1353;

					{	/* Eval/evaluate_comp.scm 114 */
						obj_t BgL_arg1485z00_1354;

						BgL_arg1485z00_1354 =
							MAKE_YOUNG_PAIR(make_bllong(BgL_arg1483z00_1352), BNIL);
						BgL_list1484z00_1353 =
							MAKE_YOUNG_PAIR(BGl_symbol5799z00zz__evaluate_compz00,
							BgL_arg1485z00_1354);
					}
					BGl_za2za2prof_resultsza2za2z00zz__evaluate_compz00 =
						BgL_list1484z00_1353;
			}}
			BGl_za2za2siza7ezd2stackza2za2z75zz__evaluate_compz00 = ((long) 8192);
			BGl_za2za2azd2labelza2za2zd2zz__evaluate_compz00 =
				create_struct(BGl_symbol5801z00zz__evaluate_compz00,
				(int) (((long) 0)));
			BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00 =
				create_struct(BGl_symbol5803z00zz__evaluate_compz00,
				(int) (((long) 0)));
			return BUNSPEC;
		}

	}



/* append-21011 */
	obj_t BGl_appendzd221011zd2zz__evaluate_compz00(obj_t BgL_l1z00_1,
		obj_t BgL_l2z00_2)
	{
		{
			{
				obj_t BgL_headz00_1355;

				BgL_headz00_1355 = MAKE_YOUNG_PAIR(BNIL, BgL_l2z00_2);
				{
					obj_t BgL_prevz00_6437;
					obj_t BgL_tailz00_6438;

					BgL_prevz00_6437 = BgL_headz00_1355;
					BgL_tailz00_6438 = BgL_l1z00_1;
				BgL_loopz00_6436:
					if (PAIRP(BgL_tailz00_6438))
						{
							obj_t BgL_newzd2prevzd2_6444;

							BgL_newzd2prevzd2_6444 =
								MAKE_YOUNG_PAIR(CAR(BgL_tailz00_6438), BgL_l2z00_2);
							SET_CDR(BgL_prevz00_6437, BgL_newzd2prevzd2_6444);
							{
								obj_t BgL_tailz00_18454;
								obj_t BgL_prevz00_18453;

								BgL_prevz00_18453 = BgL_newzd2prevzd2_6444;
								BgL_tailz00_18454 = CDR(BgL_tailz00_6438);
								BgL_tailz00_6438 = BgL_tailz00_18454;
								BgL_prevz00_6437 = BgL_prevz00_18453;
								goto BgL_loopz00_6436;
							}
						}
					else
						{
							BNIL;
						}
				}
				return CDR(BgL_headz00_1355);
			}
		}

	}



/* reset_profile */
	obj_t BGl_reset_profilez00zz__evaluate_compz00()
	{
		{	/* Eval/evaluate_comp.scm 132 */
			{	/* Eval/evaluate_comp.scm 133 */
				BGL_LONGLONG_T BgL_arg1507z00_1383;

				{	/* Eval/evaluate_comp.scm 133 */
					BGL_LONGLONG_T BgL_res4330z00_6452;

					BgL_res4330z00_6452 = LONG_TO_LLONG(((long) 0));
					BgL_arg1507z00_1383 = BgL_res4330z00_6452;
				}
				{	/* Eval/evaluate_comp.scm 133 */
					obj_t BgL_list1508z00_1384;

					{	/* Eval/evaluate_comp.scm 133 */
						obj_t BgL_arg1510z00_1385;

						BgL_arg1510z00_1385 =
							MAKE_YOUNG_PAIR(make_bllong(BgL_arg1507z00_1383), BNIL);
						BgL_list1508z00_1384 =
							MAKE_YOUNG_PAIR(BGl_symbol5799z00zz__evaluate_compz00,
							BgL_arg1510z00_1385);
					}
					return (BGl_za2za2prof_resultsza2za2z00zz__evaluate_compz00 =
						BgL_list1508z00_1384, BUNSPEC);
				}
			}
		}

	}



/* o->s~0 */
	obj_t BGl_ozd2ze3sze70zd6zz__evaluate_compz00(obj_t BgL_vz00_1394)
	{
		{	/* Eval/evaluate_comp.scm 141 */
			if (BGl_integerzf3zf3zz__r4_numbers_6_5_fixnumz00(BgL_vz00_1394))
				{	/* Ieee/fixnum.scm 979 */

					return
						BGl_integerzd2ze3stringz31zz__r4_numbers_6_5_fixnumz00(
						(long) CINT(BgL_vz00_1394), ((long) 10));
				}
			else
				{	/* Eval/evaluate_comp.scm 138 */
					if (SYMBOLP(BgL_vz00_1394))
						{	/* Eval/evaluate_comp.scm 139 */
							obj_t BgL_res4333z00_6457;

							{	/* Eval/evaluate_comp.scm 139 */
								obj_t BgL_arg4168z00_6456;

								BgL_arg4168z00_6456 = SYMBOL_TO_STRING(BgL_vz00_1394);
								BgL_res4333z00_6457 =
									BGl_stringzd2copyzd2zz__r4_strings_6_7z00
									(BgL_arg4168z00_6456);
							}
							return BgL_res4333z00_6457;
						}
					else
						{	/* Eval/evaluate_comp.scm 139 */
							if (STRINGP(BgL_vz00_1394))
								{	/* Eval/evaluate_comp.scm 140 */
									return BgL_vz00_1394;
								}
							else
								{	/* Eval/evaluate_comp.scm 140 */
									return BGl_string5805z00zz__evaluate_compz00;
								}
						}
				}
		}

	}



/* &<lexint */
	obj_t BGl_z62zc3lexintza1zz__evaluate_compz00(obj_t BgL_envz00_13557,
		obj_t BgL_t1z00_13558, obj_t BgL_t2z00_13559)
	{
		{	/* Eval/evaluate_comp.scm 135 */
			{	/* Eval/evaluate_comp.scm 138 */
				bool_t BgL_tmpz00_18471;

				{	/* Eval/evaluate_comp.scm 142 */
					obj_t BgL_v1z00_15548;
					obj_t BgL_v2z00_15549;

					BgL_v1z00_15548 = CAR(((obj_t) BgL_t1z00_13558));
					BgL_v2z00_15549 = CAR(((obj_t) BgL_t2z00_13559));
					{	/* Eval/evaluate_comp.scm 143 */
						bool_t BgL_test6068z00_18476;

						if (BGl_integerzf3zf3zz__r4_numbers_6_5_fixnumz00(BgL_v1z00_15548))
							{	/* Eval/evaluate_comp.scm 143 */
								BgL_test6068z00_18476 =
									BGl_integerzf3zf3zz__r4_numbers_6_5_fixnumz00
									(BgL_v2z00_15549);
							}
						else
							{	/* Eval/evaluate_comp.scm 143 */
								BgL_test6068z00_18476 = ((bool_t) 0);
							}
						if (BgL_test6068z00_18476)
							{	/* Eval/evaluate_comp.scm 143 */
								BgL_tmpz00_18471 =
									BGl_2zc3zc3zz__r4_numbers_6_5z00(BgL_v1z00_15548,
									BgL_v2z00_15549);
							}
						else
							{	/* Eval/evaluate_comp.scm 143 */
								BgL_tmpz00_18471 =
									bigloo_string_lt(BGl_ozd2ze3sze70zd6zz__evaluate_compz00
									(BgL_v1z00_15548),
									BGl_ozd2ze3sze70zd6zz__evaluate_compz00(BgL_v2z00_15549));
							}
					}
				}
				return BBOOL(BgL_tmpz00_18471);
			}
		}

	}



/* get_profile */
	obj_t BGl_get_profilez00zz__evaluate_compz00()
	{
		{	/* Eval/evaluate_comp.scm 147 */
			BGl_recze71ze7zz__evaluate_compz00
				(BGl_za2za2prof_resultsza2za2z00zz__evaluate_compz00);
			return BGl_za2za2prof_resultsza2za2z00zz__evaluate_compz00;
		}

	}



/* rec~1 */
	bool_t BGl_recze71ze7zz__evaluate_compz00(obj_t BgL_tz00_1403)
	{
		{	/* Eval/evaluate_comp.scm 148 */
			{	/* Eval/evaluate_comp.scm 149 */
				obj_t BgL_arg1523z00_1405;
				obj_t BgL_arg1524z00_1406;

				BgL_arg1523z00_1405 = CDR(((obj_t) BgL_tz00_1403));
				{	/* Eval/evaluate_comp.scm 149 */
					obj_t BgL_arg1527z00_1407;

					{	/* Eval/evaluate_comp.scm 149 */
						obj_t BgL_pairz00_6468;

						BgL_pairz00_6468 = CDR(((obj_t) BgL_tz00_1403));
						BgL_arg1527z00_1407 = CDR(BgL_pairz00_6468);
					}
					BgL_arg1524z00_1406 =
						BGl_sortz00zz__r4_vectors_6_8z00
						(BGl_zc3lexintzd2envz11zz__evaluate_compz00, BgL_arg1527z00_1407);
				}
				{	/* Eval/evaluate_comp.scm 149 */
					obj_t BgL_tmpz00_18492;

					BgL_tmpz00_18492 = ((obj_t) BgL_arg1523z00_1405);
					SET_CDR(BgL_tmpz00_18492, BgL_arg1524z00_1406);
				}
			}
			{	/* Eval/evaluate_comp.scm 150 */
				obj_t BgL_g1291z00_1408;

				{	/* Eval/evaluate_comp.scm 150 */
					obj_t BgL_pairz00_6473;

					BgL_pairz00_6473 = CDR(((obj_t) BgL_tz00_1403));
					BgL_g1291z00_1408 = CDR(BgL_pairz00_6473);
				}
				{
					obj_t BgL_l1289z00_6487;

					BgL_l1289z00_6487 = BgL_g1291z00_1408;
				BgL_zc3z04anonymousza31528ze3z87_6486:
					if (PAIRP(BgL_l1289z00_6487))
						{	/* Eval/evaluate_comp.scm 150 */
							BGl_recze71ze7zz__evaluate_compz00(CAR(BgL_l1289z00_6487));
							{
								obj_t BgL_l1289z00_18502;

								BgL_l1289z00_18502 = CDR(BgL_l1289z00_6487);
								BgL_l1289z00_6487 = BgL_l1289z00_18502;
								goto BgL_zc3z04anonymousza31528ze3z87_6486;
							}
						}
					else
						{	/* Eval/evaluate_comp.scm 150 */
							return ((bool_t) 1);
						}
				}
			}
		}

	}



/* index */
	obj_t BGl_indexz00zz__evaluate_compz00(obj_t BgL_xz00_6, obj_t BgL_lz00_7)
	{
		{	/* Eval/evaluate_comp.scm 156 */
			{
				obj_t BgL_lz00_6518;
				long BgL_nz00_6519;

				BgL_lz00_6518 = BgL_lz00_7;
				BgL_nz00_6519 = ((long) 0);
			BgL_walkz00_6517:
				if (NULLP(BgL_lz00_6518))
					{	/* Eval/evaluate_comp.scm 158 */
						return BFALSE;
					}
				else
					{	/* Eval/evaluate_comp.scm 158 */
						if ((BgL_xz00_6 == CAR(((obj_t) BgL_lz00_6518))))
							{	/* Eval/evaluate_comp.scm 159 */
								return BINT(BgL_nz00_6519);
							}
						else
							{
								long BgL_nz00_18514;
								obj_t BgL_lz00_18511;

								BgL_lz00_18511 = CDR(((obj_t) BgL_lz00_6518));
								BgL_nz00_18514 = (BgL_nz00_6519 + ((long) 1));
								BgL_nz00_6519 = BgL_nz00_18514;
								BgL_lz00_6518 = BgL_lz00_18511;
								goto BgL_walkz00_6517;
							}
					}
			}
		}

	}



/* _index */
	obj_t BGl__indexz00zz__evaluate_compz00(obj_t BgL_xz00_8, obj_t BgL_lz00_9)
	{
		{	/* Eval/evaluate_comp.scm 163 */
			{	/* Eval/evaluate_comp.scm 164 */
				obj_t BgL__ortest_1079z00_1428;

				BgL__ortest_1079z00_1428 =
					BGl_indexz00zz__evaluate_compz00(BgL_xz00_8, BgL_lz00_9);
				if (CBOOL(BgL__ortest_1079z00_1428))
					{	/* Eval/evaluate_comp.scm 164 */
						return BgL__ortest_1079z00_1428;
					}
				else
					{	/* Eval/evaluate_comp.scm 164 */
						obj_t BgL_arg1539z00_1429;

						{	/* Eval/evaluate_comp.scm 164 */
							obj_t BgL_arg1540z00_1430;

							if (NULLP(BgL_lz00_9))
								{	/* Eval/evaluate_comp.scm 164 */
									BgL_arg1540z00_1430 = BNIL;
								}
							else
								{	/* Eval/evaluate_comp.scm 164 */
									obj_t BgL_head1294z00_1436;

									{	/* Eval/evaluate_comp.scm 164 */
										obj_t BgL_arg1552z00_1448;

										{	/* Eval/evaluate_comp.scm 164 */
											obj_t BgL_arg1553z00_1449;

											BgL_arg1553z00_1449 = CAR(((obj_t) BgL_lz00_9));
											if (BGl_isazf3zf3zz__objectz00(BgL_arg1553z00_1449,
													BGl_ev_varz00zz__evaluate_typesz00))
												{	/* Eval/evaluate_comp.scm 189 */
													BgL_arg1552z00_1448 =
														(((BgL_ev_varz00_bglt) COBJECT(
																((BgL_ev_varz00_bglt) BgL_arg1553z00_1449)))->
														BgL_namez00);
												}
											else
												{	/* Eval/evaluate_comp.scm 189 */
													BgL_arg1552z00_1448 = BgL_arg1553z00_1449;
												}
										}
										{	/* Eval/evaluate_comp.scm 164 */
											obj_t BgL_res4346z00_6539;

											BgL_res4346z00_6539 =
												MAKE_YOUNG_PAIR(BgL_arg1552z00_1448, BNIL);
											BgL_head1294z00_1436 = BgL_res4346z00_6539;
										}
									}
									{	/* Eval/evaluate_comp.scm 164 */
										obj_t BgL_g1297z00_1437;

										BgL_g1297z00_1437 = CDR(((obj_t) BgL_lz00_9));
										{
											obj_t BgL_l1292z00_6564;
											obj_t BgL_tail1295z00_6565;

											BgL_l1292z00_6564 = BgL_g1297z00_1437;
											BgL_tail1295z00_6565 = BgL_head1294z00_1436;
										BgL_zc3z04anonymousza31545ze3z87_6563:
											if (NULLP(BgL_l1292z00_6564))
												{	/* Eval/evaluate_comp.scm 164 */
													BgL_arg1540z00_1430 = BgL_head1294z00_1436;
												}
											else
												{	/* Eval/evaluate_comp.scm 164 */
													obj_t BgL_newtail1296z00_6572;

													{	/* Eval/evaluate_comp.scm 164 */
														obj_t BgL_arg1548z00_6573;

														BgL_arg1548z00_6573 =
															BGl_lnamez00zz__evaluate_compz00(CAR(
																((obj_t) BgL_l1292z00_6564)));
														{	/* Eval/evaluate_comp.scm 164 */
															obj_t BgL_res4352z00_6578;

															BgL_res4352z00_6578 =
																MAKE_YOUNG_PAIR(BgL_arg1548z00_6573, BNIL);
															BgL_newtail1296z00_6572 = BgL_res4352z00_6578;
														}
													}
													SET_CDR(BgL_tail1295z00_6565,
														BgL_newtail1296z00_6572);
													{	/* Eval/evaluate_comp.scm 164 */
														obj_t BgL_arg1547z00_6575;

														BgL_arg1547z00_6575 =
															CDR(((obj_t) BgL_l1292z00_6564));
														{
															obj_t BgL_tail1295z00_18540;
															obj_t BgL_l1292z00_18539;

															BgL_l1292z00_18539 = BgL_arg1547z00_6575;
															BgL_tail1295z00_18540 = BgL_newtail1296z00_6572;
															BgL_tail1295z00_6565 = BgL_tail1295z00_18540;
															BgL_l1292z00_6564 = BgL_l1292z00_18539;
															goto BgL_zc3z04anonymousza31545ze3z87_6563;
														}
													}
												}
										}
									}
								}
							{	/* Eval/evaluate_comp.scm 164 */
								obj_t BgL_list1541z00_1431;

								{	/* Eval/evaluate_comp.scm 164 */
									obj_t BgL_arg1542z00_1432;

									{	/* Eval/evaluate_comp.scm 164 */
										obj_t BgL_arg1543z00_1433;

										BgL_arg1543z00_1433 =
											MAKE_YOUNG_PAIR(BgL_arg1540z00_1430, BNIL);
										BgL_arg1542z00_1432 =
											MAKE_YOUNG_PAIR(BGl_string5806z00zz__evaluate_compz00,
											BgL_arg1543z00_1433);
									}
									BgL_list1541z00_1431 =
										MAKE_YOUNG_PAIR(BgL_xz00_8, BgL_arg1542z00_1432);
								}
								BgL_arg1539z00_1429 = BgL_list1541z00_1431;
							}
						}
						return
							BGl_errorz00zz__errorz00(BGl_string5807z00zz__evaluate_compz00,
							BGl_string5808z00zz__evaluate_compz00, BgL_arg1539z00_1429);
					}
			}
		}

	}



/* lname */
	obj_t BGl_lnamez00zz__evaluate_compz00(obj_t BgL_vz00_16)
	{
		{	/* Eval/evaluate_comp.scm 188 */
			if (BGl_isazf3zf3zz__objectz00(BgL_vz00_16,
					BGl_ev_varz00zz__evaluate_typesz00))
				{	/* Eval/evaluate_comp.scm 189 */
					return
						(((BgL_ev_varz00_bglt) COBJECT(
								((BgL_ev_varz00_bglt) BgL_vz00_16)))->BgL_namez00);
				}
			else
				{	/* Eval/evaluate_comp.scm 189 */
					return BgL_vz00_16;
				}
		}

	}



/* loc-type-error */
	obj_t BGl_loczd2typezd2errorz00zz__evaluate_compz00(obj_t BgL_fz00_17,
		obj_t BgL_mz00_18, obj_t BgL_vz00_19, obj_t BgL_locz00_20)
	{
		{	/* Eval/evaluate_comp.scm 193 */
			if (PAIRP(BgL_locz00_20))
				{	/* Eval/evaluate_comp.scm 194 */
					obj_t BgL_cdrzd2194zd2_1475;

					BgL_cdrzd2194zd2_1475 = CDR(BgL_locz00_20);
					if ((CAR(BgL_locz00_20) == BGl_symbol5809z00zz__evaluate_compz00))
						{	/* Eval/evaluate_comp.scm 194 */
							if (PAIRP(BgL_cdrzd2194zd2_1475))
								{	/* Eval/evaluate_comp.scm 194 */
									obj_t BgL_cdrzd2198zd2_1479;

									BgL_cdrzd2198zd2_1479 = CDR(BgL_cdrzd2194zd2_1475);
									if (PAIRP(BgL_cdrzd2198zd2_1479))
										{	/* Eval/evaluate_comp.scm 194 */
											if (NULLP(CDR(BgL_cdrzd2198zd2_1479)))
												{	/* Eval/evaluate_comp.scm 194 */
													return
														BGl_bigloozd2typezd2errorzf2locationzf2zz__errorz00
														(BgL_fz00_17, BgL_mz00_18, BgL_vz00_19,
														CAR(BgL_cdrzd2194zd2_1475),
														CAR(BgL_cdrzd2198zd2_1479));
												}
											else
												{	/* Eval/evaluate_comp.scm 194 */
													return
														BGl_bigloozd2typezd2errorz00zz__errorz00
														(BgL_fz00_17, BgL_mz00_18, BgL_vz00_19);
												}
										}
									else
										{	/* Eval/evaluate_comp.scm 194 */
											return
												BGl_bigloozd2typezd2errorz00zz__errorz00(BgL_fz00_17,
												BgL_mz00_18, BgL_vz00_19);
										}
								}
							else
								{	/* Eval/evaluate_comp.scm 194 */
									return
										BGl_bigloozd2typezd2errorz00zz__errorz00(BgL_fz00_17,
										BgL_mz00_18, BgL_vz00_19);
								}
						}
					else
						{	/* Eval/evaluate_comp.scm 194 */
							return
								BGl_bigloozd2typezd2errorz00zz__errorz00(BgL_fz00_17,
								BgL_mz00_18, BgL_vz00_19);
						}
				}
			else
				{	/* Eval/evaluate_comp.scm 194 */
					return
						BGl_bigloozd2typezd2errorz00zz__errorz00(BgL_fz00_17, BgL_mz00_18,
						BgL_vz00_19);
				}
		}

	}



/* make-state */
	obj_t BGl_makezd2statezd2zz__evaluate_compz00()
	{
		{	/* Eval/evaluate_comp.scm 206 */
			{	/* Eval/evaluate_comp.scm 207 */
				obj_t BgL_stkz00_1495;

				BgL_stkz00_1495 =
					make_vector(((long) 8192), BGl_string5811z00zz__evaluate_compz00);
				VECTOR_SET(BgL_stkz00_1495, ((long) 0), BINT(((long) 2)));
				return BgL_stkz00_1495;
			}
		}

	}



/* find-state */
	BGL_EXPORTED_DEF obj_t BGl_findzd2statezd2zz__evaluate_compz00()
	{
		{	/* Eval/evaluate_comp.scm 211 */
			{	/* Eval/evaluate_comp.scm 212 */
				obj_t BgL_sz00_1496;

				{	/* Eval/evaluate_comp.scm 212 */
					obj_t BgL_tmpz00_18574;

					BgL_tmpz00_18574 = BGL_CURRENT_DYNAMIC_ENV();
					BgL_sz00_1496 = BGL_ENV_EVSTATE(BgL_tmpz00_18574);
				}
				if (VECTORP(BgL_sz00_1496))
					{	/* Eval/evaluate_comp.scm 213 */
						return BgL_sz00_1496;
					}
				else
					{	/* Eval/evaluate_comp.scm 214 */
						obj_t BgL_statez00_1498;

						BgL_statez00_1498 = BGl_makezd2statezd2zz__evaluate_compz00();
						{	/* Eval/evaluate_comp.scm 215 */
							obj_t BgL_tmpz00_18580;

							BgL_tmpz00_18580 = BGL_CURRENT_DYNAMIC_ENV();
							BGL_ENV_EVSTATE_SET(BgL_tmpz00_18580, BgL_statez00_1498);
						}
						return BgL_statez00_1498;
					}
			}
		}

	}



/* &find-state */
	obj_t BGl_z62findzd2statezb0zz__evaluate_compz00(obj_t BgL_envz00_13560)
	{
		{	/* Eval/evaluate_comp.scm 211 */
			return BGl_findzd2statezd2zz__evaluate_compz00();
		}

	}



/* compile */
	BGL_EXPORTED_DEF obj_t BGl_compilez00zz__evaluate_compz00(BgL_ev_exprz00_bglt
		BgL_ez00_34)
	{
		{	/* Eval/evaluate_comp.scm 273 */
			return BGl_compz00zz__evaluate_compz00(BgL_ez00_34, BNIL);
		}

	}



/* &compile */
	obj_t BGl_z62compilez62zz__evaluate_compz00(obj_t BgL_envz00_13561,
		obj_t BgL_ez00_13562)
	{
		{	/* Eval/evaluate_comp.scm 273 */
			{	/* Eval/evaluate_comp.scm 274 */
				BgL_ev_exprz00_bglt BgL_auxz00_18585;

				if (BGl_isazf3zf3zz__objectz00(BgL_ez00_13562,
						BGl_ev_exprz00zz__evaluate_typesz00))
					{	/* Eval/evaluate_comp.scm 274 */
						BgL_auxz00_18585 = ((BgL_ev_exprz00_bglt) BgL_ez00_13562);
					}
				else
					{
						obj_t BgL_auxz00_18589;

						BgL_auxz00_18589 =
							BGl_typezd2errorzd2zz__errorz00
							(BGl_string5812z00zz__evaluate_compz00, BINT(((long) 7006)),
							BGl_string5813z00zz__evaluate_compz00,
							BGl_string5814z00zz__evaluate_compz00, BgL_ez00_13562);
						FAILURE(BgL_auxz00_18589, BFALSE, BFALSE);
					}
				return BGl_compilez00zz__evaluate_compz00(BgL_auxz00_18585);
			}
		}

	}



/* global-fun-value */
	obj_t BGl_globalzd2funzd2valuez00zz__evaluate_compz00(BgL_ev_exprz00_bglt
		BgL_ez00_43)
	{
		{	/* Eval/evaluate_comp.scm 332 */
			if (BGl_isazf3zf3zz__objectz00(
					((obj_t) BgL_ez00_43), BGl_ev_globalz00zz__evaluate_typesz00))
				{	/* Eval/evaluate_comp.scm 335 */
					obj_t BgL_gz00_1554;

					{	/* Eval/evaluate_comp.scm 335 */
						obj_t BgL_arg1641z00_1555;
						obj_t BgL_arg1642z00_1556;

						BgL_arg1641z00_1555 =
							(((BgL_ev_globalz00_bglt) COBJECT(
									((BgL_ev_globalz00_bglt) BgL_ez00_43)))->BgL_modz00);
						BgL_arg1642z00_1556 =
							(((BgL_ev_globalz00_bglt) COBJECT(
									((BgL_ev_globalz00_bglt) BgL_ez00_43)))->BgL_namez00);
						BgL_gz00_1554 =
							BGl_evmodulezd2findzd2globalz00zz__evmodulez00
							(BgL_arg1641z00_1555, BgL_arg1642z00_1556);
					}
					if (CBOOL(BgL_gz00_1554))
						{	/* Eval/evaluate_comp.scm 336 */
							return VECTOR_REF(((obj_t) BgL_gz00_1554), ((long) 2));
						}
					else
						{	/* Eval/evaluate_comp.scm 336 */
							return BFALSE;
						}
				}
			else
				{	/* Eval/evaluate_comp.scm 333 */
					return BFALSE;
				}
		}

	}



/* push-boxes-args-on-sp */
	obj_t BGl_pushzd2boxeszd2argszd2onzd2spz00zz__evaluate_compz00(obj_t
		BgL_sz00_82, obj_t BgL_argsz00_83, obj_t BgL_boxesz00_84, long BgL_spz00_85,
		obj_t BgL_locz00_86)
	{
		{	/* Eval/evaluate_comp.scm 623 */
			{
				obj_t BgL_lz00_1576;
				obj_t BgL_bsz00_1577;
				long BgL_spz00_1578;

				BgL_lz00_1576 = BgL_argsz00_83;
				BgL_bsz00_1577 = BgL_boxesz00_84;
				BgL_spz00_1578 = BgL_spz00_85;
			BgL_zc3z04anonymousza31657ze3z87_1579:
				if (NULLP(BgL_lz00_1576))
					{	/* Eval/evaluate_comp.scm 625 */
						if (NULLP(BgL_bsz00_1577))
							{	/* Eval/evaluate_comp.scm 626 */
								return BFALSE;
							}
						else
							{	/* Eval/evaluate_comp.scm 629 */
								obj_t BgL_arg1660z00_1582;

								{	/* Eval/evaluate_comp.scm 629 */
									long BgL_arg1661z00_1583;
									long BgL_arg1664z00_1584;

									BgL_arg1661z00_1583 = bgl_list_length(BgL_boxesz00_84);
									BgL_arg1664z00_1584 = bgl_list_length(BgL_argsz00_83);
									{	/* Eval/evaluate_comp.scm 628 */
										obj_t BgL_list1665z00_1585;

										{	/* Eval/evaluate_comp.scm 628 */
											obj_t BgL_arg1666z00_1586;

											BgL_arg1666z00_1586 =
												MAKE_YOUNG_PAIR(BINT(BgL_arg1664z00_1584), BNIL);
											BgL_list1665z00_1585 =
												MAKE_YOUNG_PAIR(BINT(BgL_arg1661z00_1583),
												BgL_arg1666z00_1586);
										}
										BgL_arg1660z00_1582 =
											BGl_formatz00zz__r4_output_6_10_3z00
											(BGl_string5815z00zz__evaluate_compz00,
											BgL_list1665z00_1585);
								}}
								return
									BGl_everrorz00zz__everrorz00(BgL_locz00_86,
									BGl_string5807z00zz__evaluate_compz00,
									BGl_string5816z00zz__evaluate_compz00, BgL_arg1660z00_1582);
							}
					}
				else
					{	/* Eval/evaluate_comp.scm 625 */
						if (NULLP(BgL_bsz00_1577))
							{	/* Eval/evaluate_comp.scm 633 */
								obj_t BgL_arg1668z00_1588;

								{	/* Eval/evaluate_comp.scm 633 */
									long BgL_arg1669z00_1589;
									long BgL_arg1670z00_1590;

									BgL_arg1669z00_1589 = bgl_list_length(BgL_boxesz00_84);
									BgL_arg1670z00_1590 = bgl_list_length(BgL_argsz00_83);
									{	/* Eval/evaluate_comp.scm 632 */
										obj_t BgL_list1671z00_1591;

										{	/* Eval/evaluate_comp.scm 632 */
											obj_t BgL_arg1672z00_1592;

											BgL_arg1672z00_1592 =
												MAKE_YOUNG_PAIR(BINT(BgL_arg1670z00_1590), BNIL);
											BgL_list1671z00_1591 =
												MAKE_YOUNG_PAIR(BINT(BgL_arg1669z00_1589),
												BgL_arg1672z00_1592);
										}
										BgL_arg1668z00_1588 =
											BGl_formatz00zz__r4_output_6_10_3z00
											(BGl_string5815z00zz__evaluate_compz00,
											BgL_list1671z00_1591);
								}}
								return
									BGl_everrorz00zz__everrorz00(BgL_locz00_86,
									BGl_string5807z00zz__evaluate_compz00,
									BGl_string5816z00zz__evaluate_compz00, BgL_arg1668z00_1588);
							}
						else
							{	/* Eval/evaluate_comp.scm 630 */
								{	/* Eval/evaluate_comp.scm 636 */
									obj_t BgL_arg1673z00_1593;

									{	/* Eval/evaluate_comp.scm 636 */
										obj_t BgL_vz00_1594;

										{	/* Eval/evaluate_comp.scm 636 */
											obj_t BgL_fun1675z00_1596;

											BgL_fun1675z00_1596 = CAR(((obj_t) BgL_lz00_1576));
											BgL_vz00_1594 =
												PROCEDURE_ENTRY(BgL_fun1675z00_1596)
												(BgL_fun1675z00_1596, BgL_sz00_82, BEOA);
										}
										if (CBOOL(CAR(((obj_t) BgL_bsz00_1577))))
											{	/* Eval/evaluate_comp.scm 202 */
												obj_t BgL_newz00_6628;

												BgL_newz00_6628 =
													create_struct(BGl_symbol5817z00zz__evaluate_compz00,
													(int) (((long) 1)));
												{	/* Eval/evaluate_comp.scm 202 */
													int BgL_tmpz00_18640;

													BgL_tmpz00_18640 = (int) (((long) 0));
													STRUCT_SET(BgL_newz00_6628, BgL_tmpz00_18640,
														BgL_vz00_1594);
												}
												BgL_arg1673z00_1593 = BgL_newz00_6628;
											}
										else
											{	/* Eval/evaluate_comp.scm 637 */
												BgL_arg1673z00_1593 = BgL_vz00_1594;
											}
									}
									VECTOR_SET(
										((obj_t) BgL_sz00_82), BgL_spz00_1578, BgL_arg1673z00_1593);
								}
								{	/* Eval/evaluate_comp.scm 640 */
									obj_t BgL_arg1677z00_1597;
									obj_t BgL_arg1678z00_1598;
									long BgL_arg1679z00_1599;

									BgL_arg1677z00_1597 = CDR(((obj_t) BgL_lz00_1576));
									BgL_arg1678z00_1598 = CDR(((obj_t) BgL_bsz00_1577));
									BgL_arg1679z00_1599 = (BgL_spz00_1578 + ((long) 1));
									{
										long BgL_spz00_18652;
										obj_t BgL_bsz00_18651;
										obj_t BgL_lz00_18650;

										BgL_lz00_18650 = BgL_arg1677z00_1597;
										BgL_bsz00_18651 = BgL_arg1678z00_1598;
										BgL_spz00_18652 = BgL_arg1679z00_1599;
										BgL_spz00_1578 = BgL_spz00_18652;
										BgL_bsz00_1577 = BgL_bsz00_18651;
										BgL_lz00_1576 = BgL_lz00_18650;
										goto BgL_zc3z04anonymousza31657ze3z87_1579;
									}
								}
							}
					}
			}
		}

	}



/* sub-stk */
	obj_t BGl_subzd2stkzd2zz__evaluate_compz00(obj_t BgL_l1z00_88,
		obj_t BgL_l2z00_89)
	{
		{	/* Eval/evaluate_comp.scm 645 */
		BGl_subzd2stkzd2zz__evaluate_compz00:
			if (NULLP(BgL_l1z00_88))
				{	/* Eval/evaluate_comp.scm 646 */
					return BgL_l2z00_89;
				}
			else
				{	/* Eval/evaluate_comp.scm 646 */
					if ((CAR(((obj_t) BgL_l1z00_88)) == CAR(((obj_t) BgL_l2z00_89))))
						{	/* Eval/evaluate_comp.scm 649 */
							obj_t BgL_arg1684z00_1605;
							obj_t BgL_arg1685z00_1606;

							BgL_arg1684z00_1605 = CDR(((obj_t) BgL_l1z00_88));
							BgL_arg1685z00_1606 = CDR(((obj_t) BgL_l2z00_89));
							{
								obj_t BgL_l2z00_18666;
								obj_t BgL_l1z00_18665;

								BgL_l1z00_18665 = BgL_arg1684z00_1605;
								BgL_l2z00_18666 = BgL_arg1685z00_1606;
								BgL_l2z00_89 = BgL_l2z00_18666;
								BgL_l1z00_88 = BgL_l1z00_18665;
								goto BGl_subzd2stkzd2zz__evaluate_compz00;
							}
						}
					else
						{	/* Eval/evaluate_comp.scm 647 */
							return
								BGl_errorz00zz__errorz00(BGl_string5807z00zz__evaluate_compz00,
								BGl_symbol5819z00zz__evaluate_compz00,
								BGl_symbol5821z00zz__evaluate_compz00);
						}
				}
		}

	}



/* catch-trampoline */
	obj_t BGl_catchzd2trampolinezd2zz__evaluate_compz00(obj_t BgL_fz00_93,
		obj_t BgL_sz00_94, obj_t BgL_bpz00_95)
	{
		{	/* Eval/evaluate_comp.scm 669 */
			{	/* Eval/evaluate_comp.scm 670 */
				obj_t BgL_savedzd2bpzd2_1617;

				BgL_savedzd2bpzd2_1617 = VECTOR_REF(((obj_t) BgL_sz00_94), ((long) 0));
				VECTOR_SET(((obj_t) BgL_sz00_94), ((long) 0), BgL_bpz00_95);
				{
					obj_t BgL_fz00_1619;

					BgL_fz00_1619 = BgL_fz00_93;
				BgL_zc3z04anonymousza31698ze3z87_1620:
					{	/* Eval/evaluate_comp.scm 673 */
						obj_t BgL_rz00_1621;

						BgL_rz00_1621 =
							PROCEDURE_ENTRY(BgL_fz00_1619) (BgL_fz00_1619, BgL_sz00_94, BEOA);
						{	/* Eval/evaluate_comp.scm 674 */
							bool_t BgL_test6093z00_18676;

							if (PROCEDUREP(BgL_rz00_1621))
								{	/* Eval/evaluate_comp.scm 674 */
									obj_t BgL_arg1702z00_1626;

									BgL_arg1702z00_1626 = PROCEDURE_ATTR(BgL_rz00_1621);
									if (STRUCTP(BgL_arg1702z00_1626))
										{	/* Eval/evaluate_comp.scm 654 */
											BgL_test6093z00_18676 =
												(STRUCT_KEY(BgL_arg1702z00_1626) ==
												BGl_symbol5803z00zz__evaluate_compz00);
										}
									else
										{	/* Eval/evaluate_comp.scm 654 */
											BgL_test6093z00_18676 = ((bool_t) 0);
										}
								}
							else
								{	/* Eval/evaluate_comp.scm 674 */
									BgL_test6093z00_18676 = ((bool_t) 0);
								}
							if (BgL_test6093z00_18676)
								{
									obj_t BgL_fz00_18684;

									BgL_fz00_18684 = BgL_rz00_1621;
									BgL_fz00_1619 = BgL_fz00_18684;
									goto BgL_zc3z04anonymousza31698ze3z87_1620;
								}
							else
								{	/* Eval/evaluate_comp.scm 674 */
									VECTOR_SET(
										((obj_t) BgL_sz00_94), ((long) 0), BgL_savedzd2bpzd2_1617);
									return BgL_rz00_1621;
								}
						}
					}
				}
			}
		}

	}



/* comp-with-push */
	obj_t BGl_compzd2withzd2pushz00zz__evaluate_compz00(obj_t BgL_eza2za2_117,
		obj_t BgL_stkz00_118)
	{
		{	/* Eval/evaluate_comp.scm 688 */
			if (NULLP(BgL_eza2za2_117))
				{	/* Eval/evaluate_comp.scm 690 */
					return BNIL;
				}
			else
				{	/* Eval/evaluate_comp.scm 692 */
					obj_t BgL_arg1713z00_1639;
					obj_t BgL_arg1714z00_1640;

					{	/* Eval/evaluate_comp.scm 692 */
						obj_t BgL_arg1715z00_1641;

						BgL_arg1715z00_1641 = CAR(((obj_t) BgL_eza2za2_117));
						BgL_arg1713z00_1639 =
							BGl_compz00zz__evaluate_compz00(
							((BgL_ev_exprz00_bglt) BgL_arg1715z00_1641), BgL_stkz00_118);
					}
					{	/* Eval/evaluate_comp.scm 693 */
						obj_t BgL_arg1716z00_1642;
						obj_t BgL_arg1717z00_1643;

						BgL_arg1716z00_1642 = CDR(((obj_t) BgL_eza2za2_117));
						{	/* Eval/evaluate_comp.scm 693 */
							obj_t BgL_arg1718z00_1644;

							BgL_arg1718z00_1644 = MAKE_YOUNG_PAIR(BFALSE, BNIL);
							BgL_arg1717z00_1643 =
								BGl_appendzd221011zd2zz__evaluate_compz00(BgL_stkz00_118,
								BgL_arg1718z00_1644);
						}
						BgL_arg1714z00_1640 =
							BGl_compzd2withzd2pushz00zz__evaluate_compz00(BgL_arg1716z00_1642,
							BgL_arg1717z00_1643);
					}
					return MAKE_YOUNG_PAIR(BgL_arg1713z00_1639, BgL_arg1714z00_1640);
				}
		}

	}



/* rec~0 */
	obj_t BGl_recze70ze7zz__evaluate_compz00(obj_t BgL_stkz00_15533,
		obj_t BgL_lz00_1646, long BgL_iz00_1647)
	{
		{	/* Eval/evaluate_comp.scm 696 */
			if (NULLP(BgL_lz00_1646))
				{	/* Eval/evaluate_comp.scm 697 */
					return BNIL;
				}
			else
				{	/* Eval/evaluate_comp.scm 697 */
					if ((BgL_iz00_1647 == ((long) 0)))
						{	/* Eval/evaluate_comp.scm 698 */
							return
								BGl_compzd2withzd2pushz00zz__evaluate_compz00(BgL_lz00_1646,
								BgL_stkz00_15533);
						}
					else
						{	/* Eval/evaluate_comp.scm 699 */
							obj_t BgL_arg1722z00_1651;
							obj_t BgL_arg1723z00_1652;

							{	/* Eval/evaluate_comp.scm 699 */
								obj_t BgL_arg1724z00_1653;

								BgL_arg1724z00_1653 = CAR(((obj_t) BgL_lz00_1646));
								BgL_arg1722z00_1651 =
									BGl_compz00zz__evaluate_compz00(
									((BgL_ev_exprz00_bglt) BgL_arg1724z00_1653),
									BgL_stkz00_15533);
							}
							{	/* Eval/evaluate_comp.scm 700 */
								obj_t BgL_arg1725z00_1654;
								long BgL_arg1726z00_1655;

								BgL_arg1725z00_1654 = CDR(((obj_t) BgL_lz00_1646));
								BgL_arg1726z00_1655 = (BgL_iz00_1647 - ((long) 1));
								BgL_arg1723z00_1652 =
									BGl_recze70ze7zz__evaluate_compz00(BgL_stkz00_15533,
									BgL_arg1725z00_1654, BgL_arg1726z00_1655);
							}
							return MAKE_YOUNG_PAIR(BgL_arg1722z00_1651, BgL_arg1723z00_1652);
						}
				}
		}

	}



/* subr-call-with-push */
	obj_t BGl_subrzd2callzd2withzd2pushzd2zz__evaluate_compz00(obj_t BgL_sz00_122,
		obj_t BgL_fz00_123, obj_t BgL_argsz00_124, obj_t BgL_bpz00_125,
		obj_t BgL_siza7eza7_126)
	{
		{	/* Eval/evaluate_comp.scm 702 */
			{	/* Eval/evaluate_comp.scm 704 */
				obj_t BgL_argsz00_1657;

				if (NULLP(BgL_argsz00_124))
					{	/* Eval/evaluate_comp.scm 704 */
						BgL_argsz00_1657 = BNIL;
					}
				else
					{	/* Eval/evaluate_comp.scm 704 */
						obj_t BgL_head1343z00_1662;

						{	/* Eval/evaluate_comp.scm 704 */
							obj_t BgL_res4385z00_6695;

							BgL_res4385z00_6695 = MAKE_YOUNG_PAIR(BNIL, BNIL);
							BgL_head1343z00_1662 = BgL_res4385z00_6695;
						}
						{
							obj_t BgL_l1341z00_6719;
							obj_t BgL_tail1344z00_6720;

							BgL_l1341z00_6719 = BgL_argsz00_124;
							BgL_tail1344z00_6720 = BgL_head1343z00_1662;
						BgL_zc3z04anonymousza31729ze3z87_6718:
							if (NULLP(BgL_l1341z00_6719))
								{	/* Eval/evaluate_comp.scm 704 */
									BgL_argsz00_1657 = CDR(BgL_head1343z00_1662);
								}
							else
								{	/* Eval/evaluate_comp.scm 704 */
									obj_t BgL_newtail1345z00_6727;

									{	/* Eval/evaluate_comp.scm 704 */
										obj_t BgL_arg1732z00_6728;

										{	/* Eval/evaluate_comp.scm 704 */
											obj_t BgL_az00_6729;

											BgL_az00_6729 = CAR(((obj_t) BgL_l1341z00_6719));
											BgL_arg1732z00_6728 =
												PROCEDURE_ENTRY(BgL_az00_6729) (BgL_az00_6729,
												BgL_sz00_122, BEOA);
										}
										{	/* Eval/evaluate_comp.scm 704 */
											obj_t BgL_res4391z00_6734;

											BgL_res4391z00_6734 =
												MAKE_YOUNG_PAIR(BgL_arg1732z00_6728, BNIL);
											BgL_newtail1345z00_6727 = BgL_res4391z00_6734;
										}
									}
									SET_CDR(BgL_tail1344z00_6720, BgL_newtail1345z00_6727);
									{	/* Eval/evaluate_comp.scm 704 */
										obj_t BgL_arg1731z00_6730;

										BgL_arg1731z00_6730 = CDR(((obj_t) BgL_l1341z00_6719));
										{
											obj_t BgL_tail1344z00_18730;
											obj_t BgL_l1341z00_18729;

											BgL_l1341z00_18729 = BgL_arg1731z00_6730;
											BgL_tail1344z00_18730 = BgL_newtail1345z00_6727;
											BgL_tail1344z00_6720 = BgL_tail1344z00_18730;
											BgL_l1341z00_6719 = BgL_l1341z00_18729;
											goto BgL_zc3z04anonymousza31729ze3z87_6718;
										}
									}
								}
						}
					}
				{	/* Eval/evaluate_comp.scm 705 */
					long BgL_arg1727z00_1658;

					BgL_arg1727z00_1658 =
						((long) CINT(BgL_bpz00_125) + (long) CINT(BgL_siza7eza7_126));
					VECTOR_SET(
						((obj_t) BgL_sz00_122), ((long) 0), BINT(BgL_arg1727z00_1658));
				}
				{	/* Eval/evaluate_comp.scm 706 */
					obj_t BgL_za2za2resza2za2z00_1659;

					BgL_za2za2resza2za2z00_1659 = apply(BgL_fz00_123, BgL_argsz00_1657);
					VECTOR_SET(((obj_t) BgL_sz00_122), ((long) 0), BgL_bpz00_125);
					return BgL_za2za2resza2za2z00_1659;
				}
			}
		}

	}



/* push-nargs-on-sp */
	obj_t BGl_pushzd2nargszd2onzd2spzd2zz__evaluate_compz00(obj_t
		BgL_arityz00_130, obj_t BgL_sz00_131, obj_t BgL_argsz00_132,
		obj_t BgL_spz00_133)
	{
		{	/* Eval/evaluate_comp.scm 715 */
			{	/* Eval/evaluate_comp.scm 716 */
				long BgL_g1149z00_1683;

				BgL_g1149z00_1683 = (((long) -1) - (long) CINT(BgL_arityz00_130));
				{
					obj_t BgL_lz00_1685;
					obj_t BgL_spz00_1686;
					long BgL_nz00_1687;

					BgL_lz00_1685 = BgL_argsz00_132;
					BgL_spz00_1686 = BgL_spz00_133;
					BgL_nz00_1687 = BgL_g1149z00_1683;
				BgL_zc3z04anonymousza31739ze3z87_1688:
					if ((BgL_nz00_1687 == ((long) 0)))
						{
							obj_t BgL_lz00_6821;
							obj_t BgL_rz00_6822;

							BgL_lz00_6821 = BgL_lz00_1685;
							BgL_rz00_6822 = BNIL;
						BgL_rec2z00_6820:
							if (NULLP(BgL_lz00_6821))
								{	/* Eval/evaluate_comp.scm 720 */
									obj_t BgL_arg1743z00_6830;

									BgL_arg1743z00_6830 = bgl_reverse_bang(BgL_rz00_6822);
									{	/* Eval/evaluate_comp.scm 720 */
										long BgL_kz00_6837;

										BgL_kz00_6837 = (long) CINT(BgL_spz00_1686);
										return
											VECTOR_SET(
											((obj_t) BgL_sz00_131), BgL_kz00_6837,
											BgL_arg1743z00_6830);
									}
								}
							else
								{	/* Eval/evaluate_comp.scm 721 */
									obj_t BgL_arg1744z00_6831;
									obj_t BgL_arg1745z00_6832;

									BgL_arg1744z00_6831 = CDR(((obj_t) BgL_lz00_6821));
									{	/* Eval/evaluate_comp.scm 721 */
										obj_t BgL_arg1746z00_6833;

										{	/* Eval/evaluate_comp.scm 721 */
											obj_t BgL_fun1747z00_6834;

											BgL_fun1747z00_6834 = CAR(((obj_t) BgL_lz00_6821));
											BgL_arg1746z00_6833 =
												PROCEDURE_ENTRY(BgL_fun1747z00_6834)
												(BgL_fun1747z00_6834, BgL_sz00_131, BEOA);
										}
										BgL_arg1745z00_6832 =
											MAKE_YOUNG_PAIR(BgL_arg1746z00_6833, BgL_rz00_6822);
									}
									{
										obj_t BgL_rz00_18761;
										obj_t BgL_lz00_18760;

										BgL_lz00_18760 = BgL_arg1744z00_6831;
										BgL_rz00_18761 = BgL_arg1745z00_6832;
										BgL_rz00_6822 = BgL_rz00_18761;
										BgL_lz00_6821 = BgL_lz00_18760;
										goto BgL_rec2z00_6820;
									}
								}
						}
					else
						{	/* Eval/evaluate_comp.scm 717 */
							{	/* Eval/evaluate_comp.scm 722 */
								obj_t BgL_arg1748z00_1702;

								{	/* Eval/evaluate_comp.scm 722 */
									obj_t BgL_fun1750z00_1703;

									BgL_fun1750z00_1703 = CAR(((obj_t) BgL_lz00_1685));
									BgL_arg1748z00_1702 =
										PROCEDURE_ENTRY(BgL_fun1750z00_1703) (BgL_fun1750z00_1703,
										BgL_sz00_131, BEOA);
								}
								{	/* Eval/evaluate_comp.scm 722 */
									long BgL_kz00_6842;

									BgL_kz00_6842 = (long) CINT(BgL_spz00_1686);
									VECTOR_SET(
										((obj_t) BgL_sz00_131), BgL_kz00_6842, BgL_arg1748z00_1702);
							}}
							{	/* Eval/evaluate_comp.scm 723 */
								obj_t BgL_arg1751z00_1704;
								long BgL_arg1752z00_1705;
								long BgL_arg1753z00_1706;

								BgL_arg1751z00_1704 = CDR(((obj_t) BgL_lz00_1685));
								BgL_arg1752z00_1705 =
									((long) CINT(BgL_spz00_1686) + ((long) 1));
								BgL_arg1753z00_1706 = (BgL_nz00_1687 - ((long) 1));
								{
									long BgL_nz00_18779;
									obj_t BgL_spz00_18777;
									obj_t BgL_lz00_18776;

									BgL_lz00_18776 = BgL_arg1751z00_1704;
									BgL_spz00_18777 = BINT(BgL_arg1752z00_1705);
									BgL_nz00_18779 = BgL_arg1753z00_1706;
									BgL_nz00_1687 = BgL_nz00_18779;
									BgL_spz00_1686 = BgL_spz00_18777;
									BgL_lz00_1685 = BgL_lz00_18776;
									goto BgL_zc3z04anonymousza31739ze3z87_1688;
								}
							}
						}
				}
			}
		}

	}



/* need-shift */
	bool_t BGl_needzd2shiftzd2zz__evaluate_compz00(obj_t BgL_argsz00_134,
		obj_t BgL_stkz00_135)
	{
		{	/* Eval/evaluate_comp.scm 766 */
			{
				obj_t BgL_lz00_1709;
				obj_t BgL_stkz00_1710;

				BgL_lz00_1709 = BgL_argsz00_134;
				BgL_stkz00_1710 = BgL_stkz00_135;
			BgL_zc3z04anonymousza31754ze3z87_1711:
				{	/* Eval/evaluate_comp.scm 770 */
					bool_t BgL_test6103z00_18780;

					if (NULLP(BgL_lz00_1709))
						{	/* Eval/evaluate_comp.scm 770 */
							BgL_test6103z00_18780 = ((bool_t) 1);
						}
					else
						{	/* Eval/evaluate_comp.scm 770 */
							BgL_test6103z00_18780 = NULLP(BgL_stkz00_1710);
						}
					if (BgL_test6103z00_18780)
						{	/* Eval/evaluate_comp.scm 770 */
							return ((bool_t) 0);
						}
					else
						{	/* Eval/evaluate_comp.scm 772 */
							bool_t BgL_test6105z00_18784;

							{	/* Eval/evaluate_comp.scm 772 */
								obj_t BgL_g1348z00_1728;

								BgL_g1348z00_1728 = CDR(((obj_t) BgL_lz00_1709));
								{
									obj_t BgL_l1346z00_1730;

									{	/* Eval/evaluate_comp.scm 772 */
										obj_t BgL_tmpz00_18787;

										BgL_l1346z00_1730 = BgL_g1348z00_1728;
									BgL_zc3z04anonymousza31765ze3z87_1731:
										if (NULLP(BgL_l1346z00_1730))
											{	/* Eval/evaluate_comp.scm 772 */
												BgL_tmpz00_18787 = BFALSE;
											}
										else
											{	/* Eval/evaluate_comp.scm 772 */
												obj_t BgL__ortest_1349z00_1733;

												{	/* Eval/evaluate_comp.scm 772 */
													obj_t BgL_ez00_1735;

													BgL_ez00_1735 = CAR(((obj_t) BgL_l1346z00_1730));
													{	/* Eval/evaluate_comp.scm 772 */
														obj_t BgL_arg1768z00_1736;
														obj_t BgL_arg1770z00_1737;

														BgL_arg1768z00_1736 =
															CAR(((obj_t) BgL_stkz00_1710));
														BgL_arg1770z00_1737 =
															BGl_usez00zz__evaluate_usez00(
															((BgL_ev_exprz00_bglt) BgL_ez00_1735), BNIL);
														BgL__ortest_1349z00_1733 =
															BGl_memqz00zz__r4_pairs_and_lists_6_3z00
															(BgL_arg1768z00_1736, BgL_arg1770z00_1737);
													}
												}
												if (CBOOL(BgL__ortest_1349z00_1733))
													{	/* Eval/evaluate_comp.scm 772 */
														BgL_tmpz00_18787 = BgL__ortest_1349z00_1733;
													}
												else
													{	/* Eval/evaluate_comp.scm 772 */
														obj_t BgL_arg1766z00_1734;

														BgL_arg1766z00_1734 =
															CDR(((obj_t) BgL_l1346z00_1730));
														{
															obj_t BgL_l1346z00_18801;

															BgL_l1346z00_18801 = BgL_arg1766z00_1734;
															BgL_l1346z00_1730 = BgL_l1346z00_18801;
															goto BgL_zc3z04anonymousza31765ze3z87_1731;
														}
													}
											}
										BgL_test6105z00_18784 = CBOOL(BgL_tmpz00_18787);
									}
								}
							}
							if (BgL_test6105z00_18784)
								{	/* Eval/evaluate_comp.scm 772 */
									return ((bool_t) 1);
								}
							else
								{	/* Eval/evaluate_comp.scm 774 */
									obj_t BgL_arg1763z00_1726;
									obj_t BgL_arg1764z00_1727;

									BgL_arg1763z00_1726 = CDR(((obj_t) BgL_lz00_1709));
									BgL_arg1764z00_1727 = CDR(((obj_t) BgL_stkz00_1710));
									{
										obj_t BgL_stkz00_18808;
										obj_t BgL_lz00_18807;

										BgL_lz00_18807 = BgL_arg1763z00_1726;
										BgL_stkz00_18808 = BgL_arg1764z00_1727;
										BgL_stkz00_1710 = BgL_stkz00_18808;
										BgL_lz00_1709 = BgL_lz00_18807;
										goto BgL_zc3z04anonymousza31754ze3z87_1711;
									}
								}
						}
				}
			}
		}

	}



/* comp-old-call */
	obj_t BGl_compzd2oldzd2callz00zz__evaluate_compz00(BgL_ev_appz00_bglt
		BgL_ez00_136, obj_t BgL_stkz00_137)
	{
		{	/* Eval/evaluate_comp.scm 776 */
			{	/* Eval/evaluate_comp.scm 778 */
				long BgL_siza7eza7_1742;
				long BgL_nbargsz00_1743;
				obj_t BgL_fz00_1744;
				obj_t BgL_symbzd2funzd2_1745;

				BgL_siza7eza7_1742 = bgl_list_length(BgL_stkz00_137);
				BgL_nbargsz00_1743 =
					bgl_list_length(
					(((BgL_ev_appz00_bglt) COBJECT(BgL_ez00_136))->BgL_argsz00));
				BgL_fz00_1744 =
					BGl_compz00zz__evaluate_compz00(
					(((BgL_ev_appz00_bglt) COBJECT(BgL_ez00_136))->BgL_funz00),
					BgL_stkz00_137);
				BgL_symbzd2funzd2_1745 =
					BGl_uncompilez00zz__evaluate_uncompz00((((BgL_ev_appz00_bglt)
							COBJECT(BgL_ez00_136))->BgL_funz00));
				if (CBOOL((((BgL_ev_appz00_bglt) COBJECT(BgL_ez00_136))->
							BgL_tailzf3zf3)))
					{	/* Eval/evaluate_comp.scm 780 */
						if (BGl_needzd2shiftzd2zz__evaluate_compz00(
								(((BgL_ev_appz00_bglt) COBJECT(BgL_ez00_136))->BgL_argsz00),
								BgL_stkz00_137))
							{	/* Eval/evaluate_comp.scm 787 */
								bool_t BgL_test6110z00_18822;

								{	/* Eval/evaluate_comp.scm 787 */
									int BgL_arg1828z00_1824;

									BgL_arg1828z00_1824 = bgl_debug();
									BgL_test6110z00_18822 =
										BGl_2ze3ze3zz__r4_numbers_6_5z00(BINT(BgL_arg1828z00_1824),
										BINT(((long) 0)));
								}
								if (BgL_test6110z00_18822)
									{	/* Eval/evaluate_comp.scm 787 */
										obj_t BgL_argsz00_1751;

										BgL_argsz00_1751 =
											BGl_compzd2withzd2pushz00zz__evaluate_compz00(
											(((BgL_ev_appz00_bglt) COBJECT(BgL_ez00_136))->
												BgL_argsz00), BgL_stkz00_137);
										{	/* Eval/evaluate_comp.scm 787 */
											obj_t BgL_zc3z04anonymousza31777ze3z87_13563;

											BgL_zc3z04anonymousza31777ze3z87_13563 =
												MAKE_FX_PROCEDURE
												(BGl_z62zc3z04anonymousza31777ze3ze5zz__evaluate_compz00,
												(int) (((long) 1)), (int) (((long) 6)));
											PROCEDURE_SET(BgL_zc3z04anonymousza31777ze3z87_13563,
												(int) (((long) 0)), BgL_fz00_1744);
											PROCEDURE_SET(BgL_zc3z04anonymousza31777ze3z87_13563,
												(int) (((long) 1)), ((obj_t) BgL_ez00_136));
											PROCEDURE_SET(BgL_zc3z04anonymousza31777ze3z87_13563,
												(int) (((long) 2)), BgL_symbzd2funzd2_1745);
											PROCEDURE_SET(BgL_zc3z04anonymousza31777ze3z87_13563,
												(int) (((long) 3)), BINT(BgL_nbargsz00_1743));
											PROCEDURE_SET(BgL_zc3z04anonymousza31777ze3z87_13563,
												(int) (((long) 4)), BgL_argsz00_1751);
											PROCEDURE_SET(BgL_zc3z04anonymousza31777ze3z87_13563,
												(int) (((long) 5)), BINT(BgL_siza7eza7_1742));
											return BgL_zc3z04anonymousza31777ze3z87_13563;
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 787 */
										obj_t BgL_argsz00_1789;

										BgL_argsz00_1789 =
											BGl_compzd2withzd2pushz00zz__evaluate_compz00(
											(((BgL_ev_appz00_bglt) COBJECT(BgL_ez00_136))->
												BgL_argsz00), BgL_stkz00_137);
										{	/* Eval/evaluate_comp.scm 787 */
											obj_t BgL_zc3z04anonymousza31804ze3z87_13564;

											BgL_zc3z04anonymousza31804ze3z87_13564 =
												MAKE_FX_PROCEDURE
												(BGl_z62zc3z04anonymousza31804ze3ze5zz__evaluate_compz00,
												(int) (((long) 1)), (int) (((long) 6)));
											PROCEDURE_SET(BgL_zc3z04anonymousza31804ze3z87_13564,
												(int) (((long) 0)), BgL_fz00_1744);
											PROCEDURE_SET(BgL_zc3z04anonymousza31804ze3z87_13564,
												(int) (((long) 1)), ((obj_t) BgL_ez00_136));
											PROCEDURE_SET(BgL_zc3z04anonymousza31804ze3z87_13564,
												(int) (((long) 2)), BgL_symbzd2funzd2_1745);
											PROCEDURE_SET(BgL_zc3z04anonymousza31804ze3z87_13564,
												(int) (((long) 3)), BINT(BgL_nbargsz00_1743));
											PROCEDURE_SET(BgL_zc3z04anonymousza31804ze3z87_13564,
												(int) (((long) 4)), BgL_argsz00_1789);
											PROCEDURE_SET(BgL_zc3z04anonymousza31804ze3z87_13564,
												(int) (((long) 5)), BINT(BgL_siza7eza7_1742));
											return BgL_zc3z04anonymousza31804ze3z87_13564;
										}
									}
							}
						else
							{	/* Eval/evaluate_comp.scm 795 */
								bool_t BgL_test6111z00_18867;

								{	/* Eval/evaluate_comp.scm 795 */
									int BgL_arg1873z00_1894;

									BgL_arg1873z00_1894 = bgl_debug();
									BgL_test6111z00_18867 =
										BGl_2ze3ze3zz__r4_numbers_6_5z00(BINT(BgL_arg1873z00_1894),
										BINT(((long) 0)));
								}
								if (BgL_test6111z00_18867)
									{	/* Eval/evaluate_comp.scm 795 */
										obj_t BgL_argsz00_1827;

										BgL_argsz00_1827 =
											BGl_recze70ze7zz__evaluate_compz00(BgL_stkz00_137,
											(((BgL_ev_appz00_bglt) COBJECT(BgL_ez00_136))->
												BgL_argsz00), BgL_siza7eza7_1742);
										{	/* Eval/evaluate_comp.scm 795 */
											obj_t BgL_zc3z04anonymousza31831ze3z87_13565;

											BgL_zc3z04anonymousza31831ze3z87_13565 =
												MAKE_FX_PROCEDURE
												(BGl_z62zc3z04anonymousza31831ze3ze5zz__evaluate_compz00,
												(int) (((long) 1)), (int) (((long) 5)));
											PROCEDURE_SET(BgL_zc3z04anonymousza31831ze3z87_13565,
												(int) (((long) 0)), BgL_fz00_1744);
											PROCEDURE_SET(BgL_zc3z04anonymousza31831ze3z87_13565,
												(int) (((long) 1)), ((obj_t) BgL_ez00_136));
											PROCEDURE_SET(BgL_zc3z04anonymousza31831ze3z87_13565,
												(int) (((long) 2)), BgL_symbzd2funzd2_1745);
											PROCEDURE_SET(BgL_zc3z04anonymousza31831ze3z87_13565,
												(int) (((long) 3)), BINT(BgL_nbargsz00_1743));
											PROCEDURE_SET(BgL_zc3z04anonymousza31831ze3z87_13565,
												(int) (((long) 4)), BgL_argsz00_1827);
											return BgL_zc3z04anonymousza31831ze3z87_13565;
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 795 */
										obj_t BgL_argsz00_1862;

										BgL_argsz00_1862 =
											BGl_recze70ze7zz__evaluate_compz00(BgL_stkz00_137,
											(((BgL_ev_appz00_bglt) COBJECT(BgL_ez00_136))->
												BgL_argsz00), BgL_siza7eza7_1742);
										{	/* Eval/evaluate_comp.scm 795 */
											obj_t BgL_zc3z04anonymousza31854ze3z87_13566;

											BgL_zc3z04anonymousza31854ze3z87_13566 =
												MAKE_FX_PROCEDURE
												(BGl_z62zc3z04anonymousza31854ze3ze5zz__evaluate_compz00,
												(int) (((long) 1)), (int) (((long) 5)));
											PROCEDURE_SET(BgL_zc3z04anonymousza31854ze3z87_13566,
												(int) (((long) 0)), BgL_fz00_1744);
											PROCEDURE_SET(BgL_zc3z04anonymousza31854ze3z87_13566,
												(int) (((long) 1)), ((obj_t) BgL_ez00_136));
											PROCEDURE_SET(BgL_zc3z04anonymousza31854ze3z87_13566,
												(int) (((long) 2)), BgL_symbzd2funzd2_1745);
											PROCEDURE_SET(BgL_zc3z04anonymousza31854ze3z87_13566,
												(int) (((long) 3)), BINT(BgL_nbargsz00_1743));
											PROCEDURE_SET(BgL_zc3z04anonymousza31854ze3z87_13566,
												(int) (((long) 4)), BgL_argsz00_1862);
											return BgL_zc3z04anonymousza31854ze3z87_13566;
										}
									}
							}
					}
				else
					{	/* Eval/evaluate_comp.scm 781 */
						bool_t BgL_test6112z00_18906;

						{	/* Eval/evaluate_comp.scm 781 */
							int BgL_arg1915z00_1965;

							BgL_arg1915z00_1965 = bgl_debug();
							BgL_test6112z00_18906 =
								BGl_2ze3ze3zz__r4_numbers_6_5z00(BINT(BgL_arg1915z00_1965),
								BINT(((long) 0)));
						}
						if (BgL_test6112z00_18906)
							{	/* Eval/evaluate_comp.scm 781 */
								obj_t BgL_argsz00_1898;

								BgL_argsz00_1898 =
									BGl_compzd2withzd2pushz00zz__evaluate_compz00(
									(((BgL_ev_appz00_bglt) COBJECT(BgL_ez00_136))->BgL_argsz00),
									BgL_stkz00_137);
								{	/* Eval/evaluate_comp.scm 781 */
									obj_t BgL_zc3z04anonymousza31877ze3z87_13567;

									BgL_zc3z04anonymousza31877ze3z87_13567 =
										MAKE_FX_PROCEDURE
										(BGl_z62zc3z04anonymousza31877ze3ze5zz__evaluate_compz00,
										(int) (((long) 1)), (int) (((long) 6)));
									PROCEDURE_SET(BgL_zc3z04anonymousza31877ze3z87_13567,
										(int) (((long) 0)), BgL_fz00_1744);
									PROCEDURE_SET(BgL_zc3z04anonymousza31877ze3z87_13567,
										(int) (((long) 1)), ((obj_t) BgL_ez00_136));
									PROCEDURE_SET(BgL_zc3z04anonymousza31877ze3z87_13567,
										(int) (((long) 2)), BgL_symbzd2funzd2_1745);
									PROCEDURE_SET(BgL_zc3z04anonymousza31877ze3z87_13567,
										(int) (((long) 3)), BINT(BgL_nbargsz00_1743));
									PROCEDURE_SET(BgL_zc3z04anonymousza31877ze3z87_13567,
										(int) (((long) 4)), BgL_argsz00_1898);
									PROCEDURE_SET(BgL_zc3z04anonymousza31877ze3z87_13567,
										(int) (((long) 5)), BINT(BgL_siza7eza7_1742));
									return BgL_zc3z04anonymousza31877ze3z87_13567;
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 781 */
								obj_t BgL_argsz00_1933;

								BgL_argsz00_1933 =
									BGl_compzd2withzd2pushz00zz__evaluate_compz00(
									(((BgL_ev_appz00_bglt) COBJECT(BgL_ez00_136))->BgL_argsz00),
									BgL_stkz00_137);
								{	/* Eval/evaluate_comp.scm 781 */
									obj_t BgL_zc3z04anonymousza31898ze3z87_13568;

									BgL_zc3z04anonymousza31898ze3z87_13568 =
										MAKE_FX_PROCEDURE
										(BGl_z62zc3z04anonymousza31898ze3ze5zz__evaluate_compz00,
										(int) (((long) 1)), (int) (((long) 6)));
									PROCEDURE_SET(BgL_zc3z04anonymousza31898ze3z87_13568,
										(int) (((long) 0)), BgL_fz00_1744);
									PROCEDURE_SET(BgL_zc3z04anonymousza31898ze3z87_13568,
										(int) (((long) 1)), ((obj_t) BgL_ez00_136));
									PROCEDURE_SET(BgL_zc3z04anonymousza31898ze3z87_13568,
										(int) (((long) 2)), BgL_symbzd2funzd2_1745);
									PROCEDURE_SET(BgL_zc3z04anonymousza31898ze3z87_13568,
										(int) (((long) 3)), BINT(BgL_nbargsz00_1743));
									PROCEDURE_SET(BgL_zc3z04anonymousza31898ze3z87_13568,
										(int) (((long) 4)), BgL_argsz00_1933);
									PROCEDURE_SET(BgL_zc3z04anonymousza31898ze3z87_13568,
										(int) (((long) 5)), BINT(BgL_siza7eza7_1742));
									return BgL_zc3z04anonymousza31898ze3z87_13568;
								}
							}
					}
			}
		}

	}



/* &<@anonymous:1777> */
	obj_t BGl_z62zc3z04anonymousza31777ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_13569, obj_t BgL_sz00_13576)
	{
		{	/* Eval/evaluate_comp.scm 787 */
			{	/* Eval/evaluate_comp.scm 787 */
				obj_t BgL_fz00_13570;
				BgL_ev_appz00_bglt BgL_i1157z00_13571;
				obj_t BgL_symbzd2funzd2_13572;
				long BgL_nbargsz00_13573;
				obj_t BgL_argsz00_13574;
				long BgL_siza7eza7_13575;

				BgL_fz00_13570 = PROCEDURE_REF(BgL_envz00_13569, (int) (((long) 0)));
				BgL_i1157z00_13571 =
					((BgL_ev_appz00_bglt)
					PROCEDURE_REF(BgL_envz00_13569, (int) (((long) 1))));
				BgL_symbzd2funzd2_13572 =
					PROCEDURE_REF(BgL_envz00_13569, (int) (((long) 2)));
				BgL_nbargsz00_13573 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13569, (int) (((long) 3))));
				BgL_argsz00_13574 =
					((obj_t) PROCEDURE_REF(BgL_envz00_13569, (int) (((long) 4))));
				BgL_siza7eza7_13575 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13569, (int) (((long) 5))));
				{	/* Eval/evaluate_comp.scm 787 */
					obj_t BgL_bpz00_15554;

					BgL_bpz00_15554 = VECTOR_REF(((obj_t) BgL_sz00_13576), ((long) 0));
					{	/* Eval/evaluate_comp.scm 787 */
						obj_t BgL_fz00_15555;

						BgL_fz00_15555 =
							PROCEDURE_ENTRY(BgL_fz00_13570) (BgL_fz00_13570, BgL_sz00_13576,
							BEOA);
						if (PROCEDUREP(BgL_fz00_15555))
							{	/* Eval/evaluate_comp.scm 787 */
								BFALSE;
							}
						else
							{	/* Eval/evaluate_comp.scm 787 */
								BGl_evtypezd2errorzd2zz__everrorz00(
									(((BgL_ev_appz00_bglt) COBJECT(BgL_i1157z00_13571))->
										BgL_locz00), BGl_string5807z00zz__evaluate_compz00,
									BGl_string5823z00zz__evaluate_compz00, BgL_fz00_15555);
							}
						{	/* Eval/evaluate_comp.scm 787 */
							obj_t BgL_ufz00_15556;

							{	/* Eval/evaluate_comp.scm 787 */
								obj_t BgL_tmpz00_18977;

								BgL_tmpz00_18977 = ((obj_t) BgL_fz00_15555);
								BgL_ufz00_15556 = PROCEDURE_ATTR(BgL_tmpz00_18977);
							}
							{	/* Eval/evaluate_comp.scm 787 */
								bool_t BgL_test6114z00_18980;

								if (STRUCTP(BgL_ufz00_15556))
									{	/* Eval/evaluate_comp.scm 683 */
										BgL_test6114z00_18980 =
											(STRUCT_KEY(BgL_ufz00_15556) ==
											BGl_symbol5824z00zz__evaluate_compz00);
									}
								else
									{	/* Eval/evaluate_comp.scm 683 */
										BgL_test6114z00_18980 = ((bool_t) 0);
									}
								if (BgL_test6114z00_18980)
									{	/* Eval/evaluate_comp.scm 787 */
										obj_t BgL_arityz00_15557;
										obj_t BgL_runz00_15558;
										obj_t BgL_sfz00_15559;

										BgL_arityz00_15557 =
											STRUCT_REF(BgL_ufz00_15556, (int) (((long) 0)));
										BgL_runz00_15558 =
											STRUCT_REF(BgL_ufz00_15556, (int) (((long) 1)));
										BgL_sfz00_15559 =
											STRUCT_REF(BgL_ufz00_15556, (int) (((long) 2)));
										{	/* Eval/evaluate_comp.scm 787 */
											long BgL_spz00_15560;

											BgL_spz00_15560 =
												((long) CINT(BgL_bpz00_15554) + BgL_siza7eza7_13575);
											if (
												((long) CINT(BgL_arityz00_15557) ==
													BgL_nbargsz00_13573))
												{	/* Eval/evaluate_comp.scm 787 */
													{
														obj_t BgL_lz00_15562;
														long BgL_spz00_15563;

														BgL_lz00_15562 = BgL_argsz00_13574;
														BgL_spz00_15563 = BgL_spz00_15560;
													BgL_recz00_15561:
														if (NULLP(BgL_lz00_15562))
															{	/* Eval/evaluate_comp.scm 711 */
																((bool_t) 0);
															}
														else
															{	/* Eval/evaluate_comp.scm 711 */
																{	/* Eval/evaluate_comp.scm 712 */
																	obj_t BgL_arg1735z00_15564;

																	{	/* Eval/evaluate_comp.scm 712 */
																		obj_t BgL_fun1736z00_15565;

																		BgL_fun1736z00_15565 =
																			CAR(((obj_t) BgL_lz00_15562));
																		BgL_arg1735z00_15564 =
																			PROCEDURE_ENTRY(BgL_fun1736z00_15565)
																			(BgL_fun1736z00_15565, BgL_sz00_13576,
																			BEOA);
																	}
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13576), BgL_spz00_15563,
																		BgL_arg1735z00_15564);
																}
																{	/* Eval/evaluate_comp.scm 713 */
																	obj_t BgL_arg1737z00_15566;
																	long BgL_arg1738z00_15567;

																	BgL_arg1737z00_15566 =
																		CDR(((obj_t) BgL_lz00_15562));
																	BgL_arg1738z00_15567 =
																		(BgL_spz00_15563 + ((long) 1));
																	{
																		long BgL_spz00_19010;
																		obj_t BgL_lz00_19009;

																		BgL_lz00_19009 = BgL_arg1737z00_15566;
																		BgL_spz00_19010 = BgL_arg1738z00_15567;
																		BgL_spz00_15563 = BgL_spz00_19010;
																		BgL_lz00_15562 = BgL_lz00_19009;
																		goto BgL_recz00_15561;
																	}
																}
															}
													}
													{	/* Eval/evaluate_comp.scm 791 */
														long BgL_arg1783z00_15568;

														BgL_arg1783z00_15568 =
															(BgL_spz00_15560 + BgL_nbargsz00_13573);
														BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00
															(BgL_sz00_13576, (long) CINT(BgL_bpz00_15554),
															BgL_sz00_13576, BINT(BgL_spz00_15560),
															BINT(BgL_arg1783z00_15568));
												}}
											else
												{	/* Eval/evaluate_comp.scm 787 */
													bool_t BgL_test6118z00_19016;

													if (((long) CINT(BgL_arityz00_15557) >= ((long) 0)))
														{	/* Eval/evaluate_comp.scm 787 */
															BgL_test6118z00_19016 = ((bool_t) 1);
														}
													else
														{	/* Eval/evaluate_comp.scm 787 */
															BgL_test6118z00_19016 =
																(
																(long) CINT(BgL_arityz00_15557) <
																(((long) -1) - BgL_nbargsz00_13573));
														}
													if (BgL_test6118z00_19016)
														{	/* Eval/evaluate_comp.scm 787 */
															BGl_evarityzd2errorzd2zz__everrorz00(
																(((BgL_ev_appz00_bglt)
																		COBJECT(BgL_i1157z00_13571))->BgL_locz00),
																STRUCT_REF(BgL_ufz00_15556, (int) (((long) 3))),
																(int) (BgL_nbargsz00_13573),
																CINT(BgL_arityz00_15557));
														}
													else
														{	/* Eval/evaluate_comp.scm 787 */
															BGl_pushzd2nargszd2onzd2spzd2zz__evaluate_compz00
																(BgL_arityz00_15557, BgL_sz00_13576,
																BgL_argsz00_13574, BINT(BgL_spz00_15560));
															{	/* Eval/evaluate_comp.scm 793 */
																long BgL_arg1790z00_15569;

																BgL_arg1790z00_15569 =
																	(BgL_spz00_15560 +
																	(((long) 0) -
																		(long) CINT(BgL_arityz00_15557)));
																BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00
																	(BgL_sz00_13576, (long) CINT(BgL_bpz00_15554),
																	BgL_sz00_13576, BINT(BgL_spz00_15560),
																	BINT(BgL_arg1790z00_15569));
												}}}
											{	/* Eval/evaluate_comp.scm 787 */
												obj_t BgL_z12denvz12_15570;

												BgL_z12denvz12_15570 = BGL_CURRENT_DYNAMIC_ENV();
												{	/* Eval/evaluate_comp.scm 787 */
													obj_t BgL_tmpz00_19039;

													BgL_tmpz00_19039 =
														(((BgL_ev_appz00_bglt)
															COBJECT(BgL_i1157z00_13571))->BgL_locz00);
													BGL_ENV_SET_TRACE_LOCATION(BgL_z12denvz12_15570,
														BgL_tmpz00_19039);
												}
												if (
													(((long) CINT(BgL_bpz00_15554) +
															(long) CINT(BgL_sfz00_15559)) <
														VECTOR_LENGTH(((obj_t) BgL_sz00_13576))))
													{	/* Eval/evaluate_comp.scm 787 */
														return BgL_runz00_15558;
													}
												else
													{	/* Eval/evaluate_comp.scm 787 */
														obj_t BgL_nsz00_15571;

														BgL_nsz00_15571 =
															BGl_makezd2statezd2zz__evaluate_compz00();
														{	/* Eval/evaluate_comp.scm 787 */
															long BgL_arg1795z00_15572;

															BgL_arg1795z00_15572 =
																(
																(long) CINT(BgL_bpz00_15554) +
																BgL_nbargsz00_13573);
															BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00
																(BgL_nsz00_15571, ((long) 2), BgL_sz00_13576,
																BgL_bpz00_15554, BINT(BgL_arg1795z00_15572));
														}
														VECTOR_SET(BgL_nsz00_15571, ((long) 1),
															BgL_sz00_13576);
														BGL_ENV_EVSTATE_SET(BgL_z12denvz12_15570,
															BgL_nsz00_15571);
														{	/* Eval/evaluate_comp.scm 787 */
															obj_t BgL_ez00_15573;

															BgL_ez00_15573 = BGL_EXITD_TOP_AS_OBJ();
															BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
																(BgL_ez00_15573, BgL_sz00_13576);
															{	/* Eval/evaluate_comp.scm 787 */
																obj_t BgL_____rz00_15574;

																{	/* Eval/evaluate_comp.scm 670 */
																	obj_t BgL_savedzd2bpzd2_15575;

																	BgL_savedzd2bpzd2_15575 =
																		VECTOR_REF(BgL_nsz00_15571, ((long) 0));
																	VECTOR_SET(BgL_nsz00_15571, ((long) 0),
																		BINT(((long) 2)));
																	{
																		obj_t BgL_fz00_15577;

																		BgL_fz00_15577 = BgL_runz00_15558;
																	BgL_recz00_15576:
																		{	/* Eval/evaluate_comp.scm 673 */
																			obj_t BgL_rz00_15578;

																			BgL_rz00_15578 =
																				PROCEDURE_ENTRY(BgL_fz00_15577)
																				(BgL_fz00_15577, BgL_nsz00_15571, BEOA);
																			{	/* Eval/evaluate_comp.scm 674 */
																				bool_t BgL_test6121z00_19065;

																				if (PROCEDUREP(BgL_rz00_15578))
																					{	/* Eval/evaluate_comp.scm 674 */
																						obj_t BgL_arg1702z00_15579;

																						BgL_arg1702z00_15579 =
																							PROCEDURE_ATTR(BgL_rz00_15578);
																						if (STRUCTP(BgL_arg1702z00_15579))
																							{	/* Eval/evaluate_comp.scm 654 */
																								BgL_test6121z00_19065 =
																									(STRUCT_KEY
																									(BgL_arg1702z00_15579) ==
																									BGl_symbol5803z00zz__evaluate_compz00);
																							}
																						else
																							{	/* Eval/evaluate_comp.scm 654 */
																								BgL_test6121z00_19065 =
																									((bool_t) 0);
																							}
																					}
																				else
																					{	/* Eval/evaluate_comp.scm 674 */
																						BgL_test6121z00_19065 =
																							((bool_t) 0);
																					}
																				if (BgL_test6121z00_19065)
																					{
																						obj_t BgL_fz00_19073;

																						BgL_fz00_19073 = BgL_rz00_15578;
																						BgL_fz00_15577 = BgL_fz00_19073;
																						goto BgL_recz00_15576;
																					}
																				else
																					{	/* Eval/evaluate_comp.scm 674 */
																						VECTOR_SET(BgL_nsz00_15571,
																							((long) 0),
																							BgL_savedzd2bpzd2_15575);
																						BgL_____rz00_15574 = BgL_rz00_15578;
																}}}}}
																BGl_exitdzd2popzd2protectz12z12zz__bexitz00
																	(BgL_ez00_15573);
																BGL_ENV_EVSTATE_SET(BgL_z12denvz12_15570,
																	BgL_sz00_13576);
																return BgL_____rz00_15574;
															}
														}
													}
											}
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 787 */
										if (PROCEDURE_CORRECT_ARITYP(BgL_fz00_15555,
												(int) (BgL_nbargsz00_13573)))
											{	/* Eval/evaluate_comp.scm 787 */
												{	/* Eval/evaluate_comp.scm 787 */
													obj_t BgL_auxz00_19082;
													obj_t BgL_tmpz00_19080;

													BgL_auxz00_19082 =
														(((BgL_ev_appz00_bglt)
															COBJECT(BgL_i1157z00_13571))->BgL_locz00);
													BgL_tmpz00_19080 = BGL_CURRENT_DYNAMIC_ENV();
													BGL_ENV_SET_TRACE_LOCATION(BgL_tmpz00_19080,
														BgL_auxz00_19082);
												}
												return
													BGl_subrzd2callzd2withzd2pushzd2zz__evaluate_compz00
													(BgL_sz00_13576, BgL_fz00_15555, BgL_argsz00_13574,
													BgL_bpz00_15554, BINT(BgL_siza7eza7_13575));
											}
										else
											{	/* Eval/evaluate_comp.scm 787 */
												return
													BGl_evarityzd2errorzd2zz__everrorz00(
													(((BgL_ev_appz00_bglt) COBJECT(BgL_i1157z00_13571))->
														BgL_locz00), BgL_symbzd2funzd2_13572,
													(int) (BgL_nbargsz00_13573),
													PROCEDURE_ARITY(BgL_fz00_15555));
		}}}}}}}}

	}



/* &<@anonymous:1804> */
	obj_t BGl_z62zc3z04anonymousza31804ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_13577, obj_t BgL_sz00_13584)
	{
		{	/* Eval/evaluate_comp.scm 787 */
			{	/* Eval/evaluate_comp.scm 787 */
				obj_t BgL_fz00_13578;
				BgL_ev_appz00_bglt BgL_i1157z00_13579;
				obj_t BgL_symbzd2funzd2_13580;
				long BgL_nbargsz00_13581;
				obj_t BgL_argsz00_13582;
				long BgL_siza7eza7_13583;

				BgL_fz00_13578 = PROCEDURE_REF(BgL_envz00_13577, (int) (((long) 0)));
				BgL_i1157z00_13579 =
					((BgL_ev_appz00_bglt)
					PROCEDURE_REF(BgL_envz00_13577, (int) (((long) 1))));
				BgL_symbzd2funzd2_13580 =
					PROCEDURE_REF(BgL_envz00_13577, (int) (((long) 2)));
				BgL_nbargsz00_13581 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13577, (int) (((long) 3))));
				BgL_argsz00_13582 =
					((obj_t) PROCEDURE_REF(BgL_envz00_13577, (int) (((long) 4))));
				BgL_siza7eza7_13583 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13577, (int) (((long) 5))));
				{	/* Eval/evaluate_comp.scm 787 */
					obj_t BgL_bpz00_15580;

					BgL_bpz00_15580 = VECTOR_REF(((obj_t) BgL_sz00_13584), ((long) 0));
					{	/* Eval/evaluate_comp.scm 787 */
						obj_t BgL_fz00_15581;

						BgL_fz00_15581 =
							PROCEDURE_ENTRY(BgL_fz00_13578) (BgL_fz00_13578, BgL_sz00_13584,
							BEOA);
						if (PROCEDUREP(BgL_fz00_15581))
							{	/* Eval/evaluate_comp.scm 787 */
								BFALSE;
							}
						else
							{	/* Eval/evaluate_comp.scm 787 */
								BGl_evtypezd2errorzd2zz__everrorz00(
									(((BgL_ev_appz00_bglt) COBJECT(BgL_i1157z00_13579))->
										BgL_locz00), BGl_string5807z00zz__evaluate_compz00,
									BGl_string5823z00zz__evaluate_compz00, BgL_fz00_15581);
							}
						{	/* Eval/evaluate_comp.scm 787 */
							obj_t BgL_ufz00_15582;

							{	/* Eval/evaluate_comp.scm 787 */
								obj_t BgL_tmpz00_19117;

								BgL_tmpz00_19117 = ((obj_t) BgL_fz00_15581);
								BgL_ufz00_15582 = PROCEDURE_ATTR(BgL_tmpz00_19117);
							}
							{	/* Eval/evaluate_comp.scm 787 */
								bool_t BgL_test6126z00_19120;

								if (STRUCTP(BgL_ufz00_15582))
									{	/* Eval/evaluate_comp.scm 683 */
										BgL_test6126z00_19120 =
											(STRUCT_KEY(BgL_ufz00_15582) ==
											BGl_symbol5824z00zz__evaluate_compz00);
									}
								else
									{	/* Eval/evaluate_comp.scm 683 */
										BgL_test6126z00_19120 = ((bool_t) 0);
									}
								if (BgL_test6126z00_19120)
									{	/* Eval/evaluate_comp.scm 787 */
										obj_t BgL_arityz00_15583;
										obj_t BgL_runz00_15584;
										obj_t BgL_sfz00_15585;

										BgL_arityz00_15583 =
											STRUCT_REF(BgL_ufz00_15582, (int) (((long) 0)));
										BgL_runz00_15584 =
											STRUCT_REF(BgL_ufz00_15582, (int) (((long) 1)));
										BgL_sfz00_15585 =
											STRUCT_REF(BgL_ufz00_15582, (int) (((long) 2)));
										{	/* Eval/evaluate_comp.scm 787 */
											long BgL_spz00_15586;

											BgL_spz00_15586 =
												((long) CINT(BgL_bpz00_15580) + BgL_siza7eza7_13583);
											if (
												((long) CINT(BgL_arityz00_15583) ==
													BgL_nbargsz00_13581))
												{	/* Eval/evaluate_comp.scm 787 */
													{
														obj_t BgL_lz00_15588;
														long BgL_spz00_15589;

														BgL_lz00_15588 = BgL_argsz00_13582;
														BgL_spz00_15589 = BgL_spz00_15586;
													BgL_recz00_15587:
														if (NULLP(BgL_lz00_15588))
															{	/* Eval/evaluate_comp.scm 711 */
																((bool_t) 0);
															}
														else
															{	/* Eval/evaluate_comp.scm 711 */
																{	/* Eval/evaluate_comp.scm 712 */
																	obj_t BgL_arg1735z00_15590;

																	{	/* Eval/evaluate_comp.scm 712 */
																		obj_t BgL_fun1736z00_15591;

																		BgL_fun1736z00_15591 =
																			CAR(((obj_t) BgL_lz00_15588));
																		BgL_arg1735z00_15590 =
																			PROCEDURE_ENTRY(BgL_fun1736z00_15591)
																			(BgL_fun1736z00_15591, BgL_sz00_13584,
																			BEOA);
																	}
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13584), BgL_spz00_15589,
																		BgL_arg1735z00_15590);
																}
																{	/* Eval/evaluate_comp.scm 713 */
																	obj_t BgL_arg1737z00_15592;
																	long BgL_arg1738z00_15593;

																	BgL_arg1737z00_15592 =
																		CDR(((obj_t) BgL_lz00_15588));
																	BgL_arg1738z00_15593 =
																		(BgL_spz00_15589 + ((long) 1));
																	{
																		long BgL_spz00_19150;
																		obj_t BgL_lz00_19149;

																		BgL_lz00_19149 = BgL_arg1737z00_15592;
																		BgL_spz00_19150 = BgL_arg1738z00_15593;
																		BgL_spz00_15589 = BgL_spz00_19150;
																		BgL_lz00_15588 = BgL_lz00_19149;
																		goto BgL_recz00_15587;
																	}
																}
															}
													}
													{	/* Eval/evaluate_comp.scm 791 */
														long BgL_arg1811z00_15594;

														BgL_arg1811z00_15594 =
															(BgL_spz00_15586 + BgL_nbargsz00_13581);
														BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00
															(BgL_sz00_13584, (long) CINT(BgL_bpz00_15580),
															BgL_sz00_13584, BINT(BgL_spz00_15586),
															BINT(BgL_arg1811z00_15594));
												}}
											else
												{	/* Eval/evaluate_comp.scm 787 */
													bool_t BgL_test6130z00_19156;

													if (((long) CINT(BgL_arityz00_15583) >= ((long) 0)))
														{	/* Eval/evaluate_comp.scm 787 */
															BgL_test6130z00_19156 = ((bool_t) 1);
														}
													else
														{	/* Eval/evaluate_comp.scm 787 */
															BgL_test6130z00_19156 =
																(
																(long) CINT(BgL_arityz00_15583) <
																(((long) -1) - BgL_nbargsz00_13581));
														}
													if (BgL_test6130z00_19156)
														{	/* Eval/evaluate_comp.scm 787 */
															BGl_evarityzd2errorzd2zz__everrorz00(
																(((BgL_ev_appz00_bglt)
																		COBJECT(BgL_i1157z00_13579))->BgL_locz00),
																STRUCT_REF(BgL_ufz00_15582, (int) (((long) 3))),
																(int) (BgL_nbargsz00_13581),
																CINT(BgL_arityz00_15583));
														}
													else
														{	/* Eval/evaluate_comp.scm 787 */
															BGl_pushzd2nargszd2onzd2spzd2zz__evaluate_compz00
																(BgL_arityz00_15583, BgL_sz00_13584,
																BgL_argsz00_13582, BINT(BgL_spz00_15586));
															{	/* Eval/evaluate_comp.scm 793 */
																long BgL_arg1817z00_15595;

																BgL_arg1817z00_15595 =
																	(BgL_spz00_15586 +
																	(((long) 0) -
																		(long) CINT(BgL_arityz00_15583)));
																BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00
																	(BgL_sz00_13584, (long) CINT(BgL_bpz00_15580),
																	BgL_sz00_13584, BINT(BgL_spz00_15586),
																	BINT(BgL_arg1817z00_15595));
												}}}
											{	/* Eval/evaluate_comp.scm 787 */
												obj_t BgL_z12denvz12_15596;

												BgL_z12denvz12_15596 = BGL_CURRENT_DYNAMIC_ENV();
												if (
													(((long) CINT(BgL_bpz00_15580) +
															(long) CINT(BgL_sfz00_15585)) <
														VECTOR_LENGTH(((obj_t) BgL_sz00_13584))))
													{	/* Eval/evaluate_comp.scm 787 */
														return BgL_runz00_15584;
													}
												else
													{	/* Eval/evaluate_comp.scm 787 */
														obj_t BgL_nsz00_15597;

														BgL_nsz00_15597 =
															BGl_makezd2statezd2zz__evaluate_compz00();
														{	/* Eval/evaluate_comp.scm 787 */
															long BgL_arg1822z00_15598;

															BgL_arg1822z00_15598 =
																(
																(long) CINT(BgL_bpz00_15580) +
																BgL_nbargsz00_13581);
															BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00
																(BgL_nsz00_15597, ((long) 2), BgL_sz00_13584,
																BgL_bpz00_15580, BINT(BgL_arg1822z00_15598));
														}
														VECTOR_SET(BgL_nsz00_15597, ((long) 1),
															BgL_sz00_13584);
														BGL_ENV_EVSTATE_SET(BgL_z12denvz12_15596,
															BgL_nsz00_15597);
														{	/* Eval/evaluate_comp.scm 787 */
															obj_t BgL_ez00_15599;

															BgL_ez00_15599 = BGL_EXITD_TOP_AS_OBJ();
															BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
																(BgL_ez00_15599, BgL_sz00_13584);
															{	/* Eval/evaluate_comp.scm 787 */
																obj_t BgL_____rz00_15600;

																{	/* Eval/evaluate_comp.scm 670 */
																	obj_t BgL_savedzd2bpzd2_15601;

																	BgL_savedzd2bpzd2_15601 =
																		VECTOR_REF(BgL_nsz00_15597, ((long) 0));
																	VECTOR_SET(BgL_nsz00_15597, ((long) 0),
																		BINT(((long) 2)));
																	{
																		obj_t BgL_fz00_15603;

																		BgL_fz00_15603 = BgL_runz00_15584;
																	BgL_recz00_15602:
																		{	/* Eval/evaluate_comp.scm 673 */
																			obj_t BgL_rz00_15604;

																			BgL_rz00_15604 =
																				PROCEDURE_ENTRY(BgL_fz00_15603)
																				(BgL_fz00_15603, BgL_nsz00_15597, BEOA);
																			{	/* Eval/evaluate_comp.scm 674 */
																				bool_t BgL_test6133z00_19202;

																				if (PROCEDUREP(BgL_rz00_15604))
																					{	/* Eval/evaluate_comp.scm 674 */
																						obj_t BgL_arg1702z00_15605;

																						BgL_arg1702z00_15605 =
																							PROCEDURE_ATTR(BgL_rz00_15604);
																						if (STRUCTP(BgL_arg1702z00_15605))
																							{	/* Eval/evaluate_comp.scm 654 */
																								BgL_test6133z00_19202 =
																									(STRUCT_KEY
																									(BgL_arg1702z00_15605) ==
																									BGl_symbol5803z00zz__evaluate_compz00);
																							}
																						else
																							{	/* Eval/evaluate_comp.scm 654 */
																								BgL_test6133z00_19202 =
																									((bool_t) 0);
																							}
																					}
																				else
																					{	/* Eval/evaluate_comp.scm 674 */
																						BgL_test6133z00_19202 =
																							((bool_t) 0);
																					}
																				if (BgL_test6133z00_19202)
																					{
																						obj_t BgL_fz00_19210;

																						BgL_fz00_19210 = BgL_rz00_15604;
																						BgL_fz00_15603 = BgL_fz00_19210;
																						goto BgL_recz00_15602;
																					}
																				else
																					{	/* Eval/evaluate_comp.scm 674 */
																						VECTOR_SET(BgL_nsz00_15597,
																							((long) 0),
																							BgL_savedzd2bpzd2_15601);
																						BgL_____rz00_15600 = BgL_rz00_15604;
																}}}}}
																BGl_exitdzd2popzd2protectz12z12zz__bexitz00
																	(BgL_ez00_15599);
																BGL_ENV_EVSTATE_SET(BgL_z12denvz12_15596,
																	BgL_sz00_13584);
																return BgL_____rz00_15600;
															}
														}
													}
											}
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 787 */
										if (PROCEDURE_CORRECT_ARITYP(BgL_fz00_15581,
												(int) (BgL_nbargsz00_13581)))
											{	/* Eval/evaluate_comp.scm 787 */
												return
													BGl_subrzd2callzd2withzd2pushzd2zz__evaluate_compz00
													(BgL_sz00_13584, BgL_fz00_15581, BgL_argsz00_13582,
													BgL_bpz00_15580, BINT(BgL_siza7eza7_13583));
											}
										else
											{	/* Eval/evaluate_comp.scm 787 */
												return
													BGl_evarityzd2errorzd2zz__everrorz00(
													(((BgL_ev_appz00_bglt) COBJECT(BgL_i1157z00_13579))->
														BgL_locz00), BgL_symbzd2funzd2_13580,
													(int) (BgL_nbargsz00_13581),
													PROCEDURE_ARITY(BgL_fz00_15581));
		}}}}}}}}

	}



/* &<@anonymous:1831> */
	obj_t BGl_z62zc3z04anonymousza31831ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_13585, obj_t BgL_sz00_13591)
	{
		{	/* Eval/evaluate_comp.scm 795 */
			{	/* Eval/evaluate_comp.scm 795 */
				obj_t BgL_fz00_13586;
				BgL_ev_appz00_bglt BgL_i1157z00_13587;
				obj_t BgL_symbzd2funzd2_13588;
				long BgL_nbargsz00_13589;
				obj_t BgL_argsz00_13590;

				BgL_fz00_13586 = PROCEDURE_REF(BgL_envz00_13585, (int) (((long) 0)));
				BgL_i1157z00_13587 =
					((BgL_ev_appz00_bglt)
					PROCEDURE_REF(BgL_envz00_13585, (int) (((long) 1))));
				BgL_symbzd2funzd2_13588 =
					PROCEDURE_REF(BgL_envz00_13585, (int) (((long) 2)));
				BgL_nbargsz00_13589 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13585, (int) (((long) 3))));
				BgL_argsz00_13590 =
					((obj_t) PROCEDURE_REF(BgL_envz00_13585, (int) (((long) 4))));
				{	/* Eval/evaluate_comp.scm 795 */
					obj_t BgL_bpz00_15606;

					BgL_bpz00_15606 = VECTOR_REF(((obj_t) BgL_sz00_13591), ((long) 0));
					{	/* Eval/evaluate_comp.scm 795 */
						obj_t BgL_fz00_15607;

						BgL_fz00_15607 =
							PROCEDURE_ENTRY(BgL_fz00_13586) (BgL_fz00_13586, BgL_sz00_13591,
							BEOA);
						if (PROCEDUREP(BgL_fz00_15607))
							{	/* Eval/evaluate_comp.scm 795 */
								BFALSE;
							}
						else
							{	/* Eval/evaluate_comp.scm 795 */
								BGl_evtypezd2errorzd2zz__everrorz00(
									(((BgL_ev_appz00_bglt) COBJECT(BgL_i1157z00_13587))->
										BgL_locz00), BGl_string5807z00zz__evaluate_compz00,
									BGl_string5823z00zz__evaluate_compz00, BgL_fz00_15607);
							}
						{	/* Eval/evaluate_comp.scm 795 */
							obj_t BgL_ufz00_15608;

							{	/* Eval/evaluate_comp.scm 795 */
								obj_t BgL_tmpz00_19246;

								BgL_tmpz00_19246 = ((obj_t) BgL_fz00_15607);
								BgL_ufz00_15608 = PROCEDURE_ATTR(BgL_tmpz00_19246);
							}
							{	/* Eval/evaluate_comp.scm 795 */
								bool_t BgL_test6138z00_19249;

								if (STRUCTP(BgL_ufz00_15608))
									{	/* Eval/evaluate_comp.scm 683 */
										BgL_test6138z00_19249 =
											(STRUCT_KEY(BgL_ufz00_15608) ==
											BGl_symbol5824z00zz__evaluate_compz00);
									}
								else
									{	/* Eval/evaluate_comp.scm 683 */
										BgL_test6138z00_19249 = ((bool_t) 0);
									}
								if (BgL_test6138z00_19249)
									{	/* Eval/evaluate_comp.scm 795 */
										obj_t BgL_arityz00_15609;
										obj_t BgL_runz00_15610;
										obj_t BgL_sfz00_15611;

										BgL_arityz00_15609 =
											STRUCT_REF(BgL_ufz00_15608, (int) (((long) 0)));
										BgL_runz00_15610 =
											STRUCT_REF(BgL_ufz00_15608, (int) (((long) 1)));
										BgL_sfz00_15611 =
											STRUCT_REF(BgL_ufz00_15608, (int) (((long) 2)));
										if (
											((long) CINT(BgL_arityz00_15609) == BgL_nbargsz00_13589))
											{
												obj_t BgL_lz00_15613;
												obj_t BgL_spz00_15614;

												{	/* Eval/evaluate_comp.scm 710 */
													bool_t BgL_tmpz00_19263;

													BgL_lz00_15613 = BgL_argsz00_13590;
													BgL_spz00_15614 = BgL_bpz00_15606;
												BgL_recz00_15612:
													if (NULLP(BgL_lz00_15613))
														{	/* Eval/evaluate_comp.scm 711 */
															BgL_tmpz00_19263 = ((bool_t) 0);
														}
													else
														{	/* Eval/evaluate_comp.scm 711 */
															{	/* Eval/evaluate_comp.scm 712 */
																obj_t BgL_arg1735z00_15615;

																{	/* Eval/evaluate_comp.scm 712 */
																	obj_t BgL_fun1736z00_15616;

																	BgL_fun1736z00_15616 =
																		CAR(((obj_t) BgL_lz00_15613));
																	BgL_arg1735z00_15615 =
																		PROCEDURE_ENTRY(BgL_fun1736z00_15616)
																		(BgL_fun1736z00_15616, BgL_sz00_13591,
																		BEOA);
																}
																{	/* Eval/evaluate_comp.scm 712 */
																	long BgL_kz00_15617;

																	BgL_kz00_15617 = (long) CINT(BgL_spz00_15614);
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13591), BgL_kz00_15617,
																		BgL_arg1735z00_15615);
															}}
															{	/* Eval/evaluate_comp.scm 713 */
																obj_t BgL_arg1737z00_15618;
																long BgL_arg1738z00_15619;

																BgL_arg1737z00_15618 =
																	CDR(((obj_t) BgL_lz00_15613));
																BgL_arg1738z00_15619 =
																	((long) CINT(BgL_spz00_15614) + ((long) 1));
																{
																	obj_t BgL_spz00_19280;
																	obj_t BgL_lz00_19279;

																	BgL_lz00_19279 = BgL_arg1737z00_15618;
																	BgL_spz00_19280 = BINT(BgL_arg1738z00_15619);
																	BgL_spz00_15614 = BgL_spz00_19280;
																	BgL_lz00_15613 = BgL_lz00_19279;
																	goto BgL_recz00_15612;
																}
															}
														}
													BBOOL(BgL_tmpz00_19263);
												}
											}
										else
											{	/* Eval/evaluate_comp.scm 795 */
												bool_t BgL_test6142z00_19283;

												if (((long) CINT(BgL_arityz00_15609) >= ((long) 0)))
													{	/* Eval/evaluate_comp.scm 795 */
														BgL_test6142z00_19283 = ((bool_t) 1);
													}
												else
													{	/* Eval/evaluate_comp.scm 795 */
														BgL_test6142z00_19283 =
															(
															(long) CINT(BgL_arityz00_15609) <
															(((long) -1) - BgL_nbargsz00_13589));
													}
												if (BgL_test6142z00_19283)
													{	/* Eval/evaluate_comp.scm 795 */
														BGl_evarityzd2errorzd2zz__everrorz00(
															(((BgL_ev_appz00_bglt)
																	COBJECT(BgL_i1157z00_13587))->BgL_locz00),
															STRUCT_REF(BgL_ufz00_15608, (int) (((long) 3))),
															(int) (BgL_nbargsz00_13589),
															CINT(BgL_arityz00_15609));
													}
												else
													{	/* Eval/evaluate_comp.scm 795 */
														BGl_pushzd2nargszd2onzd2spzd2zz__evaluate_compz00
															(BgL_arityz00_15609, BgL_sz00_13591,
															BgL_argsz00_13590, BgL_bpz00_15606);
													}
											}
										{	/* Eval/evaluate_comp.scm 795 */
											obj_t BgL_z12denvz12_15620;

											BgL_z12denvz12_15620 = BGL_CURRENT_DYNAMIC_ENV();
											{	/* Eval/evaluate_comp.scm 795 */
												obj_t BgL_tmpz00_19298;

												BgL_tmpz00_19298 =
													(((BgL_ev_appz00_bglt) COBJECT(BgL_i1157z00_13587))->
													BgL_locz00);
												BGL_ENV_SET_TRACE_LOCATION(BgL_z12denvz12_15620,
													BgL_tmpz00_19298);
											}
											if (
												(((long) CINT(BgL_bpz00_15606) +
														(long) CINT(BgL_sfz00_15611)) <
													VECTOR_LENGTH(((obj_t) BgL_sz00_13591))))
												{	/* Eval/evaluate_comp.scm 795 */
													return BgL_runz00_15610;
												}
											else
												{	/* Eval/evaluate_comp.scm 795 */
													obj_t BgL_nsz00_15621;

													BgL_nsz00_15621 =
														BGl_makezd2statezd2zz__evaluate_compz00();
													{	/* Eval/evaluate_comp.scm 795 */
														long BgL_arg1846z00_15622;

														BgL_arg1846z00_15622 =
															(
															(long) CINT(BgL_bpz00_15606) +
															BgL_nbargsz00_13589);
														BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00
															(BgL_nsz00_15621, ((long) 2), BgL_sz00_13591,
															BgL_bpz00_15606, BINT(BgL_arg1846z00_15622));
													}
													VECTOR_SET(BgL_nsz00_15621, ((long) 1),
														BgL_sz00_13591);
													BGL_ENV_EVSTATE_SET(BgL_z12denvz12_15620,
														BgL_nsz00_15621);
													{	/* Eval/evaluate_comp.scm 795 */
														obj_t BgL_ez00_15623;

														BgL_ez00_15623 = BGL_EXITD_TOP_AS_OBJ();
														BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
															(BgL_ez00_15623, BgL_sz00_13591);
														{	/* Eval/evaluate_comp.scm 795 */
															obj_t BgL_____rz00_15624;

															{	/* Eval/evaluate_comp.scm 670 */
																obj_t BgL_savedzd2bpzd2_15625;

																BgL_savedzd2bpzd2_15625 =
																	VECTOR_REF(BgL_nsz00_15621, ((long) 0));
																VECTOR_SET(BgL_nsz00_15621, ((long) 0),
																	BINT(((long) 2)));
																{
																	obj_t BgL_fz00_15627;

																	BgL_fz00_15627 = BgL_runz00_15610;
																BgL_recz00_15626:
																	{	/* Eval/evaluate_comp.scm 673 */
																		obj_t BgL_rz00_15628;

																		BgL_rz00_15628 =
																			PROCEDURE_ENTRY(BgL_fz00_15627)
																			(BgL_fz00_15627, BgL_nsz00_15621, BEOA);
																		{	/* Eval/evaluate_comp.scm 674 */
																			bool_t BgL_test6145z00_19324;

																			if (PROCEDUREP(BgL_rz00_15628))
																				{	/* Eval/evaluate_comp.scm 674 */
																					obj_t BgL_arg1702z00_15629;

																					BgL_arg1702z00_15629 =
																						PROCEDURE_ATTR(BgL_rz00_15628);
																					if (STRUCTP(BgL_arg1702z00_15629))
																						{	/* Eval/evaluate_comp.scm 654 */
																							BgL_test6145z00_19324 =
																								(STRUCT_KEY
																								(BgL_arg1702z00_15629) ==
																								BGl_symbol5803z00zz__evaluate_compz00);
																						}
																					else
																						{	/* Eval/evaluate_comp.scm 654 */
																							BgL_test6145z00_19324 =
																								((bool_t) 0);
																						}
																				}
																			else
																				{	/* Eval/evaluate_comp.scm 674 */
																					BgL_test6145z00_19324 = ((bool_t) 0);
																				}
																			if (BgL_test6145z00_19324)
																				{
																					obj_t BgL_fz00_19332;

																					BgL_fz00_19332 = BgL_rz00_15628;
																					BgL_fz00_15627 = BgL_fz00_19332;
																					goto BgL_recz00_15626;
																				}
																			else
																				{	/* Eval/evaluate_comp.scm 674 */
																					VECTOR_SET(BgL_nsz00_15621,
																						((long) 0),
																						BgL_savedzd2bpzd2_15625);
																					BgL_____rz00_15624 = BgL_rz00_15628;
															}}}}}
															BGl_exitdzd2popzd2protectz12z12zz__bexitz00
																(BgL_ez00_15623);
															BGL_ENV_EVSTATE_SET(BgL_z12denvz12_15620,
																BgL_sz00_13591);
															return BgL_____rz00_15624;
														}
													}
												}
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 795 */
										if (PROCEDURE_CORRECT_ARITYP(BgL_fz00_15607,
												(int) (BgL_nbargsz00_13589)))
											{	/* Eval/evaluate_comp.scm 795 */
												{	/* Eval/evaluate_comp.scm 795 */
													obj_t BgL_auxz00_19341;
													obj_t BgL_tmpz00_19339;

													BgL_auxz00_19341 =
														(((BgL_ev_appz00_bglt)
															COBJECT(BgL_i1157z00_13587))->BgL_locz00);
													BgL_tmpz00_19339 = BGL_CURRENT_DYNAMIC_ENV();
													BGL_ENV_SET_TRACE_LOCATION(BgL_tmpz00_19339,
														BgL_auxz00_19341);
												}
												return
													BGl_subrzd2callzd2withzd2pushzd2zz__evaluate_compz00
													(BgL_sz00_13591, BgL_fz00_15607, BgL_argsz00_13590,
													BgL_bpz00_15606, BINT(BgL_nbargsz00_13589));
											}
										else
											{	/* Eval/evaluate_comp.scm 795 */
												return
													BGl_evarityzd2errorzd2zz__everrorz00(
													(((BgL_ev_appz00_bglt) COBJECT(BgL_i1157z00_13587))->
														BgL_locz00), BgL_symbzd2funzd2_13588,
													(int) (BgL_nbargsz00_13589),
													PROCEDURE_ARITY(BgL_fz00_15607));
		}}}}}}}}

	}



/* &<@anonymous:1854> */
	obj_t BGl_z62zc3z04anonymousza31854ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_13592, obj_t BgL_sz00_13598)
	{
		{	/* Eval/evaluate_comp.scm 795 */
			{	/* Eval/evaluate_comp.scm 795 */
				obj_t BgL_fz00_13593;
				BgL_ev_appz00_bglt BgL_i1157z00_13594;
				obj_t BgL_symbzd2funzd2_13595;
				long BgL_nbargsz00_13596;
				obj_t BgL_argsz00_13597;

				BgL_fz00_13593 = PROCEDURE_REF(BgL_envz00_13592, (int) (((long) 0)));
				BgL_i1157z00_13594 =
					((BgL_ev_appz00_bglt)
					PROCEDURE_REF(BgL_envz00_13592, (int) (((long) 1))));
				BgL_symbzd2funzd2_13595 =
					PROCEDURE_REF(BgL_envz00_13592, (int) (((long) 2)));
				BgL_nbargsz00_13596 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13592, (int) (((long) 3))));
				BgL_argsz00_13597 =
					((obj_t) PROCEDURE_REF(BgL_envz00_13592, (int) (((long) 4))));
				{	/* Eval/evaluate_comp.scm 795 */
					obj_t BgL_bpz00_15630;

					BgL_bpz00_15630 = VECTOR_REF(((obj_t) BgL_sz00_13598), ((long) 0));
					{	/* Eval/evaluate_comp.scm 795 */
						obj_t BgL_fz00_15631;

						BgL_fz00_15631 =
							PROCEDURE_ENTRY(BgL_fz00_13593) (BgL_fz00_13593, BgL_sz00_13598,
							BEOA);
						if (PROCEDUREP(BgL_fz00_15631))
							{	/* Eval/evaluate_comp.scm 795 */
								BFALSE;
							}
						else
							{	/* Eval/evaluate_comp.scm 795 */
								BGl_evtypezd2errorzd2zz__everrorz00(
									(((BgL_ev_appz00_bglt) COBJECT(BgL_i1157z00_13594))->
										BgL_locz00), BGl_string5807z00zz__evaluate_compz00,
									BGl_string5823z00zz__evaluate_compz00, BgL_fz00_15631);
							}
						{	/* Eval/evaluate_comp.scm 795 */
							obj_t BgL_ufz00_15632;

							{	/* Eval/evaluate_comp.scm 795 */
								obj_t BgL_tmpz00_19373;

								BgL_tmpz00_19373 = ((obj_t) BgL_fz00_15631);
								BgL_ufz00_15632 = PROCEDURE_ATTR(BgL_tmpz00_19373);
							}
							{	/* Eval/evaluate_comp.scm 795 */
								bool_t BgL_test6150z00_19376;

								if (STRUCTP(BgL_ufz00_15632))
									{	/* Eval/evaluate_comp.scm 683 */
										BgL_test6150z00_19376 =
											(STRUCT_KEY(BgL_ufz00_15632) ==
											BGl_symbol5824z00zz__evaluate_compz00);
									}
								else
									{	/* Eval/evaluate_comp.scm 683 */
										BgL_test6150z00_19376 = ((bool_t) 0);
									}
								if (BgL_test6150z00_19376)
									{	/* Eval/evaluate_comp.scm 795 */
										obj_t BgL_arityz00_15633;
										obj_t BgL_runz00_15634;
										obj_t BgL_sfz00_15635;

										BgL_arityz00_15633 =
											STRUCT_REF(BgL_ufz00_15632, (int) (((long) 0)));
										BgL_runz00_15634 =
											STRUCT_REF(BgL_ufz00_15632, (int) (((long) 1)));
										BgL_sfz00_15635 =
											STRUCT_REF(BgL_ufz00_15632, (int) (((long) 2)));
										if (
											((long) CINT(BgL_arityz00_15633) == BgL_nbargsz00_13596))
											{
												obj_t BgL_lz00_15637;
												obj_t BgL_spz00_15638;

												{	/* Eval/evaluate_comp.scm 710 */
													bool_t BgL_tmpz00_19390;

													BgL_lz00_15637 = BgL_argsz00_13597;
													BgL_spz00_15638 = BgL_bpz00_15630;
												BgL_recz00_15636:
													if (NULLP(BgL_lz00_15637))
														{	/* Eval/evaluate_comp.scm 711 */
															BgL_tmpz00_19390 = ((bool_t) 0);
														}
													else
														{	/* Eval/evaluate_comp.scm 711 */
															{	/* Eval/evaluate_comp.scm 712 */
																obj_t BgL_arg1735z00_15639;

																{	/* Eval/evaluate_comp.scm 712 */
																	obj_t BgL_fun1736z00_15640;

																	BgL_fun1736z00_15640 =
																		CAR(((obj_t) BgL_lz00_15637));
																	BgL_arg1735z00_15639 =
																		PROCEDURE_ENTRY(BgL_fun1736z00_15640)
																		(BgL_fun1736z00_15640, BgL_sz00_13598,
																		BEOA);
																}
																{	/* Eval/evaluate_comp.scm 712 */
																	long BgL_kz00_15641;

																	BgL_kz00_15641 = (long) CINT(BgL_spz00_15638);
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13598), BgL_kz00_15641,
																		BgL_arg1735z00_15639);
															}}
															{	/* Eval/evaluate_comp.scm 713 */
																obj_t BgL_arg1737z00_15642;
																long BgL_arg1738z00_15643;

																BgL_arg1737z00_15642 =
																	CDR(((obj_t) BgL_lz00_15637));
																BgL_arg1738z00_15643 =
																	((long) CINT(BgL_spz00_15638) + ((long) 1));
																{
																	obj_t BgL_spz00_19407;
																	obj_t BgL_lz00_19406;

																	BgL_lz00_19406 = BgL_arg1737z00_15642;
																	BgL_spz00_19407 = BINT(BgL_arg1738z00_15643);
																	BgL_spz00_15638 = BgL_spz00_19407;
																	BgL_lz00_15637 = BgL_lz00_19406;
																	goto BgL_recz00_15636;
																}
															}
														}
													BBOOL(BgL_tmpz00_19390);
												}
											}
										else
											{	/* Eval/evaluate_comp.scm 795 */
												bool_t BgL_test6154z00_19410;

												if (((long) CINT(BgL_arityz00_15633) >= ((long) 0)))
													{	/* Eval/evaluate_comp.scm 795 */
														BgL_test6154z00_19410 = ((bool_t) 1);
													}
												else
													{	/* Eval/evaluate_comp.scm 795 */
														BgL_test6154z00_19410 =
															(
															(long) CINT(BgL_arityz00_15633) <
															(((long) -1) - BgL_nbargsz00_13596));
													}
												if (BgL_test6154z00_19410)
													{	/* Eval/evaluate_comp.scm 795 */
														BGl_evarityzd2errorzd2zz__everrorz00(
															(((BgL_ev_appz00_bglt)
																	COBJECT(BgL_i1157z00_13594))->BgL_locz00),
															STRUCT_REF(BgL_ufz00_15632, (int) (((long) 3))),
															(int) (BgL_nbargsz00_13596),
															CINT(BgL_arityz00_15633));
													}
												else
													{	/* Eval/evaluate_comp.scm 795 */
														BGl_pushzd2nargszd2onzd2spzd2zz__evaluate_compz00
															(BgL_arityz00_15633, BgL_sz00_13598,
															BgL_argsz00_13597, BgL_bpz00_15630);
													}
											}
										{	/* Eval/evaluate_comp.scm 795 */
											obj_t BgL_z12denvz12_15644;

											BgL_z12denvz12_15644 = BGL_CURRENT_DYNAMIC_ENV();
											if (
												(((long) CINT(BgL_bpz00_15630) +
														(long) CINT(BgL_sfz00_15635)) <
													VECTOR_LENGTH(((obj_t) BgL_sz00_13598))))
												{	/* Eval/evaluate_comp.scm 795 */
													return BgL_runz00_15634;
												}
											else
												{	/* Eval/evaluate_comp.scm 795 */
													obj_t BgL_nsz00_15645;

													BgL_nsz00_15645 =
														BGl_makezd2statezd2zz__evaluate_compz00();
													{	/* Eval/evaluate_comp.scm 795 */
														long BgL_arg1868z00_15646;

														BgL_arg1868z00_15646 =
															(
															(long) CINT(BgL_bpz00_15630) +
															BgL_nbargsz00_13596);
														BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00
															(BgL_nsz00_15645, ((long) 2), BgL_sz00_13598,
															BgL_bpz00_15630, BINT(BgL_arg1868z00_15646));
													}
													VECTOR_SET(BgL_nsz00_15645, ((long) 1),
														BgL_sz00_13598);
													BGL_ENV_EVSTATE_SET(BgL_z12denvz12_15644,
														BgL_nsz00_15645);
													{	/* Eval/evaluate_comp.scm 795 */
														obj_t BgL_ez00_15647;

														BgL_ez00_15647 = BGL_EXITD_TOP_AS_OBJ();
														BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
															(BgL_ez00_15647, BgL_sz00_13598);
														{	/* Eval/evaluate_comp.scm 795 */
															obj_t BgL_____rz00_15648;

															{	/* Eval/evaluate_comp.scm 670 */
																obj_t BgL_savedzd2bpzd2_15649;

																BgL_savedzd2bpzd2_15649 =
																	VECTOR_REF(BgL_nsz00_15645, ((long) 0));
																VECTOR_SET(BgL_nsz00_15645, ((long) 0),
																	BINT(((long) 2)));
																{
																	obj_t BgL_fz00_15651;

																	BgL_fz00_15651 = BgL_runz00_15634;
																BgL_recz00_15650:
																	{	/* Eval/evaluate_comp.scm 673 */
																		obj_t BgL_rz00_15652;

																		BgL_rz00_15652 =
																			PROCEDURE_ENTRY(BgL_fz00_15651)
																			(BgL_fz00_15651, BgL_nsz00_15645, BEOA);
																		{	/* Eval/evaluate_comp.scm 674 */
																			bool_t BgL_test6157z00_19448;

																			if (PROCEDUREP(BgL_rz00_15652))
																				{	/* Eval/evaluate_comp.scm 674 */
																					obj_t BgL_arg1702z00_15653;

																					BgL_arg1702z00_15653 =
																						PROCEDURE_ATTR(BgL_rz00_15652);
																					if (STRUCTP(BgL_arg1702z00_15653))
																						{	/* Eval/evaluate_comp.scm 654 */
																							BgL_test6157z00_19448 =
																								(STRUCT_KEY
																								(BgL_arg1702z00_15653) ==
																								BGl_symbol5803z00zz__evaluate_compz00);
																						}
																					else
																						{	/* Eval/evaluate_comp.scm 654 */
																							BgL_test6157z00_19448 =
																								((bool_t) 0);
																						}
																				}
																			else
																				{	/* Eval/evaluate_comp.scm 674 */
																					BgL_test6157z00_19448 = ((bool_t) 0);
																				}
																			if (BgL_test6157z00_19448)
																				{
																					obj_t BgL_fz00_19456;

																					BgL_fz00_19456 = BgL_rz00_15652;
																					BgL_fz00_15651 = BgL_fz00_19456;
																					goto BgL_recz00_15650;
																				}
																			else
																				{	/* Eval/evaluate_comp.scm 674 */
																					VECTOR_SET(BgL_nsz00_15645,
																						((long) 0),
																						BgL_savedzd2bpzd2_15649);
																					BgL_____rz00_15648 = BgL_rz00_15652;
															}}}}}
															BGl_exitdzd2popzd2protectz12z12zz__bexitz00
																(BgL_ez00_15647);
															BGL_ENV_EVSTATE_SET(BgL_z12denvz12_15644,
																BgL_sz00_13598);
															return BgL_____rz00_15648;
														}
													}
												}
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 795 */
										if (PROCEDURE_CORRECT_ARITYP(BgL_fz00_15631,
												(int) (BgL_nbargsz00_13596)))
											{	/* Eval/evaluate_comp.scm 795 */
												return
													BGl_subrzd2callzd2withzd2pushzd2zz__evaluate_compz00
													(BgL_sz00_13598, BgL_fz00_15631, BgL_argsz00_13597,
													BgL_bpz00_15630, BINT(BgL_nbargsz00_13596));
											}
										else
											{	/* Eval/evaluate_comp.scm 795 */
												return
													BGl_evarityzd2errorzd2zz__everrorz00(
													(((BgL_ev_appz00_bglt) COBJECT(BgL_i1157z00_13594))->
														BgL_locz00), BgL_symbzd2funzd2_13595,
													(int) (BgL_nbargsz00_13596),
													PROCEDURE_ARITY(BgL_fz00_15631));
		}}}}}}}}

	}



/* &<@anonymous:1877> */
	obj_t BGl_z62zc3z04anonymousza31877ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_13599, obj_t BgL_sz00_13606)
	{
		{	/* Eval/evaluate_comp.scm 781 */
			{	/* Eval/evaluate_comp.scm 781 */
				obj_t BgL_fz00_13600;
				BgL_ev_appz00_bglt BgL_i1157z00_13601;
				obj_t BgL_symbzd2funzd2_13602;
				long BgL_nbargsz00_13603;
				obj_t BgL_argsz00_13604;
				long BgL_siza7eza7_13605;

				BgL_fz00_13600 = PROCEDURE_REF(BgL_envz00_13599, (int) (((long) 0)));
				BgL_i1157z00_13601 =
					((BgL_ev_appz00_bglt)
					PROCEDURE_REF(BgL_envz00_13599, (int) (((long) 1))));
				BgL_symbzd2funzd2_13602 =
					PROCEDURE_REF(BgL_envz00_13599, (int) (((long) 2)));
				BgL_nbargsz00_13603 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13599, (int) (((long) 3))));
				BgL_argsz00_13604 =
					((obj_t) PROCEDURE_REF(BgL_envz00_13599, (int) (((long) 4))));
				BgL_siza7eza7_13605 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13599, (int) (((long) 5))));
				{	/* Eval/evaluate_comp.scm 781 */
					obj_t BgL_bpz00_15654;

					BgL_bpz00_15654 = VECTOR_REF(((obj_t) BgL_sz00_13606), ((long) 0));
					{	/* Eval/evaluate_comp.scm 781 */
						obj_t BgL_fz00_15655;

						BgL_fz00_15655 =
							PROCEDURE_ENTRY(BgL_fz00_13600) (BgL_fz00_13600, BgL_sz00_13606,
							BEOA);
						if (PROCEDUREP(BgL_fz00_15655))
							{	/* Eval/evaluate_comp.scm 781 */
								BFALSE;
							}
						else
							{	/* Eval/evaluate_comp.scm 781 */
								BGl_evtypezd2errorzd2zz__everrorz00(
									(((BgL_ev_appz00_bglt) COBJECT(BgL_i1157z00_13601))->
										BgL_locz00), BGl_string5807z00zz__evaluate_compz00,
									BGl_string5823z00zz__evaluate_compz00, BgL_fz00_15655);
							}
						{	/* Eval/evaluate_comp.scm 781 */
							obj_t BgL_ufz00_15656;

							{	/* Eval/evaluate_comp.scm 781 */
								obj_t BgL_tmpz00_19495;

								BgL_tmpz00_19495 = ((obj_t) BgL_fz00_15655);
								BgL_ufz00_15656 = PROCEDURE_ATTR(BgL_tmpz00_19495);
							}
							{	/* Eval/evaluate_comp.scm 781 */
								bool_t BgL_test6162z00_19498;

								if (STRUCTP(BgL_ufz00_15656))
									{	/* Eval/evaluate_comp.scm 683 */
										BgL_test6162z00_19498 =
											(STRUCT_KEY(BgL_ufz00_15656) ==
											BGl_symbol5824z00zz__evaluate_compz00);
									}
								else
									{	/* Eval/evaluate_comp.scm 683 */
										BgL_test6162z00_19498 = ((bool_t) 0);
									}
								if (BgL_test6162z00_19498)
									{	/* Eval/evaluate_comp.scm 781 */
										obj_t BgL_arityz00_15657;
										obj_t BgL_runz00_15658;
										obj_t BgL_sfz00_15659;

										BgL_arityz00_15657 =
											STRUCT_REF(BgL_ufz00_15656, (int) (((long) 0)));
										BgL_runz00_15658 =
											STRUCT_REF(BgL_ufz00_15656, (int) (((long) 1)));
										BgL_sfz00_15659 =
											STRUCT_REF(BgL_ufz00_15656, (int) (((long) 2)));
										{	/* Eval/evaluate_comp.scm 781 */
											long BgL_spz00_15660;

											BgL_spz00_15660 =
												((long) CINT(BgL_bpz00_15654) + BgL_siza7eza7_13605);
											if (
												((long) CINT(BgL_arityz00_15657) ==
													BgL_nbargsz00_13603))
												{
													obj_t BgL_lz00_15662;
													long BgL_spz00_15663;

													{	/* Eval/evaluate_comp.scm 710 */
														bool_t BgL_tmpz00_19514;

														BgL_lz00_15662 = BgL_argsz00_13604;
														BgL_spz00_15663 = BgL_spz00_15660;
													BgL_recz00_15661:
														if (NULLP(BgL_lz00_15662))
															{	/* Eval/evaluate_comp.scm 711 */
																BgL_tmpz00_19514 = ((bool_t) 0);
															}
														else
															{	/* Eval/evaluate_comp.scm 711 */
																{	/* Eval/evaluate_comp.scm 712 */
																	obj_t BgL_arg1735z00_15664;

																	{	/* Eval/evaluate_comp.scm 712 */
																		obj_t BgL_fun1736z00_15665;

																		BgL_fun1736z00_15665 =
																			CAR(((obj_t) BgL_lz00_15662));
																		BgL_arg1735z00_15664 =
																			PROCEDURE_ENTRY(BgL_fun1736z00_15665)
																			(BgL_fun1736z00_15665, BgL_sz00_13606,
																			BEOA);
																	}
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13606), BgL_spz00_15663,
																		BgL_arg1735z00_15664);
																}
																{	/* Eval/evaluate_comp.scm 713 */
																	obj_t BgL_arg1737z00_15666;
																	long BgL_arg1738z00_15667;

																	BgL_arg1737z00_15666 =
																		CDR(((obj_t) BgL_lz00_15662));
																	BgL_arg1738z00_15667 =
																		(BgL_spz00_15663 + ((long) 1));
																	{
																		long BgL_spz00_19529;
																		obj_t BgL_lz00_19528;

																		BgL_lz00_19528 = BgL_arg1737z00_15666;
																		BgL_spz00_19529 = BgL_arg1738z00_15667;
																		BgL_spz00_15663 = BgL_spz00_19529;
																		BgL_lz00_15662 = BgL_lz00_19528;
																		goto BgL_recz00_15661;
																	}
																}
															}
														BBOOL(BgL_tmpz00_19514);
													}
												}
											else
												{	/* Eval/evaluate_comp.scm 781 */
													bool_t BgL_test6166z00_19531;

													if (((long) CINT(BgL_arityz00_15657) >= ((long) 0)))
														{	/* Eval/evaluate_comp.scm 781 */
															BgL_test6166z00_19531 = ((bool_t) 1);
														}
													else
														{	/* Eval/evaluate_comp.scm 781 */
															BgL_test6166z00_19531 =
																(
																(long) CINT(BgL_arityz00_15657) <
																(((long) -1) - BgL_nbargsz00_13603));
														}
													if (BgL_test6166z00_19531)
														{	/* Eval/evaluate_comp.scm 781 */
															BGl_evarityzd2errorzd2zz__everrorz00(
																(((BgL_ev_appz00_bglt)
																		COBJECT(BgL_i1157z00_13601))->BgL_locz00),
																STRUCT_REF(BgL_ufz00_15656, (int) (((long) 3))),
																(int) (BgL_nbargsz00_13603),
																CINT(BgL_arityz00_15657));
														}
													else
														{	/* Eval/evaluate_comp.scm 781 */
															BGl_pushzd2nargszd2onzd2spzd2zz__evaluate_compz00
																(BgL_arityz00_15657, BgL_sz00_13606,
																BgL_argsz00_13604, BINT(BgL_spz00_15660));
														}
												}
											{	/* Eval/evaluate_comp.scm 781 */
												obj_t BgL_z12denvz12_15668;

												BgL_z12denvz12_15668 = BGL_CURRENT_DYNAMIC_ENV();
												{	/* Eval/evaluate_comp.scm 781 */
													obj_t BgL_tmpz00_19547;

													BgL_tmpz00_19547 =
														(((BgL_ev_appz00_bglt)
															COBJECT(BgL_i1157z00_13601))->BgL_locz00);
													BGL_ENV_SET_TRACE_LOCATION(BgL_z12denvz12_15668,
														BgL_tmpz00_19547);
												}
												if (
													((BgL_spz00_15660 +
															(long) CINT(BgL_sfz00_15659)) <
														VECTOR_LENGTH(((obj_t) BgL_sz00_13606))))
													{	/* Eval/evaluate_comp.scm 781 */
														return
															BGl_catchzd2trampolinezd2zz__evaluate_compz00
															(BgL_runz00_15658, BgL_sz00_13606,
															BINT(BgL_spz00_15660));
													}
												else
													{	/* Eval/evaluate_comp.scm 781 */
														obj_t BgL_nsz00_15669;

														BgL_nsz00_15669 =
															BGl_makezd2statezd2zz__evaluate_compz00();
														{	/* Eval/evaluate_comp.scm 781 */
															long BgL_arg1891z00_15670;

															BgL_arg1891z00_15670 =
																(BgL_spz00_15660 + BgL_nbargsz00_13603);
															BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00
																(BgL_nsz00_15669, ((long) 2), BgL_sz00_13606,
																BINT(BgL_spz00_15660),
																BINT(BgL_arg1891z00_15670));
														}
														VECTOR_SET(BgL_nsz00_15669, ((long) 1),
															BgL_sz00_13606);
														BGL_ENV_EVSTATE_SET(BgL_z12denvz12_15668,
															BgL_nsz00_15669);
														{	/* Eval/evaluate_comp.scm 781 */
															obj_t BgL_ez00_15671;

															BgL_ez00_15671 = BGL_EXITD_TOP_AS_OBJ();
															BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
																(BgL_ez00_15671, BgL_sz00_13606);
															{	/* Eval/evaluate_comp.scm 781 */
																obj_t BgL_____rz00_15672;

																{	/* Eval/evaluate_comp.scm 670 */
																	obj_t BgL_savedzd2bpzd2_15673;

																	BgL_savedzd2bpzd2_15673 =
																		VECTOR_REF(BgL_nsz00_15669, ((long) 0));
																	VECTOR_SET(BgL_nsz00_15669, ((long) 0),
																		BINT(((long) 2)));
																	{
																		obj_t BgL_fz00_15675;

																		BgL_fz00_15675 = BgL_runz00_15658;
																	BgL_recz00_15674:
																		{	/* Eval/evaluate_comp.scm 673 */
																			obj_t BgL_rz00_15676;

																			BgL_rz00_15676 =
																				PROCEDURE_ENTRY(BgL_fz00_15675)
																				(BgL_fz00_15675, BgL_nsz00_15669, BEOA);
																			{	/* Eval/evaluate_comp.scm 674 */
																				bool_t BgL_test6169z00_19574;

																				if (PROCEDUREP(BgL_rz00_15676))
																					{	/* Eval/evaluate_comp.scm 674 */
																						obj_t BgL_arg1702z00_15677;

																						BgL_arg1702z00_15677 =
																							PROCEDURE_ATTR(BgL_rz00_15676);
																						if (STRUCTP(BgL_arg1702z00_15677))
																							{	/* Eval/evaluate_comp.scm 654 */
																								BgL_test6169z00_19574 =
																									(STRUCT_KEY
																									(BgL_arg1702z00_15677) ==
																									BGl_symbol5803z00zz__evaluate_compz00);
																							}
																						else
																							{	/* Eval/evaluate_comp.scm 654 */
																								BgL_test6169z00_19574 =
																									((bool_t) 0);
																							}
																					}
																				else
																					{	/* Eval/evaluate_comp.scm 674 */
																						BgL_test6169z00_19574 =
																							((bool_t) 0);
																					}
																				if (BgL_test6169z00_19574)
																					{
																						obj_t BgL_fz00_19582;

																						BgL_fz00_19582 = BgL_rz00_15676;
																						BgL_fz00_15675 = BgL_fz00_19582;
																						goto BgL_recz00_15674;
																					}
																				else
																					{	/* Eval/evaluate_comp.scm 674 */
																						VECTOR_SET(BgL_nsz00_15669,
																							((long) 0),
																							BgL_savedzd2bpzd2_15673);
																						BgL_____rz00_15672 = BgL_rz00_15676;
																}}}}}
																BGl_exitdzd2popzd2protectz12z12zz__bexitz00
																	(BgL_ez00_15671);
																BGL_ENV_EVSTATE_SET(BgL_z12denvz12_15668,
																	BgL_sz00_13606);
																return BgL_____rz00_15672;
															}
														}
													}
											}
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 781 */
										if (PROCEDURE_CORRECT_ARITYP(BgL_fz00_15655,
												(int) (BgL_nbargsz00_13603)))
											{	/* Eval/evaluate_comp.scm 781 */
												{	/* Eval/evaluate_comp.scm 781 */
													obj_t BgL_auxz00_19591;
													obj_t BgL_tmpz00_19589;

													BgL_auxz00_19591 =
														(((BgL_ev_appz00_bglt)
															COBJECT(BgL_i1157z00_13601))->BgL_locz00);
													BgL_tmpz00_19589 = BGL_CURRENT_DYNAMIC_ENV();
													BGL_ENV_SET_TRACE_LOCATION(BgL_tmpz00_19589,
														BgL_auxz00_19591);
												}
												return
													BGl_subrzd2callzd2withzd2pushzd2zz__evaluate_compz00
													(BgL_sz00_13606, BgL_fz00_15655, BgL_argsz00_13604,
													BgL_bpz00_15654, BINT(BgL_siza7eza7_13605));
											}
										else
											{	/* Eval/evaluate_comp.scm 781 */
												return
													BGl_evarityzd2errorzd2zz__everrorz00(
													(((BgL_ev_appz00_bglt) COBJECT(BgL_i1157z00_13601))->
														BgL_locz00), BgL_symbzd2funzd2_13602,
													(int) (BgL_nbargsz00_13603),
													PROCEDURE_ARITY(BgL_fz00_15655));
		}}}}}}}}

	}



/* &<@anonymous:1898> */
	obj_t BGl_z62zc3z04anonymousza31898ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_13607, obj_t BgL_sz00_13614)
	{
		{	/* Eval/evaluate_comp.scm 781 */
			{	/* Eval/evaluate_comp.scm 781 */
				obj_t BgL_fz00_13608;
				BgL_ev_appz00_bglt BgL_i1157z00_13609;
				obj_t BgL_symbzd2funzd2_13610;
				long BgL_nbargsz00_13611;
				obj_t BgL_argsz00_13612;
				long BgL_siza7eza7_13613;

				BgL_fz00_13608 = PROCEDURE_REF(BgL_envz00_13607, (int) (((long) 0)));
				BgL_i1157z00_13609 =
					((BgL_ev_appz00_bglt)
					PROCEDURE_REF(BgL_envz00_13607, (int) (((long) 1))));
				BgL_symbzd2funzd2_13610 =
					PROCEDURE_REF(BgL_envz00_13607, (int) (((long) 2)));
				BgL_nbargsz00_13611 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13607, (int) (((long) 3))));
				BgL_argsz00_13612 =
					((obj_t) PROCEDURE_REF(BgL_envz00_13607, (int) (((long) 4))));
				BgL_siza7eza7_13613 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13607, (int) (((long) 5))));
				{	/* Eval/evaluate_comp.scm 781 */
					obj_t BgL_bpz00_15678;

					BgL_bpz00_15678 = VECTOR_REF(((obj_t) BgL_sz00_13614), ((long) 0));
					{	/* Eval/evaluate_comp.scm 781 */
						obj_t BgL_fz00_15679;

						BgL_fz00_15679 =
							PROCEDURE_ENTRY(BgL_fz00_13608) (BgL_fz00_13608, BgL_sz00_13614,
							BEOA);
						if (PROCEDUREP(BgL_fz00_15679))
							{	/* Eval/evaluate_comp.scm 781 */
								BFALSE;
							}
						else
							{	/* Eval/evaluate_comp.scm 781 */
								BGl_evtypezd2errorzd2zz__everrorz00(
									(((BgL_ev_appz00_bglt) COBJECT(BgL_i1157z00_13609))->
										BgL_locz00), BGl_string5807z00zz__evaluate_compz00,
									BGl_string5823z00zz__evaluate_compz00, BgL_fz00_15679);
							}
						{	/* Eval/evaluate_comp.scm 781 */
							obj_t BgL_ufz00_15680;

							{	/* Eval/evaluate_comp.scm 781 */
								obj_t BgL_tmpz00_19626;

								BgL_tmpz00_19626 = ((obj_t) BgL_fz00_15679);
								BgL_ufz00_15680 = PROCEDURE_ATTR(BgL_tmpz00_19626);
							}
							{	/* Eval/evaluate_comp.scm 781 */
								bool_t BgL_test6174z00_19629;

								if (STRUCTP(BgL_ufz00_15680))
									{	/* Eval/evaluate_comp.scm 683 */
										BgL_test6174z00_19629 =
											(STRUCT_KEY(BgL_ufz00_15680) ==
											BGl_symbol5824z00zz__evaluate_compz00);
									}
								else
									{	/* Eval/evaluate_comp.scm 683 */
										BgL_test6174z00_19629 = ((bool_t) 0);
									}
								if (BgL_test6174z00_19629)
									{	/* Eval/evaluate_comp.scm 781 */
										obj_t BgL_arityz00_15681;
										obj_t BgL_runz00_15682;
										obj_t BgL_sfz00_15683;

										BgL_arityz00_15681 =
											STRUCT_REF(BgL_ufz00_15680, (int) (((long) 0)));
										BgL_runz00_15682 =
											STRUCT_REF(BgL_ufz00_15680, (int) (((long) 1)));
										BgL_sfz00_15683 =
											STRUCT_REF(BgL_ufz00_15680, (int) (((long) 2)));
										{	/* Eval/evaluate_comp.scm 781 */
											long BgL_spz00_15684;

											BgL_spz00_15684 =
												((long) CINT(BgL_bpz00_15678) + BgL_siza7eza7_13613);
											if (
												((long) CINT(BgL_arityz00_15681) ==
													BgL_nbargsz00_13611))
												{
													obj_t BgL_lz00_15686;
													long BgL_spz00_15687;

													{	/* Eval/evaluate_comp.scm 710 */
														bool_t BgL_tmpz00_19645;

														BgL_lz00_15686 = BgL_argsz00_13612;
														BgL_spz00_15687 = BgL_spz00_15684;
													BgL_recz00_15685:
														if (NULLP(BgL_lz00_15686))
															{	/* Eval/evaluate_comp.scm 711 */
																BgL_tmpz00_19645 = ((bool_t) 0);
															}
														else
															{	/* Eval/evaluate_comp.scm 711 */
																{	/* Eval/evaluate_comp.scm 712 */
																	obj_t BgL_arg1735z00_15688;

																	{	/* Eval/evaluate_comp.scm 712 */
																		obj_t BgL_fun1736z00_15689;

																		BgL_fun1736z00_15689 =
																			CAR(((obj_t) BgL_lz00_15686));
																		BgL_arg1735z00_15688 =
																			PROCEDURE_ENTRY(BgL_fun1736z00_15689)
																			(BgL_fun1736z00_15689, BgL_sz00_13614,
																			BEOA);
																	}
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13614), BgL_spz00_15687,
																		BgL_arg1735z00_15688);
																}
																{	/* Eval/evaluate_comp.scm 713 */
																	obj_t BgL_arg1737z00_15690;
																	long BgL_arg1738z00_15691;

																	BgL_arg1737z00_15690 =
																		CDR(((obj_t) BgL_lz00_15686));
																	BgL_arg1738z00_15691 =
																		(BgL_spz00_15687 + ((long) 1));
																	{
																		long BgL_spz00_19660;
																		obj_t BgL_lz00_19659;

																		BgL_lz00_19659 = BgL_arg1737z00_15690;
																		BgL_spz00_19660 = BgL_arg1738z00_15691;
																		BgL_spz00_15687 = BgL_spz00_19660;
																		BgL_lz00_15686 = BgL_lz00_19659;
																		goto BgL_recz00_15685;
																	}
																}
															}
														BBOOL(BgL_tmpz00_19645);
													}
												}
											else
												{	/* Eval/evaluate_comp.scm 781 */
													bool_t BgL_test6178z00_19662;

													if (((long) CINT(BgL_arityz00_15681) >= ((long) 0)))
														{	/* Eval/evaluate_comp.scm 781 */
															BgL_test6178z00_19662 = ((bool_t) 1);
														}
													else
														{	/* Eval/evaluate_comp.scm 781 */
															BgL_test6178z00_19662 =
																(
																(long) CINT(BgL_arityz00_15681) <
																(((long) -1) - BgL_nbargsz00_13611));
														}
													if (BgL_test6178z00_19662)
														{	/* Eval/evaluate_comp.scm 781 */
															BGl_evarityzd2errorzd2zz__everrorz00(
																(((BgL_ev_appz00_bglt)
																		COBJECT(BgL_i1157z00_13609))->BgL_locz00),
																STRUCT_REF(BgL_ufz00_15680, (int) (((long) 3))),
																(int) (BgL_nbargsz00_13611),
																CINT(BgL_arityz00_15681));
														}
													else
														{	/* Eval/evaluate_comp.scm 781 */
															BGl_pushzd2nargszd2onzd2spzd2zz__evaluate_compz00
																(BgL_arityz00_15681, BgL_sz00_13614,
																BgL_argsz00_13612, BINT(BgL_spz00_15684));
														}
												}
											{	/* Eval/evaluate_comp.scm 781 */
												obj_t BgL_z12denvz12_15692;

												BgL_z12denvz12_15692 = BGL_CURRENT_DYNAMIC_ENV();
												if (
													((BgL_spz00_15684 +
															(long) CINT(BgL_sfz00_15683)) <
														VECTOR_LENGTH(((obj_t) BgL_sz00_13614))))
													{	/* Eval/evaluate_comp.scm 781 */
														return
															BGl_catchzd2trampolinezd2zz__evaluate_compz00
															(BgL_runz00_15682, BgL_sz00_13614,
															BINT(BgL_spz00_15684));
													}
												else
													{	/* Eval/evaluate_comp.scm 781 */
														obj_t BgL_nsz00_15693;

														BgL_nsz00_15693 =
															BGl_makezd2statezd2zz__evaluate_compz00();
														{	/* Eval/evaluate_comp.scm 781 */
															long BgL_arg1910z00_15694;

															BgL_arg1910z00_15694 =
																(BgL_spz00_15684 + BgL_nbargsz00_13611);
															BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00
																(BgL_nsz00_15693, ((long) 2), BgL_sz00_13614,
																BINT(BgL_spz00_15684),
																BINT(BgL_arg1910z00_15694));
														}
														VECTOR_SET(BgL_nsz00_15693, ((long) 1),
															BgL_sz00_13614);
														BGL_ENV_EVSTATE_SET(BgL_z12denvz12_15692,
															BgL_nsz00_15693);
														{	/* Eval/evaluate_comp.scm 781 */
															obj_t BgL_ez00_15695;

															BgL_ez00_15695 = BGL_EXITD_TOP_AS_OBJ();
															BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
																(BgL_ez00_15695, BgL_sz00_13614);
															{	/* Eval/evaluate_comp.scm 781 */
																obj_t BgL_____rz00_15696;

																{	/* Eval/evaluate_comp.scm 670 */
																	obj_t BgL_savedzd2bpzd2_15697;

																	BgL_savedzd2bpzd2_15697 =
																		VECTOR_REF(BgL_nsz00_15693, ((long) 0));
																	VECTOR_SET(BgL_nsz00_15693, ((long) 0),
																		BINT(((long) 2)));
																	{
																		obj_t BgL_fz00_15699;

																		BgL_fz00_15699 = BgL_runz00_15682;
																	BgL_recz00_15698:
																		{	/* Eval/evaluate_comp.scm 673 */
																			obj_t BgL_rz00_15700;

																			BgL_rz00_15700 =
																				PROCEDURE_ENTRY(BgL_fz00_15699)
																				(BgL_fz00_15699, BgL_nsz00_15693, BEOA);
																			{	/* Eval/evaluate_comp.scm 674 */
																				bool_t BgL_test6181z00_19702;

																				if (PROCEDUREP(BgL_rz00_15700))
																					{	/* Eval/evaluate_comp.scm 674 */
																						obj_t BgL_arg1702z00_15701;

																						BgL_arg1702z00_15701 =
																							PROCEDURE_ATTR(BgL_rz00_15700);
																						if (STRUCTP(BgL_arg1702z00_15701))
																							{	/* Eval/evaluate_comp.scm 654 */
																								BgL_test6181z00_19702 =
																									(STRUCT_KEY
																									(BgL_arg1702z00_15701) ==
																									BGl_symbol5803z00zz__evaluate_compz00);
																							}
																						else
																							{	/* Eval/evaluate_comp.scm 654 */
																								BgL_test6181z00_19702 =
																									((bool_t) 0);
																							}
																					}
																				else
																					{	/* Eval/evaluate_comp.scm 674 */
																						BgL_test6181z00_19702 =
																							((bool_t) 0);
																					}
																				if (BgL_test6181z00_19702)
																					{
																						obj_t BgL_fz00_19710;

																						BgL_fz00_19710 = BgL_rz00_15700;
																						BgL_fz00_15699 = BgL_fz00_19710;
																						goto BgL_recz00_15698;
																					}
																				else
																					{	/* Eval/evaluate_comp.scm 674 */
																						VECTOR_SET(BgL_nsz00_15693,
																							((long) 0),
																							BgL_savedzd2bpzd2_15697);
																						BgL_____rz00_15696 = BgL_rz00_15700;
																}}}}}
																BGl_exitdzd2popzd2protectz12z12zz__bexitz00
																	(BgL_ez00_15695);
																BGL_ENV_EVSTATE_SET(BgL_z12denvz12_15692,
																	BgL_sz00_13614);
																return BgL_____rz00_15696;
															}
														}
													}
											}
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 781 */
										if (PROCEDURE_CORRECT_ARITYP(BgL_fz00_15679,
												(int) (BgL_nbargsz00_13611)))
											{	/* Eval/evaluate_comp.scm 781 */
												return
													BGl_subrzd2callzd2withzd2pushzd2zz__evaluate_compz00
													(BgL_sz00_13614, BgL_fz00_15679, BgL_argsz00_13612,
													BgL_bpz00_15678, BINT(BgL_siza7eza7_13613));
											}
										else
											{	/* Eval/evaluate_comp.scm 781 */
												return
													BGl_evarityzd2errorzd2zz__everrorz00(
													(((BgL_ev_appz00_bglt) COBJECT(BgL_i1157z00_13609))->
														BgL_locz00), BgL_symbzd2funzd2_13610,
													(int) (BgL_nbargsz00_13611),
													PROCEDURE_ARITY(BgL_fz00_15679));
		}}}}}}}}

	}



/* comp-call0 */
	obj_t BGl_compzd2call0zd2zz__evaluate_compz00(obj_t BgL_locz00_138,
		BgL_ev_exprz00_bglt BgL_vfunz00_139, obj_t BgL_symbzd2funzd2_140,
		obj_t BgL_funz00_141, obj_t BgL_tailzf3zf3_142, obj_t BgL_stkz00_143,
		long BgL_siza7eza7_144)
	{
		{	/* Eval/evaluate_comp.scm 896 */
			{	/* Eval/evaluate_comp.scm 896 */
				obj_t BgL_cfunz00_1969;

				BgL_cfunz00_1969 =
					BGl_iszd2constantzd2funzf3zf3zz__evaluate_compz00(BgL_vfunz00_139,
					((long) 0), BgL_locz00_138, BgL_symbzd2funzd2_140);
				if (CBOOL(BgL_cfunz00_1969))
					{	/* Eval/evaluate_comp.scm 896 */
						bool_t BgL_test6186z00_19726;

						{	/* Eval/evaluate_comp.scm 896 */
							int BgL_arg1925z00_1983;

							BgL_arg1925z00_1983 = bgl_debug();
							BgL_test6186z00_19726 =
								BGl_2ze3ze3zz__r4_numbers_6_5z00(BINT(BgL_arg1925z00_1983),
								BINT(((long) 0)));
						}
						if (BgL_test6186z00_19726)
							{	/* Eval/evaluate_comp.scm 896 */
								obj_t BgL_zc3z04anonymousza31922ze3z87_13615;

								BgL_zc3z04anonymousza31922ze3z87_13615 =
									MAKE_FX_PROCEDURE
									(BGl_z62zc3z04anonymousza31922ze3ze5zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 3)));
								PROCEDURE_SET(BgL_zc3z04anonymousza31922ze3z87_13615,
									(int) (((long) 0)), BINT(BgL_siza7eza7_144));
								PROCEDURE_SET(BgL_zc3z04anonymousza31922ze3z87_13615,
									(int) (((long) 1)), BgL_locz00_138);
								PROCEDURE_SET(BgL_zc3z04anonymousza31922ze3z87_13615,
									(int) (((long) 2)), BgL_cfunz00_1969);
								return BgL_zc3z04anonymousza31922ze3z87_13615;
							}
						else
							{	/* Eval/evaluate_comp.scm 896 */
								obj_t BgL_zc3z04anonymousza31924ze3z87_13616;

								BgL_zc3z04anonymousza31924ze3z87_13616 =
									MAKE_FX_PROCEDURE
									(BGl_z62zc3z04anonymousza31924ze3ze5zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 2)));
								PROCEDURE_SET(BgL_zc3z04anonymousza31924ze3z87_13616,
									(int) (((long) 0)), BINT(BgL_siza7eza7_144));
								PROCEDURE_SET(BgL_zc3z04anonymousza31924ze3z87_13616,
									(int) (((long) 1)), BgL_cfunz00_1969);
								return BgL_zc3z04anonymousza31924ze3z87_13616;
							}
					}
				else
					{	/* Eval/evaluate_comp.scm 896 */
						if (CBOOL(BgL_tailzf3zf3_142))
							{	/* Eval/evaluate_comp.scm 896 */
								bool_t BgL_test6188z00_19751;

								{	/* Eval/evaluate_comp.scm 896 */
									int BgL_arg1955z00_2047;

									BgL_arg1955z00_2047 = bgl_debug();
									BgL_test6188z00_19751 =
										BGl_2ze3ze3zz__r4_numbers_6_5z00(BINT(BgL_arg1955z00_2047),
										BINT(((long) 0)));
								}
								if (BgL_test6188z00_19751)
									{	/* Eval/evaluate_comp.scm 896 */
										obj_t BgL_zc3z04anonymousza31928ze3z87_13617;

										BgL_zc3z04anonymousza31928ze3z87_13617 =
											MAKE_FX_PROCEDURE
											(BGl_z62zc3z04anonymousza31928ze3ze5zz__evaluate_compz00,
											(int) (((long) 1)), (int) (((long) 4)));
										PROCEDURE_SET(BgL_zc3z04anonymousza31928ze3z87_13617,
											(int) (((long) 0)), BgL_funz00_141);
										PROCEDURE_SET(BgL_zc3z04anonymousza31928ze3z87_13617,
											(int) (((long) 1)), BgL_locz00_138);
										PROCEDURE_SET(BgL_zc3z04anonymousza31928ze3z87_13617,
											(int) (((long) 2)), BgL_symbzd2funzd2_140);
										PROCEDURE_SET(BgL_zc3z04anonymousza31928ze3z87_13617,
											(int) (((long) 3)), BINT(BgL_siza7eza7_144));
										return BgL_zc3z04anonymousza31928ze3z87_13617;
									}
								else
									{	/* Eval/evaluate_comp.scm 896 */
										obj_t BgL_zc3z04anonymousza31942ze3z87_13618;

										BgL_zc3z04anonymousza31942ze3z87_13618 =
											MAKE_FX_PROCEDURE
											(BGl_z62zc3z04anonymousza31942ze3ze5zz__evaluate_compz00,
											(int) (((long) 1)), (int) (((long) 4)));
										PROCEDURE_SET(BgL_zc3z04anonymousza31942ze3z87_13618,
											(int) (((long) 0)), BgL_funz00_141);
										PROCEDURE_SET(BgL_zc3z04anonymousza31942ze3z87_13618,
											(int) (((long) 1)), BgL_locz00_138);
										PROCEDURE_SET(BgL_zc3z04anonymousza31942ze3z87_13618,
											(int) (((long) 2)), BgL_symbzd2funzd2_140);
										PROCEDURE_SET(BgL_zc3z04anonymousza31942ze3z87_13618,
											(int) (((long) 3)), BINT(BgL_siza7eza7_144));
										return BgL_zc3z04anonymousza31942ze3z87_13618;
									}
							}
						else
							{	/* Eval/evaluate_comp.scm 896 */
								bool_t BgL_test6189z00_19780;

								{	/* Eval/evaluate_comp.scm 896 */
									int BgL_arg1986z00_2111;

									BgL_arg1986z00_2111 = bgl_debug();
									BgL_test6189z00_19780 =
										BGl_2ze3ze3zz__r4_numbers_6_5z00(BINT(BgL_arg1986z00_2111),
										BINT(((long) 0)));
								}
								if (BgL_test6189z00_19780)
									{	/* Eval/evaluate_comp.scm 896 */
										obj_t BgL_zc3z04anonymousza31958ze3z87_13619;

										BgL_zc3z04anonymousza31958ze3z87_13619 =
											MAKE_FX_PROCEDURE
											(BGl_z62zc3z04anonymousza31958ze3ze5zz__evaluate_compz00,
											(int) (((long) 1)), (int) (((long) 4)));
										PROCEDURE_SET(BgL_zc3z04anonymousza31958ze3z87_13619,
											(int) (((long) 0)), BgL_funz00_141);
										PROCEDURE_SET(BgL_zc3z04anonymousza31958ze3z87_13619,
											(int) (((long) 1)), BgL_locz00_138);
										PROCEDURE_SET(BgL_zc3z04anonymousza31958ze3z87_13619,
											(int) (((long) 2)), BgL_symbzd2funzd2_140);
										PROCEDURE_SET(BgL_zc3z04anonymousza31958ze3z87_13619,
											(int) (((long) 3)), BINT(BgL_siza7eza7_144));
										return BgL_zc3z04anonymousza31958ze3z87_13619;
									}
								else
									{	/* Eval/evaluate_comp.scm 896 */
										obj_t BgL_zc3z04anonymousza31973ze3z87_13620;

										BgL_zc3z04anonymousza31973ze3z87_13620 =
											MAKE_FX_PROCEDURE
											(BGl_z62zc3z04anonymousza31973ze3ze5zz__evaluate_compz00,
											(int) (((long) 1)), (int) (((long) 4)));
										PROCEDURE_SET(BgL_zc3z04anonymousza31973ze3z87_13620,
											(int) (((long) 0)), BgL_funz00_141);
										PROCEDURE_SET(BgL_zc3z04anonymousza31973ze3z87_13620,
											(int) (((long) 1)), BgL_locz00_138);
										PROCEDURE_SET(BgL_zc3z04anonymousza31973ze3z87_13620,
											(int) (((long) 2)), BgL_symbzd2funzd2_140);
										PROCEDURE_SET(BgL_zc3z04anonymousza31973ze3z87_13620,
											(int) (((long) 3)), BINT(BgL_siza7eza7_144));
										return BgL_zc3z04anonymousza31973ze3z87_13620;
									}
							}
					}
			}
		}

	}



/* &<@anonymous:1922> */
	obj_t BGl_z62zc3z04anonymousza31922ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_13621, obj_t BgL_sz00_13625)
	{
		{	/* Eval/evaluate_comp.scm 896 */
			{	/* Eval/evaluate_comp.scm 896 */
				long BgL_siza7eza7_13622;
				obj_t BgL_locz00_13623;
				obj_t BgL_cfunz00_13624;

				BgL_siza7eza7_13622 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13621, (int) (((long) 0))));
				BgL_locz00_13623 = PROCEDURE_REF(BgL_envz00_13621, (int) (((long) 1)));
				BgL_cfunz00_13624 = PROCEDURE_REF(BgL_envz00_13621, (int) (((long) 2)));
				{	/* Eval/evaluate_comp.scm 896 */
					obj_t BgL_bpz00_15702;

					BgL_bpz00_15702 = VECTOR_REF(((obj_t) BgL_sz00_13625), ((long) 0));
					{	/* Eval/evaluate_comp.scm 896 */

						{	/* Eval/evaluate_comp.scm 896 */
							long BgL_nbpz00_15703;

							BgL_nbpz00_15703 =
								((long) CINT(BgL_bpz00_15702) + BgL_siza7eza7_13622);
							VECTOR_SET(
								((obj_t) BgL_sz00_13625), ((long) 0), BINT(BgL_nbpz00_15703));
							{	/* Eval/evaluate_comp.scm 896 */
								obj_t BgL_tmpz00_19823;

								BgL_tmpz00_19823 = BGL_CURRENT_DYNAMIC_ENV();
								BGL_ENV_SET_TRACE_LOCATION(BgL_tmpz00_19823, BgL_locz00_13623);
							}
							{	/* Eval/evaluate_comp.scm 896 */
								obj_t BgL_rz00_15704;

								BgL_rz00_15704 =
									PROCEDURE_ENTRY(BgL_cfunz00_13624) (BgL_cfunz00_13624, BEOA);
								VECTOR_SET(
									((obj_t) BgL_sz00_13625), ((long) 0), BgL_bpz00_15702);
								return BgL_rz00_15704;
							}
						}
					}
				}
			}
		}

	}



/* &<@anonymous:1924> */
	obj_t BGl_z62zc3z04anonymousza31924ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_13626, obj_t BgL_sz00_13629)
	{
		{	/* Eval/evaluate_comp.scm 896 */
			{	/* Eval/evaluate_comp.scm 896 */
				long BgL_siza7eza7_13627;
				obj_t BgL_cfunz00_13628;

				BgL_siza7eza7_13627 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13626, (int) (((long) 0))));
				BgL_cfunz00_13628 = PROCEDURE_REF(BgL_envz00_13626, (int) (((long) 1)));
				{	/* Eval/evaluate_comp.scm 896 */
					obj_t BgL_bpz00_15705;

					BgL_bpz00_15705 = VECTOR_REF(((obj_t) BgL_sz00_13629), ((long) 0));
					{	/* Eval/evaluate_comp.scm 896 */

						{	/* Eval/evaluate_comp.scm 896 */
							long BgL_nbpz00_15706;

							BgL_nbpz00_15706 =
								((long) CINT(BgL_bpz00_15705) + BgL_siza7eza7_13627);
							VECTOR_SET(
								((obj_t) BgL_sz00_13629), ((long) 0), BINT(BgL_nbpz00_15706));
							{	/* Eval/evaluate_comp.scm 896 */
								obj_t BgL_rz00_15707;

								BgL_rz00_15707 =
									PROCEDURE_ENTRY(BgL_cfunz00_13628) (BgL_cfunz00_13628, BEOA);
								VECTOR_SET(
									((obj_t) BgL_sz00_13629), ((long) 0), BgL_bpz00_15705);
								return BgL_rz00_15707;
							}
						}
					}
				}
			}
		}

	}



/* &<@anonymous:1928> */
	obj_t BGl_z62zc3z04anonymousza31928ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_13630, obj_t BgL_sz00_13635)
	{
		{	/* Eval/evaluate_comp.scm 896 */
			{	/* Eval/evaluate_comp.scm 896 */
				obj_t BgL_funz00_13631;
				obj_t BgL_locz00_13632;
				obj_t BgL_symbzd2funzd2_13633;
				long BgL_siza7eza7_13634;

				BgL_funz00_13631 = PROCEDURE_REF(BgL_envz00_13630, (int) (((long) 0)));
				BgL_locz00_13632 = PROCEDURE_REF(BgL_envz00_13630, (int) (((long) 1)));
				BgL_symbzd2funzd2_13633 =
					PROCEDURE_REF(BgL_envz00_13630, (int) (((long) 2)));
				BgL_siza7eza7_13634 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13630, (int) (((long) 3))));
				{	/* Eval/evaluate_comp.scm 896 */
					obj_t BgL_bpz00_15708;

					BgL_bpz00_15708 = VECTOR_REF(((obj_t) BgL_sz00_13635), ((long) 0));
					{	/* Eval/evaluate_comp.scm 896 */
						obj_t BgL_fz00_15709;

						BgL_fz00_15709 =
							PROCEDURE_ENTRY(BgL_funz00_13631) (BgL_funz00_13631,
							BgL_sz00_13635, BEOA);
						if (PROCEDUREP(BgL_fz00_15709))
							{	/* Eval/evaluate_comp.scm 896 */
								BFALSE;
							}
						else
							{	/* Eval/evaluate_comp.scm 896 */
								BGl_evtypezd2errorzd2zz__everrorz00(BgL_locz00_13632,
									BGl_string5807z00zz__evaluate_compz00,
									BGl_string5823z00zz__evaluate_compz00, BgL_fz00_15709);
							}
						{	/* Eval/evaluate_comp.scm 896 */
							obj_t BgL_ufz00_15710;

							{	/* Eval/evaluate_comp.scm 896 */
								obj_t BgL_tmpz00_19866;

								BgL_tmpz00_19866 = ((obj_t) BgL_fz00_15709);
								BgL_ufz00_15710 = PROCEDURE_ATTR(BgL_tmpz00_19866);
							}
							{	/* Eval/evaluate_comp.scm 896 */
								bool_t BgL_test6191z00_19869;

								if (STRUCTP(BgL_ufz00_15710))
									{	/* Eval/evaluate_comp.scm 683 */
										BgL_test6191z00_19869 =
											(STRUCT_KEY(BgL_ufz00_15710) ==
											BGl_symbol5824z00zz__evaluate_compz00);
									}
								else
									{	/* Eval/evaluate_comp.scm 683 */
										BgL_test6191z00_19869 = ((bool_t) 0);
									}
								if (BgL_test6191z00_19869)
									{	/* Eval/evaluate_comp.scm 896 */
										obj_t BgL_arityz00_15711;
										obj_t BgL_runz00_15712;
										obj_t BgL_sfz00_15713;

										BgL_arityz00_15711 =
											STRUCT_REF(BgL_ufz00_15710, (int) (((long) 0)));
										BgL_runz00_15712 =
											STRUCT_REF(BgL_ufz00_15710, (int) (((long) 1)));
										BgL_sfz00_15713 =
											STRUCT_REF(BgL_ufz00_15710, (int) (((long) 2)));
										if (((long) CINT(BgL_arityz00_15711) == ((long) 0)))
											{	/* Eval/evaluate_comp.scm 896 */
												BUNSPEC;
											}
										else
											{	/* Eval/evaluate_comp.scm 896 */
												if (INTEGERP(BgL_arityz00_15711))
													{	/* Eval/evaluate_comp.scm 896 */
														switch ((long) CINT(BgL_arityz00_15711))
															{
															case ((long) -1):

																{	/* Eval/evaluate_comp.scm 896 */
																	long BgL_arg1933z00_15714;
																	obj_t BgL_arg1934z00_15715;

																	BgL_arg1933z00_15714 =
																		((long) CINT(BgL_bpz00_15708) + ((long) 0));
																	BgL_arg1934z00_15715 = BNIL;
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13635),
																		BgL_arg1933z00_15714, BgL_arg1934z00_15715);
																} break;
															default:
																BGl_evarityzd2errorzd2zz__everrorz00
																	(BgL_locz00_13632, STRUCT_REF(BgL_ufz00_15710,
																		(int) (((long) 3))), (int) (((long) 0)),
																	CINT(BgL_arityz00_15711));
													}}
												else
													{	/* Eval/evaluate_comp.scm 896 */
														BGl_evarityzd2errorzd2zz__everrorz00
															(BgL_locz00_13632, STRUCT_REF(BgL_ufz00_15710,
																(int) (((long) 3))), (int) (((long) 0)),
															CINT(BgL_arityz00_15711));
											}}
										{	/* Eval/evaluate_comp.scm 896 */
											obj_t BgL_z12denvz12_15716;

											BgL_z12denvz12_15716 = BGL_CURRENT_DYNAMIC_ENV();
											BGL_ENV_SET_TRACE_LOCATION(BgL_z12denvz12_15716,
												BgL_locz00_13632);
											if ((((long) CINT(BgL_bpz00_15708) +
														(long) CINT(BgL_sfz00_15713)) <
													VECTOR_LENGTH(((obj_t) BgL_sz00_13635))))
												{	/* Eval/evaluate_comp.scm 896 */
													return BgL_runz00_15712;
												}
											else
												{	/* Eval/evaluate_comp.scm 896 */
													obj_t BgL_nsz00_15717;

													BgL_nsz00_15717 =
														BGl_makezd2statezd2zz__evaluate_compz00();
													{	/* Eval/evaluate_comp.scm 896 */
														long BgL_arg1938z00_15718;

														BgL_arg1938z00_15718 =
															((long) CINT(BgL_bpz00_15708) + ((long) 0));
														BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00
															(BgL_nsz00_15717, ((long) 2), BgL_sz00_13635,
															BgL_bpz00_15708, BINT(BgL_arg1938z00_15718));
													}
													VECTOR_SET(BgL_nsz00_15717, ((long) 1),
														BgL_sz00_13635);
													BGL_ENV_EVSTATE_SET(BgL_z12denvz12_15716,
														BgL_nsz00_15717);
													{	/* Eval/evaluate_comp.scm 896 */
														obj_t BgL_ez00_15719;

														BgL_ez00_15719 = BGL_EXITD_TOP_AS_OBJ();
														BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
															(BgL_ez00_15719, BgL_sz00_13635);
														{	/* Eval/evaluate_comp.scm 896 */
															obj_t BgL_____rz00_15720;

															{	/* Eval/evaluate_comp.scm 670 */
																obj_t BgL_savedzd2bpzd2_15721;

																BgL_savedzd2bpzd2_15721 =
																	VECTOR_REF(BgL_nsz00_15717, ((long) 0));
																VECTOR_SET(BgL_nsz00_15717, ((long) 0),
																	BINT(((long) 2)));
																{
																	obj_t BgL_fz00_15723;

																	BgL_fz00_15723 = BgL_runz00_15712;
																BgL_recz00_15722:
																	{	/* Eval/evaluate_comp.scm 673 */
																		obj_t BgL_rz00_15724;

																		BgL_rz00_15724 =
																			PROCEDURE_ENTRY(BgL_fz00_15723)
																			(BgL_fz00_15723, BgL_nsz00_15717, BEOA);
																		{	/* Eval/evaluate_comp.scm 674 */
																			bool_t BgL_test6196z00_19926;

																			if (PROCEDUREP(BgL_rz00_15724))
																				{	/* Eval/evaluate_comp.scm 674 */
																					obj_t BgL_arg1702z00_15725;

																					BgL_arg1702z00_15725 =
																						PROCEDURE_ATTR(BgL_rz00_15724);
																					if (STRUCTP(BgL_arg1702z00_15725))
																						{	/* Eval/evaluate_comp.scm 654 */
																							BgL_test6196z00_19926 =
																								(STRUCT_KEY
																								(BgL_arg1702z00_15725) ==
																								BGl_symbol5803z00zz__evaluate_compz00);
																						}
																					else
																						{	/* Eval/evaluate_comp.scm 654 */
																							BgL_test6196z00_19926 =
																								((bool_t) 0);
																						}
																				}
																			else
																				{	/* Eval/evaluate_comp.scm 674 */
																					BgL_test6196z00_19926 = ((bool_t) 0);
																				}
																			if (BgL_test6196z00_19926)
																				{
																					obj_t BgL_fz00_19934;

																					BgL_fz00_19934 = BgL_rz00_15724;
																					BgL_fz00_15723 = BgL_fz00_19934;
																					goto BgL_recz00_15722;
																				}
																			else
																				{	/* Eval/evaluate_comp.scm 674 */
																					VECTOR_SET(BgL_nsz00_15717,
																						((long) 0),
																						BgL_savedzd2bpzd2_15721);
																					BgL_____rz00_15720 = BgL_rz00_15724;
															}}}}}
															BGl_exitdzd2popzd2protectz12z12zz__bexitz00
																(BgL_ez00_15719);
															BGL_ENV_EVSTATE_SET(BgL_z12denvz12_15716,
																BgL_sz00_13635);
															return BgL_____rz00_15720;
														}
													}
												}
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 896 */
										if (PROCEDURE_CORRECT_ARITYP(BgL_fz00_15709,
												(int) (((long) 0))))
											{	/* Eval/evaluate_comp.scm 896 */
												long BgL_nbpz00_15726;

												BgL_nbpz00_15726 =
													((long) CINT(BgL_bpz00_15708) + BgL_siza7eza7_13634);
												VECTOR_SET(
													((obj_t) BgL_sz00_13635), ((long) 0),
													BINT(BgL_nbpz00_15726));
												{	/* Eval/evaluate_comp.scm 896 */
													obj_t BgL_tmpz00_19946;

													BgL_tmpz00_19946 = BGL_CURRENT_DYNAMIC_ENV();
													BGL_ENV_SET_TRACE_LOCATION(BgL_tmpz00_19946,
														BgL_locz00_13632);
												}
												{	/* Eval/evaluate_comp.scm 896 */
													obj_t BgL_rz00_15727;

													BgL_rz00_15727 =
														PROCEDURE_ENTRY(BgL_fz00_15709) (BgL_fz00_15709,
														BEOA);
													VECTOR_SET(((obj_t) BgL_sz00_13635), ((long) 0),
														BgL_bpz00_15708);
													return BgL_rz00_15727;
												}
											}
										else
											{	/* Eval/evaluate_comp.scm 896 */
												return
													BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_13632,
													BgL_symbzd2funzd2_13633, (int) (((long) 0)),
													PROCEDURE_ARITY(BgL_fz00_15709));
		}}}}}}}}

	}



/* &<@anonymous:1942> */
	obj_t BGl_z62zc3z04anonymousza31942ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_13636, obj_t BgL_sz00_13641)
	{
		{	/* Eval/evaluate_comp.scm 896 */
			{	/* Eval/evaluate_comp.scm 896 */
				obj_t BgL_funz00_13637;
				obj_t BgL_locz00_13638;
				obj_t BgL_symbzd2funzd2_13639;
				long BgL_siza7eza7_13640;

				BgL_funz00_13637 = PROCEDURE_REF(BgL_envz00_13636, (int) (((long) 0)));
				BgL_locz00_13638 = PROCEDURE_REF(BgL_envz00_13636, (int) (((long) 1)));
				BgL_symbzd2funzd2_13639 =
					PROCEDURE_REF(BgL_envz00_13636, (int) (((long) 2)));
				BgL_siza7eza7_13640 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13636, (int) (((long) 3))));
				{	/* Eval/evaluate_comp.scm 896 */
					obj_t BgL_bpz00_15728;

					BgL_bpz00_15728 = VECTOR_REF(((obj_t) BgL_sz00_13641), ((long) 0));
					{	/* Eval/evaluate_comp.scm 896 */
						obj_t BgL_fz00_15729;

						BgL_fz00_15729 =
							PROCEDURE_ENTRY(BgL_funz00_13637) (BgL_funz00_13637,
							BgL_sz00_13641, BEOA);
						if (PROCEDUREP(BgL_fz00_15729))
							{	/* Eval/evaluate_comp.scm 896 */
								BFALSE;
							}
						else
							{	/* Eval/evaluate_comp.scm 896 */
								BGl_evtypezd2errorzd2zz__everrorz00(BgL_locz00_13638,
									BGl_string5807z00zz__evaluate_compz00,
									BGl_string5823z00zz__evaluate_compz00, BgL_fz00_15729);
							}
						{	/* Eval/evaluate_comp.scm 896 */
							obj_t BgL_ufz00_15730;

							{	/* Eval/evaluate_comp.scm 896 */
								obj_t BgL_tmpz00_19975;

								BgL_tmpz00_19975 = ((obj_t) BgL_fz00_15729);
								BgL_ufz00_15730 = PROCEDURE_ATTR(BgL_tmpz00_19975);
							}
							{	/* Eval/evaluate_comp.scm 896 */
								bool_t BgL_test6201z00_19978;

								if (STRUCTP(BgL_ufz00_15730))
									{	/* Eval/evaluate_comp.scm 683 */
										BgL_test6201z00_19978 =
											(STRUCT_KEY(BgL_ufz00_15730) ==
											BGl_symbol5824z00zz__evaluate_compz00);
									}
								else
									{	/* Eval/evaluate_comp.scm 683 */
										BgL_test6201z00_19978 = ((bool_t) 0);
									}
								if (BgL_test6201z00_19978)
									{	/* Eval/evaluate_comp.scm 896 */
										obj_t BgL_arityz00_15731;
										obj_t BgL_runz00_15732;
										obj_t BgL_sfz00_15733;

										BgL_arityz00_15731 =
											STRUCT_REF(BgL_ufz00_15730, (int) (((long) 0)));
										BgL_runz00_15732 =
											STRUCT_REF(BgL_ufz00_15730, (int) (((long) 1)));
										BgL_sfz00_15733 =
											STRUCT_REF(BgL_ufz00_15730, (int) (((long) 2)));
										if (((long) CINT(BgL_arityz00_15731) == ((long) 0)))
											{	/* Eval/evaluate_comp.scm 896 */
												BUNSPEC;
											}
										else
											{	/* Eval/evaluate_comp.scm 896 */
												if (INTEGERP(BgL_arityz00_15731))
													{	/* Eval/evaluate_comp.scm 896 */
														switch ((long) CINT(BgL_arityz00_15731))
															{
															case ((long) -1):

																{	/* Eval/evaluate_comp.scm 896 */
																	long BgL_arg1947z00_15734;
																	obj_t BgL_arg1948z00_15735;

																	BgL_arg1947z00_15734 =
																		((long) CINT(BgL_bpz00_15728) + ((long) 0));
																	BgL_arg1948z00_15735 = BNIL;
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13641),
																		BgL_arg1947z00_15734, BgL_arg1948z00_15735);
																} break;
															default:
																BGl_evarityzd2errorzd2zz__everrorz00
																	(BgL_locz00_13638, STRUCT_REF(BgL_ufz00_15730,
																		(int) (((long) 3))), (int) (((long) 0)),
																	CINT(BgL_arityz00_15731));
													}}
												else
													{	/* Eval/evaluate_comp.scm 896 */
														BGl_evarityzd2errorzd2zz__everrorz00
															(BgL_locz00_13638, STRUCT_REF(BgL_ufz00_15730,
																(int) (((long) 3))), (int) (((long) 0)),
															CINT(BgL_arityz00_15731));
											}}
										{	/* Eval/evaluate_comp.scm 896 */
											obj_t BgL_z12denvz12_15736;

											BgL_z12denvz12_15736 = BGL_CURRENT_DYNAMIC_ENV();
											if (
												(((long) CINT(BgL_bpz00_15728) +
														(long) CINT(BgL_sfz00_15733)) <
													VECTOR_LENGTH(((obj_t) BgL_sz00_13641))))
												{	/* Eval/evaluate_comp.scm 896 */
													return BgL_runz00_15732;
												}
											else
												{	/* Eval/evaluate_comp.scm 896 */
													obj_t BgL_nsz00_15737;

													BgL_nsz00_15737 =
														BGl_makezd2statezd2zz__evaluate_compz00();
													{	/* Eval/evaluate_comp.scm 896 */
														long BgL_arg1952z00_15738;

														BgL_arg1952z00_15738 =
															((long) CINT(BgL_bpz00_15728) + ((long) 0));
														BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00
															(BgL_nsz00_15737, ((long) 2), BgL_sz00_13641,
															BgL_bpz00_15728, BINT(BgL_arg1952z00_15738));
													}
													VECTOR_SET(BgL_nsz00_15737, ((long) 1),
														BgL_sz00_13641);
													BGL_ENV_EVSTATE_SET(BgL_z12denvz12_15736,
														BgL_nsz00_15737);
													{	/* Eval/evaluate_comp.scm 896 */
														obj_t BgL_ez00_15739;

														BgL_ez00_15739 = BGL_EXITD_TOP_AS_OBJ();
														BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
															(BgL_ez00_15739, BgL_sz00_13641);
														{	/* Eval/evaluate_comp.scm 896 */
															obj_t BgL_____rz00_15740;

															{	/* Eval/evaluate_comp.scm 670 */
																obj_t BgL_savedzd2bpzd2_15741;

																BgL_savedzd2bpzd2_15741 =
																	VECTOR_REF(BgL_nsz00_15737, ((long) 0));
																VECTOR_SET(BgL_nsz00_15737, ((long) 0),
																	BINT(((long) 2)));
																{
																	obj_t BgL_fz00_15743;

																	BgL_fz00_15743 = BgL_runz00_15732;
																BgL_recz00_15742:
																	{	/* Eval/evaluate_comp.scm 673 */
																		obj_t BgL_rz00_15744;

																		BgL_rz00_15744 =
																			PROCEDURE_ENTRY(BgL_fz00_15743)
																			(BgL_fz00_15743, BgL_nsz00_15737, BEOA);
																		{	/* Eval/evaluate_comp.scm 674 */
																			bool_t BgL_test6206z00_20034;

																			if (PROCEDUREP(BgL_rz00_15744))
																				{	/* Eval/evaluate_comp.scm 674 */
																					obj_t BgL_arg1702z00_15745;

																					BgL_arg1702z00_15745 =
																						PROCEDURE_ATTR(BgL_rz00_15744);
																					if (STRUCTP(BgL_arg1702z00_15745))
																						{	/* Eval/evaluate_comp.scm 654 */
																							BgL_test6206z00_20034 =
																								(STRUCT_KEY
																								(BgL_arg1702z00_15745) ==
																								BGl_symbol5803z00zz__evaluate_compz00);
																						}
																					else
																						{	/* Eval/evaluate_comp.scm 654 */
																							BgL_test6206z00_20034 =
																								((bool_t) 0);
																						}
																				}
																			else
																				{	/* Eval/evaluate_comp.scm 674 */
																					BgL_test6206z00_20034 = ((bool_t) 0);
																				}
																			if (BgL_test6206z00_20034)
																				{
																					obj_t BgL_fz00_20042;

																					BgL_fz00_20042 = BgL_rz00_15744;
																					BgL_fz00_15743 = BgL_fz00_20042;
																					goto BgL_recz00_15742;
																				}
																			else
																				{	/* Eval/evaluate_comp.scm 674 */
																					VECTOR_SET(BgL_nsz00_15737,
																						((long) 0),
																						BgL_savedzd2bpzd2_15741);
																					BgL_____rz00_15740 = BgL_rz00_15744;
															}}}}}
															BGl_exitdzd2popzd2protectz12z12zz__bexitz00
																(BgL_ez00_15739);
															BGL_ENV_EVSTATE_SET(BgL_z12denvz12_15736,
																BgL_sz00_13641);
															return BgL_____rz00_15740;
														}
													}
												}
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 896 */
										if (PROCEDURE_CORRECT_ARITYP(BgL_fz00_15729,
												(int) (((long) 0))))
											{	/* Eval/evaluate_comp.scm 896 */
												long BgL_nbpz00_15746;

												BgL_nbpz00_15746 =
													((long) CINT(BgL_bpz00_15728) + BgL_siza7eza7_13640);
												VECTOR_SET(
													((obj_t) BgL_sz00_13641), ((long) 0),
													BINT(BgL_nbpz00_15746));
												{	/* Eval/evaluate_comp.scm 896 */
													obj_t BgL_rz00_15747;

													BgL_rz00_15747 =
														PROCEDURE_ENTRY(BgL_fz00_15729) (BgL_fz00_15729,
														BEOA);
													VECTOR_SET(((obj_t) BgL_sz00_13641), ((long) 0),
														BgL_bpz00_15728);
													return BgL_rz00_15747;
												}
											}
										else
											{	/* Eval/evaluate_comp.scm 896 */
												return
													BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_13638,
													BgL_symbzd2funzd2_13639, (int) (((long) 0)),
													PROCEDURE_ARITY(BgL_fz00_15729));
		}}}}}}}}

	}



/* &<@anonymous:1958> */
	obj_t BGl_z62zc3z04anonymousza31958ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_13642, obj_t BgL_sz00_13647)
	{
		{	/* Eval/evaluate_comp.scm 896 */
			{	/* Eval/evaluate_comp.scm 896 */
				obj_t BgL_funz00_13643;
				obj_t BgL_locz00_13644;
				obj_t BgL_symbzd2funzd2_13645;
				long BgL_siza7eza7_13646;

				BgL_funz00_13643 = PROCEDURE_REF(BgL_envz00_13642, (int) (((long) 0)));
				BgL_locz00_13644 = PROCEDURE_REF(BgL_envz00_13642, (int) (((long) 1)));
				BgL_symbzd2funzd2_13645 =
					PROCEDURE_REF(BgL_envz00_13642, (int) (((long) 2)));
				BgL_siza7eza7_13646 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13642, (int) (((long) 3))));
				{	/* Eval/evaluate_comp.scm 896 */
					obj_t BgL_bpz00_15748;

					BgL_bpz00_15748 = VECTOR_REF(((obj_t) BgL_sz00_13647), ((long) 0));
					{	/* Eval/evaluate_comp.scm 896 */
						obj_t BgL_fz00_15749;

						BgL_fz00_15749 =
							PROCEDURE_ENTRY(BgL_funz00_13643) (BgL_funz00_13643,
							BgL_sz00_13647, BEOA);
						if (PROCEDUREP(BgL_fz00_15749))
							{	/* Eval/evaluate_comp.scm 896 */
								BFALSE;
							}
						else
							{	/* Eval/evaluate_comp.scm 896 */
								BGl_evtypezd2errorzd2zz__everrorz00(BgL_locz00_13644,
									BGl_string5807z00zz__evaluate_compz00,
									BGl_string5823z00zz__evaluate_compz00, BgL_fz00_15749);
							}
						{	/* Eval/evaluate_comp.scm 896 */
							obj_t BgL_ufz00_15750;

							{	/* Eval/evaluate_comp.scm 896 */
								obj_t BgL_tmpz00_20080;

								BgL_tmpz00_20080 = ((obj_t) BgL_fz00_15749);
								BgL_ufz00_15750 = PROCEDURE_ATTR(BgL_tmpz00_20080);
							}
							{	/* Eval/evaluate_comp.scm 896 */
								bool_t BgL_test6211z00_20083;

								if (STRUCTP(BgL_ufz00_15750))
									{	/* Eval/evaluate_comp.scm 683 */
										BgL_test6211z00_20083 =
											(STRUCT_KEY(BgL_ufz00_15750) ==
											BGl_symbol5824z00zz__evaluate_compz00);
									}
								else
									{	/* Eval/evaluate_comp.scm 683 */
										BgL_test6211z00_20083 = ((bool_t) 0);
									}
								if (BgL_test6211z00_20083)
									{	/* Eval/evaluate_comp.scm 896 */
										obj_t BgL_arityz00_15751;
										obj_t BgL_runz00_15752;
										obj_t BgL_sfz00_15753;

										BgL_arityz00_15751 =
											STRUCT_REF(BgL_ufz00_15750, (int) (((long) 0)));
										BgL_runz00_15752 =
											STRUCT_REF(BgL_ufz00_15750, (int) (((long) 1)));
										BgL_sfz00_15753 =
											STRUCT_REF(BgL_ufz00_15750, (int) (((long) 2)));
										{	/* Eval/evaluate_comp.scm 896 */
											long BgL_spz00_15754;

											BgL_spz00_15754 =
												((long) CINT(BgL_bpz00_15748) + BgL_siza7eza7_13646);
											if (((long) CINT(BgL_arityz00_15751) == ((long) 0)))
												{	/* Eval/evaluate_comp.scm 896 */
													BUNSPEC;
												}
											else
												{	/* Eval/evaluate_comp.scm 896 */
													if (INTEGERP(BgL_arityz00_15751))
														{	/* Eval/evaluate_comp.scm 896 */
															switch ((long) CINT(BgL_arityz00_15751))
																{
																case ((long) -1):

																	{	/* Eval/evaluate_comp.scm 896 */
																		long BgL_arg1963z00_15755;
																		obj_t BgL_arg1964z00_15756;

																		BgL_arg1963z00_15755 =
																			(BgL_spz00_15754 + ((long) 0));
																		BgL_arg1964z00_15756 = BNIL;
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13647),
																			BgL_arg1963z00_15755,
																			BgL_arg1964z00_15756);
																	} break;
																default:
																	BGl_evarityzd2errorzd2zz__everrorz00
																		(BgL_locz00_13644,
																		STRUCT_REF(BgL_ufz00_15750,
																			(int) (((long) 3))), (int) (((long) 0)),
																		CINT(BgL_arityz00_15751));
														}}
													else
														{	/* Eval/evaluate_comp.scm 896 */
															BGl_evarityzd2errorzd2zz__everrorz00
																(BgL_locz00_13644, STRUCT_REF(BgL_ufz00_15750,
																	(int) (((long) 3))), (int) (((long) 0)),
																CINT(BgL_arityz00_15751));
												}}
											{	/* Eval/evaluate_comp.scm 896 */
												obj_t BgL_z12denvz12_15757;

												BgL_z12denvz12_15757 = BGL_CURRENT_DYNAMIC_ENV();
												BGL_ENV_SET_TRACE_LOCATION(BgL_z12denvz12_15757,
													BgL_locz00_13644);
												if (((BgL_spz00_15754 + (long) CINT(BgL_sfz00_15753)) <
														VECTOR_LENGTH(((obj_t) BgL_sz00_13647))))
													{	/* Eval/evaluate_comp.scm 896 */
														return
															BGl_catchzd2trampolinezd2zz__evaluate_compz00
															(BgL_runz00_15752, BgL_sz00_13647,
															BINT(BgL_spz00_15754));
													}
												else
													{	/* Eval/evaluate_comp.scm 896 */
														obj_t BgL_nsz00_15758;

														BgL_nsz00_15758 =
															BGl_makezd2statezd2zz__evaluate_compz00();
														{	/* Eval/evaluate_comp.scm 896 */
															long BgL_arg1968z00_15759;

															BgL_arg1968z00_15759 =
																(BgL_spz00_15754 + ((long) 0));
															BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00
																(BgL_nsz00_15758, ((long) 2), BgL_sz00_13647,
																BINT(BgL_spz00_15754),
																BINT(BgL_arg1968z00_15759));
														}
														VECTOR_SET(BgL_nsz00_15758, ((long) 1),
															BgL_sz00_13647);
														BGL_ENV_EVSTATE_SET(BgL_z12denvz12_15757,
															BgL_nsz00_15758);
														{	/* Eval/evaluate_comp.scm 896 */
															obj_t BgL_ez00_15760;

															BgL_ez00_15760 = BGL_EXITD_TOP_AS_OBJ();
															BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
																(BgL_ez00_15760, BgL_sz00_13647);
															{	/* Eval/evaluate_comp.scm 896 */
																obj_t BgL_____rz00_15761;

																{	/* Eval/evaluate_comp.scm 670 */
																	obj_t BgL_savedzd2bpzd2_15762;

																	BgL_savedzd2bpzd2_15762 =
																		VECTOR_REF(BgL_nsz00_15758, ((long) 0));
																	VECTOR_SET(BgL_nsz00_15758, ((long) 0),
																		BINT(((long) 2)));
																	{
																		obj_t BgL_fz00_15764;

																		BgL_fz00_15764 = BgL_runz00_15752;
																	BgL_recz00_15763:
																		{	/* Eval/evaluate_comp.scm 673 */
																			obj_t BgL_rz00_15765;

																			BgL_rz00_15765 =
																				PROCEDURE_ENTRY(BgL_fz00_15764)
																				(BgL_fz00_15764, BgL_nsz00_15758, BEOA);
																			{	/* Eval/evaluate_comp.scm 674 */
																				bool_t BgL_test6216z00_20142;

																				if (PROCEDUREP(BgL_rz00_15765))
																					{	/* Eval/evaluate_comp.scm 674 */
																						obj_t BgL_arg1702z00_15766;

																						BgL_arg1702z00_15766 =
																							PROCEDURE_ATTR(BgL_rz00_15765);
																						if (STRUCTP(BgL_arg1702z00_15766))
																							{	/* Eval/evaluate_comp.scm 654 */
																								BgL_test6216z00_20142 =
																									(STRUCT_KEY
																									(BgL_arg1702z00_15766) ==
																									BGl_symbol5803z00zz__evaluate_compz00);
																							}
																						else
																							{	/* Eval/evaluate_comp.scm 654 */
																								BgL_test6216z00_20142 =
																									((bool_t) 0);
																							}
																					}
																				else
																					{	/* Eval/evaluate_comp.scm 674 */
																						BgL_test6216z00_20142 =
																							((bool_t) 0);
																					}
																				if (BgL_test6216z00_20142)
																					{
																						obj_t BgL_fz00_20150;

																						BgL_fz00_20150 = BgL_rz00_15765;
																						BgL_fz00_15764 = BgL_fz00_20150;
																						goto BgL_recz00_15763;
																					}
																				else
																					{	/* Eval/evaluate_comp.scm 674 */
																						VECTOR_SET(BgL_nsz00_15758,
																							((long) 0),
																							BgL_savedzd2bpzd2_15762);
																						BgL_____rz00_15761 = BgL_rz00_15765;
																}}}}}
																BGl_exitdzd2popzd2protectz12z12zz__bexitz00
																	(BgL_ez00_15760);
																BGL_ENV_EVSTATE_SET(BgL_z12denvz12_15757,
																	BgL_sz00_13647);
																return BgL_____rz00_15761;
															}
														}
													}
											}
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 896 */
										if (PROCEDURE_CORRECT_ARITYP(BgL_fz00_15749,
												(int) (((long) 0))))
											{	/* Eval/evaluate_comp.scm 896 */
												long BgL_nbpz00_15767;

												BgL_nbpz00_15767 =
													((long) CINT(BgL_bpz00_15748) + BgL_siza7eza7_13646);
												VECTOR_SET(
													((obj_t) BgL_sz00_13647), ((long) 0),
													BINT(BgL_nbpz00_15767));
												{	/* Eval/evaluate_comp.scm 896 */
													obj_t BgL_tmpz00_20162;

													BgL_tmpz00_20162 = BGL_CURRENT_DYNAMIC_ENV();
													BGL_ENV_SET_TRACE_LOCATION(BgL_tmpz00_20162,
														BgL_locz00_13644);
												}
												{	/* Eval/evaluate_comp.scm 896 */
													obj_t BgL_rz00_15768;

													BgL_rz00_15768 =
														PROCEDURE_ENTRY(BgL_fz00_15749) (BgL_fz00_15749,
														BEOA);
													VECTOR_SET(((obj_t) BgL_sz00_13647), ((long) 0),
														BgL_bpz00_15748);
													return BgL_rz00_15768;
												}
											}
										else
											{	/* Eval/evaluate_comp.scm 896 */
												return
													BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_13644,
													BgL_symbzd2funzd2_13645, (int) (((long) 0)),
													PROCEDURE_ARITY(BgL_fz00_15749));
		}}}}}}}}

	}



/* &<@anonymous:1973> */
	obj_t BGl_z62zc3z04anonymousza31973ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_13648, obj_t BgL_sz00_13653)
	{
		{	/* Eval/evaluate_comp.scm 896 */
			{	/* Eval/evaluate_comp.scm 896 */
				obj_t BgL_funz00_13649;
				obj_t BgL_locz00_13650;
				obj_t BgL_symbzd2funzd2_13651;
				long BgL_siza7eza7_13652;

				BgL_funz00_13649 = PROCEDURE_REF(BgL_envz00_13648, (int) (((long) 0)));
				BgL_locz00_13650 = PROCEDURE_REF(BgL_envz00_13648, (int) (((long) 1)));
				BgL_symbzd2funzd2_13651 =
					PROCEDURE_REF(BgL_envz00_13648, (int) (((long) 2)));
				BgL_siza7eza7_13652 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13648, (int) (((long) 3))));
				{	/* Eval/evaluate_comp.scm 896 */
					obj_t BgL_bpz00_15769;

					BgL_bpz00_15769 = VECTOR_REF(((obj_t) BgL_sz00_13653), ((long) 0));
					{	/* Eval/evaluate_comp.scm 896 */
						obj_t BgL_fz00_15770;

						BgL_fz00_15770 =
							PROCEDURE_ENTRY(BgL_funz00_13649) (BgL_funz00_13649,
							BgL_sz00_13653, BEOA);
						if (PROCEDUREP(BgL_fz00_15770))
							{	/* Eval/evaluate_comp.scm 896 */
								BFALSE;
							}
						else
							{	/* Eval/evaluate_comp.scm 896 */
								BGl_evtypezd2errorzd2zz__everrorz00(BgL_locz00_13650,
									BGl_string5807z00zz__evaluate_compz00,
									BGl_string5823z00zz__evaluate_compz00, BgL_fz00_15770);
							}
						{	/* Eval/evaluate_comp.scm 896 */
							obj_t BgL_ufz00_15771;

							{	/* Eval/evaluate_comp.scm 896 */
								obj_t BgL_tmpz00_20191;

								BgL_tmpz00_20191 = ((obj_t) BgL_fz00_15770);
								BgL_ufz00_15771 = PROCEDURE_ATTR(BgL_tmpz00_20191);
							}
							{	/* Eval/evaluate_comp.scm 896 */
								bool_t BgL_test6221z00_20194;

								if (STRUCTP(BgL_ufz00_15771))
									{	/* Eval/evaluate_comp.scm 683 */
										BgL_test6221z00_20194 =
											(STRUCT_KEY(BgL_ufz00_15771) ==
											BGl_symbol5824z00zz__evaluate_compz00);
									}
								else
									{	/* Eval/evaluate_comp.scm 683 */
										BgL_test6221z00_20194 = ((bool_t) 0);
									}
								if (BgL_test6221z00_20194)
									{	/* Eval/evaluate_comp.scm 896 */
										obj_t BgL_arityz00_15772;
										obj_t BgL_runz00_15773;
										obj_t BgL_sfz00_15774;

										BgL_arityz00_15772 =
											STRUCT_REF(BgL_ufz00_15771, (int) (((long) 0)));
										BgL_runz00_15773 =
											STRUCT_REF(BgL_ufz00_15771, (int) (((long) 1)));
										BgL_sfz00_15774 =
											STRUCT_REF(BgL_ufz00_15771, (int) (((long) 2)));
										{	/* Eval/evaluate_comp.scm 896 */
											long BgL_spz00_15775;

											BgL_spz00_15775 =
												((long) CINT(BgL_bpz00_15769) + BgL_siza7eza7_13652);
											if (((long) CINT(BgL_arityz00_15772) == ((long) 0)))
												{	/* Eval/evaluate_comp.scm 896 */
													BUNSPEC;
												}
											else
												{	/* Eval/evaluate_comp.scm 896 */
													if (INTEGERP(BgL_arityz00_15772))
														{	/* Eval/evaluate_comp.scm 896 */
															switch ((long) CINT(BgL_arityz00_15772))
																{
																case ((long) -1):

																	{	/* Eval/evaluate_comp.scm 896 */
																		long BgL_arg1978z00_15776;
																		obj_t BgL_arg1979z00_15777;

																		BgL_arg1978z00_15776 =
																			(BgL_spz00_15775 + ((long) 0));
																		BgL_arg1979z00_15777 = BNIL;
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13653),
																			BgL_arg1978z00_15776,
																			BgL_arg1979z00_15777);
																	} break;
																default:
																	BGl_evarityzd2errorzd2zz__everrorz00
																		(BgL_locz00_13650,
																		STRUCT_REF(BgL_ufz00_15771,
																			(int) (((long) 3))), (int) (((long) 0)),
																		CINT(BgL_arityz00_15772));
														}}
													else
														{	/* Eval/evaluate_comp.scm 896 */
															BGl_evarityzd2errorzd2zz__everrorz00
																(BgL_locz00_13650, STRUCT_REF(BgL_ufz00_15771,
																	(int) (((long) 3))), (int) (((long) 0)),
																CINT(BgL_arityz00_15772));
												}}
											{	/* Eval/evaluate_comp.scm 896 */
												obj_t BgL_z12denvz12_15778;

												BgL_z12denvz12_15778 = BGL_CURRENT_DYNAMIC_ENV();
												if (
													((BgL_spz00_15775 +
															(long) CINT(BgL_sfz00_15774)) <
														VECTOR_LENGTH(((obj_t) BgL_sz00_13653))))
													{	/* Eval/evaluate_comp.scm 896 */
														return
															BGl_catchzd2trampolinezd2zz__evaluate_compz00
															(BgL_runz00_15773, BgL_sz00_13653,
															BINT(BgL_spz00_15775));
													}
												else
													{	/* Eval/evaluate_comp.scm 896 */
														obj_t BgL_nsz00_15779;

														BgL_nsz00_15779 =
															BGl_makezd2statezd2zz__evaluate_compz00();
														{	/* Eval/evaluate_comp.scm 896 */
															long BgL_arg1983z00_15780;

															BgL_arg1983z00_15780 =
																(BgL_spz00_15775 + ((long) 0));
															BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00
																(BgL_nsz00_15779, ((long) 2), BgL_sz00_13653,
																BINT(BgL_spz00_15775),
																BINT(BgL_arg1983z00_15780));
														}
														VECTOR_SET(BgL_nsz00_15779, ((long) 1),
															BgL_sz00_13653);
														BGL_ENV_EVSTATE_SET(BgL_z12denvz12_15778,
															BgL_nsz00_15779);
														{	/* Eval/evaluate_comp.scm 896 */
															obj_t BgL_ez00_15781;

															BgL_ez00_15781 = BGL_EXITD_TOP_AS_OBJ();
															BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
																(BgL_ez00_15781, BgL_sz00_13653);
															{	/* Eval/evaluate_comp.scm 896 */
																obj_t BgL_____rz00_15782;

																{	/* Eval/evaluate_comp.scm 670 */
																	obj_t BgL_savedzd2bpzd2_15783;

																	BgL_savedzd2bpzd2_15783 =
																		VECTOR_REF(BgL_nsz00_15779, ((long) 0));
																	VECTOR_SET(BgL_nsz00_15779, ((long) 0),
																		BINT(((long) 2)));
																	{
																		obj_t BgL_fz00_15785;

																		BgL_fz00_15785 = BgL_runz00_15773;
																	BgL_recz00_15784:
																		{	/* Eval/evaluate_comp.scm 673 */
																			obj_t BgL_rz00_15786;

																			BgL_rz00_15786 =
																				PROCEDURE_ENTRY(BgL_fz00_15785)
																				(BgL_fz00_15785, BgL_nsz00_15779, BEOA);
																			{	/* Eval/evaluate_comp.scm 674 */
																				bool_t BgL_test6226z00_20252;

																				if (PROCEDUREP(BgL_rz00_15786))
																					{	/* Eval/evaluate_comp.scm 674 */
																						obj_t BgL_arg1702z00_15787;

																						BgL_arg1702z00_15787 =
																							PROCEDURE_ATTR(BgL_rz00_15786);
																						if (STRUCTP(BgL_arg1702z00_15787))
																							{	/* Eval/evaluate_comp.scm 654 */
																								BgL_test6226z00_20252 =
																									(STRUCT_KEY
																									(BgL_arg1702z00_15787) ==
																									BGl_symbol5803z00zz__evaluate_compz00);
																							}
																						else
																							{	/* Eval/evaluate_comp.scm 654 */
																								BgL_test6226z00_20252 =
																									((bool_t) 0);
																							}
																					}
																				else
																					{	/* Eval/evaluate_comp.scm 674 */
																						BgL_test6226z00_20252 =
																							((bool_t) 0);
																					}
																				if (BgL_test6226z00_20252)
																					{
																						obj_t BgL_fz00_20260;

																						BgL_fz00_20260 = BgL_rz00_15786;
																						BgL_fz00_15785 = BgL_fz00_20260;
																						goto BgL_recz00_15784;
																					}
																				else
																					{	/* Eval/evaluate_comp.scm 674 */
																						VECTOR_SET(BgL_nsz00_15779,
																							((long) 0),
																							BgL_savedzd2bpzd2_15783);
																						BgL_____rz00_15782 = BgL_rz00_15786;
																}}}}}
																BGl_exitdzd2popzd2protectz12z12zz__bexitz00
																	(BgL_ez00_15781);
																BGL_ENV_EVSTATE_SET(BgL_z12denvz12_15778,
																	BgL_sz00_13653);
																return BgL_____rz00_15782;
															}
														}
													}
											}
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 896 */
										if (PROCEDURE_CORRECT_ARITYP(BgL_fz00_15770,
												(int) (((long) 0))))
											{	/* Eval/evaluate_comp.scm 896 */
												long BgL_nbpz00_15788;

												BgL_nbpz00_15788 =
													((long) CINT(BgL_bpz00_15769) + BgL_siza7eza7_13652);
												VECTOR_SET(
													((obj_t) BgL_sz00_13653), ((long) 0),
													BINT(BgL_nbpz00_15788));
												{	/* Eval/evaluate_comp.scm 896 */
													obj_t BgL_rz00_15789;

													BgL_rz00_15789 =
														PROCEDURE_ENTRY(BgL_fz00_15770) (BgL_fz00_15770,
														BEOA);
													VECTOR_SET(((obj_t) BgL_sz00_13653), ((long) 0),
														BgL_bpz00_15769);
													return BgL_rz00_15789;
												}
											}
										else
											{	/* Eval/evaluate_comp.scm 896 */
												return
													BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_13650,
													BgL_symbzd2funzd2_13651, (int) (((long) 0)),
													PROCEDURE_ARITY(BgL_fz00_15770));
		}}}}}}}}

	}



/* comp-call1 */
	obj_t BGl_compzd2call1zd2zz__evaluate_compz00(obj_t BgL_locz00_145,
		BgL_ev_exprz00_bglt BgL_vfunz00_146, obj_t BgL_symbzd2funzd2_147,
		obj_t BgL_funz00_148, obj_t BgL_tailzf3zf3_149, obj_t BgL_stkz00_150,
		long BgL_siza7eza7_151, obj_t BgL_a1z00_152)
	{
		{	/* Eval/evaluate_comp.scm 896 */
			{	/* Eval/evaluate_comp.scm 896 */
				obj_t BgL_cfunz00_2112;

				BgL_cfunz00_2112 =
					BGl_iszd2constantzd2funzf3zf3zz__evaluate_compz00(BgL_vfunz00_146,
					((long) 1), BgL_locz00_145, BgL_symbzd2funzd2_147);
				if (CBOOL(BgL_cfunz00_2112))
					{	/* Eval/evaluate_comp.scm 896 */
						bool_t BgL_test6231z00_20283;

						{	/* Eval/evaluate_comp.scm 896 */
							int BgL_arg1992z00_2128;

							BgL_arg1992z00_2128 = bgl_debug();
							BgL_test6231z00_20283 =
								BGl_2ze3ze3zz__r4_numbers_6_5z00(BINT(BgL_arg1992z00_2128),
								BINT(((long) 0)));
						}
						if (BgL_test6231z00_20283)
							{	/* Eval/evaluate_comp.scm 896 */
								obj_t BgL_zc3z04anonymousza31989ze3z87_13654;

								BgL_zc3z04anonymousza31989ze3z87_13654 =
									MAKE_FX_PROCEDURE
									(BGl_z62zc3z04anonymousza31989ze3ze5zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 4)));
								PROCEDURE_SET(BgL_zc3z04anonymousza31989ze3z87_13654,
									(int) (((long) 0)), BgL_a1z00_152);
								PROCEDURE_SET(BgL_zc3z04anonymousza31989ze3z87_13654,
									(int) (((long) 1)), BINT(BgL_siza7eza7_151));
								PROCEDURE_SET(BgL_zc3z04anonymousza31989ze3z87_13654,
									(int) (((long) 2)), BgL_locz00_145);
								PROCEDURE_SET(BgL_zc3z04anonymousza31989ze3z87_13654,
									(int) (((long) 3)), BgL_cfunz00_2112);
								return BgL_zc3z04anonymousza31989ze3z87_13654;
							}
						else
							{	/* Eval/evaluate_comp.scm 896 */
								obj_t BgL_zc3z04anonymousza31991ze3z87_13655;

								BgL_zc3z04anonymousza31991ze3z87_13655 =
									MAKE_FX_PROCEDURE
									(BGl_z62zc3z04anonymousza31991ze3ze5zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 3)));
								PROCEDURE_SET(BgL_zc3z04anonymousza31991ze3z87_13655,
									(int) (((long) 0)), BgL_a1z00_152);
								PROCEDURE_SET(BgL_zc3z04anonymousza31991ze3z87_13655,
									(int) (((long) 1)), BINT(BgL_siza7eza7_151));
								PROCEDURE_SET(BgL_zc3z04anonymousza31991ze3z87_13655,
									(int) (((long) 2)), BgL_cfunz00_2112);
								return BgL_zc3z04anonymousza31991ze3z87_13655;
							}
					}
				else
					{	/* Eval/evaluate_comp.scm 896 */
						if (CBOOL(BgL_tailzf3zf3_149))
							{	/* Eval/evaluate_comp.scm 896 */
								bool_t BgL_test6233z00_20312;

								{	/* Eval/evaluate_comp.scm 896 */
									int BgL_arg2036z00_2204;

									BgL_arg2036z00_2204 = bgl_debug();
									BgL_test6233z00_20312 =
										BGl_2ze3ze3zz__r4_numbers_6_5z00(BINT(BgL_arg2036z00_2204),
										BINT(((long) 0)));
								}
								if (BgL_test6233z00_20312)
									{	/* Eval/evaluate_comp.scm 896 */
										obj_t BgL_zc3z04anonymousza31996ze3z87_13656;

										BgL_zc3z04anonymousza31996ze3z87_13656 =
											MAKE_FX_PROCEDURE
											(BGl_z62zc3z04anonymousza31996ze3ze5zz__evaluate_compz00,
											(int) (((long) 1)), (int) (((long) 5)));
										PROCEDURE_SET(BgL_zc3z04anonymousza31996ze3z87_13656,
											(int) (((long) 0)), BgL_funz00_148);
										PROCEDURE_SET(BgL_zc3z04anonymousza31996ze3z87_13656,
											(int) (((long) 1)), BgL_a1z00_152);
										PROCEDURE_SET(BgL_zc3z04anonymousza31996ze3z87_13656,
											(int) (((long) 2)), BgL_locz00_145);
										PROCEDURE_SET(BgL_zc3z04anonymousza31996ze3z87_13656,
											(int) (((long) 3)), BgL_symbzd2funzd2_147);
										PROCEDURE_SET(BgL_zc3z04anonymousza31996ze3z87_13656,
											(int) (((long) 4)), BINT(BgL_siza7eza7_151));
										return BgL_zc3z04anonymousza31996ze3z87_13656;
									}
								else
									{	/* Eval/evaluate_comp.scm 896 */
										obj_t BgL_zc3z04anonymousza32017ze3z87_13657;

										BgL_zc3z04anonymousza32017ze3z87_13657 =
											MAKE_FX_PROCEDURE
											(BGl_z62zc3z04anonymousza32017ze3ze5zz__evaluate_compz00,
											(int) (((long) 1)), (int) (((long) 5)));
										PROCEDURE_SET(BgL_zc3z04anonymousza32017ze3z87_13657,
											(int) (((long) 0)), BgL_funz00_148);
										PROCEDURE_SET(BgL_zc3z04anonymousza32017ze3z87_13657,
											(int) (((long) 1)), BgL_a1z00_152);
										PROCEDURE_SET(BgL_zc3z04anonymousza32017ze3z87_13657,
											(int) (((long) 2)), BgL_locz00_145);
										PROCEDURE_SET(BgL_zc3z04anonymousza32017ze3z87_13657,
											(int) (((long) 3)), BgL_symbzd2funzd2_147);
										PROCEDURE_SET(BgL_zc3z04anonymousza32017ze3z87_13657,
											(int) (((long) 4)), BINT(BgL_siza7eza7_151));
										return BgL_zc3z04anonymousza32017ze3z87_13657;
									}
							}
						else
							{	/* Eval/evaluate_comp.scm 896 */
								bool_t BgL_test6234z00_20345;

								{	/* Eval/evaluate_comp.scm 896 */
									int BgL_arg2079z00_2280;

									BgL_arg2079z00_2280 = bgl_debug();
									BgL_test6234z00_20345 =
										BGl_2ze3ze3zz__r4_numbers_6_5z00(BINT(BgL_arg2079z00_2280),
										BINT(((long) 0)));
								}
								if (BgL_test6234z00_20345)
									{	/* Eval/evaluate_comp.scm 896 */
										obj_t BgL_zc3z04anonymousza32039ze3z87_13658;

										BgL_zc3z04anonymousza32039ze3z87_13658 =
											MAKE_FX_PROCEDURE
											(BGl_z62zc3z04anonymousza32039ze3ze5zz__evaluate_compz00,
											(int) (((long) 1)), (int) (((long) 5)));
										PROCEDURE_SET(BgL_zc3z04anonymousza32039ze3z87_13658,
											(int) (((long) 0)), BgL_funz00_148);
										PROCEDURE_SET(BgL_zc3z04anonymousza32039ze3z87_13658,
											(int) (((long) 1)), BgL_a1z00_152);
										PROCEDURE_SET(BgL_zc3z04anonymousza32039ze3z87_13658,
											(int) (((long) 2)), BgL_locz00_145);
										PROCEDURE_SET(BgL_zc3z04anonymousza32039ze3z87_13658,
											(int) (((long) 3)), BgL_symbzd2funzd2_147);
										PROCEDURE_SET(BgL_zc3z04anonymousza32039ze3z87_13658,
											(int) (((long) 4)), BINT(BgL_siza7eza7_151));
										return BgL_zc3z04anonymousza32039ze3z87_13658;
									}
								else
									{	/* Eval/evaluate_comp.scm 896 */
										obj_t BgL_zc3z04anonymousza32060ze3z87_13659;

										BgL_zc3z04anonymousza32060ze3z87_13659 =
											MAKE_FX_PROCEDURE
											(BGl_z62zc3z04anonymousza32060ze3ze5zz__evaluate_compz00,
											(int) (((long) 1)), (int) (((long) 5)));
										PROCEDURE_SET(BgL_zc3z04anonymousza32060ze3z87_13659,
											(int) (((long) 0)), BgL_funz00_148);
										PROCEDURE_SET(BgL_zc3z04anonymousza32060ze3z87_13659,
											(int) (((long) 1)), BgL_a1z00_152);
										PROCEDURE_SET(BgL_zc3z04anonymousza32060ze3z87_13659,
											(int) (((long) 2)), BgL_locz00_145);
										PROCEDURE_SET(BgL_zc3z04anonymousza32060ze3z87_13659,
											(int) (((long) 3)), BgL_symbzd2funzd2_147);
										PROCEDURE_SET(BgL_zc3z04anonymousza32060ze3z87_13659,
											(int) (((long) 4)), BINT(BgL_siza7eza7_151));
										return BgL_zc3z04anonymousza32060ze3z87_13659;
									}
							}
					}
			}
		}

	}



/* &<@anonymous:1989> */
	obj_t BGl_z62zc3z04anonymousza31989ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_13660, obj_t BgL_sz00_13665)
	{
		{	/* Eval/evaluate_comp.scm 896 */
			{	/* Eval/evaluate_comp.scm 896 */
				obj_t BgL_a1z00_13661;
				long BgL_siza7eza7_13662;
				obj_t BgL_locz00_13663;
				obj_t BgL_cfunz00_13664;

				BgL_a1z00_13661 = PROCEDURE_REF(BgL_envz00_13660, (int) (((long) 0)));
				BgL_siza7eza7_13662 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13660, (int) (((long) 1))));
				BgL_locz00_13663 = PROCEDURE_REF(BgL_envz00_13660, (int) (((long) 2)));
				BgL_cfunz00_13664 = PROCEDURE_REF(BgL_envz00_13660, (int) (((long) 3)));
				{	/* Eval/evaluate_comp.scm 896 */
					obj_t BgL_bpz00_15790;

					BgL_bpz00_15790 = VECTOR_REF(((obj_t) BgL_sz00_13665), ((long) 0));
					{	/* Eval/evaluate_comp.scm 896 */
						obj_t BgL_a1z00_15791;

						BgL_a1z00_15791 =
							PROCEDURE_ENTRY(BgL_a1z00_13661) (BgL_a1z00_13661, BgL_sz00_13665,
							BEOA);
						{	/* Eval/evaluate_comp.scm 896 */
							long BgL_nbpz00_15792;

							BgL_nbpz00_15792 =
								((long) CINT(BgL_bpz00_15790) + BgL_siza7eza7_13662);
							VECTOR_SET(
								((obj_t) BgL_sz00_13665), ((long) 0), BINT(BgL_nbpz00_15792));
							{	/* Eval/evaluate_comp.scm 896 */
								obj_t BgL_tmpz00_20398;

								BgL_tmpz00_20398 = BGL_CURRENT_DYNAMIC_ENV();
								BGL_ENV_SET_TRACE_LOCATION(BgL_tmpz00_20398, BgL_locz00_13663);
							}
							{	/* Eval/evaluate_comp.scm 896 */
								obj_t BgL_rz00_15793;

								BgL_rz00_15793 =
									PROCEDURE_ENTRY(BgL_cfunz00_13664) (BgL_cfunz00_13664,
									BgL_a1z00_15791, BEOA);
								VECTOR_SET(((obj_t) BgL_sz00_13665), ((long) 0),
									BgL_bpz00_15790);
								return BgL_rz00_15793;
							}
						}
					}
				}
			}
		}

	}



/* &<@anonymous:1991> */
	obj_t BGl_z62zc3z04anonymousza31991ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_13666, obj_t BgL_sz00_13670)
	{
		{	/* Eval/evaluate_comp.scm 896 */
			{	/* Eval/evaluate_comp.scm 896 */
				obj_t BgL_a1z00_13667;
				long BgL_siza7eza7_13668;
				obj_t BgL_cfunz00_13669;

				BgL_a1z00_13667 = PROCEDURE_REF(BgL_envz00_13666, (int) (((long) 0)));
				BgL_siza7eza7_13668 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13666, (int) (((long) 1))));
				BgL_cfunz00_13669 = PROCEDURE_REF(BgL_envz00_13666, (int) (((long) 2)));
				{	/* Eval/evaluate_comp.scm 896 */
					obj_t BgL_bpz00_15794;

					BgL_bpz00_15794 = VECTOR_REF(((obj_t) BgL_sz00_13670), ((long) 0));
					{	/* Eval/evaluate_comp.scm 896 */
						obj_t BgL_a1z00_15795;

						BgL_a1z00_15795 =
							PROCEDURE_ENTRY(BgL_a1z00_13667) (BgL_a1z00_13667, BgL_sz00_13670,
							BEOA);
						{	/* Eval/evaluate_comp.scm 896 */
							long BgL_nbpz00_15796;

							BgL_nbpz00_15796 =
								((long) CINT(BgL_bpz00_15794) + BgL_siza7eza7_13668);
							VECTOR_SET(
								((obj_t) BgL_sz00_13670), ((long) 0), BINT(BgL_nbpz00_15796));
							{	/* Eval/evaluate_comp.scm 896 */
								obj_t BgL_rz00_15797;

								BgL_rz00_15797 =
									PROCEDURE_ENTRY(BgL_cfunz00_13669) (BgL_cfunz00_13669,
									BgL_a1z00_15795, BEOA);
								VECTOR_SET(((obj_t) BgL_sz00_13670), ((long) 0),
									BgL_bpz00_15794);
								return BgL_rz00_15797;
							}
						}
					}
				}
			}
		}

	}



/* &<@anonymous:1996> */
	obj_t BGl_z62zc3z04anonymousza31996ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_13671, obj_t BgL_sz00_13677)
	{
		{	/* Eval/evaluate_comp.scm 896 */
			{	/* Eval/evaluate_comp.scm 896 */
				obj_t BgL_funz00_13672;
				obj_t BgL_a1z00_13673;
				obj_t BgL_locz00_13674;
				obj_t BgL_symbzd2funzd2_13675;
				long BgL_siza7eza7_13676;

				BgL_funz00_13672 = PROCEDURE_REF(BgL_envz00_13671, (int) (((long) 0)));
				BgL_a1z00_13673 = PROCEDURE_REF(BgL_envz00_13671, (int) (((long) 1)));
				BgL_locz00_13674 = PROCEDURE_REF(BgL_envz00_13671, (int) (((long) 2)));
				BgL_symbzd2funzd2_13675 =
					PROCEDURE_REF(BgL_envz00_13671, (int) (((long) 3)));
				BgL_siza7eza7_13676 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13671, (int) (((long) 4))));
				{	/* Eval/evaluate_comp.scm 896 */
					obj_t BgL_bpz00_15798;

					BgL_bpz00_15798 = VECTOR_REF(((obj_t) BgL_sz00_13677), ((long) 0));
					{	/* Eval/evaluate_comp.scm 896 */
						obj_t BgL_fz00_15799;
						obj_t BgL_a1z00_15800;

						BgL_fz00_15799 =
							PROCEDURE_ENTRY(BgL_funz00_13672) (BgL_funz00_13672,
							BgL_sz00_13677, BEOA);
						BgL_a1z00_15800 =
							PROCEDURE_ENTRY(BgL_a1z00_13673) (BgL_a1z00_13673, BgL_sz00_13677,
							BEOA);
						if (PROCEDUREP(BgL_fz00_15799))
							{	/* Eval/evaluate_comp.scm 896 */
								BFALSE;
							}
						else
							{	/* Eval/evaluate_comp.scm 896 */
								BGl_evtypezd2errorzd2zz__everrorz00(BgL_locz00_13674,
									BGl_string5807z00zz__evaluate_compz00,
									BGl_string5823z00zz__evaluate_compz00, BgL_fz00_15799);
							}
						{	/* Eval/evaluate_comp.scm 896 */
							obj_t BgL_ufz00_15801;

							{	/* Eval/evaluate_comp.scm 896 */
								obj_t BgL_tmpz00_20455;

								BgL_tmpz00_20455 = ((obj_t) BgL_fz00_15799);
								BgL_ufz00_15801 = PROCEDURE_ATTR(BgL_tmpz00_20455);
							}
							{	/* Eval/evaluate_comp.scm 896 */
								bool_t BgL_test6236z00_20458;

								if (STRUCTP(BgL_ufz00_15801))
									{	/* Eval/evaluate_comp.scm 683 */
										BgL_test6236z00_20458 =
											(STRUCT_KEY(BgL_ufz00_15801) ==
											BGl_symbol5824z00zz__evaluate_compz00);
									}
								else
									{	/* Eval/evaluate_comp.scm 683 */
										BgL_test6236z00_20458 = ((bool_t) 0);
									}
								if (BgL_test6236z00_20458)
									{	/* Eval/evaluate_comp.scm 896 */
										obj_t BgL_arityz00_15802;
										obj_t BgL_runz00_15803;
										obj_t BgL_sfz00_15804;

										BgL_arityz00_15802 =
											STRUCT_REF(BgL_ufz00_15801, (int) (((long) 0)));
										BgL_runz00_15803 =
											STRUCT_REF(BgL_ufz00_15801, (int) (((long) 1)));
										BgL_sfz00_15804 =
											STRUCT_REF(BgL_ufz00_15801, (int) (((long) 2)));
										if (((long) CINT(BgL_arityz00_15802) == ((long) 1)))
											{	/* Eval/evaluate_comp.scm 896 */
												long BgL_arg2001z00_15805;

												BgL_arg2001z00_15805 =
													((long) CINT(BgL_bpz00_15798) + ((long) 0));
												VECTOR_SET(
													((obj_t) BgL_sz00_13677), BgL_arg2001z00_15805,
													BgL_a1z00_15800);
											}
										else
											{	/* Eval/evaluate_comp.scm 896 */
												if (INTEGERP(BgL_arityz00_15802))
													{	/* Eval/evaluate_comp.scm 896 */
														switch ((long) CINT(BgL_arityz00_15802))
															{
															case ((long) -1):

																{	/* Eval/evaluate_comp.scm 896 */
																	long BgL_arg2003z00_15806;
																	obj_t BgL_arg2004z00_15807;

																	BgL_arg2003z00_15806 =
																		((long) CINT(BgL_bpz00_15798) + ((long) 0));
																	{	/* Eval/evaluate_comp.scm 896 */
																		obj_t BgL_list2005z00_15808;

																		BgL_list2005z00_15808 =
																			MAKE_YOUNG_PAIR(BgL_a1z00_15800, BNIL);
																		BgL_arg2004z00_15807 =
																			BgL_list2005z00_15808;
																	}
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13677),
																		BgL_arg2003z00_15806, BgL_arg2004z00_15807);
																} break;
															case ((long) -2):

																{	/* Eval/evaluate_comp.scm 896 */
																	long BgL_arg2006z00_15809;

																	BgL_arg2006z00_15809 =
																		((long) CINT(BgL_bpz00_15798) + ((long) 0));
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13677),
																		BgL_arg2006z00_15809, BgL_a1z00_15800);
																}
																{	/* Eval/evaluate_comp.scm 896 */
																	long BgL_arg2007z00_15810;
																	obj_t BgL_arg2008z00_15811;

																	BgL_arg2007z00_15810 =
																		((long) CINT(BgL_bpz00_15798) + ((long) 1));
																	BgL_arg2008z00_15811 = BNIL;
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13677),
																		BgL_arg2007z00_15810, BgL_arg2008z00_15811);
																} break;
															default:
																BGl_evarityzd2errorzd2zz__everrorz00
																	(BgL_locz00_13674, STRUCT_REF(BgL_ufz00_15801,
																		(int) (((long) 3))), (int) (((long) 1)),
																	CINT(BgL_arityz00_15802));
													}}
												else
													{	/* Eval/evaluate_comp.scm 896 */
														BGl_evarityzd2errorzd2zz__everrorz00
															(BgL_locz00_13674, STRUCT_REF(BgL_ufz00_15801,
																(int) (((long) 3))), (int) (((long) 1)),
															CINT(BgL_arityz00_15802));
											}}
										{	/* Eval/evaluate_comp.scm 896 */
											obj_t BgL_z12denvz12_15812;

											BgL_z12denvz12_15812 = BGL_CURRENT_DYNAMIC_ENV();
											BGL_ENV_SET_TRACE_LOCATION(BgL_z12denvz12_15812,
												BgL_locz00_13674);
											if ((((long) CINT(BgL_bpz00_15798) +
														(long) CINT(BgL_sfz00_15804)) <
													VECTOR_LENGTH(((obj_t) BgL_sz00_13677))))
												{	/* Eval/evaluate_comp.scm 896 */
													return BgL_runz00_15803;
												}
											else
												{	/* Eval/evaluate_comp.scm 896 */
													obj_t BgL_nsz00_15813;

													BgL_nsz00_15813 =
														BGl_makezd2statezd2zz__evaluate_compz00();
													{	/* Eval/evaluate_comp.scm 896 */
														long BgL_arg2012z00_15814;

														BgL_arg2012z00_15814 =
															((long) CINT(BgL_bpz00_15798) + ((long) 1));
														BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00
															(BgL_nsz00_15813, ((long) 2), BgL_sz00_13677,
															BgL_bpz00_15798, BINT(BgL_arg2012z00_15814));
													}
													VECTOR_SET(BgL_nsz00_15813, ((long) 1),
														BgL_sz00_13677);
													BGL_ENV_EVSTATE_SET(BgL_z12denvz12_15812,
														BgL_nsz00_15813);
													{	/* Eval/evaluate_comp.scm 896 */
														obj_t BgL_ez00_15815;

														BgL_ez00_15815 = BGL_EXITD_TOP_AS_OBJ();
														BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
															(BgL_ez00_15815, BgL_sz00_13677);
														{	/* Eval/evaluate_comp.scm 896 */
															obj_t BgL_____rz00_15816;

															{	/* Eval/evaluate_comp.scm 670 */
																obj_t BgL_savedzd2bpzd2_15817;

																BgL_savedzd2bpzd2_15817 =
																	VECTOR_REF(BgL_nsz00_15813, ((long) 0));
																VECTOR_SET(BgL_nsz00_15813, ((long) 0),
																	BINT(((long) 2)));
																{
																	obj_t BgL_fz00_15819;

																	BgL_fz00_15819 = BgL_runz00_15803;
																BgL_recz00_15818:
																	{	/* Eval/evaluate_comp.scm 673 */
																		obj_t BgL_rz00_15820;

																		BgL_rz00_15820 =
																			PROCEDURE_ENTRY(BgL_fz00_15819)
																			(BgL_fz00_15819, BgL_nsz00_15813, BEOA);
																		{	/* Eval/evaluate_comp.scm 674 */
																			bool_t BgL_test6241z00_20528;

																			if (PROCEDUREP(BgL_rz00_15820))
																				{	/* Eval/evaluate_comp.scm 674 */
																					obj_t BgL_arg1702z00_15821;

																					BgL_arg1702z00_15821 =
																						PROCEDURE_ATTR(BgL_rz00_15820);
																					if (STRUCTP(BgL_arg1702z00_15821))
																						{	/* Eval/evaluate_comp.scm 654 */
																							BgL_test6241z00_20528 =
																								(STRUCT_KEY
																								(BgL_arg1702z00_15821) ==
																								BGl_symbol5803z00zz__evaluate_compz00);
																						}
																					else
																						{	/* Eval/evaluate_comp.scm 654 */
																							BgL_test6241z00_20528 =
																								((bool_t) 0);
																						}
																				}
																			else
																				{	/* Eval/evaluate_comp.scm 674 */
																					BgL_test6241z00_20528 = ((bool_t) 0);
																				}
																			if (BgL_test6241z00_20528)
																				{
																					obj_t BgL_fz00_20536;

																					BgL_fz00_20536 = BgL_rz00_15820;
																					BgL_fz00_15819 = BgL_fz00_20536;
																					goto BgL_recz00_15818;
																				}
																			else
																				{	/* Eval/evaluate_comp.scm 674 */
																					VECTOR_SET(BgL_nsz00_15813,
																						((long) 0),
																						BgL_savedzd2bpzd2_15817);
																					BgL_____rz00_15816 = BgL_rz00_15820;
															}}}}}
															BGl_exitdzd2popzd2protectz12z12zz__bexitz00
																(BgL_ez00_15815);
															BGL_ENV_EVSTATE_SET(BgL_z12denvz12_15812,
																BgL_sz00_13677);
															return BgL_____rz00_15816;
														}
													}
												}
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 896 */
										if (PROCEDURE_CORRECT_ARITYP(BgL_fz00_15799,
												(int) (((long) 1))))
											{	/* Eval/evaluate_comp.scm 896 */
												long BgL_nbpz00_15822;

												BgL_nbpz00_15822 =
													((long) CINT(BgL_bpz00_15798) + BgL_siza7eza7_13676);
												VECTOR_SET(
													((obj_t) BgL_sz00_13677), ((long) 0),
													BINT(BgL_nbpz00_15822));
												{	/* Eval/evaluate_comp.scm 896 */
													obj_t BgL_tmpz00_20548;

													BgL_tmpz00_20548 = BGL_CURRENT_DYNAMIC_ENV();
													BGL_ENV_SET_TRACE_LOCATION(BgL_tmpz00_20548,
														BgL_locz00_13674);
												}
												{	/* Eval/evaluate_comp.scm 896 */
													obj_t BgL_rz00_15823;

													BgL_rz00_15823 =
														PROCEDURE_ENTRY(BgL_fz00_15799) (BgL_fz00_15799,
														BgL_a1z00_15800, BEOA);
													VECTOR_SET(((obj_t) BgL_sz00_13677), ((long) 0),
														BgL_bpz00_15798);
													return BgL_rz00_15823;
												}
											}
										else
											{	/* Eval/evaluate_comp.scm 896 */
												return
													BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_13674,
													BgL_symbzd2funzd2_13675, (int) (((long) 1)),
													PROCEDURE_ARITY(BgL_fz00_15799));
		}}}}}}}}

	}



/* &<@anonymous:2017> */
	obj_t BGl_z62zc3z04anonymousza32017ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_13678, obj_t BgL_sz00_13684)
	{
		{	/* Eval/evaluate_comp.scm 896 */
			{	/* Eval/evaluate_comp.scm 896 */
				obj_t BgL_funz00_13679;
				obj_t BgL_a1z00_13680;
				obj_t BgL_locz00_13681;
				obj_t BgL_symbzd2funzd2_13682;
				long BgL_siza7eza7_13683;

				BgL_funz00_13679 = PROCEDURE_REF(BgL_envz00_13678, (int) (((long) 0)));
				BgL_a1z00_13680 = PROCEDURE_REF(BgL_envz00_13678, (int) (((long) 1)));
				BgL_locz00_13681 = PROCEDURE_REF(BgL_envz00_13678, (int) (((long) 2)));
				BgL_symbzd2funzd2_13682 =
					PROCEDURE_REF(BgL_envz00_13678, (int) (((long) 3)));
				BgL_siza7eza7_13683 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13678, (int) (((long) 4))));
				{	/* Eval/evaluate_comp.scm 896 */
					obj_t BgL_bpz00_15824;

					BgL_bpz00_15824 = VECTOR_REF(((obj_t) BgL_sz00_13684), ((long) 0));
					{	/* Eval/evaluate_comp.scm 896 */
						obj_t BgL_fz00_15825;
						obj_t BgL_a1z00_15826;

						BgL_fz00_15825 =
							PROCEDURE_ENTRY(BgL_funz00_13679) (BgL_funz00_13679,
							BgL_sz00_13684, BEOA);
						BgL_a1z00_15826 =
							PROCEDURE_ENTRY(BgL_a1z00_13680) (BgL_a1z00_13680, BgL_sz00_13684,
							BEOA);
						if (PROCEDUREP(BgL_fz00_15825))
							{	/* Eval/evaluate_comp.scm 896 */
								BFALSE;
							}
						else
							{	/* Eval/evaluate_comp.scm 896 */
								BGl_evtypezd2errorzd2zz__everrorz00(BgL_locz00_13681,
									BGl_string5807z00zz__evaluate_compz00,
									BGl_string5823z00zz__evaluate_compz00, BgL_fz00_15825);
							}
						{	/* Eval/evaluate_comp.scm 896 */
							obj_t BgL_ufz00_15827;

							{	/* Eval/evaluate_comp.scm 896 */
								obj_t BgL_tmpz00_20584;

								BgL_tmpz00_20584 = ((obj_t) BgL_fz00_15825);
								BgL_ufz00_15827 = PROCEDURE_ATTR(BgL_tmpz00_20584);
							}
							{	/* Eval/evaluate_comp.scm 896 */
								bool_t BgL_test6246z00_20587;

								if (STRUCTP(BgL_ufz00_15827))
									{	/* Eval/evaluate_comp.scm 683 */
										BgL_test6246z00_20587 =
											(STRUCT_KEY(BgL_ufz00_15827) ==
											BGl_symbol5824z00zz__evaluate_compz00);
									}
								else
									{	/* Eval/evaluate_comp.scm 683 */
										BgL_test6246z00_20587 = ((bool_t) 0);
									}
								if (BgL_test6246z00_20587)
									{	/* Eval/evaluate_comp.scm 896 */
										obj_t BgL_arityz00_15828;
										obj_t BgL_runz00_15829;
										obj_t BgL_sfz00_15830;

										BgL_arityz00_15828 =
											STRUCT_REF(BgL_ufz00_15827, (int) (((long) 0)));
										BgL_runz00_15829 =
											STRUCT_REF(BgL_ufz00_15827, (int) (((long) 1)));
										BgL_sfz00_15830 =
											STRUCT_REF(BgL_ufz00_15827, (int) (((long) 2)));
										if (((long) CINT(BgL_arityz00_15828) == ((long) 1)))
											{	/* Eval/evaluate_comp.scm 896 */
												long BgL_arg2021z00_15831;

												BgL_arg2021z00_15831 =
													((long) CINT(BgL_bpz00_15824) + ((long) 0));
												VECTOR_SET(
													((obj_t) BgL_sz00_13684), BgL_arg2021z00_15831,
													BgL_a1z00_15826);
											}
										else
											{	/* Eval/evaluate_comp.scm 896 */
												if (INTEGERP(BgL_arityz00_15828))
													{	/* Eval/evaluate_comp.scm 896 */
														switch ((long) CINT(BgL_arityz00_15828))
															{
															case ((long) -1):

																{	/* Eval/evaluate_comp.scm 896 */
																	long BgL_arg2023z00_15832;
																	obj_t BgL_arg2024z00_15833;

																	BgL_arg2023z00_15832 =
																		((long) CINT(BgL_bpz00_15824) + ((long) 0));
																	{	/* Eval/evaluate_comp.scm 896 */
																		obj_t BgL_list2025z00_15834;

																		BgL_list2025z00_15834 =
																			MAKE_YOUNG_PAIR(BgL_a1z00_15826, BNIL);
																		BgL_arg2024z00_15833 =
																			BgL_list2025z00_15834;
																	}
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13684),
																		BgL_arg2023z00_15832, BgL_arg2024z00_15833);
																} break;
															case ((long) -2):

																{	/* Eval/evaluate_comp.scm 896 */
																	long BgL_arg2026z00_15835;

																	BgL_arg2026z00_15835 =
																		((long) CINT(BgL_bpz00_15824) + ((long) 0));
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13684),
																		BgL_arg2026z00_15835, BgL_a1z00_15826);
																}
																{	/* Eval/evaluate_comp.scm 896 */
																	long BgL_arg2027z00_15836;
																	obj_t BgL_arg2028z00_15837;

																	BgL_arg2027z00_15836 =
																		((long) CINT(BgL_bpz00_15824) + ((long) 1));
																	BgL_arg2028z00_15837 = BNIL;
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13684),
																		BgL_arg2027z00_15836, BgL_arg2028z00_15837);
																} break;
															default:
																BGl_evarityzd2errorzd2zz__everrorz00
																	(BgL_locz00_13681, STRUCT_REF(BgL_ufz00_15827,
																		(int) (((long) 3))), (int) (((long) 1)),
																	CINT(BgL_arityz00_15828));
													}}
												else
													{	/* Eval/evaluate_comp.scm 896 */
														BGl_evarityzd2errorzd2zz__everrorz00
															(BgL_locz00_13681, STRUCT_REF(BgL_ufz00_15827,
																(int) (((long) 3))), (int) (((long) 1)),
															CINT(BgL_arityz00_15828));
											}}
										{	/* Eval/evaluate_comp.scm 896 */
											obj_t BgL_z12denvz12_15838;

											BgL_z12denvz12_15838 = BGL_CURRENT_DYNAMIC_ENV();
											if (
												(((long) CINT(BgL_bpz00_15824) +
														(long) CINT(BgL_sfz00_15830)) <
													VECTOR_LENGTH(((obj_t) BgL_sz00_13684))))
												{	/* Eval/evaluate_comp.scm 896 */
													return BgL_runz00_15829;
												}
											else
												{	/* Eval/evaluate_comp.scm 896 */
													obj_t BgL_nsz00_15839;

													BgL_nsz00_15839 =
														BGl_makezd2statezd2zz__evaluate_compz00();
													{	/* Eval/evaluate_comp.scm 896 */
														long BgL_arg2032z00_15840;

														BgL_arg2032z00_15840 =
															((long) CINT(BgL_bpz00_15824) + ((long) 1));
														BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00
															(BgL_nsz00_15839, ((long) 2), BgL_sz00_13684,
															BgL_bpz00_15824, BINT(BgL_arg2032z00_15840));
													}
													VECTOR_SET(BgL_nsz00_15839, ((long) 1),
														BgL_sz00_13684);
													BGL_ENV_EVSTATE_SET(BgL_z12denvz12_15838,
														BgL_nsz00_15839);
													{	/* Eval/evaluate_comp.scm 896 */
														obj_t BgL_ez00_15841;

														BgL_ez00_15841 = BGL_EXITD_TOP_AS_OBJ();
														BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
															(BgL_ez00_15841, BgL_sz00_13684);
														{	/* Eval/evaluate_comp.scm 896 */
															obj_t BgL_____rz00_15842;

															{	/* Eval/evaluate_comp.scm 670 */
																obj_t BgL_savedzd2bpzd2_15843;

																BgL_savedzd2bpzd2_15843 =
																	VECTOR_REF(BgL_nsz00_15839, ((long) 0));
																VECTOR_SET(BgL_nsz00_15839, ((long) 0),
																	BINT(((long) 2)));
																{
																	obj_t BgL_fz00_15845;

																	BgL_fz00_15845 = BgL_runz00_15829;
																BgL_recz00_15844:
																	{	/* Eval/evaluate_comp.scm 673 */
																		obj_t BgL_rz00_15846;

																		BgL_rz00_15846 =
																			PROCEDURE_ENTRY(BgL_fz00_15845)
																			(BgL_fz00_15845, BgL_nsz00_15839, BEOA);
																		{	/* Eval/evaluate_comp.scm 674 */
																			bool_t BgL_test6251z00_20656;

																			if (PROCEDUREP(BgL_rz00_15846))
																				{	/* Eval/evaluate_comp.scm 674 */
																					obj_t BgL_arg1702z00_15847;

																					BgL_arg1702z00_15847 =
																						PROCEDURE_ATTR(BgL_rz00_15846);
																					if (STRUCTP(BgL_arg1702z00_15847))
																						{	/* Eval/evaluate_comp.scm 654 */
																							BgL_test6251z00_20656 =
																								(STRUCT_KEY
																								(BgL_arg1702z00_15847) ==
																								BGl_symbol5803z00zz__evaluate_compz00);
																						}
																					else
																						{	/* Eval/evaluate_comp.scm 654 */
																							BgL_test6251z00_20656 =
																								((bool_t) 0);
																						}
																				}
																			else
																				{	/* Eval/evaluate_comp.scm 674 */
																					BgL_test6251z00_20656 = ((bool_t) 0);
																				}
																			if (BgL_test6251z00_20656)
																				{
																					obj_t BgL_fz00_20664;

																					BgL_fz00_20664 = BgL_rz00_15846;
																					BgL_fz00_15845 = BgL_fz00_20664;
																					goto BgL_recz00_15844;
																				}
																			else
																				{	/* Eval/evaluate_comp.scm 674 */
																					VECTOR_SET(BgL_nsz00_15839,
																						((long) 0),
																						BgL_savedzd2bpzd2_15843);
																					BgL_____rz00_15842 = BgL_rz00_15846;
															}}}}}
															BGl_exitdzd2popzd2protectz12z12zz__bexitz00
																(BgL_ez00_15841);
															BGL_ENV_EVSTATE_SET(BgL_z12denvz12_15838,
																BgL_sz00_13684);
															return BgL_____rz00_15842;
														}
													}
												}
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 896 */
										if (PROCEDURE_CORRECT_ARITYP(BgL_fz00_15825,
												(int) (((long) 1))))
											{	/* Eval/evaluate_comp.scm 896 */
												long BgL_nbpz00_15848;

												BgL_nbpz00_15848 =
													((long) CINT(BgL_bpz00_15824) + BgL_siza7eza7_13683);
												VECTOR_SET(
													((obj_t) BgL_sz00_13684), ((long) 0),
													BINT(BgL_nbpz00_15848));
												{	/* Eval/evaluate_comp.scm 896 */
													obj_t BgL_rz00_15849;

													BgL_rz00_15849 =
														PROCEDURE_ENTRY(BgL_fz00_15825) (BgL_fz00_15825,
														BgL_a1z00_15826, BEOA);
													VECTOR_SET(((obj_t) BgL_sz00_13684), ((long) 0),
														BgL_bpz00_15824);
													return BgL_rz00_15849;
												}
											}
										else
											{	/* Eval/evaluate_comp.scm 896 */
												return
													BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_13681,
													BgL_symbzd2funzd2_13682, (int) (((long) 1)),
													PROCEDURE_ARITY(BgL_fz00_15825));
		}}}}}}}}

	}



/* &<@anonymous:2039> */
	obj_t BGl_z62zc3z04anonymousza32039ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_13685, obj_t BgL_sz00_13691)
	{
		{	/* Eval/evaluate_comp.scm 896 */
			{	/* Eval/evaluate_comp.scm 896 */
				obj_t BgL_funz00_13686;
				obj_t BgL_a1z00_13687;
				obj_t BgL_locz00_13688;
				obj_t BgL_symbzd2funzd2_13689;
				long BgL_siza7eza7_13690;

				BgL_funz00_13686 = PROCEDURE_REF(BgL_envz00_13685, (int) (((long) 0)));
				BgL_a1z00_13687 = PROCEDURE_REF(BgL_envz00_13685, (int) (((long) 1)));
				BgL_locz00_13688 = PROCEDURE_REF(BgL_envz00_13685, (int) (((long) 2)));
				BgL_symbzd2funzd2_13689 =
					PROCEDURE_REF(BgL_envz00_13685, (int) (((long) 3)));
				BgL_siza7eza7_13690 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13685, (int) (((long) 4))));
				{	/* Eval/evaluate_comp.scm 896 */
					obj_t BgL_bpz00_15850;

					BgL_bpz00_15850 = VECTOR_REF(((obj_t) BgL_sz00_13691), ((long) 0));
					{	/* Eval/evaluate_comp.scm 896 */
						obj_t BgL_fz00_15851;
						obj_t BgL_a1z00_15852;

						BgL_fz00_15851 =
							PROCEDURE_ENTRY(BgL_funz00_13686) (BgL_funz00_13686,
							BgL_sz00_13691, BEOA);
						BgL_a1z00_15852 =
							PROCEDURE_ENTRY(BgL_a1z00_13687) (BgL_a1z00_13687, BgL_sz00_13691,
							BEOA);
						if (PROCEDUREP(BgL_fz00_15851))
							{	/* Eval/evaluate_comp.scm 896 */
								BFALSE;
							}
						else
							{	/* Eval/evaluate_comp.scm 896 */
								BGl_evtypezd2errorzd2zz__everrorz00(BgL_locz00_13688,
									BGl_string5807z00zz__evaluate_compz00,
									BGl_string5823z00zz__evaluate_compz00, BgL_fz00_15851);
							}
						{	/* Eval/evaluate_comp.scm 896 */
							obj_t BgL_ufz00_15853;

							{	/* Eval/evaluate_comp.scm 896 */
								obj_t BgL_tmpz00_20709;

								BgL_tmpz00_20709 = ((obj_t) BgL_fz00_15851);
								BgL_ufz00_15853 = PROCEDURE_ATTR(BgL_tmpz00_20709);
							}
							{	/* Eval/evaluate_comp.scm 896 */
								bool_t BgL_test6256z00_20712;

								if (STRUCTP(BgL_ufz00_15853))
									{	/* Eval/evaluate_comp.scm 683 */
										BgL_test6256z00_20712 =
											(STRUCT_KEY(BgL_ufz00_15853) ==
											BGl_symbol5824z00zz__evaluate_compz00);
									}
								else
									{	/* Eval/evaluate_comp.scm 683 */
										BgL_test6256z00_20712 = ((bool_t) 0);
									}
								if (BgL_test6256z00_20712)
									{	/* Eval/evaluate_comp.scm 896 */
										obj_t BgL_arityz00_15854;
										obj_t BgL_runz00_15855;
										obj_t BgL_sfz00_15856;

										BgL_arityz00_15854 =
											STRUCT_REF(BgL_ufz00_15853, (int) (((long) 0)));
										BgL_runz00_15855 =
											STRUCT_REF(BgL_ufz00_15853, (int) (((long) 1)));
										BgL_sfz00_15856 =
											STRUCT_REF(BgL_ufz00_15853, (int) (((long) 2)));
										{	/* Eval/evaluate_comp.scm 896 */
											long BgL_spz00_15857;

											BgL_spz00_15857 =
												((long) CINT(BgL_bpz00_15850) + BgL_siza7eza7_13690);
											if (((long) CINT(BgL_arityz00_15854) == ((long) 1)))
												{	/* Eval/evaluate_comp.scm 896 */
													long BgL_arg2043z00_15858;

													BgL_arg2043z00_15858 = (BgL_spz00_15857 + ((long) 0));
													VECTOR_SET(
														((obj_t) BgL_sz00_13691), BgL_arg2043z00_15858,
														BgL_a1z00_15852);
												}
											else
												{	/* Eval/evaluate_comp.scm 896 */
													if (INTEGERP(BgL_arityz00_15854))
														{	/* Eval/evaluate_comp.scm 896 */
															switch ((long) CINT(BgL_arityz00_15854))
																{
																case ((long) -1):

																	{	/* Eval/evaluate_comp.scm 896 */
																		long BgL_arg2045z00_15859;
																		obj_t BgL_arg2047z00_15860;

																		BgL_arg2045z00_15859 =
																			(BgL_spz00_15857 + ((long) 0));
																		{	/* Eval/evaluate_comp.scm 896 */
																			obj_t BgL_list2048z00_15861;

																			BgL_list2048z00_15861 =
																				MAKE_YOUNG_PAIR(BgL_a1z00_15852, BNIL);
																			BgL_arg2047z00_15860 =
																				BgL_list2048z00_15861;
																		}
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13691),
																			BgL_arg2045z00_15859,
																			BgL_arg2047z00_15860);
																	} break;
																case ((long) -2):

																	{	/* Eval/evaluate_comp.scm 896 */
																		long BgL_arg2049z00_15862;

																		BgL_arg2049z00_15862 =
																			(BgL_spz00_15857 + ((long) 0));
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13691),
																			BgL_arg2049z00_15862, BgL_a1z00_15852);
																	}
																	{	/* Eval/evaluate_comp.scm 896 */
																		long BgL_arg2050z00_15863;
																		obj_t BgL_arg2051z00_15864;

																		BgL_arg2050z00_15863 =
																			(BgL_spz00_15857 + ((long) 1));
																		BgL_arg2051z00_15864 = BNIL;
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13691),
																			BgL_arg2050z00_15863,
																			BgL_arg2051z00_15864);
																	} break;
																default:
																	BGl_evarityzd2errorzd2zz__everrorz00
																		(BgL_locz00_13688,
																		STRUCT_REF(BgL_ufz00_15853,
																			(int) (((long) 3))), (int) (((long) 1)),
																		CINT(BgL_arityz00_15854));
														}}
													else
														{	/* Eval/evaluate_comp.scm 896 */
															BGl_evarityzd2errorzd2zz__everrorz00
																(BgL_locz00_13688, STRUCT_REF(BgL_ufz00_15853,
																	(int) (((long) 3))), (int) (((long) 1)),
																CINT(BgL_arityz00_15854));
												}}
											{	/* Eval/evaluate_comp.scm 896 */
												obj_t BgL_z12denvz12_15865;

												BgL_z12denvz12_15865 = BGL_CURRENT_DYNAMIC_ENV();
												BGL_ENV_SET_TRACE_LOCATION(BgL_z12denvz12_15865,
													BgL_locz00_13688);
												if (((BgL_spz00_15857 + (long) CINT(BgL_sfz00_15856)) <
														VECTOR_LENGTH(((obj_t) BgL_sz00_13691))))
													{	/* Eval/evaluate_comp.scm 896 */
														return
															BGl_catchzd2trampolinezd2zz__evaluate_compz00
															(BgL_runz00_15855, BgL_sz00_13691,
															BINT(BgL_spz00_15857));
													}
												else
													{	/* Eval/evaluate_comp.scm 896 */
														obj_t BgL_nsz00_15866;

														BgL_nsz00_15866 =
															BGl_makezd2statezd2zz__evaluate_compz00();
														{	/* Eval/evaluate_comp.scm 896 */
															long BgL_arg2056z00_15867;

															BgL_arg2056z00_15867 =
																(BgL_spz00_15857 + ((long) 1));
															BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00
																(BgL_nsz00_15866, ((long) 2), BgL_sz00_13691,
																BINT(BgL_spz00_15857),
																BINT(BgL_arg2056z00_15867));
														}
														VECTOR_SET(BgL_nsz00_15866, ((long) 1),
															BgL_sz00_13691);
														BGL_ENV_EVSTATE_SET(BgL_z12denvz12_15865,
															BgL_nsz00_15866);
														{	/* Eval/evaluate_comp.scm 896 */
															obj_t BgL_ez00_15868;

															BgL_ez00_15868 = BGL_EXITD_TOP_AS_OBJ();
															BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
																(BgL_ez00_15868, BgL_sz00_13691);
															{	/* Eval/evaluate_comp.scm 896 */
																obj_t BgL_____rz00_15869;

																{	/* Eval/evaluate_comp.scm 670 */
																	obj_t BgL_savedzd2bpzd2_15870;

																	BgL_savedzd2bpzd2_15870 =
																		VECTOR_REF(BgL_nsz00_15866, ((long) 0));
																	VECTOR_SET(BgL_nsz00_15866, ((long) 0),
																		BINT(((long) 2)));
																	{
																		obj_t BgL_fz00_15872;

																		BgL_fz00_15872 = BgL_runz00_15855;
																	BgL_recz00_15871:
																		{	/* Eval/evaluate_comp.scm 673 */
																			obj_t BgL_rz00_15873;

																			BgL_rz00_15873 =
																				PROCEDURE_ENTRY(BgL_fz00_15872)
																				(BgL_fz00_15872, BgL_nsz00_15866, BEOA);
																			{	/* Eval/evaluate_comp.scm 674 */
																				bool_t BgL_test6261z00_20781;

																				if (PROCEDUREP(BgL_rz00_15873))
																					{	/* Eval/evaluate_comp.scm 674 */
																						obj_t BgL_arg1702z00_15874;

																						BgL_arg1702z00_15874 =
																							PROCEDURE_ATTR(BgL_rz00_15873);
																						if (STRUCTP(BgL_arg1702z00_15874))
																							{	/* Eval/evaluate_comp.scm 654 */
																								BgL_test6261z00_20781 =
																									(STRUCT_KEY
																									(BgL_arg1702z00_15874) ==
																									BGl_symbol5803z00zz__evaluate_compz00);
																							}
																						else
																							{	/* Eval/evaluate_comp.scm 654 */
																								BgL_test6261z00_20781 =
																									((bool_t) 0);
																							}
																					}
																				else
																					{	/* Eval/evaluate_comp.scm 674 */
																						BgL_test6261z00_20781 =
																							((bool_t) 0);
																					}
																				if (BgL_test6261z00_20781)
																					{
																						obj_t BgL_fz00_20789;

																						BgL_fz00_20789 = BgL_rz00_15873;
																						BgL_fz00_15872 = BgL_fz00_20789;
																						goto BgL_recz00_15871;
																					}
																				else
																					{	/* Eval/evaluate_comp.scm 674 */
																						VECTOR_SET(BgL_nsz00_15866,
																							((long) 0),
																							BgL_savedzd2bpzd2_15870);
																						BgL_____rz00_15869 = BgL_rz00_15873;
																}}}}}
																BGl_exitdzd2popzd2protectz12z12zz__bexitz00
																	(BgL_ez00_15868);
																BGL_ENV_EVSTATE_SET(BgL_z12denvz12_15865,
																	BgL_sz00_13691);
																return BgL_____rz00_15869;
															}
														}
													}
											}
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 896 */
										if (PROCEDURE_CORRECT_ARITYP(BgL_fz00_15851,
												(int) (((long) 1))))
											{	/* Eval/evaluate_comp.scm 896 */
												long BgL_nbpz00_15875;

												BgL_nbpz00_15875 =
													((long) CINT(BgL_bpz00_15850) + BgL_siza7eza7_13690);
												VECTOR_SET(
													((obj_t) BgL_sz00_13691), ((long) 0),
													BINT(BgL_nbpz00_15875));
												{	/* Eval/evaluate_comp.scm 896 */
													obj_t BgL_tmpz00_20801;

													BgL_tmpz00_20801 = BGL_CURRENT_DYNAMIC_ENV();
													BGL_ENV_SET_TRACE_LOCATION(BgL_tmpz00_20801,
														BgL_locz00_13688);
												}
												{	/* Eval/evaluate_comp.scm 896 */
													obj_t BgL_rz00_15876;

													BgL_rz00_15876 =
														PROCEDURE_ENTRY(BgL_fz00_15851) (BgL_fz00_15851,
														BgL_a1z00_15852, BEOA);
													VECTOR_SET(((obj_t) BgL_sz00_13691), ((long) 0),
														BgL_bpz00_15850);
													return BgL_rz00_15876;
												}
											}
										else
											{	/* Eval/evaluate_comp.scm 896 */
												return
													BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_13688,
													BgL_symbzd2funzd2_13689, (int) (((long) 1)),
													PROCEDURE_ARITY(BgL_fz00_15851));
		}}}}}}}}

	}



/* &<@anonymous:2060> */
	obj_t BGl_z62zc3z04anonymousza32060ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_13692, obj_t BgL_sz00_13698)
	{
		{	/* Eval/evaluate_comp.scm 896 */
			{	/* Eval/evaluate_comp.scm 896 */
				obj_t BgL_funz00_13693;
				obj_t BgL_a1z00_13694;
				obj_t BgL_locz00_13695;
				obj_t BgL_symbzd2funzd2_13696;
				long BgL_siza7eza7_13697;

				BgL_funz00_13693 = PROCEDURE_REF(BgL_envz00_13692, (int) (((long) 0)));
				BgL_a1z00_13694 = PROCEDURE_REF(BgL_envz00_13692, (int) (((long) 1)));
				BgL_locz00_13695 = PROCEDURE_REF(BgL_envz00_13692, (int) (((long) 2)));
				BgL_symbzd2funzd2_13696 =
					PROCEDURE_REF(BgL_envz00_13692, (int) (((long) 3)));
				BgL_siza7eza7_13697 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13692, (int) (((long) 4))));
				{	/* Eval/evaluate_comp.scm 896 */
					obj_t BgL_bpz00_15877;

					BgL_bpz00_15877 = VECTOR_REF(((obj_t) BgL_sz00_13698), ((long) 0));
					{	/* Eval/evaluate_comp.scm 896 */
						obj_t BgL_fz00_15878;
						obj_t BgL_a1z00_15879;

						BgL_fz00_15878 =
							PROCEDURE_ENTRY(BgL_funz00_13693) (BgL_funz00_13693,
							BgL_sz00_13698, BEOA);
						BgL_a1z00_15879 =
							PROCEDURE_ENTRY(BgL_a1z00_13694) (BgL_a1z00_13694, BgL_sz00_13698,
							BEOA);
						if (PROCEDUREP(BgL_fz00_15878))
							{	/* Eval/evaluate_comp.scm 896 */
								BFALSE;
							}
						else
							{	/* Eval/evaluate_comp.scm 896 */
								BGl_evtypezd2errorzd2zz__everrorz00(BgL_locz00_13695,
									BGl_string5807z00zz__evaluate_compz00,
									BGl_string5823z00zz__evaluate_compz00, BgL_fz00_15878);
							}
						{	/* Eval/evaluate_comp.scm 896 */
							obj_t BgL_ufz00_15880;

							{	/* Eval/evaluate_comp.scm 896 */
								obj_t BgL_tmpz00_20837;

								BgL_tmpz00_20837 = ((obj_t) BgL_fz00_15878);
								BgL_ufz00_15880 = PROCEDURE_ATTR(BgL_tmpz00_20837);
							}
							{	/* Eval/evaluate_comp.scm 896 */
								bool_t BgL_test6266z00_20840;

								if (STRUCTP(BgL_ufz00_15880))
									{	/* Eval/evaluate_comp.scm 683 */
										BgL_test6266z00_20840 =
											(STRUCT_KEY(BgL_ufz00_15880) ==
											BGl_symbol5824z00zz__evaluate_compz00);
									}
								else
									{	/* Eval/evaluate_comp.scm 683 */
										BgL_test6266z00_20840 = ((bool_t) 0);
									}
								if (BgL_test6266z00_20840)
									{	/* Eval/evaluate_comp.scm 896 */
										obj_t BgL_arityz00_15881;
										obj_t BgL_runz00_15882;
										obj_t BgL_sfz00_15883;

										BgL_arityz00_15881 =
											STRUCT_REF(BgL_ufz00_15880, (int) (((long) 0)));
										BgL_runz00_15882 =
											STRUCT_REF(BgL_ufz00_15880, (int) (((long) 1)));
										BgL_sfz00_15883 =
											STRUCT_REF(BgL_ufz00_15880, (int) (((long) 2)));
										{	/* Eval/evaluate_comp.scm 896 */
											long BgL_spz00_15884;

											BgL_spz00_15884 =
												((long) CINT(BgL_bpz00_15877) + BgL_siza7eza7_13697);
											if (((long) CINT(BgL_arityz00_15881) == ((long) 1)))
												{	/* Eval/evaluate_comp.scm 896 */
													long BgL_arg2064z00_15885;

													BgL_arg2064z00_15885 = (BgL_spz00_15884 + ((long) 0));
													VECTOR_SET(
														((obj_t) BgL_sz00_13698), BgL_arg2064z00_15885,
														BgL_a1z00_15879);
												}
											else
												{	/* Eval/evaluate_comp.scm 896 */
													if (INTEGERP(BgL_arityz00_15881))
														{	/* Eval/evaluate_comp.scm 896 */
															switch ((long) CINT(BgL_arityz00_15881))
																{
																case ((long) -1):

																	{	/* Eval/evaluate_comp.scm 896 */
																		long BgL_arg2066z00_15886;
																		obj_t BgL_arg2067z00_15887;

																		BgL_arg2066z00_15886 =
																			(BgL_spz00_15884 + ((long) 0));
																		{	/* Eval/evaluate_comp.scm 896 */
																			obj_t BgL_list2068z00_15888;

																			BgL_list2068z00_15888 =
																				MAKE_YOUNG_PAIR(BgL_a1z00_15879, BNIL);
																			BgL_arg2067z00_15887 =
																				BgL_list2068z00_15888;
																		}
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13698),
																			BgL_arg2066z00_15886,
																			BgL_arg2067z00_15887);
																	} break;
																case ((long) -2):

																	{	/* Eval/evaluate_comp.scm 896 */
																		long BgL_arg2069z00_15889;

																		BgL_arg2069z00_15889 =
																			(BgL_spz00_15884 + ((long) 0));
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13698),
																			BgL_arg2069z00_15889, BgL_a1z00_15879);
																	}
																	{	/* Eval/evaluate_comp.scm 896 */
																		long BgL_arg2070z00_15890;
																		obj_t BgL_arg2072z00_15891;

																		BgL_arg2070z00_15890 =
																			(BgL_spz00_15884 + ((long) 1));
																		BgL_arg2072z00_15891 = BNIL;
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13698),
																			BgL_arg2070z00_15890,
																			BgL_arg2072z00_15891);
																	} break;
																default:
																	BGl_evarityzd2errorzd2zz__everrorz00
																		(BgL_locz00_13695,
																		STRUCT_REF(BgL_ufz00_15880,
																			(int) (((long) 3))), (int) (((long) 1)),
																		CINT(BgL_arityz00_15881));
														}}
													else
														{	/* Eval/evaluate_comp.scm 896 */
															BGl_evarityzd2errorzd2zz__everrorz00
																(BgL_locz00_13695, STRUCT_REF(BgL_ufz00_15880,
																	(int) (((long) 3))), (int) (((long) 1)),
																CINT(BgL_arityz00_15881));
												}}
											{	/* Eval/evaluate_comp.scm 896 */
												obj_t BgL_z12denvz12_15892;

												BgL_z12denvz12_15892 = BGL_CURRENT_DYNAMIC_ENV();
												if (
													((BgL_spz00_15884 +
															(long) CINT(BgL_sfz00_15883)) <
														VECTOR_LENGTH(((obj_t) BgL_sz00_13698))))
													{	/* Eval/evaluate_comp.scm 896 */
														return
															BGl_catchzd2trampolinezd2zz__evaluate_compz00
															(BgL_runz00_15882, BgL_sz00_13698,
															BINT(BgL_spz00_15884));
													}
												else
													{	/* Eval/evaluate_comp.scm 896 */
														obj_t BgL_nsz00_15893;

														BgL_nsz00_15893 =
															BGl_makezd2statezd2zz__evaluate_compz00();
														{	/* Eval/evaluate_comp.scm 896 */
															long BgL_arg2076z00_15894;

															BgL_arg2076z00_15894 =
																(BgL_spz00_15884 + ((long) 1));
															BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00
																(BgL_nsz00_15893, ((long) 2), BgL_sz00_13698,
																BINT(BgL_spz00_15884),
																BINT(BgL_arg2076z00_15894));
														}
														VECTOR_SET(BgL_nsz00_15893, ((long) 1),
															BgL_sz00_13698);
														BGL_ENV_EVSTATE_SET(BgL_z12denvz12_15892,
															BgL_nsz00_15893);
														{	/* Eval/evaluate_comp.scm 896 */
															obj_t BgL_ez00_15895;

															BgL_ez00_15895 = BGL_EXITD_TOP_AS_OBJ();
															BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
																(BgL_ez00_15895, BgL_sz00_13698);
															{	/* Eval/evaluate_comp.scm 896 */
																obj_t BgL_____rz00_15896;

																{	/* Eval/evaluate_comp.scm 670 */
																	obj_t BgL_savedzd2bpzd2_15897;

																	BgL_savedzd2bpzd2_15897 =
																		VECTOR_REF(BgL_nsz00_15893, ((long) 0));
																	VECTOR_SET(BgL_nsz00_15893, ((long) 0),
																		BINT(((long) 2)));
																	{
																		obj_t BgL_fz00_15899;

																		BgL_fz00_15899 = BgL_runz00_15882;
																	BgL_recz00_15898:
																		{	/* Eval/evaluate_comp.scm 673 */
																			obj_t BgL_rz00_15900;

																			BgL_rz00_15900 =
																				PROCEDURE_ENTRY(BgL_fz00_15899)
																				(BgL_fz00_15899, BgL_nsz00_15893, BEOA);
																			{	/* Eval/evaluate_comp.scm 674 */
																				bool_t BgL_test6271z00_20908;

																				if (PROCEDUREP(BgL_rz00_15900))
																					{	/* Eval/evaluate_comp.scm 674 */
																						obj_t BgL_arg1702z00_15901;

																						BgL_arg1702z00_15901 =
																							PROCEDURE_ATTR(BgL_rz00_15900);
																						if (STRUCTP(BgL_arg1702z00_15901))
																							{	/* Eval/evaluate_comp.scm 654 */
																								BgL_test6271z00_20908 =
																									(STRUCT_KEY
																									(BgL_arg1702z00_15901) ==
																									BGl_symbol5803z00zz__evaluate_compz00);
																							}
																						else
																							{	/* Eval/evaluate_comp.scm 654 */
																								BgL_test6271z00_20908 =
																									((bool_t) 0);
																							}
																					}
																				else
																					{	/* Eval/evaluate_comp.scm 674 */
																						BgL_test6271z00_20908 =
																							((bool_t) 0);
																					}
																				if (BgL_test6271z00_20908)
																					{
																						obj_t BgL_fz00_20916;

																						BgL_fz00_20916 = BgL_rz00_15900;
																						BgL_fz00_15899 = BgL_fz00_20916;
																						goto BgL_recz00_15898;
																					}
																				else
																					{	/* Eval/evaluate_comp.scm 674 */
																						VECTOR_SET(BgL_nsz00_15893,
																							((long) 0),
																							BgL_savedzd2bpzd2_15897);
																						BgL_____rz00_15896 = BgL_rz00_15900;
																}}}}}
																BGl_exitdzd2popzd2protectz12z12zz__bexitz00
																	(BgL_ez00_15895);
																BGL_ENV_EVSTATE_SET(BgL_z12denvz12_15892,
																	BgL_sz00_13698);
																return BgL_____rz00_15896;
															}
														}
													}
											}
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 896 */
										if (PROCEDURE_CORRECT_ARITYP(BgL_fz00_15878,
												(int) (((long) 1))))
											{	/* Eval/evaluate_comp.scm 896 */
												long BgL_nbpz00_15902;

												BgL_nbpz00_15902 =
													((long) CINT(BgL_bpz00_15877) + BgL_siza7eza7_13697);
												VECTOR_SET(
													((obj_t) BgL_sz00_13698), ((long) 0),
													BINT(BgL_nbpz00_15902));
												{	/* Eval/evaluate_comp.scm 896 */
													obj_t BgL_rz00_15903;

													BgL_rz00_15903 =
														PROCEDURE_ENTRY(BgL_fz00_15878) (BgL_fz00_15878,
														BgL_a1z00_15879, BEOA);
													VECTOR_SET(((obj_t) BgL_sz00_13698), ((long) 0),
														BgL_bpz00_15877);
													return BgL_rz00_15903;
												}
											}
										else
											{	/* Eval/evaluate_comp.scm 896 */
												return
													BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_13695,
													BgL_symbzd2funzd2_13696, (int) (((long) 1)),
													PROCEDURE_ARITY(BgL_fz00_15878));
		}}}}}}}}

	}



/* comp-call2 */
	obj_t BGl_compzd2call2zd2zz__evaluate_compz00(obj_t BgL_locz00_153,
		BgL_ev_exprz00_bglt BgL_vfunz00_154, obj_t BgL_symbzd2funzd2_155,
		obj_t BgL_funz00_156, obj_t BgL_tailzf3zf3_157, obj_t BgL_stkz00_158,
		long BgL_siza7eza7_159, obj_t BgL_a1z00_160, obj_t BgL_a2z00_161)
	{
		{	/* Eval/evaluate_comp.scm 896 */
			{	/* Eval/evaluate_comp.scm 896 */
				obj_t BgL_cfunz00_2281;

				BgL_cfunz00_2281 =
					BGl_iszd2constantzd2funzf3zf3zz__evaluate_compz00(BgL_vfunz00_154,
					((long) 2), BgL_locz00_153, BgL_symbzd2funzd2_155);
				if (CBOOL(BgL_cfunz00_2281))
					{	/* Eval/evaluate_comp.scm 896 */
						bool_t BgL_test6276z00_20940;

						{	/* Eval/evaluate_comp.scm 896 */
							int BgL_arg2085z00_2299;

							BgL_arg2085z00_2299 = bgl_debug();
							BgL_test6276z00_20940 =
								BGl_2ze3ze3zz__r4_numbers_6_5z00(BINT(BgL_arg2085z00_2299),
								BINT(((long) 0)));
						}
						if (BgL_test6276z00_20940)
							{	/* Eval/evaluate_comp.scm 896 */
								obj_t BgL_zc3z04anonymousza32082ze3z87_13699;

								BgL_zc3z04anonymousza32082ze3z87_13699 =
									MAKE_FX_PROCEDURE
									(BGl_z62zc3z04anonymousza32082ze3ze5zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 5)));
								PROCEDURE_SET(BgL_zc3z04anonymousza32082ze3z87_13699,
									(int) (((long) 0)), BgL_a1z00_160);
								PROCEDURE_SET(BgL_zc3z04anonymousza32082ze3z87_13699,
									(int) (((long) 1)), BgL_a2z00_161);
								PROCEDURE_SET(BgL_zc3z04anonymousza32082ze3z87_13699,
									(int) (((long) 2)), BINT(BgL_siza7eza7_159));
								PROCEDURE_SET(BgL_zc3z04anonymousza32082ze3z87_13699,
									(int) (((long) 3)), BgL_locz00_153);
								PROCEDURE_SET(BgL_zc3z04anonymousza32082ze3z87_13699,
									(int) (((long) 4)), BgL_cfunz00_2281);
								return BgL_zc3z04anonymousza32082ze3z87_13699;
							}
						else
							{	/* Eval/evaluate_comp.scm 896 */
								obj_t BgL_zc3z04anonymousza32084ze3z87_13700;

								BgL_zc3z04anonymousza32084ze3z87_13700 =
									MAKE_FX_PROCEDURE
									(BGl_z62zc3z04anonymousza32084ze3ze5zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 4)));
								PROCEDURE_SET(BgL_zc3z04anonymousza32084ze3z87_13700,
									(int) (((long) 0)), BgL_a1z00_160);
								PROCEDURE_SET(BgL_zc3z04anonymousza32084ze3z87_13700,
									(int) (((long) 1)), BgL_a2z00_161);
								PROCEDURE_SET(BgL_zc3z04anonymousza32084ze3z87_13700,
									(int) (((long) 2)), BINT(BgL_siza7eza7_159));
								PROCEDURE_SET(BgL_zc3z04anonymousza32084ze3z87_13700,
									(int) (((long) 3)), BgL_cfunz00_2281);
								return BgL_zc3z04anonymousza32084ze3z87_13700;
							}
					}
				else
					{	/* Eval/evaluate_comp.scm 896 */
						if (CBOOL(BgL_tailzf3zf3_157))
							{	/* Eval/evaluate_comp.scm 896 */
								bool_t BgL_test6278z00_20973;

								{	/* Eval/evaluate_comp.scm 896 */
									int BgL_arg2143z00_2391;

									BgL_arg2143z00_2391 = bgl_debug();
									BgL_test6278z00_20973 =
										BGl_2ze3ze3zz__r4_numbers_6_5z00(BINT(BgL_arg2143z00_2391),
										BINT(((long) 0)));
								}
								if (BgL_test6278z00_20973)
									{	/* Eval/evaluate_comp.scm 896 */
										obj_t BgL_zc3z04anonymousza32088ze3z87_13701;

										BgL_zc3z04anonymousza32088ze3z87_13701 =
											MAKE_FX_PROCEDURE
											(BGl_z62zc3z04anonymousza32088ze3ze5zz__evaluate_compz00,
											(int) (((long) 1)), (int) (((long) 6)));
										PROCEDURE_SET(BgL_zc3z04anonymousza32088ze3z87_13701,
											(int) (((long) 0)), BgL_funz00_156);
										PROCEDURE_SET(BgL_zc3z04anonymousza32088ze3z87_13701,
											(int) (((long) 1)), BgL_a1z00_160);
										PROCEDURE_SET(BgL_zc3z04anonymousza32088ze3z87_13701,
											(int) (((long) 2)), BgL_a2z00_161);
										PROCEDURE_SET(BgL_zc3z04anonymousza32088ze3z87_13701,
											(int) (((long) 3)), BgL_locz00_153);
										PROCEDURE_SET(BgL_zc3z04anonymousza32088ze3z87_13701,
											(int) (((long) 4)), BgL_symbzd2funzd2_155);
										PROCEDURE_SET(BgL_zc3z04anonymousza32088ze3z87_13701,
											(int) (((long) 5)), BINT(BgL_siza7eza7_159));
										return BgL_zc3z04anonymousza32088ze3z87_13701;
									}
								else
									{	/* Eval/evaluate_comp.scm 896 */
										obj_t BgL_zc3z04anonymousza32116ze3z87_13702;

										BgL_zc3z04anonymousza32116ze3z87_13702 =
											MAKE_FX_PROCEDURE
											(BGl_z62zc3z04anonymousza32116ze3ze5zz__evaluate_compz00,
											(int) (((long) 1)), (int) (((long) 6)));
										PROCEDURE_SET(BgL_zc3z04anonymousza32116ze3z87_13702,
											(int) (((long) 0)), BgL_funz00_156);
										PROCEDURE_SET(BgL_zc3z04anonymousza32116ze3z87_13702,
											(int) (((long) 1)), BgL_a1z00_160);
										PROCEDURE_SET(BgL_zc3z04anonymousza32116ze3z87_13702,
											(int) (((long) 2)), BgL_a2z00_161);
										PROCEDURE_SET(BgL_zc3z04anonymousza32116ze3z87_13702,
											(int) (((long) 3)), BgL_locz00_153);
										PROCEDURE_SET(BgL_zc3z04anonymousza32116ze3z87_13702,
											(int) (((long) 4)), BgL_symbzd2funzd2_155);
										PROCEDURE_SET(BgL_zc3z04anonymousza32116ze3z87_13702,
											(int) (((long) 5)), BINT(BgL_siza7eza7_159));
										return BgL_zc3z04anonymousza32116ze3z87_13702;
									}
							}
						else
							{	/* Eval/evaluate_comp.scm 896 */
								bool_t BgL_test6279z00_21010;

								{	/* Eval/evaluate_comp.scm 896 */
									int BgL_arg2199z00_2483;

									BgL_arg2199z00_2483 = bgl_debug();
									BgL_test6279z00_21010 =
										BGl_2ze3ze3zz__r4_numbers_6_5z00(BINT(BgL_arg2199z00_2483),
										BINT(((long) 0)));
								}
								if (BgL_test6279z00_21010)
									{	/* Eval/evaluate_comp.scm 896 */
										obj_t BgL_zc3z04anonymousza32146ze3z87_13703;

										BgL_zc3z04anonymousza32146ze3z87_13703 =
											MAKE_FX_PROCEDURE
											(BGl_z62zc3z04anonymousza32146ze3ze5zz__evaluate_compz00,
											(int) (((long) 1)), (int) (((long) 6)));
										PROCEDURE_SET(BgL_zc3z04anonymousza32146ze3z87_13703,
											(int) (((long) 0)), BgL_funz00_156);
										PROCEDURE_SET(BgL_zc3z04anonymousza32146ze3z87_13703,
											(int) (((long) 1)), BgL_a1z00_160);
										PROCEDURE_SET(BgL_zc3z04anonymousza32146ze3z87_13703,
											(int) (((long) 2)), BgL_a2z00_161);
										PROCEDURE_SET(BgL_zc3z04anonymousza32146ze3z87_13703,
											(int) (((long) 3)), BgL_locz00_153);
										PROCEDURE_SET(BgL_zc3z04anonymousza32146ze3z87_13703,
											(int) (((long) 4)), BgL_symbzd2funzd2_155);
										PROCEDURE_SET(BgL_zc3z04anonymousza32146ze3z87_13703,
											(int) (((long) 5)), BINT(BgL_siza7eza7_159));
										return BgL_zc3z04anonymousza32146ze3z87_13703;
									}
								else
									{	/* Eval/evaluate_comp.scm 896 */
										obj_t BgL_zc3z04anonymousza32174ze3z87_13704;

										BgL_zc3z04anonymousza32174ze3z87_13704 =
											MAKE_FX_PROCEDURE
											(BGl_z62zc3z04anonymousza32174ze3ze5zz__evaluate_compz00,
											(int) (((long) 1)), (int) (((long) 6)));
										PROCEDURE_SET(BgL_zc3z04anonymousza32174ze3z87_13704,
											(int) (((long) 0)), BgL_funz00_156);
										PROCEDURE_SET(BgL_zc3z04anonymousza32174ze3z87_13704,
											(int) (((long) 1)), BgL_a1z00_160);
										PROCEDURE_SET(BgL_zc3z04anonymousza32174ze3z87_13704,
											(int) (((long) 2)), BgL_a2z00_161);
										PROCEDURE_SET(BgL_zc3z04anonymousza32174ze3z87_13704,
											(int) (((long) 3)), BgL_locz00_153);
										PROCEDURE_SET(BgL_zc3z04anonymousza32174ze3z87_13704,
											(int) (((long) 4)), BgL_symbzd2funzd2_155);
										PROCEDURE_SET(BgL_zc3z04anonymousza32174ze3z87_13704,
											(int) (((long) 5)), BINT(BgL_siza7eza7_159));
										return BgL_zc3z04anonymousza32174ze3z87_13704;
									}
							}
					}
			}
		}

	}



/* &<@anonymous:2082> */
	obj_t BGl_z62zc3z04anonymousza32082ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_13705, obj_t BgL_sz00_13711)
	{
		{	/* Eval/evaluate_comp.scm 896 */
			{	/* Eval/evaluate_comp.scm 896 */
				obj_t BgL_a1z00_13706;
				obj_t BgL_a2z00_13707;
				long BgL_siza7eza7_13708;
				obj_t BgL_locz00_13709;
				obj_t BgL_cfunz00_13710;

				BgL_a1z00_13706 = PROCEDURE_REF(BgL_envz00_13705, (int) (((long) 0)));
				BgL_a2z00_13707 = PROCEDURE_REF(BgL_envz00_13705, (int) (((long) 1)));
				BgL_siza7eza7_13708 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13705, (int) (((long) 2))));
				BgL_locz00_13709 = PROCEDURE_REF(BgL_envz00_13705, (int) (((long) 3)));
				BgL_cfunz00_13710 = PROCEDURE_REF(BgL_envz00_13705, (int) (((long) 4)));
				{	/* Eval/evaluate_comp.scm 896 */
					obj_t BgL_bpz00_15904;

					BgL_bpz00_15904 = VECTOR_REF(((obj_t) BgL_sz00_13711), ((long) 0));
					{	/* Eval/evaluate_comp.scm 896 */
						obj_t BgL_a1z00_15905;
						obj_t BgL_a2z00_15906;

						BgL_a1z00_15905 =
							PROCEDURE_ENTRY(BgL_a1z00_13706) (BgL_a1z00_13706, BgL_sz00_13711,
							BEOA);
						BgL_a2z00_15906 =
							PROCEDURE_ENTRY(BgL_a2z00_13707) (BgL_a2z00_13707, BgL_sz00_13711,
							BEOA);
						{	/* Eval/evaluate_comp.scm 896 */
							long BgL_nbpz00_15907;

							BgL_nbpz00_15907 =
								((long) CINT(BgL_bpz00_15904) + BgL_siza7eza7_13708);
							VECTOR_SET(
								((obj_t) BgL_sz00_13711), ((long) 0), BINT(BgL_nbpz00_15907));
							{	/* Eval/evaluate_comp.scm 896 */
								obj_t BgL_tmpz00_21073;

								BgL_tmpz00_21073 = BGL_CURRENT_DYNAMIC_ENV();
								BGL_ENV_SET_TRACE_LOCATION(BgL_tmpz00_21073, BgL_locz00_13709);
							}
							{	/* Eval/evaluate_comp.scm 896 */
								obj_t BgL_rz00_15908;

								BgL_rz00_15908 =
									PROCEDURE_ENTRY(BgL_cfunz00_13710) (BgL_cfunz00_13710,
									BgL_a1z00_15905, BgL_a2z00_15906, BEOA);
								VECTOR_SET(((obj_t) BgL_sz00_13711), ((long) 0),
									BgL_bpz00_15904);
								return BgL_rz00_15908;
							}
						}
					}
				}
			}
		}

	}



/* &<@anonymous:2084> */
	obj_t BGl_z62zc3z04anonymousza32084ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_13712, obj_t BgL_sz00_13717)
	{
		{	/* Eval/evaluate_comp.scm 896 */
			{	/* Eval/evaluate_comp.scm 896 */
				obj_t BgL_a1z00_13713;
				obj_t BgL_a2z00_13714;
				long BgL_siza7eza7_13715;
				obj_t BgL_cfunz00_13716;

				BgL_a1z00_13713 = PROCEDURE_REF(BgL_envz00_13712, (int) (((long) 0)));
				BgL_a2z00_13714 = PROCEDURE_REF(BgL_envz00_13712, (int) (((long) 1)));
				BgL_siza7eza7_13715 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13712, (int) (((long) 2))));
				BgL_cfunz00_13716 = PROCEDURE_REF(BgL_envz00_13712, (int) (((long) 3)));
				{	/* Eval/evaluate_comp.scm 896 */
					obj_t BgL_bpz00_15909;

					BgL_bpz00_15909 = VECTOR_REF(((obj_t) BgL_sz00_13717), ((long) 0));
					{	/* Eval/evaluate_comp.scm 896 */
						obj_t BgL_a1z00_15910;
						obj_t BgL_a2z00_15911;

						BgL_a1z00_15910 =
							PROCEDURE_ENTRY(BgL_a1z00_13713) (BgL_a1z00_13713, BgL_sz00_13717,
							BEOA);
						BgL_a2z00_15911 =
							PROCEDURE_ENTRY(BgL_a2z00_13714) (BgL_a2z00_13714, BgL_sz00_13717,
							BEOA);
						{	/* Eval/evaluate_comp.scm 896 */
							long BgL_nbpz00_15912;

							BgL_nbpz00_15912 =
								((long) CINT(BgL_bpz00_15909) + BgL_siza7eza7_13715);
							VECTOR_SET(
								((obj_t) BgL_sz00_13717), ((long) 0), BINT(BgL_nbpz00_15912));
							{	/* Eval/evaluate_comp.scm 896 */
								obj_t BgL_rz00_15913;

								BgL_rz00_15913 =
									PROCEDURE_ENTRY(BgL_cfunz00_13716) (BgL_cfunz00_13716,
									BgL_a1z00_15910, BgL_a2z00_15911, BEOA);
								VECTOR_SET(((obj_t) BgL_sz00_13717), ((long) 0),
									BgL_bpz00_15909);
								return BgL_rz00_15913;
							}
						}
					}
				}
			}
		}

	}



/* &<@anonymous:2088> */
	obj_t BGl_z62zc3z04anonymousza32088ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_13718, obj_t BgL_sz00_13725)
	{
		{	/* Eval/evaluate_comp.scm 896 */
			{	/* Eval/evaluate_comp.scm 896 */
				obj_t BgL_funz00_13719;
				obj_t BgL_a1z00_13720;
				obj_t BgL_a2z00_13721;
				obj_t BgL_locz00_13722;
				obj_t BgL_symbzd2funzd2_13723;
				long BgL_siza7eza7_13724;

				BgL_funz00_13719 = PROCEDURE_REF(BgL_envz00_13718, (int) (((long) 0)));
				BgL_a1z00_13720 = PROCEDURE_REF(BgL_envz00_13718, (int) (((long) 1)));
				BgL_a2z00_13721 = PROCEDURE_REF(BgL_envz00_13718, (int) (((long) 2)));
				BgL_locz00_13722 = PROCEDURE_REF(BgL_envz00_13718, (int) (((long) 3)));
				BgL_symbzd2funzd2_13723 =
					PROCEDURE_REF(BgL_envz00_13718, (int) (((long) 4)));
				BgL_siza7eza7_13724 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13718, (int) (((long) 5))));
				{	/* Eval/evaluate_comp.scm 896 */
					obj_t BgL_bpz00_15914;

					BgL_bpz00_15914 = VECTOR_REF(((obj_t) BgL_sz00_13725), ((long) 0));
					{	/* Eval/evaluate_comp.scm 896 */
						obj_t BgL_fz00_15915;
						obj_t BgL_a1z00_15916;
						obj_t BgL_a2z00_15917;

						BgL_fz00_15915 =
							PROCEDURE_ENTRY(BgL_funz00_13719) (BgL_funz00_13719,
							BgL_sz00_13725, BEOA);
						BgL_a1z00_15916 =
							PROCEDURE_ENTRY(BgL_a1z00_13720) (BgL_a1z00_13720, BgL_sz00_13725,
							BEOA);
						BgL_a2z00_15917 =
							PROCEDURE_ENTRY(BgL_a2z00_13721) (BgL_a2z00_13721, BgL_sz00_13725,
							BEOA);
						if (PROCEDUREP(BgL_fz00_15915))
							{	/* Eval/evaluate_comp.scm 896 */
								BFALSE;
							}
						else
							{	/* Eval/evaluate_comp.scm 896 */
								BGl_evtypezd2errorzd2zz__everrorz00(BgL_locz00_13722,
									BGl_string5807z00zz__evaluate_compz00,
									BGl_string5823z00zz__evaluate_compz00, BgL_fz00_15915);
							}
						{	/* Eval/evaluate_comp.scm 896 */
							obj_t BgL_ufz00_15918;

							{	/* Eval/evaluate_comp.scm 896 */
								obj_t BgL_tmpz00_21144;

								BgL_tmpz00_21144 = ((obj_t) BgL_fz00_15915);
								BgL_ufz00_15918 = PROCEDURE_ATTR(BgL_tmpz00_21144);
							}
							{	/* Eval/evaluate_comp.scm 896 */
								bool_t BgL_test6281z00_21147;

								if (STRUCTP(BgL_ufz00_15918))
									{	/* Eval/evaluate_comp.scm 683 */
										BgL_test6281z00_21147 =
											(STRUCT_KEY(BgL_ufz00_15918) ==
											BGl_symbol5824z00zz__evaluate_compz00);
									}
								else
									{	/* Eval/evaluate_comp.scm 683 */
										BgL_test6281z00_21147 = ((bool_t) 0);
									}
								if (BgL_test6281z00_21147)
									{	/* Eval/evaluate_comp.scm 896 */
										obj_t BgL_arityz00_15919;
										obj_t BgL_runz00_15920;
										obj_t BgL_sfz00_15921;

										BgL_arityz00_15919 =
											STRUCT_REF(BgL_ufz00_15918, (int) (((long) 0)));
										BgL_runz00_15920 =
											STRUCT_REF(BgL_ufz00_15918, (int) (((long) 1)));
										BgL_sfz00_15921 =
											STRUCT_REF(BgL_ufz00_15918, (int) (((long) 2)));
										if (((long) CINT(BgL_arityz00_15919) == ((long) 2)))
											{	/* Eval/evaluate_comp.scm 896 */
												{	/* Eval/evaluate_comp.scm 896 */
													long BgL_arg2092z00_15922;

													BgL_arg2092z00_15922 =
														((long) CINT(BgL_bpz00_15914) + ((long) 0));
													VECTOR_SET(
														((obj_t) BgL_sz00_13725), BgL_arg2092z00_15922,
														BgL_a1z00_15916);
												}
												{	/* Eval/evaluate_comp.scm 896 */
													long BgL_arg2093z00_15923;

													BgL_arg2093z00_15923 =
														((long) CINT(BgL_bpz00_15914) + ((long) 1));
													VECTOR_SET(
														((obj_t) BgL_sz00_13725), BgL_arg2093z00_15923,
														BgL_a2z00_15917);
											}}
										else
											{	/* Eval/evaluate_comp.scm 896 */
												if (INTEGERP(BgL_arityz00_15919))
													{	/* Eval/evaluate_comp.scm 896 */
														switch ((long) CINT(BgL_arityz00_15919))
															{
															case ((long) -1):

																{	/* Eval/evaluate_comp.scm 896 */
																	long BgL_arg2096z00_15924;
																	obj_t BgL_arg2097z00_15925;

																	BgL_arg2096z00_15924 =
																		((long) CINT(BgL_bpz00_15914) + ((long) 0));
																	{	/* Eval/evaluate_comp.scm 896 */
																		obj_t BgL_list2098z00_15926;

																		{	/* Eval/evaluate_comp.scm 896 */
																			obj_t BgL_arg2100z00_15927;

																			BgL_arg2100z00_15927 =
																				MAKE_YOUNG_PAIR(BgL_a2z00_15917, BNIL);
																			BgL_list2098z00_15926 =
																				MAKE_YOUNG_PAIR(BgL_a1z00_15916,
																				BgL_arg2100z00_15927);
																		}
																		BgL_arg2097z00_15925 =
																			BgL_list2098z00_15926;
																	}
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13725),
																		BgL_arg2096z00_15924, BgL_arg2097z00_15925);
																} break;
															case ((long) -2):

																{	/* Eval/evaluate_comp.scm 896 */
																	long BgL_arg2101z00_15928;

																	BgL_arg2101z00_15928 =
																		((long) CINT(BgL_bpz00_15914) + ((long) 0));
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13725),
																		BgL_arg2101z00_15928, BgL_a1z00_15916);
																}
																{	/* Eval/evaluate_comp.scm 896 */
																	long BgL_arg2102z00_15929;
																	obj_t BgL_arg2103z00_15930;

																	BgL_arg2102z00_15929 =
																		((long) CINT(BgL_bpz00_15914) + ((long) 1));
																	{	/* Eval/evaluate_comp.scm 896 */
																		obj_t BgL_list2104z00_15931;

																		BgL_list2104z00_15931 =
																			MAKE_YOUNG_PAIR(BgL_a2z00_15917, BNIL);
																		BgL_arg2103z00_15930 =
																			BgL_list2104z00_15931;
																	}
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13725),
																		BgL_arg2102z00_15929, BgL_arg2103z00_15930);
																} break;
															case ((long) -3):

																{	/* Eval/evaluate_comp.scm 896 */
																	long BgL_arg2105z00_15932;

																	BgL_arg2105z00_15932 =
																		((long) CINT(BgL_bpz00_15914) + ((long) 0));
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13725),
																		BgL_arg2105z00_15932, BgL_a1z00_15916);
																}
																{	/* Eval/evaluate_comp.scm 896 */
																	long BgL_arg2106z00_15933;

																	BgL_arg2106z00_15933 =
																		((long) CINT(BgL_bpz00_15914) + ((long) 1));
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13725),
																		BgL_arg2106z00_15933, BgL_a2z00_15917);
																}
																{	/* Eval/evaluate_comp.scm 896 */
																	long BgL_arg2107z00_15934;
																	obj_t BgL_arg2108z00_15935;

																	BgL_arg2107z00_15934 =
																		((long) CINT(BgL_bpz00_15914) + ((long) 2));
																	BgL_arg2108z00_15935 = BNIL;
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13725),
																		BgL_arg2107z00_15934, BgL_arg2108z00_15935);
																} break;
															default:
																BGl_evarityzd2errorzd2zz__everrorz00
																	(BgL_locz00_13722, STRUCT_REF(BgL_ufz00_15918,
																		(int) (((long) 3))), (int) (((long) 2)),
																	CINT(BgL_arityz00_15919));
													}}
												else
													{	/* Eval/evaluate_comp.scm 896 */
														BGl_evarityzd2errorzd2zz__everrorz00
															(BgL_locz00_13722, STRUCT_REF(BgL_ufz00_15918,
																(int) (((long) 3))), (int) (((long) 2)),
															CINT(BgL_arityz00_15919));
											}}
										{	/* Eval/evaluate_comp.scm 896 */
											obj_t BgL_z12denvz12_15936;

											BgL_z12denvz12_15936 = BGL_CURRENT_DYNAMIC_ENV();
											BGL_ENV_SET_TRACE_LOCATION(BgL_z12denvz12_15936,
												BgL_locz00_13722);
											if ((((long) CINT(BgL_bpz00_15914) +
														(long) CINT(BgL_sfz00_15921)) <
													VECTOR_LENGTH(((obj_t) BgL_sz00_13725))))
												{	/* Eval/evaluate_comp.scm 896 */
													return BgL_runz00_15920;
												}
											else
												{	/* Eval/evaluate_comp.scm 896 */
													obj_t BgL_nsz00_15937;

													BgL_nsz00_15937 =
														BGl_makezd2statezd2zz__evaluate_compz00();
													{	/* Eval/evaluate_comp.scm 896 */
														long BgL_arg2112z00_15938;

														BgL_arg2112z00_15938 =
															((long) CINT(BgL_bpz00_15914) + ((long) 2));
														BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00
															(BgL_nsz00_15937, ((long) 2), BgL_sz00_13725,
															BgL_bpz00_15914, BINT(BgL_arg2112z00_15938));
													}
													VECTOR_SET(BgL_nsz00_15937, ((long) 1),
														BgL_sz00_13725);
													BGL_ENV_EVSTATE_SET(BgL_z12denvz12_15936,
														BgL_nsz00_15937);
													{	/* Eval/evaluate_comp.scm 896 */
														obj_t BgL_ez00_15939;

														BgL_ez00_15939 = BGL_EXITD_TOP_AS_OBJ();
														BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
															(BgL_ez00_15939, BgL_sz00_13725);
														{	/* Eval/evaluate_comp.scm 896 */
															obj_t BgL_____rz00_15940;

															{	/* Eval/evaluate_comp.scm 670 */
																obj_t BgL_savedzd2bpzd2_15941;

																BgL_savedzd2bpzd2_15941 =
																	VECTOR_REF(BgL_nsz00_15937, ((long) 0));
																VECTOR_SET(BgL_nsz00_15937, ((long) 0),
																	BINT(((long) 2)));
																{
																	obj_t BgL_fz00_15943;

																	BgL_fz00_15943 = BgL_runz00_15920;
																BgL_recz00_15942:
																	{	/* Eval/evaluate_comp.scm 673 */
																		obj_t BgL_rz00_15944;

																		BgL_rz00_15944 =
																			PROCEDURE_ENTRY(BgL_fz00_15943)
																			(BgL_fz00_15943, BgL_nsz00_15937, BEOA);
																		{	/* Eval/evaluate_comp.scm 674 */
																			bool_t BgL_test6286z00_21235;

																			if (PROCEDUREP(BgL_rz00_15944))
																				{	/* Eval/evaluate_comp.scm 674 */
																					obj_t BgL_arg1702z00_15945;

																					BgL_arg1702z00_15945 =
																						PROCEDURE_ATTR(BgL_rz00_15944);
																					if (STRUCTP(BgL_arg1702z00_15945))
																						{	/* Eval/evaluate_comp.scm 654 */
																							BgL_test6286z00_21235 =
																								(STRUCT_KEY
																								(BgL_arg1702z00_15945) ==
																								BGl_symbol5803z00zz__evaluate_compz00);
																						}
																					else
																						{	/* Eval/evaluate_comp.scm 654 */
																							BgL_test6286z00_21235 =
																								((bool_t) 0);
																						}
																				}
																			else
																				{	/* Eval/evaluate_comp.scm 674 */
																					BgL_test6286z00_21235 = ((bool_t) 0);
																				}
																			if (BgL_test6286z00_21235)
																				{
																					obj_t BgL_fz00_21243;

																					BgL_fz00_21243 = BgL_rz00_15944;
																					BgL_fz00_15943 = BgL_fz00_21243;
																					goto BgL_recz00_15942;
																				}
																			else
																				{	/* Eval/evaluate_comp.scm 674 */
																					VECTOR_SET(BgL_nsz00_15937,
																						((long) 0),
																						BgL_savedzd2bpzd2_15941);
																					BgL_____rz00_15940 = BgL_rz00_15944;
															}}}}}
															BGl_exitdzd2popzd2protectz12z12zz__bexitz00
																(BgL_ez00_15939);
															BGL_ENV_EVSTATE_SET(BgL_z12denvz12_15936,
																BgL_sz00_13725);
															return BgL_____rz00_15940;
														}
													}
												}
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 896 */
										if (PROCEDURE_CORRECT_ARITYP(BgL_fz00_15915,
												(int) (((long) 2))))
											{	/* Eval/evaluate_comp.scm 896 */
												long BgL_nbpz00_15946;

												BgL_nbpz00_15946 =
													((long) CINT(BgL_bpz00_15914) + BgL_siza7eza7_13724);
												VECTOR_SET(
													((obj_t) BgL_sz00_13725), ((long) 0),
													BINT(BgL_nbpz00_15946));
												{	/* Eval/evaluate_comp.scm 896 */
													obj_t BgL_tmpz00_21255;

													BgL_tmpz00_21255 = BGL_CURRENT_DYNAMIC_ENV();
													BGL_ENV_SET_TRACE_LOCATION(BgL_tmpz00_21255,
														BgL_locz00_13722);
												}
												{	/* Eval/evaluate_comp.scm 896 */
													obj_t BgL_rz00_15947;

													BgL_rz00_15947 =
														PROCEDURE_ENTRY(BgL_fz00_15915) (BgL_fz00_15915,
														BgL_a1z00_15916, BgL_a2z00_15917, BEOA);
													VECTOR_SET(((obj_t) BgL_sz00_13725), ((long) 0),
														BgL_bpz00_15914);
													return BgL_rz00_15947;
												}
											}
										else
											{	/* Eval/evaluate_comp.scm 896 */
												return
													BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_13722,
													BgL_symbzd2funzd2_13723, (int) (((long) 2)),
													PROCEDURE_ARITY(BgL_fz00_15915));
		}}}}}}}}

	}



/* &<@anonymous:2116> */
	obj_t BGl_z62zc3z04anonymousza32116ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_13726, obj_t BgL_sz00_13733)
	{
		{	/* Eval/evaluate_comp.scm 896 */
			{	/* Eval/evaluate_comp.scm 896 */
				obj_t BgL_funz00_13727;
				obj_t BgL_a1z00_13728;
				obj_t BgL_a2z00_13729;
				obj_t BgL_locz00_13730;
				obj_t BgL_symbzd2funzd2_13731;
				long BgL_siza7eza7_13732;

				BgL_funz00_13727 = PROCEDURE_REF(BgL_envz00_13726, (int) (((long) 0)));
				BgL_a1z00_13728 = PROCEDURE_REF(BgL_envz00_13726, (int) (((long) 1)));
				BgL_a2z00_13729 = PROCEDURE_REF(BgL_envz00_13726, (int) (((long) 2)));
				BgL_locz00_13730 = PROCEDURE_REF(BgL_envz00_13726, (int) (((long) 3)));
				BgL_symbzd2funzd2_13731 =
					PROCEDURE_REF(BgL_envz00_13726, (int) (((long) 4)));
				BgL_siza7eza7_13732 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13726, (int) (((long) 5))));
				{	/* Eval/evaluate_comp.scm 896 */
					obj_t BgL_bpz00_15948;

					BgL_bpz00_15948 = VECTOR_REF(((obj_t) BgL_sz00_13733), ((long) 0));
					{	/* Eval/evaluate_comp.scm 896 */
						obj_t BgL_fz00_15949;
						obj_t BgL_a1z00_15950;
						obj_t BgL_a2z00_15951;

						BgL_fz00_15949 =
							PROCEDURE_ENTRY(BgL_funz00_13727) (BgL_funz00_13727,
							BgL_sz00_13733, BEOA);
						BgL_a1z00_15950 =
							PROCEDURE_ENTRY(BgL_a1z00_13728) (BgL_a1z00_13728, BgL_sz00_13733,
							BEOA);
						BgL_a2z00_15951 =
							PROCEDURE_ENTRY(BgL_a2z00_13729) (BgL_a2z00_13729, BgL_sz00_13733,
							BEOA);
						if (PROCEDUREP(BgL_fz00_15949))
							{	/* Eval/evaluate_comp.scm 896 */
								BFALSE;
							}
						else
							{	/* Eval/evaluate_comp.scm 896 */
								BGl_evtypezd2errorzd2zz__everrorz00(BgL_locz00_13730,
									BGl_string5807z00zz__evaluate_compz00,
									BGl_string5823z00zz__evaluate_compz00, BgL_fz00_15949);
							}
						{	/* Eval/evaluate_comp.scm 896 */
							obj_t BgL_ufz00_15952;

							{	/* Eval/evaluate_comp.scm 896 */
								obj_t BgL_tmpz00_21298;

								BgL_tmpz00_21298 = ((obj_t) BgL_fz00_15949);
								BgL_ufz00_15952 = PROCEDURE_ATTR(BgL_tmpz00_21298);
							}
							{	/* Eval/evaluate_comp.scm 896 */
								bool_t BgL_test6291z00_21301;

								if (STRUCTP(BgL_ufz00_15952))
									{	/* Eval/evaluate_comp.scm 683 */
										BgL_test6291z00_21301 =
											(STRUCT_KEY(BgL_ufz00_15952) ==
											BGl_symbol5824z00zz__evaluate_compz00);
									}
								else
									{	/* Eval/evaluate_comp.scm 683 */
										BgL_test6291z00_21301 = ((bool_t) 0);
									}
								if (BgL_test6291z00_21301)
									{	/* Eval/evaluate_comp.scm 896 */
										obj_t BgL_arityz00_15953;
										obj_t BgL_runz00_15954;
										obj_t BgL_sfz00_15955;

										BgL_arityz00_15953 =
											STRUCT_REF(BgL_ufz00_15952, (int) (((long) 0)));
										BgL_runz00_15954 =
											STRUCT_REF(BgL_ufz00_15952, (int) (((long) 1)));
										BgL_sfz00_15955 =
											STRUCT_REF(BgL_ufz00_15952, (int) (((long) 2)));
										if (((long) CINT(BgL_arityz00_15953) == ((long) 2)))
											{	/* Eval/evaluate_comp.scm 896 */
												{	/* Eval/evaluate_comp.scm 896 */
													long BgL_arg2120z00_15956;

													BgL_arg2120z00_15956 =
														((long) CINT(BgL_bpz00_15948) + ((long) 0));
													VECTOR_SET(
														((obj_t) BgL_sz00_13733), BgL_arg2120z00_15956,
														BgL_a1z00_15950);
												}
												{	/* Eval/evaluate_comp.scm 896 */
													long BgL_arg2121z00_15957;

													BgL_arg2121z00_15957 =
														((long) CINT(BgL_bpz00_15948) + ((long) 1));
													VECTOR_SET(
														((obj_t) BgL_sz00_13733), BgL_arg2121z00_15957,
														BgL_a2z00_15951);
											}}
										else
											{	/* Eval/evaluate_comp.scm 896 */
												if (INTEGERP(BgL_arityz00_15953))
													{	/* Eval/evaluate_comp.scm 896 */
														switch ((long) CINT(BgL_arityz00_15953))
															{
															case ((long) -1):

																{	/* Eval/evaluate_comp.scm 896 */
																	long BgL_arg2123z00_15958;
																	obj_t BgL_arg2124z00_15959;

																	BgL_arg2123z00_15958 =
																		((long) CINT(BgL_bpz00_15948) + ((long) 0));
																	{	/* Eval/evaluate_comp.scm 896 */
																		obj_t BgL_list2125z00_15960;

																		{	/* Eval/evaluate_comp.scm 896 */
																			obj_t BgL_arg2126z00_15961;

																			BgL_arg2126z00_15961 =
																				MAKE_YOUNG_PAIR(BgL_a2z00_15951, BNIL);
																			BgL_list2125z00_15960 =
																				MAKE_YOUNG_PAIR(BgL_a1z00_15950,
																				BgL_arg2126z00_15961);
																		}
																		BgL_arg2124z00_15959 =
																			BgL_list2125z00_15960;
																	}
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13733),
																		BgL_arg2123z00_15958, BgL_arg2124z00_15959);
																} break;
															case ((long) -2):

																{	/* Eval/evaluate_comp.scm 896 */
																	long BgL_arg2127z00_15962;

																	BgL_arg2127z00_15962 =
																		((long) CINT(BgL_bpz00_15948) + ((long) 0));
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13733),
																		BgL_arg2127z00_15962, BgL_a1z00_15950);
																}
																{	/* Eval/evaluate_comp.scm 896 */
																	long BgL_arg2128z00_15963;
																	obj_t BgL_arg2129z00_15964;

																	BgL_arg2128z00_15963 =
																		((long) CINT(BgL_bpz00_15948) + ((long) 1));
																	{	/* Eval/evaluate_comp.scm 896 */
																		obj_t BgL_list2130z00_15965;

																		BgL_list2130z00_15965 =
																			MAKE_YOUNG_PAIR(BgL_a2z00_15951, BNIL);
																		BgL_arg2129z00_15964 =
																			BgL_list2130z00_15965;
																	}
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13733),
																		BgL_arg2128z00_15963, BgL_arg2129z00_15964);
																} break;
															case ((long) -3):

																{	/* Eval/evaluate_comp.scm 896 */
																	long BgL_arg2131z00_15966;

																	BgL_arg2131z00_15966 =
																		((long) CINT(BgL_bpz00_15948) + ((long) 0));
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13733),
																		BgL_arg2131z00_15966, BgL_a1z00_15950);
																}
																{	/* Eval/evaluate_comp.scm 896 */
																	long BgL_arg2132z00_15967;

																	BgL_arg2132z00_15967 =
																		((long) CINT(BgL_bpz00_15948) + ((long) 1));
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13733),
																		BgL_arg2132z00_15967, BgL_a2z00_15951);
																}
																{	/* Eval/evaluate_comp.scm 896 */
																	long BgL_arg2133z00_15968;
																	obj_t BgL_arg2136z00_15969;

																	BgL_arg2133z00_15968 =
																		((long) CINT(BgL_bpz00_15948) + ((long) 2));
																	BgL_arg2136z00_15969 = BNIL;
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13733),
																		BgL_arg2133z00_15968, BgL_arg2136z00_15969);
																} break;
															default:
																BGl_evarityzd2errorzd2zz__everrorz00
																	(BgL_locz00_13730, STRUCT_REF(BgL_ufz00_15952,
																		(int) (((long) 3))), (int) (((long) 2)),
																	CINT(BgL_arityz00_15953));
													}}
												else
													{	/* Eval/evaluate_comp.scm 896 */
														BGl_evarityzd2errorzd2zz__everrorz00
															(BgL_locz00_13730, STRUCT_REF(BgL_ufz00_15952,
																(int) (((long) 3))), (int) (((long) 2)),
															CINT(BgL_arityz00_15953));
											}}
										{	/* Eval/evaluate_comp.scm 896 */
											obj_t BgL_z12denvz12_15970;

											BgL_z12denvz12_15970 = BGL_CURRENT_DYNAMIC_ENV();
											if (
												(((long) CINT(BgL_bpz00_15948) +
														(long) CINT(BgL_sfz00_15955)) <
													VECTOR_LENGTH(((obj_t) BgL_sz00_13733))))
												{	/* Eval/evaluate_comp.scm 896 */
													return BgL_runz00_15954;
												}
											else
												{	/* Eval/evaluate_comp.scm 896 */
													obj_t BgL_nsz00_15971;

													BgL_nsz00_15971 =
														BGl_makezd2statezd2zz__evaluate_compz00();
													{	/* Eval/evaluate_comp.scm 896 */
														long BgL_arg2140z00_15972;

														BgL_arg2140z00_15972 =
															((long) CINT(BgL_bpz00_15948) + ((long) 2));
														BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00
															(BgL_nsz00_15971, ((long) 2), BgL_sz00_13733,
															BgL_bpz00_15948, BINT(BgL_arg2140z00_15972));
													}
													VECTOR_SET(BgL_nsz00_15971, ((long) 1),
														BgL_sz00_13733);
													BGL_ENV_EVSTATE_SET(BgL_z12denvz12_15970,
														BgL_nsz00_15971);
													{	/* Eval/evaluate_comp.scm 896 */
														obj_t BgL_ez00_15973;

														BgL_ez00_15973 = BGL_EXITD_TOP_AS_OBJ();
														BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
															(BgL_ez00_15973, BgL_sz00_13733);
														{	/* Eval/evaluate_comp.scm 896 */
															obj_t BgL_____rz00_15974;

															{	/* Eval/evaluate_comp.scm 670 */
																obj_t BgL_savedzd2bpzd2_15975;

																BgL_savedzd2bpzd2_15975 =
																	VECTOR_REF(BgL_nsz00_15971, ((long) 0));
																VECTOR_SET(BgL_nsz00_15971, ((long) 0),
																	BINT(((long) 2)));
																{
																	obj_t BgL_fz00_15977;

																	BgL_fz00_15977 = BgL_runz00_15954;
																BgL_recz00_15976:
																	{	/* Eval/evaluate_comp.scm 673 */
																		obj_t BgL_rz00_15978;

																		BgL_rz00_15978 =
																			PROCEDURE_ENTRY(BgL_fz00_15977)
																			(BgL_fz00_15977, BgL_nsz00_15971, BEOA);
																		{	/* Eval/evaluate_comp.scm 674 */
																			bool_t BgL_test6296z00_21388;

																			if (PROCEDUREP(BgL_rz00_15978))
																				{	/* Eval/evaluate_comp.scm 674 */
																					obj_t BgL_arg1702z00_15979;

																					BgL_arg1702z00_15979 =
																						PROCEDURE_ATTR(BgL_rz00_15978);
																					if (STRUCTP(BgL_arg1702z00_15979))
																						{	/* Eval/evaluate_comp.scm 654 */
																							BgL_test6296z00_21388 =
																								(STRUCT_KEY
																								(BgL_arg1702z00_15979) ==
																								BGl_symbol5803z00zz__evaluate_compz00);
																						}
																					else
																						{	/* Eval/evaluate_comp.scm 654 */
																							BgL_test6296z00_21388 =
																								((bool_t) 0);
																						}
																				}
																			else
																				{	/* Eval/evaluate_comp.scm 674 */
																					BgL_test6296z00_21388 = ((bool_t) 0);
																				}
																			if (BgL_test6296z00_21388)
																				{
																					obj_t BgL_fz00_21396;

																					BgL_fz00_21396 = BgL_rz00_15978;
																					BgL_fz00_15977 = BgL_fz00_21396;
																					goto BgL_recz00_15976;
																				}
																			else
																				{	/* Eval/evaluate_comp.scm 674 */
																					VECTOR_SET(BgL_nsz00_15971,
																						((long) 0),
																						BgL_savedzd2bpzd2_15975);
																					BgL_____rz00_15974 = BgL_rz00_15978;
															}}}}}
															BGl_exitdzd2popzd2protectz12z12zz__bexitz00
																(BgL_ez00_15973);
															BGL_ENV_EVSTATE_SET(BgL_z12denvz12_15970,
																BgL_sz00_13733);
															return BgL_____rz00_15974;
														}
													}
												}
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 896 */
										if (PROCEDURE_CORRECT_ARITYP(BgL_fz00_15949,
												(int) (((long) 2))))
											{	/* Eval/evaluate_comp.scm 896 */
												long BgL_nbpz00_15980;

												BgL_nbpz00_15980 =
													((long) CINT(BgL_bpz00_15948) + BgL_siza7eza7_13732);
												VECTOR_SET(
													((obj_t) BgL_sz00_13733), ((long) 0),
													BINT(BgL_nbpz00_15980));
												{	/* Eval/evaluate_comp.scm 896 */
													obj_t BgL_rz00_15981;

													BgL_rz00_15981 =
														PROCEDURE_ENTRY(BgL_fz00_15949) (BgL_fz00_15949,
														BgL_a1z00_15950, BgL_a2z00_15951, BEOA);
													VECTOR_SET(((obj_t) BgL_sz00_13733), ((long) 0),
														BgL_bpz00_15948);
													return BgL_rz00_15981;
												}
											}
										else
											{	/* Eval/evaluate_comp.scm 896 */
												return
													BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_13730,
													BgL_symbzd2funzd2_13731, (int) (((long) 2)),
													PROCEDURE_ARITY(BgL_fz00_15949));
		}}}}}}}}

	}



/* &<@anonymous:2146> */
	obj_t BGl_z62zc3z04anonymousza32146ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_13734, obj_t BgL_sz00_13741)
	{
		{	/* Eval/evaluate_comp.scm 896 */
			{	/* Eval/evaluate_comp.scm 896 */
				obj_t BgL_funz00_13735;
				obj_t BgL_a1z00_13736;
				obj_t BgL_a2z00_13737;
				obj_t BgL_locz00_13738;
				obj_t BgL_symbzd2funzd2_13739;
				long BgL_siza7eza7_13740;

				BgL_funz00_13735 = PROCEDURE_REF(BgL_envz00_13734, (int) (((long) 0)));
				BgL_a1z00_13736 = PROCEDURE_REF(BgL_envz00_13734, (int) (((long) 1)));
				BgL_a2z00_13737 = PROCEDURE_REF(BgL_envz00_13734, (int) (((long) 2)));
				BgL_locz00_13738 = PROCEDURE_REF(BgL_envz00_13734, (int) (((long) 3)));
				BgL_symbzd2funzd2_13739 =
					PROCEDURE_REF(BgL_envz00_13734, (int) (((long) 4)));
				BgL_siza7eza7_13740 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13734, (int) (((long) 5))));
				{	/* Eval/evaluate_comp.scm 896 */
					obj_t BgL_bpz00_15982;

					BgL_bpz00_15982 = VECTOR_REF(((obj_t) BgL_sz00_13741), ((long) 0));
					{	/* Eval/evaluate_comp.scm 896 */
						obj_t BgL_fz00_15983;
						obj_t BgL_a1z00_15984;
						obj_t BgL_a2z00_15985;

						BgL_fz00_15983 =
							PROCEDURE_ENTRY(BgL_funz00_13735) (BgL_funz00_13735,
							BgL_sz00_13741, BEOA);
						BgL_a1z00_15984 =
							PROCEDURE_ENTRY(BgL_a1z00_13736) (BgL_a1z00_13736, BgL_sz00_13741,
							BEOA);
						BgL_a2z00_15985 =
							PROCEDURE_ENTRY(BgL_a2z00_13737) (BgL_a2z00_13737, BgL_sz00_13741,
							BEOA);
						if (PROCEDUREP(BgL_fz00_15983))
							{	/* Eval/evaluate_comp.scm 896 */
								BFALSE;
							}
						else
							{	/* Eval/evaluate_comp.scm 896 */
								BGl_evtypezd2errorzd2zz__everrorz00(BgL_locz00_13738,
									BGl_string5807z00zz__evaluate_compz00,
									BGl_string5823z00zz__evaluate_compz00, BgL_fz00_15983);
							}
						{	/* Eval/evaluate_comp.scm 896 */
							obj_t BgL_ufz00_15986;

							{	/* Eval/evaluate_comp.scm 896 */
								obj_t BgL_tmpz00_21448;

								BgL_tmpz00_21448 = ((obj_t) BgL_fz00_15983);
								BgL_ufz00_15986 = PROCEDURE_ATTR(BgL_tmpz00_21448);
							}
							{	/* Eval/evaluate_comp.scm 896 */
								bool_t BgL_test6301z00_21451;

								if (STRUCTP(BgL_ufz00_15986))
									{	/* Eval/evaluate_comp.scm 683 */
										BgL_test6301z00_21451 =
											(STRUCT_KEY(BgL_ufz00_15986) ==
											BGl_symbol5824z00zz__evaluate_compz00);
									}
								else
									{	/* Eval/evaluate_comp.scm 683 */
										BgL_test6301z00_21451 = ((bool_t) 0);
									}
								if (BgL_test6301z00_21451)
									{	/* Eval/evaluate_comp.scm 896 */
										obj_t BgL_arityz00_15987;
										obj_t BgL_runz00_15988;
										obj_t BgL_sfz00_15989;

										BgL_arityz00_15987 =
											STRUCT_REF(BgL_ufz00_15986, (int) (((long) 0)));
										BgL_runz00_15988 =
											STRUCT_REF(BgL_ufz00_15986, (int) (((long) 1)));
										BgL_sfz00_15989 =
											STRUCT_REF(BgL_ufz00_15986, (int) (((long) 2)));
										{	/* Eval/evaluate_comp.scm 896 */
											long BgL_spz00_15990;

											BgL_spz00_15990 =
												((long) CINT(BgL_bpz00_15982) + BgL_siza7eza7_13740);
											if (((long) CINT(BgL_arityz00_15987) == ((long) 2)))
												{	/* Eval/evaluate_comp.scm 896 */
													{	/* Eval/evaluate_comp.scm 896 */
														long BgL_arg2150z00_15991;

														BgL_arg2150z00_15991 =
															(BgL_spz00_15990 + ((long) 0));
														VECTOR_SET(
															((obj_t) BgL_sz00_13741), BgL_arg2150z00_15991,
															BgL_a1z00_15984);
													}
													{	/* Eval/evaluate_comp.scm 896 */
														long BgL_arg2151z00_15992;

														BgL_arg2151z00_15992 =
															(BgL_spz00_15990 + ((long) 1));
														VECTOR_SET(
															((obj_t) BgL_sz00_13741), BgL_arg2151z00_15992,
															BgL_a2z00_15985);
												}}
											else
												{	/* Eval/evaluate_comp.scm 896 */
													if (INTEGERP(BgL_arityz00_15987))
														{	/* Eval/evaluate_comp.scm 896 */
															switch ((long) CINT(BgL_arityz00_15987))
																{
																case ((long) -1):

																	{	/* Eval/evaluate_comp.scm 896 */
																		long BgL_arg2154z00_15993;
																		obj_t BgL_arg2155z00_15994;

																		BgL_arg2154z00_15993 =
																			(BgL_spz00_15990 + ((long) 0));
																		{	/* Eval/evaluate_comp.scm 896 */
																			obj_t BgL_list2157z00_15995;

																			{	/* Eval/evaluate_comp.scm 896 */
																				obj_t BgL_arg2158z00_15996;

																				BgL_arg2158z00_15996 =
																					MAKE_YOUNG_PAIR(BgL_a2z00_15985,
																					BNIL);
																				BgL_list2157z00_15995 =
																					MAKE_YOUNG_PAIR(BgL_a1z00_15984,
																					BgL_arg2158z00_15996);
																			}
																			BgL_arg2155z00_15994 =
																				BgL_list2157z00_15995;
																		}
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13741),
																			BgL_arg2154z00_15993,
																			BgL_arg2155z00_15994);
																	} break;
																case ((long) -2):

																	{	/* Eval/evaluate_comp.scm 896 */
																		long BgL_arg2159z00_15997;

																		BgL_arg2159z00_15997 =
																			(BgL_spz00_15990 + ((long) 0));
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13741),
																			BgL_arg2159z00_15997, BgL_a1z00_15984);
																	}
																	{	/* Eval/evaluate_comp.scm 896 */
																		long BgL_arg2160z00_15998;
																		obj_t BgL_arg2161z00_15999;

																		BgL_arg2160z00_15998 =
																			(BgL_spz00_15990 + ((long) 1));
																		{	/* Eval/evaluate_comp.scm 896 */
																			obj_t BgL_list2162z00_16000;

																			BgL_list2162z00_16000 =
																				MAKE_YOUNG_PAIR(BgL_a2z00_15985, BNIL);
																			BgL_arg2161z00_15999 =
																				BgL_list2162z00_16000;
																		}
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13741),
																			BgL_arg2160z00_15998,
																			BgL_arg2161z00_15999);
																	} break;
																case ((long) -3):

																	{	/* Eval/evaluate_comp.scm 896 */
																		long BgL_arg2163z00_16001;

																		BgL_arg2163z00_16001 =
																			(BgL_spz00_15990 + ((long) 0));
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13741),
																			BgL_arg2163z00_16001, BgL_a1z00_15984);
																	}
																	{	/* Eval/evaluate_comp.scm 896 */
																		long BgL_arg2164z00_16002;

																		BgL_arg2164z00_16002 =
																			(BgL_spz00_15990 + ((long) 1));
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13741),
																			BgL_arg2164z00_16002, BgL_a2z00_15985);
																	}
																	{	/* Eval/evaluate_comp.scm 896 */
																		long BgL_arg2165z00_16003;
																		obj_t BgL_arg2166z00_16004;

																		BgL_arg2165z00_16003 =
																			(BgL_spz00_15990 + ((long) 2));
																		BgL_arg2166z00_16004 = BNIL;
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13741),
																			BgL_arg2165z00_16003,
																			BgL_arg2166z00_16004);
																	} break;
																default:
																	BGl_evarityzd2errorzd2zz__everrorz00
																		(BgL_locz00_13738,
																		STRUCT_REF(BgL_ufz00_15986,
																			(int) (((long) 3))), (int) (((long) 2)),
																		CINT(BgL_arityz00_15987));
														}}
													else
														{	/* Eval/evaluate_comp.scm 896 */
															BGl_evarityzd2errorzd2zz__everrorz00
																(BgL_locz00_13738, STRUCT_REF(BgL_ufz00_15986,
																	(int) (((long) 3))), (int) (((long) 2)),
																CINT(BgL_arityz00_15987));
												}}
											{	/* Eval/evaluate_comp.scm 896 */
												obj_t BgL_z12denvz12_16005;

												BgL_z12denvz12_16005 = BGL_CURRENT_DYNAMIC_ENV();
												BGL_ENV_SET_TRACE_LOCATION(BgL_z12denvz12_16005,
													BgL_locz00_13738);
												if (((BgL_spz00_15990 + (long) CINT(BgL_sfz00_15989)) <
														VECTOR_LENGTH(((obj_t) BgL_sz00_13741))))
													{	/* Eval/evaluate_comp.scm 896 */
														return
															BGl_catchzd2trampolinezd2zz__evaluate_compz00
															(BgL_runz00_15988, BgL_sz00_13741,
															BINT(BgL_spz00_15990));
													}
												else
													{	/* Eval/evaluate_comp.scm 896 */
														obj_t BgL_nsz00_16006;

														BgL_nsz00_16006 =
															BGl_makezd2statezd2zz__evaluate_compz00();
														{	/* Eval/evaluate_comp.scm 896 */
															long BgL_arg2170z00_16007;

															BgL_arg2170z00_16007 =
																(BgL_spz00_15990 + ((long) 2));
															BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00
																(BgL_nsz00_16006, ((long) 2), BgL_sz00_13741,
																BINT(BgL_spz00_15990),
																BINT(BgL_arg2170z00_16007));
														}
														VECTOR_SET(BgL_nsz00_16006, ((long) 1),
															BgL_sz00_13741);
														BGL_ENV_EVSTATE_SET(BgL_z12denvz12_16005,
															BgL_nsz00_16006);
														{	/* Eval/evaluate_comp.scm 896 */
															obj_t BgL_ez00_16008;

															BgL_ez00_16008 = BGL_EXITD_TOP_AS_OBJ();
															BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
																(BgL_ez00_16008, BgL_sz00_13741);
															{	/* Eval/evaluate_comp.scm 896 */
																obj_t BgL_____rz00_16009;

																{	/* Eval/evaluate_comp.scm 670 */
																	obj_t BgL_savedzd2bpzd2_16010;

																	BgL_savedzd2bpzd2_16010 =
																		VECTOR_REF(BgL_nsz00_16006, ((long) 0));
																	VECTOR_SET(BgL_nsz00_16006, ((long) 0),
																		BINT(((long) 2)));
																	{
																		obj_t BgL_fz00_16012;

																		BgL_fz00_16012 = BgL_runz00_15988;
																	BgL_recz00_16011:
																		{	/* Eval/evaluate_comp.scm 673 */
																			obj_t BgL_rz00_16013;

																			BgL_rz00_16013 =
																				PROCEDURE_ENTRY(BgL_fz00_16012)
																				(BgL_fz00_16012, BgL_nsz00_16006, BEOA);
																			{	/* Eval/evaluate_comp.scm 674 */
																				bool_t BgL_test6306z00_21534;

																				if (PROCEDUREP(BgL_rz00_16013))
																					{	/* Eval/evaluate_comp.scm 674 */
																						obj_t BgL_arg1702z00_16014;

																						BgL_arg1702z00_16014 =
																							PROCEDURE_ATTR(BgL_rz00_16013);
																						if (STRUCTP(BgL_arg1702z00_16014))
																							{	/* Eval/evaluate_comp.scm 654 */
																								BgL_test6306z00_21534 =
																									(STRUCT_KEY
																									(BgL_arg1702z00_16014) ==
																									BGl_symbol5803z00zz__evaluate_compz00);
																							}
																						else
																							{	/* Eval/evaluate_comp.scm 654 */
																								BgL_test6306z00_21534 =
																									((bool_t) 0);
																							}
																					}
																				else
																					{	/* Eval/evaluate_comp.scm 674 */
																						BgL_test6306z00_21534 =
																							((bool_t) 0);
																					}
																				if (BgL_test6306z00_21534)
																					{
																						obj_t BgL_fz00_21542;

																						BgL_fz00_21542 = BgL_rz00_16013;
																						BgL_fz00_16012 = BgL_fz00_21542;
																						goto BgL_recz00_16011;
																					}
																				else
																					{	/* Eval/evaluate_comp.scm 674 */
																						VECTOR_SET(BgL_nsz00_16006,
																							((long) 0),
																							BgL_savedzd2bpzd2_16010);
																						BgL_____rz00_16009 = BgL_rz00_16013;
																}}}}}
																BGl_exitdzd2popzd2protectz12z12zz__bexitz00
																	(BgL_ez00_16008);
																BGL_ENV_EVSTATE_SET(BgL_z12denvz12_16005,
																	BgL_sz00_13741);
																return BgL_____rz00_16009;
															}
														}
													}
											}
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 896 */
										if (PROCEDURE_CORRECT_ARITYP(BgL_fz00_15983,
												(int) (((long) 2))))
											{	/* Eval/evaluate_comp.scm 896 */
												long BgL_nbpz00_16015;

												BgL_nbpz00_16015 =
													((long) CINT(BgL_bpz00_15982) + BgL_siza7eza7_13740);
												VECTOR_SET(
													((obj_t) BgL_sz00_13741), ((long) 0),
													BINT(BgL_nbpz00_16015));
												{	/* Eval/evaluate_comp.scm 896 */
													obj_t BgL_tmpz00_21554;

													BgL_tmpz00_21554 = BGL_CURRENT_DYNAMIC_ENV();
													BGL_ENV_SET_TRACE_LOCATION(BgL_tmpz00_21554,
														BgL_locz00_13738);
												}
												{	/* Eval/evaluate_comp.scm 896 */
													obj_t BgL_rz00_16016;

													BgL_rz00_16016 =
														PROCEDURE_ENTRY(BgL_fz00_15983) (BgL_fz00_15983,
														BgL_a1z00_15984, BgL_a2z00_15985, BEOA);
													VECTOR_SET(((obj_t) BgL_sz00_13741), ((long) 0),
														BgL_bpz00_15982);
													return BgL_rz00_16016;
												}
											}
										else
											{	/* Eval/evaluate_comp.scm 896 */
												return
													BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_13738,
													BgL_symbzd2funzd2_13739, (int) (((long) 2)),
													PROCEDURE_ARITY(BgL_fz00_15983));
		}}}}}}}}

	}



/* &<@anonymous:2174> */
	obj_t BGl_z62zc3z04anonymousza32174ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_13742, obj_t BgL_sz00_13749)
	{
		{	/* Eval/evaluate_comp.scm 896 */
			{	/* Eval/evaluate_comp.scm 896 */
				obj_t BgL_funz00_13743;
				obj_t BgL_a1z00_13744;
				obj_t BgL_a2z00_13745;
				obj_t BgL_locz00_13746;
				obj_t BgL_symbzd2funzd2_13747;
				long BgL_siza7eza7_13748;

				BgL_funz00_13743 = PROCEDURE_REF(BgL_envz00_13742, (int) (((long) 0)));
				BgL_a1z00_13744 = PROCEDURE_REF(BgL_envz00_13742, (int) (((long) 1)));
				BgL_a2z00_13745 = PROCEDURE_REF(BgL_envz00_13742, (int) (((long) 2)));
				BgL_locz00_13746 = PROCEDURE_REF(BgL_envz00_13742, (int) (((long) 3)));
				BgL_symbzd2funzd2_13747 =
					PROCEDURE_REF(BgL_envz00_13742, (int) (((long) 4)));
				BgL_siza7eza7_13748 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13742, (int) (((long) 5))));
				{	/* Eval/evaluate_comp.scm 896 */
					obj_t BgL_bpz00_16017;

					BgL_bpz00_16017 = VECTOR_REF(((obj_t) BgL_sz00_13749), ((long) 0));
					{	/* Eval/evaluate_comp.scm 896 */
						obj_t BgL_fz00_16018;
						obj_t BgL_a1z00_16019;
						obj_t BgL_a2z00_16020;

						BgL_fz00_16018 =
							PROCEDURE_ENTRY(BgL_funz00_13743) (BgL_funz00_13743,
							BgL_sz00_13749, BEOA);
						BgL_a1z00_16019 =
							PROCEDURE_ENTRY(BgL_a1z00_13744) (BgL_a1z00_13744, BgL_sz00_13749,
							BEOA);
						BgL_a2z00_16020 =
							PROCEDURE_ENTRY(BgL_a2z00_13745) (BgL_a2z00_13745, BgL_sz00_13749,
							BEOA);
						if (PROCEDUREP(BgL_fz00_16018))
							{	/* Eval/evaluate_comp.scm 896 */
								BFALSE;
							}
						else
							{	/* Eval/evaluate_comp.scm 896 */
								BGl_evtypezd2errorzd2zz__everrorz00(BgL_locz00_13746,
									BGl_string5807z00zz__evaluate_compz00,
									BGl_string5823z00zz__evaluate_compz00, BgL_fz00_16018);
							}
						{	/* Eval/evaluate_comp.scm 896 */
							obj_t BgL_ufz00_16021;

							{	/* Eval/evaluate_comp.scm 896 */
								obj_t BgL_tmpz00_21597;

								BgL_tmpz00_21597 = ((obj_t) BgL_fz00_16018);
								BgL_ufz00_16021 = PROCEDURE_ATTR(BgL_tmpz00_21597);
							}
							{	/* Eval/evaluate_comp.scm 896 */
								bool_t BgL_test6311z00_21600;

								if (STRUCTP(BgL_ufz00_16021))
									{	/* Eval/evaluate_comp.scm 683 */
										BgL_test6311z00_21600 =
											(STRUCT_KEY(BgL_ufz00_16021) ==
											BGl_symbol5824z00zz__evaluate_compz00);
									}
								else
									{	/* Eval/evaluate_comp.scm 683 */
										BgL_test6311z00_21600 = ((bool_t) 0);
									}
								if (BgL_test6311z00_21600)
									{	/* Eval/evaluate_comp.scm 896 */
										obj_t BgL_arityz00_16022;
										obj_t BgL_runz00_16023;
										obj_t BgL_sfz00_16024;

										BgL_arityz00_16022 =
											STRUCT_REF(BgL_ufz00_16021, (int) (((long) 0)));
										BgL_runz00_16023 =
											STRUCT_REF(BgL_ufz00_16021, (int) (((long) 1)));
										BgL_sfz00_16024 =
											STRUCT_REF(BgL_ufz00_16021, (int) (((long) 2)));
										{	/* Eval/evaluate_comp.scm 896 */
											long BgL_spz00_16025;

											BgL_spz00_16025 =
												((long) CINT(BgL_bpz00_16017) + BgL_siza7eza7_13748);
											if (((long) CINT(BgL_arityz00_16022) == ((long) 2)))
												{	/* Eval/evaluate_comp.scm 896 */
													{	/* Eval/evaluate_comp.scm 896 */
														long BgL_arg2178z00_16026;

														BgL_arg2178z00_16026 =
															(BgL_spz00_16025 + ((long) 0));
														VECTOR_SET(
															((obj_t) BgL_sz00_13749), BgL_arg2178z00_16026,
															BgL_a1z00_16019);
													}
													{	/* Eval/evaluate_comp.scm 896 */
														long BgL_arg2179z00_16027;

														BgL_arg2179z00_16027 =
															(BgL_spz00_16025 + ((long) 1));
														VECTOR_SET(
															((obj_t) BgL_sz00_13749), BgL_arg2179z00_16027,
															BgL_a2z00_16020);
												}}
											else
												{	/* Eval/evaluate_comp.scm 896 */
													if (INTEGERP(BgL_arityz00_16022))
														{	/* Eval/evaluate_comp.scm 896 */
															switch ((long) CINT(BgL_arityz00_16022))
																{
																case ((long) -1):

																	{	/* Eval/evaluate_comp.scm 896 */
																		long BgL_arg2181z00_16028;
																		obj_t BgL_arg2182z00_16029;

																		BgL_arg2181z00_16028 =
																			(BgL_spz00_16025 + ((long) 0));
																		{	/* Eval/evaluate_comp.scm 896 */
																			obj_t BgL_list2183z00_16030;

																			{	/* Eval/evaluate_comp.scm 896 */
																				obj_t BgL_arg2184z00_16031;

																				BgL_arg2184z00_16031 =
																					MAKE_YOUNG_PAIR(BgL_a2z00_16020,
																					BNIL);
																				BgL_list2183z00_16030 =
																					MAKE_YOUNG_PAIR(BgL_a1z00_16019,
																					BgL_arg2184z00_16031);
																			}
																			BgL_arg2182z00_16029 =
																				BgL_list2183z00_16030;
																		}
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13749),
																			BgL_arg2181z00_16028,
																			BgL_arg2182z00_16029);
																	} break;
																case ((long) -2):

																	{	/* Eval/evaluate_comp.scm 896 */
																		long BgL_arg2185z00_16032;

																		BgL_arg2185z00_16032 =
																			(BgL_spz00_16025 + ((long) 0));
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13749),
																			BgL_arg2185z00_16032, BgL_a1z00_16019);
																	}
																	{	/* Eval/evaluate_comp.scm 896 */
																		long BgL_arg2186z00_16033;
																		obj_t BgL_arg2187z00_16034;

																		BgL_arg2186z00_16033 =
																			(BgL_spz00_16025 + ((long) 1));
																		{	/* Eval/evaluate_comp.scm 896 */
																			obj_t BgL_list2188z00_16035;

																			BgL_list2188z00_16035 =
																				MAKE_YOUNG_PAIR(BgL_a2z00_16020, BNIL);
																			BgL_arg2187z00_16034 =
																				BgL_list2188z00_16035;
																		}
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13749),
																			BgL_arg2186z00_16033,
																			BgL_arg2187z00_16034);
																	} break;
																case ((long) -3):

																	{	/* Eval/evaluate_comp.scm 896 */
																		long BgL_arg2189z00_16036;

																		BgL_arg2189z00_16036 =
																			(BgL_spz00_16025 + ((long) 0));
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13749),
																			BgL_arg2189z00_16036, BgL_a1z00_16019);
																	}
																	{	/* Eval/evaluate_comp.scm 896 */
																		long BgL_arg2190z00_16037;

																		BgL_arg2190z00_16037 =
																			(BgL_spz00_16025 + ((long) 1));
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13749),
																			BgL_arg2190z00_16037, BgL_a2z00_16020);
																	}
																	{	/* Eval/evaluate_comp.scm 896 */
																		long BgL_arg2191z00_16038;
																		obj_t BgL_arg2192z00_16039;

																		BgL_arg2191z00_16038 =
																			(BgL_spz00_16025 + ((long) 2));
																		BgL_arg2192z00_16039 = BNIL;
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13749),
																			BgL_arg2191z00_16038,
																			BgL_arg2192z00_16039);
																	} break;
																default:
																	BGl_evarityzd2errorzd2zz__everrorz00
																		(BgL_locz00_13746,
																		STRUCT_REF(BgL_ufz00_16021,
																			(int) (((long) 3))), (int) (((long) 2)),
																		CINT(BgL_arityz00_16022));
														}}
													else
														{	/* Eval/evaluate_comp.scm 896 */
															BGl_evarityzd2errorzd2zz__everrorz00
																(BgL_locz00_13746, STRUCT_REF(BgL_ufz00_16021,
																	(int) (((long) 3))), (int) (((long) 2)),
																CINT(BgL_arityz00_16022));
												}}
											{	/* Eval/evaluate_comp.scm 896 */
												obj_t BgL_z12denvz12_16040;

												BgL_z12denvz12_16040 = BGL_CURRENT_DYNAMIC_ENV();
												if (
													((BgL_spz00_16025 +
															(long) CINT(BgL_sfz00_16024)) <
														VECTOR_LENGTH(((obj_t) BgL_sz00_13749))))
													{	/* Eval/evaluate_comp.scm 896 */
														return
															BGl_catchzd2trampolinezd2zz__evaluate_compz00
															(BgL_runz00_16023, BgL_sz00_13749,
															BINT(BgL_spz00_16025));
													}
												else
													{	/* Eval/evaluate_comp.scm 896 */
														obj_t BgL_nsz00_16041;

														BgL_nsz00_16041 =
															BGl_makezd2statezd2zz__evaluate_compz00();
														{	/* Eval/evaluate_comp.scm 896 */
															long BgL_arg2196z00_16042;

															BgL_arg2196z00_16042 =
																(BgL_spz00_16025 + ((long) 2));
															BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00
																(BgL_nsz00_16041, ((long) 2), BgL_sz00_13749,
																BINT(BgL_spz00_16025),
																BINT(BgL_arg2196z00_16042));
														}
														VECTOR_SET(BgL_nsz00_16041, ((long) 1),
															BgL_sz00_13749);
														BGL_ENV_EVSTATE_SET(BgL_z12denvz12_16040,
															BgL_nsz00_16041);
														{	/* Eval/evaluate_comp.scm 896 */
															obj_t BgL_ez00_16043;

															BgL_ez00_16043 = BGL_EXITD_TOP_AS_OBJ();
															BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
																(BgL_ez00_16043, BgL_sz00_13749);
															{	/* Eval/evaluate_comp.scm 896 */
																obj_t BgL_____rz00_16044;

																{	/* Eval/evaluate_comp.scm 670 */
																	obj_t BgL_savedzd2bpzd2_16045;

																	BgL_savedzd2bpzd2_16045 =
																		VECTOR_REF(BgL_nsz00_16041, ((long) 0));
																	VECTOR_SET(BgL_nsz00_16041, ((long) 0),
																		BINT(((long) 2)));
																	{
																		obj_t BgL_fz00_16047;

																		BgL_fz00_16047 = BgL_runz00_16023;
																	BgL_recz00_16046:
																		{	/* Eval/evaluate_comp.scm 673 */
																			obj_t BgL_rz00_16048;

																			BgL_rz00_16048 =
																				PROCEDURE_ENTRY(BgL_fz00_16047)
																				(BgL_fz00_16047, BgL_nsz00_16041, BEOA);
																			{	/* Eval/evaluate_comp.scm 674 */
																				bool_t BgL_test6316z00_21682;

																				if (PROCEDUREP(BgL_rz00_16048))
																					{	/* Eval/evaluate_comp.scm 674 */
																						obj_t BgL_arg1702z00_16049;

																						BgL_arg1702z00_16049 =
																							PROCEDURE_ATTR(BgL_rz00_16048);
																						if (STRUCTP(BgL_arg1702z00_16049))
																							{	/* Eval/evaluate_comp.scm 654 */
																								BgL_test6316z00_21682 =
																									(STRUCT_KEY
																									(BgL_arg1702z00_16049) ==
																									BGl_symbol5803z00zz__evaluate_compz00);
																							}
																						else
																							{	/* Eval/evaluate_comp.scm 654 */
																								BgL_test6316z00_21682 =
																									((bool_t) 0);
																							}
																					}
																				else
																					{	/* Eval/evaluate_comp.scm 674 */
																						BgL_test6316z00_21682 =
																							((bool_t) 0);
																					}
																				if (BgL_test6316z00_21682)
																					{
																						obj_t BgL_fz00_21690;

																						BgL_fz00_21690 = BgL_rz00_16048;
																						BgL_fz00_16047 = BgL_fz00_21690;
																						goto BgL_recz00_16046;
																					}
																				else
																					{	/* Eval/evaluate_comp.scm 674 */
																						VECTOR_SET(BgL_nsz00_16041,
																							((long) 0),
																							BgL_savedzd2bpzd2_16045);
																						BgL_____rz00_16044 = BgL_rz00_16048;
																}}}}}
																BGl_exitdzd2popzd2protectz12z12zz__bexitz00
																	(BgL_ez00_16043);
																BGL_ENV_EVSTATE_SET(BgL_z12denvz12_16040,
																	BgL_sz00_13749);
																return BgL_____rz00_16044;
															}
														}
													}
											}
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 896 */
										if (PROCEDURE_CORRECT_ARITYP(BgL_fz00_16018,
												(int) (((long) 2))))
											{	/* Eval/evaluate_comp.scm 896 */
												long BgL_nbpz00_16050;

												BgL_nbpz00_16050 =
													((long) CINT(BgL_bpz00_16017) + BgL_siza7eza7_13748);
												VECTOR_SET(
													((obj_t) BgL_sz00_13749), ((long) 0),
													BINT(BgL_nbpz00_16050));
												{	/* Eval/evaluate_comp.scm 896 */
													obj_t BgL_rz00_16051;

													BgL_rz00_16051 =
														PROCEDURE_ENTRY(BgL_fz00_16018) (BgL_fz00_16018,
														BgL_a1z00_16019, BgL_a2z00_16020, BEOA);
													VECTOR_SET(((obj_t) BgL_sz00_13749), ((long) 0),
														BgL_bpz00_16017);
													return BgL_rz00_16051;
												}
											}
										else
											{	/* Eval/evaluate_comp.scm 896 */
												return
													BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_13746,
													BgL_symbzd2funzd2_13747, (int) (((long) 2)),
													PROCEDURE_ARITY(BgL_fz00_16018));
		}}}}}}}}

	}



/* comp-call3 */
	obj_t BGl_compzd2call3zd2zz__evaluate_compz00(obj_t BgL_locz00_162,
		BgL_ev_exprz00_bglt BgL_vfunz00_163, obj_t BgL_symbzd2funzd2_164,
		obj_t BgL_funz00_165, obj_t BgL_tailzf3zf3_166, obj_t BgL_stkz00_167,
		long BgL_siza7eza7_168, obj_t BgL_a1z00_169, obj_t BgL_a2z00_170,
		obj_t BgL_a3z00_171)
	{
		{	/* Eval/evaluate_comp.scm 896 */
			{	/* Eval/evaluate_comp.scm 896 */
				obj_t BgL_cfunz00_2484;

				BgL_cfunz00_2484 =
					BGl_iszd2constantzd2funzf3zf3zz__evaluate_compz00(BgL_vfunz00_163,
					((long) 3), BgL_locz00_162, BgL_symbzd2funzd2_164);
				if (CBOOL(BgL_cfunz00_2484))
					{	/* Eval/evaluate_comp.scm 896 */
						bool_t BgL_test6321z00_21715;

						{	/* Eval/evaluate_comp.scm 896 */
							int BgL_arg2205z00_2504;

							BgL_arg2205z00_2504 = bgl_debug();
							BgL_test6321z00_21715 =
								BGl_2ze3ze3zz__r4_numbers_6_5z00(BINT(BgL_arg2205z00_2504),
								BINT(((long) 0)));
						}
						if (BgL_test6321z00_21715)
							{	/* Eval/evaluate_comp.scm 896 */
								obj_t BgL_zc3z04anonymousza32202ze3z87_13750;

								BgL_zc3z04anonymousza32202ze3z87_13750 =
									MAKE_FX_PROCEDURE
									(BGl_z62zc3z04anonymousza32202ze3ze5zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 6)));
								PROCEDURE_SET(BgL_zc3z04anonymousza32202ze3z87_13750,
									(int) (((long) 0)), BgL_a1z00_169);
								PROCEDURE_SET(BgL_zc3z04anonymousza32202ze3z87_13750,
									(int) (((long) 1)), BgL_a2z00_170);
								PROCEDURE_SET(BgL_zc3z04anonymousza32202ze3z87_13750,
									(int) (((long) 2)), BgL_a3z00_171);
								PROCEDURE_SET(BgL_zc3z04anonymousza32202ze3z87_13750,
									(int) (((long) 3)), BINT(BgL_siza7eza7_168));
								PROCEDURE_SET(BgL_zc3z04anonymousza32202ze3z87_13750,
									(int) (((long) 4)), BgL_locz00_162);
								PROCEDURE_SET(BgL_zc3z04anonymousza32202ze3z87_13750,
									(int) (((long) 5)), BgL_cfunz00_2484);
								return BgL_zc3z04anonymousza32202ze3z87_13750;
							}
						else
							{	/* Eval/evaluate_comp.scm 896 */
								obj_t BgL_zc3z04anonymousza32204ze3z87_13751;

								BgL_zc3z04anonymousza32204ze3z87_13751 =
									MAKE_FX_PROCEDURE
									(BGl_z62zc3z04anonymousza32204ze3ze5zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 5)));
								PROCEDURE_SET(BgL_zc3z04anonymousza32204ze3z87_13751,
									(int) (((long) 0)), BgL_a1z00_169);
								PROCEDURE_SET(BgL_zc3z04anonymousza32204ze3z87_13751,
									(int) (((long) 1)), BgL_a2z00_170);
								PROCEDURE_SET(BgL_zc3z04anonymousza32204ze3z87_13751,
									(int) (((long) 2)), BgL_a3z00_171);
								PROCEDURE_SET(BgL_zc3z04anonymousza32204ze3z87_13751,
									(int) (((long) 3)), BINT(BgL_siza7eza7_168));
								PROCEDURE_SET(BgL_zc3z04anonymousza32204ze3z87_13751,
									(int) (((long) 4)), BgL_cfunz00_2484);
								return BgL_zc3z04anonymousza32204ze3z87_13751;
							}
					}
				else
					{	/* Eval/evaluate_comp.scm 896 */
						if (CBOOL(BgL_tailzf3zf3_166))
							{	/* Eval/evaluate_comp.scm 896 */
								bool_t BgL_test6323z00_21752;

								{	/* Eval/evaluate_comp.scm 896 */
									int BgL_arg2281z00_2616;

									BgL_arg2281z00_2616 = bgl_debug();
									BgL_test6323z00_21752 =
										BGl_2ze3ze3zz__r4_numbers_6_5z00(BINT(BgL_arg2281z00_2616),
										BINT(((long) 0)));
								}
								if (BgL_test6323z00_21752)
									{	/* Eval/evaluate_comp.scm 896 */
										obj_t BgL_zc3z04anonymousza32208ze3z87_13752;

										BgL_zc3z04anonymousza32208ze3z87_13752 =
											MAKE_FX_PROCEDURE
											(BGl_z62zc3z04anonymousza32208ze3ze5zz__evaluate_compz00,
											(int) (((long) 1)), (int) (((long) 7)));
										PROCEDURE_SET(BgL_zc3z04anonymousza32208ze3z87_13752,
											(int) (((long) 0)), BgL_funz00_165);
										PROCEDURE_SET(BgL_zc3z04anonymousza32208ze3z87_13752,
											(int) (((long) 1)), BgL_a1z00_169);
										PROCEDURE_SET(BgL_zc3z04anonymousza32208ze3z87_13752,
											(int) (((long) 2)), BgL_a2z00_170);
										PROCEDURE_SET(BgL_zc3z04anonymousza32208ze3z87_13752,
											(int) (((long) 3)), BgL_a3z00_171);
										PROCEDURE_SET(BgL_zc3z04anonymousza32208ze3z87_13752,
											(int) (((long) 4)), BgL_locz00_162);
										PROCEDURE_SET(BgL_zc3z04anonymousza32208ze3z87_13752,
											(int) (((long) 5)), BgL_symbzd2funzd2_164);
										PROCEDURE_SET(BgL_zc3z04anonymousza32208ze3z87_13752,
											(int) (((long) 6)), BINT(BgL_siza7eza7_168));
										return BgL_zc3z04anonymousza32208ze3z87_13752;
									}
								else
									{	/* Eval/evaluate_comp.scm 896 */
										obj_t BgL_zc3z04anonymousza32244ze3z87_13753;

										BgL_zc3z04anonymousza32244ze3z87_13753 =
											MAKE_FX_PROCEDURE
											(BGl_z62zc3z04anonymousza32244ze3ze5zz__evaluate_compz00,
											(int) (((long) 1)), (int) (((long) 7)));
										PROCEDURE_SET(BgL_zc3z04anonymousza32244ze3z87_13753,
											(int) (((long) 0)), BgL_funz00_165);
										PROCEDURE_SET(BgL_zc3z04anonymousza32244ze3z87_13753,
											(int) (((long) 1)), BgL_a1z00_169);
										PROCEDURE_SET(BgL_zc3z04anonymousza32244ze3z87_13753,
											(int) (((long) 2)), BgL_a2z00_170);
										PROCEDURE_SET(BgL_zc3z04anonymousza32244ze3z87_13753,
											(int) (((long) 3)), BgL_a3z00_171);
										PROCEDURE_SET(BgL_zc3z04anonymousza32244ze3z87_13753,
											(int) (((long) 4)), BgL_locz00_162);
										PROCEDURE_SET(BgL_zc3z04anonymousza32244ze3z87_13753,
											(int) (((long) 5)), BgL_symbzd2funzd2_164);
										PROCEDURE_SET(BgL_zc3z04anonymousza32244ze3z87_13753,
											(int) (((long) 6)), BINT(BgL_siza7eza7_168));
										return BgL_zc3z04anonymousza32244ze3z87_13753;
									}
							}
						else
							{	/* Eval/evaluate_comp.scm 896 */
								bool_t BgL_test6324z00_21793;

								{	/* Eval/evaluate_comp.scm 896 */
									int BgL_arg2359z00_2728;

									BgL_arg2359z00_2728 = bgl_debug();
									BgL_test6324z00_21793 =
										BGl_2ze3ze3zz__r4_numbers_6_5z00(BINT(BgL_arg2359z00_2728),
										BINT(((long) 0)));
								}
								if (BgL_test6324z00_21793)
									{	/* Eval/evaluate_comp.scm 896 */
										obj_t BgL_zc3z04anonymousza32284ze3z87_13754;

										BgL_zc3z04anonymousza32284ze3z87_13754 =
											MAKE_FX_PROCEDURE
											(BGl_z62zc3z04anonymousza32284ze3ze5zz__evaluate_compz00,
											(int) (((long) 1)), (int) (((long) 7)));
										PROCEDURE_SET(BgL_zc3z04anonymousza32284ze3z87_13754,
											(int) (((long) 0)), BgL_funz00_165);
										PROCEDURE_SET(BgL_zc3z04anonymousza32284ze3z87_13754,
											(int) (((long) 1)), BgL_a1z00_169);
										PROCEDURE_SET(BgL_zc3z04anonymousza32284ze3z87_13754,
											(int) (((long) 2)), BgL_a2z00_170);
										PROCEDURE_SET(BgL_zc3z04anonymousza32284ze3z87_13754,
											(int) (((long) 3)), BgL_a3z00_171);
										PROCEDURE_SET(BgL_zc3z04anonymousza32284ze3z87_13754,
											(int) (((long) 4)), BgL_locz00_162);
										PROCEDURE_SET(BgL_zc3z04anonymousza32284ze3z87_13754,
											(int) (((long) 5)), BgL_symbzd2funzd2_164);
										PROCEDURE_SET(BgL_zc3z04anonymousza32284ze3z87_13754,
											(int) (((long) 6)), BINT(BgL_siza7eza7_168));
										return BgL_zc3z04anonymousza32284ze3z87_13754;
									}
								else
									{	/* Eval/evaluate_comp.scm 896 */
										obj_t BgL_zc3z04anonymousza32324ze3z87_13755;

										BgL_zc3z04anonymousza32324ze3z87_13755 =
											MAKE_FX_PROCEDURE
											(BGl_z62zc3z04anonymousza32324ze3ze5zz__evaluate_compz00,
											(int) (((long) 1)), (int) (((long) 7)));
										PROCEDURE_SET(BgL_zc3z04anonymousza32324ze3z87_13755,
											(int) (((long) 0)), BgL_funz00_165);
										PROCEDURE_SET(BgL_zc3z04anonymousza32324ze3z87_13755,
											(int) (((long) 1)), BgL_a1z00_169);
										PROCEDURE_SET(BgL_zc3z04anonymousza32324ze3z87_13755,
											(int) (((long) 2)), BgL_a2z00_170);
										PROCEDURE_SET(BgL_zc3z04anonymousza32324ze3z87_13755,
											(int) (((long) 3)), BgL_a3z00_171);
										PROCEDURE_SET(BgL_zc3z04anonymousza32324ze3z87_13755,
											(int) (((long) 4)), BgL_locz00_162);
										PROCEDURE_SET(BgL_zc3z04anonymousza32324ze3z87_13755,
											(int) (((long) 5)), BgL_symbzd2funzd2_164);
										PROCEDURE_SET(BgL_zc3z04anonymousza32324ze3z87_13755,
											(int) (((long) 6)), BINT(BgL_siza7eza7_168));
										return BgL_zc3z04anonymousza32324ze3z87_13755;
									}
							}
					}
			}
		}

	}



/* &<@anonymous:2202> */
	obj_t BGl_z62zc3z04anonymousza32202ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_13756, obj_t BgL_sz00_13763)
	{
		{	/* Eval/evaluate_comp.scm 896 */
			{	/* Eval/evaluate_comp.scm 896 */
				obj_t BgL_a1z00_13757;
				obj_t BgL_a2z00_13758;
				obj_t BgL_a3z00_13759;
				long BgL_siza7eza7_13760;
				obj_t BgL_locz00_13761;
				obj_t BgL_cfunz00_13762;

				BgL_a1z00_13757 = PROCEDURE_REF(BgL_envz00_13756, (int) (((long) 0)));
				BgL_a2z00_13758 = PROCEDURE_REF(BgL_envz00_13756, (int) (((long) 1)));
				BgL_a3z00_13759 = PROCEDURE_REF(BgL_envz00_13756, (int) (((long) 2)));
				BgL_siza7eza7_13760 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13756, (int) (((long) 3))));
				BgL_locz00_13761 = PROCEDURE_REF(BgL_envz00_13756, (int) (((long) 4)));
				BgL_cfunz00_13762 = PROCEDURE_REF(BgL_envz00_13756, (int) (((long) 5)));
				{	/* Eval/evaluate_comp.scm 896 */
					obj_t BgL_bpz00_16052;

					BgL_bpz00_16052 = VECTOR_REF(((obj_t) BgL_sz00_13763), ((long) 0));
					{	/* Eval/evaluate_comp.scm 896 */
						obj_t BgL_a1z00_16053;
						obj_t BgL_a2z00_16054;
						obj_t BgL_a3z00_16055;

						BgL_a1z00_16053 =
							PROCEDURE_ENTRY(BgL_a1z00_13757) (BgL_a1z00_13757, BgL_sz00_13763,
							BEOA);
						BgL_a2z00_16054 =
							PROCEDURE_ENTRY(BgL_a2z00_13758) (BgL_a2z00_13758, BgL_sz00_13763,
							BEOA);
						BgL_a3z00_16055 =
							PROCEDURE_ENTRY(BgL_a3z00_13759) (BgL_a3z00_13759, BgL_sz00_13763,
							BEOA);
						{	/* Eval/evaluate_comp.scm 896 */
							long BgL_nbpz00_16056;

							BgL_nbpz00_16056 =
								((long) CINT(BgL_bpz00_16052) + BgL_siza7eza7_13760);
							VECTOR_SET(
								((obj_t) BgL_sz00_13763), ((long) 0), BINT(BgL_nbpz00_16056));
							{	/* Eval/evaluate_comp.scm 896 */
								obj_t BgL_tmpz00_21866;

								BgL_tmpz00_21866 = BGL_CURRENT_DYNAMIC_ENV();
								BGL_ENV_SET_TRACE_LOCATION(BgL_tmpz00_21866, BgL_locz00_13761);
							}
							{	/* Eval/evaluate_comp.scm 896 */
								obj_t BgL_rz00_16057;

								BgL_rz00_16057 =
									PROCEDURE_ENTRY(BgL_cfunz00_13762) (BgL_cfunz00_13762,
									BgL_a1z00_16053, BgL_a2z00_16054, BgL_a3z00_16055, BEOA);
								VECTOR_SET(((obj_t) BgL_sz00_13763), ((long) 0),
									BgL_bpz00_16052);
								return BgL_rz00_16057;
							}
						}
					}
				}
			}
		}

	}



/* &<@anonymous:2204> */
	obj_t BGl_z62zc3z04anonymousza32204ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_13764, obj_t BgL_sz00_13770)
	{
		{	/* Eval/evaluate_comp.scm 896 */
			{	/* Eval/evaluate_comp.scm 896 */
				obj_t BgL_a1z00_13765;
				obj_t BgL_a2z00_13766;
				obj_t BgL_a3z00_13767;
				long BgL_siza7eza7_13768;
				obj_t BgL_cfunz00_13769;

				BgL_a1z00_13765 = PROCEDURE_REF(BgL_envz00_13764, (int) (((long) 0)));
				BgL_a2z00_13766 = PROCEDURE_REF(BgL_envz00_13764, (int) (((long) 1)));
				BgL_a3z00_13767 = PROCEDURE_REF(BgL_envz00_13764, (int) (((long) 2)));
				BgL_siza7eza7_13768 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13764, (int) (((long) 3))));
				BgL_cfunz00_13769 = PROCEDURE_REF(BgL_envz00_13764, (int) (((long) 4)));
				{	/* Eval/evaluate_comp.scm 896 */
					obj_t BgL_bpz00_16058;

					BgL_bpz00_16058 = VECTOR_REF(((obj_t) BgL_sz00_13770), ((long) 0));
					{	/* Eval/evaluate_comp.scm 896 */
						obj_t BgL_a1z00_16059;
						obj_t BgL_a2z00_16060;
						obj_t BgL_a3z00_16061;

						BgL_a1z00_16059 =
							PROCEDURE_ENTRY(BgL_a1z00_13765) (BgL_a1z00_13765, BgL_sz00_13770,
							BEOA);
						BgL_a2z00_16060 =
							PROCEDURE_ENTRY(BgL_a2z00_13766) (BgL_a2z00_13766, BgL_sz00_13770,
							BEOA);
						BgL_a3z00_16061 =
							PROCEDURE_ENTRY(BgL_a3z00_13767) (BgL_a3z00_13767, BgL_sz00_13770,
							BEOA);
						{	/* Eval/evaluate_comp.scm 896 */
							long BgL_nbpz00_16062;

							BgL_nbpz00_16062 =
								((long) CINT(BgL_bpz00_16058) + BgL_siza7eza7_13768);
							VECTOR_SET(
								((obj_t) BgL_sz00_13770), ((long) 0), BINT(BgL_nbpz00_16062));
							{	/* Eval/evaluate_comp.scm 896 */
								obj_t BgL_rz00_16063;

								BgL_rz00_16063 =
									PROCEDURE_ENTRY(BgL_cfunz00_13769) (BgL_cfunz00_13769,
									BgL_a1z00_16059, BgL_a2z00_16060, BgL_a3z00_16061, BEOA);
								VECTOR_SET(((obj_t) BgL_sz00_13770), ((long) 0),
									BgL_bpz00_16058);
								return BgL_rz00_16063;
							}
						}
					}
				}
			}
		}

	}



/* &<@anonymous:2208> */
	obj_t BGl_z62zc3z04anonymousza32208ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_13771, obj_t BgL_sz00_13779)
	{
		{	/* Eval/evaluate_comp.scm 896 */
			{	/* Eval/evaluate_comp.scm 896 */
				obj_t BgL_funz00_13772;
				obj_t BgL_a1z00_13773;
				obj_t BgL_a2z00_13774;
				obj_t BgL_a3z00_13775;
				obj_t BgL_locz00_13776;
				obj_t BgL_symbzd2funzd2_13777;
				long BgL_siza7eza7_13778;

				BgL_funz00_13772 = PROCEDURE_REF(BgL_envz00_13771, (int) (((long) 0)));
				BgL_a1z00_13773 = PROCEDURE_REF(BgL_envz00_13771, (int) (((long) 1)));
				BgL_a2z00_13774 = PROCEDURE_REF(BgL_envz00_13771, (int) (((long) 2)));
				BgL_a3z00_13775 = PROCEDURE_REF(BgL_envz00_13771, (int) (((long) 3)));
				BgL_locz00_13776 = PROCEDURE_REF(BgL_envz00_13771, (int) (((long) 4)));
				BgL_symbzd2funzd2_13777 =
					PROCEDURE_REF(BgL_envz00_13771, (int) (((long) 5)));
				BgL_siza7eza7_13778 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13771, (int) (((long) 6))));
				{	/* Eval/evaluate_comp.scm 896 */
					obj_t BgL_bpz00_16064;

					BgL_bpz00_16064 = VECTOR_REF(((obj_t) BgL_sz00_13779), ((long) 0));
					{	/* Eval/evaluate_comp.scm 896 */
						obj_t BgL_fz00_16065;
						obj_t BgL_a1z00_16066;
						obj_t BgL_a2z00_16067;
						obj_t BgL_a3z00_16068;

						BgL_fz00_16065 =
							PROCEDURE_ENTRY(BgL_funz00_13772) (BgL_funz00_13772,
							BgL_sz00_13779, BEOA);
						BgL_a1z00_16066 =
							PROCEDURE_ENTRY(BgL_a1z00_13773) (BgL_a1z00_13773, BgL_sz00_13779,
							BEOA);
						BgL_a2z00_16067 =
							PROCEDURE_ENTRY(BgL_a2z00_13774) (BgL_a2z00_13774, BgL_sz00_13779,
							BEOA);
						BgL_a3z00_16068 =
							PROCEDURE_ENTRY(BgL_a3z00_13775) (BgL_a3z00_13775, BgL_sz00_13779,
							BEOA);
						if (PROCEDUREP(BgL_fz00_16065))
							{	/* Eval/evaluate_comp.scm 896 */
								BFALSE;
							}
						else
							{	/* Eval/evaluate_comp.scm 896 */
								BGl_evtypezd2errorzd2zz__everrorz00(BgL_locz00_13776,
									BGl_string5807z00zz__evaluate_compz00,
									BGl_string5823z00zz__evaluate_compz00, BgL_fz00_16065);
							}
						{	/* Eval/evaluate_comp.scm 896 */
							obj_t BgL_ufz00_16069;

							{	/* Eval/evaluate_comp.scm 896 */
								obj_t BgL_tmpz00_21951;

								BgL_tmpz00_21951 = ((obj_t) BgL_fz00_16065);
								BgL_ufz00_16069 = PROCEDURE_ATTR(BgL_tmpz00_21951);
							}
							{	/* Eval/evaluate_comp.scm 896 */
								bool_t BgL_test6326z00_21954;

								if (STRUCTP(BgL_ufz00_16069))
									{	/* Eval/evaluate_comp.scm 683 */
										BgL_test6326z00_21954 =
											(STRUCT_KEY(BgL_ufz00_16069) ==
											BGl_symbol5824z00zz__evaluate_compz00);
									}
								else
									{	/* Eval/evaluate_comp.scm 683 */
										BgL_test6326z00_21954 = ((bool_t) 0);
									}
								if (BgL_test6326z00_21954)
									{	/* Eval/evaluate_comp.scm 896 */
										obj_t BgL_arityz00_16070;
										obj_t BgL_runz00_16071;
										obj_t BgL_sfz00_16072;

										BgL_arityz00_16070 =
											STRUCT_REF(BgL_ufz00_16069, (int) (((long) 0)));
										BgL_runz00_16071 =
											STRUCT_REF(BgL_ufz00_16069, (int) (((long) 1)));
										BgL_sfz00_16072 =
											STRUCT_REF(BgL_ufz00_16069, (int) (((long) 2)));
										if (((long) CINT(BgL_arityz00_16070) == ((long) 3)))
											{	/* Eval/evaluate_comp.scm 896 */
												{	/* Eval/evaluate_comp.scm 896 */
													long BgL_arg2212z00_16073;

													BgL_arg2212z00_16073 =
														((long) CINT(BgL_bpz00_16064) + ((long) 0));
													VECTOR_SET(
														((obj_t) BgL_sz00_13779), BgL_arg2212z00_16073,
														BgL_a1z00_16066);
												}
												{	/* Eval/evaluate_comp.scm 896 */
													long BgL_arg2213z00_16074;

													BgL_arg2213z00_16074 =
														((long) CINT(BgL_bpz00_16064) + ((long) 1));
													VECTOR_SET(
														((obj_t) BgL_sz00_13779), BgL_arg2213z00_16074,
														BgL_a2z00_16067);
												}
												{	/* Eval/evaluate_comp.scm 896 */
													long BgL_arg2214z00_16075;

													BgL_arg2214z00_16075 =
														((long) CINT(BgL_bpz00_16064) + ((long) 2));
													VECTOR_SET(
														((obj_t) BgL_sz00_13779), BgL_arg2214z00_16075,
														BgL_a3z00_16068);
											}}
										else
											{	/* Eval/evaluate_comp.scm 896 */
												if (INTEGERP(BgL_arityz00_16070))
													{	/* Eval/evaluate_comp.scm 896 */
														switch ((long) CINT(BgL_arityz00_16070))
															{
															case ((long) -1):

																{	/* Eval/evaluate_comp.scm 896 */
																	long BgL_arg2216z00_16076;
																	obj_t BgL_arg2217z00_16077;

																	BgL_arg2216z00_16076 =
																		((long) CINT(BgL_bpz00_16064) + ((long) 0));
																	{	/* Eval/evaluate_comp.scm 896 */
																		obj_t BgL_list2218z00_16078;

																		{	/* Eval/evaluate_comp.scm 896 */
																			obj_t BgL_arg2219z00_16079;

																			{	/* Eval/evaluate_comp.scm 896 */
																				obj_t BgL_arg2220z00_16080;

																				BgL_arg2220z00_16080 =
																					MAKE_YOUNG_PAIR(BgL_a3z00_16068,
																					BNIL);
																				BgL_arg2219z00_16079 =
																					MAKE_YOUNG_PAIR(BgL_a2z00_16067,
																					BgL_arg2220z00_16080);
																			}
																			BgL_list2218z00_16078 =
																				MAKE_YOUNG_PAIR(BgL_a1z00_16066,
																				BgL_arg2219z00_16079);
																		}
																		BgL_arg2217z00_16077 =
																			BgL_list2218z00_16078;
																	}
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13779),
																		BgL_arg2216z00_16076, BgL_arg2217z00_16077);
																} break;
															case ((long) -2):

																{	/* Eval/evaluate_comp.scm 896 */
																	long BgL_arg2222z00_16081;

																	BgL_arg2222z00_16081 =
																		((long) CINT(BgL_bpz00_16064) + ((long) 0));
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13779),
																		BgL_arg2222z00_16081, BgL_a1z00_16066);
																}
																{	/* Eval/evaluate_comp.scm 896 */
																	long BgL_arg2223z00_16082;
																	obj_t BgL_arg2224z00_16083;

																	BgL_arg2223z00_16082 =
																		((long) CINT(BgL_bpz00_16064) + ((long) 1));
																	{	/* Eval/evaluate_comp.scm 896 */
																		obj_t BgL_list2225z00_16084;

																		{	/* Eval/evaluate_comp.scm 896 */
																			obj_t BgL_arg2226z00_16085;

																			BgL_arg2226z00_16085 =
																				MAKE_YOUNG_PAIR(BgL_a3z00_16068, BNIL);
																			BgL_list2225z00_16084 =
																				MAKE_YOUNG_PAIR(BgL_a2z00_16067,
																				BgL_arg2226z00_16085);
																		}
																		BgL_arg2224z00_16083 =
																			BgL_list2225z00_16084;
																	}
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13779),
																		BgL_arg2223z00_16082, BgL_arg2224z00_16083);
																} break;
															case ((long) -3):

																{	/* Eval/evaluate_comp.scm 896 */
																	long BgL_arg2227z00_16086;

																	BgL_arg2227z00_16086 =
																		((long) CINT(BgL_bpz00_16064) + ((long) 0));
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13779),
																		BgL_arg2227z00_16086, BgL_a1z00_16066);
																}
																{	/* Eval/evaluate_comp.scm 896 */
																	long BgL_arg2228z00_16087;

																	BgL_arg2228z00_16087 =
																		((long) CINT(BgL_bpz00_16064) + ((long) 1));
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13779),
																		BgL_arg2228z00_16087, BgL_a2z00_16067);
																}
																{	/* Eval/evaluate_comp.scm 896 */
																	long BgL_arg2229z00_16088;
																	obj_t BgL_arg2230z00_16089;

																	BgL_arg2229z00_16088 =
																		((long) CINT(BgL_bpz00_16064) + ((long) 2));
																	{	/* Eval/evaluate_comp.scm 896 */
																		obj_t BgL_list2231z00_16090;

																		BgL_list2231z00_16090 =
																			MAKE_YOUNG_PAIR(BgL_a3z00_16068, BNIL);
																		BgL_arg2230z00_16089 =
																			BgL_list2231z00_16090;
																	}
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13779),
																		BgL_arg2229z00_16088, BgL_arg2230z00_16089);
																} break;
															case ((long) -4):

																{	/* Eval/evaluate_comp.scm 896 */
																	long BgL_arg2232z00_16091;

																	BgL_arg2232z00_16091 =
																		((long) CINT(BgL_bpz00_16064) + ((long) 0));
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13779),
																		BgL_arg2232z00_16091, BgL_a1z00_16066);
																}
																{	/* Eval/evaluate_comp.scm 896 */
																	long BgL_arg2233z00_16092;

																	BgL_arg2233z00_16092 =
																		((long) CINT(BgL_bpz00_16064) + ((long) 1));
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13779),
																		BgL_arg2233z00_16092, BgL_a2z00_16067);
																}
																{	/* Eval/evaluate_comp.scm 896 */
																	long BgL_arg2234z00_16093;

																	BgL_arg2234z00_16093 =
																		((long) CINT(BgL_bpz00_16064) + ((long) 2));
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13779),
																		BgL_arg2234z00_16093, BgL_a3z00_16068);
																}
																{	/* Eval/evaluate_comp.scm 896 */
																	long BgL_arg2235z00_16094;
																	obj_t BgL_arg2236z00_16095;

																	BgL_arg2235z00_16094 =
																		((long) CINT(BgL_bpz00_16064) + ((long) 3));
																	BgL_arg2236z00_16095 = BNIL;
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13779),
																		BgL_arg2235z00_16094, BgL_arg2236z00_16095);
																} break;
															default:
																BGl_evarityzd2errorzd2zz__everrorz00
																	(BgL_locz00_13776, STRUCT_REF(BgL_ufz00_16069,
																		(int) (((long) 3))), (int) (((long) 3)),
																	CINT(BgL_arityz00_16070));
													}}
												else
													{	/* Eval/evaluate_comp.scm 896 */
														BGl_evarityzd2errorzd2zz__everrorz00
															(BgL_locz00_13776, STRUCT_REF(BgL_ufz00_16069,
																(int) (((long) 3))), (int) (((long) 3)),
															CINT(BgL_arityz00_16070));
											}}
										{	/* Eval/evaluate_comp.scm 896 */
											obj_t BgL_z12denvz12_16096;

											BgL_z12denvz12_16096 = BGL_CURRENT_DYNAMIC_ENV();
											BGL_ENV_SET_TRACE_LOCATION(BgL_z12denvz12_16096,
												BgL_locz00_13776);
											if ((((long) CINT(BgL_bpz00_16064) +
														(long) CINT(BgL_sfz00_16072)) <
													VECTOR_LENGTH(((obj_t) BgL_sz00_13779))))
												{	/* Eval/evaluate_comp.scm 896 */
													return BgL_runz00_16071;
												}
											else
												{	/* Eval/evaluate_comp.scm 896 */
													obj_t BgL_nsz00_16097;

													BgL_nsz00_16097 =
														BGl_makezd2statezd2zz__evaluate_compz00();
													{	/* Eval/evaluate_comp.scm 896 */
														long BgL_arg2240z00_16098;

														BgL_arg2240z00_16098 =
															((long) CINT(BgL_bpz00_16064) + ((long) 3));
														BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00
															(BgL_nsz00_16097, ((long) 2), BgL_sz00_13779,
															BgL_bpz00_16064, BINT(BgL_arg2240z00_16098));
													}
													VECTOR_SET(BgL_nsz00_16097, ((long) 1),
														BgL_sz00_13779);
													BGL_ENV_EVSTATE_SET(BgL_z12denvz12_16096,
														BgL_nsz00_16097);
													{	/* Eval/evaluate_comp.scm 896 */
														obj_t BgL_ez00_16099;

														BgL_ez00_16099 = BGL_EXITD_TOP_AS_OBJ();
														BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
															(BgL_ez00_16099, BgL_sz00_13779);
														{	/* Eval/evaluate_comp.scm 896 */
															obj_t BgL_____rz00_16100;

															{	/* Eval/evaluate_comp.scm 670 */
																obj_t BgL_savedzd2bpzd2_16101;

																BgL_savedzd2bpzd2_16101 =
																	VECTOR_REF(BgL_nsz00_16097, ((long) 0));
																VECTOR_SET(BgL_nsz00_16097, ((long) 0),
																	BINT(((long) 2)));
																{
																	obj_t BgL_fz00_16103;

																	BgL_fz00_16103 = BgL_runz00_16071;
																BgL_recz00_16102:
																	{	/* Eval/evaluate_comp.scm 673 */
																		obj_t BgL_rz00_16104;

																		BgL_rz00_16104 =
																			PROCEDURE_ENTRY(BgL_fz00_16103)
																			(BgL_fz00_16103, BgL_nsz00_16097, BEOA);
																		{	/* Eval/evaluate_comp.scm 674 */
																			bool_t BgL_test6331z00_22065;

																			if (PROCEDUREP(BgL_rz00_16104))
																				{	/* Eval/evaluate_comp.scm 674 */
																					obj_t BgL_arg1702z00_16105;

																					BgL_arg1702z00_16105 =
																						PROCEDURE_ATTR(BgL_rz00_16104);
																					if (STRUCTP(BgL_arg1702z00_16105))
																						{	/* Eval/evaluate_comp.scm 654 */
																							BgL_test6331z00_22065 =
																								(STRUCT_KEY
																								(BgL_arg1702z00_16105) ==
																								BGl_symbol5803z00zz__evaluate_compz00);
																						}
																					else
																						{	/* Eval/evaluate_comp.scm 654 */
																							BgL_test6331z00_22065 =
																								((bool_t) 0);
																						}
																				}
																			else
																				{	/* Eval/evaluate_comp.scm 674 */
																					BgL_test6331z00_22065 = ((bool_t) 0);
																				}
																			if (BgL_test6331z00_22065)
																				{
																					obj_t BgL_fz00_22073;

																					BgL_fz00_22073 = BgL_rz00_16104;
																					BgL_fz00_16103 = BgL_fz00_22073;
																					goto BgL_recz00_16102;
																				}
																			else
																				{	/* Eval/evaluate_comp.scm 674 */
																					VECTOR_SET(BgL_nsz00_16097,
																						((long) 0),
																						BgL_savedzd2bpzd2_16101);
																					BgL_____rz00_16100 = BgL_rz00_16104;
															}}}}}
															BGl_exitdzd2popzd2protectz12z12zz__bexitz00
																(BgL_ez00_16099);
															BGL_ENV_EVSTATE_SET(BgL_z12denvz12_16096,
																BgL_sz00_13779);
															return BgL_____rz00_16100;
														}
													}
												}
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 896 */
										if (PROCEDURE_CORRECT_ARITYP(BgL_fz00_16065,
												(int) (((long) 3))))
											{	/* Eval/evaluate_comp.scm 896 */
												long BgL_nbpz00_16106;

												BgL_nbpz00_16106 =
													((long) CINT(BgL_bpz00_16064) + BgL_siza7eza7_13778);
												VECTOR_SET(
													((obj_t) BgL_sz00_13779), ((long) 0),
													BINT(BgL_nbpz00_16106));
												{	/* Eval/evaluate_comp.scm 896 */
													obj_t BgL_tmpz00_22085;

													BgL_tmpz00_22085 = BGL_CURRENT_DYNAMIC_ENV();
													BGL_ENV_SET_TRACE_LOCATION(BgL_tmpz00_22085,
														BgL_locz00_13776);
												}
												{	/* Eval/evaluate_comp.scm 896 */
													obj_t BgL_rz00_16107;

													BgL_rz00_16107 =
														PROCEDURE_ENTRY(BgL_fz00_16065) (BgL_fz00_16065,
														BgL_a1z00_16066, BgL_a2z00_16067, BgL_a3z00_16068,
														BEOA);
													VECTOR_SET(((obj_t) BgL_sz00_13779), ((long) 0),
														BgL_bpz00_16064);
													return BgL_rz00_16107;
												}
											}
										else
											{	/* Eval/evaluate_comp.scm 896 */
												return
													BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_13776,
													BgL_symbzd2funzd2_13777, (int) (((long) 3)),
													PROCEDURE_ARITY(BgL_fz00_16065));
		}}}}}}}}

	}



/* &<@anonymous:2244> */
	obj_t BGl_z62zc3z04anonymousza32244ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_13780, obj_t BgL_sz00_13788)
	{
		{	/* Eval/evaluate_comp.scm 896 */
			{	/* Eval/evaluate_comp.scm 896 */
				obj_t BgL_funz00_13781;
				obj_t BgL_a1z00_13782;
				obj_t BgL_a2z00_13783;
				obj_t BgL_a3z00_13784;
				obj_t BgL_locz00_13785;
				obj_t BgL_symbzd2funzd2_13786;
				long BgL_siza7eza7_13787;

				BgL_funz00_13781 = PROCEDURE_REF(BgL_envz00_13780, (int) (((long) 0)));
				BgL_a1z00_13782 = PROCEDURE_REF(BgL_envz00_13780, (int) (((long) 1)));
				BgL_a2z00_13783 = PROCEDURE_REF(BgL_envz00_13780, (int) (((long) 2)));
				BgL_a3z00_13784 = PROCEDURE_REF(BgL_envz00_13780, (int) (((long) 3)));
				BgL_locz00_13785 = PROCEDURE_REF(BgL_envz00_13780, (int) (((long) 4)));
				BgL_symbzd2funzd2_13786 =
					PROCEDURE_REF(BgL_envz00_13780, (int) (((long) 5)));
				BgL_siza7eza7_13787 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13780, (int) (((long) 6))));
				{	/* Eval/evaluate_comp.scm 896 */
					obj_t BgL_bpz00_16108;

					BgL_bpz00_16108 = VECTOR_REF(((obj_t) BgL_sz00_13788), ((long) 0));
					{	/* Eval/evaluate_comp.scm 896 */
						obj_t BgL_fz00_16109;
						obj_t BgL_a1z00_16110;
						obj_t BgL_a2z00_16111;
						obj_t BgL_a3z00_16112;

						BgL_fz00_16109 =
							PROCEDURE_ENTRY(BgL_funz00_13781) (BgL_funz00_13781,
							BgL_sz00_13788, BEOA);
						BgL_a1z00_16110 =
							PROCEDURE_ENTRY(BgL_a1z00_13782) (BgL_a1z00_13782, BgL_sz00_13788,
							BEOA);
						BgL_a2z00_16111 =
							PROCEDURE_ENTRY(BgL_a2z00_13783) (BgL_a2z00_13783, BgL_sz00_13788,
							BEOA);
						BgL_a3z00_16112 =
							PROCEDURE_ENTRY(BgL_a3z00_13784) (BgL_a3z00_13784, BgL_sz00_13788,
							BEOA);
						if (PROCEDUREP(BgL_fz00_16109))
							{	/* Eval/evaluate_comp.scm 896 */
								BFALSE;
							}
						else
							{	/* Eval/evaluate_comp.scm 896 */
								BGl_evtypezd2errorzd2zz__everrorz00(BgL_locz00_13785,
									BGl_string5807z00zz__evaluate_compz00,
									BGl_string5823z00zz__evaluate_compz00, BgL_fz00_16109);
							}
						{	/* Eval/evaluate_comp.scm 896 */
							obj_t BgL_ufz00_16113;

							{	/* Eval/evaluate_comp.scm 896 */
								obj_t BgL_tmpz00_22135;

								BgL_tmpz00_22135 = ((obj_t) BgL_fz00_16109);
								BgL_ufz00_16113 = PROCEDURE_ATTR(BgL_tmpz00_22135);
							}
							{	/* Eval/evaluate_comp.scm 896 */
								bool_t BgL_test6336z00_22138;

								if (STRUCTP(BgL_ufz00_16113))
									{	/* Eval/evaluate_comp.scm 683 */
										BgL_test6336z00_22138 =
											(STRUCT_KEY(BgL_ufz00_16113) ==
											BGl_symbol5824z00zz__evaluate_compz00);
									}
								else
									{	/* Eval/evaluate_comp.scm 683 */
										BgL_test6336z00_22138 = ((bool_t) 0);
									}
								if (BgL_test6336z00_22138)
									{	/* Eval/evaluate_comp.scm 896 */
										obj_t BgL_arityz00_16114;
										obj_t BgL_runz00_16115;
										obj_t BgL_sfz00_16116;

										BgL_arityz00_16114 =
											STRUCT_REF(BgL_ufz00_16113, (int) (((long) 0)));
										BgL_runz00_16115 =
											STRUCT_REF(BgL_ufz00_16113, (int) (((long) 1)));
										BgL_sfz00_16116 =
											STRUCT_REF(BgL_ufz00_16113, (int) (((long) 2)));
										if (((long) CINT(BgL_arityz00_16114) == ((long) 3)))
											{	/* Eval/evaluate_comp.scm 896 */
												{	/* Eval/evaluate_comp.scm 896 */
													long BgL_arg2248z00_16117;

													BgL_arg2248z00_16117 =
														((long) CINT(BgL_bpz00_16108) + ((long) 0));
													VECTOR_SET(
														((obj_t) BgL_sz00_13788), BgL_arg2248z00_16117,
														BgL_a1z00_16110);
												}
												{	/* Eval/evaluate_comp.scm 896 */
													long BgL_arg2250z00_16118;

													BgL_arg2250z00_16118 =
														((long) CINT(BgL_bpz00_16108) + ((long) 1));
													VECTOR_SET(
														((obj_t) BgL_sz00_13788), BgL_arg2250z00_16118,
														BgL_a2z00_16111);
												}
												{	/* Eval/evaluate_comp.scm 896 */
													long BgL_arg2251z00_16119;

													BgL_arg2251z00_16119 =
														((long) CINT(BgL_bpz00_16108) + ((long) 2));
													VECTOR_SET(
														((obj_t) BgL_sz00_13788), BgL_arg2251z00_16119,
														BgL_a3z00_16112);
											}}
										else
											{	/* Eval/evaluate_comp.scm 896 */
												if (INTEGERP(BgL_arityz00_16114))
													{	/* Eval/evaluate_comp.scm 896 */
														switch ((long) CINT(BgL_arityz00_16114))
															{
															case ((long) -1):

																{	/* Eval/evaluate_comp.scm 896 */
																	long BgL_arg2253z00_16120;
																	obj_t BgL_arg2254z00_16121;

																	BgL_arg2253z00_16120 =
																		((long) CINT(BgL_bpz00_16108) + ((long) 0));
																	{	/* Eval/evaluate_comp.scm 896 */
																		obj_t BgL_list2255z00_16122;

																		{	/* Eval/evaluate_comp.scm 896 */
																			obj_t BgL_arg2256z00_16123;

																			{	/* Eval/evaluate_comp.scm 896 */
																				obj_t BgL_arg2257z00_16124;

																				BgL_arg2257z00_16124 =
																					MAKE_YOUNG_PAIR(BgL_a3z00_16112,
																					BNIL);
																				BgL_arg2256z00_16123 =
																					MAKE_YOUNG_PAIR(BgL_a2z00_16111,
																					BgL_arg2257z00_16124);
																			}
																			BgL_list2255z00_16122 =
																				MAKE_YOUNG_PAIR(BgL_a1z00_16110,
																				BgL_arg2256z00_16123);
																		}
																		BgL_arg2254z00_16121 =
																			BgL_list2255z00_16122;
																	}
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13788),
																		BgL_arg2253z00_16120, BgL_arg2254z00_16121);
																} break;
															case ((long) -2):

																{	/* Eval/evaluate_comp.scm 896 */
																	long BgL_arg2258z00_16125;

																	BgL_arg2258z00_16125 =
																		((long) CINT(BgL_bpz00_16108) + ((long) 0));
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13788),
																		BgL_arg2258z00_16125, BgL_a1z00_16110);
																}
																{	/* Eval/evaluate_comp.scm 896 */
																	long BgL_arg2259z00_16126;
																	obj_t BgL_arg2260z00_16127;

																	BgL_arg2259z00_16126 =
																		((long) CINT(BgL_bpz00_16108) + ((long) 1));
																	{	/* Eval/evaluate_comp.scm 896 */
																		obj_t BgL_list2261z00_16128;

																		{	/* Eval/evaluate_comp.scm 896 */
																			obj_t BgL_arg2262z00_16129;

																			BgL_arg2262z00_16129 =
																				MAKE_YOUNG_PAIR(BgL_a3z00_16112, BNIL);
																			BgL_list2261z00_16128 =
																				MAKE_YOUNG_PAIR(BgL_a2z00_16111,
																				BgL_arg2262z00_16129);
																		}
																		BgL_arg2260z00_16127 =
																			BgL_list2261z00_16128;
																	}
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13788),
																		BgL_arg2259z00_16126, BgL_arg2260z00_16127);
																} break;
															case ((long) -3):

																{	/* Eval/evaluate_comp.scm 896 */
																	long BgL_arg2263z00_16130;

																	BgL_arg2263z00_16130 =
																		((long) CINT(BgL_bpz00_16108) + ((long) 0));
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13788),
																		BgL_arg2263z00_16130, BgL_a1z00_16110);
																}
																{	/* Eval/evaluate_comp.scm 896 */
																	long BgL_arg2265z00_16131;

																	BgL_arg2265z00_16131 =
																		((long) CINT(BgL_bpz00_16108) + ((long) 1));
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13788),
																		BgL_arg2265z00_16131, BgL_a2z00_16111);
																}
																{	/* Eval/evaluate_comp.scm 896 */
																	long BgL_arg2266z00_16132;
																	obj_t BgL_arg2268z00_16133;

																	BgL_arg2266z00_16132 =
																		((long) CINT(BgL_bpz00_16108) + ((long) 2));
																	{	/* Eval/evaluate_comp.scm 896 */
																		obj_t BgL_list2269z00_16134;

																		BgL_list2269z00_16134 =
																			MAKE_YOUNG_PAIR(BgL_a3z00_16112, BNIL);
																		BgL_arg2268z00_16133 =
																			BgL_list2269z00_16134;
																	}
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13788),
																		BgL_arg2266z00_16132, BgL_arg2268z00_16133);
																} break;
															case ((long) -4):

																{	/* Eval/evaluate_comp.scm 896 */
																	long BgL_arg2270z00_16135;

																	BgL_arg2270z00_16135 =
																		((long) CINT(BgL_bpz00_16108) + ((long) 0));
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13788),
																		BgL_arg2270z00_16135, BgL_a1z00_16110);
																}
																{	/* Eval/evaluate_comp.scm 896 */
																	long BgL_arg2271z00_16136;

																	BgL_arg2271z00_16136 =
																		((long) CINT(BgL_bpz00_16108) + ((long) 1));
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13788),
																		BgL_arg2271z00_16136, BgL_a2z00_16111);
																}
																{	/* Eval/evaluate_comp.scm 896 */
																	long BgL_arg2272z00_16137;

																	BgL_arg2272z00_16137 =
																		((long) CINT(BgL_bpz00_16108) + ((long) 2));
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13788),
																		BgL_arg2272z00_16137, BgL_a3z00_16112);
																}
																{	/* Eval/evaluate_comp.scm 896 */
																	long BgL_arg2273z00_16138;
																	obj_t BgL_arg2274z00_16139;

																	BgL_arg2273z00_16138 =
																		((long) CINT(BgL_bpz00_16108) + ((long) 3));
																	BgL_arg2274z00_16139 = BNIL;
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13788),
																		BgL_arg2273z00_16138, BgL_arg2274z00_16139);
																} break;
															default:
																BGl_evarityzd2errorzd2zz__everrorz00
																	(BgL_locz00_13785, STRUCT_REF(BgL_ufz00_16113,
																		(int) (((long) 3))), (int) (((long) 3)),
																	CINT(BgL_arityz00_16114));
													}}
												else
													{	/* Eval/evaluate_comp.scm 896 */
														BGl_evarityzd2errorzd2zz__everrorz00
															(BgL_locz00_13785, STRUCT_REF(BgL_ufz00_16113,
																(int) (((long) 3))), (int) (((long) 3)),
															CINT(BgL_arityz00_16114));
											}}
										{	/* Eval/evaluate_comp.scm 896 */
											obj_t BgL_z12denvz12_16140;

											BgL_z12denvz12_16140 = BGL_CURRENT_DYNAMIC_ENV();
											if (
												(((long) CINT(BgL_bpz00_16108) +
														(long) CINT(BgL_sfz00_16116)) <
													VECTOR_LENGTH(((obj_t) BgL_sz00_13788))))
												{	/* Eval/evaluate_comp.scm 896 */
													return BgL_runz00_16115;
												}
											else
												{	/* Eval/evaluate_comp.scm 896 */
													obj_t BgL_nsz00_16141;

													BgL_nsz00_16141 =
														BGl_makezd2statezd2zz__evaluate_compz00();
													{	/* Eval/evaluate_comp.scm 896 */
														long BgL_arg2278z00_16142;

														BgL_arg2278z00_16142 =
															((long) CINT(BgL_bpz00_16108) + ((long) 3));
														BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00
															(BgL_nsz00_16141, ((long) 2), BgL_sz00_13788,
															BgL_bpz00_16108, BINT(BgL_arg2278z00_16142));
													}
													VECTOR_SET(BgL_nsz00_16141, ((long) 1),
														BgL_sz00_13788);
													BGL_ENV_EVSTATE_SET(BgL_z12denvz12_16140,
														BgL_nsz00_16141);
													{	/* Eval/evaluate_comp.scm 896 */
														obj_t BgL_ez00_16143;

														BgL_ez00_16143 = BGL_EXITD_TOP_AS_OBJ();
														BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
															(BgL_ez00_16143, BgL_sz00_13788);
														{	/* Eval/evaluate_comp.scm 896 */
															obj_t BgL_____rz00_16144;

															{	/* Eval/evaluate_comp.scm 670 */
																obj_t BgL_savedzd2bpzd2_16145;

																BgL_savedzd2bpzd2_16145 =
																	VECTOR_REF(BgL_nsz00_16141, ((long) 0));
																VECTOR_SET(BgL_nsz00_16141, ((long) 0),
																	BINT(((long) 2)));
																{
																	obj_t BgL_fz00_16147;

																	BgL_fz00_16147 = BgL_runz00_16115;
																BgL_recz00_16146:
																	{	/* Eval/evaluate_comp.scm 673 */
																		obj_t BgL_rz00_16148;

																		BgL_rz00_16148 =
																			PROCEDURE_ENTRY(BgL_fz00_16147)
																			(BgL_fz00_16147, BgL_nsz00_16141, BEOA);
																		{	/* Eval/evaluate_comp.scm 674 */
																			bool_t BgL_test6341z00_22248;

																			if (PROCEDUREP(BgL_rz00_16148))
																				{	/* Eval/evaluate_comp.scm 674 */
																					obj_t BgL_arg1702z00_16149;

																					BgL_arg1702z00_16149 =
																						PROCEDURE_ATTR(BgL_rz00_16148);
																					if (STRUCTP(BgL_arg1702z00_16149))
																						{	/* Eval/evaluate_comp.scm 654 */
																							BgL_test6341z00_22248 =
																								(STRUCT_KEY
																								(BgL_arg1702z00_16149) ==
																								BGl_symbol5803z00zz__evaluate_compz00);
																						}
																					else
																						{	/* Eval/evaluate_comp.scm 654 */
																							BgL_test6341z00_22248 =
																								((bool_t) 0);
																						}
																				}
																			else
																				{	/* Eval/evaluate_comp.scm 674 */
																					BgL_test6341z00_22248 = ((bool_t) 0);
																				}
																			if (BgL_test6341z00_22248)
																				{
																					obj_t BgL_fz00_22256;

																					BgL_fz00_22256 = BgL_rz00_16148;
																					BgL_fz00_16147 = BgL_fz00_22256;
																					goto BgL_recz00_16146;
																				}
																			else
																				{	/* Eval/evaluate_comp.scm 674 */
																					VECTOR_SET(BgL_nsz00_16141,
																						((long) 0),
																						BgL_savedzd2bpzd2_16145);
																					BgL_____rz00_16144 = BgL_rz00_16148;
															}}}}}
															BGl_exitdzd2popzd2protectz12z12zz__bexitz00
																(BgL_ez00_16143);
															BGL_ENV_EVSTATE_SET(BgL_z12denvz12_16140,
																BgL_sz00_13788);
															return BgL_____rz00_16144;
														}
													}
												}
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 896 */
										if (PROCEDURE_CORRECT_ARITYP(BgL_fz00_16109,
												(int) (((long) 3))))
											{	/* Eval/evaluate_comp.scm 896 */
												long BgL_nbpz00_16150;

												BgL_nbpz00_16150 =
													((long) CINT(BgL_bpz00_16108) + BgL_siza7eza7_13787);
												VECTOR_SET(
													((obj_t) BgL_sz00_13788), ((long) 0),
													BINT(BgL_nbpz00_16150));
												{	/* Eval/evaluate_comp.scm 896 */
													obj_t BgL_rz00_16151;

													BgL_rz00_16151 =
														PROCEDURE_ENTRY(BgL_fz00_16109) (BgL_fz00_16109,
														BgL_a1z00_16110, BgL_a2z00_16111, BgL_a3z00_16112,
														BEOA);
													VECTOR_SET(((obj_t) BgL_sz00_13788), ((long) 0),
														BgL_bpz00_16108);
													return BgL_rz00_16151;
												}
											}
										else
											{	/* Eval/evaluate_comp.scm 896 */
												return
													BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_13785,
													BgL_symbzd2funzd2_13786, (int) (((long) 3)),
													PROCEDURE_ARITY(BgL_fz00_16109));
		}}}}}}}}

	}



/* &<@anonymous:2284> */
	obj_t BGl_z62zc3z04anonymousza32284ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_13789, obj_t BgL_sz00_13797)
	{
		{	/* Eval/evaluate_comp.scm 896 */
			{	/* Eval/evaluate_comp.scm 896 */
				obj_t BgL_funz00_13790;
				obj_t BgL_a1z00_13791;
				obj_t BgL_a2z00_13792;
				obj_t BgL_a3z00_13793;
				obj_t BgL_locz00_13794;
				obj_t BgL_symbzd2funzd2_13795;
				long BgL_siza7eza7_13796;

				BgL_funz00_13790 = PROCEDURE_REF(BgL_envz00_13789, (int) (((long) 0)));
				BgL_a1z00_13791 = PROCEDURE_REF(BgL_envz00_13789, (int) (((long) 1)));
				BgL_a2z00_13792 = PROCEDURE_REF(BgL_envz00_13789, (int) (((long) 2)));
				BgL_a3z00_13793 = PROCEDURE_REF(BgL_envz00_13789, (int) (((long) 3)));
				BgL_locz00_13794 = PROCEDURE_REF(BgL_envz00_13789, (int) (((long) 4)));
				BgL_symbzd2funzd2_13795 =
					PROCEDURE_REF(BgL_envz00_13789, (int) (((long) 5)));
				BgL_siza7eza7_13796 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13789, (int) (((long) 6))));
				{	/* Eval/evaluate_comp.scm 896 */
					obj_t BgL_bpz00_16152;

					BgL_bpz00_16152 = VECTOR_REF(((obj_t) BgL_sz00_13797), ((long) 0));
					{	/* Eval/evaluate_comp.scm 896 */
						obj_t BgL_fz00_16153;
						obj_t BgL_a1z00_16154;
						obj_t BgL_a2z00_16155;
						obj_t BgL_a3z00_16156;

						BgL_fz00_16153 =
							PROCEDURE_ENTRY(BgL_funz00_13790) (BgL_funz00_13790,
							BgL_sz00_13797, BEOA);
						BgL_a1z00_16154 =
							PROCEDURE_ENTRY(BgL_a1z00_13791) (BgL_a1z00_13791, BgL_sz00_13797,
							BEOA);
						BgL_a2z00_16155 =
							PROCEDURE_ENTRY(BgL_a2z00_13792) (BgL_a2z00_13792, BgL_sz00_13797,
							BEOA);
						BgL_a3z00_16156 =
							PROCEDURE_ENTRY(BgL_a3z00_13793) (BgL_a3z00_13793, BgL_sz00_13797,
							BEOA);
						if (PROCEDUREP(BgL_fz00_16153))
							{	/* Eval/evaluate_comp.scm 896 */
								BFALSE;
							}
						else
							{	/* Eval/evaluate_comp.scm 896 */
								BGl_evtypezd2errorzd2zz__everrorz00(BgL_locz00_13794,
									BGl_string5807z00zz__evaluate_compz00,
									BGl_string5823z00zz__evaluate_compz00, BgL_fz00_16153);
							}
						{	/* Eval/evaluate_comp.scm 896 */
							obj_t BgL_ufz00_16157;

							{	/* Eval/evaluate_comp.scm 896 */
								obj_t BgL_tmpz00_22315;

								BgL_tmpz00_22315 = ((obj_t) BgL_fz00_16153);
								BgL_ufz00_16157 = PROCEDURE_ATTR(BgL_tmpz00_22315);
							}
							{	/* Eval/evaluate_comp.scm 896 */
								bool_t BgL_test6346z00_22318;

								if (STRUCTP(BgL_ufz00_16157))
									{	/* Eval/evaluate_comp.scm 683 */
										BgL_test6346z00_22318 =
											(STRUCT_KEY(BgL_ufz00_16157) ==
											BGl_symbol5824z00zz__evaluate_compz00);
									}
								else
									{	/* Eval/evaluate_comp.scm 683 */
										BgL_test6346z00_22318 = ((bool_t) 0);
									}
								if (BgL_test6346z00_22318)
									{	/* Eval/evaluate_comp.scm 896 */
										obj_t BgL_arityz00_16158;
										obj_t BgL_runz00_16159;
										obj_t BgL_sfz00_16160;

										BgL_arityz00_16158 =
											STRUCT_REF(BgL_ufz00_16157, (int) (((long) 0)));
										BgL_runz00_16159 =
											STRUCT_REF(BgL_ufz00_16157, (int) (((long) 1)));
										BgL_sfz00_16160 =
											STRUCT_REF(BgL_ufz00_16157, (int) (((long) 2)));
										{	/* Eval/evaluate_comp.scm 896 */
											long BgL_spz00_16161;

											BgL_spz00_16161 =
												((long) CINT(BgL_bpz00_16152) + BgL_siza7eza7_13796);
											if (((long) CINT(BgL_arityz00_16158) == ((long) 3)))
												{	/* Eval/evaluate_comp.scm 896 */
													{	/* Eval/evaluate_comp.scm 896 */
														long BgL_arg2288z00_16162;

														BgL_arg2288z00_16162 =
															(BgL_spz00_16161 + ((long) 0));
														VECTOR_SET(
															((obj_t) BgL_sz00_13797), BgL_arg2288z00_16162,
															BgL_a1z00_16154);
													}
													{	/* Eval/evaluate_comp.scm 896 */
														long BgL_arg2289z00_16163;

														BgL_arg2289z00_16163 =
															(BgL_spz00_16161 + ((long) 1));
														VECTOR_SET(
															((obj_t) BgL_sz00_13797), BgL_arg2289z00_16163,
															BgL_a2z00_16155);
													}
													{	/* Eval/evaluate_comp.scm 896 */
														long BgL_arg2290z00_16164;

														BgL_arg2290z00_16164 =
															(BgL_spz00_16161 + ((long) 2));
														VECTOR_SET(
															((obj_t) BgL_sz00_13797), BgL_arg2290z00_16164,
															BgL_a3z00_16156);
												}}
											else
												{	/* Eval/evaluate_comp.scm 896 */
													if (INTEGERP(BgL_arityz00_16158))
														{	/* Eval/evaluate_comp.scm 896 */
															switch ((long) CINT(BgL_arityz00_16158))
																{
																case ((long) -1):

																	{	/* Eval/evaluate_comp.scm 896 */
																		long BgL_arg2292z00_16165;
																		obj_t BgL_arg2294z00_16166;

																		BgL_arg2292z00_16165 =
																			(BgL_spz00_16161 + ((long) 0));
																		{	/* Eval/evaluate_comp.scm 896 */
																			obj_t BgL_list2295z00_16167;

																			{	/* Eval/evaluate_comp.scm 896 */
																				obj_t BgL_arg2297z00_16168;

																				{	/* Eval/evaluate_comp.scm 896 */
																					obj_t BgL_arg2298z00_16169;

																					BgL_arg2298z00_16169 =
																						MAKE_YOUNG_PAIR(BgL_a3z00_16156,
																						BNIL);
																					BgL_arg2297z00_16168 =
																						MAKE_YOUNG_PAIR(BgL_a2z00_16155,
																						BgL_arg2298z00_16169);
																				}
																				BgL_list2295z00_16167 =
																					MAKE_YOUNG_PAIR(BgL_a1z00_16154,
																					BgL_arg2297z00_16168);
																			}
																			BgL_arg2294z00_16166 =
																				BgL_list2295z00_16167;
																		}
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13797),
																			BgL_arg2292z00_16165,
																			BgL_arg2294z00_16166);
																	} break;
																case ((long) -2):

																	{	/* Eval/evaluate_comp.scm 896 */
																		long BgL_arg2299z00_16170;

																		BgL_arg2299z00_16170 =
																			(BgL_spz00_16161 + ((long) 0));
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13797),
																			BgL_arg2299z00_16170, BgL_a1z00_16154);
																	}
																	{	/* Eval/evaluate_comp.scm 896 */
																		long BgL_arg2300z00_16171;
																		obj_t BgL_arg2301z00_16172;

																		BgL_arg2300z00_16171 =
																			(BgL_spz00_16161 + ((long) 1));
																		{	/* Eval/evaluate_comp.scm 896 */
																			obj_t BgL_list2302z00_16173;

																			{	/* Eval/evaluate_comp.scm 896 */
																				obj_t BgL_arg2303z00_16174;

																				BgL_arg2303z00_16174 =
																					MAKE_YOUNG_PAIR(BgL_a3z00_16156,
																					BNIL);
																				BgL_list2302z00_16173 =
																					MAKE_YOUNG_PAIR(BgL_a2z00_16155,
																					BgL_arg2303z00_16174);
																			}
																			BgL_arg2301z00_16172 =
																				BgL_list2302z00_16173;
																		}
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13797),
																			BgL_arg2300z00_16171,
																			BgL_arg2301z00_16172);
																	} break;
																case ((long) -3):

																	{	/* Eval/evaluate_comp.scm 896 */
																		long BgL_arg2304z00_16175;

																		BgL_arg2304z00_16175 =
																			(BgL_spz00_16161 + ((long) 0));
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13797),
																			BgL_arg2304z00_16175, BgL_a1z00_16154);
																	}
																	{	/* Eval/evaluate_comp.scm 896 */
																		long BgL_arg2305z00_16176;

																		BgL_arg2305z00_16176 =
																			(BgL_spz00_16161 + ((long) 1));
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13797),
																			BgL_arg2305z00_16176, BgL_a2z00_16155);
																	}
																	{	/* Eval/evaluate_comp.scm 896 */
																		long BgL_arg2306z00_16177;
																		obj_t BgL_arg2307z00_16178;

																		BgL_arg2306z00_16177 =
																			(BgL_spz00_16161 + ((long) 2));
																		{	/* Eval/evaluate_comp.scm 896 */
																			obj_t BgL_list2308z00_16179;

																			BgL_list2308z00_16179 =
																				MAKE_YOUNG_PAIR(BgL_a3z00_16156, BNIL);
																			BgL_arg2307z00_16178 =
																				BgL_list2308z00_16179;
																		}
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13797),
																			BgL_arg2306z00_16177,
																			BgL_arg2307z00_16178);
																	} break;
																case ((long) -4):

																	{	/* Eval/evaluate_comp.scm 896 */
																		long BgL_arg2310z00_16180;

																		BgL_arg2310z00_16180 =
																			(BgL_spz00_16161 + ((long) 0));
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13797),
																			BgL_arg2310z00_16180, BgL_a1z00_16154);
																	}
																	{	/* Eval/evaluate_comp.scm 896 */
																		long BgL_arg2311z00_16181;

																		BgL_arg2311z00_16181 =
																			(BgL_spz00_16161 + ((long) 1));
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13797),
																			BgL_arg2311z00_16181, BgL_a2z00_16155);
																	}
																	{	/* Eval/evaluate_comp.scm 896 */
																		long BgL_arg2312z00_16182;

																		BgL_arg2312z00_16182 =
																			(BgL_spz00_16161 + ((long) 2));
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13797),
																			BgL_arg2312z00_16182, BgL_a3z00_16156);
																	}
																	{	/* Eval/evaluate_comp.scm 896 */
																		long BgL_arg2314z00_16183;
																		obj_t BgL_arg2316z00_16184;

																		BgL_arg2314z00_16183 =
																			(BgL_spz00_16161 + ((long) 3));
																		BgL_arg2316z00_16184 = BNIL;
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13797),
																			BgL_arg2314z00_16183,
																			BgL_arg2316z00_16184);
																	} break;
																default:
																	BGl_evarityzd2errorzd2zz__everrorz00
																		(BgL_locz00_13794,
																		STRUCT_REF(BgL_ufz00_16157,
																			(int) (((long) 3))), (int) (((long) 3)),
																		CINT(BgL_arityz00_16158));
														}}
													else
														{	/* Eval/evaluate_comp.scm 896 */
															BGl_evarityzd2errorzd2zz__everrorz00
																(BgL_locz00_13794, STRUCT_REF(BgL_ufz00_16157,
																	(int) (((long) 3))), (int) (((long) 3)),
																CINT(BgL_arityz00_16158));
												}}
											{	/* Eval/evaluate_comp.scm 896 */
												obj_t BgL_z12denvz12_16185;

												BgL_z12denvz12_16185 = BGL_CURRENT_DYNAMIC_ENV();
												BGL_ENV_SET_TRACE_LOCATION(BgL_z12denvz12_16185,
													BgL_locz00_13794);
												if (((BgL_spz00_16161 + (long) CINT(BgL_sfz00_16160)) <
														VECTOR_LENGTH(((obj_t) BgL_sz00_13797))))
													{	/* Eval/evaluate_comp.scm 896 */
														return
															BGl_catchzd2trampolinezd2zz__evaluate_compz00
															(BgL_runz00_16159, BgL_sz00_13797,
															BINT(BgL_spz00_16161));
													}
												else
													{	/* Eval/evaluate_comp.scm 896 */
														obj_t BgL_nsz00_16186;

														BgL_nsz00_16186 =
															BGl_makezd2statezd2zz__evaluate_compz00();
														{	/* Eval/evaluate_comp.scm 896 */
															long BgL_arg2320z00_16187;

															BgL_arg2320z00_16187 =
																(BgL_spz00_16161 + ((long) 3));
															BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00
																(BgL_nsz00_16186, ((long) 2), BgL_sz00_13797,
																BINT(BgL_spz00_16161),
																BINT(BgL_arg2320z00_16187));
														}
														VECTOR_SET(BgL_nsz00_16186, ((long) 1),
															BgL_sz00_13797);
														BGL_ENV_EVSTATE_SET(BgL_z12denvz12_16185,
															BgL_nsz00_16186);
														{	/* Eval/evaluate_comp.scm 896 */
															obj_t BgL_ez00_16188;

															BgL_ez00_16188 = BGL_EXITD_TOP_AS_OBJ();
															BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
																(BgL_ez00_16188, BgL_sz00_13797);
															{	/* Eval/evaluate_comp.scm 896 */
																obj_t BgL_____rz00_16189;

																{	/* Eval/evaluate_comp.scm 670 */
																	obj_t BgL_savedzd2bpzd2_16190;

																	BgL_savedzd2bpzd2_16190 =
																		VECTOR_REF(BgL_nsz00_16186, ((long) 0));
																	VECTOR_SET(BgL_nsz00_16186, ((long) 0),
																		BINT(((long) 2)));
																	{
																		obj_t BgL_fz00_16192;

																		BgL_fz00_16192 = BgL_runz00_16159;
																	BgL_recz00_16191:
																		{	/* Eval/evaluate_comp.scm 673 */
																			obj_t BgL_rz00_16193;

																			BgL_rz00_16193 =
																				PROCEDURE_ENTRY(BgL_fz00_16192)
																				(BgL_fz00_16192, BgL_nsz00_16186, BEOA);
																			{	/* Eval/evaluate_comp.scm 674 */
																				bool_t BgL_test6351z00_22419;

																				if (PROCEDUREP(BgL_rz00_16193))
																					{	/* Eval/evaluate_comp.scm 674 */
																						obj_t BgL_arg1702z00_16194;

																						BgL_arg1702z00_16194 =
																							PROCEDURE_ATTR(BgL_rz00_16193);
																						if (STRUCTP(BgL_arg1702z00_16194))
																							{	/* Eval/evaluate_comp.scm 654 */
																								BgL_test6351z00_22419 =
																									(STRUCT_KEY
																									(BgL_arg1702z00_16194) ==
																									BGl_symbol5803z00zz__evaluate_compz00);
																							}
																						else
																							{	/* Eval/evaluate_comp.scm 654 */
																								BgL_test6351z00_22419 =
																									((bool_t) 0);
																							}
																					}
																				else
																					{	/* Eval/evaluate_comp.scm 674 */
																						BgL_test6351z00_22419 =
																							((bool_t) 0);
																					}
																				if (BgL_test6351z00_22419)
																					{
																						obj_t BgL_fz00_22427;

																						BgL_fz00_22427 = BgL_rz00_16193;
																						BgL_fz00_16192 = BgL_fz00_22427;
																						goto BgL_recz00_16191;
																					}
																				else
																					{	/* Eval/evaluate_comp.scm 674 */
																						VECTOR_SET(BgL_nsz00_16186,
																							((long) 0),
																							BgL_savedzd2bpzd2_16190);
																						BgL_____rz00_16189 = BgL_rz00_16193;
																}}}}}
																BGl_exitdzd2popzd2protectz12z12zz__bexitz00
																	(BgL_ez00_16188);
																BGL_ENV_EVSTATE_SET(BgL_z12denvz12_16185,
																	BgL_sz00_13797);
																return BgL_____rz00_16189;
															}
														}
													}
											}
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 896 */
										if (PROCEDURE_CORRECT_ARITYP(BgL_fz00_16153,
												(int) (((long) 3))))
											{	/* Eval/evaluate_comp.scm 896 */
												long BgL_nbpz00_16195;

												BgL_nbpz00_16195 =
													((long) CINT(BgL_bpz00_16152) + BgL_siza7eza7_13796);
												VECTOR_SET(
													((obj_t) BgL_sz00_13797), ((long) 0),
													BINT(BgL_nbpz00_16195));
												{	/* Eval/evaluate_comp.scm 896 */
													obj_t BgL_tmpz00_22439;

													BgL_tmpz00_22439 = BGL_CURRENT_DYNAMIC_ENV();
													BGL_ENV_SET_TRACE_LOCATION(BgL_tmpz00_22439,
														BgL_locz00_13794);
												}
												{	/* Eval/evaluate_comp.scm 896 */
													obj_t BgL_rz00_16196;

													BgL_rz00_16196 =
														PROCEDURE_ENTRY(BgL_fz00_16153) (BgL_fz00_16153,
														BgL_a1z00_16154, BgL_a2z00_16155, BgL_a3z00_16156,
														BEOA);
													VECTOR_SET(((obj_t) BgL_sz00_13797), ((long) 0),
														BgL_bpz00_16152);
													return BgL_rz00_16196;
												}
											}
										else
											{	/* Eval/evaluate_comp.scm 896 */
												return
													BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_13794,
													BgL_symbzd2funzd2_13795, (int) (((long) 3)),
													PROCEDURE_ARITY(BgL_fz00_16153));
		}}}}}}}}

	}



/* &<@anonymous:2324> */
	obj_t BGl_z62zc3z04anonymousza32324ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_13798, obj_t BgL_sz00_13806)
	{
		{	/* Eval/evaluate_comp.scm 896 */
			{	/* Eval/evaluate_comp.scm 896 */
				obj_t BgL_funz00_13799;
				obj_t BgL_a1z00_13800;
				obj_t BgL_a2z00_13801;
				obj_t BgL_a3z00_13802;
				obj_t BgL_locz00_13803;
				obj_t BgL_symbzd2funzd2_13804;
				long BgL_siza7eza7_13805;

				BgL_funz00_13799 = PROCEDURE_REF(BgL_envz00_13798, (int) (((long) 0)));
				BgL_a1z00_13800 = PROCEDURE_REF(BgL_envz00_13798, (int) (((long) 1)));
				BgL_a2z00_13801 = PROCEDURE_REF(BgL_envz00_13798, (int) (((long) 2)));
				BgL_a3z00_13802 = PROCEDURE_REF(BgL_envz00_13798, (int) (((long) 3)));
				BgL_locz00_13803 = PROCEDURE_REF(BgL_envz00_13798, (int) (((long) 4)));
				BgL_symbzd2funzd2_13804 =
					PROCEDURE_REF(BgL_envz00_13798, (int) (((long) 5)));
				BgL_siza7eza7_13805 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13798, (int) (((long) 6))));
				{	/* Eval/evaluate_comp.scm 896 */
					obj_t BgL_bpz00_16197;

					BgL_bpz00_16197 = VECTOR_REF(((obj_t) BgL_sz00_13806), ((long) 0));
					{	/* Eval/evaluate_comp.scm 896 */
						obj_t BgL_fz00_16198;
						obj_t BgL_a1z00_16199;
						obj_t BgL_a2z00_16200;
						obj_t BgL_a3z00_16201;

						BgL_fz00_16198 =
							PROCEDURE_ENTRY(BgL_funz00_13799) (BgL_funz00_13799,
							BgL_sz00_13806, BEOA);
						BgL_a1z00_16199 =
							PROCEDURE_ENTRY(BgL_a1z00_13800) (BgL_a1z00_13800, BgL_sz00_13806,
							BEOA);
						BgL_a2z00_16200 =
							PROCEDURE_ENTRY(BgL_a2z00_13801) (BgL_a2z00_13801, BgL_sz00_13806,
							BEOA);
						BgL_a3z00_16201 =
							PROCEDURE_ENTRY(BgL_a3z00_13802) (BgL_a3z00_13802, BgL_sz00_13806,
							BEOA);
						if (PROCEDUREP(BgL_fz00_16198))
							{	/* Eval/evaluate_comp.scm 896 */
								BFALSE;
							}
						else
							{	/* Eval/evaluate_comp.scm 896 */
								BGl_evtypezd2errorzd2zz__everrorz00(BgL_locz00_13803,
									BGl_string5807z00zz__evaluate_compz00,
									BGl_string5823z00zz__evaluate_compz00, BgL_fz00_16198);
							}
						{	/* Eval/evaluate_comp.scm 896 */
							obj_t BgL_ufz00_16202;

							{	/* Eval/evaluate_comp.scm 896 */
								obj_t BgL_tmpz00_22489;

								BgL_tmpz00_22489 = ((obj_t) BgL_fz00_16198);
								BgL_ufz00_16202 = PROCEDURE_ATTR(BgL_tmpz00_22489);
							}
							{	/* Eval/evaluate_comp.scm 896 */
								bool_t BgL_test6356z00_22492;

								if (STRUCTP(BgL_ufz00_16202))
									{	/* Eval/evaluate_comp.scm 683 */
										BgL_test6356z00_22492 =
											(STRUCT_KEY(BgL_ufz00_16202) ==
											BGl_symbol5824z00zz__evaluate_compz00);
									}
								else
									{	/* Eval/evaluate_comp.scm 683 */
										BgL_test6356z00_22492 = ((bool_t) 0);
									}
								if (BgL_test6356z00_22492)
									{	/* Eval/evaluate_comp.scm 896 */
										obj_t BgL_arityz00_16203;
										obj_t BgL_runz00_16204;
										obj_t BgL_sfz00_16205;

										BgL_arityz00_16203 =
											STRUCT_REF(BgL_ufz00_16202, (int) (((long) 0)));
										BgL_runz00_16204 =
											STRUCT_REF(BgL_ufz00_16202, (int) (((long) 1)));
										BgL_sfz00_16205 =
											STRUCT_REF(BgL_ufz00_16202, (int) (((long) 2)));
										{	/* Eval/evaluate_comp.scm 896 */
											long BgL_spz00_16206;

											BgL_spz00_16206 =
												((long) CINT(BgL_bpz00_16197) + BgL_siza7eza7_13805);
											if (((long) CINT(BgL_arityz00_16203) == ((long) 3)))
												{	/* Eval/evaluate_comp.scm 896 */
													{	/* Eval/evaluate_comp.scm 896 */
														long BgL_arg2328z00_16207;

														BgL_arg2328z00_16207 =
															(BgL_spz00_16206 + ((long) 0));
														VECTOR_SET(
															((obj_t) BgL_sz00_13806), BgL_arg2328z00_16207,
															BgL_a1z00_16199);
													}
													{	/* Eval/evaluate_comp.scm 896 */
														long BgL_arg2329z00_16208;

														BgL_arg2329z00_16208 =
															(BgL_spz00_16206 + ((long) 1));
														VECTOR_SET(
															((obj_t) BgL_sz00_13806), BgL_arg2329z00_16208,
															BgL_a2z00_16200);
													}
													{	/* Eval/evaluate_comp.scm 896 */
														long BgL_arg2330z00_16209;

														BgL_arg2330z00_16209 =
															(BgL_spz00_16206 + ((long) 2));
														VECTOR_SET(
															((obj_t) BgL_sz00_13806), BgL_arg2330z00_16209,
															BgL_a3z00_16201);
												}}
											else
												{	/* Eval/evaluate_comp.scm 896 */
													if (INTEGERP(BgL_arityz00_16203))
														{	/* Eval/evaluate_comp.scm 896 */
															switch ((long) CINT(BgL_arityz00_16203))
																{
																case ((long) -1):

																	{	/* Eval/evaluate_comp.scm 896 */
																		long BgL_arg2332z00_16210;
																		obj_t BgL_arg2333z00_16211;

																		BgL_arg2332z00_16210 =
																			(BgL_spz00_16206 + ((long) 0));
																		{	/* Eval/evaluate_comp.scm 896 */
																			obj_t BgL_list2334z00_16212;

																			{	/* Eval/evaluate_comp.scm 896 */
																				obj_t BgL_arg2335z00_16213;

																				{	/* Eval/evaluate_comp.scm 896 */
																					obj_t BgL_arg2336z00_16214;

																					BgL_arg2336z00_16214 =
																						MAKE_YOUNG_PAIR(BgL_a3z00_16201,
																						BNIL);
																					BgL_arg2335z00_16213 =
																						MAKE_YOUNG_PAIR(BgL_a2z00_16200,
																						BgL_arg2336z00_16214);
																				}
																				BgL_list2334z00_16212 =
																					MAKE_YOUNG_PAIR(BgL_a1z00_16199,
																					BgL_arg2335z00_16213);
																			}
																			BgL_arg2333z00_16211 =
																				BgL_list2334z00_16212;
																		}
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13806),
																			BgL_arg2332z00_16210,
																			BgL_arg2333z00_16211);
																	} break;
																case ((long) -2):

																	{	/* Eval/evaluate_comp.scm 896 */
																		long BgL_arg2337z00_16215;

																		BgL_arg2337z00_16215 =
																			(BgL_spz00_16206 + ((long) 0));
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13806),
																			BgL_arg2337z00_16215, BgL_a1z00_16199);
																	}
																	{	/* Eval/evaluate_comp.scm 896 */
																		long BgL_arg2339z00_16216;
																		obj_t BgL_arg2340z00_16217;

																		BgL_arg2339z00_16216 =
																			(BgL_spz00_16206 + ((long) 1));
																		{	/* Eval/evaluate_comp.scm 896 */
																			obj_t BgL_list2341z00_16218;

																			{	/* Eval/evaluate_comp.scm 896 */
																				obj_t BgL_arg2342z00_16219;

																				BgL_arg2342z00_16219 =
																					MAKE_YOUNG_PAIR(BgL_a3z00_16201,
																					BNIL);
																				BgL_list2341z00_16218 =
																					MAKE_YOUNG_PAIR(BgL_a2z00_16200,
																					BgL_arg2342z00_16219);
																			}
																			BgL_arg2340z00_16217 =
																				BgL_list2341z00_16218;
																		}
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13806),
																			BgL_arg2339z00_16216,
																			BgL_arg2340z00_16217);
																	} break;
																case ((long) -3):

																	{	/* Eval/evaluate_comp.scm 896 */
																		long BgL_arg2343z00_16220;

																		BgL_arg2343z00_16220 =
																			(BgL_spz00_16206 + ((long) 0));
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13806),
																			BgL_arg2343z00_16220, BgL_a1z00_16199);
																	}
																	{	/* Eval/evaluate_comp.scm 896 */
																		long BgL_arg2344z00_16221;

																		BgL_arg2344z00_16221 =
																			(BgL_spz00_16206 + ((long) 1));
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13806),
																			BgL_arg2344z00_16221, BgL_a2z00_16200);
																	}
																	{	/* Eval/evaluate_comp.scm 896 */
																		long BgL_arg2345z00_16222;
																		obj_t BgL_arg2346z00_16223;

																		BgL_arg2345z00_16222 =
																			(BgL_spz00_16206 + ((long) 2));
																		{	/* Eval/evaluate_comp.scm 896 */
																			obj_t BgL_list2347z00_16224;

																			BgL_list2347z00_16224 =
																				MAKE_YOUNG_PAIR(BgL_a3z00_16201, BNIL);
																			BgL_arg2346z00_16223 =
																				BgL_list2347z00_16224;
																		}
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13806),
																			BgL_arg2345z00_16222,
																			BgL_arg2346z00_16223);
																	} break;
																case ((long) -4):

																	{	/* Eval/evaluate_comp.scm 896 */
																		long BgL_arg2348z00_16225;

																		BgL_arg2348z00_16225 =
																			(BgL_spz00_16206 + ((long) 0));
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13806),
																			BgL_arg2348z00_16225, BgL_a1z00_16199);
																	}
																	{	/* Eval/evaluate_comp.scm 896 */
																		long BgL_arg2349z00_16226;

																		BgL_arg2349z00_16226 =
																			(BgL_spz00_16206 + ((long) 1));
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13806),
																			BgL_arg2349z00_16226, BgL_a2z00_16200);
																	}
																	{	/* Eval/evaluate_comp.scm 896 */
																		long BgL_arg2350z00_16227;

																		BgL_arg2350z00_16227 =
																			(BgL_spz00_16206 + ((long) 2));
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13806),
																			BgL_arg2350z00_16227, BgL_a3z00_16201);
																	}
																	{	/* Eval/evaluate_comp.scm 896 */
																		long BgL_arg2351z00_16228;
																		obj_t BgL_arg2352z00_16229;

																		BgL_arg2351z00_16228 =
																			(BgL_spz00_16206 + ((long) 3));
																		BgL_arg2352z00_16229 = BNIL;
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13806),
																			BgL_arg2351z00_16228,
																			BgL_arg2352z00_16229);
																	} break;
																default:
																	BGl_evarityzd2errorzd2zz__everrorz00
																		(BgL_locz00_13803,
																		STRUCT_REF(BgL_ufz00_16202,
																			(int) (((long) 3))), (int) (((long) 3)),
																		CINT(BgL_arityz00_16203));
														}}
													else
														{	/* Eval/evaluate_comp.scm 896 */
															BGl_evarityzd2errorzd2zz__everrorz00
																(BgL_locz00_13803, STRUCT_REF(BgL_ufz00_16202,
																	(int) (((long) 3))), (int) (((long) 3)),
																CINT(BgL_arityz00_16203));
												}}
											{	/* Eval/evaluate_comp.scm 896 */
												obj_t BgL_z12denvz12_16230;

												BgL_z12denvz12_16230 = BGL_CURRENT_DYNAMIC_ENV();
												if (
													((BgL_spz00_16206 +
															(long) CINT(BgL_sfz00_16205)) <
														VECTOR_LENGTH(((obj_t) BgL_sz00_13806))))
													{	/* Eval/evaluate_comp.scm 896 */
														return
															BGl_catchzd2trampolinezd2zz__evaluate_compz00
															(BgL_runz00_16204, BgL_sz00_13806,
															BINT(BgL_spz00_16206));
													}
												else
													{	/* Eval/evaluate_comp.scm 896 */
														obj_t BgL_nsz00_16231;

														BgL_nsz00_16231 =
															BGl_makezd2statezd2zz__evaluate_compz00();
														{	/* Eval/evaluate_comp.scm 896 */
															long BgL_arg2356z00_16232;

															BgL_arg2356z00_16232 =
																(BgL_spz00_16206 + ((long) 3));
															BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00
																(BgL_nsz00_16231, ((long) 2), BgL_sz00_13806,
																BINT(BgL_spz00_16206),
																BINT(BgL_arg2356z00_16232));
														}
														VECTOR_SET(BgL_nsz00_16231, ((long) 1),
															BgL_sz00_13806);
														BGL_ENV_EVSTATE_SET(BgL_z12denvz12_16230,
															BgL_nsz00_16231);
														{	/* Eval/evaluate_comp.scm 896 */
															obj_t BgL_ez00_16233;

															BgL_ez00_16233 = BGL_EXITD_TOP_AS_OBJ();
															BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
																(BgL_ez00_16233, BgL_sz00_13806);
															{	/* Eval/evaluate_comp.scm 896 */
																obj_t BgL_____rz00_16234;

																{	/* Eval/evaluate_comp.scm 670 */
																	obj_t BgL_savedzd2bpzd2_16235;

																	BgL_savedzd2bpzd2_16235 =
																		VECTOR_REF(BgL_nsz00_16231, ((long) 0));
																	VECTOR_SET(BgL_nsz00_16231, ((long) 0),
																		BINT(((long) 2)));
																	{
																		obj_t BgL_fz00_16237;

																		BgL_fz00_16237 = BgL_runz00_16204;
																	BgL_recz00_16236:
																		{	/* Eval/evaluate_comp.scm 673 */
																			obj_t BgL_rz00_16238;

																			BgL_rz00_16238 =
																				PROCEDURE_ENTRY(BgL_fz00_16237)
																				(BgL_fz00_16237, BgL_nsz00_16231, BEOA);
																			{	/* Eval/evaluate_comp.scm 674 */
																				bool_t BgL_test6361z00_22592;

																				if (PROCEDUREP(BgL_rz00_16238))
																					{	/* Eval/evaluate_comp.scm 674 */
																						obj_t BgL_arg1702z00_16239;

																						BgL_arg1702z00_16239 =
																							PROCEDURE_ATTR(BgL_rz00_16238);
																						if (STRUCTP(BgL_arg1702z00_16239))
																							{	/* Eval/evaluate_comp.scm 654 */
																								BgL_test6361z00_22592 =
																									(STRUCT_KEY
																									(BgL_arg1702z00_16239) ==
																									BGl_symbol5803z00zz__evaluate_compz00);
																							}
																						else
																							{	/* Eval/evaluate_comp.scm 654 */
																								BgL_test6361z00_22592 =
																									((bool_t) 0);
																							}
																					}
																				else
																					{	/* Eval/evaluate_comp.scm 674 */
																						BgL_test6361z00_22592 =
																							((bool_t) 0);
																					}
																				if (BgL_test6361z00_22592)
																					{
																						obj_t BgL_fz00_22600;

																						BgL_fz00_22600 = BgL_rz00_16238;
																						BgL_fz00_16237 = BgL_fz00_22600;
																						goto BgL_recz00_16236;
																					}
																				else
																					{	/* Eval/evaluate_comp.scm 674 */
																						VECTOR_SET(BgL_nsz00_16231,
																							((long) 0),
																							BgL_savedzd2bpzd2_16235);
																						BgL_____rz00_16234 = BgL_rz00_16238;
																}}}}}
																BGl_exitdzd2popzd2protectz12z12zz__bexitz00
																	(BgL_ez00_16233);
																BGL_ENV_EVSTATE_SET(BgL_z12denvz12_16230,
																	BgL_sz00_13806);
																return BgL_____rz00_16234;
															}
														}
													}
											}
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 896 */
										if (PROCEDURE_CORRECT_ARITYP(BgL_fz00_16198,
												(int) (((long) 3))))
											{	/* Eval/evaluate_comp.scm 896 */
												long BgL_nbpz00_16240;

												BgL_nbpz00_16240 =
													((long) CINT(BgL_bpz00_16197) + BgL_siza7eza7_13805);
												VECTOR_SET(
													((obj_t) BgL_sz00_13806), ((long) 0),
													BINT(BgL_nbpz00_16240));
												{	/* Eval/evaluate_comp.scm 896 */
													obj_t BgL_rz00_16241;

													BgL_rz00_16241 =
														PROCEDURE_ENTRY(BgL_fz00_16198) (BgL_fz00_16198,
														BgL_a1z00_16199, BgL_a2z00_16200, BgL_a3z00_16201,
														BEOA);
													VECTOR_SET(((obj_t) BgL_sz00_13806), ((long) 0),
														BgL_bpz00_16197);
													return BgL_rz00_16241;
												}
											}
										else
											{	/* Eval/evaluate_comp.scm 896 */
												return
													BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_13803,
													BgL_symbzd2funzd2_13804, (int) (((long) 3)),
													PROCEDURE_ARITY(BgL_fz00_16198));
		}}}}}}}}

	}



/* comp-call4 */
	obj_t BGl_compzd2call4zd2zz__evaluate_compz00(obj_t BgL_locz00_172,
		BgL_ev_exprz00_bglt BgL_vfunz00_173, obj_t BgL_symbzd2funzd2_174,
		obj_t BgL_funz00_175, obj_t BgL_tailzf3zf3_176, obj_t BgL_stkz00_177,
		long BgL_siza7eza7_178, obj_t BgL_a1z00_179, obj_t BgL_a2z00_180,
		obj_t BgL_a3z00_181, obj_t BgL_a4z00_182)
	{
		{	/* Eval/evaluate_comp.scm 896 */
			{	/* Eval/evaluate_comp.scm 896 */
				obj_t BgL_cfunz00_2729;

				BgL_cfunz00_2729 =
					BGl_iszd2constantzd2funzf3zf3zz__evaluate_compz00(BgL_vfunz00_173,
					((long) 4), BgL_locz00_172, BgL_symbzd2funzd2_174);
				if (CBOOL(BgL_cfunz00_2729))
					{	/* Eval/evaluate_comp.scm 896 */
						bool_t BgL_test6366z00_22626;

						{	/* Eval/evaluate_comp.scm 896 */
							int BgL_arg2365z00_2751;

							BgL_arg2365z00_2751 = bgl_debug();
							BgL_test6366z00_22626 =
								BGl_2ze3ze3zz__r4_numbers_6_5z00(BINT(BgL_arg2365z00_2751),
								BINT(((long) 0)));
						}
						if (BgL_test6366z00_22626)
							{	/* Eval/evaluate_comp.scm 896 */
								obj_t BgL_zc3z04anonymousza32362ze3z87_13807;

								BgL_zc3z04anonymousza32362ze3z87_13807 =
									MAKE_FX_PROCEDURE
									(BGl_z62zc3z04anonymousza32362ze3ze5zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 7)));
								PROCEDURE_SET(BgL_zc3z04anonymousza32362ze3z87_13807,
									(int) (((long) 0)), BgL_a1z00_179);
								PROCEDURE_SET(BgL_zc3z04anonymousza32362ze3z87_13807,
									(int) (((long) 1)), BgL_a2z00_180);
								PROCEDURE_SET(BgL_zc3z04anonymousza32362ze3z87_13807,
									(int) (((long) 2)), BgL_a3z00_181);
								PROCEDURE_SET(BgL_zc3z04anonymousza32362ze3z87_13807,
									(int) (((long) 3)), BgL_a4z00_182);
								PROCEDURE_SET(BgL_zc3z04anonymousza32362ze3z87_13807,
									(int) (((long) 4)), BINT(BgL_siza7eza7_178));
								PROCEDURE_SET(BgL_zc3z04anonymousza32362ze3z87_13807,
									(int) (((long) 5)), BgL_locz00_172);
								PROCEDURE_SET(BgL_zc3z04anonymousza32362ze3z87_13807,
									(int) (((long) 6)), BgL_cfunz00_2729);
								return BgL_zc3z04anonymousza32362ze3z87_13807;
							}
						else
							{	/* Eval/evaluate_comp.scm 896 */
								obj_t BgL_zc3z04anonymousza32364ze3z87_13808;

								BgL_zc3z04anonymousza32364ze3z87_13808 =
									MAKE_FX_PROCEDURE
									(BGl_z62zc3z04anonymousza32364ze3ze5zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 6)));
								PROCEDURE_SET(BgL_zc3z04anonymousza32364ze3z87_13808,
									(int) (((long) 0)), BgL_a1z00_179);
								PROCEDURE_SET(BgL_zc3z04anonymousza32364ze3z87_13808,
									(int) (((long) 1)), BgL_a2z00_180);
								PROCEDURE_SET(BgL_zc3z04anonymousza32364ze3z87_13808,
									(int) (((long) 2)), BgL_a3z00_181);
								PROCEDURE_SET(BgL_zc3z04anonymousza32364ze3z87_13808,
									(int) (((long) 3)), BgL_a4z00_182);
								PROCEDURE_SET(BgL_zc3z04anonymousza32364ze3z87_13808,
									(int) (((long) 4)), BINT(BgL_siza7eza7_178));
								PROCEDURE_SET(BgL_zc3z04anonymousza32364ze3z87_13808,
									(int) (((long) 5)), BgL_cfunz00_2729);
								return BgL_zc3z04anonymousza32364ze3z87_13808;
							}
					}
				else
					{	/* Eval/evaluate_comp.scm 896 */
						if (CBOOL(BgL_tailzf3zf3_176))
							{	/* Eval/evaluate_comp.scm 896 */
								bool_t BgL_test6368z00_22667;

								{	/* Eval/evaluate_comp.scm 896 */
									int BgL_arg2479z00_2887;

									BgL_arg2479z00_2887 = bgl_debug();
									BgL_test6368z00_22667 =
										BGl_2ze3ze3zz__r4_numbers_6_5z00(BINT(BgL_arg2479z00_2887),
										BINT(((long) 0)));
								}
								if (BgL_test6368z00_22667)
									{	/* Eval/evaluate_comp.scm 896 */
										obj_t BgL_zc3z04anonymousza32368ze3z87_13809;

										BgL_zc3z04anonymousza32368ze3z87_13809 =
											MAKE_FX_PROCEDURE
											(BGl_z62zc3z04anonymousza32368ze3ze5zz__evaluate_compz00,
											(int) (((long) 1)), (int) (((long) 8)));
										PROCEDURE_SET(BgL_zc3z04anonymousza32368ze3z87_13809,
											(int) (((long) 0)), BgL_funz00_175);
										PROCEDURE_SET(BgL_zc3z04anonymousza32368ze3z87_13809,
											(int) (((long) 1)), BgL_a1z00_179);
										PROCEDURE_SET(BgL_zc3z04anonymousza32368ze3z87_13809,
											(int) (((long) 2)), BgL_a2z00_180);
										PROCEDURE_SET(BgL_zc3z04anonymousza32368ze3z87_13809,
											(int) (((long) 3)), BgL_a3z00_181);
										PROCEDURE_SET(BgL_zc3z04anonymousza32368ze3z87_13809,
											(int) (((long) 4)), BgL_a4z00_182);
										PROCEDURE_SET(BgL_zc3z04anonymousza32368ze3z87_13809,
											(int) (((long) 5)), BgL_locz00_172);
										PROCEDURE_SET(BgL_zc3z04anonymousza32368ze3z87_13809,
											(int) (((long) 6)), BgL_symbzd2funzd2_174);
										PROCEDURE_SET(BgL_zc3z04anonymousza32368ze3z87_13809,
											(int) (((long) 7)), BINT(BgL_siza7eza7_178));
										return BgL_zc3z04anonymousza32368ze3z87_13809;
									}
								else
									{	/* Eval/evaluate_comp.scm 896 */
										obj_t BgL_zc3z04anonymousza32426ze3z87_13810;

										BgL_zc3z04anonymousza32426ze3z87_13810 =
											MAKE_FX_PROCEDURE
											(BGl_z62zc3z04anonymousza32426ze3ze5zz__evaluate_compz00,
											(int) (((long) 1)), (int) (((long) 8)));
										PROCEDURE_SET(BgL_zc3z04anonymousza32426ze3z87_13810,
											(int) (((long) 0)), BgL_funz00_175);
										PROCEDURE_SET(BgL_zc3z04anonymousza32426ze3z87_13810,
											(int) (((long) 1)), BgL_a1z00_179);
										PROCEDURE_SET(BgL_zc3z04anonymousza32426ze3z87_13810,
											(int) (((long) 2)), BgL_a2z00_180);
										PROCEDURE_SET(BgL_zc3z04anonymousza32426ze3z87_13810,
											(int) (((long) 3)), BgL_a3z00_181);
										PROCEDURE_SET(BgL_zc3z04anonymousza32426ze3z87_13810,
											(int) (((long) 4)), BgL_a4z00_182);
										PROCEDURE_SET(BgL_zc3z04anonymousza32426ze3z87_13810,
											(int) (((long) 5)), BgL_locz00_172);
										PROCEDURE_SET(BgL_zc3z04anonymousza32426ze3z87_13810,
											(int) (((long) 6)), BgL_symbzd2funzd2_174);
										PROCEDURE_SET(BgL_zc3z04anonymousza32426ze3z87_13810,
											(int) (((long) 7)), BINT(BgL_siza7eza7_178));
										return BgL_zc3z04anonymousza32426ze3z87_13810;
									}
							}
						else
							{	/* Eval/evaluate_comp.scm 896 */
								bool_t BgL_test6369z00_22712;

								{	/* Eval/evaluate_comp.scm 896 */
									int BgL_arg2606z00_3023;

									BgL_arg2606z00_3023 = bgl_debug();
									BgL_test6369z00_22712 =
										BGl_2ze3ze3zz__r4_numbers_6_5z00(BINT(BgL_arg2606z00_3023),
										BINT(((long) 0)));
								}
								if (BgL_test6369z00_22712)
									{	/* Eval/evaluate_comp.scm 896 */
										obj_t BgL_zc3z04anonymousza32482ze3z87_13811;

										BgL_zc3z04anonymousza32482ze3z87_13811 =
											MAKE_FX_PROCEDURE
											(BGl_z62zc3z04anonymousza32482ze3ze5zz__evaluate_compz00,
											(int) (((long) 1)), (int) (((long) 8)));
										PROCEDURE_SET(BgL_zc3z04anonymousza32482ze3z87_13811,
											(int) (((long) 0)), BgL_funz00_175);
										PROCEDURE_SET(BgL_zc3z04anonymousza32482ze3z87_13811,
											(int) (((long) 1)), BgL_a1z00_179);
										PROCEDURE_SET(BgL_zc3z04anonymousza32482ze3z87_13811,
											(int) (((long) 2)), BgL_a2z00_180);
										PROCEDURE_SET(BgL_zc3z04anonymousza32482ze3z87_13811,
											(int) (((long) 3)), BgL_a3z00_181);
										PROCEDURE_SET(BgL_zc3z04anonymousza32482ze3z87_13811,
											(int) (((long) 4)), BgL_a4z00_182);
										PROCEDURE_SET(BgL_zc3z04anonymousza32482ze3z87_13811,
											(int) (((long) 5)), BgL_locz00_172);
										PROCEDURE_SET(BgL_zc3z04anonymousza32482ze3z87_13811,
											(int) (((long) 6)), BgL_symbzd2funzd2_174);
										PROCEDURE_SET(BgL_zc3z04anonymousza32482ze3z87_13811,
											(int) (((long) 7)), BINT(BgL_siza7eza7_178));
										return BgL_zc3z04anonymousza32482ze3z87_13811;
									}
								else
									{	/* Eval/evaluate_comp.scm 896 */
										obj_t BgL_zc3z04anonymousza32548ze3z87_13812;

										BgL_zc3z04anonymousza32548ze3z87_13812 =
											MAKE_FX_PROCEDURE
											(BGl_z62zc3z04anonymousza32548ze3ze5zz__evaluate_compz00,
											(int) (((long) 1)), (int) (((long) 8)));
										PROCEDURE_SET(BgL_zc3z04anonymousza32548ze3z87_13812,
											(int) (((long) 0)), BgL_funz00_175);
										PROCEDURE_SET(BgL_zc3z04anonymousza32548ze3z87_13812,
											(int) (((long) 1)), BgL_a1z00_179);
										PROCEDURE_SET(BgL_zc3z04anonymousza32548ze3z87_13812,
											(int) (((long) 2)), BgL_a2z00_180);
										PROCEDURE_SET(BgL_zc3z04anonymousza32548ze3z87_13812,
											(int) (((long) 3)), BgL_a3z00_181);
										PROCEDURE_SET(BgL_zc3z04anonymousza32548ze3z87_13812,
											(int) (((long) 4)), BgL_a4z00_182);
										PROCEDURE_SET(BgL_zc3z04anonymousza32548ze3z87_13812,
											(int) (((long) 5)), BgL_locz00_172);
										PROCEDURE_SET(BgL_zc3z04anonymousza32548ze3z87_13812,
											(int) (((long) 6)), BgL_symbzd2funzd2_174);
										PROCEDURE_SET(BgL_zc3z04anonymousza32548ze3z87_13812,
											(int) (((long) 7)), BINT(BgL_siza7eza7_178));
										return BgL_zc3z04anonymousza32548ze3z87_13812;
									}
							}
					}
			}
		}

	}



/* &<@anonymous:2362> */
	obj_t BGl_z62zc3z04anonymousza32362ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_13813, obj_t BgL_sz00_13821)
	{
		{	/* Eval/evaluate_comp.scm 896 */
			{	/* Eval/evaluate_comp.scm 896 */
				obj_t BgL_a1z00_13814;
				obj_t BgL_a2z00_13815;
				obj_t BgL_a3z00_13816;
				obj_t BgL_a4z00_13817;
				long BgL_siza7eza7_13818;
				obj_t BgL_locz00_13819;
				obj_t BgL_cfunz00_13820;

				BgL_a1z00_13814 = PROCEDURE_REF(BgL_envz00_13813, (int) (((long) 0)));
				BgL_a2z00_13815 = PROCEDURE_REF(BgL_envz00_13813, (int) (((long) 1)));
				BgL_a3z00_13816 = PROCEDURE_REF(BgL_envz00_13813, (int) (((long) 2)));
				BgL_a4z00_13817 = PROCEDURE_REF(BgL_envz00_13813, (int) (((long) 3)));
				BgL_siza7eza7_13818 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13813, (int) (((long) 4))));
				BgL_locz00_13819 = PROCEDURE_REF(BgL_envz00_13813, (int) (((long) 5)));
				BgL_cfunz00_13820 = PROCEDURE_REF(BgL_envz00_13813, (int) (((long) 6)));
				{	/* Eval/evaluate_comp.scm 896 */
					obj_t BgL_bpz00_16242;

					BgL_bpz00_16242 = VECTOR_REF(((obj_t) BgL_sz00_13821), ((long) 0));
					{	/* Eval/evaluate_comp.scm 896 */
						obj_t BgL_a1z00_16243;
						obj_t BgL_a2z00_16244;
						obj_t BgL_a3z00_16245;
						obj_t BgL_a4z00_16246;

						BgL_a1z00_16243 =
							PROCEDURE_ENTRY(BgL_a1z00_13814) (BgL_a1z00_13814, BgL_sz00_13821,
							BEOA);
						BgL_a2z00_16244 =
							PROCEDURE_ENTRY(BgL_a2z00_13815) (BgL_a2z00_13815, BgL_sz00_13821,
							BEOA);
						BgL_a3z00_16245 =
							PROCEDURE_ENTRY(BgL_a3z00_13816) (BgL_a3z00_13816, BgL_sz00_13821,
							BEOA);
						BgL_a4z00_16246 =
							PROCEDURE_ENTRY(BgL_a4z00_13817) (BgL_a4z00_13817, BgL_sz00_13821,
							BEOA);
						{	/* Eval/evaluate_comp.scm 896 */
							long BgL_nbpz00_16247;

							BgL_nbpz00_16247 =
								((long) CINT(BgL_bpz00_16242) + BgL_siza7eza7_13818);
							VECTOR_SET(
								((obj_t) BgL_sz00_13821), ((long) 0), BINT(BgL_nbpz00_16247));
							{	/* Eval/evaluate_comp.scm 896 */
								obj_t BgL_tmpz00_22795;

								BgL_tmpz00_22795 = BGL_CURRENT_DYNAMIC_ENV();
								BGL_ENV_SET_TRACE_LOCATION(BgL_tmpz00_22795, BgL_locz00_13819);
							}
							{	/* Eval/evaluate_comp.scm 896 */
								obj_t BgL_rz00_16248;

								BgL_rz00_16248 =
									PROCEDURE_ENTRY(BgL_cfunz00_13820) (BgL_cfunz00_13820,
									BgL_a1z00_16243, BgL_a2z00_16244, BgL_a3z00_16245,
									BgL_a4z00_16246, BEOA);
								VECTOR_SET(((obj_t) BgL_sz00_13821), ((long) 0),
									BgL_bpz00_16242);
								return BgL_rz00_16248;
							}
						}
					}
				}
			}
		}

	}



/* &<@anonymous:2364> */
	obj_t BGl_z62zc3z04anonymousza32364ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_13822, obj_t BgL_sz00_13829)
	{
		{	/* Eval/evaluate_comp.scm 896 */
			{	/* Eval/evaluate_comp.scm 896 */
				obj_t BgL_a1z00_13823;
				obj_t BgL_a2z00_13824;
				obj_t BgL_a3z00_13825;
				obj_t BgL_a4z00_13826;
				long BgL_siza7eza7_13827;
				obj_t BgL_cfunz00_13828;

				BgL_a1z00_13823 = PROCEDURE_REF(BgL_envz00_13822, (int) (((long) 0)));
				BgL_a2z00_13824 = PROCEDURE_REF(BgL_envz00_13822, (int) (((long) 1)));
				BgL_a3z00_13825 = PROCEDURE_REF(BgL_envz00_13822, (int) (((long) 2)));
				BgL_a4z00_13826 = PROCEDURE_REF(BgL_envz00_13822, (int) (((long) 3)));
				BgL_siza7eza7_13827 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13822, (int) (((long) 4))));
				BgL_cfunz00_13828 = PROCEDURE_REF(BgL_envz00_13822, (int) (((long) 5)));
				{	/* Eval/evaluate_comp.scm 896 */
					obj_t BgL_bpz00_16249;

					BgL_bpz00_16249 = VECTOR_REF(((obj_t) BgL_sz00_13829), ((long) 0));
					{	/* Eval/evaluate_comp.scm 896 */
						obj_t BgL_a1z00_16250;
						obj_t BgL_a2z00_16251;
						obj_t BgL_a3z00_16252;
						obj_t BgL_a4z00_16253;

						BgL_a1z00_16250 =
							PROCEDURE_ENTRY(BgL_a1z00_13823) (BgL_a1z00_13823, BgL_sz00_13829,
							BEOA);
						BgL_a2z00_16251 =
							PROCEDURE_ENTRY(BgL_a2z00_13824) (BgL_a2z00_13824, BgL_sz00_13829,
							BEOA);
						BgL_a3z00_16252 =
							PROCEDURE_ENTRY(BgL_a3z00_13825) (BgL_a3z00_13825, BgL_sz00_13829,
							BEOA);
						BgL_a4z00_16253 =
							PROCEDURE_ENTRY(BgL_a4z00_13826) (BgL_a4z00_13826, BgL_sz00_13829,
							BEOA);
						{	/* Eval/evaluate_comp.scm 896 */
							long BgL_nbpz00_16254;

							BgL_nbpz00_16254 =
								((long) CINT(BgL_bpz00_16249) + BgL_siza7eza7_13827);
							VECTOR_SET(
								((obj_t) BgL_sz00_13829), ((long) 0), BINT(BgL_nbpz00_16254));
							{	/* Eval/evaluate_comp.scm 896 */
								obj_t BgL_rz00_16255;

								BgL_rz00_16255 =
									PROCEDURE_ENTRY(BgL_cfunz00_13828) (BgL_cfunz00_13828,
									BgL_a1z00_16250, BgL_a2z00_16251, BgL_a3z00_16252,
									BgL_a4z00_16253, BEOA);
								VECTOR_SET(((obj_t) BgL_sz00_13829), ((long) 0),
									BgL_bpz00_16249);
								return BgL_rz00_16255;
							}
						}
					}
				}
			}
		}

	}



/* &<@anonymous:2368> */
	obj_t BGl_z62zc3z04anonymousza32368ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_13830, obj_t BgL_sz00_13839)
	{
		{	/* Eval/evaluate_comp.scm 896 */
			{	/* Eval/evaluate_comp.scm 896 */
				obj_t BgL_funz00_13831;
				obj_t BgL_a1z00_13832;
				obj_t BgL_a2z00_13833;
				obj_t BgL_a3z00_13834;
				obj_t BgL_a4z00_13835;
				obj_t BgL_locz00_13836;
				obj_t BgL_symbzd2funzd2_13837;
				long BgL_siza7eza7_13838;

				BgL_funz00_13831 = PROCEDURE_REF(BgL_envz00_13830, (int) (((long) 0)));
				BgL_a1z00_13832 = PROCEDURE_REF(BgL_envz00_13830, (int) (((long) 1)));
				BgL_a2z00_13833 = PROCEDURE_REF(BgL_envz00_13830, (int) (((long) 2)));
				BgL_a3z00_13834 = PROCEDURE_REF(BgL_envz00_13830, (int) (((long) 3)));
				BgL_a4z00_13835 = PROCEDURE_REF(BgL_envz00_13830, (int) (((long) 4)));
				BgL_locz00_13836 = PROCEDURE_REF(BgL_envz00_13830, (int) (((long) 5)));
				BgL_symbzd2funzd2_13837 =
					PROCEDURE_REF(BgL_envz00_13830, (int) (((long) 6)));
				BgL_siza7eza7_13838 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13830, (int) (((long) 7))));
				{	/* Eval/evaluate_comp.scm 896 */
					obj_t BgL_bpz00_16256;

					BgL_bpz00_16256 = VECTOR_REF(((obj_t) BgL_sz00_13839), ((long) 0));
					{	/* Eval/evaluate_comp.scm 896 */
						obj_t BgL_fz00_16257;
						obj_t BgL_a1z00_16258;
						obj_t BgL_a2z00_16259;
						obj_t BgL_a3z00_16260;
						obj_t BgL_a4z00_16261;

						BgL_fz00_16257 =
							PROCEDURE_ENTRY(BgL_funz00_13831) (BgL_funz00_13831,
							BgL_sz00_13839, BEOA);
						BgL_a1z00_16258 =
							PROCEDURE_ENTRY(BgL_a1z00_13832) (BgL_a1z00_13832, BgL_sz00_13839,
							BEOA);
						BgL_a2z00_16259 =
							PROCEDURE_ENTRY(BgL_a2z00_13833) (BgL_a2z00_13833, BgL_sz00_13839,
							BEOA);
						BgL_a3z00_16260 =
							PROCEDURE_ENTRY(BgL_a3z00_13834) (BgL_a3z00_13834, BgL_sz00_13839,
							BEOA);
						BgL_a4z00_16261 =
							PROCEDURE_ENTRY(BgL_a4z00_13835) (BgL_a4z00_13835, BgL_sz00_13839,
							BEOA);
						if (PROCEDUREP(BgL_fz00_16257))
							{	/* Eval/evaluate_comp.scm 896 */
								BFALSE;
							}
						else
							{	/* Eval/evaluate_comp.scm 896 */
								BGl_evtypezd2errorzd2zz__everrorz00(BgL_locz00_13836,
									BGl_string5807z00zz__evaluate_compz00,
									BGl_string5823z00zz__evaluate_compz00, BgL_fz00_16257);
							}
						{	/* Eval/evaluate_comp.scm 896 */
							obj_t BgL_ufz00_16262;

							{	/* Eval/evaluate_comp.scm 896 */
								obj_t BgL_tmpz00_22894;

								BgL_tmpz00_22894 = ((obj_t) BgL_fz00_16257);
								BgL_ufz00_16262 = PROCEDURE_ATTR(BgL_tmpz00_22894);
							}
							{	/* Eval/evaluate_comp.scm 896 */
								bool_t BgL_test6371z00_22897;

								if (STRUCTP(BgL_ufz00_16262))
									{	/* Eval/evaluate_comp.scm 683 */
										BgL_test6371z00_22897 =
											(STRUCT_KEY(BgL_ufz00_16262) ==
											BGl_symbol5824z00zz__evaluate_compz00);
									}
								else
									{	/* Eval/evaluate_comp.scm 683 */
										BgL_test6371z00_22897 = ((bool_t) 0);
									}
								if (BgL_test6371z00_22897)
									{	/* Eval/evaluate_comp.scm 896 */
										obj_t BgL_arityz00_16263;
										obj_t BgL_runz00_16264;
										obj_t BgL_sfz00_16265;

										BgL_arityz00_16263 =
											STRUCT_REF(BgL_ufz00_16262, (int) (((long) 0)));
										BgL_runz00_16264 =
											STRUCT_REF(BgL_ufz00_16262, (int) (((long) 1)));
										BgL_sfz00_16265 =
											STRUCT_REF(BgL_ufz00_16262, (int) (((long) 2)));
										if (((long) CINT(BgL_arityz00_16263) == ((long) 4)))
											{	/* Eval/evaluate_comp.scm 896 */
												{	/* Eval/evaluate_comp.scm 896 */
													long BgL_arg2372z00_16266;

													BgL_arg2372z00_16266 =
														((long) CINT(BgL_bpz00_16256) + ((long) 0));
													VECTOR_SET(
														((obj_t) BgL_sz00_13839), BgL_arg2372z00_16266,
														BgL_a1z00_16258);
												}
												{	/* Eval/evaluate_comp.scm 896 */
													long BgL_arg2373z00_16267;

													BgL_arg2373z00_16267 =
														((long) CINT(BgL_bpz00_16256) + ((long) 1));
													VECTOR_SET(
														((obj_t) BgL_sz00_13839), BgL_arg2373z00_16267,
														BgL_a2z00_16259);
												}
												{	/* Eval/evaluate_comp.scm 896 */
													long BgL_arg2375z00_16268;

													BgL_arg2375z00_16268 =
														((long) CINT(BgL_bpz00_16256) + ((long) 2));
													VECTOR_SET(
														((obj_t) BgL_sz00_13839), BgL_arg2375z00_16268,
														BgL_a3z00_16260);
												}
												{	/* Eval/evaluate_comp.scm 896 */
													long BgL_arg2376z00_16269;

													BgL_arg2376z00_16269 =
														((long) CINT(BgL_bpz00_16256) + ((long) 3));
													VECTOR_SET(
														((obj_t) BgL_sz00_13839), BgL_arg2376z00_16269,
														BgL_a4z00_16261);
											}}
										else
											{	/* Eval/evaluate_comp.scm 896 */
												if (INTEGERP(BgL_arityz00_16263))
													{	/* Eval/evaluate_comp.scm 896 */
														switch ((long) CINT(BgL_arityz00_16263))
															{
															case ((long) -1):

																{	/* Eval/evaluate_comp.scm 896 */
																	long BgL_arg2378z00_16270;
																	obj_t BgL_arg2379z00_16271;

																	BgL_arg2378z00_16270 =
																		((long) CINT(BgL_bpz00_16256) + ((long) 0));
																	{	/* Eval/evaluate_comp.scm 896 */
																		obj_t BgL_list2380z00_16272;

																		{	/* Eval/evaluate_comp.scm 896 */
																			obj_t BgL_arg2381z00_16273;

																			{	/* Eval/evaluate_comp.scm 896 */
																				obj_t BgL_arg2382z00_16274;

																				{	/* Eval/evaluate_comp.scm 896 */
																					obj_t BgL_arg2383z00_16275;

																					BgL_arg2383z00_16275 =
																						MAKE_YOUNG_PAIR(BgL_a4z00_16261,
																						BNIL);
																					BgL_arg2382z00_16274 =
																						MAKE_YOUNG_PAIR(BgL_a3z00_16260,
																						BgL_arg2383z00_16275);
																				}
																				BgL_arg2381z00_16273 =
																					MAKE_YOUNG_PAIR(BgL_a2z00_16259,
																					BgL_arg2382z00_16274);
																			}
																			BgL_list2380z00_16272 =
																				MAKE_YOUNG_PAIR(BgL_a1z00_16258,
																				BgL_arg2381z00_16273);
																		}
																		BgL_arg2379z00_16271 =
																			BgL_list2380z00_16272;
																	}
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13839),
																		BgL_arg2378z00_16270, BgL_arg2379z00_16271);
																} break;
															case ((long) -2):

																{	/* Eval/evaluate_comp.scm 896 */
																	long BgL_arg2384z00_16276;

																	BgL_arg2384z00_16276 =
																		((long) CINT(BgL_bpz00_16256) + ((long) 0));
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13839),
																		BgL_arg2384z00_16276, BgL_a1z00_16258);
																}
																{	/* Eval/evaluate_comp.scm 896 */
																	long BgL_arg2385z00_16277;
																	obj_t BgL_arg2387z00_16278;

																	BgL_arg2385z00_16277 =
																		((long) CINT(BgL_bpz00_16256) + ((long) 1));
																	{	/* Eval/evaluate_comp.scm 896 */
																		obj_t BgL_list2388z00_16279;

																		{	/* Eval/evaluate_comp.scm 896 */
																			obj_t BgL_arg2389z00_16280;

																			{	/* Eval/evaluate_comp.scm 896 */
																				obj_t BgL_arg2391z00_16281;

																				BgL_arg2391z00_16281 =
																					MAKE_YOUNG_PAIR(BgL_a4z00_16261,
																					BNIL);
																				BgL_arg2389z00_16280 =
																					MAKE_YOUNG_PAIR(BgL_a3z00_16260,
																					BgL_arg2391z00_16281);
																			}
																			BgL_list2388z00_16279 =
																				MAKE_YOUNG_PAIR(BgL_a2z00_16259,
																				BgL_arg2389z00_16280);
																		}
																		BgL_arg2387z00_16278 =
																			BgL_list2388z00_16279;
																	}
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13839),
																		BgL_arg2385z00_16277, BgL_arg2387z00_16278);
																} break;
															case ((long) -3):

																{	/* Eval/evaluate_comp.scm 896 */
																	long BgL_arg2393z00_16282;

																	BgL_arg2393z00_16282 =
																		((long) CINT(BgL_bpz00_16256) + ((long) 0));
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13839),
																		BgL_arg2393z00_16282, BgL_a1z00_16258);
																}
																{	/* Eval/evaluate_comp.scm 896 */
																	long BgL_arg2394z00_16283;

																	BgL_arg2394z00_16283 =
																		((long) CINT(BgL_bpz00_16256) + ((long) 1));
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13839),
																		BgL_arg2394z00_16283, BgL_a2z00_16259);
																}
																{	/* Eval/evaluate_comp.scm 896 */
																	long BgL_arg2395z00_16284;
																	obj_t BgL_arg2397z00_16285;

																	BgL_arg2395z00_16284 =
																		((long) CINT(BgL_bpz00_16256) + ((long) 2));
																	{	/* Eval/evaluate_comp.scm 896 */
																		obj_t BgL_list2398z00_16286;

																		{	/* Eval/evaluate_comp.scm 896 */
																			obj_t BgL_arg2400z00_16287;

																			BgL_arg2400z00_16287 =
																				MAKE_YOUNG_PAIR(BgL_a4z00_16261, BNIL);
																			BgL_list2398z00_16286 =
																				MAKE_YOUNG_PAIR(BgL_a3z00_16260,
																				BgL_arg2400z00_16287);
																		}
																		BgL_arg2397z00_16285 =
																			BgL_list2398z00_16286;
																	}
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13839),
																		BgL_arg2395z00_16284, BgL_arg2397z00_16285);
																} break;
															case ((long) -4):

																{	/* Eval/evaluate_comp.scm 896 */
																	long BgL_arg2401z00_16288;

																	BgL_arg2401z00_16288 =
																		((long) CINT(BgL_bpz00_16256) + ((long) 0));
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13839),
																		BgL_arg2401z00_16288, BgL_a1z00_16258);
																}
																{	/* Eval/evaluate_comp.scm 896 */
																	long BgL_arg2403z00_16289;

																	BgL_arg2403z00_16289 =
																		((long) CINT(BgL_bpz00_16256) + ((long) 1));
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13839),
																		BgL_arg2403z00_16289, BgL_a2z00_16259);
																}
																{	/* Eval/evaluate_comp.scm 896 */
																	long BgL_arg2404z00_16290;

																	BgL_arg2404z00_16290 =
																		((long) CINT(BgL_bpz00_16256) + ((long) 2));
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13839),
																		BgL_arg2404z00_16290, BgL_a3z00_16260);
																}
																{	/* Eval/evaluate_comp.scm 896 */
																	long BgL_arg2405z00_16291;
																	obj_t BgL_arg2407z00_16292;

																	BgL_arg2405z00_16291 =
																		((long) CINT(BgL_bpz00_16256) + ((long) 3));
																	{	/* Eval/evaluate_comp.scm 896 */
																		obj_t BgL_list2408z00_16293;

																		BgL_list2408z00_16293 =
																			MAKE_YOUNG_PAIR(BgL_a4z00_16261, BNIL);
																		BgL_arg2407z00_16292 =
																			BgL_list2408z00_16293;
																	}
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13839),
																		BgL_arg2405z00_16291, BgL_arg2407z00_16292);
																} break;
															case ((long) -5):

																{	/* Eval/evaluate_comp.scm 896 */
																	long BgL_arg2410z00_16294;

																	BgL_arg2410z00_16294 =
																		((long) CINT(BgL_bpz00_16256) + ((long) 0));
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13839),
																		BgL_arg2410z00_16294, BgL_a1z00_16258);
																}
																{	/* Eval/evaluate_comp.scm 896 */
																	long BgL_arg2411z00_16295;

																	BgL_arg2411z00_16295 =
																		((long) CINT(BgL_bpz00_16256) + ((long) 1));
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13839),
																		BgL_arg2411z00_16295, BgL_a2z00_16259);
																}
																{	/* Eval/evaluate_comp.scm 896 */
																	long BgL_arg2412z00_16296;

																	BgL_arg2412z00_16296 =
																		((long) CINT(BgL_bpz00_16256) + ((long) 2));
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13839),
																		BgL_arg2412z00_16296, BgL_a3z00_16260);
																}
																{	/* Eval/evaluate_comp.scm 896 */
																	long BgL_arg2413z00_16297;

																	BgL_arg2413z00_16297 =
																		((long) CINT(BgL_bpz00_16256) + ((long) 3));
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13839),
																		BgL_arg2413z00_16297, BgL_a4z00_16261);
																}
																{	/* Eval/evaluate_comp.scm 896 */
																	long BgL_arg2415z00_16298;
																	obj_t BgL_arg2416z00_16299;

																	BgL_arg2415z00_16298 =
																		((long) CINT(BgL_bpz00_16256) + ((long) 4));
																	BgL_arg2416z00_16299 = BNIL;
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13839),
																		BgL_arg2415z00_16298, BgL_arg2416z00_16299);
																} break;
															default:
																BGl_evarityzd2errorzd2zz__everrorz00
																	(BgL_locz00_13836, STRUCT_REF(BgL_ufz00_16262,
																		(int) (((long) 3))), (int) (((long) 4)),
																	CINT(BgL_arityz00_16263));
													}}
												else
													{	/* Eval/evaluate_comp.scm 896 */
														BGl_evarityzd2errorzd2zz__everrorz00
															(BgL_locz00_13836, STRUCT_REF(BgL_ufz00_16262,
																(int) (((long) 3))), (int) (((long) 4)),
															CINT(BgL_arityz00_16263));
											}}
										{	/* Eval/evaluate_comp.scm 896 */
											obj_t BgL_z12denvz12_16300;

											BgL_z12denvz12_16300 = BGL_CURRENT_DYNAMIC_ENV();
											BGL_ENV_SET_TRACE_LOCATION(BgL_z12denvz12_16300,
												BgL_locz00_13836);
											if ((((long) CINT(BgL_bpz00_16256) +
														(long) CINT(BgL_sfz00_16265)) <
													VECTOR_LENGTH(((obj_t) BgL_sz00_13839))))
												{	/* Eval/evaluate_comp.scm 896 */
													return BgL_runz00_16264;
												}
											else
												{	/* Eval/evaluate_comp.scm 896 */
													obj_t BgL_nsz00_16301;

													BgL_nsz00_16301 =
														BGl_makezd2statezd2zz__evaluate_compz00();
													{	/* Eval/evaluate_comp.scm 896 */
														long BgL_arg2421z00_16302;

														BgL_arg2421z00_16302 =
															((long) CINT(BgL_bpz00_16256) + ((long) 4));
														BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00
															(BgL_nsz00_16301, ((long) 2), BgL_sz00_13839,
															BgL_bpz00_16256, BINT(BgL_arg2421z00_16302));
													}
													VECTOR_SET(BgL_nsz00_16301, ((long) 1),
														BgL_sz00_13839);
													BGL_ENV_EVSTATE_SET(BgL_z12denvz12_16300,
														BgL_nsz00_16301);
													{	/* Eval/evaluate_comp.scm 896 */
														obj_t BgL_ez00_16303;

														BgL_ez00_16303 = BGL_EXITD_TOP_AS_OBJ();
														BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
															(BgL_ez00_16303, BgL_sz00_13839);
														{	/* Eval/evaluate_comp.scm 896 */
															obj_t BgL_____rz00_16304;

															{	/* Eval/evaluate_comp.scm 670 */
																obj_t BgL_savedzd2bpzd2_16305;

																BgL_savedzd2bpzd2_16305 =
																	VECTOR_REF(BgL_nsz00_16301, ((long) 0));
																VECTOR_SET(BgL_nsz00_16301, ((long) 0),
																	BINT(((long) 2)));
																{
																	obj_t BgL_fz00_16307;

																	BgL_fz00_16307 = BgL_runz00_16264;
																BgL_recz00_16306:
																	{	/* Eval/evaluate_comp.scm 673 */
																		obj_t BgL_rz00_16308;

																		BgL_rz00_16308 =
																			PROCEDURE_ENTRY(BgL_fz00_16307)
																			(BgL_fz00_16307, BgL_nsz00_16301, BEOA);
																		{	/* Eval/evaluate_comp.scm 674 */
																			bool_t BgL_test6376z00_23036;

																			if (PROCEDUREP(BgL_rz00_16308))
																				{	/* Eval/evaluate_comp.scm 674 */
																					obj_t BgL_arg1702z00_16309;

																					BgL_arg1702z00_16309 =
																						PROCEDURE_ATTR(BgL_rz00_16308);
																					if (STRUCTP(BgL_arg1702z00_16309))
																						{	/* Eval/evaluate_comp.scm 654 */
																							BgL_test6376z00_23036 =
																								(STRUCT_KEY
																								(BgL_arg1702z00_16309) ==
																								BGl_symbol5803z00zz__evaluate_compz00);
																						}
																					else
																						{	/* Eval/evaluate_comp.scm 654 */
																							BgL_test6376z00_23036 =
																								((bool_t) 0);
																						}
																				}
																			else
																				{	/* Eval/evaluate_comp.scm 674 */
																					BgL_test6376z00_23036 = ((bool_t) 0);
																				}
																			if (BgL_test6376z00_23036)
																				{
																					obj_t BgL_fz00_23044;

																					BgL_fz00_23044 = BgL_rz00_16308;
																					BgL_fz00_16307 = BgL_fz00_23044;
																					goto BgL_recz00_16306;
																				}
																			else
																				{	/* Eval/evaluate_comp.scm 674 */
																					VECTOR_SET(BgL_nsz00_16301,
																						((long) 0),
																						BgL_savedzd2bpzd2_16305);
																					BgL_____rz00_16304 = BgL_rz00_16308;
															}}}}}
															BGl_exitdzd2popzd2protectz12z12zz__bexitz00
																(BgL_ez00_16303);
															BGL_ENV_EVSTATE_SET(BgL_z12denvz12_16300,
																BgL_sz00_13839);
															return BgL_____rz00_16304;
														}
													}
												}
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 896 */
										if (PROCEDURE_CORRECT_ARITYP(BgL_fz00_16257,
												(int) (((long) 4))))
											{	/* Eval/evaluate_comp.scm 896 */
												long BgL_nbpz00_16310;

												BgL_nbpz00_16310 =
													((long) CINT(BgL_bpz00_16256) + BgL_siza7eza7_13838);
												VECTOR_SET(
													((obj_t) BgL_sz00_13839), ((long) 0),
													BINT(BgL_nbpz00_16310));
												{	/* Eval/evaluate_comp.scm 896 */
													obj_t BgL_tmpz00_23056;

													BgL_tmpz00_23056 = BGL_CURRENT_DYNAMIC_ENV();
													BGL_ENV_SET_TRACE_LOCATION(BgL_tmpz00_23056,
														BgL_locz00_13836);
												}
												{	/* Eval/evaluate_comp.scm 896 */
													obj_t BgL_rz00_16311;

													BgL_rz00_16311 =
														PROCEDURE_ENTRY(BgL_fz00_16257) (BgL_fz00_16257,
														BgL_a1z00_16258, BgL_a2z00_16259, BgL_a3z00_16260,
														BgL_a4z00_16261, BEOA);
													VECTOR_SET(((obj_t) BgL_sz00_13839), ((long) 0),
														BgL_bpz00_16256);
													return BgL_rz00_16311;
												}
											}
										else
											{	/* Eval/evaluate_comp.scm 896 */
												return
													BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_13836,
													BgL_symbzd2funzd2_13837, (int) (((long) 4)),
													PROCEDURE_ARITY(BgL_fz00_16257));
		}}}}}}}}

	}



/* &<@anonymous:2426> */
	obj_t BGl_z62zc3z04anonymousza32426ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_13840, obj_t BgL_sz00_13849)
	{
		{	/* Eval/evaluate_comp.scm 896 */
			{	/* Eval/evaluate_comp.scm 896 */
				obj_t BgL_funz00_13841;
				obj_t BgL_a1z00_13842;
				obj_t BgL_a2z00_13843;
				obj_t BgL_a3z00_13844;
				obj_t BgL_a4z00_13845;
				obj_t BgL_locz00_13846;
				obj_t BgL_symbzd2funzd2_13847;
				long BgL_siza7eza7_13848;

				BgL_funz00_13841 = PROCEDURE_REF(BgL_envz00_13840, (int) (((long) 0)));
				BgL_a1z00_13842 = PROCEDURE_REF(BgL_envz00_13840, (int) (((long) 1)));
				BgL_a2z00_13843 = PROCEDURE_REF(BgL_envz00_13840, (int) (((long) 2)));
				BgL_a3z00_13844 = PROCEDURE_REF(BgL_envz00_13840, (int) (((long) 3)));
				BgL_a4z00_13845 = PROCEDURE_REF(BgL_envz00_13840, (int) (((long) 4)));
				BgL_locz00_13846 = PROCEDURE_REF(BgL_envz00_13840, (int) (((long) 5)));
				BgL_symbzd2funzd2_13847 =
					PROCEDURE_REF(BgL_envz00_13840, (int) (((long) 6)));
				BgL_siza7eza7_13848 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13840, (int) (((long) 7))));
				{	/* Eval/evaluate_comp.scm 896 */
					obj_t BgL_bpz00_16312;

					BgL_bpz00_16312 = VECTOR_REF(((obj_t) BgL_sz00_13849), ((long) 0));
					{	/* Eval/evaluate_comp.scm 896 */
						obj_t BgL_fz00_16313;
						obj_t BgL_a1z00_16314;
						obj_t BgL_a2z00_16315;
						obj_t BgL_a3z00_16316;
						obj_t BgL_a4z00_16317;

						BgL_fz00_16313 =
							PROCEDURE_ENTRY(BgL_funz00_13841) (BgL_funz00_13841,
							BgL_sz00_13849, BEOA);
						BgL_a1z00_16314 =
							PROCEDURE_ENTRY(BgL_a1z00_13842) (BgL_a1z00_13842, BgL_sz00_13849,
							BEOA);
						BgL_a2z00_16315 =
							PROCEDURE_ENTRY(BgL_a2z00_13843) (BgL_a2z00_13843, BgL_sz00_13849,
							BEOA);
						BgL_a3z00_16316 =
							PROCEDURE_ENTRY(BgL_a3z00_13844) (BgL_a3z00_13844, BgL_sz00_13849,
							BEOA);
						BgL_a4z00_16317 =
							PROCEDURE_ENTRY(BgL_a4z00_13845) (BgL_a4z00_13845, BgL_sz00_13849,
							BEOA);
						if (PROCEDUREP(BgL_fz00_16313))
							{	/* Eval/evaluate_comp.scm 896 */
								BFALSE;
							}
						else
							{	/* Eval/evaluate_comp.scm 896 */
								BGl_evtypezd2errorzd2zz__everrorz00(BgL_locz00_13846,
									BGl_string5807z00zz__evaluate_compz00,
									BGl_string5823z00zz__evaluate_compz00, BgL_fz00_16313);
							}
						{	/* Eval/evaluate_comp.scm 896 */
							obj_t BgL_ufz00_16318;

							{	/* Eval/evaluate_comp.scm 896 */
								obj_t BgL_tmpz00_23113;

								BgL_tmpz00_23113 = ((obj_t) BgL_fz00_16313);
								BgL_ufz00_16318 = PROCEDURE_ATTR(BgL_tmpz00_23113);
							}
							{	/* Eval/evaluate_comp.scm 896 */
								bool_t BgL_test6381z00_23116;

								if (STRUCTP(BgL_ufz00_16318))
									{	/* Eval/evaluate_comp.scm 683 */
										BgL_test6381z00_23116 =
											(STRUCT_KEY(BgL_ufz00_16318) ==
											BGl_symbol5824z00zz__evaluate_compz00);
									}
								else
									{	/* Eval/evaluate_comp.scm 683 */
										BgL_test6381z00_23116 = ((bool_t) 0);
									}
								if (BgL_test6381z00_23116)
									{	/* Eval/evaluate_comp.scm 896 */
										obj_t BgL_arityz00_16319;
										obj_t BgL_runz00_16320;
										obj_t BgL_sfz00_16321;

										BgL_arityz00_16319 =
											STRUCT_REF(BgL_ufz00_16318, (int) (((long) 0)));
										BgL_runz00_16320 =
											STRUCT_REF(BgL_ufz00_16318, (int) (((long) 1)));
										BgL_sfz00_16321 =
											STRUCT_REF(BgL_ufz00_16318, (int) (((long) 2)));
										if (((long) CINT(BgL_arityz00_16319) == ((long) 4)))
											{	/* Eval/evaluate_comp.scm 896 */
												{	/* Eval/evaluate_comp.scm 896 */
													long BgL_arg2430z00_16322;

													BgL_arg2430z00_16322 =
														((long) CINT(BgL_bpz00_16312) + ((long) 0));
													VECTOR_SET(
														((obj_t) BgL_sz00_13849), BgL_arg2430z00_16322,
														BgL_a1z00_16314);
												}
												{	/* Eval/evaluate_comp.scm 896 */
													long BgL_arg2431z00_16323;

													BgL_arg2431z00_16323 =
														((long) CINT(BgL_bpz00_16312) + ((long) 1));
													VECTOR_SET(
														((obj_t) BgL_sz00_13849), BgL_arg2431z00_16323,
														BgL_a2z00_16315);
												}
												{	/* Eval/evaluate_comp.scm 896 */
													long BgL_arg2433z00_16324;

													BgL_arg2433z00_16324 =
														((long) CINT(BgL_bpz00_16312) + ((long) 2));
													VECTOR_SET(
														((obj_t) BgL_sz00_13849), BgL_arg2433z00_16324,
														BgL_a3z00_16316);
												}
												{	/* Eval/evaluate_comp.scm 896 */
													long BgL_arg2434z00_16325;

													BgL_arg2434z00_16325 =
														((long) CINT(BgL_bpz00_16312) + ((long) 3));
													VECTOR_SET(
														((obj_t) BgL_sz00_13849), BgL_arg2434z00_16325,
														BgL_a4z00_16317);
											}}
										else
											{	/* Eval/evaluate_comp.scm 896 */
												if (INTEGERP(BgL_arityz00_16319))
													{	/* Eval/evaluate_comp.scm 896 */
														switch ((long) CINT(BgL_arityz00_16319))
															{
															case ((long) -1):

																{	/* Eval/evaluate_comp.scm 896 */
																	long BgL_arg2436z00_16326;
																	obj_t BgL_arg2437z00_16327;

																	BgL_arg2436z00_16326 =
																		((long) CINT(BgL_bpz00_16312) + ((long) 0));
																	{	/* Eval/evaluate_comp.scm 896 */
																		obj_t BgL_list2438z00_16328;

																		{	/* Eval/evaluate_comp.scm 896 */
																			obj_t BgL_arg2440z00_16329;

																			{	/* Eval/evaluate_comp.scm 896 */
																				obj_t BgL_arg2441z00_16330;

																				{	/* Eval/evaluate_comp.scm 896 */
																					obj_t BgL_arg2443z00_16331;

																					BgL_arg2443z00_16331 =
																						MAKE_YOUNG_PAIR(BgL_a4z00_16317,
																						BNIL);
																					BgL_arg2441z00_16330 =
																						MAKE_YOUNG_PAIR(BgL_a3z00_16316,
																						BgL_arg2443z00_16331);
																				}
																				BgL_arg2440z00_16329 =
																					MAKE_YOUNG_PAIR(BgL_a2z00_16315,
																					BgL_arg2441z00_16330);
																			}
																			BgL_list2438z00_16328 =
																				MAKE_YOUNG_PAIR(BgL_a1z00_16314,
																				BgL_arg2440z00_16329);
																		}
																		BgL_arg2437z00_16327 =
																			BgL_list2438z00_16328;
																	}
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13849),
																		BgL_arg2436z00_16326, BgL_arg2437z00_16327);
																} break;
															case ((long) -2):

																{	/* Eval/evaluate_comp.scm 896 */
																	long BgL_arg2444z00_16332;

																	BgL_arg2444z00_16332 =
																		((long) CINT(BgL_bpz00_16312) + ((long) 0));
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13849),
																		BgL_arg2444z00_16332, BgL_a1z00_16314);
																}
																{	/* Eval/evaluate_comp.scm 896 */
																	long BgL_arg2445z00_16333;
																	obj_t BgL_arg2446z00_16334;

																	BgL_arg2445z00_16333 =
																		((long) CINT(BgL_bpz00_16312) + ((long) 1));
																	{	/* Eval/evaluate_comp.scm 896 */
																		obj_t BgL_list2447z00_16335;

																		{	/* Eval/evaluate_comp.scm 896 */
																			obj_t BgL_arg2448z00_16336;

																			{	/* Eval/evaluate_comp.scm 896 */
																				obj_t BgL_arg2449z00_16337;

																				BgL_arg2449z00_16337 =
																					MAKE_YOUNG_PAIR(BgL_a4z00_16317,
																					BNIL);
																				BgL_arg2448z00_16336 =
																					MAKE_YOUNG_PAIR(BgL_a3z00_16316,
																					BgL_arg2449z00_16337);
																			}
																			BgL_list2447z00_16335 =
																				MAKE_YOUNG_PAIR(BgL_a2z00_16315,
																				BgL_arg2448z00_16336);
																		}
																		BgL_arg2446z00_16334 =
																			BgL_list2447z00_16335;
																	}
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13849),
																		BgL_arg2445z00_16333, BgL_arg2446z00_16334);
																} break;
															case ((long) -3):

																{	/* Eval/evaluate_comp.scm 896 */
																	long BgL_arg2450z00_16338;

																	BgL_arg2450z00_16338 =
																		((long) CINT(BgL_bpz00_16312) + ((long) 0));
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13849),
																		BgL_arg2450z00_16338, BgL_a1z00_16314);
																}
																{	/* Eval/evaluate_comp.scm 896 */
																	long BgL_arg2452z00_16339;

																	BgL_arg2452z00_16339 =
																		((long) CINT(BgL_bpz00_16312) + ((long) 1));
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13849),
																		BgL_arg2452z00_16339, BgL_a2z00_16315);
																}
																{	/* Eval/evaluate_comp.scm 896 */
																	long BgL_arg2453z00_16340;
																	obj_t BgL_arg2454z00_16341;

																	BgL_arg2453z00_16340 =
																		((long) CINT(BgL_bpz00_16312) + ((long) 2));
																	{	/* Eval/evaluate_comp.scm 896 */
																		obj_t BgL_list2455z00_16342;

																		{	/* Eval/evaluate_comp.scm 896 */
																			obj_t BgL_arg2456z00_16343;

																			BgL_arg2456z00_16343 =
																				MAKE_YOUNG_PAIR(BgL_a4z00_16317, BNIL);
																			BgL_list2455z00_16342 =
																				MAKE_YOUNG_PAIR(BgL_a3z00_16316,
																				BgL_arg2456z00_16343);
																		}
																		BgL_arg2454z00_16341 =
																			BgL_list2455z00_16342;
																	}
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13849),
																		BgL_arg2453z00_16340, BgL_arg2454z00_16341);
																} break;
															case ((long) -4):

																{	/* Eval/evaluate_comp.scm 896 */
																	long BgL_arg2457z00_16344;

																	BgL_arg2457z00_16344 =
																		((long) CINT(BgL_bpz00_16312) + ((long) 0));
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13849),
																		BgL_arg2457z00_16344, BgL_a1z00_16314);
																}
																{	/* Eval/evaluate_comp.scm 896 */
																	long BgL_arg2458z00_16345;

																	BgL_arg2458z00_16345 =
																		((long) CINT(BgL_bpz00_16312) + ((long) 1));
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13849),
																		BgL_arg2458z00_16345, BgL_a2z00_16315);
																}
																{	/* Eval/evaluate_comp.scm 896 */
																	long BgL_arg2461z00_16346;

																	BgL_arg2461z00_16346 =
																		((long) CINT(BgL_bpz00_16312) + ((long) 2));
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13849),
																		BgL_arg2461z00_16346, BgL_a3z00_16316);
																}
																{	/* Eval/evaluate_comp.scm 896 */
																	long BgL_arg2463z00_16347;
																	obj_t BgL_arg2464z00_16348;

																	BgL_arg2463z00_16347 =
																		((long) CINT(BgL_bpz00_16312) + ((long) 3));
																	{	/* Eval/evaluate_comp.scm 896 */
																		obj_t BgL_list2465z00_16349;

																		BgL_list2465z00_16349 =
																			MAKE_YOUNG_PAIR(BgL_a4z00_16317, BNIL);
																		BgL_arg2464z00_16348 =
																			BgL_list2465z00_16349;
																	}
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13849),
																		BgL_arg2463z00_16347, BgL_arg2464z00_16348);
																} break;
															case ((long) -5):

																{	/* Eval/evaluate_comp.scm 896 */
																	long BgL_arg2466z00_16350;

																	BgL_arg2466z00_16350 =
																		((long) CINT(BgL_bpz00_16312) + ((long) 0));
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13849),
																		BgL_arg2466z00_16350, BgL_a1z00_16314);
																}
																{	/* Eval/evaluate_comp.scm 896 */
																	long BgL_arg2467z00_16351;

																	BgL_arg2467z00_16351 =
																		((long) CINT(BgL_bpz00_16312) + ((long) 1));
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13849),
																		BgL_arg2467z00_16351, BgL_a2z00_16315);
																}
																{	/* Eval/evaluate_comp.scm 896 */
																	long BgL_arg2468z00_16352;

																	BgL_arg2468z00_16352 =
																		((long) CINT(BgL_bpz00_16312) + ((long) 2));
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13849),
																		BgL_arg2468z00_16352, BgL_a3z00_16316);
																}
																{	/* Eval/evaluate_comp.scm 896 */
																	long BgL_arg2470z00_16353;

																	BgL_arg2470z00_16353 =
																		((long) CINT(BgL_bpz00_16312) + ((long) 3));
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13849),
																		BgL_arg2470z00_16353, BgL_a4z00_16317);
																}
																{	/* Eval/evaluate_comp.scm 896 */
																	long BgL_arg2471z00_16354;
																	obj_t BgL_arg2472z00_16355;

																	BgL_arg2471z00_16354 =
																		((long) CINT(BgL_bpz00_16312) + ((long) 4));
																	BgL_arg2472z00_16355 = BNIL;
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13849),
																		BgL_arg2471z00_16354, BgL_arg2472z00_16355);
																} break;
															default:
																BGl_evarityzd2errorzd2zz__everrorz00
																	(BgL_locz00_13846, STRUCT_REF(BgL_ufz00_16318,
																		(int) (((long) 3))), (int) (((long) 4)),
																	CINT(BgL_arityz00_16319));
													}}
												else
													{	/* Eval/evaluate_comp.scm 896 */
														BGl_evarityzd2errorzd2zz__everrorz00
															(BgL_locz00_13846, STRUCT_REF(BgL_ufz00_16318,
																(int) (((long) 3))), (int) (((long) 4)),
															CINT(BgL_arityz00_16319));
											}}
										{	/* Eval/evaluate_comp.scm 896 */
											obj_t BgL_z12denvz12_16356;

											BgL_z12denvz12_16356 = BGL_CURRENT_DYNAMIC_ENV();
											if (
												(((long) CINT(BgL_bpz00_16312) +
														(long) CINT(BgL_sfz00_16321)) <
													VECTOR_LENGTH(((obj_t) BgL_sz00_13849))))
												{	/* Eval/evaluate_comp.scm 896 */
													return BgL_runz00_16320;
												}
											else
												{	/* Eval/evaluate_comp.scm 896 */
													obj_t BgL_nsz00_16357;

													BgL_nsz00_16357 =
														BGl_makezd2statezd2zz__evaluate_compz00();
													{	/* Eval/evaluate_comp.scm 896 */
														long BgL_arg2476z00_16358;

														BgL_arg2476z00_16358 =
															((long) CINT(BgL_bpz00_16312) + ((long) 4));
														BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00
															(BgL_nsz00_16357, ((long) 2), BgL_sz00_13849,
															BgL_bpz00_16312, BINT(BgL_arg2476z00_16358));
													}
													VECTOR_SET(BgL_nsz00_16357, ((long) 1),
														BgL_sz00_13849);
													BGL_ENV_EVSTATE_SET(BgL_z12denvz12_16356,
														BgL_nsz00_16357);
													{	/* Eval/evaluate_comp.scm 896 */
														obj_t BgL_ez00_16359;

														BgL_ez00_16359 = BGL_EXITD_TOP_AS_OBJ();
														BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
															(BgL_ez00_16359, BgL_sz00_13849);
														{	/* Eval/evaluate_comp.scm 896 */
															obj_t BgL_____rz00_16360;

															{	/* Eval/evaluate_comp.scm 670 */
																obj_t BgL_savedzd2bpzd2_16361;

																BgL_savedzd2bpzd2_16361 =
																	VECTOR_REF(BgL_nsz00_16357, ((long) 0));
																VECTOR_SET(BgL_nsz00_16357, ((long) 0),
																	BINT(((long) 2)));
																{
																	obj_t BgL_fz00_16363;

																	BgL_fz00_16363 = BgL_runz00_16320;
																BgL_recz00_16362:
																	{	/* Eval/evaluate_comp.scm 673 */
																		obj_t BgL_rz00_16364;

																		BgL_rz00_16364 =
																			PROCEDURE_ENTRY(BgL_fz00_16363)
																			(BgL_fz00_16363, BgL_nsz00_16357, BEOA);
																		{	/* Eval/evaluate_comp.scm 674 */
																			bool_t BgL_test6386z00_23254;

																			if (PROCEDUREP(BgL_rz00_16364))
																				{	/* Eval/evaluate_comp.scm 674 */
																					obj_t BgL_arg1702z00_16365;

																					BgL_arg1702z00_16365 =
																						PROCEDURE_ATTR(BgL_rz00_16364);
																					if (STRUCTP(BgL_arg1702z00_16365))
																						{	/* Eval/evaluate_comp.scm 654 */
																							BgL_test6386z00_23254 =
																								(STRUCT_KEY
																								(BgL_arg1702z00_16365) ==
																								BGl_symbol5803z00zz__evaluate_compz00);
																						}
																					else
																						{	/* Eval/evaluate_comp.scm 654 */
																							BgL_test6386z00_23254 =
																								((bool_t) 0);
																						}
																				}
																			else
																				{	/* Eval/evaluate_comp.scm 674 */
																					BgL_test6386z00_23254 = ((bool_t) 0);
																				}
																			if (BgL_test6386z00_23254)
																				{
																					obj_t BgL_fz00_23262;

																					BgL_fz00_23262 = BgL_rz00_16364;
																					BgL_fz00_16363 = BgL_fz00_23262;
																					goto BgL_recz00_16362;
																				}
																			else
																				{	/* Eval/evaluate_comp.scm 674 */
																					VECTOR_SET(BgL_nsz00_16357,
																						((long) 0),
																						BgL_savedzd2bpzd2_16361);
																					BgL_____rz00_16360 = BgL_rz00_16364;
															}}}}}
															BGl_exitdzd2popzd2protectz12z12zz__bexitz00
																(BgL_ez00_16359);
															BGL_ENV_EVSTATE_SET(BgL_z12denvz12_16356,
																BgL_sz00_13849);
															return BgL_____rz00_16360;
														}
													}
												}
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 896 */
										if (PROCEDURE_CORRECT_ARITYP(BgL_fz00_16313,
												(int) (((long) 4))))
											{	/* Eval/evaluate_comp.scm 896 */
												long BgL_nbpz00_16366;

												BgL_nbpz00_16366 =
													((long) CINT(BgL_bpz00_16312) + BgL_siza7eza7_13848);
												VECTOR_SET(
													((obj_t) BgL_sz00_13849), ((long) 0),
													BINT(BgL_nbpz00_16366));
												{	/* Eval/evaluate_comp.scm 896 */
													obj_t BgL_rz00_16367;

													BgL_rz00_16367 =
														PROCEDURE_ENTRY(BgL_fz00_16313) (BgL_fz00_16313,
														BgL_a1z00_16314, BgL_a2z00_16315, BgL_a3z00_16316,
														BgL_a4z00_16317, BEOA);
													VECTOR_SET(((obj_t) BgL_sz00_13849), ((long) 0),
														BgL_bpz00_16312);
													return BgL_rz00_16367;
												}
											}
										else
											{	/* Eval/evaluate_comp.scm 896 */
												return
													BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_13846,
													BgL_symbzd2funzd2_13847, (int) (((long) 4)),
													PROCEDURE_ARITY(BgL_fz00_16313));
		}}}}}}}}

	}



/* &<@anonymous:2482> */
	obj_t BGl_z62zc3z04anonymousza32482ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_13850, obj_t BgL_sz00_13859)
	{
		{	/* Eval/evaluate_comp.scm 896 */
			{	/* Eval/evaluate_comp.scm 896 */
				obj_t BgL_funz00_13851;
				obj_t BgL_a1z00_13852;
				obj_t BgL_a2z00_13853;
				obj_t BgL_a3z00_13854;
				obj_t BgL_a4z00_13855;
				obj_t BgL_locz00_13856;
				obj_t BgL_symbzd2funzd2_13857;
				long BgL_siza7eza7_13858;

				BgL_funz00_13851 = PROCEDURE_REF(BgL_envz00_13850, (int) (((long) 0)));
				BgL_a1z00_13852 = PROCEDURE_REF(BgL_envz00_13850, (int) (((long) 1)));
				BgL_a2z00_13853 = PROCEDURE_REF(BgL_envz00_13850, (int) (((long) 2)));
				BgL_a3z00_13854 = PROCEDURE_REF(BgL_envz00_13850, (int) (((long) 3)));
				BgL_a4z00_13855 = PROCEDURE_REF(BgL_envz00_13850, (int) (((long) 4)));
				BgL_locz00_13856 = PROCEDURE_REF(BgL_envz00_13850, (int) (((long) 5)));
				BgL_symbzd2funzd2_13857 =
					PROCEDURE_REF(BgL_envz00_13850, (int) (((long) 6)));
				BgL_siza7eza7_13858 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13850, (int) (((long) 7))));
				{	/* Eval/evaluate_comp.scm 896 */
					obj_t BgL_bpz00_16368;

					BgL_bpz00_16368 = VECTOR_REF(((obj_t) BgL_sz00_13859), ((long) 0));
					{	/* Eval/evaluate_comp.scm 896 */
						obj_t BgL_fz00_16369;
						obj_t BgL_a1z00_16370;
						obj_t BgL_a2z00_16371;
						obj_t BgL_a3z00_16372;
						obj_t BgL_a4z00_16373;

						BgL_fz00_16369 =
							PROCEDURE_ENTRY(BgL_funz00_13851) (BgL_funz00_13851,
							BgL_sz00_13859, BEOA);
						BgL_a1z00_16370 =
							PROCEDURE_ENTRY(BgL_a1z00_13852) (BgL_a1z00_13852, BgL_sz00_13859,
							BEOA);
						BgL_a2z00_16371 =
							PROCEDURE_ENTRY(BgL_a2z00_13853) (BgL_a2z00_13853, BgL_sz00_13859,
							BEOA);
						BgL_a3z00_16372 =
							PROCEDURE_ENTRY(BgL_a3z00_13854) (BgL_a3z00_13854, BgL_sz00_13859,
							BEOA);
						BgL_a4z00_16373 =
							PROCEDURE_ENTRY(BgL_a4z00_13855) (BgL_a4z00_13855, BgL_sz00_13859,
							BEOA);
						if (PROCEDUREP(BgL_fz00_16369))
							{	/* Eval/evaluate_comp.scm 896 */
								BFALSE;
							}
						else
							{	/* Eval/evaluate_comp.scm 896 */
								BGl_evtypezd2errorzd2zz__everrorz00(BgL_locz00_13856,
									BGl_string5807z00zz__evaluate_compz00,
									BGl_string5823z00zz__evaluate_compz00, BgL_fz00_16369);
							}
						{	/* Eval/evaluate_comp.scm 896 */
							obj_t BgL_ufz00_16374;

							{	/* Eval/evaluate_comp.scm 896 */
								obj_t BgL_tmpz00_23328;

								BgL_tmpz00_23328 = ((obj_t) BgL_fz00_16369);
								BgL_ufz00_16374 = PROCEDURE_ATTR(BgL_tmpz00_23328);
							}
							{	/* Eval/evaluate_comp.scm 896 */
								bool_t BgL_test6391z00_23331;

								if (STRUCTP(BgL_ufz00_16374))
									{	/* Eval/evaluate_comp.scm 683 */
										BgL_test6391z00_23331 =
											(STRUCT_KEY(BgL_ufz00_16374) ==
											BGl_symbol5824z00zz__evaluate_compz00);
									}
								else
									{	/* Eval/evaluate_comp.scm 683 */
										BgL_test6391z00_23331 = ((bool_t) 0);
									}
								if (BgL_test6391z00_23331)
									{	/* Eval/evaluate_comp.scm 896 */
										obj_t BgL_arityz00_16375;
										obj_t BgL_runz00_16376;
										obj_t BgL_sfz00_16377;

										BgL_arityz00_16375 =
											STRUCT_REF(BgL_ufz00_16374, (int) (((long) 0)));
										BgL_runz00_16376 =
											STRUCT_REF(BgL_ufz00_16374, (int) (((long) 1)));
										BgL_sfz00_16377 =
											STRUCT_REF(BgL_ufz00_16374, (int) (((long) 2)));
										{	/* Eval/evaluate_comp.scm 896 */
											long BgL_spz00_16378;

											BgL_spz00_16378 =
												((long) CINT(BgL_bpz00_16368) + BgL_siza7eza7_13858);
											if (((long) CINT(BgL_arityz00_16375) == ((long) 4)))
												{	/* Eval/evaluate_comp.scm 896 */
													{	/* Eval/evaluate_comp.scm 896 */
														long BgL_arg2486z00_16379;

														BgL_arg2486z00_16379 =
															(BgL_spz00_16378 + ((long) 0));
														VECTOR_SET(
															((obj_t) BgL_sz00_13859), BgL_arg2486z00_16379,
															BgL_a1z00_16370);
													}
													{	/* Eval/evaluate_comp.scm 896 */
														long BgL_arg2488z00_16380;

														BgL_arg2488z00_16380 =
															(BgL_spz00_16378 + ((long) 1));
														VECTOR_SET(
															((obj_t) BgL_sz00_13859), BgL_arg2488z00_16380,
															BgL_a2z00_16371);
													}
													{	/* Eval/evaluate_comp.scm 896 */
														long BgL_arg2489z00_16381;

														BgL_arg2489z00_16381 =
															(BgL_spz00_16378 + ((long) 2));
														VECTOR_SET(
															((obj_t) BgL_sz00_13859), BgL_arg2489z00_16381,
															BgL_a3z00_16372);
													}
													{	/* Eval/evaluate_comp.scm 896 */
														long BgL_arg2490z00_16382;

														BgL_arg2490z00_16382 =
															(BgL_spz00_16378 + ((long) 3));
														VECTOR_SET(
															((obj_t) BgL_sz00_13859), BgL_arg2490z00_16382,
															BgL_a4z00_16373);
												}}
											else
												{	/* Eval/evaluate_comp.scm 896 */
													if (INTEGERP(BgL_arityz00_16375))
														{	/* Eval/evaluate_comp.scm 896 */
															switch ((long) CINT(BgL_arityz00_16375))
																{
																case ((long) -1):

																	{	/* Eval/evaluate_comp.scm 896 */
																		long BgL_arg2493z00_16383;
																		obj_t BgL_arg2495z00_16384;

																		BgL_arg2493z00_16383 =
																			(BgL_spz00_16378 + ((long) 0));
																		{	/* Eval/evaluate_comp.scm 896 */
																			obj_t BgL_list2496z00_16385;

																			{	/* Eval/evaluate_comp.scm 896 */
																				obj_t BgL_arg2497z00_16386;

																				{	/* Eval/evaluate_comp.scm 896 */
																					obj_t BgL_arg2498z00_16387;

																					{	/* Eval/evaluate_comp.scm 896 */
																						obj_t BgL_arg2500z00_16388;

																						BgL_arg2500z00_16388 =
																							MAKE_YOUNG_PAIR(BgL_a4z00_16373,
																							BNIL);
																						BgL_arg2498z00_16387 =
																							MAKE_YOUNG_PAIR(BgL_a3z00_16372,
																							BgL_arg2500z00_16388);
																					}
																					BgL_arg2497z00_16386 =
																						MAKE_YOUNG_PAIR(BgL_a2z00_16371,
																						BgL_arg2498z00_16387);
																				}
																				BgL_list2496z00_16385 =
																					MAKE_YOUNG_PAIR(BgL_a1z00_16370,
																					BgL_arg2497z00_16386);
																			}
																			BgL_arg2495z00_16384 =
																				BgL_list2496z00_16385;
																		}
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13859),
																			BgL_arg2493z00_16383,
																			BgL_arg2495z00_16384);
																	} break;
																case ((long) -2):

																	{	/* Eval/evaluate_comp.scm 896 */
																		long BgL_arg2501z00_16389;

																		BgL_arg2501z00_16389 =
																			(BgL_spz00_16378 + ((long) 0));
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13859),
																			BgL_arg2501z00_16389, BgL_a1z00_16370);
																	}
																	{	/* Eval/evaluate_comp.scm 896 */
																		long BgL_arg2502z00_16390;
																		obj_t BgL_arg2504z00_16391;

																		BgL_arg2502z00_16390 =
																			(BgL_spz00_16378 + ((long) 1));
																		{	/* Eval/evaluate_comp.scm 896 */
																			obj_t BgL_list2505z00_16392;

																			{	/* Eval/evaluate_comp.scm 896 */
																				obj_t BgL_arg2506z00_16393;

																				{	/* Eval/evaluate_comp.scm 896 */
																					obj_t BgL_arg2507z00_16394;

																					BgL_arg2507z00_16394 =
																						MAKE_YOUNG_PAIR(BgL_a4z00_16373,
																						BNIL);
																					BgL_arg2506z00_16393 =
																						MAKE_YOUNG_PAIR(BgL_a3z00_16372,
																						BgL_arg2507z00_16394);
																				}
																				BgL_list2505z00_16392 =
																					MAKE_YOUNG_PAIR(BgL_a2z00_16371,
																					BgL_arg2506z00_16393);
																			}
																			BgL_arg2504z00_16391 =
																				BgL_list2505z00_16392;
																		}
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13859),
																			BgL_arg2502z00_16390,
																			BgL_arg2504z00_16391);
																	} break;
																case ((long) -3):

																	{	/* Eval/evaluate_comp.scm 896 */
																		long BgL_arg2508z00_16395;

																		BgL_arg2508z00_16395 =
																			(BgL_spz00_16378 + ((long) 0));
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13859),
																			BgL_arg2508z00_16395, BgL_a1z00_16370);
																	}
																	{	/* Eval/evaluate_comp.scm 896 */
																		long BgL_arg2510z00_16396;

																		BgL_arg2510z00_16396 =
																			(BgL_spz00_16378 + ((long) 1));
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13859),
																			BgL_arg2510z00_16396, BgL_a2z00_16371);
																	}
																	{	/* Eval/evaluate_comp.scm 896 */
																		long BgL_arg2511z00_16397;
																		obj_t BgL_arg2515z00_16398;

																		BgL_arg2511z00_16397 =
																			(BgL_spz00_16378 + ((long) 2));
																		{	/* Eval/evaluate_comp.scm 896 */
																			obj_t BgL_list2516z00_16399;

																			{	/* Eval/evaluate_comp.scm 896 */
																				obj_t BgL_arg2518z00_16400;

																				BgL_arg2518z00_16400 =
																					MAKE_YOUNG_PAIR(BgL_a4z00_16373,
																					BNIL);
																				BgL_list2516z00_16399 =
																					MAKE_YOUNG_PAIR(BgL_a3z00_16372,
																					BgL_arg2518z00_16400);
																			}
																			BgL_arg2515z00_16398 =
																				BgL_list2516z00_16399;
																		}
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13859),
																			BgL_arg2511z00_16397,
																			BgL_arg2515z00_16398);
																	} break;
																case ((long) -4):

																	{	/* Eval/evaluate_comp.scm 896 */
																		long BgL_arg2519z00_16401;

																		BgL_arg2519z00_16401 =
																			(BgL_spz00_16378 + ((long) 0));
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13859),
																			BgL_arg2519z00_16401, BgL_a1z00_16370);
																	}
																	{	/* Eval/evaluate_comp.scm 896 */
																		long BgL_arg2520z00_16402;

																		BgL_arg2520z00_16402 =
																			(BgL_spz00_16378 + ((long) 1));
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13859),
																			BgL_arg2520z00_16402, BgL_a2z00_16371);
																	}
																	{	/* Eval/evaluate_comp.scm 896 */
																		long BgL_arg2521z00_16403;

																		BgL_arg2521z00_16403 =
																			(BgL_spz00_16378 + ((long) 2));
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13859),
																			BgL_arg2521z00_16403, BgL_a3z00_16372);
																	}
																	{	/* Eval/evaluate_comp.scm 896 */
																		long BgL_arg2522z00_16404;
																		obj_t BgL_arg2524z00_16405;

																		BgL_arg2522z00_16404 =
																			(BgL_spz00_16378 + ((long) 3));
																		{	/* Eval/evaluate_comp.scm 896 */
																			obj_t BgL_list2525z00_16406;

																			BgL_list2525z00_16406 =
																				MAKE_YOUNG_PAIR(BgL_a4z00_16373, BNIL);
																			BgL_arg2524z00_16405 =
																				BgL_list2525z00_16406;
																		}
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13859),
																			BgL_arg2522z00_16404,
																			BgL_arg2524z00_16405);
																	} break;
																case ((long) -5):

																	{	/* Eval/evaluate_comp.scm 896 */
																		long BgL_arg2528z00_16407;

																		BgL_arg2528z00_16407 =
																			(BgL_spz00_16378 + ((long) 0));
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13859),
																			BgL_arg2528z00_16407, BgL_a1z00_16370);
																	}
																	{	/* Eval/evaluate_comp.scm 896 */
																		long BgL_arg2533z00_16408;

																		BgL_arg2533z00_16408 =
																			(BgL_spz00_16378 + ((long) 1));
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13859),
																			BgL_arg2533z00_16408, BgL_a2z00_16371);
																	}
																	{	/* Eval/evaluate_comp.scm 896 */
																		long BgL_arg2534z00_16409;

																		BgL_arg2534z00_16409 =
																			(BgL_spz00_16378 + ((long) 2));
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13859),
																			BgL_arg2534z00_16409, BgL_a3z00_16372);
																	}
																	{	/* Eval/evaluate_comp.scm 896 */
																		long BgL_arg2538z00_16410;

																		BgL_arg2538z00_16410 =
																			(BgL_spz00_16378 + ((long) 3));
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13859),
																			BgL_arg2538z00_16410, BgL_a4z00_16373);
																	}
																	{	/* Eval/evaluate_comp.scm 896 */
																		long BgL_arg2539z00_16411;
																		obj_t BgL_arg2540z00_16412;

																		BgL_arg2539z00_16411 =
																			(BgL_spz00_16378 + ((long) 4));
																		BgL_arg2540z00_16412 = BNIL;
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13859),
																			BgL_arg2539z00_16411,
																			BgL_arg2540z00_16412);
																	} break;
																default:
																	BGl_evarityzd2errorzd2zz__everrorz00
																		(BgL_locz00_13856,
																		STRUCT_REF(BgL_ufz00_16374,
																			(int) (((long) 3))), (int) (((long) 4)),
																		CINT(BgL_arityz00_16375));
														}}
													else
														{	/* Eval/evaluate_comp.scm 896 */
															BGl_evarityzd2errorzd2zz__everrorz00
																(BgL_locz00_13856, STRUCT_REF(BgL_ufz00_16374,
																	(int) (((long) 3))), (int) (((long) 4)),
																CINT(BgL_arityz00_16375));
												}}
											{	/* Eval/evaluate_comp.scm 896 */
												obj_t BgL_z12denvz12_16413;

												BgL_z12denvz12_16413 = BGL_CURRENT_DYNAMIC_ENV();
												BGL_ENV_SET_TRACE_LOCATION(BgL_z12denvz12_16413,
													BgL_locz00_13856);
												if (((BgL_spz00_16378 + (long) CINT(BgL_sfz00_16377)) <
														VECTOR_LENGTH(((obj_t) BgL_sz00_13859))))
													{	/* Eval/evaluate_comp.scm 896 */
														return
															BGl_catchzd2trampolinezd2zz__evaluate_compz00
															(BgL_runz00_16376, BgL_sz00_13859,
															BINT(BgL_spz00_16378));
													}
												else
													{	/* Eval/evaluate_comp.scm 896 */
														obj_t BgL_nsz00_16414;

														BgL_nsz00_16414 =
															BGl_makezd2statezd2zz__evaluate_compz00();
														{	/* Eval/evaluate_comp.scm 896 */
															long BgL_arg2544z00_16415;

															BgL_arg2544z00_16415 =
																(BgL_spz00_16378 + ((long) 4));
															BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00
																(BgL_nsz00_16414, ((long) 2), BgL_sz00_13859,
																BINT(BgL_spz00_16378),
																BINT(BgL_arg2544z00_16415));
														}
														VECTOR_SET(BgL_nsz00_16414, ((long) 1),
															BgL_sz00_13859);
														BGL_ENV_EVSTATE_SET(BgL_z12denvz12_16413,
															BgL_nsz00_16414);
														{	/* Eval/evaluate_comp.scm 896 */
															obj_t BgL_ez00_16416;

															BgL_ez00_16416 = BGL_EXITD_TOP_AS_OBJ();
															BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
																(BgL_ez00_16416, BgL_sz00_13859);
															{	/* Eval/evaluate_comp.scm 896 */
																obj_t BgL_____rz00_16417;

																{	/* Eval/evaluate_comp.scm 670 */
																	obj_t BgL_savedzd2bpzd2_16418;

																	BgL_savedzd2bpzd2_16418 =
																		VECTOR_REF(BgL_nsz00_16414, ((long) 0));
																	VECTOR_SET(BgL_nsz00_16414, ((long) 0),
																		BINT(((long) 2)));
																	{
																		obj_t BgL_fz00_16420;

																		BgL_fz00_16420 = BgL_runz00_16376;
																	BgL_recz00_16419:
																		{	/* Eval/evaluate_comp.scm 673 */
																			obj_t BgL_rz00_16421;

																			BgL_rz00_16421 =
																				PROCEDURE_ENTRY(BgL_fz00_16420)
																				(BgL_fz00_16420, BgL_nsz00_16414, BEOA);
																			{	/* Eval/evaluate_comp.scm 674 */
																				bool_t BgL_test6396z00_23454;

																				if (PROCEDUREP(BgL_rz00_16421))
																					{	/* Eval/evaluate_comp.scm 674 */
																						obj_t BgL_arg1702z00_16422;

																						BgL_arg1702z00_16422 =
																							PROCEDURE_ATTR(BgL_rz00_16421);
																						if (STRUCTP(BgL_arg1702z00_16422))
																							{	/* Eval/evaluate_comp.scm 654 */
																								BgL_test6396z00_23454 =
																									(STRUCT_KEY
																									(BgL_arg1702z00_16422) ==
																									BGl_symbol5803z00zz__evaluate_compz00);
																							}
																						else
																							{	/* Eval/evaluate_comp.scm 654 */
																								BgL_test6396z00_23454 =
																									((bool_t) 0);
																							}
																					}
																				else
																					{	/* Eval/evaluate_comp.scm 674 */
																						BgL_test6396z00_23454 =
																							((bool_t) 0);
																					}
																				if (BgL_test6396z00_23454)
																					{
																						obj_t BgL_fz00_23462;

																						BgL_fz00_23462 = BgL_rz00_16421;
																						BgL_fz00_16420 = BgL_fz00_23462;
																						goto BgL_recz00_16419;
																					}
																				else
																					{	/* Eval/evaluate_comp.scm 674 */
																						VECTOR_SET(BgL_nsz00_16414,
																							((long) 0),
																							BgL_savedzd2bpzd2_16418);
																						BgL_____rz00_16417 = BgL_rz00_16421;
																}}}}}
																BGl_exitdzd2popzd2protectz12z12zz__bexitz00
																	(BgL_ez00_16416);
																BGL_ENV_EVSTATE_SET(BgL_z12denvz12_16413,
																	BgL_sz00_13859);
																return BgL_____rz00_16417;
															}
														}
													}
											}
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 896 */
										if (PROCEDURE_CORRECT_ARITYP(BgL_fz00_16369,
												(int) (((long) 4))))
											{	/* Eval/evaluate_comp.scm 896 */
												long BgL_nbpz00_16423;

												BgL_nbpz00_16423 =
													((long) CINT(BgL_bpz00_16368) + BgL_siza7eza7_13858);
												VECTOR_SET(
													((obj_t) BgL_sz00_13859), ((long) 0),
													BINT(BgL_nbpz00_16423));
												{	/* Eval/evaluate_comp.scm 896 */
													obj_t BgL_tmpz00_23474;

													BgL_tmpz00_23474 = BGL_CURRENT_DYNAMIC_ENV();
													BGL_ENV_SET_TRACE_LOCATION(BgL_tmpz00_23474,
														BgL_locz00_13856);
												}
												{	/* Eval/evaluate_comp.scm 896 */
													obj_t BgL_rz00_16424;

													BgL_rz00_16424 =
														PROCEDURE_ENTRY(BgL_fz00_16369) (BgL_fz00_16369,
														BgL_a1z00_16370, BgL_a2z00_16371, BgL_a3z00_16372,
														BgL_a4z00_16373, BEOA);
													VECTOR_SET(((obj_t) BgL_sz00_13859), ((long) 0),
														BgL_bpz00_16368);
													return BgL_rz00_16424;
												}
											}
										else
											{	/* Eval/evaluate_comp.scm 896 */
												return
													BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_13856,
													BgL_symbzd2funzd2_13857, (int) (((long) 4)),
													PROCEDURE_ARITY(BgL_fz00_16369));
		}}}}}}}}

	}



/* &<@anonymous:2548> */
	obj_t BGl_z62zc3z04anonymousza32548ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_13860, obj_t BgL_sz00_13869)
	{
		{	/* Eval/evaluate_comp.scm 896 */
			{	/* Eval/evaluate_comp.scm 896 */
				obj_t BgL_funz00_13861;
				obj_t BgL_a1z00_13862;
				obj_t BgL_a2z00_13863;
				obj_t BgL_a3z00_13864;
				obj_t BgL_a4z00_13865;
				obj_t BgL_locz00_13866;
				obj_t BgL_symbzd2funzd2_13867;
				long BgL_siza7eza7_13868;

				BgL_funz00_13861 = PROCEDURE_REF(BgL_envz00_13860, (int) (((long) 0)));
				BgL_a1z00_13862 = PROCEDURE_REF(BgL_envz00_13860, (int) (((long) 1)));
				BgL_a2z00_13863 = PROCEDURE_REF(BgL_envz00_13860, (int) (((long) 2)));
				BgL_a3z00_13864 = PROCEDURE_REF(BgL_envz00_13860, (int) (((long) 3)));
				BgL_a4z00_13865 = PROCEDURE_REF(BgL_envz00_13860, (int) (((long) 4)));
				BgL_locz00_13866 = PROCEDURE_REF(BgL_envz00_13860, (int) (((long) 5)));
				BgL_symbzd2funzd2_13867 =
					PROCEDURE_REF(BgL_envz00_13860, (int) (((long) 6)));
				BgL_siza7eza7_13868 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13860, (int) (((long) 7))));
				{	/* Eval/evaluate_comp.scm 896 */
					obj_t BgL_bpz00_16425;

					BgL_bpz00_16425 = VECTOR_REF(((obj_t) BgL_sz00_13869), ((long) 0));
					{	/* Eval/evaluate_comp.scm 896 */
						obj_t BgL_fz00_16426;
						obj_t BgL_a1z00_16427;
						obj_t BgL_a2z00_16428;
						obj_t BgL_a3z00_16429;
						obj_t BgL_a4z00_16430;

						BgL_fz00_16426 =
							PROCEDURE_ENTRY(BgL_funz00_13861) (BgL_funz00_13861,
							BgL_sz00_13869, BEOA);
						BgL_a1z00_16427 =
							PROCEDURE_ENTRY(BgL_a1z00_13862) (BgL_a1z00_13862, BgL_sz00_13869,
							BEOA);
						BgL_a2z00_16428 =
							PROCEDURE_ENTRY(BgL_a2z00_13863) (BgL_a2z00_13863, BgL_sz00_13869,
							BEOA);
						BgL_a3z00_16429 =
							PROCEDURE_ENTRY(BgL_a3z00_13864) (BgL_a3z00_13864, BgL_sz00_13869,
							BEOA);
						BgL_a4z00_16430 =
							PROCEDURE_ENTRY(BgL_a4z00_13865) (BgL_a4z00_13865, BgL_sz00_13869,
							BEOA);
						if (PROCEDUREP(BgL_fz00_16426))
							{	/* Eval/evaluate_comp.scm 896 */
								BFALSE;
							}
						else
							{	/* Eval/evaluate_comp.scm 896 */
								BGl_evtypezd2errorzd2zz__everrorz00(BgL_locz00_13866,
									BGl_string5807z00zz__evaluate_compz00,
									BGl_string5823z00zz__evaluate_compz00, BgL_fz00_16426);
							}
						{	/* Eval/evaluate_comp.scm 896 */
							obj_t BgL_ufz00_16431;

							{	/* Eval/evaluate_comp.scm 896 */
								obj_t BgL_tmpz00_23531;

								BgL_tmpz00_23531 = ((obj_t) BgL_fz00_16426);
								BgL_ufz00_16431 = PROCEDURE_ATTR(BgL_tmpz00_23531);
							}
							{	/* Eval/evaluate_comp.scm 896 */
								bool_t BgL_test6401z00_23534;

								if (STRUCTP(BgL_ufz00_16431))
									{	/* Eval/evaluate_comp.scm 683 */
										BgL_test6401z00_23534 =
											(STRUCT_KEY(BgL_ufz00_16431) ==
											BGl_symbol5824z00zz__evaluate_compz00);
									}
								else
									{	/* Eval/evaluate_comp.scm 683 */
										BgL_test6401z00_23534 = ((bool_t) 0);
									}
								if (BgL_test6401z00_23534)
									{	/* Eval/evaluate_comp.scm 896 */
										obj_t BgL_arityz00_16432;
										obj_t BgL_runz00_16433;
										obj_t BgL_sfz00_16434;

										BgL_arityz00_16432 =
											STRUCT_REF(BgL_ufz00_16431, (int) (((long) 0)));
										BgL_runz00_16433 =
											STRUCT_REF(BgL_ufz00_16431, (int) (((long) 1)));
										BgL_sfz00_16434 =
											STRUCT_REF(BgL_ufz00_16431, (int) (((long) 2)));
										{	/* Eval/evaluate_comp.scm 896 */
											long BgL_spz00_16435;

											BgL_spz00_16435 =
												((long) CINT(BgL_bpz00_16425) + BgL_siza7eza7_13868);
											if (((long) CINT(BgL_arityz00_16432) == ((long) 4)))
												{	/* Eval/evaluate_comp.scm 896 */
													{	/* Eval/evaluate_comp.scm 896 */
														long BgL_arg2552z00_16436;

														BgL_arg2552z00_16436 =
															(BgL_spz00_16435 + ((long) 0));
														VECTOR_SET(
															((obj_t) BgL_sz00_13869), BgL_arg2552z00_16436,
															BgL_a1z00_16427);
													}
													{	/* Eval/evaluate_comp.scm 896 */
														long BgL_arg2555z00_16437;

														BgL_arg2555z00_16437 =
															(BgL_spz00_16435 + ((long) 1));
														VECTOR_SET(
															((obj_t) BgL_sz00_13869), BgL_arg2555z00_16437,
															BgL_a2z00_16428);
													}
													{	/* Eval/evaluate_comp.scm 896 */
														long BgL_arg2556z00_16438;

														BgL_arg2556z00_16438 =
															(BgL_spz00_16435 + ((long) 2));
														VECTOR_SET(
															((obj_t) BgL_sz00_13869), BgL_arg2556z00_16438,
															BgL_a3z00_16429);
													}
													{	/* Eval/evaluate_comp.scm 896 */
														long BgL_arg2557z00_16439;

														BgL_arg2557z00_16439 =
															(BgL_spz00_16435 + ((long) 3));
														VECTOR_SET(
															((obj_t) BgL_sz00_13869), BgL_arg2557z00_16439,
															BgL_a4z00_16430);
												}}
											else
												{	/* Eval/evaluate_comp.scm 896 */
													if (INTEGERP(BgL_arityz00_16432))
														{	/* Eval/evaluate_comp.scm 896 */
															switch ((long) CINT(BgL_arityz00_16432))
																{
																case ((long) -1):

																	{	/* Eval/evaluate_comp.scm 896 */
																		long BgL_arg2559z00_16440;
																		obj_t BgL_arg2560z00_16441;

																		BgL_arg2559z00_16440 =
																			(BgL_spz00_16435 + ((long) 0));
																		{	/* Eval/evaluate_comp.scm 896 */
																			obj_t BgL_list2561z00_16442;

																			{	/* Eval/evaluate_comp.scm 896 */
																				obj_t BgL_arg2564z00_16443;

																				{	/* Eval/evaluate_comp.scm 896 */
																					obj_t BgL_arg2565z00_16444;

																					{	/* Eval/evaluate_comp.scm 896 */
																						obj_t BgL_arg2566z00_16445;

																						BgL_arg2566z00_16445 =
																							MAKE_YOUNG_PAIR(BgL_a4z00_16430,
																							BNIL);
																						BgL_arg2565z00_16444 =
																							MAKE_YOUNG_PAIR(BgL_a3z00_16429,
																							BgL_arg2566z00_16445);
																					}
																					BgL_arg2564z00_16443 =
																						MAKE_YOUNG_PAIR(BgL_a2z00_16428,
																						BgL_arg2565z00_16444);
																				}
																				BgL_list2561z00_16442 =
																					MAKE_YOUNG_PAIR(BgL_a1z00_16427,
																					BgL_arg2564z00_16443);
																			}
																			BgL_arg2560z00_16441 =
																				BgL_list2561z00_16442;
																		}
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13869),
																			BgL_arg2559z00_16440,
																			BgL_arg2560z00_16441);
																	} break;
																case ((long) -2):

																	{	/* Eval/evaluate_comp.scm 896 */
																		long BgL_arg2572z00_16446;

																		BgL_arg2572z00_16446 =
																			(BgL_spz00_16435 + ((long) 0));
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13869),
																			BgL_arg2572z00_16446, BgL_a1z00_16427);
																	}
																	{	/* Eval/evaluate_comp.scm 896 */
																		long BgL_arg2573z00_16447;
																		obj_t BgL_arg2574z00_16448;

																		BgL_arg2573z00_16447 =
																			(BgL_spz00_16435 + ((long) 1));
																		{	/* Eval/evaluate_comp.scm 896 */
																			obj_t BgL_list2575z00_16449;

																			{	/* Eval/evaluate_comp.scm 896 */
																				obj_t BgL_arg2577z00_16450;

																				{	/* Eval/evaluate_comp.scm 896 */
																					obj_t BgL_arg2578z00_16451;

																					BgL_arg2578z00_16451 =
																						MAKE_YOUNG_PAIR(BgL_a4z00_16430,
																						BNIL);
																					BgL_arg2577z00_16450 =
																						MAKE_YOUNG_PAIR(BgL_a3z00_16429,
																						BgL_arg2578z00_16451);
																				}
																				BgL_list2575z00_16449 =
																					MAKE_YOUNG_PAIR(BgL_a2z00_16428,
																					BgL_arg2577z00_16450);
																			}
																			BgL_arg2574z00_16448 =
																				BgL_list2575z00_16449;
																		}
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13869),
																			BgL_arg2573z00_16447,
																			BgL_arg2574z00_16448);
																	} break;
																case ((long) -3):

																	{	/* Eval/evaluate_comp.scm 896 */
																		long BgL_arg2579z00_16452;

																		BgL_arg2579z00_16452 =
																			(BgL_spz00_16435 + ((long) 0));
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13869),
																			BgL_arg2579z00_16452, BgL_a1z00_16427);
																	}
																	{	/* Eval/evaluate_comp.scm 896 */
																		long BgL_arg2580z00_16453;

																		BgL_arg2580z00_16453 =
																			(BgL_spz00_16435 + ((long) 1));
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13869),
																			BgL_arg2580z00_16453, BgL_a2z00_16428);
																	}
																	{	/* Eval/evaluate_comp.scm 896 */
																		long BgL_arg2581z00_16454;
																		obj_t BgL_arg2583z00_16455;

																		BgL_arg2581z00_16454 =
																			(BgL_spz00_16435 + ((long) 2));
																		{	/* Eval/evaluate_comp.scm 896 */
																			obj_t BgL_list2584z00_16456;

																			{	/* Eval/evaluate_comp.scm 896 */
																				obj_t BgL_arg2585z00_16457;

																				BgL_arg2585z00_16457 =
																					MAKE_YOUNG_PAIR(BgL_a4z00_16430,
																					BNIL);
																				BgL_list2584z00_16456 =
																					MAKE_YOUNG_PAIR(BgL_a3z00_16429,
																					BgL_arg2585z00_16457);
																			}
																			BgL_arg2583z00_16455 =
																				BgL_list2584z00_16456;
																		}
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13869),
																			BgL_arg2581z00_16454,
																			BgL_arg2583z00_16455);
																	} break;
																case ((long) -4):

																	{	/* Eval/evaluate_comp.scm 896 */
																		long BgL_arg2586z00_16458;

																		BgL_arg2586z00_16458 =
																			(BgL_spz00_16435 + ((long) 0));
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13869),
																			BgL_arg2586z00_16458, BgL_a1z00_16427);
																	}
																	{	/* Eval/evaluate_comp.scm 896 */
																		long BgL_arg2587z00_16459;

																		BgL_arg2587z00_16459 =
																			(BgL_spz00_16435 + ((long) 1));
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13869),
																			BgL_arg2587z00_16459, BgL_a2z00_16428);
																	}
																	{	/* Eval/evaluate_comp.scm 896 */
																		long BgL_arg2589z00_16460;

																		BgL_arg2589z00_16460 =
																			(BgL_spz00_16435 + ((long) 2));
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13869),
																			BgL_arg2589z00_16460, BgL_a3z00_16429);
																	}
																	{	/* Eval/evaluate_comp.scm 896 */
																		long BgL_arg2590z00_16461;
																		obj_t BgL_arg2591z00_16462;

																		BgL_arg2590z00_16461 =
																			(BgL_spz00_16435 + ((long) 3));
																		{	/* Eval/evaluate_comp.scm 896 */
																			obj_t BgL_list2592z00_16463;

																			BgL_list2592z00_16463 =
																				MAKE_YOUNG_PAIR(BgL_a4z00_16430, BNIL);
																			BgL_arg2591z00_16462 =
																				BgL_list2592z00_16463;
																		}
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13869),
																			BgL_arg2590z00_16461,
																			BgL_arg2591z00_16462);
																	} break;
																case ((long) -5):

																	{	/* Eval/evaluate_comp.scm 896 */
																		long BgL_arg2593z00_16464;

																		BgL_arg2593z00_16464 =
																			(BgL_spz00_16435 + ((long) 0));
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13869),
																			BgL_arg2593z00_16464, BgL_a1z00_16427);
																	}
																	{	/* Eval/evaluate_comp.scm 896 */
																		long BgL_arg2594z00_16465;

																		BgL_arg2594z00_16465 =
																			(BgL_spz00_16435 + ((long) 1));
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13869),
																			BgL_arg2594z00_16465, BgL_a2z00_16428);
																	}
																	{	/* Eval/evaluate_comp.scm 896 */
																		long BgL_arg2596z00_16466;

																		BgL_arg2596z00_16466 =
																			(BgL_spz00_16435 + ((long) 2));
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13869),
																			BgL_arg2596z00_16466, BgL_a3z00_16429);
																	}
																	{	/* Eval/evaluate_comp.scm 896 */
																		long BgL_arg2597z00_16467;

																		BgL_arg2597z00_16467 =
																			(BgL_spz00_16435 + ((long) 3));
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13869),
																			BgL_arg2597z00_16467, BgL_a4z00_16430);
																	}
																	{	/* Eval/evaluate_comp.scm 896 */
																		long BgL_arg2598z00_16468;
																		obj_t BgL_arg2599z00_16469;

																		BgL_arg2598z00_16468 =
																			(BgL_spz00_16435 + ((long) 4));
																		BgL_arg2599z00_16469 = BNIL;
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13869),
																			BgL_arg2598z00_16468,
																			BgL_arg2599z00_16469);
																	} break;
																default:
																	BGl_evarityzd2errorzd2zz__everrorz00
																		(BgL_locz00_13866,
																		STRUCT_REF(BgL_ufz00_16431,
																			(int) (((long) 3))), (int) (((long) 4)),
																		CINT(BgL_arityz00_16432));
														}}
													else
														{	/* Eval/evaluate_comp.scm 896 */
															BGl_evarityzd2errorzd2zz__everrorz00
																(BgL_locz00_13866, STRUCT_REF(BgL_ufz00_16431,
																	(int) (((long) 3))), (int) (((long) 4)),
																CINT(BgL_arityz00_16432));
												}}
											{	/* Eval/evaluate_comp.scm 896 */
												obj_t BgL_z12denvz12_16470;

												BgL_z12denvz12_16470 = BGL_CURRENT_DYNAMIC_ENV();
												if (
													((BgL_spz00_16435 +
															(long) CINT(BgL_sfz00_16434)) <
														VECTOR_LENGTH(((obj_t) BgL_sz00_13869))))
													{	/* Eval/evaluate_comp.scm 896 */
														return
															BGl_catchzd2trampolinezd2zz__evaluate_compz00
															(BgL_runz00_16433, BgL_sz00_13869,
															BINT(BgL_spz00_16435));
													}
												else
													{	/* Eval/evaluate_comp.scm 896 */
														obj_t BgL_nsz00_16471;

														BgL_nsz00_16471 =
															BGl_makezd2statezd2zz__evaluate_compz00();
														{	/* Eval/evaluate_comp.scm 896 */
															long BgL_arg2603z00_16472;

															BgL_arg2603z00_16472 =
																(BgL_spz00_16435 + ((long) 4));
															BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00
																(BgL_nsz00_16471, ((long) 2), BgL_sz00_13869,
																BINT(BgL_spz00_16435),
																BINT(BgL_arg2603z00_16472));
														}
														VECTOR_SET(BgL_nsz00_16471, ((long) 1),
															BgL_sz00_13869);
														BGL_ENV_EVSTATE_SET(BgL_z12denvz12_16470,
															BgL_nsz00_16471);
														{	/* Eval/evaluate_comp.scm 896 */
															obj_t BgL_ez00_16473;

															BgL_ez00_16473 = BGL_EXITD_TOP_AS_OBJ();
															BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
																(BgL_ez00_16473, BgL_sz00_13869);
															{	/* Eval/evaluate_comp.scm 896 */
																obj_t BgL_____rz00_16474;

																{	/* Eval/evaluate_comp.scm 670 */
																	obj_t BgL_savedzd2bpzd2_16475;

																	BgL_savedzd2bpzd2_16475 =
																		VECTOR_REF(BgL_nsz00_16471, ((long) 0));
																	VECTOR_SET(BgL_nsz00_16471, ((long) 0),
																		BINT(((long) 2)));
																	{
																		obj_t BgL_fz00_16477;

																		BgL_fz00_16477 = BgL_runz00_16433;
																	BgL_recz00_16476:
																		{	/* Eval/evaluate_comp.scm 673 */
																			obj_t BgL_rz00_16478;

																			BgL_rz00_16478 =
																				PROCEDURE_ENTRY(BgL_fz00_16477)
																				(BgL_fz00_16477, BgL_nsz00_16471, BEOA);
																			{	/* Eval/evaluate_comp.scm 674 */
																				bool_t BgL_test6406z00_23656;

																				if (PROCEDUREP(BgL_rz00_16478))
																					{	/* Eval/evaluate_comp.scm 674 */
																						obj_t BgL_arg1702z00_16479;

																						BgL_arg1702z00_16479 =
																							PROCEDURE_ATTR(BgL_rz00_16478);
																						if (STRUCTP(BgL_arg1702z00_16479))
																							{	/* Eval/evaluate_comp.scm 654 */
																								BgL_test6406z00_23656 =
																									(STRUCT_KEY
																									(BgL_arg1702z00_16479) ==
																									BGl_symbol5803z00zz__evaluate_compz00);
																							}
																						else
																							{	/* Eval/evaluate_comp.scm 654 */
																								BgL_test6406z00_23656 =
																									((bool_t) 0);
																							}
																					}
																				else
																					{	/* Eval/evaluate_comp.scm 674 */
																						BgL_test6406z00_23656 =
																							((bool_t) 0);
																					}
																				if (BgL_test6406z00_23656)
																					{
																						obj_t BgL_fz00_23664;

																						BgL_fz00_23664 = BgL_rz00_16478;
																						BgL_fz00_16477 = BgL_fz00_23664;
																						goto BgL_recz00_16476;
																					}
																				else
																					{	/* Eval/evaluate_comp.scm 674 */
																						VECTOR_SET(BgL_nsz00_16471,
																							((long) 0),
																							BgL_savedzd2bpzd2_16475);
																						BgL_____rz00_16474 = BgL_rz00_16478;
																}}}}}
																BGl_exitdzd2popzd2protectz12z12zz__bexitz00
																	(BgL_ez00_16473);
																BGL_ENV_EVSTATE_SET(BgL_z12denvz12_16470,
																	BgL_sz00_13869);
																return BgL_____rz00_16474;
															}
														}
													}
											}
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 896 */
										if (PROCEDURE_CORRECT_ARITYP(BgL_fz00_16426,
												(int) (((long) 4))))
											{	/* Eval/evaluate_comp.scm 896 */
												long BgL_nbpz00_16480;

												BgL_nbpz00_16480 =
													((long) CINT(BgL_bpz00_16425) + BgL_siza7eza7_13868);
												VECTOR_SET(
													((obj_t) BgL_sz00_13869), ((long) 0),
													BINT(BgL_nbpz00_16480));
												{	/* Eval/evaluate_comp.scm 896 */
													obj_t BgL_rz00_16481;

													BgL_rz00_16481 =
														PROCEDURE_ENTRY(BgL_fz00_16426) (BgL_fz00_16426,
														BgL_a1z00_16427, BgL_a2z00_16428, BgL_a3z00_16429,
														BgL_a4z00_16430, BEOA);
													VECTOR_SET(((obj_t) BgL_sz00_13869), ((long) 0),
														BgL_bpz00_16425);
													return BgL_rz00_16481;
												}
											}
										else
											{	/* Eval/evaluate_comp.scm 896 */
												return
													BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_13866,
													BgL_symbzd2funzd2_13867, (int) (((long) 4)),
													PROCEDURE_ARITY(BgL_fz00_16426));
		}}}}}}}}

	}



/* is-constant-fun? */
	obj_t BGl_iszd2constantzd2funzf3zf3zz__evaluate_compz00(BgL_ev_exprz00_bglt
		BgL_funz00_183, long BgL_nbargsz00_184, obj_t BgL_locz00_185,
		obj_t BgL_symbzd2funzd2_186)
	{
		{	/* Eval/evaluate_comp.scm 899 */
			if (BGl_isazf3zf3zz__objectz00(
					((obj_t) BgL_funz00_183), BGl_ev_globalz00zz__evaluate_typesz00))
				{	/* Eval/evaluate_comp.scm 903 */
					obj_t BgL_gz00_3026;

					{	/* Eval/evaluate_comp.scm 903 */
						obj_t BgL_arg2614z00_3034;
						obj_t BgL_arg2615z00_3035;

						BgL_arg2614z00_3034 =
							(((BgL_ev_globalz00_bglt) COBJECT(
									((BgL_ev_globalz00_bglt) BgL_funz00_183)))->BgL_modz00);
						BgL_arg2615z00_3035 =
							(((BgL_ev_globalz00_bglt) COBJECT(
									((BgL_ev_globalz00_bglt) BgL_funz00_183)))->BgL_namez00);
						BgL_gz00_3026 =
							BGl_evmodulezd2findzd2globalz00zz__evmodulez00
							(BgL_arg2614z00_3034, BgL_arg2615z00_3035);
					}
					if (CBOOL(BgL_gz00_3026))
						{	/* Eval/evaluate_comp.scm 905 */
							bool_t BgL_test6412z00_23698;

							{	/* Eval/evaluate_comp.scm 905 */
								int BgL_arg2613z00_3033;

								{	/* Eval/evaluate_comp.scm 905 */
									int BgL_res4967z00_9329;

									BgL_res4967z00_9329 =
										CINT(VECTOR_REF(((obj_t) BgL_gz00_3026), ((long) 0)));
									BgL_arg2613z00_3033 = BgL_res4967z00_9329;
								}
								BgL_test6412z00_23698 =
									((long) (BgL_arg2613z00_3033) == ((long) 0));
							}
							if (BgL_test6412z00_23698)
								{	/* Eval/evaluate_comp.scm 906 */
									obj_t BgL_valz00_3029;

									BgL_valz00_3029 =
										VECTOR_REF(((obj_t) BgL_gz00_3026), ((long) 2));
									{	/* Eval/evaluate_comp.scm 907 */
										bool_t BgL_test6413z00_23706;

										if (PROCEDUREP(BgL_valz00_3029))
											{	/* Eval/evaluate_comp.scm 907 */
												BgL_test6413z00_23706 =
													PROCEDURE_CORRECT_ARITYP(BgL_valz00_3029,
													(int) (BgL_nbargsz00_184));
											}
										else
											{	/* Eval/evaluate_comp.scm 907 */
												BgL_test6413z00_23706 = ((bool_t) 0);
											}
										if (BgL_test6413z00_23706)
											{	/* Eval/evaluate_comp.scm 907 */
												return BgL_valz00_3029;
											}
										else
											{	/* Eval/evaluate_comp.scm 907 */
												return BFALSE;
											}
									}
								}
							else
								{	/* Eval/evaluate_comp.scm 905 */
									return BFALSE;
								}
						}
					else
						{	/* Eval/evaluate_comp.scm 904 */
							return BFALSE;
						}
				}
			else
				{	/* Eval/evaluate_comp.scm 910 */
					bool_t BgL_test6415z00_23711;

					if (BGl_isazf3zf3zz__objectz00(
							((obj_t) BgL_funz00_183), BGl_ev_littz00zz__evaluate_typesz00))
						{	/* Eval/evaluate_comp.scm 911 */
							obj_t BgL_tmpz00_23715;

							BgL_tmpz00_23715 =
								(((BgL_ev_littz00_bglt) COBJECT(
										((BgL_ev_littz00_bglt) BgL_funz00_183)))->BgL_valuez00);
							BgL_test6415z00_23711 = PROCEDUREP(BgL_tmpz00_23715);
						}
					else
						{	/* Eval/evaluate_comp.scm 910 */
							BgL_test6415z00_23711 = ((bool_t) 0);
						}
					if (BgL_test6415z00_23711)
						{	/* Eval/evaluate_comp.scm 913 */
							bool_t BgL_test6417z00_23719;

							{	/* Eval/evaluate_comp.scm 913 */
								obj_t BgL_arg2624z00_3045;

								BgL_arg2624z00_3045 =
									(((BgL_ev_littz00_bglt) COBJECT(
											((BgL_ev_littz00_bglt) BgL_funz00_183)))->BgL_valuez00);
								BgL_test6417z00_23719 =
									PROCEDURE_CORRECT_ARITYP(BgL_arg2624z00_3045,
									(int) (BgL_nbargsz00_184));
							}
							if (BgL_test6417z00_23719)
								{	/* Eval/evaluate_comp.scm 913 */
									return
										(((BgL_ev_littz00_bglt) COBJECT(
												((BgL_ev_littz00_bglt) BgL_funz00_183)))->BgL_valuez00);
								}
							else
								{	/* Eval/evaluate_comp.scm 915 */
									int BgL_arg2621z00_3043;

									{	/* Eval/evaluate_comp.scm 915 */
										obj_t BgL_arg2622z00_3044;

										BgL_arg2622z00_3044 =
											(((BgL_ev_littz00_bglt) COBJECT(
													((BgL_ev_littz00_bglt) BgL_funz00_183)))->
											BgL_valuez00);
										BgL_arg2621z00_3043 = PROCEDURE_ARITY(BgL_arg2622z00_3044);
									}
									return
										BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_185,
										BgL_symbzd2funzd2_186, (int) (BgL_nbargsz00_184),
										BgL_arg2621z00_3043);
						}}
					else
						{	/* Eval/evaluate_comp.scm 910 */
							return BFALSE;
						}
				}
		}

	}



/* compile-float-arith */
	obj_t BGl_compilezd2floatzd2arithz00zz__evaluate_compz00(obj_t
		BgL_exprz00_187, obj_t BgL_stkz00_188)
	{
		{	/* Eval/evaluate_comp.scm 918 */
			if (BGl_isazf3zf3zz__objectz00(BgL_exprz00_187,
					BGl_ev_littz00zz__evaluate_typesz00))
				{	/* Eval/evaluate_comp.scm 922 */
					if (INTEGERP(
							(((BgL_ev_littz00_bglt) COBJECT(
										((BgL_ev_littz00_bglt) BgL_exprz00_187)))->BgL_valuez00)))
						{	/* Eval/evaluate_comp.scm 924 */
							obj_t BgL_v1350z00_3054;

							BgL_v1350z00_3054 = create_vector(((long) 2));
							VECTOR_SET(BgL_v1350z00_3054, ((long) 0), BINT(((long) 1)));
							{	/* Eval/evaluate_comp.scm 924 */
								double BgL_arg2630z00_3055;

								BgL_arg2630z00_3055 =
									(double) (
									(long) CINT(
										(((BgL_ev_littz00_bglt) COBJECT(
													((BgL_ev_littz00_bglt) BgL_exprz00_187)))->
											BgL_valuez00)));
								VECTOR_SET(BgL_v1350z00_3054, ((long) 1),
									DOUBLE_TO_REAL(BgL_arg2630z00_3055));
							}
							return BgL_v1350z00_3054;
						}
					else
						{	/* Eval/evaluate_comp.scm 925 */
							bool_t BgL_test6420z00_23746;

							{	/* Eval/evaluate_comp.scm 925 */
								obj_t BgL_tmpz00_23747;

								BgL_tmpz00_23747 =
									(((BgL_ev_littz00_bglt) COBJECT(
											((BgL_ev_littz00_bglt) BgL_exprz00_187)))->BgL_valuez00);
								BgL_test6420z00_23746 = REALP(BgL_tmpz00_23747);
							}
							if (BgL_test6420z00_23746)
								{	/* Eval/evaluate_comp.scm 925 */
									obj_t BgL_v1351z00_3059;

									BgL_v1351z00_3059 = create_vector(((long) 2));
									VECTOR_SET(BgL_v1351z00_3059, ((long) 0), BINT(((long) 1)));
									{	/* Eval/evaluate_comp.scm 925 */
										obj_t BgL_arg2636z00_3060;

										BgL_arg2636z00_3060 =
											(((BgL_ev_littz00_bglt) COBJECT(
													((BgL_ev_littz00_bglt) BgL_exprz00_187)))->
											BgL_valuez00);
										VECTOR_SET(BgL_v1351z00_3059, ((long) 1),
											BgL_arg2636z00_3060);
									}
									return BgL_v1351z00_3059;
								}
							else
								{	/* Eval/evaluate_comp.scm 926 */
									obj_t BgL_v1352z00_3061;

									BgL_v1352z00_3061 = create_vector(((long) 2));
									VECTOR_SET(BgL_v1352z00_3061, ((long) 0), BINT(((long) 0)));
									{	/* Eval/evaluate_comp.scm 926 */
										obj_t BgL_arg2637z00_3062;

										BgL_arg2637z00_3062 =
											BGl_compz00zz__evaluate_compz00(
											((BgL_ev_exprz00_bglt)
												((BgL_ev_littz00_bglt) BgL_exprz00_187)),
											BgL_stkz00_188);
										VECTOR_SET(BgL_v1352z00_3061, ((long) 1),
											BgL_arg2637z00_3062);
									}
									return BgL_v1352z00_3061;
								}
						}
				}
			else
				{	/* Eval/evaluate_comp.scm 922 */
					if (BGl_isazf3zf3zz__objectz00(BgL_exprz00_187,
							BGl_ev_varz00zz__evaluate_typesz00))
						{	/* Eval/evaluate_comp.scm 927 */
							if (CBOOL(
									(((BgL_ev_varz00_bglt) COBJECT(
												((BgL_ev_varz00_bglt) BgL_exprz00_187)))->BgL_effz00)))
								{	/* Eval/evaluate_comp.scm 930 */
									obj_t BgL_v1353z00_3068;

									BgL_v1353z00_3068 = create_vector(((long) 2));
									VECTOR_SET(BgL_v1353z00_3068, ((long) 0), BINT(((long) 3)));
									VECTOR_SET(BgL_v1353z00_3068, ((long) 1),
										BGl__indexz00zz__evaluate_compz00(BgL_exprz00_187,
											BgL_stkz00_188));
									return BgL_v1353z00_3068;
								}
							else
								{	/* Eval/evaluate_comp.scm 931 */
									obj_t BgL_v1354z00_3070;

									BgL_v1354z00_3070 = create_vector(((long) 2));
									VECTOR_SET(BgL_v1354z00_3070, ((long) 0), BINT(((long) 2)));
									VECTOR_SET(BgL_v1354z00_3070, ((long) 1),
										BGl__indexz00zz__evaluate_compz00(BgL_exprz00_187,
											BgL_stkz00_188));
									return BgL_v1354z00_3070;
								}
						}
					else
						{	/* Eval/evaluate_comp.scm 927 */
							if (BGl_isazf3zf3zz__objectz00(BgL_exprz00_187,
									BGl_ev_globalz00zz__evaluate_typesz00))
								{	/* Eval/evaluate_comp.scm 934 */
									obj_t BgL_gz00_3074;

									{	/* Eval/evaluate_comp.scm 934 */
										obj_t BgL_arg2654z00_3082;
										obj_t BgL_arg2655z00_3083;

										BgL_arg2654z00_3082 =
											(((BgL_ev_globalz00_bglt) COBJECT(
													((BgL_ev_globalz00_bglt) BgL_exprz00_187)))->
											BgL_modz00);
										BgL_arg2655z00_3083 =
											(((BgL_ev_globalz00_bglt) COBJECT(((BgL_ev_globalz00_bglt)
														BgL_exprz00_187)))->BgL_namez00);
										BgL_gz00_3074 =
											BGl_evmodulezd2findzd2globalz00zz__evmodulez00
											(BgL_arg2654z00_3082, BgL_arg2655z00_3083);
									}
									if (CBOOL(BgL_gz00_3074))
										{	/* Eval/evaluate_comp.scm 936 */
											bool_t BgL_test6425z00_23789;

											{	/* Eval/evaluate_comp.scm 936 */
												int BgL_arg2650z00_3079;

												{	/* Eval/evaluate_comp.scm 936 */
													int BgL_res4974z00_9352;

													BgL_res4974z00_9352 =
														CINT(VECTOR_REF(
															((obj_t) BgL_gz00_3074), ((long) 0)));
													BgL_arg2650z00_3079 = BgL_res4974z00_9352;
												}
												BgL_test6425z00_23789 =
													(BINT(BgL_arg2650z00_3079) == BINT(((long) 1)));
											}
											if (BgL_test6425z00_23789)
												{	/* Eval/evaluate_comp.scm 937 */
													obj_t BgL_v1355z00_3077;

													BgL_v1355z00_3077 = create_vector(((long) 2));
													VECTOR_SET(BgL_v1355z00_3077, ((long) 0),
														BINT(((long) 4)));
													VECTOR_SET(BgL_v1355z00_3077, ((long) 1),
														BgL_gz00_3074);
													return BgL_v1355z00_3077;
												}
											else
												{	/* Eval/evaluate_comp.scm 938 */
													obj_t BgL_v1356z00_3078;

													BgL_v1356z00_3078 = create_vector(((long) 2));
													VECTOR_SET(BgL_v1356z00_3078, ((long) 0),
														BINT(((long) 5)));
													VECTOR_SET(BgL_v1356z00_3078, ((long) 1),
														BgL_gz00_3074);
													return BgL_v1356z00_3078;
												}
										}
									else
										{	/* Eval/evaluate_comp.scm 939 */
											obj_t BgL_v1357z00_3080;

											BgL_v1357z00_3080 = create_vector(((long) 2));
											VECTOR_SET(BgL_v1357z00_3080, ((long) 0),
												BINT(((long) 0)));
											{	/* Eval/evaluate_comp.scm 939 */
												obj_t BgL_arg2651z00_3081;

												BgL_arg2651z00_3081 =
													BGl_compz00zz__evaluate_compz00(
													((BgL_ev_exprz00_bglt)
														((BgL_ev_globalz00_bglt) BgL_exprz00_187)),
													BgL_stkz00_188);
												VECTOR_SET(BgL_v1357z00_3080, ((long) 1),
													BgL_arg2651z00_3081);
											}
											return BgL_v1357z00_3080;
										}
								}
							else
								{	/* Eval/evaluate_comp.scm 932 */
									if (BGl_isazf3zf3zz__objectz00(BgL_exprz00_187,
											BGl_ev_appz00zz__evaluate_typesz00))
										{	/* Eval/evaluate_comp.scm 942 */
											obj_t BgL_fvalz00_3086;

											{	/* Eval/evaluate_comp.scm 942 */
												BgL_ev_exprz00_bglt BgL_arg2701z00_3134;

												BgL_arg2701z00_3134 =
													(((BgL_ev_appz00_bglt) COBJECT(
															((BgL_ev_appz00_bglt) BgL_exprz00_187)))->
													BgL_funz00);
												BgL_fvalz00_3086 =
													BGl_globalzd2funzd2valuez00zz__evaluate_compz00
													(BgL_arg2701z00_3134);
											}
											if (
												(BgL_fvalz00_3086 ==
													BGl_zb2flzd2envz60zz__r4_numbers_6_5_flonumz00))
												{	/* Eval/evaluate_comp.scm 945 */
													obj_t BgL_v1358z00_3088;

													BgL_v1358z00_3088 = create_vector(((long) 3));
													VECTOR_SET(BgL_v1358z00_3088, ((long) 0),
														BINT(((long) 6)));
													{	/* Eval/evaluate_comp.scm 945 */
														obj_t BgL_arg2659z00_3089;

														{	/* Eval/evaluate_comp.scm 945 */
															obj_t BgL_arg2660z00_3090;

															{	/* Eval/evaluate_comp.scm 945 */
																obj_t BgL_pairz00_9360;

																BgL_pairz00_9360 =
																	(((BgL_ev_appz00_bglt) COBJECT(
																			((BgL_ev_appz00_bglt) BgL_exprz00_187)))->
																	BgL_argsz00);
																BgL_arg2660z00_3090 = CAR(BgL_pairz00_9360);
															}
															BgL_arg2659z00_3089 =
																BGl_compilezd2floatzd2arithz00zz__evaluate_compz00
																(BgL_arg2660z00_3090, BgL_stkz00_188);
														}
														VECTOR_SET(BgL_v1358z00_3088, ((long) 1),
															BgL_arg2659z00_3089);
													}
													{	/* Eval/evaluate_comp.scm 945 */
														obj_t BgL_arg2663z00_3092;

														{	/* Eval/evaluate_comp.scm 945 */
															obj_t BgL_arg2664z00_3093;

															{	/* Eval/evaluate_comp.scm 945 */
																obj_t BgL_pairz00_9362;

																BgL_pairz00_9362 =
																	(((BgL_ev_appz00_bglt) COBJECT(
																			((BgL_ev_appz00_bglt) BgL_exprz00_187)))->
																	BgL_argsz00);
																BgL_arg2664z00_3093 =
																	CAR(CDR(BgL_pairz00_9362));
															}
															BgL_arg2663z00_3092 =
																BGl_compilezd2floatzd2arithz00zz__evaluate_compz00
																(BgL_arg2664z00_3093, BgL_stkz00_188);
														}
														VECTOR_SET(BgL_v1358z00_3088, ((long) 2),
															BgL_arg2663z00_3092);
													}
													return BgL_v1358z00_3088;
												}
											else
												{	/* Eval/evaluate_comp.scm 944 */
													if (
														(BgL_fvalz00_3086 ==
															BGl_zd2flzd2envz00zz__r4_numbers_6_5_flonumz00))
														{	/* Eval/evaluate_comp.scm 947 */
															obj_t BgL_v1359z00_3096;

															BgL_v1359z00_3096 = create_vector(((long) 3));
															VECTOR_SET(BgL_v1359z00_3096, ((long) 0),
																BINT(((long) 7)));
															{	/* Eval/evaluate_comp.scm 947 */
																obj_t BgL_arg2667z00_3097;

																{	/* Eval/evaluate_comp.scm 947 */
																	obj_t BgL_arg2668z00_3098;

																	{	/* Eval/evaluate_comp.scm 947 */
																		obj_t BgL_pairz00_9368;

																		BgL_pairz00_9368 =
																			(((BgL_ev_appz00_bglt) COBJECT(
																					((BgL_ev_appz00_bglt)
																						BgL_exprz00_187)))->BgL_argsz00);
																		BgL_arg2668z00_3098 = CAR(BgL_pairz00_9368);
																	}
																	BgL_arg2667z00_3097 =
																		BGl_compilezd2floatzd2arithz00zz__evaluate_compz00
																		(BgL_arg2668z00_3098, BgL_stkz00_188);
																}
																VECTOR_SET(BgL_v1359z00_3096, ((long) 1),
																	BgL_arg2667z00_3097);
															}
															{	/* Eval/evaluate_comp.scm 947 */
																obj_t BgL_arg2670z00_3100;

																{	/* Eval/evaluate_comp.scm 947 */
																	obj_t BgL_arg2671z00_3101;

																	{	/* Eval/evaluate_comp.scm 947 */
																		obj_t BgL_pairz00_9370;

																		BgL_pairz00_9370 =
																			(((BgL_ev_appz00_bglt) COBJECT(
																					((BgL_ev_appz00_bglt)
																						BgL_exprz00_187)))->BgL_argsz00);
																		BgL_arg2671z00_3101 =
																			CAR(CDR(BgL_pairz00_9370));
																	}
																	BgL_arg2670z00_3100 =
																		BGl_compilezd2floatzd2arithz00zz__evaluate_compz00
																		(BgL_arg2671z00_3101, BgL_stkz00_188);
																}
																VECTOR_SET(BgL_v1359z00_3096, ((long) 2),
																	BgL_arg2670z00_3100);
															}
															return BgL_v1359z00_3096;
														}
													else
														{	/* Eval/evaluate_comp.scm 946 */
															if (
																(BgL_fvalz00_3086 ==
																	BGl_za2flzd2envz70zz__r4_numbers_6_5_flonumz00))
																{	/* Eval/evaluate_comp.scm 949 */
																	obj_t BgL_v1360z00_3104;

																	BgL_v1360z00_3104 = create_vector(((long) 3));
																	VECTOR_SET(BgL_v1360z00_3104, ((long) 0),
																		BINT(((long) 8)));
																	{	/* Eval/evaluate_comp.scm 949 */
																		obj_t BgL_arg2674z00_3105;

																		{	/* Eval/evaluate_comp.scm 949 */
																			obj_t BgL_arg2675z00_3106;

																			{	/* Eval/evaluate_comp.scm 949 */
																				obj_t BgL_pairz00_9376;

																				BgL_pairz00_9376 =
																					(((BgL_ev_appz00_bglt) COBJECT(
																							((BgL_ev_appz00_bglt)
																								BgL_exprz00_187)))->
																					BgL_argsz00);
																				BgL_arg2675z00_3106 =
																					CAR(BgL_pairz00_9376);
																			}
																			BgL_arg2674z00_3105 =
																				BGl_compilezd2floatzd2arithz00zz__evaluate_compz00
																				(BgL_arg2675z00_3106, BgL_stkz00_188);
																		}
																		VECTOR_SET(BgL_v1360z00_3104, ((long) 1),
																			BgL_arg2674z00_3105);
																	}
																	{	/* Eval/evaluate_comp.scm 949 */
																		obj_t BgL_arg2677z00_3108;

																		{	/* Eval/evaluate_comp.scm 949 */
																			obj_t BgL_arg2679z00_3109;

																			{	/* Eval/evaluate_comp.scm 949 */
																				obj_t BgL_pairz00_9378;

																				BgL_pairz00_9378 =
																					(((BgL_ev_appz00_bglt) COBJECT(
																							((BgL_ev_appz00_bglt)
																								BgL_exprz00_187)))->
																					BgL_argsz00);
																				BgL_arg2679z00_3109 =
																					CAR(CDR(BgL_pairz00_9378));
																			}
																			BgL_arg2677z00_3108 =
																				BGl_compilezd2floatzd2arithz00zz__evaluate_compz00
																				(BgL_arg2679z00_3109, BgL_stkz00_188);
																		}
																		VECTOR_SET(BgL_v1360z00_3104, ((long) 2),
																			BgL_arg2677z00_3108);
																	}
																	return BgL_v1360z00_3104;
																}
															else
																{	/* Eval/evaluate_comp.scm 948 */
																	if (
																		(BgL_fvalz00_3086 ==
																			BGl_zf2flzd2envz20zz__r4_numbers_6_5_flonumz00))
																		{	/* Eval/evaluate_comp.scm 951 */
																			obj_t BgL_v1361z00_3112;

																			BgL_v1361z00_3112 =
																				create_vector(((long) 3));
																			VECTOR_SET(BgL_v1361z00_3112, ((long) 0),
																				BINT(((long) 9)));
																			{	/* Eval/evaluate_comp.scm 951 */
																				obj_t BgL_arg2682z00_3113;

																				{	/* Eval/evaluate_comp.scm 951 */
																					obj_t BgL_arg2683z00_3114;

																					{	/* Eval/evaluate_comp.scm 951 */
																						obj_t BgL_pairz00_9384;

																						BgL_pairz00_9384 =
																							(((BgL_ev_appz00_bglt) COBJECT(
																									((BgL_ev_appz00_bglt)
																										BgL_exprz00_187)))->
																							BgL_argsz00);
																						BgL_arg2683z00_3114 =
																							CAR(BgL_pairz00_9384);
																					}
																					BgL_arg2682z00_3113 =
																						BGl_compilezd2floatzd2arithz00zz__evaluate_compz00
																						(BgL_arg2683z00_3114,
																						BgL_stkz00_188);
																				}
																				VECTOR_SET(BgL_v1361z00_3112,
																					((long) 1), BgL_arg2682z00_3113);
																			}
																			{	/* Eval/evaluate_comp.scm 951 */
																				obj_t BgL_arg2685z00_3116;

																				{	/* Eval/evaluate_comp.scm 951 */
																					obj_t BgL_arg2686z00_3117;

																					{	/* Eval/evaluate_comp.scm 951 */
																						obj_t BgL_pairz00_9386;

																						BgL_pairz00_9386 =
																							(((BgL_ev_appz00_bglt) COBJECT(
																									((BgL_ev_appz00_bglt)
																										BgL_exprz00_187)))->
																							BgL_argsz00);
																						BgL_arg2686z00_3117 =
																							CAR(CDR(BgL_pairz00_9386));
																					}
																					BgL_arg2685z00_3116 =
																						BGl_compilezd2floatzd2arithz00zz__evaluate_compz00
																						(BgL_arg2686z00_3117,
																						BgL_stkz00_188);
																				}
																				VECTOR_SET(BgL_v1361z00_3112,
																					((long) 2), BgL_arg2685z00_3116);
																			}
																			return BgL_v1361z00_3112;
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 950 */
																			if (
																				(BgL_fvalz00_3086 ==
																					BGl_fixnumzd2ze3flonumzd2envze3zz__r4_numbers_6_5z00))
																				{	/* Eval/evaluate_comp.scm 953 */
																					obj_t BgL_v1362z00_3120;

																					BgL_v1362z00_3120 =
																						create_vector(((long) 2));
																					VECTOR_SET(BgL_v1362z00_3120,
																						((long) 0), BINT(((long) 10)));
																					{	/* Eval/evaluate_comp.scm 953 */
																						obj_t BgL_arg2690z00_3121;

																						{	/* Eval/evaluate_comp.scm 953 */
																							obj_t BgL_arg2691z00_3122;

																							{	/* Eval/evaluate_comp.scm 953 */
																								obj_t BgL_pairz00_9392;

																								BgL_pairz00_9392 =
																									(((BgL_ev_appz00_bglt)
																										COBJECT((
																												(BgL_ev_appz00_bglt)
																												BgL_exprz00_187)))->
																									BgL_argsz00);
																								BgL_arg2691z00_3122 =
																									CAR(BgL_pairz00_9392);
																							}
																							BgL_arg2690z00_3121 =
																								BGl_compz00zz__evaluate_compz00(
																								((BgL_ev_exprz00_bglt)
																									BgL_arg2691z00_3122),
																								BgL_stkz00_188);
																						}
																						VECTOR_SET(BgL_v1362z00_3120,
																							((long) 1), BgL_arg2690z00_3121);
																					}
																					return BgL_v1362z00_3120;
																				}
																			else
																				{	/* Eval/evaluate_comp.scm 952 */
																					if (
																						(BgL_fvalz00_3086 ==
																							BGl_f64vectorzd2refzd2envz00zz__srfi4z00))
																						{	/* Eval/evaluate_comp.scm 955 */
																							obj_t BgL_v1363z00_3125;

																							BgL_v1363z00_3125 =
																								create_vector(((long) 3));
																							VECTOR_SET(BgL_v1363z00_3125,
																								((long) 0), BINT(((long) 11)));
																							{	/* Eval/evaluate_comp.scm 955 */
																								obj_t BgL_arg2694z00_3126;

																								{	/* Eval/evaluate_comp.scm 955 */
																									obj_t BgL_arg2695z00_3127;

																									{	/* Eval/evaluate_comp.scm 955 */
																										obj_t BgL_pairz00_9395;

																										BgL_pairz00_9395 =
																											(((BgL_ev_appz00_bglt)
																												COBJECT((
																														(BgL_ev_appz00_bglt)
																														BgL_exprz00_187)))->
																											BgL_argsz00);
																										BgL_arg2695z00_3127 =
																											CAR(BgL_pairz00_9395);
																									}
																									BgL_arg2694z00_3126 =
																										BGl_compz00zz__evaluate_compz00
																										(((BgL_ev_exprz00_bglt)
																											BgL_arg2695z00_3127),
																										BgL_stkz00_188);
																								}
																								VECTOR_SET(BgL_v1363z00_3125,
																									((long) 1),
																									BgL_arg2694z00_3126);
																							}
																							{	/* Eval/evaluate_comp.scm 955 */
																								obj_t BgL_arg2697z00_3129;

																								{	/* Eval/evaluate_comp.scm 955 */
																									obj_t BgL_arg2698z00_3130;

																									{	/* Eval/evaluate_comp.scm 955 */
																										obj_t BgL_pairz00_9397;

																										BgL_pairz00_9397 =
																											(((BgL_ev_appz00_bglt)
																												COBJECT((
																														(BgL_ev_appz00_bglt)
																														BgL_exprz00_187)))->
																											BgL_argsz00);
																										BgL_arg2698z00_3130 =
																											CAR(CDR
																											(BgL_pairz00_9397));
																									}
																									BgL_arg2697z00_3129 =
																										BGl_compz00zz__evaluate_compz00
																										(((BgL_ev_exprz00_bglt)
																											BgL_arg2698z00_3130),
																										BgL_stkz00_188);
																								}
																								VECTOR_SET(BgL_v1363z00_3125,
																									((long) 2),
																									BgL_arg2697z00_3129);
																							}
																							return BgL_v1363z00_3125;
																						}
																					else
																						{	/* Eval/evaluate_comp.scm 957 */
																							obj_t BgL_v1364z00_3132;

																							BgL_v1364z00_3132 =
																								create_vector(((long) 2));
																							VECTOR_SET(BgL_v1364z00_3132,
																								((long) 0), BINT(((long) 0)));
																							{	/* Eval/evaluate_comp.scm 957 */
																								obj_t BgL_arg2700z00_3133;

																								BgL_arg2700z00_3133 =
																									BGl_compz00zz__evaluate_compz00
																									(((BgL_ev_exprz00_bglt) (
																											(BgL_ev_appz00_bglt)
																											BgL_exprz00_187)),
																									BgL_stkz00_188);
																								VECTOR_SET(BgL_v1364z00_3132,
																									((long) 1),
																									BgL_arg2700z00_3133);
																							}
																							return BgL_v1364z00_3132;
																						}
																				}
																		}
																}
														}
												}
										}
									else
										{	/* Eval/evaluate_comp.scm 958 */
											obj_t BgL_v1365z00_3135;

											BgL_v1365z00_3135 = create_vector(((long) 2));
											VECTOR_SET(BgL_v1365z00_3135, ((long) 0),
												BINT(((long) 0)));
											{	/* Eval/evaluate_comp.scm 958 */
												obj_t BgL_arg2702z00_3136;

												BgL_arg2702z00_3136 =
													BGl_compz00zz__evaluate_compz00(
													((BgL_ev_exprz00_bglt) BgL_exprz00_187),
													BgL_stkz00_188);
												VECTOR_SET(BgL_v1365z00_3135, ((long) 1),
													BgL_arg2702z00_3136);
											}
											return BgL_v1365z00_3135;
										}
								}
						}
				}
		}

	}



/* eval-float-arith */
	double BGl_evalzd2floatzd2arithz00zz__evaluate_compz00(obj_t BgL_bcz00_189,
		obj_t BgL_sz00_190)
	{
		{	/* Eval/evaluate_comp.scm 960 */
			return
				REAL_TO_DOUBLE(BGl_Eze70ze7zz__evaluate_compz00(BgL_sz00_190,
					BgL_bcz00_189));
		}

	}



/* E~0 */
	obj_t BGl_Eze70ze7zz__evaluate_compz00(obj_t BgL_sz00_15532,
		obj_t BgL_bcz00_3141)
	{
		{	/* Eval/evaluate_comp.scm 975 */
			{	/* Eval/evaluate_comp.scm 962 */
				obj_t BgL_aux1221z00_3144;

				BgL_aux1221z00_3144 = VECTOR_REF(((obj_t) BgL_bcz00_3141), ((long) 0));
				if (INTEGERP(BgL_aux1221z00_3144))
					{	/* Eval/evaluate_comp.scm 962 */
						switch ((long) CINT(BgL_aux1221z00_3144))
							{
							case ((long) 0):

								{	/* Eval/evaluate_comp.scm 963 */
									obj_t BgL_fun2706z00_3146;

									BgL_fun2706z00_3146 =
										VECTOR_REF(((obj_t) BgL_bcz00_3141), ((long) 1));
									return
										PROCEDURE_ENTRY(BgL_fun2706z00_3146) (BgL_fun2706z00_3146,
										BgL_sz00_15532, BEOA);
								}
								break;
							case ((long) 1):

								return VECTOR_REF(((obj_t) BgL_bcz00_3141), ((long) 1));
								break;
							case ((long) 2):

								{	/* Eval/evaluate_comp.scm 965 */
									long BgL_arg2707z00_3147;

									{	/* Eval/evaluate_comp.scm 965 */
										obj_t BgL_arg2708z00_3148;
										obj_t BgL_arg2709z00_3149;

										BgL_arg2708z00_3148 =
											VECTOR_REF(((obj_t) BgL_sz00_15532), ((long) 0));
										BgL_arg2709z00_3149 =
											VECTOR_REF(((obj_t) BgL_bcz00_3141), ((long) 1));
										BgL_arg2707z00_3147 =
											(
											(long) CINT(BgL_arg2708z00_3148) +
											(long) CINT(BgL_arg2709z00_3149));
									}
									return
										VECTOR_REF(((obj_t) BgL_sz00_15532), BgL_arg2707z00_3147);
								}
								break;
							case ((long) 3):

								{	/* Eval/evaluate_comp.scm 966 */
									obj_t BgL_arg2710z00_3150;

									{	/* Eval/evaluate_comp.scm 966 */
										long BgL_arg2711z00_3151;

										{	/* Eval/evaluate_comp.scm 966 */
											obj_t BgL_arg2712z00_3152;
											obj_t BgL_arg2714z00_3153;

											BgL_arg2712z00_3152 =
												VECTOR_REF(((obj_t) BgL_sz00_15532), ((long) 0));
											BgL_arg2714z00_3153 =
												VECTOR_REF(((obj_t) BgL_bcz00_3141), ((long) 1));
											BgL_arg2711z00_3151 =
												(
												(long) CINT(BgL_arg2712z00_3152) +
												(long) CINT(BgL_arg2714z00_3153));
										}
										BgL_arg2710z00_3150 =
											VECTOR_REF(((obj_t) BgL_sz00_15532), BgL_arg2711z00_3151);
									}
									return
										STRUCT_REF(
										((obj_t) BgL_arg2710z00_3150), (int) (((long) 0)));
								} break;
							case ((long) 4):

								{	/* Eval/evaluate_comp.scm 967 */
									obj_t BgL_arg2715z00_3154;

									{	/* Eval/evaluate_comp.scm 967 */
										obj_t BgL_arg2716z00_3155;

										BgL_arg2716z00_3155 =
											VECTOR_REF(((obj_t) BgL_bcz00_3141), ((long) 1));
										BgL_arg2715z00_3154 =
											VECTOR_REF(((obj_t) BgL_arg2716z00_3155), ((long) 2));
									}
									return __EVMEANING_ADDRESS_REF(BgL_arg2715z00_3154);
								}
								break;
							case ((long) 5):

								{	/* Eval/evaluate_comp.scm 968 */
									obj_t BgL_arg2717z00_3156;

									BgL_arg2717z00_3156 =
										VECTOR_REF(((obj_t) BgL_bcz00_3141), ((long) 1));
									return VECTOR_REF(((obj_t) BgL_arg2717z00_3156), ((long) 2));
								} break;
							case ((long) 6):

								{	/* Eval/evaluate_comp.scm 969 */
									obj_t BgL_arg2718z00_3157;
									obj_t BgL_arg2720z00_3158;

									{	/* Eval/evaluate_comp.scm 969 */
										obj_t BgL_arg2722z00_3159;

										BgL_arg2722z00_3159 =
											VECTOR_REF(((obj_t) BgL_bcz00_3141), ((long) 1));
										BgL_arg2718z00_3157 =
											BGl_Eze70ze7zz__evaluate_compz00(BgL_sz00_15532,
											BgL_arg2722z00_3159);
									}
									{	/* Eval/evaluate_comp.scm 969 */
										obj_t BgL_arg2723z00_3160;

										BgL_arg2723z00_3160 =
											VECTOR_REF(((obj_t) BgL_bcz00_3141), ((long) 2));
										BgL_arg2720z00_3158 =
											BGl_Eze70ze7zz__evaluate_compz00(BgL_sz00_15532,
											BgL_arg2723z00_3160);
									}
									return
										DOUBLE_TO_REAL(
										(REAL_TO_DOUBLE(BgL_arg2718z00_3157) +
											REAL_TO_DOUBLE(BgL_arg2720z00_3158)));
								}
								break;
							case ((long) 7):

								{	/* Eval/evaluate_comp.scm 970 */
									obj_t BgL_arg2724z00_3161;
									obj_t BgL_arg2726z00_3162;

									{	/* Eval/evaluate_comp.scm 970 */
										obj_t BgL_arg2727z00_3163;

										BgL_arg2727z00_3163 =
											VECTOR_REF(((obj_t) BgL_bcz00_3141), ((long) 1));
										BgL_arg2724z00_3161 =
											BGl_Eze70ze7zz__evaluate_compz00(BgL_sz00_15532,
											BgL_arg2727z00_3163);
									}
									{	/* Eval/evaluate_comp.scm 970 */
										obj_t BgL_arg2729z00_3164;

										BgL_arg2729z00_3164 =
											VECTOR_REF(((obj_t) BgL_bcz00_3141), ((long) 2));
										BgL_arg2726z00_3162 =
											BGl_Eze70ze7zz__evaluate_compz00(BgL_sz00_15532,
											BgL_arg2729z00_3164);
									}
									return
										DOUBLE_TO_REAL(
										(REAL_TO_DOUBLE(BgL_arg2724z00_3161) -
											REAL_TO_DOUBLE(BgL_arg2726z00_3162)));
								}
								break;
							case ((long) 8):

								{	/* Eval/evaluate_comp.scm 971 */
									obj_t BgL_arg2730z00_3165;
									obj_t BgL_arg2731z00_3166;

									{	/* Eval/evaluate_comp.scm 971 */
										obj_t BgL_arg2733z00_3167;

										BgL_arg2733z00_3167 =
											VECTOR_REF(((obj_t) BgL_bcz00_3141), ((long) 1));
										BgL_arg2730z00_3165 =
											BGl_Eze70ze7zz__evaluate_compz00(BgL_sz00_15532,
											BgL_arg2733z00_3167);
									}
									{	/* Eval/evaluate_comp.scm 971 */
										obj_t BgL_arg2734z00_3168;

										BgL_arg2734z00_3168 =
											VECTOR_REF(((obj_t) BgL_bcz00_3141), ((long) 2));
										BgL_arg2731z00_3166 =
											BGl_Eze70ze7zz__evaluate_compz00(BgL_sz00_15532,
											BgL_arg2734z00_3168);
									}
									return
										DOUBLE_TO_REAL(
										(REAL_TO_DOUBLE(BgL_arg2730z00_3165) *
											REAL_TO_DOUBLE(BgL_arg2731z00_3166)));
								}
								break;
							case ((long) 9):

								{	/* Eval/evaluate_comp.scm 972 */
									obj_t BgL_arg2738z00_3169;
									obj_t BgL_arg2739z00_3170;

									{	/* Eval/evaluate_comp.scm 972 */
										obj_t BgL_arg2741z00_3171;

										BgL_arg2741z00_3171 =
											VECTOR_REF(((obj_t) BgL_bcz00_3141), ((long) 1));
										BgL_arg2738z00_3169 =
											BGl_Eze70ze7zz__evaluate_compz00(BgL_sz00_15532,
											BgL_arg2741z00_3171);
									}
									{	/* Eval/evaluate_comp.scm 972 */
										obj_t BgL_arg2742z00_3172;

										BgL_arg2742z00_3172 =
											VECTOR_REF(((obj_t) BgL_bcz00_3141), ((long) 2));
										BgL_arg2739z00_3170 =
											BGl_Eze70ze7zz__evaluate_compz00(BgL_sz00_15532,
											BgL_arg2742z00_3172);
									}
									return
										DOUBLE_TO_REAL(
										(REAL_TO_DOUBLE(BgL_arg2738z00_3169) /
											REAL_TO_DOUBLE(BgL_arg2739z00_3170)));
								}
								break;
							case ((long) 10):

								{	/* Eval/evaluate_comp.scm 973 */
									obj_t BgL_arg2744z00_3173;

									{	/* Eval/evaluate_comp.scm 973 */
										obj_t BgL_fun2745z00_3174;

										BgL_fun2745z00_3174 =
											VECTOR_REF(((obj_t) BgL_bcz00_3141), ((long) 1));
										BgL_arg2744z00_3173 =
											PROCEDURE_ENTRY(BgL_fun2745z00_3174) (BgL_fun2745z00_3174,
											BgL_sz00_15532, BEOA);
									}
									return
										DOUBLE_TO_REAL((double) ((long) CINT(BgL_arg2744z00_3173)));
								} break;
							case ((long) 11):

								{	/* Eval/evaluate_comp.scm 974 */
									obj_t BgL_arg2747z00_3175;
									obj_t BgL_arg2748z00_3176;

									{	/* Eval/evaluate_comp.scm 974 */
										obj_t BgL_fun2749z00_3177;

										BgL_fun2749z00_3177 =
											VECTOR_REF(((obj_t) BgL_bcz00_3141), ((long) 1));
										BgL_arg2747z00_3175 =
											PROCEDURE_ENTRY(BgL_fun2749z00_3177) (BgL_fun2749z00_3177,
											BgL_sz00_15532, BEOA);
									}
									{	/* Eval/evaluate_comp.scm 974 */
										obj_t BgL_fun2750z00_3178;

										BgL_fun2750z00_3178 =
											VECTOR_REF(((obj_t) BgL_bcz00_3141), ((long) 2));
										BgL_arg2748z00_3176 =
											PROCEDURE_ENTRY(BgL_fun2750z00_3178) (BgL_fun2750z00_3178,
											BgL_sz00_15532, BEOA);
									}
									{	/* Eval/evaluate_comp.scm 974 */
										double BgL_tmpz00_24027;

										{	/* Eval/evaluate_comp.scm 974 */
											long BgL_tmpz00_24028;

											BgL_tmpz00_24028 = (long) CINT(BgL_arg2748z00_3176);
											BgL_tmpz00_24027 =
												BGL_F64VREF(BgL_arg2747z00_3175, BgL_tmpz00_24028);
										}
										return DOUBLE_TO_REAL(BgL_tmpz00_24027);
									}
								}
								break;
							default:
								{	/* Eval/evaluate_comp.scm 975 */
									obj_t BgL_arg2751z00_9457;

									BgL_arg2751z00_9457 =
										VECTOR_REF(((obj_t) BgL_bcz00_3141), ((long) 0));
									return
										BGl_errorz00zz__errorz00
										(BGl_string5807z00zz__evaluate_compz00,
										BGl_string5826z00zz__evaluate_compz00, BgL_arg2751z00_9457);
								}
							}
					}
				else
					{	/* Eval/evaluate_comp.scm 975 */
						obj_t BgL_arg2751z00_9459;

						BgL_arg2751z00_9459 =
							VECTOR_REF(((obj_t) BgL_bcz00_3141), ((long) 0));
						return
							BGl_errorz00zz__errorz00(BGl_string5807z00zz__evaluate_compz00,
							BGl_string5826z00zz__evaluate_compz00, BgL_arg2751z00_9459);
					}
			}
		}

	}



/* arith-expression */
	obj_t BGl_arithzd2expressionzd2zz__evaluate_compz00(BgL_ev_appz00_bglt
		BgL_exprz00_191, obj_t BgL_stkz00_192)
	{
		{	/* Eval/evaluate_comp.scm 978 */
			{	/* Eval/evaluate_comp.scm 980 */
				obj_t BgL_fvalz00_3182;

				BgL_fvalz00_3182 =
					BGl_globalzd2funzd2valuez00zz__evaluate_compz00(
					(((BgL_ev_appz00_bglt) COBJECT(BgL_exprz00_191))->BgL_funz00));
				{	/* Eval/evaluate_comp.scm 981 */
					bool_t BgL_test6434z00_24042;

					if (
						(BgL_fvalz00_3182 ==
							BGl_zb2flzd2envz60zz__r4_numbers_6_5_flonumz00))
						{	/* Eval/evaluate_comp.scm 981 */
							BgL_test6434z00_24042 = ((bool_t) 1);
						}
					else
						{	/* Eval/evaluate_comp.scm 981 */
							if (
								(BgL_fvalz00_3182 ==
									BGl_zd2flzd2envz00zz__r4_numbers_6_5_flonumz00))
								{	/* Eval/evaluate_comp.scm 981 */
									BgL_test6434z00_24042 = ((bool_t) 1);
								}
							else
								{	/* Eval/evaluate_comp.scm 981 */
									if (
										(BgL_fvalz00_3182 ==
											BGl_za2flzd2envz70zz__r4_numbers_6_5_flonumz00))
										{	/* Eval/evaluate_comp.scm 981 */
											BgL_test6434z00_24042 = ((bool_t) 1);
										}
									else
										{	/* Eval/evaluate_comp.scm 981 */
											BgL_test6434z00_24042 =
												(BgL_fvalz00_3182 ==
												BGl_zf2flzd2envz20zz__r4_numbers_6_5_flonumz00);
										}
								}
						}
					if (BgL_test6434z00_24042)
						{	/* Eval/evaluate_comp.scm 982 */
							obj_t BgL_bcz00_3187;

							BgL_bcz00_3187 =
								BGl_compilezd2floatzd2arithz00zz__evaluate_compz00(
								((obj_t) BgL_exprz00_191), BgL_stkz00_192);
							{	/* Eval/evaluate_comp.scm 983 */
								obj_t BgL_zc3z04anonymousza32756ze3z87_13887;

								BgL_zc3z04anonymousza32756ze3z87_13887 =
									MAKE_FX_PROCEDURE
									(BGl_z62zc3z04anonymousza32756ze3ze5zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 1)));
								PROCEDURE_SET(BgL_zc3z04anonymousza32756ze3z87_13887,
									(int) (((long) 0)), BgL_bcz00_3187);
								return BgL_zc3z04anonymousza32756ze3z87_13887;
							}
						}
					else
						{	/* Eval/evaluate_comp.scm 981 */
							return BFALSE;
						}
				}
			}
		}

	}



/* &<@anonymous:2756> */
	obj_t BGl_z62zc3z04anonymousza32756ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_13888, obj_t BgL_sz00_13890)
	{
		{	/* Eval/evaluate_comp.scm 983 */
			{	/* Eval/evaluate_comp.scm 983 */
				obj_t BgL_bcz00_13889;

				BgL_bcz00_13889 =
					((obj_t) PROCEDURE_REF(BgL_envz00_13888, (int) (((long) 0))));
				{	/* Eval/evaluate_comp.scm 983 */
					double BgL_tmpz00_24060;

					{	/* Eval/evaluate_comp.scm 983 */
						obj_t BgL_bpz00_16482;

						BgL_bpz00_16482 = VECTOR_REF(((obj_t) BgL_sz00_13890), ((long) 0));
						BgL_tmpz00_24060 =
							BGl_evalzd2floatzd2arithz00zz__evaluate_compz00(BgL_bcz00_13889,
							BgL_sz00_13890);
					}
					return DOUBLE_TO_REAL(BgL_tmpz00_24060);
				}
			}
		}

	}



/* inline-call */
	obj_t BGl_inlinezd2callzd2zz__evaluate_compz00(obj_t BgL_locz00_193,
		BgL_ev_exprz00_bglt BgL_funz00_194, obj_t BgL_argsz00_195,
		obj_t BgL_stkz00_196)
	{
		{	/* Eval/evaluate_comp.scm 1012 */
			{	/* Eval/evaluate_comp.scm 1013 */
				obj_t BgL_valz00_3195;

				BgL_valz00_3195 =
					BGl_globalzd2funzd2valuez00zz__evaluate_compz00(BgL_funz00_194);
				if (CBOOL(BgL_valz00_3195))
					{	/* Eval/evaluate_comp.scm 1015 */
						long BgL_nz00_3196;

						BgL_nz00_3196 = bgl_list_length(BgL_argsz00_195);
						{	/* Eval/evaluate_comp.scm 1016 */
							obj_t BgL__ortest_1227z00_3197;

							if ((BgL_nz00_3196 == ((long) 1)))
								{	/* Eval/evaluate_comp.scm 1017 */
									obj_t BgL_a1z00_3488;

									BgL_a1z00_3488 = CAR(((obj_t) BgL_argsz00_195));
									if (
										(BgL_valz00_3195 ==
											BGl_carzd2envzd2zz__r4_pairs_and_lists_6_3z00))
										{	/* Eval/evaluate_comp.scm 1018 */
											obj_t BgL_a1z00_3490;

											BgL_a1z00_3490 =
												BGl_compz00zz__evaluate_compz00(
												((BgL_ev_exprz00_bglt) BgL_a1z00_3488), BgL_stkz00_196);
											{	/* Eval/evaluate_comp.scm 1018 */
												obj_t BgL_zc3z04anonymousza32874ze3z87_13920;

												BgL_zc3z04anonymousza32874ze3z87_13920 =
													MAKE_FX_PROCEDURE
													(BGl_z62zc3z04anonymousza32874ze3ze5zz__evaluate_compz00,
													(int) (((long) 1)), (int) (((long) 2)));
												PROCEDURE_SET(BgL_zc3z04anonymousza32874ze3z87_13920,
													(int) (((long) 0)), BgL_a1z00_3490);
												PROCEDURE_SET(BgL_zc3z04anonymousza32874ze3z87_13920,
													(int) (((long) 1)), BgL_locz00_193);
												BgL__ortest_1227z00_3197 =
													BgL_zc3z04anonymousza32874ze3z87_13920;
										}}
									else
										{	/* Eval/evaluate_comp.scm 1018 */
											if (
												(BgL_valz00_3195 ==
													BGl_cdrzd2envzd2zz__r4_pairs_and_lists_6_3z00))
												{	/* Eval/evaluate_comp.scm 1018 */
													obj_t BgL_a1z00_3497;

													BgL_a1z00_3497 =
														BGl_compz00zz__evaluate_compz00(
														((BgL_ev_exprz00_bglt) BgL_a1z00_3488),
														BgL_stkz00_196);
													{	/* Eval/evaluate_comp.scm 1018 */
														obj_t BgL_zc3z04anonymousza32877ze3z87_13921;

														BgL_zc3z04anonymousza32877ze3z87_13921 =
															MAKE_FX_PROCEDURE
															(BGl_z62zc3z04anonymousza32877ze3ze5zz__evaluate_compz00,
															(int) (((long) 1)), (int) (((long) 2)));
														PROCEDURE_SET
															(BgL_zc3z04anonymousza32877ze3z87_13921,
															(int) (((long) 0)), BgL_a1z00_3497);
														PROCEDURE_SET
															(BgL_zc3z04anonymousza32877ze3z87_13921,
															(int) (((long) 1)), BgL_locz00_193);
														BgL__ortest_1227z00_3197 =
															BgL_zc3z04anonymousza32877ze3z87_13921;
												}}
											else
												{	/* Eval/evaluate_comp.scm 1018 */
													if (
														(BgL_valz00_3195 ==
															BGl_cadrzd2envzd2zz__r4_pairs_and_lists_6_3z00))
														{	/* Eval/evaluate_comp.scm 1018 */
															obj_t BgL_a1z00_3504;

															BgL_a1z00_3504 =
																BGl_compz00zz__evaluate_compz00(
																((BgL_ev_exprz00_bglt) BgL_a1z00_3488),
																BgL_stkz00_196);
															{	/* Eval/evaluate_comp.scm 1018 */
																obj_t BgL_zc3z04anonymousza32880ze3z87_13922;

																BgL_zc3z04anonymousza32880ze3z87_13922 =
																	MAKE_FX_PROCEDURE
																	(BGl_z62zc3z04anonymousza32880ze3ze5zz__evaluate_compz00,
																	(int) (((long) 1)), (int) (((long) 2)));
																PROCEDURE_SET
																	(BgL_zc3z04anonymousza32880ze3z87_13922,
																	(int) (((long) 0)), BgL_a1z00_3504);
																PROCEDURE_SET
																	(BgL_zc3z04anonymousza32880ze3z87_13922,
																	(int) (((long) 1)), BgL_locz00_193);
																BgL__ortest_1227z00_3197 =
																	BgL_zc3z04anonymousza32880ze3z87_13922;
														}}
													else
														{	/* Eval/evaluate_comp.scm 1018 */
															BgL__ortest_1227z00_3197 = BFALSE;
														}
												}
										}
								}
							else
								{	/* Eval/evaluate_comp.scm 1016 */
									BgL__ortest_1227z00_3197 = BFALSE;
								}
							if (CBOOL(BgL__ortest_1227z00_3197))
								{	/* Eval/evaluate_comp.scm 1016 */
									return BgL__ortest_1227z00_3197;
								}
							else
								{	/* Eval/evaluate_comp.scm 1016 */
									if ((BgL_nz00_3196 == ((long) 2)))
										{	/* Eval/evaluate_comp.scm 1020 */
											obj_t BgL_a1z00_3199;
											obj_t BgL_a2z00_3200;

											BgL_a1z00_3199 = CAR(((obj_t) BgL_argsz00_195));
											{	/* Eval/evaluate_comp.scm 1020 */
												obj_t BgL_pairz00_9491;

												BgL_pairz00_9491 = CDR(((obj_t) BgL_argsz00_195));
												BgL_a2z00_3200 = CAR(BgL_pairz00_9491);
											}
											if (
												(BgL_valz00_3195 ==
													BGl_zb2zd2envz60zz__r4_numbers_6_5z00))
												{	/* Eval/evaluate_comp.scm 1021 */
													obj_t BgL_a1z00_3202;
													obj_t BgL_a2z00_3203;

													BgL_a1z00_3202 =
														BGl_compz00zz__evaluate_compz00(
														((BgL_ev_exprz00_bglt) BgL_a1z00_3199),
														BgL_stkz00_196);
													BgL_a2z00_3203 =
														BGl_compz00zz__evaluate_compz00((
															(BgL_ev_exprz00_bglt) BgL_a2z00_3200),
														BgL_stkz00_196);
													{	/* Eval/evaluate_comp.scm 1021 */
														obj_t BgL_zc3z04anonymousza32761ze3z87_13891;

														BgL_zc3z04anonymousza32761ze3z87_13891 =
															MAKE_FX_PROCEDURE
															(BGl_z62zc3z04anonymousza32761ze3ze5zz__evaluate_compz00,
															(int) (((long) 1)), (int) (((long) 3)));
														PROCEDURE_SET
															(BgL_zc3z04anonymousza32761ze3z87_13891,
															(int) (((long) 0)), BgL_a1z00_3202);
														PROCEDURE_SET
															(BgL_zc3z04anonymousza32761ze3z87_13891,
															(int) (((long) 1)), BgL_a2z00_3203);
														PROCEDURE_SET
															(BgL_zc3z04anonymousza32761ze3z87_13891,
															(int) (((long) 2)), BgL_locz00_193);
														return BgL_zc3z04anonymousza32761ze3z87_13891;
													}
												}
											else
												{	/* Eval/evaluate_comp.scm 1021 */
													if (
														(BgL_valz00_3195 ==
															BGl_zd2zd2envz00zz__r4_numbers_6_5z00))
														{	/* Eval/evaluate_comp.scm 1021 */
															obj_t BgL_a1z00_3212;
															obj_t BgL_a2z00_3213;

															BgL_a1z00_3212 =
																BGl_compz00zz__evaluate_compz00(
																((BgL_ev_exprz00_bglt) BgL_a1z00_3199),
																BgL_stkz00_196);
															BgL_a2z00_3213 =
																BGl_compz00zz__evaluate_compz00((
																	(BgL_ev_exprz00_bglt) BgL_a2z00_3200),
																BgL_stkz00_196);
															{	/* Eval/evaluate_comp.scm 1021 */
																obj_t BgL_zc3z04anonymousza32765ze3z87_13892;

																BgL_zc3z04anonymousza32765ze3z87_13892 =
																	MAKE_FX_PROCEDURE
																	(BGl_z62zc3z04anonymousza32765ze3ze5zz__evaluate_compz00,
																	(int) (((long) 1)), (int) (((long) 3)));
																PROCEDURE_SET
																	(BgL_zc3z04anonymousza32765ze3z87_13892,
																	(int) (((long) 0)), BgL_a1z00_3212);
																PROCEDURE_SET
																	(BgL_zc3z04anonymousza32765ze3z87_13892,
																	(int) (((long) 1)), BgL_a2z00_3213);
																PROCEDURE_SET
																	(BgL_zc3z04anonymousza32765ze3z87_13892,
																	(int) (((long) 2)), BgL_locz00_193);
																return BgL_zc3z04anonymousza32765ze3z87_13892;
															}
														}
													else
														{	/* Eval/evaluate_comp.scm 1021 */
															if (
																(BgL_valz00_3195 ==
																	BGl_za2zd2envz70zz__r4_numbers_6_5z00))
																{	/* Eval/evaluate_comp.scm 1021 */
																	obj_t BgL_a1z00_3222;
																	obj_t BgL_a2z00_3223;

																	BgL_a1z00_3222 =
																		BGl_compz00zz__evaluate_compz00(
																		((BgL_ev_exprz00_bglt) BgL_a1z00_3199),
																		BgL_stkz00_196);
																	BgL_a2z00_3223 =
																		BGl_compz00zz__evaluate_compz00((
																			(BgL_ev_exprz00_bglt) BgL_a2z00_3200),
																		BgL_stkz00_196);
																	{	/* Eval/evaluate_comp.scm 1021 */
																		obj_t
																			BgL_zc3z04anonymousza32769ze3z87_13893;
																		BgL_zc3z04anonymousza32769ze3z87_13893 =
																			MAKE_FX_PROCEDURE
																			(BGl_z62zc3z04anonymousza32769ze3ze5zz__evaluate_compz00,
																			(int) (((long) 1)), (int) (((long) 3)));
																		PROCEDURE_SET
																			(BgL_zc3z04anonymousza32769ze3z87_13893,
																			(int) (((long) 0)), BgL_a1z00_3222);
																		PROCEDURE_SET
																			(BgL_zc3z04anonymousza32769ze3z87_13893,
																			(int) (((long) 1)), BgL_a2z00_3223);
																		PROCEDURE_SET
																			(BgL_zc3z04anonymousza32769ze3z87_13893,
																			(int) (((long) 2)), BgL_locz00_193);
																		return
																			BgL_zc3z04anonymousza32769ze3z87_13893;
																	}
																}
															else
																{	/* Eval/evaluate_comp.scm 1021 */
																	if (
																		(BgL_valz00_3195 ==
																			BGl_zf2zd2envz20zz__r4_numbers_6_5z00))
																		{	/* Eval/evaluate_comp.scm 1021 */
																			obj_t BgL_a1z00_3232;
																			obj_t BgL_a2z00_3233;

																			BgL_a1z00_3232 =
																				BGl_compz00zz__evaluate_compz00(
																				((BgL_ev_exprz00_bglt) BgL_a1z00_3199),
																				BgL_stkz00_196);
																			BgL_a2z00_3233 =
																				BGl_compz00zz__evaluate_compz00((
																					(BgL_ev_exprz00_bglt) BgL_a2z00_3200),
																				BgL_stkz00_196);
																			{	/* Eval/evaluate_comp.scm 1021 */
																				obj_t
																					BgL_zc3z04anonymousza32773ze3z87_13894;
																				BgL_zc3z04anonymousza32773ze3z87_13894 =
																					MAKE_FX_PROCEDURE
																					(BGl_z62zc3z04anonymousza32773ze3ze5zz__evaluate_compz00,
																					(int) (((long) 1)),
																					(int) (((long) 3)));
																				PROCEDURE_SET
																					(BgL_zc3z04anonymousza32773ze3z87_13894,
																					(int) (((long) 0)), BgL_a1z00_3232);
																				PROCEDURE_SET
																					(BgL_zc3z04anonymousza32773ze3z87_13894,
																					(int) (((long) 1)), BgL_a2z00_3233);
																				PROCEDURE_SET
																					(BgL_zc3z04anonymousza32773ze3z87_13894,
																					(int) (((long) 2)), BgL_locz00_193);
																				return
																					BgL_zc3z04anonymousza32773ze3z87_13894;
																			}
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 1021 */
																			if (
																				(BgL_valz00_3195 ==
																					BGl_zc3zd2envz11zz__r4_numbers_6_5z00))
																				{	/* Eval/evaluate_comp.scm 1021 */
																					obj_t BgL_a1z00_3242;
																					obj_t BgL_a2z00_3243;

																					BgL_a1z00_3242 =
																						BGl_compz00zz__evaluate_compz00(
																						((BgL_ev_exprz00_bglt)
																							BgL_a1z00_3199), BgL_stkz00_196);
																					BgL_a2z00_3243 =
																						BGl_compz00zz__evaluate_compz00((
																							(BgL_ev_exprz00_bglt)
																							BgL_a2z00_3200), BgL_stkz00_196);
																					{	/* Eval/evaluate_comp.scm 1021 */
																						obj_t
																							BgL_zc3z04anonymousza32777ze3z87_13895;
																						BgL_zc3z04anonymousza32777ze3z87_13895
																							=
																							MAKE_FX_PROCEDURE
																							(BGl_z62zc3z04anonymousza32777ze3ze5zz__evaluate_compz00,
																							(int) (((long) 1)),
																							(int) (((long) 3)));
																						PROCEDURE_SET
																							(BgL_zc3z04anonymousza32777ze3z87_13895,
																							(int) (((long) 0)),
																							BgL_a1z00_3242);
																						PROCEDURE_SET
																							(BgL_zc3z04anonymousza32777ze3z87_13895,
																							(int) (((long) 1)),
																							BgL_a2z00_3243);
																						PROCEDURE_SET
																							(BgL_zc3z04anonymousza32777ze3z87_13895,
																							(int) (((long) 2)),
																							BgL_locz00_193);
																						return
																							BgL_zc3z04anonymousza32777ze3z87_13895;
																					}
																				}
																			else
																				{	/* Eval/evaluate_comp.scm 1021 */
																					if (
																						(BgL_valz00_3195 ==
																							BGl_ze3zd2envz31zz__r4_numbers_6_5z00))
																						{	/* Eval/evaluate_comp.scm 1021 */
																							obj_t BgL_a1z00_3252;
																							obj_t BgL_a2z00_3253;

																							BgL_a1z00_3252 =
																								BGl_compz00zz__evaluate_compz00(
																								((BgL_ev_exprz00_bglt)
																									BgL_a1z00_3199),
																								BgL_stkz00_196);
																							BgL_a2z00_3253 =
																								BGl_compz00zz__evaluate_compz00(
																								((BgL_ev_exprz00_bglt)
																									BgL_a2z00_3200),
																								BgL_stkz00_196);
																							{	/* Eval/evaluate_comp.scm 1021 */
																								obj_t
																									BgL_zc3z04anonymousza32781ze3z87_13896;
																								BgL_zc3z04anonymousza32781ze3z87_13896
																									=
																									MAKE_FX_PROCEDURE
																									(BGl_z62zc3z04anonymousza32781ze3ze5zz__evaluate_compz00,
																									(int) (((long) 1)),
																									(int) (((long) 3)));
																								PROCEDURE_SET
																									(BgL_zc3z04anonymousza32781ze3z87_13896,
																									(int) (((long) 0)),
																									BgL_a1z00_3252);
																								PROCEDURE_SET
																									(BgL_zc3z04anonymousza32781ze3z87_13896,
																									(int) (((long) 1)),
																									BgL_a2z00_3253);
																								PROCEDURE_SET
																									(BgL_zc3z04anonymousza32781ze3z87_13896,
																									(int) (((long) 2)),
																									BgL_locz00_193);
																								return
																									BgL_zc3z04anonymousza32781ze3z87_13896;
																							}
																						}
																					else
																						{	/* Eval/evaluate_comp.scm 1021 */
																							if (
																								(BgL_valz00_3195 ==
																									BGl_zc3zd3zd2envzc2zz__r4_numbers_6_5z00))
																								{	/* Eval/evaluate_comp.scm 1021 */
																									obj_t BgL_a1z00_3262;
																									obj_t BgL_a2z00_3263;

																									BgL_a1z00_3262 =
																										BGl_compz00zz__evaluate_compz00
																										(((BgL_ev_exprz00_bglt)
																											BgL_a1z00_3199),
																										BgL_stkz00_196);
																									BgL_a2z00_3263 =
																										BGl_compz00zz__evaluate_compz00
																										(((BgL_ev_exprz00_bglt)
																											BgL_a2z00_3200),
																										BgL_stkz00_196);
																									{	/* Eval/evaluate_comp.scm 1021 */
																										obj_t
																											BgL_zc3z04anonymousza32785ze3z87_13897;
																										BgL_zc3z04anonymousza32785ze3z87_13897
																											=
																											MAKE_FX_PROCEDURE
																											(BGl_z62zc3z04anonymousza32785ze3ze5zz__evaluate_compz00,
																											(int) (((long) 1)),
																											(int) (((long) 3)));
																										PROCEDURE_SET
																											(BgL_zc3z04anonymousza32785ze3z87_13897,
																											(int) (((long) 0)),
																											BgL_a1z00_3262);
																										PROCEDURE_SET
																											(BgL_zc3z04anonymousza32785ze3z87_13897,
																											(int) (((long) 1)),
																											BgL_a2z00_3263);
																										PROCEDURE_SET
																											(BgL_zc3z04anonymousza32785ze3z87_13897,
																											(int) (((long) 2)),
																											BgL_locz00_193);
																										return
																											BgL_zc3z04anonymousza32785ze3z87_13897;
																									}
																								}
																							else
																								{	/* Eval/evaluate_comp.scm 1021 */
																									if (
																										(BgL_valz00_3195 ==
																											BGl_ze3zd3zd2envze2zz__r4_numbers_6_5z00))
																										{	/* Eval/evaluate_comp.scm 1021 */
																											obj_t BgL_a1z00_3272;
																											obj_t BgL_a2z00_3273;

																											BgL_a1z00_3272 =
																												BGl_compz00zz__evaluate_compz00
																												(((BgL_ev_exprz00_bglt)
																													BgL_a1z00_3199),
																												BgL_stkz00_196);
																											BgL_a2z00_3273 =
																												BGl_compz00zz__evaluate_compz00
																												(((BgL_ev_exprz00_bglt)
																													BgL_a2z00_3200),
																												BgL_stkz00_196);
																											{	/* Eval/evaluate_comp.scm 1021 */
																												obj_t
																													BgL_zc3z04anonymousza32789ze3z87_13898;
																												BgL_zc3z04anonymousza32789ze3z87_13898
																													=
																													MAKE_FX_PROCEDURE
																													(BGl_z62zc3z04anonymousza32789ze3ze5zz__evaluate_compz00,
																													(int) (((long) 1)),
																													(int) (((long) 3)));
																												PROCEDURE_SET
																													(BgL_zc3z04anonymousza32789ze3z87_13898,
																													(int) (((long) 0)),
																													BgL_a1z00_3272);
																												PROCEDURE_SET
																													(BgL_zc3z04anonymousza32789ze3z87_13898,
																													(int) (((long) 1)),
																													BgL_a2z00_3273);
																												PROCEDURE_SET
																													(BgL_zc3z04anonymousza32789ze3z87_13898,
																													(int) (((long) 2)),
																													BgL_locz00_193);
																												return
																													BgL_zc3z04anonymousza32789ze3z87_13898;
																											}
																										}
																									else
																										{	/* Eval/evaluate_comp.scm 1021 */
																											if (
																												(BgL_valz00_3195 ==
																													BGl_zd3zd2envz01zz__r4_numbers_6_5z00))
																												{	/* Eval/evaluate_comp.scm 1021 */
																													obj_t BgL_a1z00_3282;
																													obj_t BgL_a2z00_3283;

																													BgL_a1z00_3282 =
																														BGl_compz00zz__evaluate_compz00
																														(((BgL_ev_exprz00_bglt) BgL_a1z00_3199), BgL_stkz00_196);
																													BgL_a2z00_3283 =
																														BGl_compz00zz__evaluate_compz00
																														(((BgL_ev_exprz00_bglt) BgL_a2z00_3200), BgL_stkz00_196);
																													{	/* Eval/evaluate_comp.scm 1021 */
																														obj_t
																															BgL_zc3z04anonymousza32793ze3z87_13899;
																														BgL_zc3z04anonymousza32793ze3z87_13899
																															=
																															MAKE_FX_PROCEDURE
																															(BGl_z62zc3z04anonymousza32793ze3ze5zz__evaluate_compz00,
																															(int) (((long)
																																	1)),
																															(int) (((long)
																																	3)));
																														PROCEDURE_SET
																															(BgL_zc3z04anonymousza32793ze3z87_13899,
																															(int) (((long)
																																	0)),
																															BgL_a1z00_3282);
																														PROCEDURE_SET
																															(BgL_zc3z04anonymousza32793ze3z87_13899,
																															(int) (((long)
																																	1)),
																															BgL_a2z00_3283);
																														PROCEDURE_SET
																															(BgL_zc3z04anonymousza32793ze3z87_13899,
																															(int) (((long)
																																	2)),
																															BgL_locz00_193);
																														return
																															BgL_zc3z04anonymousza32793ze3z87_13899;
																													}
																												}
																											else
																												{	/* Eval/evaluate_comp.scm 1021 */
																													if (
																														(BgL_valz00_3195 ==
																															BGl_zb2fxzd2envz60zz__r4_numbers_6_5_fixnumz00))
																														{	/* Eval/evaluate_comp.scm 1021 */
																															obj_t
																																BgL_a1z00_3292;
																															obj_t
																																BgL_a2z00_3293;
																															BgL_a1z00_3292 =
																																BGl_compz00zz__evaluate_compz00
																																(((BgL_ev_exprz00_bglt) BgL_a1z00_3199), BgL_stkz00_196);
																															BgL_a2z00_3293 =
																																BGl_compz00zz__evaluate_compz00
																																(((BgL_ev_exprz00_bglt) BgL_a2z00_3200), BgL_stkz00_196);
																															{	/* Eval/evaluate_comp.scm 1021 */
																																obj_t
																																	BgL_zc3z04anonymousza32797ze3z87_13900;
																																BgL_zc3z04anonymousza32797ze3z87_13900
																																	=
																																	MAKE_FX_PROCEDURE
																																	(BGl_z62zc3z04anonymousza32797ze3ze5zz__evaluate_compz00,
																																	(int) (((long)
																																			1)),
																																	(int) (((long)
																																			3)));
																																PROCEDURE_SET
																																	(BgL_zc3z04anonymousza32797ze3z87_13900,
																																	(int) (((long)
																																			0)),
																																	BgL_a1z00_3292);
																																PROCEDURE_SET
																																	(BgL_zc3z04anonymousza32797ze3z87_13900,
																																	(int) (((long)
																																			1)),
																																	BgL_a2z00_3293);
																																PROCEDURE_SET
																																	(BgL_zc3z04anonymousza32797ze3z87_13900,
																																	(int) (((long)
																																			2)),
																																	BgL_locz00_193);
																																return
																																	BgL_zc3z04anonymousza32797ze3z87_13900;
																															}
																														}
																													else
																														{	/* Eval/evaluate_comp.scm 1021 */
																															if (
																																(BgL_valz00_3195
																																	==
																																	BGl_zd2fxzd2envz00zz__r4_numbers_6_5_fixnumz00))
																																{	/* Eval/evaluate_comp.scm 1021 */
																																	obj_t
																																		BgL_a1z00_3302;
																																	obj_t
																																		BgL_a2z00_3303;
																																	BgL_a1z00_3302
																																		=
																																		BGl_compz00zz__evaluate_compz00
																																		(((BgL_ev_exprz00_bglt) BgL_a1z00_3199), BgL_stkz00_196);
																																	BgL_a2z00_3303
																																		=
																																		BGl_compz00zz__evaluate_compz00
																																		(((BgL_ev_exprz00_bglt) BgL_a2z00_3200), BgL_stkz00_196);
																																	{	/* Eval/evaluate_comp.scm 1021 */
																																		obj_t
																																			BgL_zc3z04anonymousza32801ze3z87_13901;
																																		BgL_zc3z04anonymousza32801ze3z87_13901
																																			=
																																			MAKE_FX_PROCEDURE
																																			(BGl_z62zc3z04anonymousza32801ze3ze5zz__evaluate_compz00,
																																			(int) ((
																																					(long)
																																					1)),
																																			(int) ((
																																					(long)
																																					3)));
																																		PROCEDURE_SET
																																			(BgL_zc3z04anonymousza32801ze3z87_13901,
																																			(int) ((
																																					(long)
																																					0)),
																																			BgL_a1z00_3302);
																																		PROCEDURE_SET
																																			(BgL_zc3z04anonymousza32801ze3z87_13901,
																																			(int) ((
																																					(long)
																																					1)),
																																			BgL_a2z00_3303);
																																		PROCEDURE_SET
																																			(BgL_zc3z04anonymousza32801ze3z87_13901,
																																			(int) ((
																																					(long)
																																					2)),
																																			BgL_locz00_193);
																																		return
																																			BgL_zc3z04anonymousza32801ze3z87_13901;
																																	}
																																}
																															else
																																{	/* Eval/evaluate_comp.scm 1021 */
																																	if (
																																		(BgL_valz00_3195
																																			==
																																			BGl_za2fxzd2envz70zz__r4_numbers_6_5_fixnumz00))
																																		{	/* Eval/evaluate_comp.scm 1021 */
																																			obj_t
																																				BgL_a1z00_3312;
																																			obj_t
																																				BgL_a2z00_3313;
																																			BgL_a1z00_3312
																																				=
																																				BGl_compz00zz__evaluate_compz00
																																				(((BgL_ev_exprz00_bglt) BgL_a1z00_3199), BgL_stkz00_196);
																																			BgL_a2z00_3313
																																				=
																																				BGl_compz00zz__evaluate_compz00
																																				(((BgL_ev_exprz00_bglt) BgL_a2z00_3200), BgL_stkz00_196);
																																			{	/* Eval/evaluate_comp.scm 1021 */
																																				obj_t
																																					BgL_zc3z04anonymousza32805ze3z87_13902;
																																				BgL_zc3z04anonymousza32805ze3z87_13902
																																					=
																																					MAKE_FX_PROCEDURE
																																					(BGl_z62zc3z04anonymousza32805ze3ze5zz__evaluate_compz00,
																																					(int)
																																					(((long) 1)), (int) (((long) 3)));
																																				PROCEDURE_SET
																																					(BgL_zc3z04anonymousza32805ze3z87_13902,
																																					(int)
																																					(((long) 0)), BgL_a1z00_3312);
																																				PROCEDURE_SET
																																					(BgL_zc3z04anonymousza32805ze3z87_13902,
																																					(int)
																																					(((long) 1)), BgL_a2z00_3313);
																																				PROCEDURE_SET
																																					(BgL_zc3z04anonymousza32805ze3z87_13902,
																																					(int)
																																					(((long) 2)), BgL_locz00_193);
																																				return
																																					BgL_zc3z04anonymousza32805ze3z87_13902;
																																			}
																																		}
																																	else
																																		{	/* Eval/evaluate_comp.scm 1021 */
																																			if (
																																				(BgL_valz00_3195
																																					==
																																					BGl_zf2fxzd2envz20zz__r4_numbers_6_5_fixnumz00))
																																				{	/* Eval/evaluate_comp.scm 1021 */
																																					obj_t
																																						BgL_a1z00_3322;
																																					obj_t
																																						BgL_a2z00_3323;
																																					BgL_a1z00_3322
																																						=
																																						BGl_compz00zz__evaluate_compz00
																																						(((BgL_ev_exprz00_bglt) BgL_a1z00_3199), BgL_stkz00_196);
																																					BgL_a2z00_3323
																																						=
																																						BGl_compz00zz__evaluate_compz00
																																						(((BgL_ev_exprz00_bglt) BgL_a2z00_3200), BgL_stkz00_196);
																																					{	/* Eval/evaluate_comp.scm 1021 */
																																						obj_t
																																							BgL_zc3z04anonymousza32809ze3z87_13903;
																																						BgL_zc3z04anonymousza32809ze3z87_13903
																																							=
																																							MAKE_FX_PROCEDURE
																																							(BGl_z62zc3z04anonymousza32809ze3ze5zz__evaluate_compz00,
																																							(int)
																																							(((long) 1)), (int) (((long) 3)));
																																						PROCEDURE_SET
																																							(BgL_zc3z04anonymousza32809ze3z87_13903,
																																							(int)
																																							(((long) 0)), BgL_a1z00_3322);
																																						PROCEDURE_SET
																																							(BgL_zc3z04anonymousza32809ze3z87_13903,
																																							(int)
																																							(((long) 1)), BgL_a2z00_3323);
																																						PROCEDURE_SET
																																							(BgL_zc3z04anonymousza32809ze3z87_13903,
																																							(int)
																																							(((long) 2)), BgL_locz00_193);
																																						return
																																							BgL_zc3z04anonymousza32809ze3z87_13903;
																																					}
																																				}
																																			else
																																				{	/* Eval/evaluate_comp.scm 1021 */
																																					if (
																																						(BgL_valz00_3195
																																							==
																																							BGl_zc3fxzd2envz11zz__r4_numbers_6_5_fixnumz00))
																																						{	/* Eval/evaluate_comp.scm 1021 */
																																							obj_t
																																								BgL_a1z00_3332;
																																							obj_t
																																								BgL_a2z00_3333;
																																							BgL_a1z00_3332
																																								=
																																								BGl_compz00zz__evaluate_compz00
																																								(
																																								((BgL_ev_exprz00_bglt) BgL_a1z00_3199), BgL_stkz00_196);
																																							BgL_a2z00_3333
																																								=
																																								BGl_compz00zz__evaluate_compz00
																																								(
																																								((BgL_ev_exprz00_bglt) BgL_a2z00_3200), BgL_stkz00_196);
																																							{	/* Eval/evaluate_comp.scm 1021 */
																																								obj_t
																																									BgL_zc3z04anonymousza32813ze3z87_13904;
																																								BgL_zc3z04anonymousza32813ze3z87_13904
																																									=
																																									MAKE_FX_PROCEDURE
																																									(BGl_z62zc3z04anonymousza32813ze3ze5zz__evaluate_compz00,
																																									(int)
																																									(((long) 1)), (int) (((long) 3)));
																																								PROCEDURE_SET
																																									(BgL_zc3z04anonymousza32813ze3z87_13904,
																																									(int)
																																									(((long) 0)), BgL_a1z00_3332);
																																								PROCEDURE_SET
																																									(BgL_zc3z04anonymousza32813ze3z87_13904,
																																									(int)
																																									(((long) 1)), BgL_a2z00_3333);
																																								PROCEDURE_SET
																																									(BgL_zc3z04anonymousza32813ze3z87_13904,
																																									(int)
																																									(((long) 2)), BgL_locz00_193);
																																								return
																																									BgL_zc3z04anonymousza32813ze3z87_13904;
																																							}
																																						}
																																					else
																																						{	/* Eval/evaluate_comp.scm 1021 */
																																							if ((BgL_valz00_3195 == BGl_ze3fxzd2envz31zz__r4_numbers_6_5_fixnumz00))
																																								{	/* Eval/evaluate_comp.scm 1021 */
																																									obj_t
																																										BgL_a1z00_3342;
																																									obj_t
																																										BgL_a2z00_3343;
																																									BgL_a1z00_3342
																																										=
																																										BGl_compz00zz__evaluate_compz00
																																										(
																																										((BgL_ev_exprz00_bglt) BgL_a1z00_3199), BgL_stkz00_196);
																																									BgL_a2z00_3343
																																										=
																																										BGl_compz00zz__evaluate_compz00
																																										(
																																										((BgL_ev_exprz00_bglt) BgL_a2z00_3200), BgL_stkz00_196);
																																									{	/* Eval/evaluate_comp.scm 1021 */
																																										obj_t
																																											BgL_zc3z04anonymousza32817ze3z87_13905;
																																										BgL_zc3z04anonymousza32817ze3z87_13905
																																											=
																																											MAKE_FX_PROCEDURE
																																											(BGl_z62zc3z04anonymousza32817ze3ze5zz__evaluate_compz00,
																																											(int)
																																											(((long) 1)), (int) (((long) 3)));
																																										PROCEDURE_SET
																																											(BgL_zc3z04anonymousza32817ze3z87_13905,
																																											(int)
																																											(((long) 0)), BgL_a1z00_3342);
																																										PROCEDURE_SET
																																											(BgL_zc3z04anonymousza32817ze3z87_13905,
																																											(int)
																																											(((long) 1)), BgL_a2z00_3343);
																																										PROCEDURE_SET
																																											(BgL_zc3z04anonymousza32817ze3z87_13905,
																																											(int)
																																											(((long) 2)), BgL_locz00_193);
																																										return
																																											BgL_zc3z04anonymousza32817ze3z87_13905;
																																									}
																																								}
																																							else
																																								{	/* Eval/evaluate_comp.scm 1021 */
																																									if ((BgL_valz00_3195 == BGl_zc3zd3fxzd2envzc2zz__r4_numbers_6_5_fixnumz00))
																																										{	/* Eval/evaluate_comp.scm 1021 */
																																											obj_t
																																												BgL_a1z00_3352;
																																											obj_t
																																												BgL_a2z00_3353;
																																											BgL_a1z00_3352
																																												=
																																												BGl_compz00zz__evaluate_compz00
																																												(
																																												((BgL_ev_exprz00_bglt) BgL_a1z00_3199), BgL_stkz00_196);
																																											BgL_a2z00_3353
																																												=
																																												BGl_compz00zz__evaluate_compz00
																																												(
																																												((BgL_ev_exprz00_bglt) BgL_a2z00_3200), BgL_stkz00_196);
																																											{	/* Eval/evaluate_comp.scm 1021 */
																																												obj_t
																																													BgL_zc3z04anonymousza32821ze3z87_13906;
																																												BgL_zc3z04anonymousza32821ze3z87_13906
																																													=
																																													MAKE_FX_PROCEDURE
																																													(BGl_z62zc3z04anonymousza32821ze3ze5zz__evaluate_compz00,
																																													(int)
																																													(((long) 1)), (int) (((long) 3)));
																																												PROCEDURE_SET
																																													(BgL_zc3z04anonymousza32821ze3z87_13906,
																																													(int)
																																													(((long) 0)), BgL_a1z00_3352);
																																												PROCEDURE_SET
																																													(BgL_zc3z04anonymousza32821ze3z87_13906,
																																													(int)
																																													(((long) 1)), BgL_a2z00_3353);
																																												PROCEDURE_SET
																																													(BgL_zc3z04anonymousza32821ze3z87_13906,
																																													(int)
																																													(((long) 2)), BgL_locz00_193);
																																												return
																																													BgL_zc3z04anonymousza32821ze3z87_13906;
																																											}
																																										}
																																									else
																																										{	/* Eval/evaluate_comp.scm 1021 */
																																											if ((BgL_valz00_3195 == BGl_ze3zd3fxzd2envze2zz__r4_numbers_6_5_fixnumz00))
																																												{	/* Eval/evaluate_comp.scm 1021 */
																																													obj_t
																																														BgL_a1z00_3362;
																																													obj_t
																																														BgL_a2z00_3363;
																																													BgL_a1z00_3362
																																														=
																																														BGl_compz00zz__evaluate_compz00
																																														(
																																														((BgL_ev_exprz00_bglt) BgL_a1z00_3199), BgL_stkz00_196);
																																													BgL_a2z00_3363
																																														=
																																														BGl_compz00zz__evaluate_compz00
																																														(
																																														((BgL_ev_exprz00_bglt) BgL_a2z00_3200), BgL_stkz00_196);
																																													{	/* Eval/evaluate_comp.scm 1021 */
																																														obj_t
																																															BgL_zc3z04anonymousza32825ze3z87_13907;
																																														BgL_zc3z04anonymousza32825ze3z87_13907
																																															=
																																															MAKE_FX_PROCEDURE
																																															(BGl_z62zc3z04anonymousza32825ze3ze5zz__evaluate_compz00,
																																															(int)
																																															(((long) 1)), (int) (((long) 3)));
																																														PROCEDURE_SET
																																															(BgL_zc3z04anonymousza32825ze3z87_13907,
																																															(int)
																																															(((long) 0)), BgL_a1z00_3362);
																																														PROCEDURE_SET
																																															(BgL_zc3z04anonymousza32825ze3z87_13907,
																																															(int)
																																															(((long) 1)), BgL_a2z00_3363);
																																														PROCEDURE_SET
																																															(BgL_zc3z04anonymousza32825ze3z87_13907,
																																															(int)
																																															(((long) 2)), BgL_locz00_193);
																																														return
																																															BgL_zc3z04anonymousza32825ze3z87_13907;
																																													}
																																												}
																																											else
																																												{	/* Eval/evaluate_comp.scm 1021 */
																																													if ((BgL_valz00_3195 == BGl_zd3fxzd2envz01zz__r4_numbers_6_5_fixnumz00))
																																														{	/* Eval/evaluate_comp.scm 1021 */
																																															obj_t
																																																BgL_a1z00_3372;
																																															obj_t
																																																BgL_a2z00_3373;
																																															BgL_a1z00_3372
																																																=
																																																BGl_compz00zz__evaluate_compz00
																																																(
																																																((BgL_ev_exprz00_bglt) BgL_a1z00_3199), BgL_stkz00_196);
																																															BgL_a2z00_3373
																																																=
																																																BGl_compz00zz__evaluate_compz00
																																																(
																																																((BgL_ev_exprz00_bglt) BgL_a2z00_3200), BgL_stkz00_196);
																																															{	/* Eval/evaluate_comp.scm 1021 */
																																																obj_t
																																																	BgL_zc3z04anonymousza32829ze3z87_13908;
																																																BgL_zc3z04anonymousza32829ze3z87_13908
																																																	=
																																																	MAKE_FX_PROCEDURE
																																																	(BGl_z62zc3z04anonymousza32829ze3ze5zz__evaluate_compz00,
																																																	(int)
																																																	(((long) 1)), (int) (((long) 3)));
																																																PROCEDURE_SET
																																																	(BgL_zc3z04anonymousza32829ze3z87_13908,
																																																	(int)
																																																	(((long) 0)), BgL_a1z00_3372);
																																																PROCEDURE_SET
																																																	(BgL_zc3z04anonymousza32829ze3z87_13908,
																																																	(int)
																																																	(((long) 1)), BgL_a2z00_3373);
																																																PROCEDURE_SET
																																																	(BgL_zc3z04anonymousza32829ze3z87_13908,
																																																	(int)
																																																	(((long) 2)), BgL_locz00_193);
																																																return
																																																	BgL_zc3z04anonymousza32829ze3z87_13908;
																																															}
																																														}
																																													else
																																														{	/* Eval/evaluate_comp.scm 1021 */
																																															if ((BgL_valz00_3195 == BGl_zb2flzd2envz60zz__r4_numbers_6_5_flonumz00))
																																																{	/* Eval/evaluate_comp.scm 1021 */
																																																	obj_t
																																																		BgL_a1z00_3382;
																																																	obj_t
																																																		BgL_a2z00_3383;
																																																	BgL_a1z00_3382
																																																		=
																																																		BGl_compz00zz__evaluate_compz00
																																																		(
																																																		((BgL_ev_exprz00_bglt) BgL_a1z00_3199), BgL_stkz00_196);
																																																	BgL_a2z00_3383
																																																		=
																																																		BGl_compz00zz__evaluate_compz00
																																																		(
																																																		((BgL_ev_exprz00_bglt) BgL_a2z00_3200), BgL_stkz00_196);
																																																	{	/* Eval/evaluate_comp.scm 1021 */
																																																		obj_t
																																																			BgL_zc3z04anonymousza32833ze3z87_13909;
																																																		BgL_zc3z04anonymousza32833ze3z87_13909
																																																			=
																																																			MAKE_FX_PROCEDURE
																																																			(BGl_z62zc3z04anonymousza32833ze3ze5zz__evaluate_compz00,
																																																			(int)
																																																			(((long) 1)), (int) (((long) 3)));
																																																		PROCEDURE_SET
																																																			(BgL_zc3z04anonymousza32833ze3z87_13909,
																																																			(int)
																																																			(((long) 0)), BgL_a1z00_3382);
																																																		PROCEDURE_SET
																																																			(BgL_zc3z04anonymousza32833ze3z87_13909,
																																																			(int)
																																																			(((long) 1)), BgL_a2z00_3383);
																																																		PROCEDURE_SET
																																																			(BgL_zc3z04anonymousza32833ze3z87_13909,
																																																			(int)
																																																			(((long) 2)), BgL_locz00_193);
																																																		return
																																																			BgL_zc3z04anonymousza32833ze3z87_13909;
																																																	}
																																																}
																																															else
																																																{	/* Eval/evaluate_comp.scm 1021 */
																																																	if ((BgL_valz00_3195 == BGl_zd2flzd2envz00zz__r4_numbers_6_5_flonumz00))
																																																		{	/* Eval/evaluate_comp.scm 1021 */
																																																			obj_t
																																																				BgL_a1z00_3392;
																																																			obj_t
																																																				BgL_a2z00_3393;
																																																			BgL_a1z00_3392
																																																				=
																																																				BGl_compz00zz__evaluate_compz00
																																																				(
																																																				((BgL_ev_exprz00_bglt) BgL_a1z00_3199), BgL_stkz00_196);
																																																			BgL_a2z00_3393
																																																				=
																																																				BGl_compz00zz__evaluate_compz00
																																																				(
																																																				((BgL_ev_exprz00_bglt) BgL_a2z00_3200), BgL_stkz00_196);
																																																			{	/* Eval/evaluate_comp.scm 1021 */
																																																				obj_t
																																																					BgL_zc3z04anonymousza32837ze3z87_13910;
																																																				BgL_zc3z04anonymousza32837ze3z87_13910
																																																					=
																																																					MAKE_FX_PROCEDURE
																																																					(BGl_z62zc3z04anonymousza32837ze3ze5zz__evaluate_compz00,
																																																					(int)
																																																					(((long) 1)), (int) (((long) 3)));
																																																				PROCEDURE_SET
																																																					(BgL_zc3z04anonymousza32837ze3z87_13910,
																																																					(int)
																																																					(((long) 0)), BgL_a1z00_3392);
																																																				PROCEDURE_SET
																																																					(BgL_zc3z04anonymousza32837ze3z87_13910,
																																																					(int)
																																																					(((long) 1)), BgL_a2z00_3393);
																																																				PROCEDURE_SET
																																																					(BgL_zc3z04anonymousza32837ze3z87_13910,
																																																					(int)
																																																					(((long) 2)), BgL_locz00_193);
																																																				return
																																																					BgL_zc3z04anonymousza32837ze3z87_13910;
																																																			}
																																																		}
																																																	else
																																																		{	/* Eval/evaluate_comp.scm 1021 */
																																																			if ((BgL_valz00_3195 == BGl_za2flzd2envz70zz__r4_numbers_6_5_flonumz00))
																																																				{	/* Eval/evaluate_comp.scm 1021 */
																																																					obj_t
																																																						BgL_a1z00_3402;
																																																					obj_t
																																																						BgL_a2z00_3403;
																																																					BgL_a1z00_3402
																																																						=
																																																						BGl_compz00zz__evaluate_compz00
																																																						(
																																																						((BgL_ev_exprz00_bglt) BgL_a1z00_3199), BgL_stkz00_196);
																																																					BgL_a2z00_3403
																																																						=
																																																						BGl_compz00zz__evaluate_compz00
																																																						(
																																																						((BgL_ev_exprz00_bglt) BgL_a2z00_3200), BgL_stkz00_196);
																																																					{	/* Eval/evaluate_comp.scm 1021 */
																																																						obj_t
																																																							BgL_zc3z04anonymousza32841ze3z87_13911;
																																																						BgL_zc3z04anonymousza32841ze3z87_13911
																																																							=
																																																							MAKE_FX_PROCEDURE
																																																							(BGl_z62zc3z04anonymousza32841ze3ze5zz__evaluate_compz00,
																																																							(int)
																																																							(((long) 1)), (int) (((long) 3)));
																																																						PROCEDURE_SET
																																																							(BgL_zc3z04anonymousza32841ze3z87_13911,
																																																							(int)
																																																							(((long) 0)), BgL_a1z00_3402);
																																																						PROCEDURE_SET
																																																							(BgL_zc3z04anonymousza32841ze3z87_13911,
																																																							(int)
																																																							(((long) 1)), BgL_a2z00_3403);
																																																						PROCEDURE_SET
																																																							(BgL_zc3z04anonymousza32841ze3z87_13911,
																																																							(int)
																																																							(((long) 2)), BgL_locz00_193);
																																																						return
																																																							BgL_zc3z04anonymousza32841ze3z87_13911;
																																																					}
																																																				}
																																																			else
																																																				{	/* Eval/evaluate_comp.scm 1021 */
																																																					if ((BgL_valz00_3195 == BGl_zf2flzd2envz20zz__r4_numbers_6_5_flonumz00))
																																																						{	/* Eval/evaluate_comp.scm 1021 */
																																																							obj_t
																																																								BgL_a1z00_3412;
																																																							obj_t
																																																								BgL_a2z00_3413;
																																																							BgL_a1z00_3412
																																																								=
																																																								BGl_compz00zz__evaluate_compz00
																																																								(
																																																								((BgL_ev_exprz00_bglt) BgL_a1z00_3199), BgL_stkz00_196);
																																																							BgL_a2z00_3413
																																																								=
																																																								BGl_compz00zz__evaluate_compz00
																																																								(
																																																								((BgL_ev_exprz00_bglt) BgL_a2z00_3200), BgL_stkz00_196);
																																																							{	/* Eval/evaluate_comp.scm 1021 */
																																																								obj_t
																																																									BgL_zc3z04anonymousza32845ze3z87_13912;
																																																								BgL_zc3z04anonymousza32845ze3z87_13912
																																																									=
																																																									MAKE_FX_PROCEDURE
																																																									(BGl_z62zc3z04anonymousza32845ze3ze5zz__evaluate_compz00,
																																																									(int)
																																																									(((long) 1)), (int) (((long) 3)));
																																																								PROCEDURE_SET
																																																									(BgL_zc3z04anonymousza32845ze3z87_13912,
																																																									(int)
																																																									(((long) 0)), BgL_a1z00_3412);
																																																								PROCEDURE_SET
																																																									(BgL_zc3z04anonymousza32845ze3z87_13912,
																																																									(int)
																																																									(((long) 1)), BgL_a2z00_3413);
																																																								PROCEDURE_SET
																																																									(BgL_zc3z04anonymousza32845ze3z87_13912,
																																																									(int)
																																																									(((long) 2)), BgL_locz00_193);
																																																								return
																																																									BgL_zc3z04anonymousza32845ze3z87_13912;
																																																							}
																																																						}
																																																					else
																																																						{	/* Eval/evaluate_comp.scm 1021 */
																																																							if ((BgL_valz00_3195 == BGl_zc3flzd2envz11zz__r4_numbers_6_5_flonumz00))
																																																								{	/* Eval/evaluate_comp.scm 1021 */
																																																									obj_t
																																																										BgL_a1z00_3422;
																																																									obj_t
																																																										BgL_a2z00_3423;
																																																									BgL_a1z00_3422
																																																										=
																																																										BGl_compz00zz__evaluate_compz00
																																																										(
																																																										((BgL_ev_exprz00_bglt) BgL_a1z00_3199), BgL_stkz00_196);
																																																									BgL_a2z00_3423
																																																										=
																																																										BGl_compz00zz__evaluate_compz00
																																																										(
																																																										((BgL_ev_exprz00_bglt) BgL_a2z00_3200), BgL_stkz00_196);
																																																									{	/* Eval/evaluate_comp.scm 1021 */
																																																										obj_t
																																																											BgL_zc3z04anonymousza32849ze3z87_13913;
																																																										BgL_zc3z04anonymousza32849ze3z87_13913
																																																											=
																																																											MAKE_FX_PROCEDURE
																																																											(BGl_z62zc3z04anonymousza32849ze3ze5zz__evaluate_compz00,
																																																											(int)
																																																											(((long) 1)), (int) (((long) 3)));
																																																										PROCEDURE_SET
																																																											(BgL_zc3z04anonymousza32849ze3z87_13913,
																																																											(int)
																																																											(((long) 0)), BgL_a1z00_3422);
																																																										PROCEDURE_SET
																																																											(BgL_zc3z04anonymousza32849ze3z87_13913,
																																																											(int)
																																																											(((long) 1)), BgL_a2z00_3423);
																																																										PROCEDURE_SET
																																																											(BgL_zc3z04anonymousza32849ze3z87_13913,
																																																											(int)
																																																											(((long) 2)), BgL_locz00_193);
																																																										return
																																																											BgL_zc3z04anonymousza32849ze3z87_13913;
																																																									}
																																																								}
																																																							else
																																																								{	/* Eval/evaluate_comp.scm 1021 */
																																																									if ((BgL_valz00_3195 == BGl_ze3flzd2envz31zz__r4_numbers_6_5_flonumz00))
																																																										{	/* Eval/evaluate_comp.scm 1021 */
																																																											obj_t
																																																												BgL_a1z00_3432;
																																																											obj_t
																																																												BgL_a2z00_3433;
																																																											BgL_a1z00_3432
																																																												=
																																																												BGl_compz00zz__evaluate_compz00
																																																												(
																																																												((BgL_ev_exprz00_bglt) BgL_a1z00_3199), BgL_stkz00_196);
																																																											BgL_a2z00_3433
																																																												=
																																																												BGl_compz00zz__evaluate_compz00
																																																												(
																																																												((BgL_ev_exprz00_bglt) BgL_a2z00_3200), BgL_stkz00_196);
																																																											{	/* Eval/evaluate_comp.scm 1021 */
																																																												obj_t
																																																													BgL_zc3z04anonymousza32853ze3z87_13914;
																																																												BgL_zc3z04anonymousza32853ze3z87_13914
																																																													=
																																																													MAKE_FX_PROCEDURE
																																																													(BGl_z62zc3z04anonymousza32853ze3ze5zz__evaluate_compz00,
																																																													(int)
																																																													(((long) 1)), (int) (((long) 3)));
																																																												PROCEDURE_SET
																																																													(BgL_zc3z04anonymousza32853ze3z87_13914,
																																																													(int)
																																																													(((long) 0)), BgL_a1z00_3432);
																																																												PROCEDURE_SET
																																																													(BgL_zc3z04anonymousza32853ze3z87_13914,
																																																													(int)
																																																													(((long) 1)), BgL_a2z00_3433);
																																																												PROCEDURE_SET
																																																													(BgL_zc3z04anonymousza32853ze3z87_13914,
																																																													(int)
																																																													(((long) 2)), BgL_locz00_193);
																																																												return
																																																													BgL_zc3z04anonymousza32853ze3z87_13914;
																																																											}
																																																										}
																																																									else
																																																										{	/* Eval/evaluate_comp.scm 1021 */
																																																											if ((BgL_valz00_3195 == BGl_zc3zd3flzd2envzc2zz__r4_numbers_6_5_flonumz00))
																																																												{	/* Eval/evaluate_comp.scm 1021 */
																																																													obj_t
																																																														BgL_a1z00_3442;
																																																													obj_t
																																																														BgL_a2z00_3443;
																																																													BgL_a1z00_3442
																																																														=
																																																														BGl_compz00zz__evaluate_compz00
																																																														(
																																																														((BgL_ev_exprz00_bglt) BgL_a1z00_3199), BgL_stkz00_196);
																																																													BgL_a2z00_3443
																																																														=
																																																														BGl_compz00zz__evaluate_compz00
																																																														(
																																																														((BgL_ev_exprz00_bglt) BgL_a2z00_3200), BgL_stkz00_196);
																																																													{	/* Eval/evaluate_comp.scm 1021 */
																																																														obj_t
																																																															BgL_zc3z04anonymousza32857ze3z87_13915;
																																																														BgL_zc3z04anonymousza32857ze3z87_13915
																																																															=
																																																															MAKE_FX_PROCEDURE
																																																															(BGl_z62zc3z04anonymousza32857ze3ze5zz__evaluate_compz00,
																																																															(int)
																																																															(((long) 1)), (int) (((long) 3)));
																																																														PROCEDURE_SET
																																																															(BgL_zc3z04anonymousza32857ze3z87_13915,
																																																															(int)
																																																															(((long) 0)), BgL_a1z00_3442);
																																																														PROCEDURE_SET
																																																															(BgL_zc3z04anonymousza32857ze3z87_13915,
																																																															(int)
																																																															(((long) 1)), BgL_a2z00_3443);
																																																														PROCEDURE_SET
																																																															(BgL_zc3z04anonymousza32857ze3z87_13915,
																																																															(int)
																																																															(((long) 2)), BgL_locz00_193);
																																																														return
																																																															BgL_zc3z04anonymousza32857ze3z87_13915;
																																																													}
																																																												}
																																																											else
																																																												{	/* Eval/evaluate_comp.scm 1021 */
																																																													if ((BgL_valz00_3195 == BGl_ze3zd3flzd2envze2zz__r4_numbers_6_5_flonumz00))
																																																														{	/* Eval/evaluate_comp.scm 1021 */
																																																															obj_t
																																																																BgL_a1z00_3452;
																																																															obj_t
																																																																BgL_a2z00_3453;
																																																															BgL_a1z00_3452
																																																																=
																																																																BGl_compz00zz__evaluate_compz00
																																																																(
																																																																((BgL_ev_exprz00_bglt) BgL_a1z00_3199), BgL_stkz00_196);
																																																															BgL_a2z00_3453
																																																																=
																																																																BGl_compz00zz__evaluate_compz00
																																																																(
																																																																((BgL_ev_exprz00_bglt) BgL_a2z00_3200), BgL_stkz00_196);
																																																															{	/* Eval/evaluate_comp.scm 1021 */
																																																																obj_t
																																																																	BgL_zc3z04anonymousza32861ze3z87_13916;
																																																																BgL_zc3z04anonymousza32861ze3z87_13916
																																																																	=
																																																																	MAKE_FX_PROCEDURE
																																																																	(BGl_z62zc3z04anonymousza32861ze3ze5zz__evaluate_compz00,
																																																																	(int)
																																																																	(((long) 1)), (int) (((long) 3)));
																																																																PROCEDURE_SET
																																																																	(BgL_zc3z04anonymousza32861ze3z87_13916,
																																																																	(int)
																																																																	(((long) 0)), BgL_a1z00_3452);
																																																																PROCEDURE_SET
																																																																	(BgL_zc3z04anonymousza32861ze3z87_13916,
																																																																	(int)
																																																																	(((long) 1)), BgL_a2z00_3453);
																																																																PROCEDURE_SET
																																																																	(BgL_zc3z04anonymousza32861ze3z87_13916,
																																																																	(int)
																																																																	(((long) 2)), BgL_locz00_193);
																																																																return
																																																																	BgL_zc3z04anonymousza32861ze3z87_13916;
																																																															}
																																																														}
																																																													else
																																																														{	/* Eval/evaluate_comp.scm 1021 */
																																																															if ((BgL_valz00_3195 == BGl_zd3flzd2envz01zz__r4_numbers_6_5_flonumz00))
																																																																{	/* Eval/evaluate_comp.scm 1021 */
																																																																	obj_t
																																																																		BgL_a1z00_3462;
																																																																	obj_t
																																																																		BgL_a2z00_3463;
																																																																	BgL_a1z00_3462
																																																																		=
																																																																		BGl_compz00zz__evaluate_compz00
																																																																		(
																																																																		((BgL_ev_exprz00_bglt) BgL_a1z00_3199), BgL_stkz00_196);
																																																																	BgL_a2z00_3463
																																																																		=
																																																																		BGl_compz00zz__evaluate_compz00
																																																																		(
																																																																		((BgL_ev_exprz00_bglt) BgL_a2z00_3200), BgL_stkz00_196);
																																																																	{	/* Eval/evaluate_comp.scm 1021 */
																																																																		obj_t
																																																																			BgL_zc3z04anonymousza32865ze3z87_13917;
																																																																		BgL_zc3z04anonymousza32865ze3z87_13917
																																																																			=
																																																																			MAKE_FX_PROCEDURE
																																																																			(BGl_z62zc3z04anonymousza32865ze3ze5zz__evaluate_compz00,
																																																																			(int)
																																																																			(((long) 1)), (int) (((long) 3)));
																																																																		PROCEDURE_SET
																																																																			(BgL_zc3z04anonymousza32865ze3z87_13917,
																																																																			(int)
																																																																			(((long) 0)), BgL_a1z00_3462);
																																																																		PROCEDURE_SET
																																																																			(BgL_zc3z04anonymousza32865ze3z87_13917,
																																																																			(int)
																																																																			(((long) 1)), BgL_a2z00_3463);
																																																																		PROCEDURE_SET
																																																																			(BgL_zc3z04anonymousza32865ze3z87_13917,
																																																																			(int)
																																																																			(((long) 2)), BgL_locz00_193);
																																																																		return
																																																																			BgL_zc3z04anonymousza32865ze3z87_13917;
																																																																	}
																																																																}
																																																															else
																																																																{	/* Eval/evaluate_comp.scm 1021 */
																																																																	if ((BgL_valz00_3195 == BGl_eqzf3zd2envz21zz__r4_equivalence_6_2z00))
																																																																		{	/* Eval/evaluate_comp.scm 1021 */
																																																																			obj_t
																																																																				BgL_a1z00_3472;
																																																																			obj_t
																																																																				BgL_a2z00_3473;
																																																																			BgL_a1z00_3472
																																																																				=
																																																																				BGl_compz00zz__evaluate_compz00
																																																																				(
																																																																				((BgL_ev_exprz00_bglt) BgL_a1z00_3199), BgL_stkz00_196);
																																																																			BgL_a2z00_3473
																																																																				=
																																																																				BGl_compz00zz__evaluate_compz00
																																																																				(
																																																																				((BgL_ev_exprz00_bglt) BgL_a2z00_3200), BgL_stkz00_196);
																																																																			{	/* Eval/evaluate_comp.scm 1021 */
																																																																				obj_t
																																																																					BgL_zc3z04anonymousza32869ze3z87_13918;
																																																																				BgL_zc3z04anonymousza32869ze3z87_13918
																																																																					=
																																																																					MAKE_FX_PROCEDURE
																																																																					(BGl_z62zc3z04anonymousza32869ze3ze5zz__evaluate_compz00,
																																																																					(int)
																																																																					(((long) 1)), (int) (((long) 2)));
																																																																				PROCEDURE_SET
																																																																					(BgL_zc3z04anonymousza32869ze3z87_13918,
																																																																					(int)
																																																																					(((long) 0)), BgL_a1z00_3472);
																																																																				PROCEDURE_SET
																																																																					(BgL_zc3z04anonymousza32869ze3z87_13918,
																																																																					(int)
																																																																					(((long) 1)), BgL_a2z00_3473);
																																																																				return
																																																																					BgL_zc3z04anonymousza32869ze3z87_13918;
																																																																			}
																																																																		}
																																																																	else
																																																																		{	/* Eval/evaluate_comp.scm 1021 */
																																																																			if ((BgL_valz00_3195 == BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00))
																																																																				{	/* Eval/evaluate_comp.scm 1021 */
																																																																					obj_t
																																																																						BgL_a1z00_3480;
																																																																					obj_t
																																																																						BgL_a2z00_3481;
																																																																					BgL_a1z00_3480
																																																																						=
																																																																						BGl_compz00zz__evaluate_compz00
																																																																						(
																																																																						((BgL_ev_exprz00_bglt) BgL_a1z00_3199), BgL_stkz00_196);
																																																																					BgL_a2z00_3481
																																																																						=
																																																																						BGl_compz00zz__evaluate_compz00
																																																																						(
																																																																						((BgL_ev_exprz00_bglt) BgL_a2z00_3200), BgL_stkz00_196);
																																																																					{	/* Eval/evaluate_comp.scm 1021 */
																																																																						obj_t
																																																																							BgL_zc3z04anonymousza32871ze3z87_13919;
																																																																						BgL_zc3z04anonymousza32871ze3z87_13919
																																																																							=
																																																																							MAKE_FX_PROCEDURE
																																																																							(BGl_z62zc3z04anonymousza32871ze3ze5zz__evaluate_compz00,
																																																																							(int)
																																																																							(((long) 1)), (int) (((long) 2)));
																																																																						PROCEDURE_SET
																																																																							(BgL_zc3z04anonymousza32871ze3z87_13919,
																																																																							(int)
																																																																							(((long) 0)), BgL_a1z00_3480);
																																																																						PROCEDURE_SET
																																																																							(BgL_zc3z04anonymousza32871ze3z87_13919,
																																																																							(int)
																																																																							(((long) 1)), BgL_a2z00_3481);
																																																																						return
																																																																							BgL_zc3z04anonymousza32871ze3z87_13919;
																																																																					}
																																																																				}
																																																																			else
																																																																				{	/* Eval/evaluate_comp.scm 1021 */
																																																																					return
																																																																						BFALSE;
																																																																				}
																																																																		}
																																																																}
																																																														}
																																																												}
																																																										}
																																																								}
																																																						}
																																																				}
																																																		}
																																																}
																																														}
																																												}
																																										}
																																								}
																																						}
																																				}
																																		}
																																}
																														}
																												}
																										}
																								}
																						}
																				}
																		}
																}
														}
												}
										}
									else
										{	/* Eval/evaluate_comp.scm 1019 */
											return BFALSE;
										}
								}
						}
					}
				else
					{	/* Eval/evaluate_comp.scm 1014 */
						return BFALSE;
					}
			}
		}

	}



/* &<@anonymous:2761> */
	obj_t BGl_z62zc3z04anonymousza32761ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_13923, obj_t BgL_sz00_13927)
	{
		{	/* Eval/evaluate_comp.scm 1021 */
			{	/* Eval/evaluate_comp.scm 1021 */
				obj_t BgL_a1z00_13924;
				obj_t BgL_a2z00_13925;
				obj_t BgL_locz00_13926;

				BgL_a1z00_13924 = PROCEDURE_REF(BgL_envz00_13923, (int) (((long) 0)));
				BgL_a2z00_13925 = PROCEDURE_REF(BgL_envz00_13923, (int) (((long) 1)));
				BgL_locz00_13926 = PROCEDURE_REF(BgL_envz00_13923, (int) (((long) 2)));
				{	/* Eval/evaluate_comp.scm 1021 */
					obj_t BgL_bpz00_16483;

					BgL_bpz00_16483 = VECTOR_REF(((obj_t) BgL_sz00_13927), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1021 */
						obj_t BgL_a1z00_16484;
						obj_t BgL_a2z00_16485;

						BgL_a1z00_16484 =
							PROCEDURE_ENTRY(BgL_a1z00_13924) (BgL_a1z00_13924, BgL_sz00_13927,
							BEOA);
						BgL_a2z00_16485 =
							PROCEDURE_ENTRY(BgL_a2z00_13925) (BgL_a2z00_13925, BgL_sz00_13927,
							BEOA);
						if (BGl_numberzf3zf3zz__r4_numbers_6_5z00(BgL_a1z00_16484))
							{	/* Eval/evaluate_comp.scm 1021 */
								BFALSE;
							}
						else
							{	/* Eval/evaluate_comp.scm 1021 */
								BGl_loczd2typezd2errorz00zz__evaluate_compz00
									(BGl_symbol5827z00zz__evaluate_compz00,
									BGl_symbol5829z00zz__evaluate_compz00, BgL_a1z00_16484,
									BgL_locz00_13926);
							}
						if (BGl_numberzf3zf3zz__r4_numbers_6_5z00(BgL_a2z00_16485))
							{	/* Eval/evaluate_comp.scm 1021 */
								BFALSE;
							}
						else
							{	/* Eval/evaluate_comp.scm 1021 */
								BGl_loczd2typezd2errorz00zz__evaluate_compz00
									(BGl_symbol5827z00zz__evaluate_compz00,
									BGl_symbol5829z00zz__evaluate_compz00, BgL_a2z00_16485,
									BgL_locz00_13926);
							}
						return
							BGl_2zb2zb2zz__r4_numbers_6_5z00(BgL_a1z00_16484,
							BgL_a2z00_16485);
					}
				}
			}
		}

	}



/* &<@anonymous:2765> */
	obj_t BGl_z62zc3z04anonymousza32765ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_13928, obj_t BgL_sz00_13932)
	{
		{	/* Eval/evaluate_comp.scm 1021 */
			{	/* Eval/evaluate_comp.scm 1021 */
				obj_t BgL_a1z00_13929;
				obj_t BgL_a2z00_13930;
				obj_t BgL_locz00_13931;

				BgL_a1z00_13929 = PROCEDURE_REF(BgL_envz00_13928, (int) (((long) 0)));
				BgL_a2z00_13930 = PROCEDURE_REF(BgL_envz00_13928, (int) (((long) 1)));
				BgL_locz00_13931 = PROCEDURE_REF(BgL_envz00_13928, (int) (((long) 2)));
				{	/* Eval/evaluate_comp.scm 1021 */
					obj_t BgL_bpz00_16486;

					BgL_bpz00_16486 = VECTOR_REF(((obj_t) BgL_sz00_13932), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1021 */
						obj_t BgL_a1z00_16487;
						obj_t BgL_a2z00_16488;

						BgL_a1z00_16487 =
							PROCEDURE_ENTRY(BgL_a1z00_13929) (BgL_a1z00_13929, BgL_sz00_13932,
							BEOA);
						BgL_a2z00_16488 =
							PROCEDURE_ENTRY(BgL_a2z00_13930) (BgL_a2z00_13930, BgL_sz00_13932,
							BEOA);
						if (BGl_numberzf3zf3zz__r4_numbers_6_5z00(BgL_a1z00_16487))
							{	/* Eval/evaluate_comp.scm 1021 */
								BFALSE;
							}
						else
							{	/* Eval/evaluate_comp.scm 1021 */
								BGl_loczd2typezd2errorz00zz__evaluate_compz00
									(BGl_symbol5831z00zz__evaluate_compz00,
									BGl_symbol5829z00zz__evaluate_compz00, BgL_a1z00_16487,
									BgL_locz00_13931);
							}
						if (BGl_numberzf3zf3zz__r4_numbers_6_5z00(BgL_a2z00_16488))
							{	/* Eval/evaluate_comp.scm 1021 */
								BFALSE;
							}
						else
							{	/* Eval/evaluate_comp.scm 1021 */
								BGl_loczd2typezd2errorz00zz__evaluate_compz00
									(BGl_symbol5831z00zz__evaluate_compz00,
									BGl_symbol5829z00zz__evaluate_compz00, BgL_a2z00_16488,
									BgL_locz00_13931);
							}
						return
							BGl_2zd2zd2zz__r4_numbers_6_5z00(BgL_a1z00_16487,
							BgL_a2z00_16488);
					}
				}
			}
		}

	}



/* &<@anonymous:2769> */
	obj_t BGl_z62zc3z04anonymousza32769ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_13933, obj_t BgL_sz00_13937)
	{
		{	/* Eval/evaluate_comp.scm 1021 */
			{	/* Eval/evaluate_comp.scm 1021 */
				obj_t BgL_a1z00_13934;
				obj_t BgL_a2z00_13935;
				obj_t BgL_locz00_13936;

				BgL_a1z00_13934 = PROCEDURE_REF(BgL_envz00_13933, (int) (((long) 0)));
				BgL_a2z00_13935 = PROCEDURE_REF(BgL_envz00_13933, (int) (((long) 1)));
				BgL_locz00_13936 = PROCEDURE_REF(BgL_envz00_13933, (int) (((long) 2)));
				{	/* Eval/evaluate_comp.scm 1021 */
					obj_t BgL_bpz00_16489;

					BgL_bpz00_16489 = VECTOR_REF(((obj_t) BgL_sz00_13937), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1021 */
						obj_t BgL_a1z00_16490;
						obj_t BgL_a2z00_16491;

						BgL_a1z00_16490 =
							PROCEDURE_ENTRY(BgL_a1z00_13934) (BgL_a1z00_13934, BgL_sz00_13937,
							BEOA);
						BgL_a2z00_16491 =
							PROCEDURE_ENTRY(BgL_a2z00_13935) (BgL_a2z00_13935, BgL_sz00_13937,
							BEOA);
						if (BGl_numberzf3zf3zz__r4_numbers_6_5z00(BgL_a1z00_16490))
							{	/* Eval/evaluate_comp.scm 1021 */
								BFALSE;
							}
						else
							{	/* Eval/evaluate_comp.scm 1021 */
								BGl_loczd2typezd2errorz00zz__evaluate_compz00
									(BGl_symbol5833z00zz__evaluate_compz00,
									BGl_symbol5829z00zz__evaluate_compz00, BgL_a1z00_16490,
									BgL_locz00_13936);
							}
						if (BGl_numberzf3zf3zz__r4_numbers_6_5z00(BgL_a2z00_16491))
							{	/* Eval/evaluate_comp.scm 1021 */
								BFALSE;
							}
						else
							{	/* Eval/evaluate_comp.scm 1021 */
								BGl_loczd2typezd2errorz00zz__evaluate_compz00
									(BGl_symbol5833z00zz__evaluate_compz00,
									BGl_symbol5829z00zz__evaluate_compz00, BgL_a2z00_16491,
									BgL_locz00_13936);
							}
						return
							BGl_2za2za2zz__r4_numbers_6_5z00(BgL_a1z00_16490,
							BgL_a2z00_16491);
					}
				}
			}
		}

	}



/* &<@anonymous:2773> */
	obj_t BGl_z62zc3z04anonymousza32773ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_13938, obj_t BgL_sz00_13942)
	{
		{	/* Eval/evaluate_comp.scm 1021 */
			{	/* Eval/evaluate_comp.scm 1021 */
				obj_t BgL_a1z00_13939;
				obj_t BgL_a2z00_13940;
				obj_t BgL_locz00_13941;

				BgL_a1z00_13939 = PROCEDURE_REF(BgL_envz00_13938, (int) (((long) 0)));
				BgL_a2z00_13940 = PROCEDURE_REF(BgL_envz00_13938, (int) (((long) 1)));
				BgL_locz00_13941 = PROCEDURE_REF(BgL_envz00_13938, (int) (((long) 2)));
				{	/* Eval/evaluate_comp.scm 1021 */
					obj_t BgL_bpz00_16492;

					BgL_bpz00_16492 = VECTOR_REF(((obj_t) BgL_sz00_13942), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1021 */
						obj_t BgL_a1z00_16493;
						obj_t BgL_a2z00_16494;

						BgL_a1z00_16493 =
							PROCEDURE_ENTRY(BgL_a1z00_13939) (BgL_a1z00_13939, BgL_sz00_13942,
							BEOA);
						BgL_a2z00_16494 =
							PROCEDURE_ENTRY(BgL_a2z00_13940) (BgL_a2z00_13940, BgL_sz00_13942,
							BEOA);
						if (BGl_numberzf3zf3zz__r4_numbers_6_5z00(BgL_a1z00_16493))
							{	/* Eval/evaluate_comp.scm 1021 */
								BFALSE;
							}
						else
							{	/* Eval/evaluate_comp.scm 1021 */
								BGl_loczd2typezd2errorz00zz__evaluate_compz00
									(BGl_symbol5835z00zz__evaluate_compz00,
									BGl_symbol5829z00zz__evaluate_compz00, BgL_a1z00_16493,
									BgL_locz00_13941);
							}
						if (BGl_numberzf3zf3zz__r4_numbers_6_5z00(BgL_a2z00_16494))
							{	/* Eval/evaluate_comp.scm 1021 */
								BFALSE;
							}
						else
							{	/* Eval/evaluate_comp.scm 1021 */
								BGl_loczd2typezd2errorz00zz__evaluate_compz00
									(BGl_symbol5835z00zz__evaluate_compz00,
									BGl_symbol5829z00zz__evaluate_compz00, BgL_a2z00_16494,
									BgL_locz00_13941);
							}
						return
							BGl_2zf2zf2zz__r4_numbers_6_5z00(BgL_a1z00_16493,
							BgL_a2z00_16494);
					}
				}
			}
		}

	}



/* &<@anonymous:2777> */
	obj_t BGl_z62zc3z04anonymousza32777ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_13943, obj_t BgL_sz00_13947)
	{
		{	/* Eval/evaluate_comp.scm 1021 */
			{	/* Eval/evaluate_comp.scm 1021 */
				obj_t BgL_a1z00_13944;
				obj_t BgL_a2z00_13945;
				obj_t BgL_locz00_13946;

				BgL_a1z00_13944 = PROCEDURE_REF(BgL_envz00_13943, (int) (((long) 0)));
				BgL_a2z00_13945 = PROCEDURE_REF(BgL_envz00_13943, (int) (((long) 1)));
				BgL_locz00_13946 = PROCEDURE_REF(BgL_envz00_13943, (int) (((long) 2)));
				{	/* Eval/evaluate_comp.scm 1021 */
					bool_t BgL_tmpz00_24644;

					{	/* Eval/evaluate_comp.scm 1021 */
						obj_t BgL_bpz00_16495;

						BgL_bpz00_16495 = VECTOR_REF(((obj_t) BgL_sz00_13947), ((long) 0));
						{	/* Eval/evaluate_comp.scm 1021 */
							obj_t BgL_a1z00_16496;
							obj_t BgL_a2z00_16497;

							BgL_a1z00_16496 =
								PROCEDURE_ENTRY(BgL_a1z00_13944) (BgL_a1z00_13944,
								BgL_sz00_13947, BEOA);
							BgL_a2z00_16497 =
								PROCEDURE_ENTRY(BgL_a2z00_13945) (BgL_a2z00_13945,
								BgL_sz00_13947, BEOA);
							if (BGl_numberzf3zf3zz__r4_numbers_6_5z00(BgL_a1z00_16496))
								{	/* Eval/evaluate_comp.scm 1021 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1021 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol5837z00zz__evaluate_compz00,
										BGl_symbol5829z00zz__evaluate_compz00, BgL_a1z00_16496,
										BgL_locz00_13946);
								}
							if (BGl_numberzf3zf3zz__r4_numbers_6_5z00(BgL_a2z00_16497))
								{	/* Eval/evaluate_comp.scm 1021 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1021 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol5837z00zz__evaluate_compz00,
										BGl_symbol5829z00zz__evaluate_compz00, BgL_a2z00_16497,
										BgL_locz00_13946);
								}
							BgL_tmpz00_24644 =
								BGl_2zc3zc3zz__r4_numbers_6_5z00(BgL_a1z00_16496,
								BgL_a2z00_16497);
						}
					}
					return BBOOL(BgL_tmpz00_24644);
				}
			}
		}

	}



/* &<@anonymous:2781> */
	obj_t BGl_z62zc3z04anonymousza32781ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_13948, obj_t BgL_sz00_13952)
	{
		{	/* Eval/evaluate_comp.scm 1021 */
			{	/* Eval/evaluate_comp.scm 1021 */
				obj_t BgL_a1z00_13949;
				obj_t BgL_a2z00_13950;
				obj_t BgL_locz00_13951;

				BgL_a1z00_13949 = PROCEDURE_REF(BgL_envz00_13948, (int) (((long) 0)));
				BgL_a2z00_13950 = PROCEDURE_REF(BgL_envz00_13948, (int) (((long) 1)));
				BgL_locz00_13951 = PROCEDURE_REF(BgL_envz00_13948, (int) (((long) 2)));
				{	/* Eval/evaluate_comp.scm 1021 */
					bool_t BgL_tmpz00_24669;

					{	/* Eval/evaluate_comp.scm 1021 */
						obj_t BgL_bpz00_16498;

						BgL_bpz00_16498 = VECTOR_REF(((obj_t) BgL_sz00_13952), ((long) 0));
						{	/* Eval/evaluate_comp.scm 1021 */
							obj_t BgL_a1z00_16499;
							obj_t BgL_a2z00_16500;

							BgL_a1z00_16499 =
								PROCEDURE_ENTRY(BgL_a1z00_13949) (BgL_a1z00_13949,
								BgL_sz00_13952, BEOA);
							BgL_a2z00_16500 =
								PROCEDURE_ENTRY(BgL_a2z00_13950) (BgL_a2z00_13950,
								BgL_sz00_13952, BEOA);
							if (BGl_numberzf3zf3zz__r4_numbers_6_5z00(BgL_a1z00_16499))
								{	/* Eval/evaluate_comp.scm 1021 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1021 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol5839z00zz__evaluate_compz00,
										BGl_symbol5829z00zz__evaluate_compz00, BgL_a1z00_16499,
										BgL_locz00_13951);
								}
							if (BGl_numberzf3zf3zz__r4_numbers_6_5z00(BgL_a2z00_16500))
								{	/* Eval/evaluate_comp.scm 1021 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1021 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol5839z00zz__evaluate_compz00,
										BGl_symbol5829z00zz__evaluate_compz00, BgL_a2z00_16500,
										BgL_locz00_13951);
								}
							BgL_tmpz00_24669 =
								BGl_2ze3ze3zz__r4_numbers_6_5z00(BgL_a1z00_16499,
								BgL_a2z00_16500);
						}
					}
					return BBOOL(BgL_tmpz00_24669);
				}
			}
		}

	}



/* &<@anonymous:2785> */
	obj_t BGl_z62zc3z04anonymousza32785ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_13953, obj_t BgL_sz00_13957)
	{
		{	/* Eval/evaluate_comp.scm 1021 */
			{	/* Eval/evaluate_comp.scm 1021 */
				obj_t BgL_a1z00_13954;
				obj_t BgL_a2z00_13955;
				obj_t BgL_locz00_13956;

				BgL_a1z00_13954 = PROCEDURE_REF(BgL_envz00_13953, (int) (((long) 0)));
				BgL_a2z00_13955 = PROCEDURE_REF(BgL_envz00_13953, (int) (((long) 1)));
				BgL_locz00_13956 = PROCEDURE_REF(BgL_envz00_13953, (int) (((long) 2)));
				{	/* Eval/evaluate_comp.scm 1021 */
					bool_t BgL_tmpz00_24694;

					{	/* Eval/evaluate_comp.scm 1021 */
						obj_t BgL_bpz00_16501;

						BgL_bpz00_16501 = VECTOR_REF(((obj_t) BgL_sz00_13957), ((long) 0));
						{	/* Eval/evaluate_comp.scm 1021 */
							obj_t BgL_a1z00_16502;
							obj_t BgL_a2z00_16503;

							BgL_a1z00_16502 =
								PROCEDURE_ENTRY(BgL_a1z00_13954) (BgL_a1z00_13954,
								BgL_sz00_13957, BEOA);
							BgL_a2z00_16503 =
								PROCEDURE_ENTRY(BgL_a2z00_13955) (BgL_a2z00_13955,
								BgL_sz00_13957, BEOA);
							if (BGl_numberzf3zf3zz__r4_numbers_6_5z00(BgL_a1z00_16502))
								{	/* Eval/evaluate_comp.scm 1021 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1021 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol5841z00zz__evaluate_compz00,
										BGl_symbol5829z00zz__evaluate_compz00, BgL_a1z00_16502,
										BgL_locz00_13956);
								}
							if (BGl_numberzf3zf3zz__r4_numbers_6_5z00(BgL_a2z00_16503))
								{	/* Eval/evaluate_comp.scm 1021 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1021 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol5841z00zz__evaluate_compz00,
										BGl_symbol5829z00zz__evaluate_compz00, BgL_a2z00_16503,
										BgL_locz00_13956);
								}
							BgL_tmpz00_24694 =
								BGl_2zc3zd3z10zz__r4_numbers_6_5z00(BgL_a1z00_16502,
								BgL_a2z00_16503);
						}
					}
					return BBOOL(BgL_tmpz00_24694);
				}
			}
		}

	}



/* &<@anonymous:2789> */
	obj_t BGl_z62zc3z04anonymousza32789ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_13958, obj_t BgL_sz00_13962)
	{
		{	/* Eval/evaluate_comp.scm 1021 */
			{	/* Eval/evaluate_comp.scm 1021 */
				obj_t BgL_a1z00_13959;
				obj_t BgL_a2z00_13960;
				obj_t BgL_locz00_13961;

				BgL_a1z00_13959 = PROCEDURE_REF(BgL_envz00_13958, (int) (((long) 0)));
				BgL_a2z00_13960 = PROCEDURE_REF(BgL_envz00_13958, (int) (((long) 1)));
				BgL_locz00_13961 = PROCEDURE_REF(BgL_envz00_13958, (int) (((long) 2)));
				{	/* Eval/evaluate_comp.scm 1021 */
					bool_t BgL_tmpz00_24719;

					{	/* Eval/evaluate_comp.scm 1021 */
						obj_t BgL_bpz00_16504;

						BgL_bpz00_16504 = VECTOR_REF(((obj_t) BgL_sz00_13962), ((long) 0));
						{	/* Eval/evaluate_comp.scm 1021 */
							obj_t BgL_a1z00_16505;
							obj_t BgL_a2z00_16506;

							BgL_a1z00_16505 =
								PROCEDURE_ENTRY(BgL_a1z00_13959) (BgL_a1z00_13959,
								BgL_sz00_13962, BEOA);
							BgL_a2z00_16506 =
								PROCEDURE_ENTRY(BgL_a2z00_13960) (BgL_a2z00_13960,
								BgL_sz00_13962, BEOA);
							if (BGl_numberzf3zf3zz__r4_numbers_6_5z00(BgL_a1z00_16505))
								{	/* Eval/evaluate_comp.scm 1021 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1021 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol5843z00zz__evaluate_compz00,
										BGl_symbol5829z00zz__evaluate_compz00, BgL_a1z00_16505,
										BgL_locz00_13961);
								}
							if (BGl_numberzf3zf3zz__r4_numbers_6_5z00(BgL_a2z00_16506))
								{	/* Eval/evaluate_comp.scm 1021 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1021 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol5843z00zz__evaluate_compz00,
										BGl_symbol5829z00zz__evaluate_compz00, BgL_a2z00_16506,
										BgL_locz00_13961);
								}
							BgL_tmpz00_24719 =
								BGl_2ze3zd3z30zz__r4_numbers_6_5z00(BgL_a1z00_16505,
								BgL_a2z00_16506);
						}
					}
					return BBOOL(BgL_tmpz00_24719);
				}
			}
		}

	}



/* &<@anonymous:2793> */
	obj_t BGl_z62zc3z04anonymousza32793ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_13963, obj_t BgL_sz00_13967)
	{
		{	/* Eval/evaluate_comp.scm 1021 */
			{	/* Eval/evaluate_comp.scm 1021 */
				obj_t BgL_a1z00_13964;
				obj_t BgL_a2z00_13965;
				obj_t BgL_locz00_13966;

				BgL_a1z00_13964 = PROCEDURE_REF(BgL_envz00_13963, (int) (((long) 0)));
				BgL_a2z00_13965 = PROCEDURE_REF(BgL_envz00_13963, (int) (((long) 1)));
				BgL_locz00_13966 = PROCEDURE_REF(BgL_envz00_13963, (int) (((long) 2)));
				{	/* Eval/evaluate_comp.scm 1021 */
					bool_t BgL_tmpz00_24744;

					{	/* Eval/evaluate_comp.scm 1021 */
						obj_t BgL_bpz00_16507;

						BgL_bpz00_16507 = VECTOR_REF(((obj_t) BgL_sz00_13967), ((long) 0));
						{	/* Eval/evaluate_comp.scm 1021 */
							obj_t BgL_a1z00_16508;
							obj_t BgL_a2z00_16509;

							BgL_a1z00_16508 =
								PROCEDURE_ENTRY(BgL_a1z00_13964) (BgL_a1z00_13964,
								BgL_sz00_13967, BEOA);
							BgL_a2z00_16509 =
								PROCEDURE_ENTRY(BgL_a2z00_13965) (BgL_a2z00_13965,
								BgL_sz00_13967, BEOA);
							if (BGl_numberzf3zf3zz__r4_numbers_6_5z00(BgL_a1z00_16508))
								{	/* Eval/evaluate_comp.scm 1021 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1021 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol5845z00zz__evaluate_compz00,
										BGl_symbol5829z00zz__evaluate_compz00, BgL_a1z00_16508,
										BgL_locz00_13966);
								}
							if (BGl_numberzf3zf3zz__r4_numbers_6_5z00(BgL_a2z00_16509))
								{	/* Eval/evaluate_comp.scm 1021 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1021 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol5845z00zz__evaluate_compz00,
										BGl_symbol5829z00zz__evaluate_compz00, BgL_a2z00_16509,
										BgL_locz00_13966);
								}
							BgL_tmpz00_24744 =
								BGl_2zd3zd3zz__r4_numbers_6_5z00(BgL_a1z00_16508,
								BgL_a2z00_16509);
						}
					}
					return BBOOL(BgL_tmpz00_24744);
				}
			}
		}

	}



/* &<@anonymous:2797> */
	obj_t BGl_z62zc3z04anonymousza32797ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_13968, obj_t BgL_sz00_13972)
	{
		{	/* Eval/evaluate_comp.scm 1021 */
			{	/* Eval/evaluate_comp.scm 1021 */
				obj_t BgL_a1z00_13969;
				obj_t BgL_a2z00_13970;
				obj_t BgL_locz00_13971;

				BgL_a1z00_13969 = PROCEDURE_REF(BgL_envz00_13968, (int) (((long) 0)));
				BgL_a2z00_13970 = PROCEDURE_REF(BgL_envz00_13968, (int) (((long) 1)));
				BgL_locz00_13971 = PROCEDURE_REF(BgL_envz00_13968, (int) (((long) 2)));
				{	/* Eval/evaluate_comp.scm 1021 */
					long BgL_tmpz00_24769;

					{	/* Eval/evaluate_comp.scm 1021 */
						obj_t BgL_bpz00_16510;

						BgL_bpz00_16510 = VECTOR_REF(((obj_t) BgL_sz00_13972), ((long) 0));
						{	/* Eval/evaluate_comp.scm 1021 */
							obj_t BgL_a1z00_16511;
							obj_t BgL_a2z00_16512;

							BgL_a1z00_16511 =
								PROCEDURE_ENTRY(BgL_a1z00_13969) (BgL_a1z00_13969,
								BgL_sz00_13972, BEOA);
							BgL_a2z00_16512 =
								PROCEDURE_ENTRY(BgL_a2z00_13970) (BgL_a2z00_13970,
								BgL_sz00_13972, BEOA);
							if (INTEGERP(BgL_a1z00_16511))
								{	/* Eval/evaluate_comp.scm 1021 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1021 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol5847z00zz__evaluate_compz00,
										BGl_symbol5849z00zz__evaluate_compz00, BgL_a1z00_16511,
										BgL_locz00_13971);
								}
							if (INTEGERP(BgL_a2z00_16512))
								{	/* Eval/evaluate_comp.scm 1021 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1021 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol5847z00zz__evaluate_compz00,
										BGl_symbol5849z00zz__evaluate_compz00, BgL_a2z00_16512,
										BgL_locz00_13971);
								}
							BgL_tmpz00_24769 =
								((long) CINT(BgL_a1z00_16511) + (long) CINT(BgL_a2z00_16512));
					}}
					return BINT(BgL_tmpz00_24769);
				}
			}
		}

	}



/* &<@anonymous:2801> */
	obj_t BGl_z62zc3z04anonymousza32801ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_13973, obj_t BgL_sz00_13977)
	{
		{	/* Eval/evaluate_comp.scm 1021 */
			{	/* Eval/evaluate_comp.scm 1021 */
				obj_t BgL_a1z00_13974;
				obj_t BgL_a2z00_13975;
				obj_t BgL_locz00_13976;

				BgL_a1z00_13974 = PROCEDURE_REF(BgL_envz00_13973, (int) (((long) 0)));
				BgL_a2z00_13975 = PROCEDURE_REF(BgL_envz00_13973, (int) (((long) 1)));
				BgL_locz00_13976 = PROCEDURE_REF(BgL_envz00_13973, (int) (((long) 2)));
				{	/* Eval/evaluate_comp.scm 1021 */
					long BgL_tmpz00_24796;

					{	/* Eval/evaluate_comp.scm 1021 */
						obj_t BgL_bpz00_16513;

						BgL_bpz00_16513 = VECTOR_REF(((obj_t) BgL_sz00_13977), ((long) 0));
						{	/* Eval/evaluate_comp.scm 1021 */
							obj_t BgL_a1z00_16514;
							obj_t BgL_a2z00_16515;

							BgL_a1z00_16514 =
								PROCEDURE_ENTRY(BgL_a1z00_13974) (BgL_a1z00_13974,
								BgL_sz00_13977, BEOA);
							BgL_a2z00_16515 =
								PROCEDURE_ENTRY(BgL_a2z00_13975) (BgL_a2z00_13975,
								BgL_sz00_13977, BEOA);
							if (INTEGERP(BgL_a1z00_16514))
								{	/* Eval/evaluate_comp.scm 1021 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1021 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol5851z00zz__evaluate_compz00,
										BGl_symbol5849z00zz__evaluate_compz00, BgL_a1z00_16514,
										BgL_locz00_13976);
								}
							if (INTEGERP(BgL_a2z00_16515))
								{	/* Eval/evaluate_comp.scm 1021 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1021 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol5851z00zz__evaluate_compz00,
										BGl_symbol5849z00zz__evaluate_compz00, BgL_a2z00_16515,
										BgL_locz00_13976);
								}
							BgL_tmpz00_24796 =
								((long) CINT(BgL_a1z00_16514) - (long) CINT(BgL_a2z00_16515));
					}}
					return BINT(BgL_tmpz00_24796);
				}
			}
		}

	}



/* &<@anonymous:2805> */
	obj_t BGl_z62zc3z04anonymousza32805ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_13978, obj_t BgL_sz00_13982)
	{
		{	/* Eval/evaluate_comp.scm 1021 */
			{	/* Eval/evaluate_comp.scm 1021 */
				obj_t BgL_a1z00_13979;
				obj_t BgL_a2z00_13980;
				obj_t BgL_locz00_13981;

				BgL_a1z00_13979 = PROCEDURE_REF(BgL_envz00_13978, (int) (((long) 0)));
				BgL_a2z00_13980 = PROCEDURE_REF(BgL_envz00_13978, (int) (((long) 1)));
				BgL_locz00_13981 = PROCEDURE_REF(BgL_envz00_13978, (int) (((long) 2)));
				{	/* Eval/evaluate_comp.scm 1021 */
					long BgL_tmpz00_24823;

					{	/* Eval/evaluate_comp.scm 1021 */
						obj_t BgL_bpz00_16516;

						BgL_bpz00_16516 = VECTOR_REF(((obj_t) BgL_sz00_13982), ((long) 0));
						{	/* Eval/evaluate_comp.scm 1021 */
							obj_t BgL_a1z00_16517;
							obj_t BgL_a2z00_16518;

							BgL_a1z00_16517 =
								PROCEDURE_ENTRY(BgL_a1z00_13979) (BgL_a1z00_13979,
								BgL_sz00_13982, BEOA);
							BgL_a2z00_16518 =
								PROCEDURE_ENTRY(BgL_a2z00_13980) (BgL_a2z00_13980,
								BgL_sz00_13982, BEOA);
							if (INTEGERP(BgL_a1z00_16517))
								{	/* Eval/evaluate_comp.scm 1021 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1021 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol5853z00zz__evaluate_compz00,
										BGl_symbol5849z00zz__evaluate_compz00, BgL_a1z00_16517,
										BgL_locz00_13981);
								}
							if (INTEGERP(BgL_a2z00_16518))
								{	/* Eval/evaluate_comp.scm 1021 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1021 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol5853z00zz__evaluate_compz00,
										BGl_symbol5849z00zz__evaluate_compz00, BgL_a2z00_16518,
										BgL_locz00_13981);
								}
							BgL_tmpz00_24823 =
								((long) CINT(BgL_a1z00_16517) * (long) CINT(BgL_a2z00_16518));
					}}
					return BINT(BgL_tmpz00_24823);
				}
			}
		}

	}



/* &<@anonymous:2809> */
	obj_t BGl_z62zc3z04anonymousza32809ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_13983, obj_t BgL_sz00_13987)
	{
		{	/* Eval/evaluate_comp.scm 1021 */
			{	/* Eval/evaluate_comp.scm 1021 */
				obj_t BgL_a1z00_13984;
				obj_t BgL_a2z00_13985;
				obj_t BgL_locz00_13986;

				BgL_a1z00_13984 = PROCEDURE_REF(BgL_envz00_13983, (int) (((long) 0)));
				BgL_a2z00_13985 = PROCEDURE_REF(BgL_envz00_13983, (int) (((long) 1)));
				BgL_locz00_13986 = PROCEDURE_REF(BgL_envz00_13983, (int) (((long) 2)));
				{	/* Eval/evaluate_comp.scm 1021 */
					long BgL_tmpz00_24850;

					{	/* Eval/evaluate_comp.scm 1021 */
						obj_t BgL_bpz00_16519;

						BgL_bpz00_16519 = VECTOR_REF(((obj_t) BgL_sz00_13987), ((long) 0));
						{	/* Eval/evaluate_comp.scm 1021 */
							obj_t BgL_a1z00_16520;
							obj_t BgL_a2z00_16521;

							BgL_a1z00_16520 =
								PROCEDURE_ENTRY(BgL_a1z00_13984) (BgL_a1z00_13984,
								BgL_sz00_13987, BEOA);
							BgL_a2z00_16521 =
								PROCEDURE_ENTRY(BgL_a2z00_13985) (BgL_a2z00_13985,
								BgL_sz00_13987, BEOA);
							if (INTEGERP(BgL_a1z00_16520))
								{	/* Eval/evaluate_comp.scm 1021 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1021 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol5855z00zz__evaluate_compz00,
										BGl_symbol5849z00zz__evaluate_compz00, BgL_a1z00_16520,
										BgL_locz00_13986);
								}
							if (INTEGERP(BgL_a2z00_16521))
								{	/* Eval/evaluate_comp.scm 1021 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1021 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol5855z00zz__evaluate_compz00,
										BGl_symbol5849z00zz__evaluate_compz00, BgL_a2z00_16521,
										BgL_locz00_13986);
								}
							BgL_tmpz00_24850 =
								((long) CINT(BgL_a1z00_16520) / (long) CINT(BgL_a2z00_16521));
					}}
					return BINT(BgL_tmpz00_24850);
				}
			}
		}

	}



/* &<@anonymous:2813> */
	obj_t BGl_z62zc3z04anonymousza32813ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_13988, obj_t BgL_sz00_13992)
	{
		{	/* Eval/evaluate_comp.scm 1021 */
			{	/* Eval/evaluate_comp.scm 1021 */
				obj_t BgL_a1z00_13989;
				obj_t BgL_a2z00_13990;
				obj_t BgL_locz00_13991;

				BgL_a1z00_13989 = PROCEDURE_REF(BgL_envz00_13988, (int) (((long) 0)));
				BgL_a2z00_13990 = PROCEDURE_REF(BgL_envz00_13988, (int) (((long) 1)));
				BgL_locz00_13991 = PROCEDURE_REF(BgL_envz00_13988, (int) (((long) 2)));
				{	/* Eval/evaluate_comp.scm 1021 */
					bool_t BgL_tmpz00_24877;

					{	/* Eval/evaluate_comp.scm 1021 */
						obj_t BgL_bpz00_16522;

						BgL_bpz00_16522 = VECTOR_REF(((obj_t) BgL_sz00_13992), ((long) 0));
						{	/* Eval/evaluate_comp.scm 1021 */
							obj_t BgL_a1z00_16523;
							obj_t BgL_a2z00_16524;

							BgL_a1z00_16523 =
								PROCEDURE_ENTRY(BgL_a1z00_13989) (BgL_a1z00_13989,
								BgL_sz00_13992, BEOA);
							BgL_a2z00_16524 =
								PROCEDURE_ENTRY(BgL_a2z00_13990) (BgL_a2z00_13990,
								BgL_sz00_13992, BEOA);
							if (INTEGERP(BgL_a1z00_16523))
								{	/* Eval/evaluate_comp.scm 1021 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1021 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol5857z00zz__evaluate_compz00,
										BGl_symbol5849z00zz__evaluate_compz00, BgL_a1z00_16523,
										BgL_locz00_13991);
								}
							if (INTEGERP(BgL_a2z00_16524))
								{	/* Eval/evaluate_comp.scm 1021 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1021 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol5857z00zz__evaluate_compz00,
										BGl_symbol5849z00zz__evaluate_compz00, BgL_a2z00_16524,
										BgL_locz00_13991);
								}
							BgL_tmpz00_24877 =
								((long) CINT(BgL_a1z00_16523) < (long) CINT(BgL_a2z00_16524));
					}}
					return BBOOL(BgL_tmpz00_24877);
				}
			}
		}

	}



/* &<@anonymous:2817> */
	obj_t BGl_z62zc3z04anonymousza32817ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_13993, obj_t BgL_sz00_13997)
	{
		{	/* Eval/evaluate_comp.scm 1021 */
			{	/* Eval/evaluate_comp.scm 1021 */
				obj_t BgL_a1z00_13994;
				obj_t BgL_a2z00_13995;
				obj_t BgL_locz00_13996;

				BgL_a1z00_13994 = PROCEDURE_REF(BgL_envz00_13993, (int) (((long) 0)));
				BgL_a2z00_13995 = PROCEDURE_REF(BgL_envz00_13993, (int) (((long) 1)));
				BgL_locz00_13996 = PROCEDURE_REF(BgL_envz00_13993, (int) (((long) 2)));
				{	/* Eval/evaluate_comp.scm 1021 */
					bool_t BgL_tmpz00_24904;

					{	/* Eval/evaluate_comp.scm 1021 */
						obj_t BgL_bpz00_16525;

						BgL_bpz00_16525 = VECTOR_REF(((obj_t) BgL_sz00_13997), ((long) 0));
						{	/* Eval/evaluate_comp.scm 1021 */
							obj_t BgL_a1z00_16526;
							obj_t BgL_a2z00_16527;

							BgL_a1z00_16526 =
								PROCEDURE_ENTRY(BgL_a1z00_13994) (BgL_a1z00_13994,
								BgL_sz00_13997, BEOA);
							BgL_a2z00_16527 =
								PROCEDURE_ENTRY(BgL_a2z00_13995) (BgL_a2z00_13995,
								BgL_sz00_13997, BEOA);
							if (INTEGERP(BgL_a1z00_16526))
								{	/* Eval/evaluate_comp.scm 1021 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1021 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol5859z00zz__evaluate_compz00,
										BGl_symbol5849z00zz__evaluate_compz00, BgL_a1z00_16526,
										BgL_locz00_13996);
								}
							if (INTEGERP(BgL_a2z00_16527))
								{	/* Eval/evaluate_comp.scm 1021 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1021 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol5859z00zz__evaluate_compz00,
										BGl_symbol5849z00zz__evaluate_compz00, BgL_a2z00_16527,
										BgL_locz00_13996);
								}
							BgL_tmpz00_24904 =
								((long) CINT(BgL_a1z00_16526) > (long) CINT(BgL_a2z00_16527));
					}}
					return BBOOL(BgL_tmpz00_24904);
				}
			}
		}

	}



/* &<@anonymous:2821> */
	obj_t BGl_z62zc3z04anonymousza32821ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_13998, obj_t BgL_sz00_14002)
	{
		{	/* Eval/evaluate_comp.scm 1021 */
			{	/* Eval/evaluate_comp.scm 1021 */
				obj_t BgL_a1z00_13999;
				obj_t BgL_a2z00_14000;
				obj_t BgL_locz00_14001;

				BgL_a1z00_13999 = PROCEDURE_REF(BgL_envz00_13998, (int) (((long) 0)));
				BgL_a2z00_14000 = PROCEDURE_REF(BgL_envz00_13998, (int) (((long) 1)));
				BgL_locz00_14001 = PROCEDURE_REF(BgL_envz00_13998, (int) (((long) 2)));
				{	/* Eval/evaluate_comp.scm 1021 */
					bool_t BgL_tmpz00_24931;

					{	/* Eval/evaluate_comp.scm 1021 */
						obj_t BgL_bpz00_16528;

						BgL_bpz00_16528 = VECTOR_REF(((obj_t) BgL_sz00_14002), ((long) 0));
						{	/* Eval/evaluate_comp.scm 1021 */
							obj_t BgL_a1z00_16529;
							obj_t BgL_a2z00_16530;

							BgL_a1z00_16529 =
								PROCEDURE_ENTRY(BgL_a1z00_13999) (BgL_a1z00_13999,
								BgL_sz00_14002, BEOA);
							BgL_a2z00_16530 =
								PROCEDURE_ENTRY(BgL_a2z00_14000) (BgL_a2z00_14000,
								BgL_sz00_14002, BEOA);
							if (INTEGERP(BgL_a1z00_16529))
								{	/* Eval/evaluate_comp.scm 1021 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1021 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol5861z00zz__evaluate_compz00,
										BGl_symbol5849z00zz__evaluate_compz00, BgL_a1z00_16529,
										BgL_locz00_14001);
								}
							if (INTEGERP(BgL_a2z00_16530))
								{	/* Eval/evaluate_comp.scm 1021 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1021 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol5861z00zz__evaluate_compz00,
										BGl_symbol5849z00zz__evaluate_compz00, BgL_a2z00_16530,
										BgL_locz00_14001);
								}
							BgL_tmpz00_24931 =
								((long) CINT(BgL_a1z00_16529) <= (long) CINT(BgL_a2z00_16530));
					}}
					return BBOOL(BgL_tmpz00_24931);
				}
			}
		}

	}



/* &<@anonymous:2825> */
	obj_t BGl_z62zc3z04anonymousza32825ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_14003, obj_t BgL_sz00_14007)
	{
		{	/* Eval/evaluate_comp.scm 1021 */
			{	/* Eval/evaluate_comp.scm 1021 */
				obj_t BgL_a1z00_14004;
				obj_t BgL_a2z00_14005;
				obj_t BgL_locz00_14006;

				BgL_a1z00_14004 = PROCEDURE_REF(BgL_envz00_14003, (int) (((long) 0)));
				BgL_a2z00_14005 = PROCEDURE_REF(BgL_envz00_14003, (int) (((long) 1)));
				BgL_locz00_14006 = PROCEDURE_REF(BgL_envz00_14003, (int) (((long) 2)));
				{	/* Eval/evaluate_comp.scm 1021 */
					bool_t BgL_tmpz00_24958;

					{	/* Eval/evaluate_comp.scm 1021 */
						obj_t BgL_bpz00_16531;

						BgL_bpz00_16531 = VECTOR_REF(((obj_t) BgL_sz00_14007), ((long) 0));
						{	/* Eval/evaluate_comp.scm 1021 */
							obj_t BgL_a1z00_16532;
							obj_t BgL_a2z00_16533;

							BgL_a1z00_16532 =
								PROCEDURE_ENTRY(BgL_a1z00_14004) (BgL_a1z00_14004,
								BgL_sz00_14007, BEOA);
							BgL_a2z00_16533 =
								PROCEDURE_ENTRY(BgL_a2z00_14005) (BgL_a2z00_14005,
								BgL_sz00_14007, BEOA);
							if (INTEGERP(BgL_a1z00_16532))
								{	/* Eval/evaluate_comp.scm 1021 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1021 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol5863z00zz__evaluate_compz00,
										BGl_symbol5849z00zz__evaluate_compz00, BgL_a1z00_16532,
										BgL_locz00_14006);
								}
							if (INTEGERP(BgL_a2z00_16533))
								{	/* Eval/evaluate_comp.scm 1021 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1021 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol5863z00zz__evaluate_compz00,
										BGl_symbol5849z00zz__evaluate_compz00, BgL_a2z00_16533,
										BgL_locz00_14006);
								}
							BgL_tmpz00_24958 =
								((long) CINT(BgL_a1z00_16532) >= (long) CINT(BgL_a2z00_16533));
					}}
					return BBOOL(BgL_tmpz00_24958);
				}
			}
		}

	}



/* &<@anonymous:2829> */
	obj_t BGl_z62zc3z04anonymousza32829ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_14008, obj_t BgL_sz00_14012)
	{
		{	/* Eval/evaluate_comp.scm 1021 */
			{	/* Eval/evaluate_comp.scm 1021 */
				obj_t BgL_a1z00_14009;
				obj_t BgL_a2z00_14010;
				obj_t BgL_locz00_14011;

				BgL_a1z00_14009 = PROCEDURE_REF(BgL_envz00_14008, (int) (((long) 0)));
				BgL_a2z00_14010 = PROCEDURE_REF(BgL_envz00_14008, (int) (((long) 1)));
				BgL_locz00_14011 = PROCEDURE_REF(BgL_envz00_14008, (int) (((long) 2)));
				{	/* Eval/evaluate_comp.scm 1021 */
					bool_t BgL_tmpz00_24985;

					{	/* Eval/evaluate_comp.scm 1021 */
						obj_t BgL_bpz00_16534;

						BgL_bpz00_16534 = VECTOR_REF(((obj_t) BgL_sz00_14012), ((long) 0));
						{	/* Eval/evaluate_comp.scm 1021 */
							obj_t BgL_a1z00_16535;
							obj_t BgL_a2z00_16536;

							BgL_a1z00_16535 =
								PROCEDURE_ENTRY(BgL_a1z00_14009) (BgL_a1z00_14009,
								BgL_sz00_14012, BEOA);
							BgL_a2z00_16536 =
								PROCEDURE_ENTRY(BgL_a2z00_14010) (BgL_a2z00_14010,
								BgL_sz00_14012, BEOA);
							if (INTEGERP(BgL_a1z00_16535))
								{	/* Eval/evaluate_comp.scm 1021 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1021 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol5865z00zz__evaluate_compz00,
										BGl_symbol5849z00zz__evaluate_compz00, BgL_a1z00_16535,
										BgL_locz00_14011);
								}
							if (INTEGERP(BgL_a2z00_16536))
								{	/* Eval/evaluate_comp.scm 1021 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1021 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol5865z00zz__evaluate_compz00,
										BGl_symbol5849z00zz__evaluate_compz00, BgL_a2z00_16536,
										BgL_locz00_14011);
								}
							BgL_tmpz00_24985 =
								((long) CINT(BgL_a1z00_16535) == (long) CINT(BgL_a2z00_16536));
					}}
					return BBOOL(BgL_tmpz00_24985);
				}
			}
		}

	}



/* &<@anonymous:2833> */
	obj_t BGl_z62zc3z04anonymousza32833ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_14013, obj_t BgL_sz00_14017)
	{
		{	/* Eval/evaluate_comp.scm 1021 */
			{	/* Eval/evaluate_comp.scm 1021 */
				obj_t BgL_a1z00_14014;
				obj_t BgL_a2z00_14015;
				obj_t BgL_locz00_14016;

				BgL_a1z00_14014 = PROCEDURE_REF(BgL_envz00_14013, (int) (((long) 0)));
				BgL_a2z00_14015 = PROCEDURE_REF(BgL_envz00_14013, (int) (((long) 1)));
				BgL_locz00_14016 = PROCEDURE_REF(BgL_envz00_14013, (int) (((long) 2)));
				{	/* Eval/evaluate_comp.scm 1021 */
					double BgL_tmpz00_25012;

					{	/* Eval/evaluate_comp.scm 1021 */
						obj_t BgL_bpz00_16537;

						BgL_bpz00_16537 = VECTOR_REF(((obj_t) BgL_sz00_14017), ((long) 0));
						{	/* Eval/evaluate_comp.scm 1021 */
							obj_t BgL_a1z00_16538;
							obj_t BgL_a2z00_16539;

							BgL_a1z00_16538 =
								PROCEDURE_ENTRY(BgL_a1z00_14014) (BgL_a1z00_14014,
								BgL_sz00_14017, BEOA);
							BgL_a2z00_16539 =
								PROCEDURE_ENTRY(BgL_a2z00_14015) (BgL_a2z00_14015,
								BgL_sz00_14017, BEOA);
							if (REALP(BgL_a1z00_16538))
								{	/* Eval/evaluate_comp.scm 1021 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1021 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol5867z00zz__evaluate_compz00,
										BGl_symbol5869z00zz__evaluate_compz00, BgL_a1z00_16538,
										BgL_locz00_14016);
								}
							if (REALP(BgL_a2z00_16539))
								{	/* Eval/evaluate_comp.scm 1021 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1021 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol5867z00zz__evaluate_compz00,
										BGl_symbol5869z00zz__evaluate_compz00, BgL_a2z00_16539,
										BgL_locz00_14016);
								}
							BgL_tmpz00_25012 =
								(REAL_TO_DOUBLE(BgL_a1z00_16538) +
								REAL_TO_DOUBLE(BgL_a2z00_16539));
						}
					}
					return DOUBLE_TO_REAL(BgL_tmpz00_25012);
				}
			}
		}

	}



/* &<@anonymous:2837> */
	obj_t BGl_z62zc3z04anonymousza32837ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_14018, obj_t BgL_sz00_14022)
	{
		{	/* Eval/evaluate_comp.scm 1021 */
			{	/* Eval/evaluate_comp.scm 1021 */
				obj_t BgL_a1z00_14019;
				obj_t BgL_a2z00_14020;
				obj_t BgL_locz00_14021;

				BgL_a1z00_14019 = PROCEDURE_REF(BgL_envz00_14018, (int) (((long) 0)));
				BgL_a2z00_14020 = PROCEDURE_REF(BgL_envz00_14018, (int) (((long) 1)));
				BgL_locz00_14021 = PROCEDURE_REF(BgL_envz00_14018, (int) (((long) 2)));
				{	/* Eval/evaluate_comp.scm 1021 */
					double BgL_tmpz00_25039;

					{	/* Eval/evaluate_comp.scm 1021 */
						obj_t BgL_bpz00_16540;

						BgL_bpz00_16540 = VECTOR_REF(((obj_t) BgL_sz00_14022), ((long) 0));
						{	/* Eval/evaluate_comp.scm 1021 */
							obj_t BgL_a1z00_16541;
							obj_t BgL_a2z00_16542;

							BgL_a1z00_16541 =
								PROCEDURE_ENTRY(BgL_a1z00_14019) (BgL_a1z00_14019,
								BgL_sz00_14022, BEOA);
							BgL_a2z00_16542 =
								PROCEDURE_ENTRY(BgL_a2z00_14020) (BgL_a2z00_14020,
								BgL_sz00_14022, BEOA);
							if (REALP(BgL_a1z00_16541))
								{	/* Eval/evaluate_comp.scm 1021 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1021 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol5871z00zz__evaluate_compz00,
										BGl_symbol5869z00zz__evaluate_compz00, BgL_a1z00_16541,
										BgL_locz00_14021);
								}
							if (REALP(BgL_a2z00_16542))
								{	/* Eval/evaluate_comp.scm 1021 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1021 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol5871z00zz__evaluate_compz00,
										BGl_symbol5869z00zz__evaluate_compz00, BgL_a2z00_16542,
										BgL_locz00_14021);
								}
							BgL_tmpz00_25039 =
								(REAL_TO_DOUBLE(BgL_a1z00_16541) -
								REAL_TO_DOUBLE(BgL_a2z00_16542));
						}
					}
					return DOUBLE_TO_REAL(BgL_tmpz00_25039);
				}
			}
		}

	}



/* &<@anonymous:2841> */
	obj_t BGl_z62zc3z04anonymousza32841ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_14023, obj_t BgL_sz00_14027)
	{
		{	/* Eval/evaluate_comp.scm 1021 */
			{	/* Eval/evaluate_comp.scm 1021 */
				obj_t BgL_a1z00_14024;
				obj_t BgL_a2z00_14025;
				obj_t BgL_locz00_14026;

				BgL_a1z00_14024 = PROCEDURE_REF(BgL_envz00_14023, (int) (((long) 0)));
				BgL_a2z00_14025 = PROCEDURE_REF(BgL_envz00_14023, (int) (((long) 1)));
				BgL_locz00_14026 = PROCEDURE_REF(BgL_envz00_14023, (int) (((long) 2)));
				{	/* Eval/evaluate_comp.scm 1021 */
					double BgL_tmpz00_25066;

					{	/* Eval/evaluate_comp.scm 1021 */
						obj_t BgL_bpz00_16543;

						BgL_bpz00_16543 = VECTOR_REF(((obj_t) BgL_sz00_14027), ((long) 0));
						{	/* Eval/evaluate_comp.scm 1021 */
							obj_t BgL_a1z00_16544;
							obj_t BgL_a2z00_16545;

							BgL_a1z00_16544 =
								PROCEDURE_ENTRY(BgL_a1z00_14024) (BgL_a1z00_14024,
								BgL_sz00_14027, BEOA);
							BgL_a2z00_16545 =
								PROCEDURE_ENTRY(BgL_a2z00_14025) (BgL_a2z00_14025,
								BgL_sz00_14027, BEOA);
							if (REALP(BgL_a1z00_16544))
								{	/* Eval/evaluate_comp.scm 1021 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1021 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol5873z00zz__evaluate_compz00,
										BGl_symbol5869z00zz__evaluate_compz00, BgL_a1z00_16544,
										BgL_locz00_14026);
								}
							if (REALP(BgL_a2z00_16545))
								{	/* Eval/evaluate_comp.scm 1021 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1021 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol5873z00zz__evaluate_compz00,
										BGl_symbol5869z00zz__evaluate_compz00, BgL_a2z00_16545,
										BgL_locz00_14026);
								}
							BgL_tmpz00_25066 =
								(REAL_TO_DOUBLE(BgL_a1z00_16544) *
								REAL_TO_DOUBLE(BgL_a2z00_16545));
						}
					}
					return DOUBLE_TO_REAL(BgL_tmpz00_25066);
				}
			}
		}

	}



/* &<@anonymous:2845> */
	obj_t BGl_z62zc3z04anonymousza32845ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_14028, obj_t BgL_sz00_14032)
	{
		{	/* Eval/evaluate_comp.scm 1021 */
			{	/* Eval/evaluate_comp.scm 1021 */
				obj_t BgL_a1z00_14029;
				obj_t BgL_a2z00_14030;
				obj_t BgL_locz00_14031;

				BgL_a1z00_14029 = PROCEDURE_REF(BgL_envz00_14028, (int) (((long) 0)));
				BgL_a2z00_14030 = PROCEDURE_REF(BgL_envz00_14028, (int) (((long) 1)));
				BgL_locz00_14031 = PROCEDURE_REF(BgL_envz00_14028, (int) (((long) 2)));
				{	/* Eval/evaluate_comp.scm 1021 */
					double BgL_tmpz00_25093;

					{	/* Eval/evaluate_comp.scm 1021 */
						obj_t BgL_bpz00_16546;

						BgL_bpz00_16546 = VECTOR_REF(((obj_t) BgL_sz00_14032), ((long) 0));
						{	/* Eval/evaluate_comp.scm 1021 */
							obj_t BgL_a1z00_16547;
							obj_t BgL_a2z00_16548;

							BgL_a1z00_16547 =
								PROCEDURE_ENTRY(BgL_a1z00_14029) (BgL_a1z00_14029,
								BgL_sz00_14032, BEOA);
							BgL_a2z00_16548 =
								PROCEDURE_ENTRY(BgL_a2z00_14030) (BgL_a2z00_14030,
								BgL_sz00_14032, BEOA);
							if (REALP(BgL_a1z00_16547))
								{	/* Eval/evaluate_comp.scm 1021 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1021 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol5875z00zz__evaluate_compz00,
										BGl_symbol5869z00zz__evaluate_compz00, BgL_a1z00_16547,
										BgL_locz00_14031);
								}
							if (REALP(BgL_a2z00_16548))
								{	/* Eval/evaluate_comp.scm 1021 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1021 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol5875z00zz__evaluate_compz00,
										BGl_symbol5869z00zz__evaluate_compz00, BgL_a2z00_16548,
										BgL_locz00_14031);
								}
							BgL_tmpz00_25093 =
								(REAL_TO_DOUBLE(BgL_a1z00_16547) /
								REAL_TO_DOUBLE(BgL_a2z00_16548));
						}
					}
					return DOUBLE_TO_REAL(BgL_tmpz00_25093);
				}
			}
		}

	}



/* &<@anonymous:2849> */
	obj_t BGl_z62zc3z04anonymousza32849ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_14033, obj_t BgL_sz00_14037)
	{
		{	/* Eval/evaluate_comp.scm 1021 */
			{	/* Eval/evaluate_comp.scm 1021 */
				obj_t BgL_a1z00_14034;
				obj_t BgL_a2z00_14035;
				obj_t BgL_locz00_14036;

				BgL_a1z00_14034 = PROCEDURE_REF(BgL_envz00_14033, (int) (((long) 0)));
				BgL_a2z00_14035 = PROCEDURE_REF(BgL_envz00_14033, (int) (((long) 1)));
				BgL_locz00_14036 = PROCEDURE_REF(BgL_envz00_14033, (int) (((long) 2)));
				{	/* Eval/evaluate_comp.scm 1021 */
					bool_t BgL_tmpz00_25120;

					{	/* Eval/evaluate_comp.scm 1021 */
						obj_t BgL_bpz00_16549;

						BgL_bpz00_16549 = VECTOR_REF(((obj_t) BgL_sz00_14037), ((long) 0));
						{	/* Eval/evaluate_comp.scm 1021 */
							obj_t BgL_a1z00_16550;
							obj_t BgL_a2z00_16551;

							BgL_a1z00_16550 =
								PROCEDURE_ENTRY(BgL_a1z00_14034) (BgL_a1z00_14034,
								BgL_sz00_14037, BEOA);
							BgL_a2z00_16551 =
								PROCEDURE_ENTRY(BgL_a2z00_14035) (BgL_a2z00_14035,
								BgL_sz00_14037, BEOA);
							if (REALP(BgL_a1z00_16550))
								{	/* Eval/evaluate_comp.scm 1021 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1021 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol5877z00zz__evaluate_compz00,
										BGl_symbol5869z00zz__evaluate_compz00, BgL_a1z00_16550,
										BgL_locz00_14036);
								}
							if (REALP(BgL_a2z00_16551))
								{	/* Eval/evaluate_comp.scm 1021 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1021 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol5877z00zz__evaluate_compz00,
										BGl_symbol5869z00zz__evaluate_compz00, BgL_a2z00_16551,
										BgL_locz00_14036);
								}
							BgL_tmpz00_25120 =
								(REAL_TO_DOUBLE(BgL_a1z00_16550) <
								REAL_TO_DOUBLE(BgL_a2z00_16551));
						}
					}
					return BBOOL(BgL_tmpz00_25120);
				}
			}
		}

	}



/* &<@anonymous:2853> */
	obj_t BGl_z62zc3z04anonymousza32853ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_14038, obj_t BgL_sz00_14042)
	{
		{	/* Eval/evaluate_comp.scm 1021 */
			{	/* Eval/evaluate_comp.scm 1021 */
				obj_t BgL_a1z00_14039;
				obj_t BgL_a2z00_14040;
				obj_t BgL_locz00_14041;

				BgL_a1z00_14039 = PROCEDURE_REF(BgL_envz00_14038, (int) (((long) 0)));
				BgL_a2z00_14040 = PROCEDURE_REF(BgL_envz00_14038, (int) (((long) 1)));
				BgL_locz00_14041 = PROCEDURE_REF(BgL_envz00_14038, (int) (((long) 2)));
				{	/* Eval/evaluate_comp.scm 1021 */
					bool_t BgL_tmpz00_25147;

					{	/* Eval/evaluate_comp.scm 1021 */
						obj_t BgL_bpz00_16552;

						BgL_bpz00_16552 = VECTOR_REF(((obj_t) BgL_sz00_14042), ((long) 0));
						{	/* Eval/evaluate_comp.scm 1021 */
							obj_t BgL_a1z00_16553;
							obj_t BgL_a2z00_16554;

							BgL_a1z00_16553 =
								PROCEDURE_ENTRY(BgL_a1z00_14039) (BgL_a1z00_14039,
								BgL_sz00_14042, BEOA);
							BgL_a2z00_16554 =
								PROCEDURE_ENTRY(BgL_a2z00_14040) (BgL_a2z00_14040,
								BgL_sz00_14042, BEOA);
							if (REALP(BgL_a1z00_16553))
								{	/* Eval/evaluate_comp.scm 1021 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1021 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol5879z00zz__evaluate_compz00,
										BGl_symbol5869z00zz__evaluate_compz00, BgL_a1z00_16553,
										BgL_locz00_14041);
								}
							if (REALP(BgL_a2z00_16554))
								{	/* Eval/evaluate_comp.scm 1021 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1021 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol5879z00zz__evaluate_compz00,
										BGl_symbol5869z00zz__evaluate_compz00, BgL_a2z00_16554,
										BgL_locz00_14041);
								}
							BgL_tmpz00_25147 =
								(REAL_TO_DOUBLE(BgL_a1z00_16553) >
								REAL_TO_DOUBLE(BgL_a2z00_16554));
						}
					}
					return BBOOL(BgL_tmpz00_25147);
				}
			}
		}

	}



/* &<@anonymous:2857> */
	obj_t BGl_z62zc3z04anonymousza32857ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_14043, obj_t BgL_sz00_14047)
	{
		{	/* Eval/evaluate_comp.scm 1021 */
			{	/* Eval/evaluate_comp.scm 1021 */
				obj_t BgL_a1z00_14044;
				obj_t BgL_a2z00_14045;
				obj_t BgL_locz00_14046;

				BgL_a1z00_14044 = PROCEDURE_REF(BgL_envz00_14043, (int) (((long) 0)));
				BgL_a2z00_14045 = PROCEDURE_REF(BgL_envz00_14043, (int) (((long) 1)));
				BgL_locz00_14046 = PROCEDURE_REF(BgL_envz00_14043, (int) (((long) 2)));
				{	/* Eval/evaluate_comp.scm 1021 */
					bool_t BgL_tmpz00_25174;

					{	/* Eval/evaluate_comp.scm 1021 */
						obj_t BgL_bpz00_16555;

						BgL_bpz00_16555 = VECTOR_REF(((obj_t) BgL_sz00_14047), ((long) 0));
						{	/* Eval/evaluate_comp.scm 1021 */
							obj_t BgL_a1z00_16556;
							obj_t BgL_a2z00_16557;

							BgL_a1z00_16556 =
								PROCEDURE_ENTRY(BgL_a1z00_14044) (BgL_a1z00_14044,
								BgL_sz00_14047, BEOA);
							BgL_a2z00_16557 =
								PROCEDURE_ENTRY(BgL_a2z00_14045) (BgL_a2z00_14045,
								BgL_sz00_14047, BEOA);
							if (REALP(BgL_a1z00_16556))
								{	/* Eval/evaluate_comp.scm 1021 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1021 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol5881z00zz__evaluate_compz00,
										BGl_symbol5869z00zz__evaluate_compz00, BgL_a1z00_16556,
										BgL_locz00_14046);
								}
							if (REALP(BgL_a2z00_16557))
								{	/* Eval/evaluate_comp.scm 1021 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1021 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol5881z00zz__evaluate_compz00,
										BGl_symbol5869z00zz__evaluate_compz00, BgL_a2z00_16557,
										BgL_locz00_14046);
								}
							BgL_tmpz00_25174 =
								(REAL_TO_DOUBLE(BgL_a1z00_16556) <=
								REAL_TO_DOUBLE(BgL_a2z00_16557));
						}
					}
					return BBOOL(BgL_tmpz00_25174);
				}
			}
		}

	}



/* &<@anonymous:2861> */
	obj_t BGl_z62zc3z04anonymousza32861ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_14048, obj_t BgL_sz00_14052)
	{
		{	/* Eval/evaluate_comp.scm 1021 */
			{	/* Eval/evaluate_comp.scm 1021 */
				obj_t BgL_a1z00_14049;
				obj_t BgL_a2z00_14050;
				obj_t BgL_locz00_14051;

				BgL_a1z00_14049 = PROCEDURE_REF(BgL_envz00_14048, (int) (((long) 0)));
				BgL_a2z00_14050 = PROCEDURE_REF(BgL_envz00_14048, (int) (((long) 1)));
				BgL_locz00_14051 = PROCEDURE_REF(BgL_envz00_14048, (int) (((long) 2)));
				{	/* Eval/evaluate_comp.scm 1021 */
					bool_t BgL_tmpz00_25201;

					{	/* Eval/evaluate_comp.scm 1021 */
						obj_t BgL_bpz00_16558;

						BgL_bpz00_16558 = VECTOR_REF(((obj_t) BgL_sz00_14052), ((long) 0));
						{	/* Eval/evaluate_comp.scm 1021 */
							obj_t BgL_a1z00_16559;
							obj_t BgL_a2z00_16560;

							BgL_a1z00_16559 =
								PROCEDURE_ENTRY(BgL_a1z00_14049) (BgL_a1z00_14049,
								BgL_sz00_14052, BEOA);
							BgL_a2z00_16560 =
								PROCEDURE_ENTRY(BgL_a2z00_14050) (BgL_a2z00_14050,
								BgL_sz00_14052, BEOA);
							if (REALP(BgL_a1z00_16559))
								{	/* Eval/evaluate_comp.scm 1021 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1021 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol5883z00zz__evaluate_compz00,
										BGl_symbol5869z00zz__evaluate_compz00, BgL_a1z00_16559,
										BgL_locz00_14051);
								}
							if (REALP(BgL_a2z00_16560))
								{	/* Eval/evaluate_comp.scm 1021 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1021 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol5883z00zz__evaluate_compz00,
										BGl_symbol5869z00zz__evaluate_compz00, BgL_a2z00_16560,
										BgL_locz00_14051);
								}
							BgL_tmpz00_25201 =
								(REAL_TO_DOUBLE(BgL_a1z00_16559) >=
								REAL_TO_DOUBLE(BgL_a2z00_16560));
						}
					}
					return BBOOL(BgL_tmpz00_25201);
				}
			}
		}

	}



/* &<@anonymous:2865> */
	obj_t BGl_z62zc3z04anonymousza32865ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_14053, obj_t BgL_sz00_14057)
	{
		{	/* Eval/evaluate_comp.scm 1021 */
			{	/* Eval/evaluate_comp.scm 1021 */
				obj_t BgL_a1z00_14054;
				obj_t BgL_a2z00_14055;
				obj_t BgL_locz00_14056;

				BgL_a1z00_14054 = PROCEDURE_REF(BgL_envz00_14053, (int) (((long) 0)));
				BgL_a2z00_14055 = PROCEDURE_REF(BgL_envz00_14053, (int) (((long) 1)));
				BgL_locz00_14056 = PROCEDURE_REF(BgL_envz00_14053, (int) (((long) 2)));
				{	/* Eval/evaluate_comp.scm 1021 */
					bool_t BgL_tmpz00_25228;

					{	/* Eval/evaluate_comp.scm 1021 */
						obj_t BgL_bpz00_16561;

						BgL_bpz00_16561 = VECTOR_REF(((obj_t) BgL_sz00_14057), ((long) 0));
						{	/* Eval/evaluate_comp.scm 1021 */
							obj_t BgL_a1z00_16562;
							obj_t BgL_a2z00_16563;

							BgL_a1z00_16562 =
								PROCEDURE_ENTRY(BgL_a1z00_14054) (BgL_a1z00_14054,
								BgL_sz00_14057, BEOA);
							BgL_a2z00_16563 =
								PROCEDURE_ENTRY(BgL_a2z00_14055) (BgL_a2z00_14055,
								BgL_sz00_14057, BEOA);
							if (REALP(BgL_a1z00_16562))
								{	/* Eval/evaluate_comp.scm 1021 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1021 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol5885z00zz__evaluate_compz00,
										BGl_symbol5869z00zz__evaluate_compz00, BgL_a1z00_16562,
										BgL_locz00_14056);
								}
							if (REALP(BgL_a2z00_16563))
								{	/* Eval/evaluate_comp.scm 1021 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1021 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol5885z00zz__evaluate_compz00,
										BGl_symbol5869z00zz__evaluate_compz00, BgL_a2z00_16563,
										BgL_locz00_14056);
								}
							BgL_tmpz00_25228 =
								(REAL_TO_DOUBLE(BgL_a1z00_16562) ==
								REAL_TO_DOUBLE(BgL_a2z00_16563));
						}
					}
					return BBOOL(BgL_tmpz00_25228);
				}
			}
		}

	}



/* &<@anonymous:2869> */
	obj_t BGl_z62zc3z04anonymousza32869ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_14058, obj_t BgL_sz00_14061)
	{
		{	/* Eval/evaluate_comp.scm 1021 */
			{	/* Eval/evaluate_comp.scm 1021 */
				obj_t BgL_a1z00_14059;
				obj_t BgL_a2z00_14060;

				BgL_a1z00_14059 = PROCEDURE_REF(BgL_envz00_14058, (int) (((long) 0)));
				BgL_a2z00_14060 = PROCEDURE_REF(BgL_envz00_14058, (int) (((long) 1)));
				{	/* Eval/evaluate_comp.scm 1021 */
					bool_t BgL_tmpz00_25253;

					{	/* Eval/evaluate_comp.scm 1021 */
						obj_t BgL_bpz00_16564;

						BgL_bpz00_16564 = VECTOR_REF(((obj_t) BgL_sz00_14061), ((long) 0));
						{	/* Eval/evaluate_comp.scm 1021 */
							obj_t BgL_a1z00_16565;
							obj_t BgL_a2z00_16566;

							BgL_a1z00_16565 =
								PROCEDURE_ENTRY(BgL_a1z00_14059) (BgL_a1z00_14059,
								BgL_sz00_14061, BEOA);
							BgL_a2z00_16566 =
								PROCEDURE_ENTRY(BgL_a2z00_14060) (BgL_a2z00_14060,
								BgL_sz00_14061, BEOA);
							BgL_tmpz00_25253 = (BgL_a1z00_16565 == BgL_a2z00_16566);
					}}
					return BBOOL(BgL_tmpz00_25253);
				}
			}
		}

	}



/* &<@anonymous:2871> */
	obj_t BGl_z62zc3z04anonymousza32871ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_14062, obj_t BgL_sz00_14065)
	{
		{	/* Eval/evaluate_comp.scm 1021 */
			{	/* Eval/evaluate_comp.scm 1021 */
				obj_t BgL_a1z00_14063;
				obj_t BgL_a2z00_14064;

				BgL_a1z00_14063 = PROCEDURE_REF(BgL_envz00_14062, (int) (((long) 0)));
				BgL_a2z00_14064 = PROCEDURE_REF(BgL_envz00_14062, (int) (((long) 1)));
				{	/* Eval/evaluate_comp.scm 1021 */
					obj_t BgL_bpz00_16567;

					BgL_bpz00_16567 = VECTOR_REF(((obj_t) BgL_sz00_14065), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1021 */
						obj_t BgL_a1z00_16568;
						obj_t BgL_a2z00_16569;

						BgL_a1z00_16568 =
							PROCEDURE_ENTRY(BgL_a1z00_14063) (BgL_a1z00_14063, BgL_sz00_14065,
							BEOA);
						BgL_a2z00_16569 =
							PROCEDURE_ENTRY(BgL_a2z00_14064) (BgL_a2z00_14064, BgL_sz00_14065,
							BEOA);
						return MAKE_YOUNG_PAIR(BgL_a1z00_16568, BgL_a2z00_16569);
					}
				}
			}
		}

	}



/* &<@anonymous:2874> */
	obj_t BGl_z62zc3z04anonymousza32874ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_14066, obj_t BgL_sz00_14069)
	{
		{	/* Eval/evaluate_comp.scm 1018 */
			{	/* Eval/evaluate_comp.scm 1018 */
				obj_t BgL_a1z00_14067;
				obj_t BgL_locz00_14068;

				BgL_a1z00_14067 = PROCEDURE_REF(BgL_envz00_14066, (int) (((long) 0)));
				BgL_locz00_14068 = PROCEDURE_REF(BgL_envz00_14066, (int) (((long) 1)));
				{	/* Eval/evaluate_comp.scm 1018 */
					obj_t BgL_bpz00_16570;

					BgL_bpz00_16570 = VECTOR_REF(((obj_t) BgL_sz00_14069), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1018 */
						obj_t BgL_a1z00_16571;

						BgL_a1z00_16571 =
							PROCEDURE_ENTRY(BgL_a1z00_14067) (BgL_a1z00_14067, BgL_sz00_14069,
							BEOA);
						if (PAIRP(BgL_a1z00_16571))
							{	/* Eval/evaluate_comp.scm 1018 */
								BFALSE;
							}
						else
							{	/* Eval/evaluate_comp.scm 1018 */
								BGl_loczd2typezd2errorz00zz__evaluate_compz00
									(BGl_symbol5887z00zz__evaluate_compz00,
									BGl_symbol5889z00zz__evaluate_compz00, BgL_a1z00_16571,
									BgL_locz00_14068);
							}
						return CAR(((obj_t) BgL_a1z00_16571));
					}
				}
			}
		}

	}



/* &<@anonymous:2877> */
	obj_t BGl_z62zc3z04anonymousza32877ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_14070, obj_t BgL_sz00_14073)
	{
		{	/* Eval/evaluate_comp.scm 1018 */
			{	/* Eval/evaluate_comp.scm 1018 */
				obj_t BgL_a1z00_14071;
				obj_t BgL_locz00_14072;

				BgL_a1z00_14071 = PROCEDURE_REF(BgL_envz00_14070, (int) (((long) 0)));
				BgL_locz00_14072 = PROCEDURE_REF(BgL_envz00_14070, (int) (((long) 1)));
				{	/* Eval/evaluate_comp.scm 1018 */
					obj_t BgL_bpz00_16572;

					BgL_bpz00_16572 = VECTOR_REF(((obj_t) BgL_sz00_14073), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1018 */
						obj_t BgL_a1z00_16573;

						BgL_a1z00_16573 =
							PROCEDURE_ENTRY(BgL_a1z00_14071) (BgL_a1z00_14071, BgL_sz00_14073,
							BEOA);
						if (PAIRP(BgL_a1z00_16573))
							{	/* Eval/evaluate_comp.scm 1018 */
								BFALSE;
							}
						else
							{	/* Eval/evaluate_comp.scm 1018 */
								BGl_loczd2typezd2errorz00zz__evaluate_compz00
									(BGl_symbol5891z00zz__evaluate_compz00,
									BGl_symbol5889z00zz__evaluate_compz00, BgL_a1z00_16573,
									BgL_locz00_14072);
							}
						return CDR(((obj_t) BgL_a1z00_16573));
					}
				}
			}
		}

	}



/* &<@anonymous:2880> */
	obj_t BGl_z62zc3z04anonymousza32880ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_14074, obj_t BgL_sz00_14077)
	{
		{	/* Eval/evaluate_comp.scm 1018 */
			{	/* Eval/evaluate_comp.scm 1018 */
				obj_t BgL_a1z00_14075;
				obj_t BgL_locz00_14076;

				BgL_a1z00_14075 = PROCEDURE_REF(BgL_envz00_14074, (int) (((long) 0)));
				BgL_locz00_14076 = PROCEDURE_REF(BgL_envz00_14074, (int) (((long) 1)));
				{	/* Eval/evaluate_comp.scm 1018 */
					obj_t BgL_bpz00_16574;

					BgL_bpz00_16574 = VECTOR_REF(((obj_t) BgL_sz00_14077), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1018 */
						obj_t BgL_a1z00_16575;

						BgL_a1z00_16575 =
							PROCEDURE_ENTRY(BgL_a1z00_14075) (BgL_a1z00_14075, BgL_sz00_14077,
							BEOA);
						{	/* Eval/evaluate_comp.scm 1018 */
							bool_t BgL_test6530z00_25321;

							if (PAIRP(BgL_a1z00_16575))
								{	/* Eval/evaluate_comp.scm 1027 */
									obj_t BgL_tmpz00_25324;

									BgL_tmpz00_25324 = CDR(BgL_a1z00_16575);
									BgL_test6530z00_25321 = PAIRP(BgL_tmpz00_25324);
								}
							else
								{	/* Eval/evaluate_comp.scm 1027 */
									BgL_test6530z00_25321 = ((bool_t) 0);
								}
							if (BgL_test6530z00_25321)
								{	/* Eval/evaluate_comp.scm 1018 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1018 */
									obj_t BgL_arg2882z00_16576;

									if (PAIRP(BgL_a1z00_16575))
										{	/* Eval/evaluate_comp.scm 1030 */
											BgL_arg2882z00_16576 = CDR(BgL_a1z00_16575);
										}
									else
										{	/* Eval/evaluate_comp.scm 1030 */
											BgL_arg2882z00_16576 = BgL_a1z00_16575;
										}
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol5893z00zz__evaluate_compz00,
										BGl_symbol5889z00zz__evaluate_compz00, BgL_arg2882z00_16576,
										BgL_locz00_14076);
								}
						}
						{	/* Eval/evaluate_comp.scm 1018 */
							obj_t BgL_pairz00_16577;

							BgL_pairz00_16577 = CDR(((obj_t) BgL_a1z00_16575));
							return CAR(BgL_pairz00_16577);
						}
					}
				}
			}
		}

	}



/* bind-frame */
	obj_t BGl_bindzd2framezd2zz__evaluate_compz00(obj_t BgL_sz00_203,
		obj_t BgL_wherez00_204, long BgL_spz00_205, long BgL_arityz00_206,
		obj_t BgL_valsz00_207, obj_t BgL_locz00_208)
	{
		{	/* Eval/evaluate_comp.scm 1063 */
			if ((BgL_arityz00_206 < ((long) 0)))
				{	/* Eval/evaluate_comp.scm 1065 */
					long BgL_g1237z00_3516;

					BgL_g1237z00_3516 = (((long) -1) - BgL_arityz00_206);
					{
						long BgL_rz00_3518;
						long BgL_spz00_3519;
						obj_t BgL_lz00_3520;

						BgL_rz00_3518 = BgL_g1237z00_3516;
						BgL_spz00_3519 = BgL_spz00_205;
						BgL_lz00_3520 = BgL_valsz00_207;
					BgL_zc3z04anonymousza32887ze3z87_3521:
						if ((BgL_rz00_3518 == ((long) 0)))
							{	/* Eval/evaluate_comp.scm 1067 */
								return
									VECTOR_SET(
									((obj_t) BgL_sz00_203), BgL_spz00_3519, BgL_lz00_3520);
							}
						else
							{	/* Eval/evaluate_comp.scm 1067 */
								if (PAIRP(BgL_lz00_3520))
									{	/* Eval/evaluate_comp.scm 1069 */
										{	/* Eval/evaluate_comp.scm 1072 */
											obj_t BgL_arg2892z00_3524;

											BgL_arg2892z00_3524 = CAR(BgL_lz00_3520);
											VECTOR_SET(
												((obj_t) BgL_sz00_203), BgL_spz00_3519,
												BgL_arg2892z00_3524);
										}
										{
											obj_t BgL_lz00_25350;
											long BgL_spz00_25348;
											long BgL_rz00_25346;

											BgL_rz00_25346 = (BgL_rz00_3518 - ((long) 1));
											BgL_spz00_25348 = (BgL_spz00_3519 + ((long) 1));
											BgL_lz00_25350 = CDR(BgL_lz00_3520);
											BgL_lz00_3520 = BgL_lz00_25350;
											BgL_spz00_3519 = BgL_spz00_25348;
											BgL_rz00_3518 = BgL_rz00_25346;
											goto BgL_zc3z04anonymousza32887ze3z87_3521;
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 1070 */
										long BgL_arg2902z00_3528;

										BgL_arg2902z00_3528 = bgl_list_length(BgL_valsz00_207);
										return
											BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_208,
											BgL_wherez00_204, (int) (BgL_arityz00_206),
											(int) (BgL_arg2902z00_3528));
				}}}}
			else
				{
					long BgL_rz00_3531;
					long BgL_spz00_3532;
					obj_t BgL_lz00_3533;

					BgL_rz00_3531 = BgL_arityz00_206;
					BgL_spz00_3532 = BgL_spz00_205;
					BgL_lz00_3533 = BgL_valsz00_207;
				BgL_zc3z04anonymousza32903ze3z87_3534:
					if ((BgL_rz00_3531 == ((long) 0)))
						{	/* Eval/evaluate_comp.scm 1076 */
							if (NULLP(BgL_lz00_3533))
								{	/* Eval/evaluate_comp.scm 1077 */
									return BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1078 */
									long BgL_arg2906z00_3537;

									BgL_arg2906z00_3537 = bgl_list_length(BgL_valsz00_207);
									return
										BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_208,
										BgL_wherez00_204, (int) (BgL_arityz00_206),
										(int) (BgL_arg2906z00_3537));
						}}
					else
						{	/* Eval/evaluate_comp.scm 1076 */
							if (PAIRP(BgL_lz00_3533))
								{	/* Eval/evaluate_comp.scm 1079 */
									{	/* Eval/evaluate_comp.scm 1082 */
										obj_t BgL_arg2908z00_3539;

										BgL_arg2908z00_3539 = CAR(BgL_lz00_3533);
										VECTOR_SET(
											((obj_t) BgL_sz00_203), BgL_spz00_3532,
											BgL_arg2908z00_3539);
									}
									{
										obj_t BgL_lz00_25373;
										long BgL_spz00_25371;
										long BgL_rz00_25369;

										BgL_rz00_25369 = (BgL_rz00_3531 - ((long) 1));
										BgL_spz00_25371 = (BgL_spz00_3532 + ((long) 1));
										BgL_lz00_25373 = CDR(BgL_lz00_3533);
										BgL_lz00_3533 = BgL_lz00_25373;
										BgL_spz00_3532 = BgL_spz00_25371;
										BgL_rz00_3531 = BgL_rz00_25369;
										goto BgL_zc3z04anonymousza32903ze3z87_3534;
									}
								}
							else
								{	/* Eval/evaluate_comp.scm 1080 */
									long BgL_arg2912z00_3543;

									BgL_arg2912z00_3543 = bgl_list_length(BgL_valsz00_207);
									return
										BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_208,
										BgL_wherez00_204, (int) (BgL_arityz00_206),
										(int) (BgL_arg2912z00_3543));
		}}}}

	}



/* make-boxes */
	bool_t BGl_makezd2boxeszd2zz__evaluate_compz00(obj_t BgL_sz00_211,
		obj_t BgL_ibza2za2_212, obj_t BgL_bpz00_213)
	{
		{	/* Eval/evaluate_comp.scm 1177 */
			{
				long BgL_iz00_3547;

				BgL_iz00_3547 = ((long) 0);
			BgL_zc3z04anonymousza32913ze3z87_3548:
				{	/* Eval/evaluate_comp.scm 1180 */
					long BgL_spz00_3549;

					{	/* Eval/evaluate_comp.scm 1180 */
						obj_t BgL_arg2918z00_3554;

						BgL_arg2918z00_3554 =
							VECTOR_REF(((obj_t) BgL_ibza2za2_212), BgL_iz00_3547);
						BgL_spz00_3549 =
							((long) CINT(BgL_bpz00_213) + (long) CINT(BgL_arg2918z00_3554));
					}
					{	/* Eval/evaluate_comp.scm 1181 */
						obj_t BgL_arg2914z00_3550;

						{	/* Eval/evaluate_comp.scm 1181 */
							obj_t BgL_arg2915z00_3551;

							BgL_arg2915z00_3551 =
								VECTOR_REF(((obj_t) BgL_sz00_211), BgL_spz00_3549);
							{	/* Eval/evaluate_comp.scm 202 */
								obj_t BgL_newz00_9671;

								BgL_newz00_9671 =
									create_struct(BGl_symbol5817z00zz__evaluate_compz00,
									(int) (((long) 1)));
								{	/* Eval/evaluate_comp.scm 202 */
									int BgL_tmpz00_25388;

									BgL_tmpz00_25388 = (int) (((long) 0));
									STRUCT_SET(BgL_newz00_9671, BgL_tmpz00_25388,
										BgL_arg2915z00_3551);
								}
								BgL_arg2914z00_3550 = BgL_newz00_9671;
						}}
						VECTOR_SET(
							((obj_t) BgL_sz00_211), BgL_spz00_3549, BgL_arg2914z00_3550);
					}
					{	/* Eval/evaluate_comp.scm 1182 */
						long BgL_niz00_3552;

						BgL_niz00_3552 = (BgL_iz00_3547 + ((long) 1));
						if ((BgL_niz00_3552 < VECTOR_LENGTH(((obj_t) BgL_ibza2za2_212))))
							{
								long BgL_iz00_25398;

								BgL_iz00_25398 = BgL_niz00_3552;
								BgL_iz00_3547 = BgL_iz00_25398;
								goto BgL_zc3z04anonymousza32913ze3z87_3548;
							}
						else
							{	/* Eval/evaluate_comp.scm 1183 */
								return ((bool_t) 0);
							}
					}
				}
			}
		}

	}



/* free-collect */
	obj_t BGl_freezd2collectzd2zz__evaluate_compz00(obj_t BgL_sz00_214,
		obj_t BgL_bpz00_215, obj_t BgL_iza2za2_216)
	{
		{	/* Eval/evaluate_comp.scm 1185 */
			{	/* Eval/evaluate_comp.scm 1186 */
				obj_t BgL_rz00_3557;

				BgL_rz00_3557 =
					make_vector(VECTOR_LENGTH(((obj_t) BgL_iza2za2_216)), BUNSPEC);
				{	/* Eval/evaluate_comp.scm 1186 */

					{
						long BgL_iz00_3559;

						BgL_iz00_3559 = ((long) 0);
					BgL_zc3z04anonymousza32919ze3z87_3560:
						if ((BgL_iz00_3559 >= VECTOR_LENGTH(((obj_t) BgL_iza2za2_216))))
							{	/* Eval/evaluate_comp.scm 1188 */
								return BgL_rz00_3557;
							}
						else
							{	/* Eval/evaluate_comp.scm 1188 */
								{	/* Eval/evaluate_comp.scm 1191 */
									obj_t BgL_arg2936z00_3562;

									{	/* Eval/evaluate_comp.scm 1191 */
										long BgL_arg2937z00_3563;

										{	/* Eval/evaluate_comp.scm 1191 */
											obj_t BgL_arg2938z00_3564;

											BgL_arg2938z00_3564 =
												VECTOR_REF(((obj_t) BgL_iza2za2_216), BgL_iz00_3559);
											BgL_arg2937z00_3563 =
												(
												(long) CINT(BgL_bpz00_215) +
												(long) CINT(BgL_arg2938z00_3564));
										}
										BgL_arg2936z00_3562 =
											VECTOR_REF(((obj_t) BgL_sz00_214), BgL_arg2937z00_3563);
									}
									VECTOR_SET(BgL_rz00_3557, BgL_iz00_3559, BgL_arg2936z00_3562);
								}
								{
									long BgL_iz00_25414;

									BgL_iz00_25414 = (BgL_iz00_3559 + ((long) 1));
									BgL_iz00_3559 = BgL_iz00_25414;
									goto BgL_zc3z04anonymousza32919ze3z87_3560;
								}
							}
					}
				}
			}
		}

	}



/* free-restore */
	bool_t BGl_freezd2restorezd2zz__evaluate_compz00(obj_t BgL_sz00_217,
		obj_t BgL_valza2za2_218, long BgL_spz00_219)
	{
		{	/* Eval/evaluate_comp.scm 1194 */
			{	/* Eval/evaluate_comp.scm 1195 */
				long BgL_stopz00_3568;

				BgL_stopz00_3568 =
					(BgL_spz00_219 + VECTOR_LENGTH(((obj_t) BgL_valza2za2_218)));
				{
					long BgL_iz00_9731;
					long BgL_spz00_9732;

					BgL_iz00_9731 = ((long) 0);
					BgL_spz00_9732 = BgL_spz00_219;
				BgL_recz00_9730:
					if ((BgL_spz00_9732 < BgL_stopz00_3568))
						{	/* Eval/evaluate_comp.scm 1197 */
							{	/* Eval/evaluate_comp.scm 1198 */
								obj_t BgL_arg2945z00_9738;

								BgL_arg2945z00_9738 =
									VECTOR_REF(((obj_t) BgL_valza2za2_218), BgL_iz00_9731);
								VECTOR_SET(
									((obj_t) BgL_sz00_217), BgL_spz00_9732, BgL_arg2945z00_9738);
							}
							{
								long BgL_spz00_25427;
								long BgL_iz00_25425;

								BgL_iz00_25425 = (BgL_iz00_9731 + ((long) 1));
								BgL_spz00_25427 = (BgL_spz00_9732 + ((long) 1));
								BgL_spz00_9732 = BgL_spz00_25427;
								BgL_iz00_9731 = BgL_iz00_25425;
								goto BgL_recz00_9730;
							}
						}
					else
						{	/* Eval/evaluate_comp.scm 1197 */
							return ((bool_t) 0);
						}
				}
			}
		}

	}



/* object-init */
	obj_t BGl_objectzd2initzd2zz__evaluate_compz00()
	{
		{	/* Eval/evaluate_comp.scm 15 */
			return BUNSPEC;
		}

	}



/* generic-init */
	obj_t BGl_genericzd2initzd2zz__evaluate_compz00()
	{
		{	/* Eval/evaluate_comp.scm 15 */
			return
				BGl_registerzd2genericz12zc0zz__objectz00
				(BGl_compzd2envzd2zz__evaluate_compz00,
				BGl_proc5895z00zz__evaluate_compz00,
				BGl_ev_exprz00zz__evaluate_typesz00,
				BGl_string5896z00zz__evaluate_compz00);
		}

	}



/* &comp1389 */
	obj_t BGl_z62comp1389z62zz__evaluate_compz00(obj_t BgL_envz00_14163,
		obj_t BgL_ez00_14164, obj_t BgL_stkz00_14165)
	{
		{	/* Eval/evaluate_comp.scm 276 */
			return
				BGl_errorz00zz__errorz00(BGl_string5807z00zz__evaluate_compz00,
				BGl_string5897z00zz__evaluate_compz00,
				((obj_t) ((BgL_ev_exprz00_bglt) BgL_ez00_14164)));
		}

	}



/* comp */
	obj_t BGl_compz00zz__evaluate_compz00(BgL_ev_exprz00_bglt BgL_ez00_35,
		obj_t BgL_stkz00_36)
	{
		{	/* Eval/evaluate_comp.scm 276 */
			{	/* Eval/evaluate_comp.scm 276 */
				obj_t BgL_method1392z00_3584;

				{	/* Eval/evaluate_comp.scm 276 */
					obj_t BgL_res5087z00_9788;

					{	/* Eval/evaluate_comp.scm 276 */
						long BgL_objzd2classzd2numz00_9753;

						{	/* Eval/evaluate_comp.scm 276 */
							long BgL_res5077z00_9756;

							BgL_res5077z00_9756 =
								BGL_OBJECT_CLASS_NUM(((BgL_objectz00_bglt) BgL_ez00_35));
							BgL_objzd2classzd2numz00_9753 = BgL_res5077z00_9756;
						}
						{	/* Eval/evaluate_comp.scm 276 */
							obj_t BgL_arg4313z00_9754;

							BgL_arg4313z00_9754 =
								PROCEDURE_REF(BGl_compzd2envzd2zz__evaluate_compz00,
								(int) (((long) 1)));
							{	/* Eval/evaluate_comp.scm 276 */
								int BgL_offsetz00_9758;

								BgL_offsetz00_9758 = (int) (BgL_objzd2classzd2numz00_9753);
								{	/* Eval/evaluate_comp.scm 276 */
									long BgL_offsetz00_9759;

									BgL_offsetz00_9759 =
										((long) (BgL_offsetz00_9758) - OBJECT_TYPE);
									{	/* Eval/evaluate_comp.scm 276 */
										long BgL_modz00_9760;

										BgL_modz00_9760 =
											(BgL_offsetz00_9759 >>
											(int) ((long) ((int) (((long) 4)))));
										{	/* Eval/evaluate_comp.scm 276 */
											long BgL_restz00_9762;

											BgL_restz00_9762 =
												(BgL_offsetz00_9759 &
												(long) (
													(int) (
														((long) (
																(int) (
																	(((long) 1) <<
																		(int) (
																			(long) (
																				(int) (((long) 4))))))) -
															((long) 1)))));
											{	/* Eval/evaluate_comp.scm 276 */

												{	/* Eval/evaluate_comp.scm 276 */
													obj_t BgL_bucketz00_9764;

													BgL_bucketz00_9764 =
														VECTOR_REF(
														((obj_t) BgL_arg4313z00_9754), BgL_modz00_9760);
													BgL_res5087z00_9788 =
														VECTOR_REF(
														((obj_t) BgL_bucketz00_9764), BgL_restz00_9762);
					}}}}}}}}
					BgL_method1392z00_3584 = BgL_res5087z00_9788;
				}
				return
					PROCEDURE_ENTRY(BgL_method1392z00_3584) (BgL_method1392z00_3584,
					((obj_t) BgL_ez00_35), BgL_stkz00_36, BEOA);
			}
		}

	}



/* &comp */
	obj_t BGl_z62compz62zz__evaluate_compz00(obj_t BgL_envz00_14166,
		obj_t BgL_ez00_14167, obj_t BgL_stkz00_14168)
	{
		{	/* Eval/evaluate_comp.scm 276 */
			{	/* Eval/evaluate_comp.scm 276 */
				BgL_ev_exprz00_bglt BgL_auxz00_25464;

				if (BGl_isazf3zf3zz__objectz00(BgL_ez00_14167,
						BGl_ev_exprz00zz__evaluate_typesz00))
					{	/* Eval/evaluate_comp.scm 276 */
						BgL_auxz00_25464 = ((BgL_ev_exprz00_bglt) BgL_ez00_14167);
					}
				else
					{
						obj_t BgL_auxz00_25468;

						BgL_auxz00_25468 =
							BGl_typezd2errorzd2zz__errorz00
							(BGl_string5812z00zz__evaluate_compz00, BINT(((long) 7022)),
							BGl_string5898z00zz__evaluate_compz00,
							BGl_string5814z00zz__evaluate_compz00, BgL_ez00_14167);
						FAILURE(BgL_auxz00_25468, BFALSE, BFALSE);
					}
				return
					BGl_compz00zz__evaluate_compz00(BgL_auxz00_25464, BgL_stkz00_14168);
			}
		}

	}



/* method-init */
	obj_t BGl_methodzd2initzd2zz__evaluate_compz00()
	{
		{	/* Eval/evaluate_comp.scm 15 */
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_compzd2envzd2zz__evaluate_compz00,
				BGl_ev_trapz00zz__evaluate_typesz00,
				BGl_proc5899z00zz__evaluate_compz00,
				BGl_string5900z00zz__evaluate_compz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_compzd2envzd2zz__evaluate_compz00,
				BGl_ev_varz00zz__evaluate_typesz00, BGl_proc5901z00zz__evaluate_compz00,
				BGl_string5900z00zz__evaluate_compz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_compzd2envzd2zz__evaluate_compz00,
				BGl_ev_setlocalz00zz__evaluate_typesz00,
				BGl_proc5902z00zz__evaluate_compz00,
				BGl_string5900z00zz__evaluate_compz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_compzd2envzd2zz__evaluate_compz00,
				BGl_ev_globalz00zz__evaluate_typesz00,
				BGl_proc5903z00zz__evaluate_compz00,
				BGl_string5900z00zz__evaluate_compz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_compzd2envzd2zz__evaluate_compz00,
				BGl_ev_setglobalz00zz__evaluate_typesz00,
				BGl_proc5904z00zz__evaluate_compz00,
				BGl_string5900z00zz__evaluate_compz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_compzd2envzd2zz__evaluate_compz00,
				BGl_ev_defglobalz00zz__evaluate_typesz00,
				BGl_proc5905z00zz__evaluate_compz00,
				BGl_string5900z00zz__evaluate_compz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_compzd2envzd2zz__evaluate_compz00,
				BGl_ev_littz00zz__evaluate_typesz00,
				BGl_proc5906z00zz__evaluate_compz00,
				BGl_string5900z00zz__evaluate_compz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_compzd2envzd2zz__evaluate_compz00,
				BGl_ev_ifz00zz__evaluate_typesz00, BGl_proc5907z00zz__evaluate_compz00,
				BGl_string5900z00zz__evaluate_compz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_compzd2envzd2zz__evaluate_compz00,
				BGl_ev_orz00zz__evaluate_typesz00, BGl_proc5908z00zz__evaluate_compz00,
				BGl_string5900z00zz__evaluate_compz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_compzd2envzd2zz__evaluate_compz00,
				BGl_ev_andz00zz__evaluate_typesz00, BGl_proc5909z00zz__evaluate_compz00,
				BGl_string5900z00zz__evaluate_compz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_compzd2envzd2zz__evaluate_compz00,
				BGl_ev_prog2z00zz__evaluate_typesz00,
				BGl_proc5910z00zz__evaluate_compz00,
				BGl_string5900z00zz__evaluate_compz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_compzd2envzd2zz__evaluate_compz00,
				BGl_ev_letz00zz__evaluate_typesz00, BGl_proc5911z00zz__evaluate_compz00,
				BGl_string5900z00zz__evaluate_compz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_compzd2envzd2zz__evaluate_compz00,
				BGl_ev_letza2za2zz__evaluate_typesz00,
				BGl_proc5912z00zz__evaluate_compz00,
				BGl_string5900z00zz__evaluate_compz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_compzd2envzd2zz__evaluate_compz00,
				BGl_ev_letrecz00zz__evaluate_typesz00,
				BGl_proc5913z00zz__evaluate_compz00,
				BGl_string5900z00zz__evaluate_compz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_compzd2envzd2zz__evaluate_compz00,
				BGl_ev_bindzd2exitzd2zz__evaluate_typesz00,
				BGl_proc5914z00zz__evaluate_compz00,
				BGl_string5900z00zz__evaluate_compz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_compzd2envzd2zz__evaluate_compz00,
				BGl_ev_unwindzd2protectzd2zz__evaluate_typesz00,
				BGl_proc5915z00zz__evaluate_compz00,
				BGl_string5900z00zz__evaluate_compz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_compzd2envzd2zz__evaluate_compz00,
				BGl_ev_withzd2handlerzd2zz__evaluate_typesz00,
				BGl_proc5916z00zz__evaluate_compz00,
				BGl_string5900z00zz__evaluate_compz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_compzd2envzd2zz__evaluate_compz00,
				BGl_ev_synchroniza7eza7zz__evaluate_typesz00,
				BGl_proc5917z00zz__evaluate_compz00,
				BGl_string5900z00zz__evaluate_compz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_compzd2envzd2zz__evaluate_compz00,
				BGl_ev_labelsz00zz__evaluate_typesz00,
				BGl_proc5918z00zz__evaluate_compz00,
				BGl_string5900z00zz__evaluate_compz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_compzd2envzd2zz__evaluate_compz00,
				BGl_ev_gotoz00zz__evaluate_typesz00,
				BGl_proc5919z00zz__evaluate_compz00,
				BGl_string5900z00zz__evaluate_compz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_compzd2envzd2zz__evaluate_compz00,
				BGl_ev_appz00zz__evaluate_typesz00, BGl_proc5920z00zz__evaluate_compz00,
				BGl_string5900z00zz__evaluate_compz00);
			return
				BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_compzd2envzd2zz__evaluate_compz00,
				BGl_ev_absz00zz__evaluate_typesz00, BGl_proc5921z00zz__evaluate_compz00,
				BGl_string5900z00zz__evaluate_compz00);
		}

	}



/* &comp-ev_abs1439 */
	obj_t BGl_z62compzd2ev_abs1439zb0zz__evaluate_compz00(obj_t BgL_envz00_14363,
		obj_t BgL_ez00_14364, obj_t BgL_stkz00_14365)
	{
		{	/* Eval/evaluate_comp.scm 1165 */
			{	/* Eval/evaluate_comp.scm 1167 */
				obj_t BgL_ifreesz00_16580;
				obj_t BgL_iboxesz00_16581;
				long BgL_siza7eza7_16582;
				long BgL_siza7ezd2framez75_16583;
				obj_t BgL_nstkz00_16584;

				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_arg4021z00_16585;

					{	/* Eval/evaluate_comp.scm 1167 */
						obj_t BgL_l1366z00_16586;

						BgL_l1366z00_16586 =
							(((BgL_ev_absz00_bglt) COBJECT(
									((BgL_ev_absz00_bglt) BgL_ez00_14364)))->BgL_freez00);
						if (NULLP(BgL_l1366z00_16586))
							{	/* Eval/evaluate_comp.scm 1167 */
								BgL_arg4021z00_16585 = BNIL;
							}
						else
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_head1368z00_16587;

								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_res5226z00_16588;

									BgL_res5226z00_16588 = MAKE_YOUNG_PAIR(BNIL, BNIL);
									BgL_head1368z00_16587 = BgL_res5226z00_16588;
								}
								{
									obj_t BgL_l1366z00_16590;
									obj_t BgL_tail1369z00_16591;

									BgL_l1366z00_16590 = BgL_l1366z00_16586;
									BgL_tail1369z00_16591 = BgL_head1368z00_16587;
								BgL_zc3z04anonymousza34023ze3z87_16589:
									if (NULLP(BgL_l1366z00_16590))
										{	/* Eval/evaluate_comp.scm 1167 */
											BgL_arg4021z00_16585 = CDR(BgL_head1368z00_16587);
										}
									else
										{	/* Eval/evaluate_comp.scm 1167 */
											obj_t BgL_newtail1370z00_16592;

											{	/* Eval/evaluate_comp.scm 1167 */
												obj_t BgL_arg4026z00_16593;

												{	/* Eval/evaluate_comp.scm 1167 */
													obj_t BgL_vz00_16594;

													BgL_vz00_16594 = CAR(((obj_t) BgL_l1366z00_16590));
													BgL_arg4026z00_16593 =
														BGl__indexz00zz__evaluate_compz00(BgL_vz00_16594,
														BgL_stkz00_14365);
												}
												{	/* Eval/evaluate_comp.scm 1167 */
													obj_t BgL_res5232z00_16595;

													BgL_res5232z00_16595 =
														MAKE_YOUNG_PAIR(BgL_arg4026z00_16593, BNIL);
													BgL_newtail1370z00_16592 = BgL_res5232z00_16595;
												}
											}
											SET_CDR(BgL_tail1369z00_16591, BgL_newtail1370z00_16592);
											{	/* Eval/evaluate_comp.scm 1167 */
												obj_t BgL_arg4025z00_16596;

												BgL_arg4025z00_16596 =
													CDR(((obj_t) BgL_l1366z00_16590));
												{
													obj_t BgL_tail1369z00_25511;
													obj_t BgL_l1366z00_25510;

													BgL_l1366z00_25510 = BgL_arg4025z00_16596;
													BgL_tail1369z00_25511 = BgL_newtail1370z00_16592;
													BgL_tail1369z00_16591 = BgL_tail1369z00_25511;
													BgL_l1366z00_16590 = BgL_l1366z00_25510;
													goto BgL_zc3z04anonymousza34023ze3z87_16589;
												}
											}
										}
								}
							}
					}
					BgL_ifreesz00_16580 =
						BGl_listzd2ze3vectorz31zz__r4_vectors_6_8z00(BgL_arg4021z00_16585);
				}
				{	/* Eval/evaluate_comp.scm 1168 */
					obj_t BgL_arg4027z00_16597;

					{	/* Eval/evaluate_comp.scm 1168 */
						obj_t BgL_l1371z00_16598;

						BgL_l1371z00_16598 =
							(((BgL_ev_absz00_bglt) COBJECT(
									((BgL_ev_absz00_bglt) BgL_ez00_14364)))->BgL_boxesz00);
						if (NULLP(BgL_l1371z00_16598))
							{	/* Eval/evaluate_comp.scm 1168 */
								BgL_arg4027z00_16597 = BNIL;
							}
						else
							{	/* Eval/evaluate_comp.scm 1168 */
								obj_t BgL_head1373z00_16599;

								{	/* Eval/evaluate_comp.scm 1168 */
									obj_t BgL_res5234z00_16600;

									BgL_res5234z00_16600 = MAKE_YOUNG_PAIR(BNIL, BNIL);
									BgL_head1373z00_16599 = BgL_res5234z00_16600;
								}
								{
									obj_t BgL_l1371z00_16602;
									obj_t BgL_tail1374z00_16603;

									BgL_l1371z00_16602 = BgL_l1371z00_16598;
									BgL_tail1374z00_16603 = BgL_head1373z00_16599;
								BgL_zc3z04anonymousza34029ze3z87_16601:
									if (NULLP(BgL_l1371z00_16602))
										{	/* Eval/evaluate_comp.scm 1168 */
											BgL_arg4027z00_16597 = CDR(BgL_head1373z00_16599);
										}
									else
										{	/* Eval/evaluate_comp.scm 1168 */
											obj_t BgL_newtail1375z00_16604;

											{	/* Eval/evaluate_comp.scm 1168 */
												obj_t BgL_arg4032z00_16605;

												{	/* Eval/evaluate_comp.scm 1168 */
													obj_t BgL_vz00_16606;

													BgL_vz00_16606 = CAR(((obj_t) BgL_l1371z00_16602));
													BgL_arg4032z00_16605 =
														BGl__indexz00zz__evaluate_compz00(BgL_vz00_16606,
														(((BgL_ev_absz00_bglt) COBJECT(
																	((BgL_ev_absz00_bglt) BgL_ez00_14364)))->
															BgL_varsz00));
												}
												{	/* Eval/evaluate_comp.scm 1168 */
													obj_t BgL_res5236z00_16607;

													BgL_res5236z00_16607 =
														MAKE_YOUNG_PAIR(BgL_arg4032z00_16605, BNIL);
													BgL_newtail1375z00_16604 = BgL_res5236z00_16607;
												}
											}
											SET_CDR(BgL_tail1374z00_16603, BgL_newtail1375z00_16604);
											{	/* Eval/evaluate_comp.scm 1168 */
												obj_t BgL_arg4031z00_16608;

												BgL_arg4031z00_16608 =
													CDR(((obj_t) BgL_l1371z00_16602));
												{
													obj_t BgL_tail1374z00_25531;
													obj_t BgL_l1371z00_25530;

													BgL_l1371z00_25530 = BgL_arg4031z00_16608;
													BgL_tail1374z00_25531 = BgL_newtail1375z00_16604;
													BgL_tail1374z00_16603 = BgL_tail1374z00_25531;
													BgL_l1371z00_16602 = BgL_l1371z00_25530;
													goto BgL_zc3z04anonymousza34029ze3z87_16601;
												}
											}
										}
								}
							}
					}
					BgL_iboxesz00_16581 =
						BGl_listzd2ze3vectorz31zz__r4_vectors_6_8z00(BgL_arg4027z00_16597);
				}
				BgL_siza7eza7_16582 =
					bgl_list_length(
					(((BgL_ev_absz00_bglt) COBJECT(
								((BgL_ev_absz00_bglt) BgL_ez00_14364)))->BgL_varsz00));
				BgL_siza7ezd2framez75_16583 =
					(
					(long) (
						(((BgL_ev_absz00_bglt) COBJECT(
									((BgL_ev_absz00_bglt) BgL_ez00_14364)))->BgL_siza7eza7)) +
					bgl_list_length(
						(((BgL_ev_absz00_bglt) COBJECT(
									((BgL_ev_absz00_bglt) BgL_ez00_14364)))->BgL_freez00)));
				BgL_nstkz00_16584 =
					BGl_appendzd221011zd2zz__evaluate_compz00(
					(((BgL_ev_absz00_bglt) COBJECT(
								((BgL_ev_absz00_bglt) BgL_ez00_14364)))->BgL_varsz00),
					(((BgL_ev_absz00_bglt) COBJECT(
								((BgL_ev_absz00_bglt) BgL_ez00_14364)))->BgL_freez00));
				{	/* Eval/evaluate_comp.scm 1172 */
					obj_t BgL_bodyz00_16609;

					BgL_bodyz00_16609 =
						BGl_compz00zz__evaluate_compz00(
						(((BgL_ev_absz00_bglt) COBJECT(
									((BgL_ev_absz00_bglt) BgL_ez00_14364)))->BgL_bodyz00),
						BgL_nstkz00_16584);
					{

						{	/* Eval/evaluate_comp.scm 1174 */
							obj_t BgL_aux1249z00_16615;

							BgL_aux1249z00_16615 =
								(((BgL_ev_absz00_bglt) COBJECT(
										((BgL_ev_absz00_bglt) BgL_ez00_14364)))->BgL_arityz00);
							if (INTEGERP(BgL_aux1249z00_16615))
								{	/* Eval/evaluate_comp.scm 1174 */
									switch ((long) CINT(BgL_aux1249z00_16615))
										{
										case ((long) 0):

											if ((VECTOR_LENGTH(BgL_ifreesz00_16580) == ((long) 0)))
												{	/* Eval/evaluate_comp.scm 1174 */
													if (
														(VECTOR_LENGTH(BgL_iboxesz00_16581) == ((long) 0)))
														{	/* Eval/evaluate_comp.scm 1174 */
															obj_t BgL_zc3z04anonymousza33450ze3z87_16616;

															BgL_zc3z04anonymousza33450ze3z87_16616 =
																MAKE_FX_PROCEDURE
																(BGl_z62zc3z04anonymousza33450ze3ze5zz__evaluate_compz00,
																(int) (((long) 1)), (int) (((long) 3)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33450ze3z87_16616,
																(int) (((long) 0)),
																((obj_t) ((BgL_ev_absz00_bglt)
																		BgL_ez00_14364)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33450ze3z87_16616,
																(int) (((long) 1)), BgL_bodyz00_16609);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33450ze3z87_16616,
																(int) (((long) 2)),
																BINT(BgL_siza7ezd2framez75_16583));
															return BgL_zc3z04anonymousza33450ze3z87_16616;
														}
													else
														{	/* Eval/evaluate_comp.scm 1174 */
															obj_t BgL_zc3z04anonymousza33457ze3z87_16617;

															BgL_zc3z04anonymousza33457ze3z87_16617 =
																MAKE_FX_PROCEDURE
																(BGl_z62zc3z04anonymousza33457ze3ze5zz__evaluate_compz00,
																(int) (((long) 1)), (int) (((long) 4)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33457ze3z87_16617,
																(int) (((long) 0)), BgL_iboxesz00_16581);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33457ze3z87_16617,
																(int) (((long) 1)),
																((obj_t) ((BgL_ev_absz00_bglt)
																		BgL_ez00_14364)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33457ze3z87_16617,
																(int) (((long) 2)), BgL_bodyz00_16609);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33457ze3z87_16617,
																(int) (((long) 3)),
																BINT(BgL_siza7ezd2framez75_16583));
															return BgL_zc3z04anonymousza33457ze3z87_16617;
														}
												}
											else
												{	/* Eval/evaluate_comp.scm 1174 */
													if (
														(VECTOR_LENGTH(BgL_iboxesz00_16581) == ((long) 0)))
														{	/* Eval/evaluate_comp.scm 1174 */
															obj_t BgL_zc3z04anonymousza33467ze3z87_16618;

															BgL_zc3z04anonymousza33467ze3z87_16618 =
																MAKE_FX_PROCEDURE
																(BGl_z62zc3z04anonymousza33467ze3ze5zz__evaluate_compz00,
																(int) (((long) 1)), (int) (((long) 5)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33467ze3z87_16618,
																(int) (((long) 0)), BgL_ifreesz00_16580);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33467ze3z87_16618,
																(int) (((long) 1)), BINT(BgL_siza7eza7_16582));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33467ze3z87_16618,
																(int) (((long) 2)),
																((obj_t) ((BgL_ev_absz00_bglt)
																		BgL_ez00_14364)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33467ze3z87_16618,
																(int) (((long) 3)), BgL_bodyz00_16609);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33467ze3z87_16618,
																(int) (((long) 4)),
																BINT(BgL_siza7ezd2framez75_16583));
															return BgL_zc3z04anonymousza33467ze3z87_16618;
														}
													else
														{	/* Eval/evaluate_comp.scm 1174 */
															obj_t BgL_zc3z04anonymousza33475ze3z87_16619;

															BgL_zc3z04anonymousza33475ze3z87_16619 =
																MAKE_FX_PROCEDURE
																(BGl_z62zc3z04anonymousza33475ze3ze5zz__evaluate_compz00,
																(int) (((long) 1)), (int) (((long) 6)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33475ze3z87_16619,
																(int) (((long) 0)), BgL_ifreesz00_16580);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33475ze3z87_16619,
																(int) (((long) 1)), BgL_iboxesz00_16581);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33475ze3z87_16619,
																(int) (((long) 2)), BINT(BgL_siza7eza7_16582));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33475ze3z87_16619,
																(int) (((long) 3)),
																((obj_t) ((BgL_ev_absz00_bglt)
																		BgL_ez00_14364)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33475ze3z87_16619,
																(int) (((long) 4)), BgL_bodyz00_16609);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33475ze3z87_16619,
																(int) (((long) 5)),
																BINT(BgL_siza7ezd2framez75_16583));
															return BgL_zc3z04anonymousza33475ze3z87_16619;
														}
												}
											break;
										case ((long) -1):

											if ((VECTOR_LENGTH(BgL_ifreesz00_16580) == ((long) 0)))
												{	/* Eval/evaluate_comp.scm 1174 */
													if (
														(VECTOR_LENGTH(BgL_iboxesz00_16581) == ((long) 0)))
														{	/* Eval/evaluate_comp.scm 1174 */
															obj_t BgL_zc3z04anonymousza33489ze3z87_16620;

															BgL_zc3z04anonymousza33489ze3z87_16620 =
																MAKE_FX_PROCEDURE
																(BGl_z62zc3z04anonymousza33489ze3ze5zz__evaluate_compz00,
																(int) (((long) 1)), (int) (((long) 3)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33489ze3z87_16620,
																(int) (((long) 0)),
																((obj_t) ((BgL_ev_absz00_bglt)
																		BgL_ez00_14364)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33489ze3z87_16620,
																(int) (((long) 1)), BgL_bodyz00_16609);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33489ze3z87_16620,
																(int) (((long) 2)),
																BINT(BgL_siza7ezd2framez75_16583));
															return BgL_zc3z04anonymousza33489ze3z87_16620;
														}
													else
														{	/* Eval/evaluate_comp.scm 1174 */
															obj_t BgL_zc3z04anonymousza33497ze3z87_16621;

															BgL_zc3z04anonymousza33497ze3z87_16621 =
																MAKE_FX_PROCEDURE
																(BGl_z62zc3z04anonymousza33497ze3ze5zz__evaluate_compz00,
																(int) (((long) 1)), (int) (((long) 4)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33497ze3z87_16621,
																(int) (((long) 0)), BgL_iboxesz00_16581);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33497ze3z87_16621,
																(int) (((long) 1)),
																((obj_t) ((BgL_ev_absz00_bglt)
																		BgL_ez00_14364)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33497ze3z87_16621,
																(int) (((long) 2)), BgL_bodyz00_16609);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33497ze3z87_16621,
																(int) (((long) 3)),
																BINT(BgL_siza7ezd2framez75_16583));
															return BgL_zc3z04anonymousza33497ze3z87_16621;
														}
												}
											else
												{	/* Eval/evaluate_comp.scm 1174 */
													if (
														(VECTOR_LENGTH(BgL_iboxesz00_16581) == ((long) 0)))
														{	/* Eval/evaluate_comp.scm 1174 */
															obj_t BgL_zc3z04anonymousza33509ze3z87_16622;

															BgL_zc3z04anonymousza33509ze3z87_16622 =
																MAKE_FX_PROCEDURE
																(BGl_z62zc3z04anonymousza33509ze3ze5zz__evaluate_compz00,
																(int) (((long) 1)), (int) (((long) 5)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33509ze3z87_16622,
																(int) (((long) 0)), BgL_ifreesz00_16580);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33509ze3z87_16622,
																(int) (((long) 1)), BINT(BgL_siza7eza7_16582));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33509ze3z87_16622,
																(int) (((long) 2)),
																((obj_t) ((BgL_ev_absz00_bglt)
																		BgL_ez00_14364)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33509ze3z87_16622,
																(int) (((long) 3)), BgL_bodyz00_16609);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33509ze3z87_16622,
																(int) (((long) 4)),
																BINT(BgL_siza7ezd2framez75_16583));
															return BgL_zc3z04anonymousza33509ze3z87_16622;
														}
													else
														{	/* Eval/evaluate_comp.scm 1174 */
															obj_t BgL_zc3z04anonymousza33519ze3z87_16623;

															BgL_zc3z04anonymousza33519ze3z87_16623 =
																MAKE_FX_PROCEDURE
																(BGl_z62zc3z04anonymousza33519ze3ze5zz__evaluate_compz00,
																(int) (((long) 1)), (int) (((long) 6)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33519ze3z87_16623,
																(int) (((long) 0)), BgL_ifreesz00_16580);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33519ze3z87_16623,
																(int) (((long) 1)), BgL_iboxesz00_16581);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33519ze3z87_16623,
																(int) (((long) 2)), BINT(BgL_siza7eza7_16582));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33519ze3z87_16623,
																(int) (((long) 3)),
																((obj_t) ((BgL_ev_absz00_bglt)
																		BgL_ez00_14364)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33519ze3z87_16623,
																(int) (((long) 4)), BgL_bodyz00_16609);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33519ze3z87_16623,
																(int) (((long) 5)),
																BINT(BgL_siza7ezd2framez75_16583));
															return BgL_zc3z04anonymousza33519ze3z87_16623;
														}
												}
											break;
										case ((long) 1):

											if ((VECTOR_LENGTH(BgL_ifreesz00_16580) == ((long) 0)))
												{	/* Eval/evaluate_comp.scm 1174 */
													if (
														(VECTOR_LENGTH(BgL_iboxesz00_16581) == ((long) 0)))
														{	/* Eval/evaluate_comp.scm 1174 */
															obj_t BgL_zc3z04anonymousza33534ze3z87_16624;

															BgL_zc3z04anonymousza33534ze3z87_16624 =
																MAKE_FX_PROCEDURE
																(BGl_z62zc3z04anonymousza33534ze3ze5zz__evaluate_compz00,
																(int) (((long) 1)), (int) (((long) 3)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33534ze3z87_16624,
																(int) (((long) 0)),
																((obj_t) ((BgL_ev_absz00_bglt)
																		BgL_ez00_14364)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33534ze3z87_16624,
																(int) (((long) 1)), BgL_bodyz00_16609);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33534ze3z87_16624,
																(int) (((long) 2)),
																BINT(BgL_siza7ezd2framez75_16583));
															return BgL_zc3z04anonymousza33534ze3z87_16624;
														}
													else
														{	/* Eval/evaluate_comp.scm 1174 */
															obj_t BgL_zc3z04anonymousza33541ze3z87_16625;

															BgL_zc3z04anonymousza33541ze3z87_16625 =
																MAKE_FX_PROCEDURE
																(BGl_z62zc3z04anonymousza33541ze3ze5zz__evaluate_compz00,
																(int) (((long) 1)), (int) (((long) 4)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33541ze3z87_16625,
																(int) (((long) 0)), BgL_iboxesz00_16581);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33541ze3z87_16625,
																(int) (((long) 1)),
																((obj_t) ((BgL_ev_absz00_bglt)
																		BgL_ez00_14364)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33541ze3z87_16625,
																(int) (((long) 2)), BgL_bodyz00_16609);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33541ze3z87_16625,
																(int) (((long) 3)),
																BINT(BgL_siza7ezd2framez75_16583));
															return BgL_zc3z04anonymousza33541ze3z87_16625;
														}
												}
											else
												{	/* Eval/evaluate_comp.scm 1174 */
													if (
														(VECTOR_LENGTH(BgL_iboxesz00_16581) == ((long) 0)))
														{	/* Eval/evaluate_comp.scm 1174 */
															obj_t BgL_zc3z04anonymousza33553ze3z87_16626;

															BgL_zc3z04anonymousza33553ze3z87_16626 =
																MAKE_FX_PROCEDURE
																(BGl_z62zc3z04anonymousza33553ze3ze5zz__evaluate_compz00,
																(int) (((long) 1)), (int) (((long) 5)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33553ze3z87_16626,
																(int) (((long) 0)), BgL_ifreesz00_16580);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33553ze3z87_16626,
																(int) (((long) 1)), BINT(BgL_siza7eza7_16582));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33553ze3z87_16626,
																(int) (((long) 2)),
																((obj_t) ((BgL_ev_absz00_bglt)
																		BgL_ez00_14364)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33553ze3z87_16626,
																(int) (((long) 3)), BgL_bodyz00_16609);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33553ze3z87_16626,
																(int) (((long) 4)),
																BINT(BgL_siza7ezd2framez75_16583));
															return BgL_zc3z04anonymousza33553ze3z87_16626;
														}
													else
														{	/* Eval/evaluate_comp.scm 1174 */
															obj_t BgL_zc3z04anonymousza33561ze3z87_16627;

															BgL_zc3z04anonymousza33561ze3z87_16627 =
																MAKE_FX_PROCEDURE
																(BGl_z62zc3z04anonymousza33561ze3ze5zz__evaluate_compz00,
																(int) (((long) 1)), (int) (((long) 6)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33561ze3z87_16627,
																(int) (((long) 0)), BgL_ifreesz00_16580);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33561ze3z87_16627,
																(int) (((long) 1)), BgL_iboxesz00_16581);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33561ze3z87_16627,
																(int) (((long) 2)), BINT(BgL_siza7eza7_16582));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33561ze3z87_16627,
																(int) (((long) 3)),
																((obj_t) ((BgL_ev_absz00_bglt)
																		BgL_ez00_14364)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33561ze3z87_16627,
																(int) (((long) 4)), BgL_bodyz00_16609);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33561ze3z87_16627,
																(int) (((long) 5)),
																BINT(BgL_siza7ezd2framez75_16583));
															return BgL_zc3z04anonymousza33561ze3z87_16627;
														}
												}
											break;
										case ((long) -2):

											if ((VECTOR_LENGTH(BgL_ifreesz00_16580) == ((long) 0)))
												{	/* Eval/evaluate_comp.scm 1174 */
													if (
														(VECTOR_LENGTH(BgL_iboxesz00_16581) == ((long) 0)))
														{	/* Eval/evaluate_comp.scm 1174 */
															obj_t BgL_zc3z04anonymousza33577ze3z87_16628;

															BgL_zc3z04anonymousza33577ze3z87_16628 =
																MAKE_FX_PROCEDURE
																(BGl_z62zc3z04anonymousza33577ze3ze5zz__evaluate_compz00,
																(int) (((long) 1)), (int) (((long) 3)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33577ze3z87_16628,
																(int) (((long) 0)),
																((obj_t) ((BgL_ev_absz00_bglt)
																		BgL_ez00_14364)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33577ze3z87_16628,
																(int) (((long) 1)), BgL_bodyz00_16609);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33577ze3z87_16628,
																(int) (((long) 2)),
																BINT(BgL_siza7ezd2framez75_16583));
															return BgL_zc3z04anonymousza33577ze3z87_16628;
														}
													else
														{	/* Eval/evaluate_comp.scm 1174 */
															obj_t BgL_zc3z04anonymousza33587ze3z87_16629;

															BgL_zc3z04anonymousza33587ze3z87_16629 =
																MAKE_FX_PROCEDURE
																(BGl_z62zc3z04anonymousza33587ze3ze5zz__evaluate_compz00,
																(int) (((long) 1)), (int) (((long) 4)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33587ze3z87_16629,
																(int) (((long) 0)), BgL_iboxesz00_16581);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33587ze3z87_16629,
																(int) (((long) 1)),
																((obj_t) ((BgL_ev_absz00_bglt)
																		BgL_ez00_14364)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33587ze3z87_16629,
																(int) (((long) 2)), BgL_bodyz00_16609);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33587ze3z87_16629,
																(int) (((long) 3)),
																BINT(BgL_siza7ezd2framez75_16583));
															return BgL_zc3z04anonymousza33587ze3z87_16629;
														}
												}
											else
												{	/* Eval/evaluate_comp.scm 1174 */
													if (
														(VECTOR_LENGTH(BgL_iboxesz00_16581) == ((long) 0)))
														{	/* Eval/evaluate_comp.scm 1174 */
															obj_t BgL_zc3z04anonymousza33600ze3z87_16630;

															BgL_zc3z04anonymousza33600ze3z87_16630 =
																MAKE_FX_PROCEDURE
																(BGl_z62zc3z04anonymousza33600ze3ze5zz__evaluate_compz00,
																(int) (((long) 1)), (int) (((long) 5)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33600ze3z87_16630,
																(int) (((long) 0)), BgL_ifreesz00_16580);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33600ze3z87_16630,
																(int) (((long) 1)), BINT(BgL_siza7eza7_16582));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33600ze3z87_16630,
																(int) (((long) 2)),
																((obj_t) ((BgL_ev_absz00_bglt)
																		BgL_ez00_14364)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33600ze3z87_16630,
																(int) (((long) 3)), BgL_bodyz00_16609);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33600ze3z87_16630,
																(int) (((long) 4)),
																BINT(BgL_siza7ezd2framez75_16583));
															return BgL_zc3z04anonymousza33600ze3z87_16630;
														}
													else
														{	/* Eval/evaluate_comp.scm 1174 */
															obj_t BgL_zc3z04anonymousza33609ze3z87_16631;

															BgL_zc3z04anonymousza33609ze3z87_16631 =
																MAKE_FX_PROCEDURE
																(BGl_z62zc3z04anonymousza33609ze3ze5zz__evaluate_compz00,
																(int) (((long) 1)), (int) (((long) 6)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33609ze3z87_16631,
																(int) (((long) 0)), BgL_ifreesz00_16580);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33609ze3z87_16631,
																(int) (((long) 1)), BgL_iboxesz00_16581);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33609ze3z87_16631,
																(int) (((long) 2)), BINT(BgL_siza7eza7_16582));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33609ze3z87_16631,
																(int) (((long) 3)),
																((obj_t) ((BgL_ev_absz00_bglt)
																		BgL_ez00_14364)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33609ze3z87_16631,
																(int) (((long) 4)), BgL_bodyz00_16609);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33609ze3z87_16631,
																(int) (((long) 5)),
																BINT(BgL_siza7ezd2framez75_16583));
															return BgL_zc3z04anonymousza33609ze3z87_16631;
														}
												}
											break;
										case ((long) 2):

											if ((VECTOR_LENGTH(BgL_ifreesz00_16580) == ((long) 0)))
												{	/* Eval/evaluate_comp.scm 1174 */
													if (
														(VECTOR_LENGTH(BgL_iboxesz00_16581) == ((long) 0)))
														{	/* Eval/evaluate_comp.scm 1174 */
															obj_t BgL_zc3z04anonymousza33629ze3z87_16632;

															BgL_zc3z04anonymousza33629ze3z87_16632 =
																MAKE_FX_PROCEDURE
																(BGl_z62zc3z04anonymousza33629ze3ze5zz__evaluate_compz00,
																(int) (((long) 1)), (int) (((long) 3)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33629ze3z87_16632,
																(int) (((long) 0)),
																((obj_t) ((BgL_ev_absz00_bglt)
																		BgL_ez00_14364)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33629ze3z87_16632,
																(int) (((long) 1)), BgL_bodyz00_16609);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33629ze3z87_16632,
																(int) (((long) 2)),
																BINT(BgL_siza7ezd2framez75_16583));
															return BgL_zc3z04anonymousza33629ze3z87_16632;
														}
													else
														{	/* Eval/evaluate_comp.scm 1174 */
															obj_t BgL_zc3z04anonymousza33639ze3z87_16633;

															BgL_zc3z04anonymousza33639ze3z87_16633 =
																MAKE_FX_PROCEDURE
																(BGl_z62zc3z04anonymousza33639ze3ze5zz__evaluate_compz00,
																(int) (((long) 1)), (int) (((long) 4)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33639ze3z87_16633,
																(int) (((long) 0)), BgL_iboxesz00_16581);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33639ze3z87_16633,
																(int) (((long) 1)),
																((obj_t) ((BgL_ev_absz00_bglt)
																		BgL_ez00_14364)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33639ze3z87_16633,
																(int) (((long) 2)), BgL_bodyz00_16609);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33639ze3z87_16633,
																(int) (((long) 3)),
																BINT(BgL_siza7ezd2framez75_16583));
															return BgL_zc3z04anonymousza33639ze3z87_16633;
														}
												}
											else
												{	/* Eval/evaluate_comp.scm 1174 */
													if (
														(VECTOR_LENGTH(BgL_iboxesz00_16581) == ((long) 0)))
														{	/* Eval/evaluate_comp.scm 1174 */
															obj_t BgL_zc3z04anonymousza33651ze3z87_16634;

															BgL_zc3z04anonymousza33651ze3z87_16634 =
																MAKE_FX_PROCEDURE
																(BGl_z62zc3z04anonymousza33651ze3ze5zz__evaluate_compz00,
																(int) (((long) 1)), (int) (((long) 5)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33651ze3z87_16634,
																(int) (((long) 0)), BgL_ifreesz00_16580);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33651ze3z87_16634,
																(int) (((long) 1)), BINT(BgL_siza7eza7_16582));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33651ze3z87_16634,
																(int) (((long) 2)),
																((obj_t) ((BgL_ev_absz00_bglt)
																		BgL_ez00_14364)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33651ze3z87_16634,
																(int) (((long) 3)), BgL_bodyz00_16609);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33651ze3z87_16634,
																(int) (((long) 4)),
																BINT(BgL_siza7ezd2framez75_16583));
															return BgL_zc3z04anonymousza33651ze3z87_16634;
														}
													else
														{	/* Eval/evaluate_comp.scm 1174 */
															obj_t BgL_zc3z04anonymousza33661ze3z87_16635;

															BgL_zc3z04anonymousza33661ze3z87_16635 =
																MAKE_FX_PROCEDURE
																(BGl_z62zc3z04anonymousza33661ze3ze5zz__evaluate_compz00,
																(int) (((long) 1)), (int) (((long) 6)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33661ze3z87_16635,
																(int) (((long) 0)), BgL_ifreesz00_16580);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33661ze3z87_16635,
																(int) (((long) 1)), BgL_iboxesz00_16581);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33661ze3z87_16635,
																(int) (((long) 2)), BINT(BgL_siza7eza7_16582));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33661ze3z87_16635,
																(int) (((long) 3)),
																((obj_t) ((BgL_ev_absz00_bglt)
																		BgL_ez00_14364)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33661ze3z87_16635,
																(int) (((long) 4)), BgL_bodyz00_16609);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33661ze3z87_16635,
																(int) (((long) 5)),
																BINT(BgL_siza7ezd2framez75_16583));
															return BgL_zc3z04anonymousza33661ze3z87_16635;
														}
												}
											break;
										case ((long) -3):

											if ((VECTOR_LENGTH(BgL_ifreesz00_16580) == ((long) 0)))
												{	/* Eval/evaluate_comp.scm 1174 */
													if (
														(VECTOR_LENGTH(BgL_iboxesz00_16581) == ((long) 0)))
														{	/* Eval/evaluate_comp.scm 1174 */
															obj_t BgL_zc3z04anonymousza33678ze3z87_16636;

															BgL_zc3z04anonymousza33678ze3z87_16636 =
																MAKE_FX_PROCEDURE
																(BGl_z62zc3z04anonymousza33678ze3ze5zz__evaluate_compz00,
																(int) (((long) 1)), (int) (((long) 3)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33678ze3z87_16636,
																(int) (((long) 0)),
																((obj_t) ((BgL_ev_absz00_bglt)
																		BgL_ez00_14364)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33678ze3z87_16636,
																(int) (((long) 1)), BgL_bodyz00_16609);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33678ze3z87_16636,
																(int) (((long) 2)),
																BINT(BgL_siza7ezd2framez75_16583));
															return BgL_zc3z04anonymousza33678ze3z87_16636;
														}
													else
														{	/* Eval/evaluate_comp.scm 1174 */
															obj_t BgL_zc3z04anonymousza33688ze3z87_16637;

															BgL_zc3z04anonymousza33688ze3z87_16637 =
																MAKE_FX_PROCEDURE
																(BGl_z62zc3z04anonymousza33688ze3ze5zz__evaluate_compz00,
																(int) (((long) 1)), (int) (((long) 4)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33688ze3z87_16637,
																(int) (((long) 0)), BgL_iboxesz00_16581);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33688ze3z87_16637,
																(int) (((long) 1)),
																((obj_t) ((BgL_ev_absz00_bglt)
																		BgL_ez00_14364)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33688ze3z87_16637,
																(int) (((long) 2)), BgL_bodyz00_16609);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33688ze3z87_16637,
																(int) (((long) 3)),
																BINT(BgL_siza7ezd2framez75_16583));
															return BgL_zc3z04anonymousza33688ze3z87_16637;
														}
												}
											else
												{	/* Eval/evaluate_comp.scm 1174 */
													if (
														(VECTOR_LENGTH(BgL_iboxesz00_16581) == ((long) 0)))
														{	/* Eval/evaluate_comp.scm 1174 */
															obj_t BgL_zc3z04anonymousza33702ze3z87_16638;

															BgL_zc3z04anonymousza33702ze3z87_16638 =
																MAKE_FX_PROCEDURE
																(BGl_z62zc3z04anonymousza33702ze3ze5zz__evaluate_compz00,
																(int) (((long) 1)), (int) (((long) 5)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33702ze3z87_16638,
																(int) (((long) 0)), BgL_ifreesz00_16580);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33702ze3z87_16638,
																(int) (((long) 1)), BINT(BgL_siza7eza7_16582));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33702ze3z87_16638,
																(int) (((long) 2)),
																((obj_t) ((BgL_ev_absz00_bglt)
																		BgL_ez00_14364)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33702ze3z87_16638,
																(int) (((long) 3)), BgL_bodyz00_16609);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33702ze3z87_16638,
																(int) (((long) 4)),
																BINT(BgL_siza7ezd2framez75_16583));
															return BgL_zc3z04anonymousza33702ze3z87_16638;
														}
													else
														{	/* Eval/evaluate_comp.scm 1174 */
															obj_t BgL_zc3z04anonymousza33712ze3z87_16639;

															BgL_zc3z04anonymousza33712ze3z87_16639 =
																MAKE_FX_PROCEDURE
																(BGl_z62zc3z04anonymousza33712ze3ze5zz__evaluate_compz00,
																(int) (((long) 1)), (int) (((long) 6)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33712ze3z87_16639,
																(int) (((long) 0)), BgL_ifreesz00_16580);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33712ze3z87_16639,
																(int) (((long) 1)), BgL_iboxesz00_16581);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33712ze3z87_16639,
																(int) (((long) 2)), BINT(BgL_siza7eza7_16582));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33712ze3z87_16639,
																(int) (((long) 3)),
																((obj_t) ((BgL_ev_absz00_bglt)
																		BgL_ez00_14364)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33712ze3z87_16639,
																(int) (((long) 4)), BgL_bodyz00_16609);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33712ze3z87_16639,
																(int) (((long) 5)),
																BINT(BgL_siza7ezd2framez75_16583));
															return BgL_zc3z04anonymousza33712ze3z87_16639;
														}
												}
											break;
										case ((long) 3):

											if ((VECTOR_LENGTH(BgL_ifreesz00_16580) == ((long) 0)))
												{	/* Eval/evaluate_comp.scm 1174 */
													if (
														(VECTOR_LENGTH(BgL_iboxesz00_16581) == ((long) 0)))
														{	/* Eval/evaluate_comp.scm 1174 */
															obj_t BgL_zc3z04anonymousza33729ze3z87_16640;

															BgL_zc3z04anonymousza33729ze3z87_16640 =
																MAKE_FX_PROCEDURE
																(BGl_z62zc3z04anonymousza33729ze3ze5zz__evaluate_compz00,
																(int) (((long) 1)), (int) (((long) 3)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33729ze3z87_16640,
																(int) (((long) 0)),
																((obj_t) ((BgL_ev_absz00_bglt)
																		BgL_ez00_14364)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33729ze3z87_16640,
																(int) (((long) 1)), BgL_bodyz00_16609);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33729ze3z87_16640,
																(int) (((long) 2)),
																BINT(BgL_siza7ezd2framez75_16583));
															return BgL_zc3z04anonymousza33729ze3z87_16640;
														}
													else
														{	/* Eval/evaluate_comp.scm 1174 */
															obj_t BgL_zc3z04anonymousza33738ze3z87_16641;

															BgL_zc3z04anonymousza33738ze3z87_16641 =
																MAKE_FX_PROCEDURE
																(BGl_z62zc3z04anonymousza33738ze3ze5zz__evaluate_compz00,
																(int) (((long) 1)), (int) (((long) 4)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33738ze3z87_16641,
																(int) (((long) 0)), BgL_iboxesz00_16581);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33738ze3z87_16641,
																(int) (((long) 1)),
																((obj_t) ((BgL_ev_absz00_bglt)
																		BgL_ez00_14364)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33738ze3z87_16641,
																(int) (((long) 2)), BgL_bodyz00_16609);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33738ze3z87_16641,
																(int) (((long) 3)),
																BINT(BgL_siza7ezd2framez75_16583));
															return BgL_zc3z04anonymousza33738ze3z87_16641;
														}
												}
											else
												{	/* Eval/evaluate_comp.scm 1174 */
													if (
														(VECTOR_LENGTH(BgL_iboxesz00_16581) == ((long) 0)))
														{	/* Eval/evaluate_comp.scm 1174 */
															obj_t BgL_zc3z04anonymousza33750ze3z87_16642;

															BgL_zc3z04anonymousza33750ze3z87_16642 =
																MAKE_FX_PROCEDURE
																(BGl_z62zc3z04anonymousza33750ze3ze5zz__evaluate_compz00,
																(int) (((long) 1)), (int) (((long) 5)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33750ze3z87_16642,
																(int) (((long) 0)), BgL_ifreesz00_16580);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33750ze3z87_16642,
																(int) (((long) 1)), BINT(BgL_siza7eza7_16582));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33750ze3z87_16642,
																(int) (((long) 2)),
																((obj_t) ((BgL_ev_absz00_bglt)
																		BgL_ez00_14364)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33750ze3z87_16642,
																(int) (((long) 3)), BgL_bodyz00_16609);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33750ze3z87_16642,
																(int) (((long) 4)),
																BINT(BgL_siza7ezd2framez75_16583));
															return BgL_zc3z04anonymousza33750ze3z87_16642;
														}
													else
														{	/* Eval/evaluate_comp.scm 1174 */
															obj_t BgL_zc3z04anonymousza33760ze3z87_16643;

															BgL_zc3z04anonymousza33760ze3z87_16643 =
																MAKE_FX_PROCEDURE
																(BGl_z62zc3z04anonymousza33760ze3ze5zz__evaluate_compz00,
																(int) (((long) 1)), (int) (((long) 6)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33760ze3z87_16643,
																(int) (((long) 0)), BgL_ifreesz00_16580);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33760ze3z87_16643,
																(int) (((long) 1)), BgL_iboxesz00_16581);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33760ze3z87_16643,
																(int) (((long) 2)), BINT(BgL_siza7eza7_16582));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33760ze3z87_16643,
																(int) (((long) 3)),
																((obj_t) ((BgL_ev_absz00_bglt)
																		BgL_ez00_14364)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33760ze3z87_16643,
																(int) (((long) 4)), BgL_bodyz00_16609);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33760ze3z87_16643,
																(int) (((long) 5)),
																BINT(BgL_siza7ezd2framez75_16583));
															return BgL_zc3z04anonymousza33760ze3z87_16643;
														}
												}
											break;
										case ((long) -4):

											if ((VECTOR_LENGTH(BgL_ifreesz00_16580) == ((long) 0)))
												{	/* Eval/evaluate_comp.scm 1174 */
													if (
														(VECTOR_LENGTH(BgL_iboxesz00_16581) == ((long) 0)))
														{	/* Eval/evaluate_comp.scm 1174 */
															obj_t BgL_zc3z04anonymousza33776ze3z87_16644;

															BgL_zc3z04anonymousza33776ze3z87_16644 =
																MAKE_FX_PROCEDURE
																(BGl_z62zc3z04anonymousza33776ze3ze5zz__evaluate_compz00,
																(int) (((long) 1)), (int) (((long) 3)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33776ze3z87_16644,
																(int) (((long) 0)),
																((obj_t) ((BgL_ev_absz00_bglt)
																		BgL_ez00_14364)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33776ze3z87_16644,
																(int) (((long) 1)), BgL_bodyz00_16609);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33776ze3z87_16644,
																(int) (((long) 2)),
																BINT(BgL_siza7ezd2framez75_16583));
															return BgL_zc3z04anonymousza33776ze3z87_16644;
														}
													else
														{	/* Eval/evaluate_comp.scm 1174 */
															obj_t BgL_zc3z04anonymousza33786ze3z87_16645;

															BgL_zc3z04anonymousza33786ze3z87_16645 =
																MAKE_FX_PROCEDURE
																(BGl_z62zc3z04anonymousza33786ze3ze5zz__evaluate_compz00,
																(int) (((long) 1)), (int) (((long) 4)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33786ze3z87_16645,
																(int) (((long) 0)), BgL_iboxesz00_16581);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33786ze3z87_16645,
																(int) (((long) 1)),
																((obj_t) ((BgL_ev_absz00_bglt)
																		BgL_ez00_14364)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33786ze3z87_16645,
																(int) (((long) 2)), BgL_bodyz00_16609);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33786ze3z87_16645,
																(int) (((long) 3)),
																BINT(BgL_siza7ezd2framez75_16583));
															return BgL_zc3z04anonymousza33786ze3z87_16645;
														}
												}
											else
												{	/* Eval/evaluate_comp.scm 1174 */
													if (
														(VECTOR_LENGTH(BgL_iboxesz00_16581) == ((long) 0)))
														{	/* Eval/evaluate_comp.scm 1174 */
															obj_t BgL_zc3z04anonymousza33799ze3z87_16646;

															BgL_zc3z04anonymousza33799ze3z87_16646 =
																MAKE_FX_PROCEDURE
																(BGl_z62zc3z04anonymousza33799ze3ze5zz__evaluate_compz00,
																(int) (((long) 1)), (int) (((long) 5)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33799ze3z87_16646,
																(int) (((long) 0)), BgL_ifreesz00_16580);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33799ze3z87_16646,
																(int) (((long) 1)), BINT(BgL_siza7eza7_16582));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33799ze3z87_16646,
																(int) (((long) 2)),
																((obj_t) ((BgL_ev_absz00_bglt)
																		BgL_ez00_14364)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33799ze3z87_16646,
																(int) (((long) 3)), BgL_bodyz00_16609);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33799ze3z87_16646,
																(int) (((long) 4)),
																BINT(BgL_siza7ezd2framez75_16583));
															return BgL_zc3z04anonymousza33799ze3z87_16646;
														}
													else
														{	/* Eval/evaluate_comp.scm 1174 */
															obj_t BgL_zc3z04anonymousza33810ze3z87_16647;

															BgL_zc3z04anonymousza33810ze3z87_16647 =
																MAKE_FX_PROCEDURE
																(BGl_z62zc3z04anonymousza33810ze3ze5zz__evaluate_compz00,
																(int) (((long) 1)), (int) (((long) 6)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33810ze3z87_16647,
																(int) (((long) 0)), BgL_ifreesz00_16580);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33810ze3z87_16647,
																(int) (((long) 1)), BgL_iboxesz00_16581);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33810ze3z87_16647,
																(int) (((long) 2)), BINT(BgL_siza7eza7_16582));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33810ze3z87_16647,
																(int) (((long) 3)),
																((obj_t) ((BgL_ev_absz00_bglt)
																		BgL_ez00_14364)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33810ze3z87_16647,
																(int) (((long) 4)), BgL_bodyz00_16609);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33810ze3z87_16647,
																(int) (((long) 5)),
																BINT(BgL_siza7ezd2framez75_16583));
															return BgL_zc3z04anonymousza33810ze3z87_16647;
														}
												}
											break;
										case ((long) 4):

											if ((VECTOR_LENGTH(BgL_ifreesz00_16580) == ((long) 0)))
												{	/* Eval/evaluate_comp.scm 1174 */
													if (
														(VECTOR_LENGTH(BgL_iboxesz00_16581) == ((long) 0)))
														{	/* Eval/evaluate_comp.scm 1174 */
															obj_t BgL_zc3z04anonymousza33827ze3z87_16648;

															BgL_zc3z04anonymousza33827ze3z87_16648 =
																MAKE_FX_PROCEDURE
																(BGl_z62zc3z04anonymousza33827ze3ze5zz__evaluate_compz00,
																(int) (((long) 1)), (int) (((long) 3)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33827ze3z87_16648,
																(int) (((long) 0)),
																((obj_t) ((BgL_ev_absz00_bglt)
																		BgL_ez00_14364)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33827ze3z87_16648,
																(int) (((long) 1)), BgL_bodyz00_16609);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33827ze3z87_16648,
																(int) (((long) 2)),
																BINT(BgL_siza7ezd2framez75_16583));
															return BgL_zc3z04anonymousza33827ze3z87_16648;
														}
													else
														{	/* Eval/evaluate_comp.scm 1174 */
															obj_t BgL_zc3z04anonymousza33837ze3z87_16649;

															BgL_zc3z04anonymousza33837ze3z87_16649 =
																MAKE_FX_PROCEDURE
																(BGl_z62zc3z04anonymousza33837ze3ze5zz__evaluate_compz00,
																(int) (((long) 1)), (int) (((long) 4)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33837ze3z87_16649,
																(int) (((long) 0)), BgL_iboxesz00_16581);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33837ze3z87_16649,
																(int) (((long) 1)),
																((obj_t) ((BgL_ev_absz00_bglt)
																		BgL_ez00_14364)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33837ze3z87_16649,
																(int) (((long) 2)), BgL_bodyz00_16609);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33837ze3z87_16649,
																(int) (((long) 3)),
																BINT(BgL_siza7ezd2framez75_16583));
															return BgL_zc3z04anonymousza33837ze3z87_16649;
														}
												}
											else
												{	/* Eval/evaluate_comp.scm 1174 */
													if (
														(VECTOR_LENGTH(BgL_iboxesz00_16581) == ((long) 0)))
														{	/* Eval/evaluate_comp.scm 1174 */
															obj_t BgL_zc3z04anonymousza33850ze3z87_16650;

															BgL_zc3z04anonymousza33850ze3z87_16650 =
																MAKE_FX_PROCEDURE
																(BGl_z62zc3z04anonymousza33850ze3ze5zz__evaluate_compz00,
																(int) (((long) 1)), (int) (((long) 5)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33850ze3z87_16650,
																(int) (((long) 0)), BgL_ifreesz00_16580);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33850ze3z87_16650,
																(int) (((long) 1)), BINT(BgL_siza7eza7_16582));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33850ze3z87_16650,
																(int) (((long) 2)),
																((obj_t) ((BgL_ev_absz00_bglt)
																		BgL_ez00_14364)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33850ze3z87_16650,
																(int) (((long) 3)), BgL_bodyz00_16609);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33850ze3z87_16650,
																(int) (((long) 4)),
																BINT(BgL_siza7ezd2framez75_16583));
															return BgL_zc3z04anonymousza33850ze3z87_16650;
														}
													else
														{	/* Eval/evaluate_comp.scm 1174 */
															obj_t BgL_zc3z04anonymousza33861ze3z87_16651;

															BgL_zc3z04anonymousza33861ze3z87_16651 =
																MAKE_FX_PROCEDURE
																(BGl_z62zc3z04anonymousza33861ze3ze5zz__evaluate_compz00,
																(int) (((long) 1)), (int) (((long) 6)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33861ze3z87_16651,
																(int) (((long) 0)), BgL_ifreesz00_16580);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33861ze3z87_16651,
																(int) (((long) 1)), BgL_iboxesz00_16581);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33861ze3z87_16651,
																(int) (((long) 2)), BINT(BgL_siza7eza7_16582));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33861ze3z87_16651,
																(int) (((long) 3)),
																((obj_t) ((BgL_ev_absz00_bglt)
																		BgL_ez00_14364)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33861ze3z87_16651,
																(int) (((long) 4)), BgL_bodyz00_16609);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33861ze3z87_16651,
																(int) (((long) 5)),
																BINT(BgL_siza7ezd2framez75_16583));
															return BgL_zc3z04anonymousza33861ze3z87_16651;
														}
												}
											break;
										case ((long) -5):

											if ((VECTOR_LENGTH(BgL_ifreesz00_16580) == ((long) 0)))
												{	/* Eval/evaluate_comp.scm 1174 */
													if (
														(VECTOR_LENGTH(BgL_iboxesz00_16581) == ((long) 0)))
														{	/* Eval/evaluate_comp.scm 1174 */
															obj_t BgL_zc3z04anonymousza33878ze3z87_16652;

															BgL_zc3z04anonymousza33878ze3z87_16652 =
																MAKE_FX_PROCEDURE
																(BGl_z62zc3z04anonymousza33878ze3ze5zz__evaluate_compz00,
																(int) (((long) 1)), (int) (((long) 3)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33878ze3z87_16652,
																(int) (((long) 0)),
																((obj_t) ((BgL_ev_absz00_bglt)
																		BgL_ez00_14364)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33878ze3z87_16652,
																(int) (((long) 1)), BgL_bodyz00_16609);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33878ze3z87_16652,
																(int) (((long) 2)),
																BINT(BgL_siza7ezd2framez75_16583));
															return BgL_zc3z04anonymousza33878ze3z87_16652;
														}
													else
														{	/* Eval/evaluate_comp.scm 1174 */
															obj_t BgL_zc3z04anonymousza33889ze3z87_16653;

															BgL_zc3z04anonymousza33889ze3z87_16653 =
																MAKE_FX_PROCEDURE
																(BGl_z62zc3z04anonymousza33889ze3ze5zz__evaluate_compz00,
																(int) (((long) 1)), (int) (((long) 4)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33889ze3z87_16653,
																(int) (((long) 0)), BgL_iboxesz00_16581);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33889ze3z87_16653,
																(int) (((long) 1)),
																((obj_t) ((BgL_ev_absz00_bglt)
																		BgL_ez00_14364)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33889ze3z87_16653,
																(int) (((long) 2)), BgL_bodyz00_16609);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33889ze3z87_16653,
																(int) (((long) 3)),
																BINT(BgL_siza7ezd2framez75_16583));
															return BgL_zc3z04anonymousza33889ze3z87_16653;
														}
												}
											else
												{	/* Eval/evaluate_comp.scm 1174 */
													if (
														(VECTOR_LENGTH(BgL_iboxesz00_16581) == ((long) 0)))
														{	/* Eval/evaluate_comp.scm 1174 */
															obj_t BgL_zc3z04anonymousza33903ze3z87_16654;

															BgL_zc3z04anonymousza33903ze3z87_16654 =
																MAKE_FX_PROCEDURE
																(BGl_z62zc3z04anonymousza33903ze3ze5zz__evaluate_compz00,
																(int) (((long) 1)), (int) (((long) 5)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33903ze3z87_16654,
																(int) (((long) 0)), BgL_ifreesz00_16580);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33903ze3z87_16654,
																(int) (((long) 1)), BINT(BgL_siza7eza7_16582));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33903ze3z87_16654,
																(int) (((long) 2)),
																((obj_t) ((BgL_ev_absz00_bglt)
																		BgL_ez00_14364)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33903ze3z87_16654,
																(int) (((long) 3)), BgL_bodyz00_16609);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33903ze3z87_16654,
																(int) (((long) 4)),
																BINT(BgL_siza7ezd2framez75_16583));
															return BgL_zc3z04anonymousza33903ze3z87_16654;
														}
													else
														{	/* Eval/evaluate_comp.scm 1174 */
															obj_t BgL_zc3z04anonymousza33915ze3z87_16655;

															BgL_zc3z04anonymousza33915ze3z87_16655 =
																MAKE_FX_PROCEDURE
																(BGl_z62zc3z04anonymousza33915ze3ze5zz__evaluate_compz00,
																(int) (((long) 1)), (int) (((long) 6)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33915ze3z87_16655,
																(int) (((long) 0)), BgL_ifreesz00_16580);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33915ze3z87_16655,
																(int) (((long) 1)), BgL_iboxesz00_16581);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33915ze3z87_16655,
																(int) (((long) 2)), BINT(BgL_siza7eza7_16582));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33915ze3z87_16655,
																(int) (((long) 3)),
																((obj_t) ((BgL_ev_absz00_bglt)
																		BgL_ez00_14364)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33915ze3z87_16655,
																(int) (((long) 4)), BgL_bodyz00_16609);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33915ze3z87_16655,
																(int) (((long) 5)),
																BINT(BgL_siza7ezd2framez75_16583));
															return BgL_zc3z04anonymousza33915ze3z87_16655;
														}
												}
											break;
										default:
										BgL_case_else1248z00_16610:
											if ((VECTOR_LENGTH(BgL_ifreesz00_16580) == ((long) 0)))
												{	/* Eval/evaluate_comp.scm 1174 */
													if (
														(VECTOR_LENGTH(BgL_iboxesz00_16581) == ((long) 0)))
														{	/* Eval/evaluate_comp.scm 1174 */
															obj_t BgL_zc3z04anonymousza33933ze3z87_16611;

															BgL_zc3z04anonymousza33933ze3z87_16611 =
																MAKE_FX_PROCEDURE
																(BGl_z62zc3z04anonymousza33933ze3ze5zz__evaluate_compz00,
																(int) (((long) 1)), (int) (((long) 3)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33933ze3z87_16611,
																(int) (((long) 0)),
																((obj_t) ((BgL_ev_absz00_bglt)
																		BgL_ez00_14364)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33933ze3z87_16611,
																(int) (((long) 1)), BgL_bodyz00_16609);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33933ze3z87_16611,
																(int) (((long) 2)),
																BINT(BgL_siza7ezd2framez75_16583));
															return BgL_zc3z04anonymousza33933ze3z87_16611;
														}
													else
														{	/* Eval/evaluate_comp.scm 1174 */
															obj_t BgL_zc3z04anonymousza33953ze3z87_16612;

															BgL_zc3z04anonymousza33953ze3z87_16612 =
																MAKE_FX_PROCEDURE
																(BGl_z62zc3z04anonymousza33953ze3ze5zz__evaluate_compz00,
																(int) (((long) 1)), (int) (((long) 4)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33953ze3z87_16612,
																(int) (((long) 0)), BgL_iboxesz00_16581);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33953ze3z87_16612,
																(int) (((long) 1)),
																((obj_t) ((BgL_ev_absz00_bglt)
																		BgL_ez00_14364)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33953ze3z87_16612,
																(int) (((long) 2)), BgL_bodyz00_16609);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33953ze3z87_16612,
																(int) (((long) 3)),
																BINT(BgL_siza7ezd2framez75_16583));
															return BgL_zc3z04anonymousza33953ze3z87_16612;
														}
												}
											else
												{	/* Eval/evaluate_comp.scm 1174 */
													if (
														(VECTOR_LENGTH(BgL_iboxesz00_16581) == ((long) 0)))
														{	/* Eval/evaluate_comp.scm 1174 */
															obj_t BgL_zc3z04anonymousza33976ze3z87_16613;

															BgL_zc3z04anonymousza33976ze3z87_16613 =
																MAKE_FX_PROCEDURE
																(BGl_z62zc3z04anonymousza33976ze3ze5zz__evaluate_compz00,
																(int) (((long) 1)), (int) (((long) 5)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33976ze3z87_16613,
																(int) (((long) 0)), BgL_ifreesz00_16580);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33976ze3z87_16613,
																(int) (((long) 1)), BINT(BgL_siza7eza7_16582));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33976ze3z87_16613,
																(int) (((long) 2)),
																((obj_t) ((BgL_ev_absz00_bglt)
																		BgL_ez00_14364)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33976ze3z87_16613,
																(int) (((long) 3)), BgL_bodyz00_16609);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33976ze3z87_16613,
																(int) (((long) 4)),
																BINT(BgL_siza7ezd2framez75_16583));
															return BgL_zc3z04anonymousza33976ze3z87_16613;
														}
													else
														{	/* Eval/evaluate_comp.scm 1174 */
															obj_t BgL_zc3z04anonymousza33997ze3z87_16614;

															BgL_zc3z04anonymousza33997ze3z87_16614 =
																MAKE_FX_PROCEDURE
																(BGl_z62zc3z04anonymousza33997ze3ze5zz__evaluate_compz00,
																(int) (((long) 1)), (int) (((long) 6)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33997ze3z87_16614,
																(int) (((long) 0)), BgL_ifreesz00_16580);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33997ze3z87_16614,
																(int) (((long) 1)), BgL_iboxesz00_16581);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33997ze3z87_16614,
																(int) (((long) 2)), BINT(BgL_siza7eza7_16582));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33997ze3z87_16614,
																(int) (((long) 3)),
																((obj_t) ((BgL_ev_absz00_bglt)
																		BgL_ez00_14364)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33997ze3z87_16614,
																(int) (((long) 4)), BgL_bodyz00_16609);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33997ze3z87_16614,
																(int) (((long) 5)),
																BINT(BgL_siza7ezd2framez75_16583));
															return BgL_zc3z04anonymousza33997ze3z87_16614;
														}
												}
										}
								}
							else
								{	/* Eval/evaluate_comp.scm 1174 */
									goto BgL_case_else1248z00_16610;
								}
						}
					}
				}
			}
		}

	}



/* &<@anonymous:3878> */
	obj_t BGl_z62zc3z04anonymousza33878ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_14366, obj_t BgL_sz00_14370)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				BgL_ev_absz00_bglt BgL_i1247z00_14367;
				obj_t BgL_bodyz00_14368;
				long BgL_siza7ezd2framez75_14369;

				BgL_i1247z00_14367 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14366, (int) (((long) 0))));
				BgL_bodyz00_14368 = PROCEDURE_REF(BgL_envz00_14366, (int) (((long) 1)));
				BgL_siza7ezd2framez75_14369 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14366, (int) (((long) 2))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_16656;

					BgL_bpz00_16656 = VECTOR_REF(((obj_t) BgL_sz00_14370), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1174 */

						{	/* Eval/evaluate_comp.scm 1174 */
							obj_t BgL_runz00_16657;

							BgL_runz00_16657 =
								MAKE_FX_PROCEDURE(BGl_z62runz62zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 2)));
							PROCEDURE_SET(BgL_runz00_16657,
								(int) (((long) 0)), ((obj_t) BgL_i1247z00_14367));
							PROCEDURE_SET(BgL_runz00_16657,
								(int) (((long) 1)), BgL_bodyz00_14368);
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_mainz00_16658;

								BgL_mainz00_16658 =
									MAKE_VA_PROCEDURE(BGl_z62mainz62zz__evaluate_compz00,
									(int) (((long) -5)), (int) (((long) 4)));
								PROCEDURE_SET(BgL_mainz00_16658,
									(int) (((long) 0)), ((obj_t) BgL_i1247z00_14367));
								PROCEDURE_SET(BgL_mainz00_16658,
									(int) (((long) 1)), BgL_bodyz00_14368);
								PROCEDURE_SET(BgL_mainz00_16658,
									(int) (((long) 2)), BgL_runz00_16657);
								PROCEDURE_SET(BgL_mainz00_16658,
									(int) (((long) 3)), BINT(BgL_siza7ezd2framez75_14369));
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_objz00_16659;

									BgL_objz00_16659 =
										BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
									PROCEDURE_ATTR_SET(BgL_runz00_16657, BgL_objz00_16659);
									BgL_objz00_16659;
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_arg3879z00_16660;

									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_arg3880z00_16661;

										BgL_arg3880z00_16661 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14367))->
											BgL_wherez00);
										{	/* Eval/evaluate_comp.scm 683 */
											obj_t BgL_newz00_16662;

											BgL_newz00_16662 =
												create_struct(BGl_symbol5824z00zz__evaluate_compz00,
												(int) (((long) 4)));
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_26373;

												BgL_tmpz00_26373 = (int) (((long) 3));
												STRUCT_SET(BgL_newz00_16662, BgL_tmpz00_26373,
													BgL_arg3880z00_16661);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_26378;
												int BgL_tmpz00_26376;

												BgL_auxz00_26378 = BINT(BgL_siza7ezd2framez75_14369);
												BgL_tmpz00_26376 = (int) (((long) 2));
												STRUCT_SET(BgL_newz00_16662, BgL_tmpz00_26376,
													BgL_auxz00_26378);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_26381;

												BgL_tmpz00_26381 = (int) (((long) 1));
												STRUCT_SET(BgL_newz00_16662, BgL_tmpz00_26381,
													BgL_runz00_16657);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_26386;
												int BgL_tmpz00_26384;

												BgL_auxz00_26386 = BINT(((long) -5));
												BgL_tmpz00_26384 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_16662, BgL_tmpz00_26384,
													BgL_auxz00_26386);
											}
											BgL_arg3879z00_16660 = BgL_newz00_16662;
									}}
									PROCEDURE_ATTR_SET(BgL_mainz00_16658, BgL_arg3879z00_16660);
									BgL_arg3879z00_16660;
								}
								return BgL_mainz00_16658;
							}
						}
					}
				}
			}
		}

	}



/* &main */
	obj_t BGl_z62mainz62zz__evaluate_compz00(obj_t BgL_envz00_14371,
		obj_t BgL_az00_14376, obj_t BgL_bz00_14377, obj_t BgL_cz00_14378,
		obj_t BgL_dz00_14379, obj_t BgL_lastz00_14380)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_runz00_14374;
				long BgL_siza7ezd2framez75_14375;

				BgL_runz00_14374 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14371, (int) (((long) 2))));
				BgL_siza7ezd2framez75_14375 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14371, (int) (((long) 3))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_sz00_16663;

					BgL_sz00_16663 = BGl_findzd2statezd2zz__evaluate_compz00();
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_bpz00_16664;

						BgL_bpz00_16664 = VECTOR_REF(((obj_t) BgL_sz00_16663), ((long) 0));
						if (
							(((long) CINT(BgL_bpz00_16664) + BgL_siza7ezd2framez75_14375) <
								VECTOR_LENGTH(((obj_t) BgL_sz00_16663))))
							{	/* Eval/evaluate_comp.scm 1174 */
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3883z00_16665;

									BgL_arg3883z00_16665 =
										((long) CINT(BgL_bpz00_16664) + ((long) 0));
									VECTOR_SET(
										((obj_t) BgL_sz00_16663), BgL_arg3883z00_16665,
										BgL_az00_14376);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3884z00_16666;

									BgL_arg3884z00_16666 =
										((long) CINT(BgL_bpz00_16664) + ((long) 1));
									VECTOR_SET(
										((obj_t) BgL_sz00_16663), BgL_arg3884z00_16666,
										BgL_bz00_14377);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3885z00_16667;

									BgL_arg3885z00_16667 =
										((long) CINT(BgL_bpz00_16664) + ((long) 2));
									VECTOR_SET(
										((obj_t) BgL_sz00_16663), BgL_arg3885z00_16667,
										BgL_cz00_14378);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3886z00_16668;

									BgL_arg3886z00_16668 =
										((long) CINT(BgL_bpz00_16664) + ((long) 3));
									VECTOR_SET(
										((obj_t) BgL_sz00_16663), BgL_arg3886z00_16668,
										BgL_dz00_14379);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3887z00_16669;

									BgL_arg3887z00_16669 =
										((long) CINT(BgL_bpz00_16664) + ((long) 4));
									VECTOR_SET(
										((obj_t) BgL_sz00_16663), BgL_arg3887z00_16669,
										BgL_lastz00_14380);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_ez00_16670;

									BgL_ez00_16670 = BGL_EXITD_TOP_AS_OBJ();
									BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_16670,
										BgL_bpz00_16664);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_accz00_16671;

										BgL_accz00_16671 =
											BGl_catchzd2trampolinezd2zz__evaluate_compz00
											(BgL_runz00_14374, BgL_sz00_16663, BgL_bpz00_16664);
										BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_16670);
										VECTOR_SET(
											((obj_t) BgL_sz00_16663), ((long) 0), BgL_bpz00_16664);
										return BgL_accz00_16671;
									}
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_nsz00_16672;

								BgL_nsz00_16672 = BGl_makezd2statezd2zz__evaluate_compz00();
								VECTOR_SET(BgL_nsz00_16672, ((long) 1), BgL_sz00_16663);
								VECTOR_SET(BgL_nsz00_16672, ((long) 2), BgL_az00_14376);
								VECTOR_SET(BgL_nsz00_16672, ((long) 3), BgL_bz00_14377);
								VECTOR_SET(BgL_nsz00_16672, ((long) 4), BgL_cz00_14378);
								VECTOR_SET(BgL_nsz00_16672, ((long) 5), BgL_dz00_14379);
								VECTOR_SET(BgL_nsz00_16672, ((long) 6), BgL_lastz00_14380);
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_z12denvz12_16673;

									BgL_z12denvz12_16673 = BGL_CURRENT_DYNAMIC_ENV();
									BGL_ENV_EVSTATE_SET(BgL_z12denvz12_16673, BgL_nsz00_16672);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_ez00_16674;

										BgL_ez00_16674 = BGL_EXITD_TOP_AS_OBJ();
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_16674,
											BgL_sz00_16663);
										{	/* Eval/evaluate_comp.scm 1174 */
											obj_t BgL_____rz00_16675;

											{	/* Eval/evaluate_comp.scm 670 */
												obj_t BgL_savedzd2bpzd2_16676;

												BgL_savedzd2bpzd2_16676 =
													VECTOR_REF(BgL_nsz00_16672, ((long) 0));
												VECTOR_SET(BgL_nsz00_16672, ((long) 0),
													BINT(((long) 2)));
												{
													obj_t BgL_fz00_16678;

													BgL_fz00_16678 = BgL_runz00_14374;
												BgL_recz00_16677:
													{	/* Eval/evaluate_comp.scm 673 */
														obj_t BgL_rz00_16679;

														BgL_rz00_16679 =
															PROCEDURE_ENTRY(BgL_fz00_16678) (BgL_fz00_16678,
															BgL_nsz00_16672, BEOA);
														{	/* Eval/evaluate_comp.scm 674 */
															bool_t BgL_test6582z00_26449;

															if (PROCEDUREP(BgL_rz00_16679))
																{	/* Eval/evaluate_comp.scm 674 */
																	obj_t BgL_arg1702z00_16680;

																	BgL_arg1702z00_16680 =
																		PROCEDURE_ATTR(BgL_rz00_16679);
																	if (STRUCTP(BgL_arg1702z00_16680))
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test6582z00_26449 =
																				(STRUCT_KEY(BgL_arg1702z00_16680) ==
																				BGl_symbol5803z00zz__evaluate_compz00);
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test6582z00_26449 = ((bool_t) 0);
																		}
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	BgL_test6582z00_26449 = ((bool_t) 0);
																}
															if (BgL_test6582z00_26449)
																{
																	obj_t BgL_fz00_26457;

																	BgL_fz00_26457 = BgL_rz00_16679;
																	BgL_fz00_16678 = BgL_fz00_26457;
																	goto BgL_recz00_16677;
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	VECTOR_SET(BgL_nsz00_16672, ((long) 0),
																		BgL_savedzd2bpzd2_16676);
																	BgL_____rz00_16675 = BgL_rz00_16679;
											}}}}}
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_ez00_16674);
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_16673, BgL_sz00_16663);
											return BgL_____rz00_16675;
										}
									}
								}
							}
					}
				}
			}
		}

	}



/* &run */
	obj_t BGl_z62runz62zz__evaluate_compz00(obj_t BgL_envz00_14381,
		obj_t BgL_sz00_14384)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				BgL_ev_absz00_bglt BgL_i1247z00_14382;
				obj_t BgL_bodyz00_14383;

				BgL_i1247z00_14382 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14381, (int) (((long) 0))));
				BgL_bodyz00_14383 = PROCEDURE_REF(BgL_envz00_14381, (int) (((long) 1)));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_16681;

					BgL_bpz00_16681 = VECTOR_REF(((obj_t) BgL_sz00_14384), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_z12denvz12_16682;
						obj_t BgL_wherez00_16683;
						obj_t BgL_locz00_16684;

						BgL_z12denvz12_16682 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_wherez00_16683 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14382))->
							BgL_wherez00);
						BgL_locz00_16684 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14382))->BgL_locz00);
						{	/* Eval/evaluate_comp.scm 1174 */

							BGL_ENV_PUSH_TRACE(BgL_z12denvz12_16682, BgL_wherez00_16683,
								BgL_locz00_16684);
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_za2za2resza2za2z00_16685;

								BgL_za2za2resza2za2z00_16685 =
									PROCEDURE_ENTRY(BgL_bodyz00_14383) (BgL_bodyz00_14383,
									BgL_sz00_14384, BEOA);
								BGL_ENV_POP_TRACE(BgL_z12denvz12_16682);
								return BgL_za2za2resza2za2z00_16685;
							}
						}
					}
				}
			}
		}

	}



/* &<@anonymous:3889> */
	obj_t BGl_z62zc3z04anonymousza33889ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_14385, obj_t BgL_sz00_14390)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_iboxesz00_14386;
				BgL_ev_absz00_bglt BgL_i1247z00_14387;
				obj_t BgL_bodyz00_14388;
				long BgL_siza7ezd2framez75_14389;

				BgL_iboxesz00_14386 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14385, (int) (((long) 0))));
				BgL_i1247z00_14387 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14385, (int) (((long) 1))));
				BgL_bodyz00_14388 = PROCEDURE_REF(BgL_envz00_14385, (int) (((long) 2)));
				BgL_siza7ezd2framez75_14389 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14385, (int) (((long) 3))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_16686;

					BgL_bpz00_16686 = VECTOR_REF(((obj_t) BgL_sz00_14390), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1174 */

						{	/* Eval/evaluate_comp.scm 1174 */
							obj_t BgL_runz00_16687;

							BgL_runz00_16687 =
								MAKE_FX_PROCEDURE(BGl_z62run5710z62zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 3)));
							PROCEDURE_SET(BgL_runz00_16687,
								(int) (((long) 0)), BgL_iboxesz00_14386);
							PROCEDURE_SET(BgL_runz00_16687,
								(int) (((long) 1)), ((obj_t) BgL_i1247z00_14387));
							PROCEDURE_SET(BgL_runz00_16687,
								(int) (((long) 2)), BgL_bodyz00_14388);
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_mainz00_16688;

								BgL_mainz00_16688 =
									MAKE_VA_PROCEDURE(BGl_z62main5709z62zz__evaluate_compz00,
									(int) (((long) -5)), (int) (((long) 5)));
								PROCEDURE_SET(BgL_mainz00_16688,
									(int) (((long) 0)), BgL_iboxesz00_14386);
								PROCEDURE_SET(BgL_mainz00_16688,
									(int) (((long) 1)), ((obj_t) BgL_i1247z00_14387));
								PROCEDURE_SET(BgL_mainz00_16688,
									(int) (((long) 2)), BgL_bodyz00_14388);
								PROCEDURE_SET(BgL_mainz00_16688,
									(int) (((long) 3)), BgL_runz00_16687);
								PROCEDURE_SET(BgL_mainz00_16688,
									(int) (((long) 4)), BINT(BgL_siza7ezd2framez75_14389));
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_objz00_16689;

									BgL_objz00_16689 =
										BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
									PROCEDURE_ATTR_SET(BgL_runz00_16687, BgL_objz00_16689);
									BgL_objz00_16689;
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_arg3890z00_16690;

									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_arg3891z00_16691;

										BgL_arg3891z00_16691 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14387))->
											BgL_wherez00);
										{	/* Eval/evaluate_comp.scm 683 */
											obj_t BgL_newz00_16692;

											BgL_newz00_16692 =
												create_struct(BGl_symbol5824z00zz__evaluate_compz00,
												(int) (((long) 4)));
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_26519;

												BgL_tmpz00_26519 = (int) (((long) 3));
												STRUCT_SET(BgL_newz00_16692, BgL_tmpz00_26519,
													BgL_arg3891z00_16691);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_26524;
												int BgL_tmpz00_26522;

												BgL_auxz00_26524 = BINT(BgL_siza7ezd2framez75_14389);
												BgL_tmpz00_26522 = (int) (((long) 2));
												STRUCT_SET(BgL_newz00_16692, BgL_tmpz00_26522,
													BgL_auxz00_26524);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_26527;

												BgL_tmpz00_26527 = (int) (((long) 1));
												STRUCT_SET(BgL_newz00_16692, BgL_tmpz00_26527,
													BgL_runz00_16687);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_26532;
												int BgL_tmpz00_26530;

												BgL_auxz00_26532 = BINT(((long) -5));
												BgL_tmpz00_26530 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_16692, BgL_tmpz00_26530,
													BgL_auxz00_26532);
											}
											BgL_arg3890z00_16690 = BgL_newz00_16692;
									}}
									PROCEDURE_ATTR_SET(BgL_mainz00_16688, BgL_arg3890z00_16690);
									BgL_arg3890z00_16690;
								}
								return BgL_mainz00_16688;
							}
						}
					}
				}
			}
		}

	}



/* &main5709 */
	obj_t BGl_z62main5709z62zz__evaluate_compz00(obj_t BgL_envz00_14391,
		obj_t BgL_az00_14397, obj_t BgL_bz00_14398, obj_t BgL_cz00_14399,
		obj_t BgL_dz00_14400, obj_t BgL_lastz00_14401)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_runz00_14395;
				long BgL_siza7ezd2framez75_14396;

				BgL_runz00_14395 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14391, (int) (((long) 3))));
				BgL_siza7ezd2framez75_14396 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14391, (int) (((long) 4))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_sz00_16693;

					BgL_sz00_16693 = BGl_findzd2statezd2zz__evaluate_compz00();
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_bpz00_16694;

						BgL_bpz00_16694 = VECTOR_REF(((obj_t) BgL_sz00_16693), ((long) 0));
						if (
							(((long) CINT(BgL_bpz00_16694) + BgL_siza7ezd2framez75_14396) <
								VECTOR_LENGTH(((obj_t) BgL_sz00_16693))))
							{	/* Eval/evaluate_comp.scm 1174 */
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3894z00_16695;

									BgL_arg3894z00_16695 =
										((long) CINT(BgL_bpz00_16694) + ((long) 0));
									VECTOR_SET(
										((obj_t) BgL_sz00_16693), BgL_arg3894z00_16695,
										BgL_az00_14397);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3895z00_16696;

									BgL_arg3895z00_16696 =
										((long) CINT(BgL_bpz00_16694) + ((long) 1));
									VECTOR_SET(
										((obj_t) BgL_sz00_16693), BgL_arg3895z00_16696,
										BgL_bz00_14398);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3896z00_16697;

									BgL_arg3896z00_16697 =
										((long) CINT(BgL_bpz00_16694) + ((long) 2));
									VECTOR_SET(
										((obj_t) BgL_sz00_16693), BgL_arg3896z00_16697,
										BgL_cz00_14399);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3897z00_16698;

									BgL_arg3897z00_16698 =
										((long) CINT(BgL_bpz00_16694) + ((long) 3));
									VECTOR_SET(
										((obj_t) BgL_sz00_16693), BgL_arg3897z00_16698,
										BgL_dz00_14400);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3898z00_16699;

									BgL_arg3898z00_16699 =
										((long) CINT(BgL_bpz00_16694) + ((long) 4));
									VECTOR_SET(
										((obj_t) BgL_sz00_16693), BgL_arg3898z00_16699,
										BgL_lastz00_14401);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_ez00_16700;

									BgL_ez00_16700 = BGL_EXITD_TOP_AS_OBJ();
									BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_16700,
										BgL_bpz00_16694);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_accz00_16701;

										BgL_accz00_16701 =
											BGl_catchzd2trampolinezd2zz__evaluate_compz00
											(BgL_runz00_14395, BgL_sz00_16693, BgL_bpz00_16694);
										BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_16700);
										VECTOR_SET(
											((obj_t) BgL_sz00_16693), ((long) 0), BgL_bpz00_16694);
										return BgL_accz00_16701;
									}
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_nsz00_16702;

								BgL_nsz00_16702 = BGl_makezd2statezd2zz__evaluate_compz00();
								VECTOR_SET(BgL_nsz00_16702, ((long) 1), BgL_sz00_16693);
								VECTOR_SET(BgL_nsz00_16702, ((long) 2), BgL_az00_14397);
								VECTOR_SET(BgL_nsz00_16702, ((long) 3), BgL_bz00_14398);
								VECTOR_SET(BgL_nsz00_16702, ((long) 4), BgL_cz00_14399);
								VECTOR_SET(BgL_nsz00_16702, ((long) 5), BgL_dz00_14400);
								VECTOR_SET(BgL_nsz00_16702, ((long) 6), BgL_lastz00_14401);
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_z12denvz12_16703;

									BgL_z12denvz12_16703 = BGL_CURRENT_DYNAMIC_ENV();
									BGL_ENV_EVSTATE_SET(BgL_z12denvz12_16703, BgL_nsz00_16702);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_ez00_16704;

										BgL_ez00_16704 = BGL_EXITD_TOP_AS_OBJ();
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_16704,
											BgL_sz00_16693);
										{	/* Eval/evaluate_comp.scm 1174 */
											obj_t BgL_____rz00_16705;

											{	/* Eval/evaluate_comp.scm 670 */
												obj_t BgL_savedzd2bpzd2_16706;

												BgL_savedzd2bpzd2_16706 =
													VECTOR_REF(BgL_nsz00_16702, ((long) 0));
												VECTOR_SET(BgL_nsz00_16702, ((long) 0),
													BINT(((long) 2)));
												{
													obj_t BgL_fz00_16708;

													BgL_fz00_16708 = BgL_runz00_14395;
												BgL_recz00_16707:
													{	/* Eval/evaluate_comp.scm 673 */
														obj_t BgL_rz00_16709;

														BgL_rz00_16709 =
															PROCEDURE_ENTRY(BgL_fz00_16708) (BgL_fz00_16708,
															BgL_nsz00_16702, BEOA);
														{	/* Eval/evaluate_comp.scm 674 */
															bool_t BgL_test6586z00_26595;

															if (PROCEDUREP(BgL_rz00_16709))
																{	/* Eval/evaluate_comp.scm 674 */
																	obj_t BgL_arg1702z00_16710;

																	BgL_arg1702z00_16710 =
																		PROCEDURE_ATTR(BgL_rz00_16709);
																	if (STRUCTP(BgL_arg1702z00_16710))
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test6586z00_26595 =
																				(STRUCT_KEY(BgL_arg1702z00_16710) ==
																				BGl_symbol5803z00zz__evaluate_compz00);
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test6586z00_26595 = ((bool_t) 0);
																		}
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	BgL_test6586z00_26595 = ((bool_t) 0);
																}
															if (BgL_test6586z00_26595)
																{
																	obj_t BgL_fz00_26603;

																	BgL_fz00_26603 = BgL_rz00_16709;
																	BgL_fz00_16708 = BgL_fz00_26603;
																	goto BgL_recz00_16707;
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	VECTOR_SET(BgL_nsz00_16702, ((long) 0),
																		BgL_savedzd2bpzd2_16706);
																	BgL_____rz00_16705 = BgL_rz00_16709;
											}}}}}
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_ez00_16704);
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_16703, BgL_sz00_16693);
											return BgL_____rz00_16705;
										}
									}
								}
							}
					}
				}
			}
		}

	}



/* &run5710 */
	obj_t BGl_z62run5710z62zz__evaluate_compz00(obj_t BgL_envz00_14402,
		obj_t BgL_sz00_14406)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_iboxesz00_14403;
				BgL_ev_absz00_bglt BgL_i1247z00_14404;
				obj_t BgL_bodyz00_14405;

				BgL_iboxesz00_14403 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14402, (int) (((long) 0))));
				BgL_i1247z00_14404 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14402, (int) (((long) 1))));
				BgL_bodyz00_14405 = PROCEDURE_REF(BgL_envz00_14402, (int) (((long) 2)));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_16711;

					BgL_bpz00_16711 = VECTOR_REF(((obj_t) BgL_sz00_14406), ((long) 0));
					BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_14406,
						BgL_iboxesz00_14403, BgL_bpz00_16711);
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_z12denvz12_16712;
						obj_t BgL_wherez00_16713;
						obj_t BgL_locz00_16714;

						BgL_z12denvz12_16712 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_wherez00_16713 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14404))->
							BgL_wherez00);
						BgL_locz00_16714 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14404))->BgL_locz00);
						{	/* Eval/evaluate_comp.scm 1174 */

							BGL_ENV_PUSH_TRACE(BgL_z12denvz12_16712, BgL_wherez00_16713,
								BgL_locz00_16714);
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_za2za2resza2za2z00_16715;

								BgL_za2za2resza2za2z00_16715 =
									PROCEDURE_ENTRY(BgL_bodyz00_14405) (BgL_bodyz00_14405,
									BgL_sz00_14406, BEOA);
								BGL_ENV_POP_TRACE(BgL_z12denvz12_16712);
								return BgL_za2za2resza2za2z00_16715;
							}
						}
					}
				}
			}
		}

	}



/* &<@anonymous:3903> */
	obj_t BGl_z62zc3z04anonymousza33903ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_14407, obj_t BgL_sz00_14413)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_ifreesz00_14408;
				long BgL_siza7eza7_14409;
				BgL_ev_absz00_bglt BgL_i1247z00_14410;
				obj_t BgL_bodyz00_14411;
				long BgL_siza7ezd2framez75_14412;

				BgL_ifreesz00_14408 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14407, (int) (((long) 0))));
				BgL_siza7eza7_14409 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14407, (int) (((long) 1))));
				BgL_i1247z00_14410 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14407, (int) (((long) 2))));
				BgL_bodyz00_14411 = PROCEDURE_REF(BgL_envz00_14407, (int) (((long) 3)));
				BgL_siza7ezd2framez75_14412 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14407, (int) (((long) 4))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_16716;

					BgL_bpz00_16716 = VECTOR_REF(((obj_t) BgL_sz00_14413), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_valza2za2_16717;

						BgL_valza2za2_16717 =
							BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_14413,
							BgL_bpz00_16716, BgL_ifreesz00_14408);
						{	/* Eval/evaluate_comp.scm 1174 */
							obj_t BgL_runz00_16718;

							BgL_runz00_16718 =
								MAKE_FX_PROCEDURE(BGl_z62run5712z62zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 4)));
							PROCEDURE_SET(BgL_runz00_16718,
								(int) (((long) 0)), BINT(BgL_siza7eza7_14409));
							PROCEDURE_SET(BgL_runz00_16718,
								(int) (((long) 1)), BgL_valza2za2_16717);
							PROCEDURE_SET(BgL_runz00_16718,
								(int) (((long) 2)), ((obj_t) BgL_i1247z00_14410));
							PROCEDURE_SET(BgL_runz00_16718,
								(int) (((long) 3)), BgL_bodyz00_14411);
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_mainz00_16719;

								BgL_mainz00_16719 =
									MAKE_VA_PROCEDURE(BGl_z62main5711z62zz__evaluate_compz00,
									(int) (((long) -5)), (int) (((long) 6)));
								PROCEDURE_SET(BgL_mainz00_16719,
									(int) (((long) 0)), BINT(BgL_siza7eza7_14409));
								PROCEDURE_SET(BgL_mainz00_16719,
									(int) (((long) 1)), BgL_valza2za2_16717);
								PROCEDURE_SET(BgL_mainz00_16719,
									(int) (((long) 2)), ((obj_t) BgL_i1247z00_14410));
								PROCEDURE_SET(BgL_mainz00_16719,
									(int) (((long) 3)), BgL_bodyz00_14411);
								PROCEDURE_SET(BgL_mainz00_16719,
									(int) (((long) 4)), BgL_runz00_16718);
								PROCEDURE_SET(BgL_mainz00_16719,
									(int) (((long) 5)), BINT(BgL_siza7ezd2framez75_14412));
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_objz00_16720;

									BgL_objz00_16720 =
										BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
									PROCEDURE_ATTR_SET(BgL_runz00_16718, BgL_objz00_16720);
									BgL_objz00_16720;
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_arg3904z00_16721;

									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_arg3905z00_16722;

										BgL_arg3905z00_16722 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14410))->
											BgL_wherez00);
										{	/* Eval/evaluate_comp.scm 683 */
											obj_t BgL_newz00_16723;

											BgL_newz00_16723 =
												create_struct(BGl_symbol5824z00zz__evaluate_compz00,
												(int) (((long) 4)));
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_26679;

												BgL_tmpz00_26679 = (int) (((long) 3));
												STRUCT_SET(BgL_newz00_16723, BgL_tmpz00_26679,
													BgL_arg3905z00_16722);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_26684;
												int BgL_tmpz00_26682;

												BgL_auxz00_26684 = BINT(BgL_siza7ezd2framez75_14412);
												BgL_tmpz00_26682 = (int) (((long) 2));
												STRUCT_SET(BgL_newz00_16723, BgL_tmpz00_26682,
													BgL_auxz00_26684);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_26687;

												BgL_tmpz00_26687 = (int) (((long) 1));
												STRUCT_SET(BgL_newz00_16723, BgL_tmpz00_26687,
													BgL_runz00_16718);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_26692;
												int BgL_tmpz00_26690;

												BgL_auxz00_26692 = BINT(((long) -5));
												BgL_tmpz00_26690 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_16723, BgL_tmpz00_26690,
													BgL_auxz00_26692);
											}
											BgL_arg3904z00_16721 = BgL_newz00_16723;
									}}
									PROCEDURE_ATTR_SET(BgL_mainz00_16719, BgL_arg3904z00_16721);
									BgL_arg3904z00_16721;
								}
								return BgL_mainz00_16719;
							}
						}
					}
				}
			}
		}

	}



/* &main5711 */
	obj_t BGl_z62main5711z62zz__evaluate_compz00(obj_t BgL_envz00_14414,
		obj_t BgL_az00_14421, obj_t BgL_bz00_14422, obj_t BgL_cz00_14423,
		obj_t BgL_dz00_14424, obj_t BgL_lastz00_14425)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_runz00_14419;
				long BgL_siza7ezd2framez75_14420;

				BgL_runz00_14419 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14414, (int) (((long) 4))));
				BgL_siza7ezd2framez75_14420 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14414, (int) (((long) 5))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_sz00_16724;

					BgL_sz00_16724 = BGl_findzd2statezd2zz__evaluate_compz00();
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_bpz00_16725;

						BgL_bpz00_16725 = VECTOR_REF(((obj_t) BgL_sz00_16724), ((long) 0));
						if (
							(((long) CINT(BgL_bpz00_16725) + BgL_siza7ezd2framez75_14420) <
								VECTOR_LENGTH(((obj_t) BgL_sz00_16724))))
							{	/* Eval/evaluate_comp.scm 1174 */
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3908z00_16726;

									BgL_arg3908z00_16726 =
										((long) CINT(BgL_bpz00_16725) + ((long) 0));
									VECTOR_SET(
										((obj_t) BgL_sz00_16724), BgL_arg3908z00_16726,
										BgL_az00_14421);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3909z00_16727;

									BgL_arg3909z00_16727 =
										((long) CINT(BgL_bpz00_16725) + ((long) 1));
									VECTOR_SET(
										((obj_t) BgL_sz00_16724), BgL_arg3909z00_16727,
										BgL_bz00_14422);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3910z00_16728;

									BgL_arg3910z00_16728 =
										((long) CINT(BgL_bpz00_16725) + ((long) 2));
									VECTOR_SET(
										((obj_t) BgL_sz00_16724), BgL_arg3910z00_16728,
										BgL_cz00_14423);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3911z00_16729;

									BgL_arg3911z00_16729 =
										((long) CINT(BgL_bpz00_16725) + ((long) 3));
									VECTOR_SET(
										((obj_t) BgL_sz00_16724), BgL_arg3911z00_16729,
										BgL_dz00_14424);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3912z00_16730;

									BgL_arg3912z00_16730 =
										((long) CINT(BgL_bpz00_16725) + ((long) 4));
									VECTOR_SET(
										((obj_t) BgL_sz00_16724), BgL_arg3912z00_16730,
										BgL_lastz00_14425);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_ez00_16731;

									BgL_ez00_16731 = BGL_EXITD_TOP_AS_OBJ();
									BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_16731,
										BgL_bpz00_16725);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_accz00_16732;

										BgL_accz00_16732 =
											BGl_catchzd2trampolinezd2zz__evaluate_compz00
											(BgL_runz00_14419, BgL_sz00_16724, BgL_bpz00_16725);
										BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_16731);
										VECTOR_SET(
											((obj_t) BgL_sz00_16724), ((long) 0), BgL_bpz00_16725);
										return BgL_accz00_16732;
									}
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_nsz00_16733;

								BgL_nsz00_16733 = BGl_makezd2statezd2zz__evaluate_compz00();
								VECTOR_SET(BgL_nsz00_16733, ((long) 1), BgL_sz00_16724);
								VECTOR_SET(BgL_nsz00_16733, ((long) 2), BgL_az00_14421);
								VECTOR_SET(BgL_nsz00_16733, ((long) 3), BgL_bz00_14422);
								VECTOR_SET(BgL_nsz00_16733, ((long) 4), BgL_cz00_14423);
								VECTOR_SET(BgL_nsz00_16733, ((long) 5), BgL_dz00_14424);
								VECTOR_SET(BgL_nsz00_16733, ((long) 6), BgL_lastz00_14425);
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_z12denvz12_16734;

									BgL_z12denvz12_16734 = BGL_CURRENT_DYNAMIC_ENV();
									BGL_ENV_EVSTATE_SET(BgL_z12denvz12_16734, BgL_nsz00_16733);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_ez00_16735;

										BgL_ez00_16735 = BGL_EXITD_TOP_AS_OBJ();
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_16735,
											BgL_sz00_16724);
										{	/* Eval/evaluate_comp.scm 1174 */
											obj_t BgL_____rz00_16736;

											{	/* Eval/evaluate_comp.scm 670 */
												obj_t BgL_savedzd2bpzd2_16737;

												BgL_savedzd2bpzd2_16737 =
													VECTOR_REF(BgL_nsz00_16733, ((long) 0));
												VECTOR_SET(BgL_nsz00_16733, ((long) 0),
													BINT(((long) 2)));
												{
													obj_t BgL_fz00_16739;

													BgL_fz00_16739 = BgL_runz00_14419;
												BgL_recz00_16738:
													{	/* Eval/evaluate_comp.scm 673 */
														obj_t BgL_rz00_16740;

														BgL_rz00_16740 =
															PROCEDURE_ENTRY(BgL_fz00_16739) (BgL_fz00_16739,
															BgL_nsz00_16733, BEOA);
														{	/* Eval/evaluate_comp.scm 674 */
															bool_t BgL_test6590z00_26755;

															if (PROCEDUREP(BgL_rz00_16740))
																{	/* Eval/evaluate_comp.scm 674 */
																	obj_t BgL_arg1702z00_16741;

																	BgL_arg1702z00_16741 =
																		PROCEDURE_ATTR(BgL_rz00_16740);
																	if (STRUCTP(BgL_arg1702z00_16741))
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test6590z00_26755 =
																				(STRUCT_KEY(BgL_arg1702z00_16741) ==
																				BGl_symbol5803z00zz__evaluate_compz00);
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test6590z00_26755 = ((bool_t) 0);
																		}
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	BgL_test6590z00_26755 = ((bool_t) 0);
																}
															if (BgL_test6590z00_26755)
																{
																	obj_t BgL_fz00_26763;

																	BgL_fz00_26763 = BgL_rz00_16740;
																	BgL_fz00_16739 = BgL_fz00_26763;
																	goto BgL_recz00_16738;
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	VECTOR_SET(BgL_nsz00_16733, ((long) 0),
																		BgL_savedzd2bpzd2_16737);
																	BgL_____rz00_16736 = BgL_rz00_16740;
											}}}}}
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_ez00_16735);
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_16734, BgL_sz00_16724);
											return BgL_____rz00_16736;
										}
									}
								}
							}
					}
				}
			}
		}

	}



/* &run5712 */
	obj_t BGl_z62run5712z62zz__evaluate_compz00(obj_t BgL_envz00_14426,
		obj_t BgL_sz00_14431)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				long BgL_siza7eza7_14427;
				obj_t BgL_valza2za2_14428;
				BgL_ev_absz00_bglt BgL_i1247z00_14429;
				obj_t BgL_bodyz00_14430;

				BgL_siza7eza7_14427 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14426, (int) (((long) 0))));
				BgL_valza2za2_14428 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14426, (int) (((long) 1))));
				BgL_i1247z00_14429 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14426, (int) (((long) 2))));
				BgL_bodyz00_14430 = PROCEDURE_REF(BgL_envz00_14426, (int) (((long) 3)));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_16742;

					BgL_bpz00_16742 = VECTOR_REF(((obj_t) BgL_sz00_14431), ((long) 0));
					BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_14431,
						BgL_valza2za2_14428,
						((long) CINT(BgL_bpz00_16742) + BgL_siza7eza7_14427));
					{	/* Eval/evaluate_comp.scm 1095 */
						obj_t BgL_z12denvz12_16743;
						obj_t BgL_wherez00_16744;
						obj_t BgL_locz00_16745;

						BgL_z12denvz12_16743 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_wherez00_16744 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14429))->
							BgL_wherez00);
						BgL_locz00_16745 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14429))->BgL_locz00);
						{	/* Eval/evaluate_comp.scm 1095 */

							BGL_ENV_PUSH_TRACE(BgL_z12denvz12_16743, BgL_wherez00_16744,
								BgL_locz00_16745);
							{	/* Eval/evaluate_comp.scm 1095 */
								obj_t BgL_za2za2resza2za2z00_16746;

								BgL_za2za2resza2za2z00_16746 =
									PROCEDURE_ENTRY(BgL_bodyz00_14430) (BgL_bodyz00_14430,
									BgL_sz00_14431, BEOA);
								BGL_ENV_POP_TRACE(BgL_z12denvz12_16743);
								return BgL_za2za2resza2za2z00_16746;
							}
						}
					}
				}
			}
		}

	}



/* &<@anonymous:3915> */
	obj_t BGl_z62zc3z04anonymousza33915ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_14432, obj_t BgL_sz00_14439)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_ifreesz00_14433;
				obj_t BgL_iboxesz00_14434;
				long BgL_siza7eza7_14435;
				BgL_ev_absz00_bglt BgL_i1247z00_14436;
				obj_t BgL_bodyz00_14437;
				long BgL_siza7ezd2framez75_14438;

				BgL_ifreesz00_14433 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14432, (int) (((long) 0))));
				BgL_iboxesz00_14434 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14432, (int) (((long) 1))));
				BgL_siza7eza7_14435 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14432, (int) (((long) 2))));
				BgL_i1247z00_14436 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14432, (int) (((long) 3))));
				BgL_bodyz00_14437 = PROCEDURE_REF(BgL_envz00_14432, (int) (((long) 4)));
				BgL_siza7ezd2framez75_14438 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14432, (int) (((long) 5))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_16747;

					BgL_bpz00_16747 = VECTOR_REF(((obj_t) BgL_sz00_14439), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_valza2za2_16748;

						BgL_valza2za2_16748 =
							BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_14439,
							BgL_bpz00_16747, BgL_ifreesz00_14433);
						{	/* Eval/evaluate_comp.scm 1174 */
							obj_t BgL_runz00_16749;

							BgL_runz00_16749 =
								MAKE_FX_PROCEDURE(BGl_z62run5714z62zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 5)));
							PROCEDURE_SET(BgL_runz00_16749,
								(int) (((long) 0)), BgL_iboxesz00_14434);
							PROCEDURE_SET(BgL_runz00_16749,
								(int) (((long) 1)), BINT(BgL_siza7eza7_14435));
							PROCEDURE_SET(BgL_runz00_16749,
								(int) (((long) 2)), BgL_valza2za2_16748);
							PROCEDURE_SET(BgL_runz00_16749,
								(int) (((long) 3)), ((obj_t) BgL_i1247z00_14436));
							PROCEDURE_SET(BgL_runz00_16749,
								(int) (((long) 4)), BgL_bodyz00_14437);
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_mainz00_16750;

								BgL_mainz00_16750 =
									MAKE_VA_PROCEDURE(BGl_z62main5713z62zz__evaluate_compz00,
									(int) (((long) -5)), (int) (((long) 7)));
								PROCEDURE_SET(BgL_mainz00_16750,
									(int) (((long) 0)), BgL_iboxesz00_14434);
								PROCEDURE_SET(BgL_mainz00_16750,
									(int) (((long) 1)), BINT(BgL_siza7eza7_14435));
								PROCEDURE_SET(BgL_mainz00_16750,
									(int) (((long) 2)), BgL_valza2za2_16748);
								PROCEDURE_SET(BgL_mainz00_16750,
									(int) (((long) 3)), ((obj_t) BgL_i1247z00_14436));
								PROCEDURE_SET(BgL_mainz00_16750,
									(int) (((long) 4)), BgL_bodyz00_14437);
								PROCEDURE_SET(BgL_mainz00_16750,
									(int) (((long) 5)), BgL_runz00_16749);
								PROCEDURE_SET(BgL_mainz00_16750,
									(int) (((long) 6)), BINT(BgL_siza7ezd2framez75_14438));
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_objz00_16751;

									BgL_objz00_16751 =
										BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
									PROCEDURE_ATTR_SET(BgL_runz00_16749, BgL_objz00_16751);
									BgL_objz00_16751;
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_arg3916z00_16752;

									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_arg3917z00_16753;

										BgL_arg3917z00_16753 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14436))->
											BgL_wherez00);
										{	/* Eval/evaluate_comp.scm 683 */
											obj_t BgL_newz00_16754;

											BgL_newz00_16754 =
												create_struct(BGl_symbol5824z00zz__evaluate_compz00,
												(int) (((long) 4)));
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_26851;

												BgL_tmpz00_26851 = (int) (((long) 3));
												STRUCT_SET(BgL_newz00_16754, BgL_tmpz00_26851,
													BgL_arg3917z00_16753);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_26856;
												int BgL_tmpz00_26854;

												BgL_auxz00_26856 = BINT(BgL_siza7ezd2framez75_14438);
												BgL_tmpz00_26854 = (int) (((long) 2));
												STRUCT_SET(BgL_newz00_16754, BgL_tmpz00_26854,
													BgL_auxz00_26856);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_26859;

												BgL_tmpz00_26859 = (int) (((long) 1));
												STRUCT_SET(BgL_newz00_16754, BgL_tmpz00_26859,
													BgL_runz00_16749);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_26864;
												int BgL_tmpz00_26862;

												BgL_auxz00_26864 = BINT(((long) -5));
												BgL_tmpz00_26862 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_16754, BgL_tmpz00_26862,
													BgL_auxz00_26864);
											}
											BgL_arg3916z00_16752 = BgL_newz00_16754;
									}}
									PROCEDURE_ATTR_SET(BgL_mainz00_16750, BgL_arg3916z00_16752);
									BgL_arg3916z00_16752;
								}
								return BgL_mainz00_16750;
							}
						}
					}
				}
			}
		}

	}



/* &main5713 */
	obj_t BGl_z62main5713z62zz__evaluate_compz00(obj_t BgL_envz00_14440,
		obj_t BgL_az00_14448, obj_t BgL_bz00_14449, obj_t BgL_cz00_14450,
		obj_t BgL_dz00_14451, obj_t BgL_lastz00_14452)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_runz00_14446;
				long BgL_siza7ezd2framez75_14447;

				BgL_runz00_14446 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14440, (int) (((long) 5))));
				BgL_siza7ezd2framez75_14447 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14440, (int) (((long) 6))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_sz00_16755;

					BgL_sz00_16755 = BGl_findzd2statezd2zz__evaluate_compz00();
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_bpz00_16756;

						BgL_bpz00_16756 = VECTOR_REF(((obj_t) BgL_sz00_16755), ((long) 0));
						if (
							(((long) CINT(BgL_bpz00_16756) + BgL_siza7ezd2framez75_14447) <
								VECTOR_LENGTH(((obj_t) BgL_sz00_16755))))
							{	/* Eval/evaluate_comp.scm 1174 */
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3920z00_16757;

									BgL_arg3920z00_16757 =
										((long) CINT(BgL_bpz00_16756) + ((long) 0));
									VECTOR_SET(
										((obj_t) BgL_sz00_16755), BgL_arg3920z00_16757,
										BgL_az00_14448);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3921z00_16758;

									BgL_arg3921z00_16758 =
										((long) CINT(BgL_bpz00_16756) + ((long) 1));
									VECTOR_SET(
										((obj_t) BgL_sz00_16755), BgL_arg3921z00_16758,
										BgL_bz00_14449);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3922z00_16759;

									BgL_arg3922z00_16759 =
										((long) CINT(BgL_bpz00_16756) + ((long) 2));
									VECTOR_SET(
										((obj_t) BgL_sz00_16755), BgL_arg3922z00_16759,
										BgL_cz00_14450);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3923z00_16760;

									BgL_arg3923z00_16760 =
										((long) CINT(BgL_bpz00_16756) + ((long) 3));
									VECTOR_SET(
										((obj_t) BgL_sz00_16755), BgL_arg3923z00_16760,
										BgL_dz00_14451);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3924z00_16761;

									BgL_arg3924z00_16761 =
										((long) CINT(BgL_bpz00_16756) + ((long) 4));
									VECTOR_SET(
										((obj_t) BgL_sz00_16755), BgL_arg3924z00_16761,
										BgL_lastz00_14452);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_ez00_16762;

									BgL_ez00_16762 = BGL_EXITD_TOP_AS_OBJ();
									BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_16762,
										BgL_bpz00_16756);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_accz00_16763;

										BgL_accz00_16763 =
											BGl_catchzd2trampolinezd2zz__evaluate_compz00
											(BgL_runz00_14446, BgL_sz00_16755, BgL_bpz00_16756);
										BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_16762);
										VECTOR_SET(
											((obj_t) BgL_sz00_16755), ((long) 0), BgL_bpz00_16756);
										return BgL_accz00_16763;
									}
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_nsz00_16764;

								BgL_nsz00_16764 = BGl_makezd2statezd2zz__evaluate_compz00();
								VECTOR_SET(BgL_nsz00_16764, ((long) 1), BgL_sz00_16755);
								VECTOR_SET(BgL_nsz00_16764, ((long) 2), BgL_az00_14448);
								VECTOR_SET(BgL_nsz00_16764, ((long) 3), BgL_bz00_14449);
								VECTOR_SET(BgL_nsz00_16764, ((long) 4), BgL_cz00_14450);
								VECTOR_SET(BgL_nsz00_16764, ((long) 5), BgL_dz00_14451);
								VECTOR_SET(BgL_nsz00_16764, ((long) 6), BgL_lastz00_14452);
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_z12denvz12_16765;

									BgL_z12denvz12_16765 = BGL_CURRENT_DYNAMIC_ENV();
									BGL_ENV_EVSTATE_SET(BgL_z12denvz12_16765, BgL_nsz00_16764);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_ez00_16766;

										BgL_ez00_16766 = BGL_EXITD_TOP_AS_OBJ();
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_16766,
											BgL_sz00_16755);
										{	/* Eval/evaluate_comp.scm 1174 */
											obj_t BgL_____rz00_16767;

											{	/* Eval/evaluate_comp.scm 670 */
												obj_t BgL_savedzd2bpzd2_16768;

												BgL_savedzd2bpzd2_16768 =
													VECTOR_REF(BgL_nsz00_16764, ((long) 0));
												VECTOR_SET(BgL_nsz00_16764, ((long) 0),
													BINT(((long) 2)));
												{
													obj_t BgL_fz00_16770;

													BgL_fz00_16770 = BgL_runz00_14446;
												BgL_recz00_16769:
													{	/* Eval/evaluate_comp.scm 673 */
														obj_t BgL_rz00_16771;

														BgL_rz00_16771 =
															PROCEDURE_ENTRY(BgL_fz00_16770) (BgL_fz00_16770,
															BgL_nsz00_16764, BEOA);
														{	/* Eval/evaluate_comp.scm 674 */
															bool_t BgL_test6594z00_26927;

															if (PROCEDUREP(BgL_rz00_16771))
																{	/* Eval/evaluate_comp.scm 674 */
																	obj_t BgL_arg1702z00_16772;

																	BgL_arg1702z00_16772 =
																		PROCEDURE_ATTR(BgL_rz00_16771);
																	if (STRUCTP(BgL_arg1702z00_16772))
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test6594z00_26927 =
																				(STRUCT_KEY(BgL_arg1702z00_16772) ==
																				BGl_symbol5803z00zz__evaluate_compz00);
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test6594z00_26927 = ((bool_t) 0);
																		}
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	BgL_test6594z00_26927 = ((bool_t) 0);
																}
															if (BgL_test6594z00_26927)
																{
																	obj_t BgL_fz00_26935;

																	BgL_fz00_26935 = BgL_rz00_16771;
																	BgL_fz00_16770 = BgL_fz00_26935;
																	goto BgL_recz00_16769;
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	VECTOR_SET(BgL_nsz00_16764, ((long) 0),
																		BgL_savedzd2bpzd2_16768);
																	BgL_____rz00_16767 = BgL_rz00_16771;
											}}}}}
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_ez00_16766);
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_16765, BgL_sz00_16755);
											return BgL_____rz00_16767;
										}
									}
								}
							}
					}
				}
			}
		}

	}



/* &run5714 */
	obj_t BGl_z62run5714z62zz__evaluate_compz00(obj_t BgL_envz00_14453,
		obj_t BgL_sz00_14459)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_iboxesz00_14454;
				long BgL_siza7eza7_14455;
				obj_t BgL_valza2za2_14456;
				BgL_ev_absz00_bglt BgL_i1247z00_14457;
				obj_t BgL_bodyz00_14458;

				BgL_iboxesz00_14454 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14453, (int) (((long) 0))));
				BgL_siza7eza7_14455 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14453, (int) (((long) 1))));
				BgL_valza2za2_14456 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14453, (int) (((long) 2))));
				BgL_i1247z00_14457 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14453, (int) (((long) 3))));
				BgL_bodyz00_14458 = PROCEDURE_REF(BgL_envz00_14453, (int) (((long) 4)));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_16773;

					BgL_bpz00_16773 = VECTOR_REF(((obj_t) BgL_sz00_14459), ((long) 0));
					BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_14459,
						BgL_iboxesz00_14454, BgL_bpz00_16773);
					BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_14459,
						BgL_valza2za2_14456,
						((long) CINT(BgL_bpz00_16773) + BgL_siza7eza7_14455));
					{	/* Eval/evaluate_comp.scm 1095 */
						obj_t BgL_z12denvz12_16774;
						obj_t BgL_wherez00_16775;
						obj_t BgL_locz00_16776;

						BgL_z12denvz12_16774 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_wherez00_16775 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14457))->
							BgL_wherez00);
						BgL_locz00_16776 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14457))->BgL_locz00);
						{	/* Eval/evaluate_comp.scm 1095 */

							BGL_ENV_PUSH_TRACE(BgL_z12denvz12_16774, BgL_wherez00_16775,
								BgL_locz00_16776);
							{	/* Eval/evaluate_comp.scm 1095 */
								obj_t BgL_za2za2resza2za2z00_16777;

								BgL_za2za2resza2za2z00_16777 =
									PROCEDURE_ENTRY(BgL_bodyz00_14458) (BgL_bodyz00_14458,
									BgL_sz00_14459, BEOA);
								BGL_ENV_POP_TRACE(BgL_z12denvz12_16774);
								return BgL_za2za2resza2za2z00_16777;
							}
						}
					}
				}
			}
		}

	}



/* &<@anonymous:3827> */
	obj_t BGl_z62zc3z04anonymousza33827ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_14460, obj_t BgL_sz00_14464)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				BgL_ev_absz00_bglt BgL_i1247z00_14461;
				obj_t BgL_bodyz00_14462;
				long BgL_siza7ezd2framez75_14463;

				BgL_i1247z00_14461 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14460, (int) (((long) 0))));
				BgL_bodyz00_14462 = PROCEDURE_REF(BgL_envz00_14460, (int) (((long) 1)));
				BgL_siza7ezd2framez75_14463 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14460, (int) (((long) 2))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_16778;

					BgL_bpz00_16778 = VECTOR_REF(((obj_t) BgL_sz00_14464), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1174 */

						{	/* Eval/evaluate_comp.scm 1174 */
							obj_t BgL_runz00_16779;

							BgL_runz00_16779 =
								MAKE_FX_PROCEDURE(BGl_z62run5716z62zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 2)));
							PROCEDURE_SET(BgL_runz00_16779,
								(int) (((long) 0)), ((obj_t) BgL_i1247z00_14461));
							PROCEDURE_SET(BgL_runz00_16779,
								(int) (((long) 1)), BgL_bodyz00_14462);
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_mainz00_16780;

								BgL_mainz00_16780 =
									MAKE_FX_PROCEDURE(BGl_z62main5715z62zz__evaluate_compz00,
									(int) (((long) 4)), (int) (((long) 4)));
								PROCEDURE_SET(BgL_mainz00_16780,
									(int) (((long) 0)), ((obj_t) BgL_i1247z00_14461));
								PROCEDURE_SET(BgL_mainz00_16780,
									(int) (((long) 1)), BgL_bodyz00_14462);
								PROCEDURE_SET(BgL_mainz00_16780,
									(int) (((long) 2)), BgL_runz00_16779);
								PROCEDURE_SET(BgL_mainz00_16780,
									(int) (((long) 3)), BINT(BgL_siza7ezd2framez75_14463));
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_objz00_16781;

									BgL_objz00_16781 =
										BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
									PROCEDURE_ATTR_SET(BgL_runz00_16779, BgL_objz00_16781);
									BgL_objz00_16781;
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_arg3828z00_16782;

									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_arg3829z00_16783;

										BgL_arg3829z00_16783 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14461))->
											BgL_wherez00);
										{	/* Eval/evaluate_comp.scm 683 */
											obj_t BgL_newz00_16784;

											BgL_newz00_16784 =
												create_struct(BGl_symbol5824z00zz__evaluate_compz00,
												(int) (((long) 4)));
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_27003;

												BgL_tmpz00_27003 = (int) (((long) 3));
												STRUCT_SET(BgL_newz00_16784, BgL_tmpz00_27003,
													BgL_arg3829z00_16783);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_27008;
												int BgL_tmpz00_27006;

												BgL_auxz00_27008 = BINT(BgL_siza7ezd2framez75_14463);
												BgL_tmpz00_27006 = (int) (((long) 2));
												STRUCT_SET(BgL_newz00_16784, BgL_tmpz00_27006,
													BgL_auxz00_27008);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_27011;

												BgL_tmpz00_27011 = (int) (((long) 1));
												STRUCT_SET(BgL_newz00_16784, BgL_tmpz00_27011,
													BgL_runz00_16779);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_27016;
												int BgL_tmpz00_27014;

												BgL_auxz00_27016 = BINT(((long) 4));
												BgL_tmpz00_27014 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_16784, BgL_tmpz00_27014,
													BgL_auxz00_27016);
											}
											BgL_arg3828z00_16782 = BgL_newz00_16784;
									}}
									PROCEDURE_ATTR_SET(BgL_mainz00_16780, BgL_arg3828z00_16782);
									BgL_arg3828z00_16782;
								}
								return BgL_mainz00_16780;
							}
						}
					}
				}
			}
		}

	}



/* &main5715 */
	obj_t BGl_z62main5715z62zz__evaluate_compz00(obj_t BgL_envz00_14465,
		obj_t BgL_az00_14470, obj_t BgL_bz00_14471, obj_t BgL_cz00_14472,
		obj_t BgL_dz00_14473)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_runz00_14468;
				long BgL_siza7ezd2framez75_14469;

				BgL_runz00_14468 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14465, (int) (((long) 2))));
				BgL_siza7ezd2framez75_14469 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14465, (int) (((long) 3))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_sz00_16785;

					BgL_sz00_16785 = BGl_findzd2statezd2zz__evaluate_compz00();
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_bpz00_16786;

						BgL_bpz00_16786 = VECTOR_REF(((obj_t) BgL_sz00_16785), ((long) 0));
						if (
							(((long) CINT(BgL_bpz00_16786) + BgL_siza7ezd2framez75_14469) <
								VECTOR_LENGTH(((obj_t) BgL_sz00_16785))))
							{	/* Eval/evaluate_comp.scm 1174 */
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3832z00_16787;

									BgL_arg3832z00_16787 =
										((long) CINT(BgL_bpz00_16786) + ((long) 0));
									VECTOR_SET(
										((obj_t) BgL_sz00_16785), BgL_arg3832z00_16787,
										BgL_az00_14470);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3833z00_16788;

									BgL_arg3833z00_16788 =
										((long) CINT(BgL_bpz00_16786) + ((long) 1));
									VECTOR_SET(
										((obj_t) BgL_sz00_16785), BgL_arg3833z00_16788,
										BgL_bz00_14471);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3834z00_16789;

									BgL_arg3834z00_16789 =
										((long) CINT(BgL_bpz00_16786) + ((long) 2));
									VECTOR_SET(
										((obj_t) BgL_sz00_16785), BgL_arg3834z00_16789,
										BgL_cz00_14472);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3835z00_16790;

									BgL_arg3835z00_16790 =
										((long) CINT(BgL_bpz00_16786) + ((long) 3));
									VECTOR_SET(
										((obj_t) BgL_sz00_16785), BgL_arg3835z00_16790,
										BgL_dz00_14473);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_ez00_16791;

									BgL_ez00_16791 = BGL_EXITD_TOP_AS_OBJ();
									BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_16791,
										BgL_bpz00_16786);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_accz00_16792;

										BgL_accz00_16792 =
											BGl_catchzd2trampolinezd2zz__evaluate_compz00
											(BgL_runz00_14468, BgL_sz00_16785, BgL_bpz00_16786);
										BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_16791);
										VECTOR_SET(
											((obj_t) BgL_sz00_16785), ((long) 0), BgL_bpz00_16786);
										return BgL_accz00_16792;
									}
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_nsz00_16793;

								BgL_nsz00_16793 = BGl_makezd2statezd2zz__evaluate_compz00();
								VECTOR_SET(BgL_nsz00_16793, ((long) 1), BgL_sz00_16785);
								VECTOR_SET(BgL_nsz00_16793, ((long) 2), BgL_az00_14470);
								VECTOR_SET(BgL_nsz00_16793, ((long) 3), BgL_bz00_14471);
								VECTOR_SET(BgL_nsz00_16793, ((long) 4), BgL_cz00_14472);
								VECTOR_SET(BgL_nsz00_16793, ((long) 5), BgL_dz00_14473);
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_z12denvz12_16794;

									BgL_z12denvz12_16794 = BGL_CURRENT_DYNAMIC_ENV();
									BGL_ENV_EVSTATE_SET(BgL_z12denvz12_16794, BgL_nsz00_16793);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_ez00_16795;

										BgL_ez00_16795 = BGL_EXITD_TOP_AS_OBJ();
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_16795,
											BgL_sz00_16785);
										{	/* Eval/evaluate_comp.scm 1174 */
											obj_t BgL_____rz00_16796;

											{	/* Eval/evaluate_comp.scm 670 */
												obj_t BgL_savedzd2bpzd2_16797;

												BgL_savedzd2bpzd2_16797 =
													VECTOR_REF(BgL_nsz00_16793, ((long) 0));
												VECTOR_SET(BgL_nsz00_16793, ((long) 0),
													BINT(((long) 2)));
												{
													obj_t BgL_fz00_16799;

													BgL_fz00_16799 = BgL_runz00_14468;
												BgL_recz00_16798:
													{	/* Eval/evaluate_comp.scm 673 */
														obj_t BgL_rz00_16800;

														BgL_rz00_16800 =
															PROCEDURE_ENTRY(BgL_fz00_16799) (BgL_fz00_16799,
															BgL_nsz00_16793, BEOA);
														{	/* Eval/evaluate_comp.scm 674 */
															bool_t BgL_test6598z00_27074;

															if (PROCEDUREP(BgL_rz00_16800))
																{	/* Eval/evaluate_comp.scm 674 */
																	obj_t BgL_arg1702z00_16801;

																	BgL_arg1702z00_16801 =
																		PROCEDURE_ATTR(BgL_rz00_16800);
																	if (STRUCTP(BgL_arg1702z00_16801))
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test6598z00_27074 =
																				(STRUCT_KEY(BgL_arg1702z00_16801) ==
																				BGl_symbol5803z00zz__evaluate_compz00);
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test6598z00_27074 = ((bool_t) 0);
																		}
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	BgL_test6598z00_27074 = ((bool_t) 0);
																}
															if (BgL_test6598z00_27074)
																{
																	obj_t BgL_fz00_27082;

																	BgL_fz00_27082 = BgL_rz00_16800;
																	BgL_fz00_16799 = BgL_fz00_27082;
																	goto BgL_recz00_16798;
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	VECTOR_SET(BgL_nsz00_16793, ((long) 0),
																		BgL_savedzd2bpzd2_16797);
																	BgL_____rz00_16796 = BgL_rz00_16800;
											}}}}}
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_ez00_16795);
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_16794, BgL_sz00_16785);
											return BgL_____rz00_16796;
										}
									}
								}
							}
					}
				}
			}
		}

	}



/* &run5716 */
	obj_t BGl_z62run5716z62zz__evaluate_compz00(obj_t BgL_envz00_14474,
		obj_t BgL_sz00_14477)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				BgL_ev_absz00_bglt BgL_i1247z00_14475;
				obj_t BgL_bodyz00_14476;

				BgL_i1247z00_14475 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14474, (int) (((long) 0))));
				BgL_bodyz00_14476 = PROCEDURE_REF(BgL_envz00_14474, (int) (((long) 1)));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_16802;

					BgL_bpz00_16802 = VECTOR_REF(((obj_t) BgL_sz00_14477), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_z12denvz12_16803;
						obj_t BgL_wherez00_16804;
						obj_t BgL_locz00_16805;

						BgL_z12denvz12_16803 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_wherez00_16804 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14475))->
							BgL_wherez00);
						BgL_locz00_16805 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14475))->BgL_locz00);
						{	/* Eval/evaluate_comp.scm 1174 */

							BGL_ENV_PUSH_TRACE(BgL_z12denvz12_16803, BgL_wherez00_16804,
								BgL_locz00_16805);
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_za2za2resza2za2z00_16806;

								BgL_za2za2resza2za2z00_16806 =
									PROCEDURE_ENTRY(BgL_bodyz00_14476) (BgL_bodyz00_14476,
									BgL_sz00_14477, BEOA);
								BGL_ENV_POP_TRACE(BgL_z12denvz12_16803);
								return BgL_za2za2resza2za2z00_16806;
							}
						}
					}
				}
			}
		}

	}



/* &<@anonymous:3837> */
	obj_t BGl_z62zc3z04anonymousza33837ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_14478, obj_t BgL_sz00_14483)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_iboxesz00_14479;
				BgL_ev_absz00_bglt BgL_i1247z00_14480;
				obj_t BgL_bodyz00_14481;
				long BgL_siza7ezd2framez75_14482;

				BgL_iboxesz00_14479 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14478, (int) (((long) 0))));
				BgL_i1247z00_14480 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14478, (int) (((long) 1))));
				BgL_bodyz00_14481 = PROCEDURE_REF(BgL_envz00_14478, (int) (((long) 2)));
				BgL_siza7ezd2framez75_14482 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14478, (int) (((long) 3))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_16807;

					BgL_bpz00_16807 = VECTOR_REF(((obj_t) BgL_sz00_14483), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1174 */

						{	/* Eval/evaluate_comp.scm 1174 */
							obj_t BgL_runz00_16808;

							BgL_runz00_16808 =
								MAKE_FX_PROCEDURE(BGl_z62run5718z62zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 3)));
							PROCEDURE_SET(BgL_runz00_16808,
								(int) (((long) 0)), BgL_iboxesz00_14479);
							PROCEDURE_SET(BgL_runz00_16808,
								(int) (((long) 1)), ((obj_t) BgL_i1247z00_14480));
							PROCEDURE_SET(BgL_runz00_16808,
								(int) (((long) 2)), BgL_bodyz00_14481);
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_mainz00_16809;

								BgL_mainz00_16809 =
									MAKE_FX_PROCEDURE(BGl_z62main5717z62zz__evaluate_compz00,
									(int) (((long) 4)), (int) (((long) 5)));
								PROCEDURE_SET(BgL_mainz00_16809,
									(int) (((long) 0)), BgL_iboxesz00_14479);
								PROCEDURE_SET(BgL_mainz00_16809,
									(int) (((long) 1)), ((obj_t) BgL_i1247z00_14480));
								PROCEDURE_SET(BgL_mainz00_16809,
									(int) (((long) 2)), BgL_bodyz00_14481);
								PROCEDURE_SET(BgL_mainz00_16809,
									(int) (((long) 3)), BgL_runz00_16808);
								PROCEDURE_SET(BgL_mainz00_16809,
									(int) (((long) 4)), BINT(BgL_siza7ezd2framez75_14482));
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_objz00_16810;

									BgL_objz00_16810 =
										BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
									PROCEDURE_ATTR_SET(BgL_runz00_16808, BgL_objz00_16810);
									BgL_objz00_16810;
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_arg3838z00_16811;

									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_arg3839z00_16812;

										BgL_arg3839z00_16812 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14480))->
											BgL_wherez00);
										{	/* Eval/evaluate_comp.scm 683 */
											obj_t BgL_newz00_16813;

											BgL_newz00_16813 =
												create_struct(BGl_symbol5824z00zz__evaluate_compz00,
												(int) (((long) 4)));
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_27144;

												BgL_tmpz00_27144 = (int) (((long) 3));
												STRUCT_SET(BgL_newz00_16813, BgL_tmpz00_27144,
													BgL_arg3839z00_16812);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_27149;
												int BgL_tmpz00_27147;

												BgL_auxz00_27149 = BINT(BgL_siza7ezd2framez75_14482);
												BgL_tmpz00_27147 = (int) (((long) 2));
												STRUCT_SET(BgL_newz00_16813, BgL_tmpz00_27147,
													BgL_auxz00_27149);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_27152;

												BgL_tmpz00_27152 = (int) (((long) 1));
												STRUCT_SET(BgL_newz00_16813, BgL_tmpz00_27152,
													BgL_runz00_16808);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_27157;
												int BgL_tmpz00_27155;

												BgL_auxz00_27157 = BINT(((long) 4));
												BgL_tmpz00_27155 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_16813, BgL_tmpz00_27155,
													BgL_auxz00_27157);
											}
											BgL_arg3838z00_16811 = BgL_newz00_16813;
									}}
									PROCEDURE_ATTR_SET(BgL_mainz00_16809, BgL_arg3838z00_16811);
									BgL_arg3838z00_16811;
								}
								return BgL_mainz00_16809;
							}
						}
					}
				}
			}
		}

	}



/* &main5717 */
	obj_t BGl_z62main5717z62zz__evaluate_compz00(obj_t BgL_envz00_14484,
		obj_t BgL_az00_14490, obj_t BgL_bz00_14491, obj_t BgL_cz00_14492,
		obj_t BgL_dz00_14493)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_runz00_14488;
				long BgL_siza7ezd2framez75_14489;

				BgL_runz00_14488 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14484, (int) (((long) 3))));
				BgL_siza7ezd2framez75_14489 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14484, (int) (((long) 4))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_sz00_16814;

					BgL_sz00_16814 = BGl_findzd2statezd2zz__evaluate_compz00();
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_bpz00_16815;

						BgL_bpz00_16815 = VECTOR_REF(((obj_t) BgL_sz00_16814), ((long) 0));
						if (
							(((long) CINT(BgL_bpz00_16815) + BgL_siza7ezd2framez75_14489) <
								VECTOR_LENGTH(((obj_t) BgL_sz00_16814))))
							{	/* Eval/evaluate_comp.scm 1174 */
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3842z00_16816;

									BgL_arg3842z00_16816 =
										((long) CINT(BgL_bpz00_16815) + ((long) 0));
									VECTOR_SET(
										((obj_t) BgL_sz00_16814), BgL_arg3842z00_16816,
										BgL_az00_14490);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3843z00_16817;

									BgL_arg3843z00_16817 =
										((long) CINT(BgL_bpz00_16815) + ((long) 1));
									VECTOR_SET(
										((obj_t) BgL_sz00_16814), BgL_arg3843z00_16817,
										BgL_bz00_14491);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3844z00_16818;

									BgL_arg3844z00_16818 =
										((long) CINT(BgL_bpz00_16815) + ((long) 2));
									VECTOR_SET(
										((obj_t) BgL_sz00_16814), BgL_arg3844z00_16818,
										BgL_cz00_14492);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3845z00_16819;

									BgL_arg3845z00_16819 =
										((long) CINT(BgL_bpz00_16815) + ((long) 3));
									VECTOR_SET(
										((obj_t) BgL_sz00_16814), BgL_arg3845z00_16819,
										BgL_dz00_14493);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_ez00_16820;

									BgL_ez00_16820 = BGL_EXITD_TOP_AS_OBJ();
									BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_16820,
										BgL_bpz00_16815);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_accz00_16821;

										BgL_accz00_16821 =
											BGl_catchzd2trampolinezd2zz__evaluate_compz00
											(BgL_runz00_14488, BgL_sz00_16814, BgL_bpz00_16815);
										BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_16820);
										VECTOR_SET(
											((obj_t) BgL_sz00_16814), ((long) 0), BgL_bpz00_16815);
										return BgL_accz00_16821;
									}
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_nsz00_16822;

								BgL_nsz00_16822 = BGl_makezd2statezd2zz__evaluate_compz00();
								VECTOR_SET(BgL_nsz00_16822, ((long) 1), BgL_sz00_16814);
								VECTOR_SET(BgL_nsz00_16822, ((long) 2), BgL_az00_14490);
								VECTOR_SET(BgL_nsz00_16822, ((long) 3), BgL_bz00_14491);
								VECTOR_SET(BgL_nsz00_16822, ((long) 4), BgL_cz00_14492);
								VECTOR_SET(BgL_nsz00_16822, ((long) 5), BgL_dz00_14493);
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_z12denvz12_16823;

									BgL_z12denvz12_16823 = BGL_CURRENT_DYNAMIC_ENV();
									BGL_ENV_EVSTATE_SET(BgL_z12denvz12_16823, BgL_nsz00_16822);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_ez00_16824;

										BgL_ez00_16824 = BGL_EXITD_TOP_AS_OBJ();
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_16824,
											BgL_sz00_16814);
										{	/* Eval/evaluate_comp.scm 1174 */
											obj_t BgL_____rz00_16825;

											{	/* Eval/evaluate_comp.scm 670 */
												obj_t BgL_savedzd2bpzd2_16826;

												BgL_savedzd2bpzd2_16826 =
													VECTOR_REF(BgL_nsz00_16822, ((long) 0));
												VECTOR_SET(BgL_nsz00_16822, ((long) 0),
													BINT(((long) 2)));
												{
													obj_t BgL_fz00_16828;

													BgL_fz00_16828 = BgL_runz00_14488;
												BgL_recz00_16827:
													{	/* Eval/evaluate_comp.scm 673 */
														obj_t BgL_rz00_16829;

														BgL_rz00_16829 =
															PROCEDURE_ENTRY(BgL_fz00_16828) (BgL_fz00_16828,
															BgL_nsz00_16822, BEOA);
														{	/* Eval/evaluate_comp.scm 674 */
															bool_t BgL_test6602z00_27215;

															if (PROCEDUREP(BgL_rz00_16829))
																{	/* Eval/evaluate_comp.scm 674 */
																	obj_t BgL_arg1702z00_16830;

																	BgL_arg1702z00_16830 =
																		PROCEDURE_ATTR(BgL_rz00_16829);
																	if (STRUCTP(BgL_arg1702z00_16830))
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test6602z00_27215 =
																				(STRUCT_KEY(BgL_arg1702z00_16830) ==
																				BGl_symbol5803z00zz__evaluate_compz00);
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test6602z00_27215 = ((bool_t) 0);
																		}
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	BgL_test6602z00_27215 = ((bool_t) 0);
																}
															if (BgL_test6602z00_27215)
																{
																	obj_t BgL_fz00_27223;

																	BgL_fz00_27223 = BgL_rz00_16829;
																	BgL_fz00_16828 = BgL_fz00_27223;
																	goto BgL_recz00_16827;
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	VECTOR_SET(BgL_nsz00_16822, ((long) 0),
																		BgL_savedzd2bpzd2_16826);
																	BgL_____rz00_16825 = BgL_rz00_16829;
											}}}}}
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_ez00_16824);
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_16823, BgL_sz00_16814);
											return BgL_____rz00_16825;
										}
									}
								}
							}
					}
				}
			}
		}

	}



/* &run5718 */
	obj_t BGl_z62run5718z62zz__evaluate_compz00(obj_t BgL_envz00_14494,
		obj_t BgL_sz00_14498)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_iboxesz00_14495;
				BgL_ev_absz00_bglt BgL_i1247z00_14496;
				obj_t BgL_bodyz00_14497;

				BgL_iboxesz00_14495 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14494, (int) (((long) 0))));
				BgL_i1247z00_14496 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14494, (int) (((long) 1))));
				BgL_bodyz00_14497 = PROCEDURE_REF(BgL_envz00_14494, (int) (((long) 2)));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_16831;

					BgL_bpz00_16831 = VECTOR_REF(((obj_t) BgL_sz00_14498), ((long) 0));
					BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_14498,
						BgL_iboxesz00_14495, BgL_bpz00_16831);
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_z12denvz12_16832;
						obj_t BgL_wherez00_16833;
						obj_t BgL_locz00_16834;

						BgL_z12denvz12_16832 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_wherez00_16833 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14496))->
							BgL_wherez00);
						BgL_locz00_16834 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14496))->BgL_locz00);
						{	/* Eval/evaluate_comp.scm 1174 */

							BGL_ENV_PUSH_TRACE(BgL_z12denvz12_16832, BgL_wherez00_16833,
								BgL_locz00_16834);
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_za2za2resza2za2z00_16835;

								BgL_za2za2resza2za2z00_16835 =
									PROCEDURE_ENTRY(BgL_bodyz00_14497) (BgL_bodyz00_14497,
									BgL_sz00_14498, BEOA);
								BGL_ENV_POP_TRACE(BgL_z12denvz12_16832);
								return BgL_za2za2resza2za2z00_16835;
							}
						}
					}
				}
			}
		}

	}



/* &<@anonymous:3850> */
	obj_t BGl_z62zc3z04anonymousza33850ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_14499, obj_t BgL_sz00_14505)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_ifreesz00_14500;
				long BgL_siza7eza7_14501;
				BgL_ev_absz00_bglt BgL_i1247z00_14502;
				obj_t BgL_bodyz00_14503;
				long BgL_siza7ezd2framez75_14504;

				BgL_ifreesz00_14500 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14499, (int) (((long) 0))));
				BgL_siza7eza7_14501 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14499, (int) (((long) 1))));
				BgL_i1247z00_14502 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14499, (int) (((long) 2))));
				BgL_bodyz00_14503 = PROCEDURE_REF(BgL_envz00_14499, (int) (((long) 3)));
				BgL_siza7ezd2framez75_14504 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14499, (int) (((long) 4))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_16836;

					BgL_bpz00_16836 = VECTOR_REF(((obj_t) BgL_sz00_14505), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_valza2za2_16837;

						BgL_valza2za2_16837 =
							BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_14505,
							BgL_bpz00_16836, BgL_ifreesz00_14500);
						{	/* Eval/evaluate_comp.scm 1174 */
							obj_t BgL_runz00_16838;

							BgL_runz00_16838 =
								MAKE_FX_PROCEDURE(BGl_z62run5720z62zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 4)));
							PROCEDURE_SET(BgL_runz00_16838,
								(int) (((long) 0)), BINT(BgL_siza7eza7_14501));
							PROCEDURE_SET(BgL_runz00_16838,
								(int) (((long) 1)), BgL_valza2za2_16837);
							PROCEDURE_SET(BgL_runz00_16838,
								(int) (((long) 2)), ((obj_t) BgL_i1247z00_14502));
							PROCEDURE_SET(BgL_runz00_16838,
								(int) (((long) 3)), BgL_bodyz00_14503);
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_mainz00_16839;

								BgL_mainz00_16839 =
									MAKE_FX_PROCEDURE(BGl_z62main5719z62zz__evaluate_compz00,
									(int) (((long) 4)), (int) (((long) 6)));
								PROCEDURE_SET(BgL_mainz00_16839,
									(int) (((long) 0)), BINT(BgL_siza7eza7_14501));
								PROCEDURE_SET(BgL_mainz00_16839,
									(int) (((long) 1)), BgL_valza2za2_16837);
								PROCEDURE_SET(BgL_mainz00_16839,
									(int) (((long) 2)), ((obj_t) BgL_i1247z00_14502));
								PROCEDURE_SET(BgL_mainz00_16839,
									(int) (((long) 3)), BgL_bodyz00_14503);
								PROCEDURE_SET(BgL_mainz00_16839,
									(int) (((long) 4)), BgL_runz00_16838);
								PROCEDURE_SET(BgL_mainz00_16839,
									(int) (((long) 5)), BINT(BgL_siza7ezd2framez75_14504));
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_objz00_16840;

									BgL_objz00_16840 =
										BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
									PROCEDURE_ATTR_SET(BgL_runz00_16838, BgL_objz00_16840);
									BgL_objz00_16840;
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_arg3851z00_16841;

									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_arg3852z00_16842;

										BgL_arg3852z00_16842 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14502))->
											BgL_wherez00);
										{	/* Eval/evaluate_comp.scm 683 */
											obj_t BgL_newz00_16843;

											BgL_newz00_16843 =
												create_struct(BGl_symbol5824z00zz__evaluate_compz00,
												(int) (((long) 4)));
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_27299;

												BgL_tmpz00_27299 = (int) (((long) 3));
												STRUCT_SET(BgL_newz00_16843, BgL_tmpz00_27299,
													BgL_arg3852z00_16842);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_27304;
												int BgL_tmpz00_27302;

												BgL_auxz00_27304 = BINT(BgL_siza7ezd2framez75_14504);
												BgL_tmpz00_27302 = (int) (((long) 2));
												STRUCT_SET(BgL_newz00_16843, BgL_tmpz00_27302,
													BgL_auxz00_27304);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_27307;

												BgL_tmpz00_27307 = (int) (((long) 1));
												STRUCT_SET(BgL_newz00_16843, BgL_tmpz00_27307,
													BgL_runz00_16838);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_27312;
												int BgL_tmpz00_27310;

												BgL_auxz00_27312 = BINT(((long) 4));
												BgL_tmpz00_27310 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_16843, BgL_tmpz00_27310,
													BgL_auxz00_27312);
											}
											BgL_arg3851z00_16841 = BgL_newz00_16843;
									}}
									PROCEDURE_ATTR_SET(BgL_mainz00_16839, BgL_arg3851z00_16841);
									BgL_arg3851z00_16841;
								}
								return BgL_mainz00_16839;
							}
						}
					}
				}
			}
		}

	}



/* &main5719 */
	obj_t BGl_z62main5719z62zz__evaluate_compz00(obj_t BgL_envz00_14506,
		obj_t BgL_az00_14513, obj_t BgL_bz00_14514, obj_t BgL_cz00_14515,
		obj_t BgL_dz00_14516)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_runz00_14511;
				long BgL_siza7ezd2framez75_14512;

				BgL_runz00_14511 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14506, (int) (((long) 4))));
				BgL_siza7ezd2framez75_14512 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14506, (int) (((long) 5))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_sz00_16844;

					BgL_sz00_16844 = BGl_findzd2statezd2zz__evaluate_compz00();
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_bpz00_16845;

						BgL_bpz00_16845 = VECTOR_REF(((obj_t) BgL_sz00_16844), ((long) 0));
						if (
							(((long) CINT(BgL_bpz00_16845) + BgL_siza7ezd2framez75_14512) <
								VECTOR_LENGTH(((obj_t) BgL_sz00_16844))))
							{	/* Eval/evaluate_comp.scm 1174 */
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3855z00_16846;

									BgL_arg3855z00_16846 =
										((long) CINT(BgL_bpz00_16845) + ((long) 0));
									VECTOR_SET(
										((obj_t) BgL_sz00_16844), BgL_arg3855z00_16846,
										BgL_az00_14513);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3856z00_16847;

									BgL_arg3856z00_16847 =
										((long) CINT(BgL_bpz00_16845) + ((long) 1));
									VECTOR_SET(
										((obj_t) BgL_sz00_16844), BgL_arg3856z00_16847,
										BgL_bz00_14514);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3857z00_16848;

									BgL_arg3857z00_16848 =
										((long) CINT(BgL_bpz00_16845) + ((long) 2));
									VECTOR_SET(
										((obj_t) BgL_sz00_16844), BgL_arg3857z00_16848,
										BgL_cz00_14515);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3858z00_16849;

									BgL_arg3858z00_16849 =
										((long) CINT(BgL_bpz00_16845) + ((long) 3));
									VECTOR_SET(
										((obj_t) BgL_sz00_16844), BgL_arg3858z00_16849,
										BgL_dz00_14516);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_ez00_16850;

									BgL_ez00_16850 = BGL_EXITD_TOP_AS_OBJ();
									BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_16850,
										BgL_bpz00_16845);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_accz00_16851;

										BgL_accz00_16851 =
											BGl_catchzd2trampolinezd2zz__evaluate_compz00
											(BgL_runz00_14511, BgL_sz00_16844, BgL_bpz00_16845);
										BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_16850);
										VECTOR_SET(
											((obj_t) BgL_sz00_16844), ((long) 0), BgL_bpz00_16845);
										return BgL_accz00_16851;
									}
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_nsz00_16852;

								BgL_nsz00_16852 = BGl_makezd2statezd2zz__evaluate_compz00();
								VECTOR_SET(BgL_nsz00_16852, ((long) 1), BgL_sz00_16844);
								VECTOR_SET(BgL_nsz00_16852, ((long) 2), BgL_az00_14513);
								VECTOR_SET(BgL_nsz00_16852, ((long) 3), BgL_bz00_14514);
								VECTOR_SET(BgL_nsz00_16852, ((long) 4), BgL_cz00_14515);
								VECTOR_SET(BgL_nsz00_16852, ((long) 5), BgL_dz00_14516);
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_z12denvz12_16853;

									BgL_z12denvz12_16853 = BGL_CURRENT_DYNAMIC_ENV();
									BGL_ENV_EVSTATE_SET(BgL_z12denvz12_16853, BgL_nsz00_16852);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_ez00_16854;

										BgL_ez00_16854 = BGL_EXITD_TOP_AS_OBJ();
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_16854,
											BgL_sz00_16844);
										{	/* Eval/evaluate_comp.scm 1174 */
											obj_t BgL_____rz00_16855;

											{	/* Eval/evaluate_comp.scm 670 */
												obj_t BgL_savedzd2bpzd2_16856;

												BgL_savedzd2bpzd2_16856 =
													VECTOR_REF(BgL_nsz00_16852, ((long) 0));
												VECTOR_SET(BgL_nsz00_16852, ((long) 0),
													BINT(((long) 2)));
												{
													obj_t BgL_fz00_16858;

													BgL_fz00_16858 = BgL_runz00_14511;
												BgL_recz00_16857:
													{	/* Eval/evaluate_comp.scm 673 */
														obj_t BgL_rz00_16859;

														BgL_rz00_16859 =
															PROCEDURE_ENTRY(BgL_fz00_16858) (BgL_fz00_16858,
															BgL_nsz00_16852, BEOA);
														{	/* Eval/evaluate_comp.scm 674 */
															bool_t BgL_test6606z00_27370;

															if (PROCEDUREP(BgL_rz00_16859))
																{	/* Eval/evaluate_comp.scm 674 */
																	obj_t BgL_arg1702z00_16860;

																	BgL_arg1702z00_16860 =
																		PROCEDURE_ATTR(BgL_rz00_16859);
																	if (STRUCTP(BgL_arg1702z00_16860))
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test6606z00_27370 =
																				(STRUCT_KEY(BgL_arg1702z00_16860) ==
																				BGl_symbol5803z00zz__evaluate_compz00);
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test6606z00_27370 = ((bool_t) 0);
																		}
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	BgL_test6606z00_27370 = ((bool_t) 0);
																}
															if (BgL_test6606z00_27370)
																{
																	obj_t BgL_fz00_27378;

																	BgL_fz00_27378 = BgL_rz00_16859;
																	BgL_fz00_16858 = BgL_fz00_27378;
																	goto BgL_recz00_16857;
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	VECTOR_SET(BgL_nsz00_16852, ((long) 0),
																		BgL_savedzd2bpzd2_16856);
																	BgL_____rz00_16855 = BgL_rz00_16859;
											}}}}}
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_ez00_16854);
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_16853, BgL_sz00_16844);
											return BgL_____rz00_16855;
										}
									}
								}
							}
					}
				}
			}
		}

	}



/* &run5720 */
	obj_t BGl_z62run5720z62zz__evaluate_compz00(obj_t BgL_envz00_14517,
		obj_t BgL_sz00_14522)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				long BgL_siza7eza7_14518;
				obj_t BgL_valza2za2_14519;
				BgL_ev_absz00_bglt BgL_i1247z00_14520;
				obj_t BgL_bodyz00_14521;

				BgL_siza7eza7_14518 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14517, (int) (((long) 0))));
				BgL_valza2za2_14519 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14517, (int) (((long) 1))));
				BgL_i1247z00_14520 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14517, (int) (((long) 2))));
				BgL_bodyz00_14521 = PROCEDURE_REF(BgL_envz00_14517, (int) (((long) 3)));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_16861;

					BgL_bpz00_16861 = VECTOR_REF(((obj_t) BgL_sz00_14522), ((long) 0));
					BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_14522,
						BgL_valza2za2_14519,
						((long) CINT(BgL_bpz00_16861) + BgL_siza7eza7_14518));
					{	/* Eval/evaluate_comp.scm 1095 */
						obj_t BgL_z12denvz12_16862;
						obj_t BgL_wherez00_16863;
						obj_t BgL_locz00_16864;

						BgL_z12denvz12_16862 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_wherez00_16863 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14520))->
							BgL_wherez00);
						BgL_locz00_16864 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14520))->BgL_locz00);
						{	/* Eval/evaluate_comp.scm 1095 */

							BGL_ENV_PUSH_TRACE(BgL_z12denvz12_16862, BgL_wherez00_16863,
								BgL_locz00_16864);
							{	/* Eval/evaluate_comp.scm 1095 */
								obj_t BgL_za2za2resza2za2z00_16865;

								BgL_za2za2resza2za2z00_16865 =
									PROCEDURE_ENTRY(BgL_bodyz00_14521) (BgL_bodyz00_14521,
									BgL_sz00_14522, BEOA);
								BGL_ENV_POP_TRACE(BgL_z12denvz12_16862);
								return BgL_za2za2resza2za2z00_16865;
							}
						}
					}
				}
			}
		}

	}



/* &<@anonymous:3861> */
	obj_t BGl_z62zc3z04anonymousza33861ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_14523, obj_t BgL_sz00_14530)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_ifreesz00_14524;
				obj_t BgL_iboxesz00_14525;
				long BgL_siza7eza7_14526;
				BgL_ev_absz00_bglt BgL_i1247z00_14527;
				obj_t BgL_bodyz00_14528;
				long BgL_siza7ezd2framez75_14529;

				BgL_ifreesz00_14524 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14523, (int) (((long) 0))));
				BgL_iboxesz00_14525 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14523, (int) (((long) 1))));
				BgL_siza7eza7_14526 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14523, (int) (((long) 2))));
				BgL_i1247z00_14527 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14523, (int) (((long) 3))));
				BgL_bodyz00_14528 = PROCEDURE_REF(BgL_envz00_14523, (int) (((long) 4)));
				BgL_siza7ezd2framez75_14529 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14523, (int) (((long) 5))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_16866;

					BgL_bpz00_16866 = VECTOR_REF(((obj_t) BgL_sz00_14530), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_valza2za2_16867;

						BgL_valza2za2_16867 =
							BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_14530,
							BgL_bpz00_16866, BgL_ifreesz00_14524);
						{	/* Eval/evaluate_comp.scm 1174 */
							obj_t BgL_runz00_16868;

							BgL_runz00_16868 =
								MAKE_FX_PROCEDURE(BGl_z62run5722z62zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 5)));
							PROCEDURE_SET(BgL_runz00_16868,
								(int) (((long) 0)), BgL_iboxesz00_14525);
							PROCEDURE_SET(BgL_runz00_16868,
								(int) (((long) 1)), BINT(BgL_siza7eza7_14526));
							PROCEDURE_SET(BgL_runz00_16868,
								(int) (((long) 2)), BgL_valza2za2_16867);
							PROCEDURE_SET(BgL_runz00_16868,
								(int) (((long) 3)), ((obj_t) BgL_i1247z00_14527));
							PROCEDURE_SET(BgL_runz00_16868,
								(int) (((long) 4)), BgL_bodyz00_14528);
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_mainz00_16869;

								BgL_mainz00_16869 =
									MAKE_FX_PROCEDURE(BGl_z62main5721z62zz__evaluate_compz00,
									(int) (((long) 4)), (int) (((long) 7)));
								PROCEDURE_SET(BgL_mainz00_16869,
									(int) (((long) 0)), BgL_iboxesz00_14525);
								PROCEDURE_SET(BgL_mainz00_16869,
									(int) (((long) 1)), BINT(BgL_siza7eza7_14526));
								PROCEDURE_SET(BgL_mainz00_16869,
									(int) (((long) 2)), BgL_valza2za2_16867);
								PROCEDURE_SET(BgL_mainz00_16869,
									(int) (((long) 3)), ((obj_t) BgL_i1247z00_14527));
								PROCEDURE_SET(BgL_mainz00_16869,
									(int) (((long) 4)), BgL_bodyz00_14528);
								PROCEDURE_SET(BgL_mainz00_16869,
									(int) (((long) 5)), BgL_runz00_16868);
								PROCEDURE_SET(BgL_mainz00_16869,
									(int) (((long) 6)), BINT(BgL_siza7ezd2framez75_14529));
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_objz00_16870;

									BgL_objz00_16870 =
										BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
									PROCEDURE_ATTR_SET(BgL_runz00_16868, BgL_objz00_16870);
									BgL_objz00_16870;
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_arg3862z00_16871;

									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_arg3863z00_16872;

										BgL_arg3863z00_16872 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14527))->
											BgL_wherez00);
										{	/* Eval/evaluate_comp.scm 683 */
											obj_t BgL_newz00_16873;

											BgL_newz00_16873 =
												create_struct(BGl_symbol5824z00zz__evaluate_compz00,
												(int) (((long) 4)));
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_27466;

												BgL_tmpz00_27466 = (int) (((long) 3));
												STRUCT_SET(BgL_newz00_16873, BgL_tmpz00_27466,
													BgL_arg3863z00_16872);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_27471;
												int BgL_tmpz00_27469;

												BgL_auxz00_27471 = BINT(BgL_siza7ezd2framez75_14529);
												BgL_tmpz00_27469 = (int) (((long) 2));
												STRUCT_SET(BgL_newz00_16873, BgL_tmpz00_27469,
													BgL_auxz00_27471);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_27474;

												BgL_tmpz00_27474 = (int) (((long) 1));
												STRUCT_SET(BgL_newz00_16873, BgL_tmpz00_27474,
													BgL_runz00_16868);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_27479;
												int BgL_tmpz00_27477;

												BgL_auxz00_27479 = BINT(((long) 4));
												BgL_tmpz00_27477 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_16873, BgL_tmpz00_27477,
													BgL_auxz00_27479);
											}
											BgL_arg3862z00_16871 = BgL_newz00_16873;
									}}
									PROCEDURE_ATTR_SET(BgL_mainz00_16869, BgL_arg3862z00_16871);
									BgL_arg3862z00_16871;
								}
								return BgL_mainz00_16869;
							}
						}
					}
				}
			}
		}

	}



/* &main5721 */
	obj_t BGl_z62main5721z62zz__evaluate_compz00(obj_t BgL_envz00_14531,
		obj_t BgL_az00_14539, obj_t BgL_bz00_14540, obj_t BgL_cz00_14541,
		obj_t BgL_dz00_14542)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_runz00_14537;
				long BgL_siza7ezd2framez75_14538;

				BgL_runz00_14537 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14531, (int) (((long) 5))));
				BgL_siza7ezd2framez75_14538 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14531, (int) (((long) 6))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_sz00_16874;

					BgL_sz00_16874 = BGl_findzd2statezd2zz__evaluate_compz00();
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_bpz00_16875;

						BgL_bpz00_16875 = VECTOR_REF(((obj_t) BgL_sz00_16874), ((long) 0));
						if (
							(((long) CINT(BgL_bpz00_16875) + BgL_siza7ezd2framez75_14538) <
								VECTOR_LENGTH(((obj_t) BgL_sz00_16874))))
							{	/* Eval/evaluate_comp.scm 1174 */
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3866z00_16876;

									BgL_arg3866z00_16876 =
										((long) CINT(BgL_bpz00_16875) + ((long) 0));
									VECTOR_SET(
										((obj_t) BgL_sz00_16874), BgL_arg3866z00_16876,
										BgL_az00_14539);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3867z00_16877;

									BgL_arg3867z00_16877 =
										((long) CINT(BgL_bpz00_16875) + ((long) 1));
									VECTOR_SET(
										((obj_t) BgL_sz00_16874), BgL_arg3867z00_16877,
										BgL_bz00_14540);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3868z00_16878;

									BgL_arg3868z00_16878 =
										((long) CINT(BgL_bpz00_16875) + ((long) 2));
									VECTOR_SET(
										((obj_t) BgL_sz00_16874), BgL_arg3868z00_16878,
										BgL_cz00_14541);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3869z00_16879;

									BgL_arg3869z00_16879 =
										((long) CINT(BgL_bpz00_16875) + ((long) 3));
									VECTOR_SET(
										((obj_t) BgL_sz00_16874), BgL_arg3869z00_16879,
										BgL_dz00_14542);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_ez00_16880;

									BgL_ez00_16880 = BGL_EXITD_TOP_AS_OBJ();
									BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_16880,
										BgL_bpz00_16875);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_accz00_16881;

										BgL_accz00_16881 =
											BGl_catchzd2trampolinezd2zz__evaluate_compz00
											(BgL_runz00_14537, BgL_sz00_16874, BgL_bpz00_16875);
										BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_16880);
										VECTOR_SET(
											((obj_t) BgL_sz00_16874), ((long) 0), BgL_bpz00_16875);
										return BgL_accz00_16881;
									}
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_nsz00_16882;

								BgL_nsz00_16882 = BGl_makezd2statezd2zz__evaluate_compz00();
								VECTOR_SET(BgL_nsz00_16882, ((long) 1), BgL_sz00_16874);
								VECTOR_SET(BgL_nsz00_16882, ((long) 2), BgL_az00_14539);
								VECTOR_SET(BgL_nsz00_16882, ((long) 3), BgL_bz00_14540);
								VECTOR_SET(BgL_nsz00_16882, ((long) 4), BgL_cz00_14541);
								VECTOR_SET(BgL_nsz00_16882, ((long) 5), BgL_dz00_14542);
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_z12denvz12_16883;

									BgL_z12denvz12_16883 = BGL_CURRENT_DYNAMIC_ENV();
									BGL_ENV_EVSTATE_SET(BgL_z12denvz12_16883, BgL_nsz00_16882);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_ez00_16884;

										BgL_ez00_16884 = BGL_EXITD_TOP_AS_OBJ();
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_16884,
											BgL_sz00_16874);
										{	/* Eval/evaluate_comp.scm 1174 */
											obj_t BgL_____rz00_16885;

											{	/* Eval/evaluate_comp.scm 670 */
												obj_t BgL_savedzd2bpzd2_16886;

												BgL_savedzd2bpzd2_16886 =
													VECTOR_REF(BgL_nsz00_16882, ((long) 0));
												VECTOR_SET(BgL_nsz00_16882, ((long) 0),
													BINT(((long) 2)));
												{
													obj_t BgL_fz00_16888;

													BgL_fz00_16888 = BgL_runz00_14537;
												BgL_recz00_16887:
													{	/* Eval/evaluate_comp.scm 673 */
														obj_t BgL_rz00_16889;

														BgL_rz00_16889 =
															PROCEDURE_ENTRY(BgL_fz00_16888) (BgL_fz00_16888,
															BgL_nsz00_16882, BEOA);
														{	/* Eval/evaluate_comp.scm 674 */
															bool_t BgL_test6610z00_27537;

															if (PROCEDUREP(BgL_rz00_16889))
																{	/* Eval/evaluate_comp.scm 674 */
																	obj_t BgL_arg1702z00_16890;

																	BgL_arg1702z00_16890 =
																		PROCEDURE_ATTR(BgL_rz00_16889);
																	if (STRUCTP(BgL_arg1702z00_16890))
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test6610z00_27537 =
																				(STRUCT_KEY(BgL_arg1702z00_16890) ==
																				BGl_symbol5803z00zz__evaluate_compz00);
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test6610z00_27537 = ((bool_t) 0);
																		}
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	BgL_test6610z00_27537 = ((bool_t) 0);
																}
															if (BgL_test6610z00_27537)
																{
																	obj_t BgL_fz00_27545;

																	BgL_fz00_27545 = BgL_rz00_16889;
																	BgL_fz00_16888 = BgL_fz00_27545;
																	goto BgL_recz00_16887;
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	VECTOR_SET(BgL_nsz00_16882, ((long) 0),
																		BgL_savedzd2bpzd2_16886);
																	BgL_____rz00_16885 = BgL_rz00_16889;
											}}}}}
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_ez00_16884);
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_16883, BgL_sz00_16874);
											return BgL_____rz00_16885;
										}
									}
								}
							}
					}
				}
			}
		}

	}



/* &run5722 */
	obj_t BGl_z62run5722z62zz__evaluate_compz00(obj_t BgL_envz00_14543,
		obj_t BgL_sz00_14549)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_iboxesz00_14544;
				long BgL_siza7eza7_14545;
				obj_t BgL_valza2za2_14546;
				BgL_ev_absz00_bglt BgL_i1247z00_14547;
				obj_t BgL_bodyz00_14548;

				BgL_iboxesz00_14544 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14543, (int) (((long) 0))));
				BgL_siza7eza7_14545 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14543, (int) (((long) 1))));
				BgL_valza2za2_14546 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14543, (int) (((long) 2))));
				BgL_i1247z00_14547 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14543, (int) (((long) 3))));
				BgL_bodyz00_14548 = PROCEDURE_REF(BgL_envz00_14543, (int) (((long) 4)));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_16891;

					BgL_bpz00_16891 = VECTOR_REF(((obj_t) BgL_sz00_14549), ((long) 0));
					BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_14549,
						BgL_iboxesz00_14544, BgL_bpz00_16891);
					BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_14549,
						BgL_valza2za2_14546,
						((long) CINT(BgL_bpz00_16891) + BgL_siza7eza7_14545));
					{	/* Eval/evaluate_comp.scm 1095 */
						obj_t BgL_z12denvz12_16892;
						obj_t BgL_wherez00_16893;
						obj_t BgL_locz00_16894;

						BgL_z12denvz12_16892 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_wherez00_16893 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14547))->
							BgL_wherez00);
						BgL_locz00_16894 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14547))->BgL_locz00);
						{	/* Eval/evaluate_comp.scm 1095 */

							BGL_ENV_PUSH_TRACE(BgL_z12denvz12_16892, BgL_wherez00_16893,
								BgL_locz00_16894);
							{	/* Eval/evaluate_comp.scm 1095 */
								obj_t BgL_za2za2resza2za2z00_16895;

								BgL_za2za2resza2za2z00_16895 =
									PROCEDURE_ENTRY(BgL_bodyz00_14548) (BgL_bodyz00_14548,
									BgL_sz00_14549, BEOA);
								BGL_ENV_POP_TRACE(BgL_z12denvz12_16892);
								return BgL_za2za2resza2za2z00_16895;
							}
						}
					}
				}
			}
		}

	}



/* &<@anonymous:3776> */
	obj_t BGl_z62zc3z04anonymousza33776ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_14550, obj_t BgL_sz00_14554)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				BgL_ev_absz00_bglt BgL_i1247z00_14551;
				obj_t BgL_bodyz00_14552;
				long BgL_siza7ezd2framez75_14553;

				BgL_i1247z00_14551 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14550, (int) (((long) 0))));
				BgL_bodyz00_14552 = PROCEDURE_REF(BgL_envz00_14550, (int) (((long) 1)));
				BgL_siza7ezd2framez75_14553 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14550, (int) (((long) 2))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_16896;

					BgL_bpz00_16896 = VECTOR_REF(((obj_t) BgL_sz00_14554), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1174 */

						{	/* Eval/evaluate_comp.scm 1174 */
							obj_t BgL_runz00_16897;

							BgL_runz00_16897 =
								MAKE_FX_PROCEDURE(BGl_z62run5724z62zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 2)));
							PROCEDURE_SET(BgL_runz00_16897,
								(int) (((long) 0)), ((obj_t) BgL_i1247z00_14551));
							PROCEDURE_SET(BgL_runz00_16897,
								(int) (((long) 1)), BgL_bodyz00_14552);
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_mainz00_16898;

								BgL_mainz00_16898 =
									MAKE_VA_PROCEDURE(BGl_z62main5723z62zz__evaluate_compz00,
									(int) (((long) -4)), (int) (((long) 4)));
								PROCEDURE_SET(BgL_mainz00_16898,
									(int) (((long) 0)), ((obj_t) BgL_i1247z00_14551));
								PROCEDURE_SET(BgL_mainz00_16898,
									(int) (((long) 1)), BgL_bodyz00_14552);
								PROCEDURE_SET(BgL_mainz00_16898,
									(int) (((long) 2)), BgL_runz00_16897);
								PROCEDURE_SET(BgL_mainz00_16898,
									(int) (((long) 3)), BINT(BgL_siza7ezd2framez75_14553));
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_objz00_16899;

									BgL_objz00_16899 =
										BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
									PROCEDURE_ATTR_SET(BgL_runz00_16897, BgL_objz00_16899);
									BgL_objz00_16899;
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_arg3777z00_16900;

									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_arg3778z00_16901;

										BgL_arg3778z00_16901 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14551))->
											BgL_wherez00);
										{	/* Eval/evaluate_comp.scm 683 */
											obj_t BgL_newz00_16902;

											BgL_newz00_16902 =
												create_struct(BGl_symbol5824z00zz__evaluate_compz00,
												(int) (((long) 4)));
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_27613;

												BgL_tmpz00_27613 = (int) (((long) 3));
												STRUCT_SET(BgL_newz00_16902, BgL_tmpz00_27613,
													BgL_arg3778z00_16901);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_27618;
												int BgL_tmpz00_27616;

												BgL_auxz00_27618 = BINT(BgL_siza7ezd2framez75_14553);
												BgL_tmpz00_27616 = (int) (((long) 2));
												STRUCT_SET(BgL_newz00_16902, BgL_tmpz00_27616,
													BgL_auxz00_27618);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_27621;

												BgL_tmpz00_27621 = (int) (((long) 1));
												STRUCT_SET(BgL_newz00_16902, BgL_tmpz00_27621,
													BgL_runz00_16897);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_27626;
												int BgL_tmpz00_27624;

												BgL_auxz00_27626 = BINT(((long) -4));
												BgL_tmpz00_27624 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_16902, BgL_tmpz00_27624,
													BgL_auxz00_27626);
											}
											BgL_arg3777z00_16900 = BgL_newz00_16902;
									}}
									PROCEDURE_ATTR_SET(BgL_mainz00_16898, BgL_arg3777z00_16900);
									BgL_arg3777z00_16900;
								}
								return BgL_mainz00_16898;
							}
						}
					}
				}
			}
		}

	}



/* &main5723 */
	obj_t BGl_z62main5723z62zz__evaluate_compz00(obj_t BgL_envz00_14555,
		obj_t BgL_bz00_14560, obj_t BgL_cz00_14561, obj_t BgL_dz00_14562,
		obj_t BgL_lastz00_14563)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_runz00_14558;
				long BgL_siza7ezd2framez75_14559;

				BgL_runz00_14558 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14555, (int) (((long) 2))));
				BgL_siza7ezd2framez75_14559 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14555, (int) (((long) 3))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_sz00_16903;

					BgL_sz00_16903 = BGl_findzd2statezd2zz__evaluate_compz00();
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_bpz00_16904;

						BgL_bpz00_16904 = VECTOR_REF(((obj_t) BgL_sz00_16903), ((long) 0));
						if (
							(((long) CINT(BgL_bpz00_16904) + BgL_siza7ezd2framez75_14559) <
								VECTOR_LENGTH(((obj_t) BgL_sz00_16903))))
							{	/* Eval/evaluate_comp.scm 1174 */
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3781z00_16905;

									BgL_arg3781z00_16905 =
										((long) CINT(BgL_bpz00_16904) + ((long) 0));
									VECTOR_SET(
										((obj_t) BgL_sz00_16903), BgL_arg3781z00_16905,
										BgL_bz00_14560);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3782z00_16906;

									BgL_arg3782z00_16906 =
										((long) CINT(BgL_bpz00_16904) + ((long) 1));
									VECTOR_SET(
										((obj_t) BgL_sz00_16903), BgL_arg3782z00_16906,
										BgL_cz00_14561);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3783z00_16907;

									BgL_arg3783z00_16907 =
										((long) CINT(BgL_bpz00_16904) + ((long) 2));
									VECTOR_SET(
										((obj_t) BgL_sz00_16903), BgL_arg3783z00_16907,
										BgL_dz00_14562);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3784z00_16908;

									BgL_arg3784z00_16908 =
										((long) CINT(BgL_bpz00_16904) + ((long) 3));
									VECTOR_SET(
										((obj_t) BgL_sz00_16903), BgL_arg3784z00_16908,
										BgL_lastz00_14563);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_ez00_16909;

									BgL_ez00_16909 = BGL_EXITD_TOP_AS_OBJ();
									BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_16909,
										BgL_bpz00_16904);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_accz00_16910;

										BgL_accz00_16910 =
											BGl_catchzd2trampolinezd2zz__evaluate_compz00
											(BgL_runz00_14558, BgL_sz00_16903, BgL_bpz00_16904);
										BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_16909);
										VECTOR_SET(
											((obj_t) BgL_sz00_16903), ((long) 0), BgL_bpz00_16904);
										return BgL_accz00_16910;
									}
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_nsz00_16911;

								BgL_nsz00_16911 = BGl_makezd2statezd2zz__evaluate_compz00();
								VECTOR_SET(BgL_nsz00_16911, ((long) 1), BgL_sz00_16903);
								VECTOR_SET(BgL_nsz00_16911, ((long) 2), BgL_bz00_14560);
								VECTOR_SET(BgL_nsz00_16911, ((long) 3), BgL_cz00_14561);
								VECTOR_SET(BgL_nsz00_16911, ((long) 4), BgL_dz00_14562);
								VECTOR_SET(BgL_nsz00_16911, ((long) 5), BgL_lastz00_14563);
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_z12denvz12_16912;

									BgL_z12denvz12_16912 = BGL_CURRENT_DYNAMIC_ENV();
									BGL_ENV_EVSTATE_SET(BgL_z12denvz12_16912, BgL_nsz00_16911);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_ez00_16913;

										BgL_ez00_16913 = BGL_EXITD_TOP_AS_OBJ();
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_16913,
											BgL_sz00_16903);
										{	/* Eval/evaluate_comp.scm 1174 */
											obj_t BgL_____rz00_16914;

											{	/* Eval/evaluate_comp.scm 670 */
												obj_t BgL_savedzd2bpzd2_16915;

												BgL_savedzd2bpzd2_16915 =
													VECTOR_REF(BgL_nsz00_16911, ((long) 0));
												VECTOR_SET(BgL_nsz00_16911, ((long) 0),
													BINT(((long) 2)));
												{
													obj_t BgL_fz00_16917;

													BgL_fz00_16917 = BgL_runz00_14558;
												BgL_recz00_16916:
													{	/* Eval/evaluate_comp.scm 673 */
														obj_t BgL_rz00_16918;

														BgL_rz00_16918 =
															PROCEDURE_ENTRY(BgL_fz00_16917) (BgL_fz00_16917,
															BgL_nsz00_16911, BEOA);
														{	/* Eval/evaluate_comp.scm 674 */
															bool_t BgL_test6614z00_27684;

															if (PROCEDUREP(BgL_rz00_16918))
																{	/* Eval/evaluate_comp.scm 674 */
																	obj_t BgL_arg1702z00_16919;

																	BgL_arg1702z00_16919 =
																		PROCEDURE_ATTR(BgL_rz00_16918);
																	if (STRUCTP(BgL_arg1702z00_16919))
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test6614z00_27684 =
																				(STRUCT_KEY(BgL_arg1702z00_16919) ==
																				BGl_symbol5803z00zz__evaluate_compz00);
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test6614z00_27684 = ((bool_t) 0);
																		}
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	BgL_test6614z00_27684 = ((bool_t) 0);
																}
															if (BgL_test6614z00_27684)
																{
																	obj_t BgL_fz00_27692;

																	BgL_fz00_27692 = BgL_rz00_16918;
																	BgL_fz00_16917 = BgL_fz00_27692;
																	goto BgL_recz00_16916;
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	VECTOR_SET(BgL_nsz00_16911, ((long) 0),
																		BgL_savedzd2bpzd2_16915);
																	BgL_____rz00_16914 = BgL_rz00_16918;
											}}}}}
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_ez00_16913);
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_16912, BgL_sz00_16903);
											return BgL_____rz00_16914;
										}
									}
								}
							}
					}
				}
			}
		}

	}



/* &run5724 */
	obj_t BGl_z62run5724z62zz__evaluate_compz00(obj_t BgL_envz00_14564,
		obj_t BgL_sz00_14567)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				BgL_ev_absz00_bglt BgL_i1247z00_14565;
				obj_t BgL_bodyz00_14566;

				BgL_i1247z00_14565 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14564, (int) (((long) 0))));
				BgL_bodyz00_14566 = PROCEDURE_REF(BgL_envz00_14564, (int) (((long) 1)));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_16920;

					BgL_bpz00_16920 = VECTOR_REF(((obj_t) BgL_sz00_14567), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_z12denvz12_16921;
						obj_t BgL_wherez00_16922;
						obj_t BgL_locz00_16923;

						BgL_z12denvz12_16921 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_wherez00_16922 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14565))->
							BgL_wherez00);
						BgL_locz00_16923 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14565))->BgL_locz00);
						{	/* Eval/evaluate_comp.scm 1174 */

							BGL_ENV_PUSH_TRACE(BgL_z12denvz12_16921, BgL_wherez00_16922,
								BgL_locz00_16923);
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_za2za2resza2za2z00_16924;

								BgL_za2za2resza2za2z00_16924 =
									PROCEDURE_ENTRY(BgL_bodyz00_14566) (BgL_bodyz00_14566,
									BgL_sz00_14567, BEOA);
								BGL_ENV_POP_TRACE(BgL_z12denvz12_16921);
								return BgL_za2za2resza2za2z00_16924;
							}
						}
					}
				}
			}
		}

	}



/* &<@anonymous:3786> */
	obj_t BGl_z62zc3z04anonymousza33786ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_14568, obj_t BgL_sz00_14573)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_iboxesz00_14569;
				BgL_ev_absz00_bglt BgL_i1247z00_14570;
				obj_t BgL_bodyz00_14571;
				long BgL_siza7ezd2framez75_14572;

				BgL_iboxesz00_14569 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14568, (int) (((long) 0))));
				BgL_i1247z00_14570 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14568, (int) (((long) 1))));
				BgL_bodyz00_14571 = PROCEDURE_REF(BgL_envz00_14568, (int) (((long) 2)));
				BgL_siza7ezd2framez75_14572 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14568, (int) (((long) 3))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_16925;

					BgL_bpz00_16925 = VECTOR_REF(((obj_t) BgL_sz00_14573), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1174 */

						{	/* Eval/evaluate_comp.scm 1174 */
							obj_t BgL_runz00_16926;

							BgL_runz00_16926 =
								MAKE_FX_PROCEDURE(BGl_z62run5726z62zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 3)));
							PROCEDURE_SET(BgL_runz00_16926,
								(int) (((long) 0)), BgL_iboxesz00_14569);
							PROCEDURE_SET(BgL_runz00_16926,
								(int) (((long) 1)), ((obj_t) BgL_i1247z00_14570));
							PROCEDURE_SET(BgL_runz00_16926,
								(int) (((long) 2)), BgL_bodyz00_14571);
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_mainz00_16927;

								BgL_mainz00_16927 =
									MAKE_VA_PROCEDURE(BGl_z62main5725z62zz__evaluate_compz00,
									(int) (((long) -4)), (int) (((long) 5)));
								PROCEDURE_SET(BgL_mainz00_16927,
									(int) (((long) 0)), BgL_iboxesz00_14569);
								PROCEDURE_SET(BgL_mainz00_16927,
									(int) (((long) 1)), ((obj_t) BgL_i1247z00_14570));
								PROCEDURE_SET(BgL_mainz00_16927,
									(int) (((long) 2)), BgL_bodyz00_14571);
								PROCEDURE_SET(BgL_mainz00_16927,
									(int) (((long) 3)), BgL_runz00_16926);
								PROCEDURE_SET(BgL_mainz00_16927,
									(int) (((long) 4)), BINT(BgL_siza7ezd2framez75_14572));
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_objz00_16928;

									BgL_objz00_16928 =
										BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
									PROCEDURE_ATTR_SET(BgL_runz00_16926, BgL_objz00_16928);
									BgL_objz00_16928;
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_arg3787z00_16929;

									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_arg3788z00_16930;

										BgL_arg3788z00_16930 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14570))->
											BgL_wherez00);
										{	/* Eval/evaluate_comp.scm 683 */
											obj_t BgL_newz00_16931;

											BgL_newz00_16931 =
												create_struct(BGl_symbol5824z00zz__evaluate_compz00,
												(int) (((long) 4)));
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_27754;

												BgL_tmpz00_27754 = (int) (((long) 3));
												STRUCT_SET(BgL_newz00_16931, BgL_tmpz00_27754,
													BgL_arg3788z00_16930);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_27759;
												int BgL_tmpz00_27757;

												BgL_auxz00_27759 = BINT(BgL_siza7ezd2framez75_14572);
												BgL_tmpz00_27757 = (int) (((long) 2));
												STRUCT_SET(BgL_newz00_16931, BgL_tmpz00_27757,
													BgL_auxz00_27759);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_27762;

												BgL_tmpz00_27762 = (int) (((long) 1));
												STRUCT_SET(BgL_newz00_16931, BgL_tmpz00_27762,
													BgL_runz00_16926);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_27767;
												int BgL_tmpz00_27765;

												BgL_auxz00_27767 = BINT(((long) -4));
												BgL_tmpz00_27765 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_16931, BgL_tmpz00_27765,
													BgL_auxz00_27767);
											}
											BgL_arg3787z00_16929 = BgL_newz00_16931;
									}}
									PROCEDURE_ATTR_SET(BgL_mainz00_16927, BgL_arg3787z00_16929);
									BgL_arg3787z00_16929;
								}
								return BgL_mainz00_16927;
							}
						}
					}
				}
			}
		}

	}



/* &main5725 */
	obj_t BGl_z62main5725z62zz__evaluate_compz00(obj_t BgL_envz00_14574,
		obj_t BgL_bz00_14580, obj_t BgL_cz00_14581, obj_t BgL_dz00_14582,
		obj_t BgL_lastz00_14583)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_runz00_14578;
				long BgL_siza7ezd2framez75_14579;

				BgL_runz00_14578 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14574, (int) (((long) 3))));
				BgL_siza7ezd2framez75_14579 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14574, (int) (((long) 4))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_sz00_16932;

					BgL_sz00_16932 = BGl_findzd2statezd2zz__evaluate_compz00();
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_bpz00_16933;

						BgL_bpz00_16933 = VECTOR_REF(((obj_t) BgL_sz00_16932), ((long) 0));
						if (
							(((long) CINT(BgL_bpz00_16933) + BgL_siza7ezd2framez75_14579) <
								VECTOR_LENGTH(((obj_t) BgL_sz00_16932))))
							{	/* Eval/evaluate_comp.scm 1174 */
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3791z00_16934;

									BgL_arg3791z00_16934 =
										((long) CINT(BgL_bpz00_16933) + ((long) 0));
									VECTOR_SET(
										((obj_t) BgL_sz00_16932), BgL_arg3791z00_16934,
										BgL_bz00_14580);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3792z00_16935;

									BgL_arg3792z00_16935 =
										((long) CINT(BgL_bpz00_16933) + ((long) 1));
									VECTOR_SET(
										((obj_t) BgL_sz00_16932), BgL_arg3792z00_16935,
										BgL_cz00_14581);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3793z00_16936;

									BgL_arg3793z00_16936 =
										((long) CINT(BgL_bpz00_16933) + ((long) 2));
									VECTOR_SET(
										((obj_t) BgL_sz00_16932), BgL_arg3793z00_16936,
										BgL_dz00_14582);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3794z00_16937;

									BgL_arg3794z00_16937 =
										((long) CINT(BgL_bpz00_16933) + ((long) 3));
									VECTOR_SET(
										((obj_t) BgL_sz00_16932), BgL_arg3794z00_16937,
										BgL_lastz00_14583);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_ez00_16938;

									BgL_ez00_16938 = BGL_EXITD_TOP_AS_OBJ();
									BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_16938,
										BgL_bpz00_16933);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_accz00_16939;

										BgL_accz00_16939 =
											BGl_catchzd2trampolinezd2zz__evaluate_compz00
											(BgL_runz00_14578, BgL_sz00_16932, BgL_bpz00_16933);
										BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_16938);
										VECTOR_SET(
											((obj_t) BgL_sz00_16932), ((long) 0), BgL_bpz00_16933);
										return BgL_accz00_16939;
									}
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_nsz00_16940;

								BgL_nsz00_16940 = BGl_makezd2statezd2zz__evaluate_compz00();
								VECTOR_SET(BgL_nsz00_16940, ((long) 1), BgL_sz00_16932);
								VECTOR_SET(BgL_nsz00_16940, ((long) 2), BgL_bz00_14580);
								VECTOR_SET(BgL_nsz00_16940, ((long) 3), BgL_cz00_14581);
								VECTOR_SET(BgL_nsz00_16940, ((long) 4), BgL_dz00_14582);
								VECTOR_SET(BgL_nsz00_16940, ((long) 5), BgL_lastz00_14583);
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_z12denvz12_16941;

									BgL_z12denvz12_16941 = BGL_CURRENT_DYNAMIC_ENV();
									BGL_ENV_EVSTATE_SET(BgL_z12denvz12_16941, BgL_nsz00_16940);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_ez00_16942;

										BgL_ez00_16942 = BGL_EXITD_TOP_AS_OBJ();
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_16942,
											BgL_sz00_16932);
										{	/* Eval/evaluate_comp.scm 1174 */
											obj_t BgL_____rz00_16943;

											{	/* Eval/evaluate_comp.scm 670 */
												obj_t BgL_savedzd2bpzd2_16944;

												BgL_savedzd2bpzd2_16944 =
													VECTOR_REF(BgL_nsz00_16940, ((long) 0));
												VECTOR_SET(BgL_nsz00_16940, ((long) 0),
													BINT(((long) 2)));
												{
													obj_t BgL_fz00_16946;

													BgL_fz00_16946 = BgL_runz00_14578;
												BgL_recz00_16945:
													{	/* Eval/evaluate_comp.scm 673 */
														obj_t BgL_rz00_16947;

														BgL_rz00_16947 =
															PROCEDURE_ENTRY(BgL_fz00_16946) (BgL_fz00_16946,
															BgL_nsz00_16940, BEOA);
														{	/* Eval/evaluate_comp.scm 674 */
															bool_t BgL_test6618z00_27825;

															if (PROCEDUREP(BgL_rz00_16947))
																{	/* Eval/evaluate_comp.scm 674 */
																	obj_t BgL_arg1702z00_16948;

																	BgL_arg1702z00_16948 =
																		PROCEDURE_ATTR(BgL_rz00_16947);
																	if (STRUCTP(BgL_arg1702z00_16948))
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test6618z00_27825 =
																				(STRUCT_KEY(BgL_arg1702z00_16948) ==
																				BGl_symbol5803z00zz__evaluate_compz00);
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test6618z00_27825 = ((bool_t) 0);
																		}
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	BgL_test6618z00_27825 = ((bool_t) 0);
																}
															if (BgL_test6618z00_27825)
																{
																	obj_t BgL_fz00_27833;

																	BgL_fz00_27833 = BgL_rz00_16947;
																	BgL_fz00_16946 = BgL_fz00_27833;
																	goto BgL_recz00_16945;
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	VECTOR_SET(BgL_nsz00_16940, ((long) 0),
																		BgL_savedzd2bpzd2_16944);
																	BgL_____rz00_16943 = BgL_rz00_16947;
											}}}}}
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_ez00_16942);
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_16941, BgL_sz00_16932);
											return BgL_____rz00_16943;
										}
									}
								}
							}
					}
				}
			}
		}

	}



/* &run5726 */
	obj_t BGl_z62run5726z62zz__evaluate_compz00(obj_t BgL_envz00_14584,
		obj_t BgL_sz00_14588)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_iboxesz00_14585;
				BgL_ev_absz00_bglt BgL_i1247z00_14586;
				obj_t BgL_bodyz00_14587;

				BgL_iboxesz00_14585 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14584, (int) (((long) 0))));
				BgL_i1247z00_14586 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14584, (int) (((long) 1))));
				BgL_bodyz00_14587 = PROCEDURE_REF(BgL_envz00_14584, (int) (((long) 2)));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_16949;

					BgL_bpz00_16949 = VECTOR_REF(((obj_t) BgL_sz00_14588), ((long) 0));
					BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_14588,
						BgL_iboxesz00_14585, BgL_bpz00_16949);
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_z12denvz12_16950;
						obj_t BgL_wherez00_16951;
						obj_t BgL_locz00_16952;

						BgL_z12denvz12_16950 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_wherez00_16951 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14586))->
							BgL_wherez00);
						BgL_locz00_16952 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14586))->BgL_locz00);
						{	/* Eval/evaluate_comp.scm 1174 */

							BGL_ENV_PUSH_TRACE(BgL_z12denvz12_16950, BgL_wherez00_16951,
								BgL_locz00_16952);
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_za2za2resza2za2z00_16953;

								BgL_za2za2resza2za2z00_16953 =
									PROCEDURE_ENTRY(BgL_bodyz00_14587) (BgL_bodyz00_14587,
									BgL_sz00_14588, BEOA);
								BGL_ENV_POP_TRACE(BgL_z12denvz12_16950);
								return BgL_za2za2resza2za2z00_16953;
							}
						}
					}
				}
			}
		}

	}



/* &<@anonymous:3799> */
	obj_t BGl_z62zc3z04anonymousza33799ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_14589, obj_t BgL_sz00_14595)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_ifreesz00_14590;
				long BgL_siza7eza7_14591;
				BgL_ev_absz00_bglt BgL_i1247z00_14592;
				obj_t BgL_bodyz00_14593;
				long BgL_siza7ezd2framez75_14594;

				BgL_ifreesz00_14590 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14589, (int) (((long) 0))));
				BgL_siza7eza7_14591 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14589, (int) (((long) 1))));
				BgL_i1247z00_14592 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14589, (int) (((long) 2))));
				BgL_bodyz00_14593 = PROCEDURE_REF(BgL_envz00_14589, (int) (((long) 3)));
				BgL_siza7ezd2framez75_14594 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14589, (int) (((long) 4))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_16954;

					BgL_bpz00_16954 = VECTOR_REF(((obj_t) BgL_sz00_14595), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_valza2za2_16955;

						BgL_valza2za2_16955 =
							BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_14595,
							BgL_bpz00_16954, BgL_ifreesz00_14590);
						{	/* Eval/evaluate_comp.scm 1174 */
							obj_t BgL_runz00_16956;

							BgL_runz00_16956 =
								MAKE_FX_PROCEDURE(BGl_z62run5728z62zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 4)));
							PROCEDURE_SET(BgL_runz00_16956,
								(int) (((long) 0)), BINT(BgL_siza7eza7_14591));
							PROCEDURE_SET(BgL_runz00_16956,
								(int) (((long) 1)), BgL_valza2za2_16955);
							PROCEDURE_SET(BgL_runz00_16956,
								(int) (((long) 2)), ((obj_t) BgL_i1247z00_14592));
							PROCEDURE_SET(BgL_runz00_16956,
								(int) (((long) 3)), BgL_bodyz00_14593);
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_mainz00_16957;

								BgL_mainz00_16957 =
									MAKE_VA_PROCEDURE(BGl_z62main5727z62zz__evaluate_compz00,
									(int) (((long) -4)), (int) (((long) 6)));
								PROCEDURE_SET(BgL_mainz00_16957,
									(int) (((long) 0)), BINT(BgL_siza7eza7_14591));
								PROCEDURE_SET(BgL_mainz00_16957,
									(int) (((long) 1)), BgL_valza2za2_16955);
								PROCEDURE_SET(BgL_mainz00_16957,
									(int) (((long) 2)), ((obj_t) BgL_i1247z00_14592));
								PROCEDURE_SET(BgL_mainz00_16957,
									(int) (((long) 3)), BgL_bodyz00_14593);
								PROCEDURE_SET(BgL_mainz00_16957,
									(int) (((long) 4)), BgL_runz00_16956);
								PROCEDURE_SET(BgL_mainz00_16957,
									(int) (((long) 5)), BINT(BgL_siza7ezd2framez75_14594));
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_objz00_16958;

									BgL_objz00_16958 =
										BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
									PROCEDURE_ATTR_SET(BgL_runz00_16956, BgL_objz00_16958);
									BgL_objz00_16958;
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_arg3800z00_16959;

									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_arg3801z00_16960;

										BgL_arg3801z00_16960 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14592))->
											BgL_wherez00);
										{	/* Eval/evaluate_comp.scm 683 */
											obj_t BgL_newz00_16961;

											BgL_newz00_16961 =
												create_struct(BGl_symbol5824z00zz__evaluate_compz00,
												(int) (((long) 4)));
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_27909;

												BgL_tmpz00_27909 = (int) (((long) 3));
												STRUCT_SET(BgL_newz00_16961, BgL_tmpz00_27909,
													BgL_arg3801z00_16960);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_27914;
												int BgL_tmpz00_27912;

												BgL_auxz00_27914 = BINT(BgL_siza7ezd2framez75_14594);
												BgL_tmpz00_27912 = (int) (((long) 2));
												STRUCT_SET(BgL_newz00_16961, BgL_tmpz00_27912,
													BgL_auxz00_27914);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_27917;

												BgL_tmpz00_27917 = (int) (((long) 1));
												STRUCT_SET(BgL_newz00_16961, BgL_tmpz00_27917,
													BgL_runz00_16956);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_27922;
												int BgL_tmpz00_27920;

												BgL_auxz00_27922 = BINT(((long) -4));
												BgL_tmpz00_27920 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_16961, BgL_tmpz00_27920,
													BgL_auxz00_27922);
											}
											BgL_arg3800z00_16959 = BgL_newz00_16961;
									}}
									PROCEDURE_ATTR_SET(BgL_mainz00_16957, BgL_arg3800z00_16959);
									BgL_arg3800z00_16959;
								}
								return BgL_mainz00_16957;
							}
						}
					}
				}
			}
		}

	}



/* &main5727 */
	obj_t BGl_z62main5727z62zz__evaluate_compz00(obj_t BgL_envz00_14596,
		obj_t BgL_bz00_14603, obj_t BgL_cz00_14604, obj_t BgL_dz00_14605,
		obj_t BgL_lastz00_14606)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_runz00_14601;
				long BgL_siza7ezd2framez75_14602;

				BgL_runz00_14601 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14596, (int) (((long) 4))));
				BgL_siza7ezd2framez75_14602 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14596, (int) (((long) 5))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_sz00_16962;

					BgL_sz00_16962 = BGl_findzd2statezd2zz__evaluate_compz00();
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_bpz00_16963;

						BgL_bpz00_16963 = VECTOR_REF(((obj_t) BgL_sz00_16962), ((long) 0));
						if (
							(((long) CINT(BgL_bpz00_16963) + BgL_siza7ezd2framez75_14602) <
								VECTOR_LENGTH(((obj_t) BgL_sz00_16962))))
							{	/* Eval/evaluate_comp.scm 1174 */
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3804z00_16964;

									BgL_arg3804z00_16964 =
										((long) CINT(BgL_bpz00_16963) + ((long) 0));
									VECTOR_SET(
										((obj_t) BgL_sz00_16962), BgL_arg3804z00_16964,
										BgL_bz00_14603);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3805z00_16965;

									BgL_arg3805z00_16965 =
										((long) CINT(BgL_bpz00_16963) + ((long) 1));
									VECTOR_SET(
										((obj_t) BgL_sz00_16962), BgL_arg3805z00_16965,
										BgL_cz00_14604);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3806z00_16966;

									BgL_arg3806z00_16966 =
										((long) CINT(BgL_bpz00_16963) + ((long) 2));
									VECTOR_SET(
										((obj_t) BgL_sz00_16962), BgL_arg3806z00_16966,
										BgL_dz00_14605);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3807z00_16967;

									BgL_arg3807z00_16967 =
										((long) CINT(BgL_bpz00_16963) + ((long) 3));
									VECTOR_SET(
										((obj_t) BgL_sz00_16962), BgL_arg3807z00_16967,
										BgL_lastz00_14606);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_ez00_16968;

									BgL_ez00_16968 = BGL_EXITD_TOP_AS_OBJ();
									BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_16968,
										BgL_bpz00_16963);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_accz00_16969;

										BgL_accz00_16969 =
											BGl_catchzd2trampolinezd2zz__evaluate_compz00
											(BgL_runz00_14601, BgL_sz00_16962, BgL_bpz00_16963);
										BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_16968);
										VECTOR_SET(
											((obj_t) BgL_sz00_16962), ((long) 0), BgL_bpz00_16963);
										return BgL_accz00_16969;
									}
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_nsz00_16970;

								BgL_nsz00_16970 = BGl_makezd2statezd2zz__evaluate_compz00();
								VECTOR_SET(BgL_nsz00_16970, ((long) 1), BgL_sz00_16962);
								VECTOR_SET(BgL_nsz00_16970, ((long) 2), BgL_bz00_14603);
								VECTOR_SET(BgL_nsz00_16970, ((long) 3), BgL_cz00_14604);
								VECTOR_SET(BgL_nsz00_16970, ((long) 4), BgL_dz00_14605);
								VECTOR_SET(BgL_nsz00_16970, ((long) 5), BgL_lastz00_14606);
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_z12denvz12_16971;

									BgL_z12denvz12_16971 = BGL_CURRENT_DYNAMIC_ENV();
									BGL_ENV_EVSTATE_SET(BgL_z12denvz12_16971, BgL_nsz00_16970);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_ez00_16972;

										BgL_ez00_16972 = BGL_EXITD_TOP_AS_OBJ();
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_16972,
											BgL_sz00_16962);
										{	/* Eval/evaluate_comp.scm 1174 */
											obj_t BgL_____rz00_16973;

											{	/* Eval/evaluate_comp.scm 670 */
												obj_t BgL_savedzd2bpzd2_16974;

												BgL_savedzd2bpzd2_16974 =
													VECTOR_REF(BgL_nsz00_16970, ((long) 0));
												VECTOR_SET(BgL_nsz00_16970, ((long) 0),
													BINT(((long) 2)));
												{
													obj_t BgL_fz00_16976;

													BgL_fz00_16976 = BgL_runz00_14601;
												BgL_recz00_16975:
													{	/* Eval/evaluate_comp.scm 673 */
														obj_t BgL_rz00_16977;

														BgL_rz00_16977 =
															PROCEDURE_ENTRY(BgL_fz00_16976) (BgL_fz00_16976,
															BgL_nsz00_16970, BEOA);
														{	/* Eval/evaluate_comp.scm 674 */
															bool_t BgL_test6622z00_27980;

															if (PROCEDUREP(BgL_rz00_16977))
																{	/* Eval/evaluate_comp.scm 674 */
																	obj_t BgL_arg1702z00_16978;

																	BgL_arg1702z00_16978 =
																		PROCEDURE_ATTR(BgL_rz00_16977);
																	if (STRUCTP(BgL_arg1702z00_16978))
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test6622z00_27980 =
																				(STRUCT_KEY(BgL_arg1702z00_16978) ==
																				BGl_symbol5803z00zz__evaluate_compz00);
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test6622z00_27980 = ((bool_t) 0);
																		}
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	BgL_test6622z00_27980 = ((bool_t) 0);
																}
															if (BgL_test6622z00_27980)
																{
																	obj_t BgL_fz00_27988;

																	BgL_fz00_27988 = BgL_rz00_16977;
																	BgL_fz00_16976 = BgL_fz00_27988;
																	goto BgL_recz00_16975;
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	VECTOR_SET(BgL_nsz00_16970, ((long) 0),
																		BgL_savedzd2bpzd2_16974);
																	BgL_____rz00_16973 = BgL_rz00_16977;
											}}}}}
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_ez00_16972);
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_16971, BgL_sz00_16962);
											return BgL_____rz00_16973;
										}
									}
								}
							}
					}
				}
			}
		}

	}



/* &run5728 */
	obj_t BGl_z62run5728z62zz__evaluate_compz00(obj_t BgL_envz00_14607,
		obj_t BgL_sz00_14612)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				long BgL_siza7eza7_14608;
				obj_t BgL_valza2za2_14609;
				BgL_ev_absz00_bglt BgL_i1247z00_14610;
				obj_t BgL_bodyz00_14611;

				BgL_siza7eza7_14608 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14607, (int) (((long) 0))));
				BgL_valza2za2_14609 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14607, (int) (((long) 1))));
				BgL_i1247z00_14610 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14607, (int) (((long) 2))));
				BgL_bodyz00_14611 = PROCEDURE_REF(BgL_envz00_14607, (int) (((long) 3)));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_16979;

					BgL_bpz00_16979 = VECTOR_REF(((obj_t) BgL_sz00_14612), ((long) 0));
					BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_14612,
						BgL_valza2za2_14609,
						((long) CINT(BgL_bpz00_16979) + BgL_siza7eza7_14608));
					{	/* Eval/evaluate_comp.scm 1095 */
						obj_t BgL_z12denvz12_16980;
						obj_t BgL_wherez00_16981;
						obj_t BgL_locz00_16982;

						BgL_z12denvz12_16980 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_wherez00_16981 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14610))->
							BgL_wherez00);
						BgL_locz00_16982 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14610))->BgL_locz00);
						{	/* Eval/evaluate_comp.scm 1095 */

							BGL_ENV_PUSH_TRACE(BgL_z12denvz12_16980, BgL_wherez00_16981,
								BgL_locz00_16982);
							{	/* Eval/evaluate_comp.scm 1095 */
								obj_t BgL_za2za2resza2za2z00_16983;

								BgL_za2za2resza2za2z00_16983 =
									PROCEDURE_ENTRY(BgL_bodyz00_14611) (BgL_bodyz00_14611,
									BgL_sz00_14612, BEOA);
								BGL_ENV_POP_TRACE(BgL_z12denvz12_16980);
								return BgL_za2za2resza2za2z00_16983;
							}
						}
					}
				}
			}
		}

	}



/* &<@anonymous:3810> */
	obj_t BGl_z62zc3z04anonymousza33810ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_14613, obj_t BgL_sz00_14620)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_ifreesz00_14614;
				obj_t BgL_iboxesz00_14615;
				long BgL_siza7eza7_14616;
				BgL_ev_absz00_bglt BgL_i1247z00_14617;
				obj_t BgL_bodyz00_14618;
				long BgL_siza7ezd2framez75_14619;

				BgL_ifreesz00_14614 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14613, (int) (((long) 0))));
				BgL_iboxesz00_14615 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14613, (int) (((long) 1))));
				BgL_siza7eza7_14616 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14613, (int) (((long) 2))));
				BgL_i1247z00_14617 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14613, (int) (((long) 3))));
				BgL_bodyz00_14618 = PROCEDURE_REF(BgL_envz00_14613, (int) (((long) 4)));
				BgL_siza7ezd2framez75_14619 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14613, (int) (((long) 5))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_16984;

					BgL_bpz00_16984 = VECTOR_REF(((obj_t) BgL_sz00_14620), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_valza2za2_16985;

						BgL_valza2za2_16985 =
							BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_14620,
							BgL_bpz00_16984, BgL_ifreesz00_14614);
						{	/* Eval/evaluate_comp.scm 1174 */
							obj_t BgL_runz00_16986;

							BgL_runz00_16986 =
								MAKE_FX_PROCEDURE(BGl_z62run5730z62zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 5)));
							PROCEDURE_SET(BgL_runz00_16986,
								(int) (((long) 0)), BgL_iboxesz00_14615);
							PROCEDURE_SET(BgL_runz00_16986,
								(int) (((long) 1)), BINT(BgL_siza7eza7_14616));
							PROCEDURE_SET(BgL_runz00_16986,
								(int) (((long) 2)), BgL_valza2za2_16985);
							PROCEDURE_SET(BgL_runz00_16986,
								(int) (((long) 3)), ((obj_t) BgL_i1247z00_14617));
							PROCEDURE_SET(BgL_runz00_16986,
								(int) (((long) 4)), BgL_bodyz00_14618);
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_mainz00_16987;

								BgL_mainz00_16987 =
									MAKE_VA_PROCEDURE(BGl_z62main5729z62zz__evaluate_compz00,
									(int) (((long) -4)), (int) (((long) 7)));
								PROCEDURE_SET(BgL_mainz00_16987,
									(int) (((long) 0)), BgL_iboxesz00_14615);
								PROCEDURE_SET(BgL_mainz00_16987,
									(int) (((long) 1)), BINT(BgL_siza7eza7_14616));
								PROCEDURE_SET(BgL_mainz00_16987,
									(int) (((long) 2)), BgL_valza2za2_16985);
								PROCEDURE_SET(BgL_mainz00_16987,
									(int) (((long) 3)), ((obj_t) BgL_i1247z00_14617));
								PROCEDURE_SET(BgL_mainz00_16987,
									(int) (((long) 4)), BgL_bodyz00_14618);
								PROCEDURE_SET(BgL_mainz00_16987,
									(int) (((long) 5)), BgL_runz00_16986);
								PROCEDURE_SET(BgL_mainz00_16987,
									(int) (((long) 6)), BINT(BgL_siza7ezd2framez75_14619));
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_objz00_16988;

									BgL_objz00_16988 =
										BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
									PROCEDURE_ATTR_SET(BgL_runz00_16986, BgL_objz00_16988);
									BgL_objz00_16988;
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_arg3811z00_16989;

									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_arg3812z00_16990;

										BgL_arg3812z00_16990 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14617))->
											BgL_wherez00);
										{	/* Eval/evaluate_comp.scm 683 */
											obj_t BgL_newz00_16991;

											BgL_newz00_16991 =
												create_struct(BGl_symbol5824z00zz__evaluate_compz00,
												(int) (((long) 4)));
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_28076;

												BgL_tmpz00_28076 = (int) (((long) 3));
												STRUCT_SET(BgL_newz00_16991, BgL_tmpz00_28076,
													BgL_arg3812z00_16990);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_28081;
												int BgL_tmpz00_28079;

												BgL_auxz00_28081 = BINT(BgL_siza7ezd2framez75_14619);
												BgL_tmpz00_28079 = (int) (((long) 2));
												STRUCT_SET(BgL_newz00_16991, BgL_tmpz00_28079,
													BgL_auxz00_28081);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_28084;

												BgL_tmpz00_28084 = (int) (((long) 1));
												STRUCT_SET(BgL_newz00_16991, BgL_tmpz00_28084,
													BgL_runz00_16986);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_28089;
												int BgL_tmpz00_28087;

												BgL_auxz00_28089 = BINT(((long) -4));
												BgL_tmpz00_28087 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_16991, BgL_tmpz00_28087,
													BgL_auxz00_28089);
											}
											BgL_arg3811z00_16989 = BgL_newz00_16991;
									}}
									PROCEDURE_ATTR_SET(BgL_mainz00_16987, BgL_arg3811z00_16989);
									BgL_arg3811z00_16989;
								}
								return BgL_mainz00_16987;
							}
						}
					}
				}
			}
		}

	}



/* &main5729 */
	obj_t BGl_z62main5729z62zz__evaluate_compz00(obj_t BgL_envz00_14621,
		obj_t BgL_bz00_14629, obj_t BgL_cz00_14630, obj_t BgL_dz00_14631,
		obj_t BgL_lastz00_14632)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_runz00_14627;
				long BgL_siza7ezd2framez75_14628;

				BgL_runz00_14627 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14621, (int) (((long) 5))));
				BgL_siza7ezd2framez75_14628 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14621, (int) (((long) 6))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_sz00_16992;

					BgL_sz00_16992 = BGl_findzd2statezd2zz__evaluate_compz00();
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_bpz00_16993;

						BgL_bpz00_16993 = VECTOR_REF(((obj_t) BgL_sz00_16992), ((long) 0));
						if (
							(((long) CINT(BgL_bpz00_16993) + BgL_siza7ezd2framez75_14628) <
								VECTOR_LENGTH(((obj_t) BgL_sz00_16992))))
							{	/* Eval/evaluate_comp.scm 1174 */
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3815z00_16994;

									BgL_arg3815z00_16994 =
										((long) CINT(BgL_bpz00_16993) + ((long) 0));
									VECTOR_SET(
										((obj_t) BgL_sz00_16992), BgL_arg3815z00_16994,
										BgL_bz00_14629);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3816z00_16995;

									BgL_arg3816z00_16995 =
										((long) CINT(BgL_bpz00_16993) + ((long) 1));
									VECTOR_SET(
										((obj_t) BgL_sz00_16992), BgL_arg3816z00_16995,
										BgL_cz00_14630);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3817z00_16996;

									BgL_arg3817z00_16996 =
										((long) CINT(BgL_bpz00_16993) + ((long) 2));
									VECTOR_SET(
										((obj_t) BgL_sz00_16992), BgL_arg3817z00_16996,
										BgL_dz00_14631);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3818z00_16997;

									BgL_arg3818z00_16997 =
										((long) CINT(BgL_bpz00_16993) + ((long) 3));
									VECTOR_SET(
										((obj_t) BgL_sz00_16992), BgL_arg3818z00_16997,
										BgL_lastz00_14632);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_ez00_16998;

									BgL_ez00_16998 = BGL_EXITD_TOP_AS_OBJ();
									BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_16998,
										BgL_bpz00_16993);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_accz00_16999;

										BgL_accz00_16999 =
											BGl_catchzd2trampolinezd2zz__evaluate_compz00
											(BgL_runz00_14627, BgL_sz00_16992, BgL_bpz00_16993);
										BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_16998);
										VECTOR_SET(
											((obj_t) BgL_sz00_16992), ((long) 0), BgL_bpz00_16993);
										return BgL_accz00_16999;
									}
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_nsz00_17000;

								BgL_nsz00_17000 = BGl_makezd2statezd2zz__evaluate_compz00();
								VECTOR_SET(BgL_nsz00_17000, ((long) 1), BgL_sz00_16992);
								VECTOR_SET(BgL_nsz00_17000, ((long) 2), BgL_bz00_14629);
								VECTOR_SET(BgL_nsz00_17000, ((long) 3), BgL_cz00_14630);
								VECTOR_SET(BgL_nsz00_17000, ((long) 4), BgL_dz00_14631);
								VECTOR_SET(BgL_nsz00_17000, ((long) 5), BgL_lastz00_14632);
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_z12denvz12_17001;

									BgL_z12denvz12_17001 = BGL_CURRENT_DYNAMIC_ENV();
									BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17001, BgL_nsz00_17000);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_ez00_17002;

										BgL_ez00_17002 = BGL_EXITD_TOP_AS_OBJ();
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17002,
											BgL_sz00_16992);
										{	/* Eval/evaluate_comp.scm 1174 */
											obj_t BgL_____rz00_17003;

											{	/* Eval/evaluate_comp.scm 670 */
												obj_t BgL_savedzd2bpzd2_17004;

												BgL_savedzd2bpzd2_17004 =
													VECTOR_REF(BgL_nsz00_17000, ((long) 0));
												VECTOR_SET(BgL_nsz00_17000, ((long) 0),
													BINT(((long) 2)));
												{
													obj_t BgL_fz00_17006;

													BgL_fz00_17006 = BgL_runz00_14627;
												BgL_recz00_17005:
													{	/* Eval/evaluate_comp.scm 673 */
														obj_t BgL_rz00_17007;

														BgL_rz00_17007 =
															PROCEDURE_ENTRY(BgL_fz00_17006) (BgL_fz00_17006,
															BgL_nsz00_17000, BEOA);
														{	/* Eval/evaluate_comp.scm 674 */
															bool_t BgL_test6626z00_28147;

															if (PROCEDUREP(BgL_rz00_17007))
																{	/* Eval/evaluate_comp.scm 674 */
																	obj_t BgL_arg1702z00_17008;

																	BgL_arg1702z00_17008 =
																		PROCEDURE_ATTR(BgL_rz00_17007);
																	if (STRUCTP(BgL_arg1702z00_17008))
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test6626z00_28147 =
																				(STRUCT_KEY(BgL_arg1702z00_17008) ==
																				BGl_symbol5803z00zz__evaluate_compz00);
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test6626z00_28147 = ((bool_t) 0);
																		}
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	BgL_test6626z00_28147 = ((bool_t) 0);
																}
															if (BgL_test6626z00_28147)
																{
																	obj_t BgL_fz00_28155;

																	BgL_fz00_28155 = BgL_rz00_17007;
																	BgL_fz00_17006 = BgL_fz00_28155;
																	goto BgL_recz00_17005;
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	VECTOR_SET(BgL_nsz00_17000, ((long) 0),
																		BgL_savedzd2bpzd2_17004);
																	BgL_____rz00_17003 = BgL_rz00_17007;
											}}}}}
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_ez00_17002);
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17001, BgL_sz00_16992);
											return BgL_____rz00_17003;
										}
									}
								}
							}
					}
				}
			}
		}

	}



/* &run5730 */
	obj_t BGl_z62run5730z62zz__evaluate_compz00(obj_t BgL_envz00_14633,
		obj_t BgL_sz00_14639)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_iboxesz00_14634;
				long BgL_siza7eza7_14635;
				obj_t BgL_valza2za2_14636;
				BgL_ev_absz00_bglt BgL_i1247z00_14637;
				obj_t BgL_bodyz00_14638;

				BgL_iboxesz00_14634 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14633, (int) (((long) 0))));
				BgL_siza7eza7_14635 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14633, (int) (((long) 1))));
				BgL_valza2za2_14636 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14633, (int) (((long) 2))));
				BgL_i1247z00_14637 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14633, (int) (((long) 3))));
				BgL_bodyz00_14638 = PROCEDURE_REF(BgL_envz00_14633, (int) (((long) 4)));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_17009;

					BgL_bpz00_17009 = VECTOR_REF(((obj_t) BgL_sz00_14639), ((long) 0));
					BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_14639,
						BgL_iboxesz00_14634, BgL_bpz00_17009);
					BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_14639,
						BgL_valza2za2_14636,
						((long) CINT(BgL_bpz00_17009) + BgL_siza7eza7_14635));
					{	/* Eval/evaluate_comp.scm 1095 */
						obj_t BgL_z12denvz12_17010;
						obj_t BgL_wherez00_17011;
						obj_t BgL_locz00_17012;

						BgL_z12denvz12_17010 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_wherez00_17011 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14637))->
							BgL_wherez00);
						BgL_locz00_17012 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14637))->BgL_locz00);
						{	/* Eval/evaluate_comp.scm 1095 */

							BGL_ENV_PUSH_TRACE(BgL_z12denvz12_17010, BgL_wherez00_17011,
								BgL_locz00_17012);
							{	/* Eval/evaluate_comp.scm 1095 */
								obj_t BgL_za2za2resza2za2z00_17013;

								BgL_za2za2resza2za2z00_17013 =
									PROCEDURE_ENTRY(BgL_bodyz00_14638) (BgL_bodyz00_14638,
									BgL_sz00_14639, BEOA);
								BGL_ENV_POP_TRACE(BgL_z12denvz12_17010);
								return BgL_za2za2resza2za2z00_17013;
							}
						}
					}
				}
			}
		}

	}



/* &<@anonymous:3729> */
	obj_t BGl_z62zc3z04anonymousza33729ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_14640, obj_t BgL_sz00_14644)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				BgL_ev_absz00_bglt BgL_i1247z00_14641;
				obj_t BgL_bodyz00_14642;
				long BgL_siza7ezd2framez75_14643;

				BgL_i1247z00_14641 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14640, (int) (((long) 0))));
				BgL_bodyz00_14642 = PROCEDURE_REF(BgL_envz00_14640, (int) (((long) 1)));
				BgL_siza7ezd2framez75_14643 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14640, (int) (((long) 2))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_17014;

					BgL_bpz00_17014 = VECTOR_REF(((obj_t) BgL_sz00_14644), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1174 */

						{	/* Eval/evaluate_comp.scm 1174 */
							obj_t BgL_runz00_17015;

							BgL_runz00_17015 =
								MAKE_FX_PROCEDURE(BGl_z62run5732z62zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 2)));
							PROCEDURE_SET(BgL_runz00_17015,
								(int) (((long) 0)), ((obj_t) BgL_i1247z00_14641));
							PROCEDURE_SET(BgL_runz00_17015,
								(int) (((long) 1)), BgL_bodyz00_14642);
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_mainz00_17016;

								BgL_mainz00_17016 =
									MAKE_FX_PROCEDURE(BGl_z62main5731z62zz__evaluate_compz00,
									(int) (((long) 3)), (int) (((long) 4)));
								PROCEDURE_SET(BgL_mainz00_17016,
									(int) (((long) 0)), ((obj_t) BgL_i1247z00_14641));
								PROCEDURE_SET(BgL_mainz00_17016,
									(int) (((long) 1)), BgL_bodyz00_14642);
								PROCEDURE_SET(BgL_mainz00_17016,
									(int) (((long) 2)), BgL_runz00_17015);
								PROCEDURE_SET(BgL_mainz00_17016,
									(int) (((long) 3)), BINT(BgL_siza7ezd2framez75_14643));
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_objz00_17017;

									BgL_objz00_17017 =
										BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
									PROCEDURE_ATTR_SET(BgL_runz00_17015, BgL_objz00_17017);
									BgL_objz00_17017;
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_arg3730z00_17018;

									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_arg3731z00_17019;

										BgL_arg3731z00_17019 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14641))->
											BgL_wherez00);
										{	/* Eval/evaluate_comp.scm 683 */
											obj_t BgL_newz00_17020;

											BgL_newz00_17020 =
												create_struct(BGl_symbol5824z00zz__evaluate_compz00,
												(int) (((long) 4)));
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_28223;

												BgL_tmpz00_28223 = (int) (((long) 3));
												STRUCT_SET(BgL_newz00_17020, BgL_tmpz00_28223,
													BgL_arg3731z00_17019);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_28228;
												int BgL_tmpz00_28226;

												BgL_auxz00_28228 = BINT(BgL_siza7ezd2framez75_14643);
												BgL_tmpz00_28226 = (int) (((long) 2));
												STRUCT_SET(BgL_newz00_17020, BgL_tmpz00_28226,
													BgL_auxz00_28228);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_28231;

												BgL_tmpz00_28231 = (int) (((long) 1));
												STRUCT_SET(BgL_newz00_17020, BgL_tmpz00_28231,
													BgL_runz00_17015);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_28236;
												int BgL_tmpz00_28234;

												BgL_auxz00_28236 = BINT(((long) 3));
												BgL_tmpz00_28234 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_17020, BgL_tmpz00_28234,
													BgL_auxz00_28236);
											}
											BgL_arg3730z00_17018 = BgL_newz00_17020;
									}}
									PROCEDURE_ATTR_SET(BgL_mainz00_17016, BgL_arg3730z00_17018);
									BgL_arg3730z00_17018;
								}
								return BgL_mainz00_17016;
							}
						}
					}
				}
			}
		}

	}



/* &main5731 */
	obj_t BGl_z62main5731z62zz__evaluate_compz00(obj_t BgL_envz00_14645,
		obj_t BgL_bz00_14650, obj_t BgL_cz00_14651, obj_t BgL_dz00_14652)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_runz00_14648;
				long BgL_siza7ezd2framez75_14649;

				BgL_runz00_14648 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14645, (int) (((long) 2))));
				BgL_siza7ezd2framez75_14649 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14645, (int) (((long) 3))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_sz00_17021;

					BgL_sz00_17021 = BGl_findzd2statezd2zz__evaluate_compz00();
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_bpz00_17022;

						BgL_bpz00_17022 = VECTOR_REF(((obj_t) BgL_sz00_17021), ((long) 0));
						if (
							(((long) CINT(BgL_bpz00_17022) + BgL_siza7ezd2framez75_14649) <
								VECTOR_LENGTH(((obj_t) BgL_sz00_17021))))
							{	/* Eval/evaluate_comp.scm 1174 */
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3734z00_17023;

									BgL_arg3734z00_17023 =
										((long) CINT(BgL_bpz00_17022) + ((long) 0));
									VECTOR_SET(
										((obj_t) BgL_sz00_17021), BgL_arg3734z00_17023,
										BgL_bz00_14650);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3735z00_17024;

									BgL_arg3735z00_17024 =
										((long) CINT(BgL_bpz00_17022) + ((long) 1));
									VECTOR_SET(
										((obj_t) BgL_sz00_17021), BgL_arg3735z00_17024,
										BgL_cz00_14651);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3736z00_17025;

									BgL_arg3736z00_17025 =
										((long) CINT(BgL_bpz00_17022) + ((long) 2));
									VECTOR_SET(
										((obj_t) BgL_sz00_17021), BgL_arg3736z00_17025,
										BgL_dz00_14652);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_ez00_17026;

									BgL_ez00_17026 = BGL_EXITD_TOP_AS_OBJ();
									BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17026,
										BgL_bpz00_17022);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_accz00_17027;

										BgL_accz00_17027 =
											BGl_catchzd2trampolinezd2zz__evaluate_compz00
											(BgL_runz00_14648, BgL_sz00_17021, BgL_bpz00_17022);
										BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_17026);
										VECTOR_SET(
											((obj_t) BgL_sz00_17021), ((long) 0), BgL_bpz00_17022);
										return BgL_accz00_17027;
									}
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_nsz00_17028;

								BgL_nsz00_17028 = BGl_makezd2statezd2zz__evaluate_compz00();
								VECTOR_SET(BgL_nsz00_17028, ((long) 1), BgL_sz00_17021);
								VECTOR_SET(BgL_nsz00_17028, ((long) 2), BgL_bz00_14650);
								VECTOR_SET(BgL_nsz00_17028, ((long) 3), BgL_cz00_14651);
								VECTOR_SET(BgL_nsz00_17028, ((long) 4), BgL_dz00_14652);
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_z12denvz12_17029;

									BgL_z12denvz12_17029 = BGL_CURRENT_DYNAMIC_ENV();
									BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17029, BgL_nsz00_17028);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_ez00_17030;

										BgL_ez00_17030 = BGL_EXITD_TOP_AS_OBJ();
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17030,
											BgL_sz00_17021);
										{	/* Eval/evaluate_comp.scm 1174 */
											obj_t BgL_____rz00_17031;

											{	/* Eval/evaluate_comp.scm 670 */
												obj_t BgL_savedzd2bpzd2_17032;

												BgL_savedzd2bpzd2_17032 =
													VECTOR_REF(BgL_nsz00_17028, ((long) 0));
												VECTOR_SET(BgL_nsz00_17028, ((long) 0),
													BINT(((long) 2)));
												{
													obj_t BgL_fz00_17034;

													BgL_fz00_17034 = BgL_runz00_14648;
												BgL_recz00_17033:
													{	/* Eval/evaluate_comp.scm 673 */
														obj_t BgL_rz00_17035;

														BgL_rz00_17035 =
															PROCEDURE_ENTRY(BgL_fz00_17034) (BgL_fz00_17034,
															BgL_nsz00_17028, BEOA);
														{	/* Eval/evaluate_comp.scm 674 */
															bool_t BgL_test6630z00_28289;

															if (PROCEDUREP(BgL_rz00_17035))
																{	/* Eval/evaluate_comp.scm 674 */
																	obj_t BgL_arg1702z00_17036;

																	BgL_arg1702z00_17036 =
																		PROCEDURE_ATTR(BgL_rz00_17035);
																	if (STRUCTP(BgL_arg1702z00_17036))
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test6630z00_28289 =
																				(STRUCT_KEY(BgL_arg1702z00_17036) ==
																				BGl_symbol5803z00zz__evaluate_compz00);
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test6630z00_28289 = ((bool_t) 0);
																		}
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	BgL_test6630z00_28289 = ((bool_t) 0);
																}
															if (BgL_test6630z00_28289)
																{
																	obj_t BgL_fz00_28297;

																	BgL_fz00_28297 = BgL_rz00_17035;
																	BgL_fz00_17034 = BgL_fz00_28297;
																	goto BgL_recz00_17033;
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	VECTOR_SET(BgL_nsz00_17028, ((long) 0),
																		BgL_savedzd2bpzd2_17032);
																	BgL_____rz00_17031 = BgL_rz00_17035;
											}}}}}
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_ez00_17030);
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17029, BgL_sz00_17021);
											return BgL_____rz00_17031;
										}
									}
								}
							}
					}
				}
			}
		}

	}



/* &run5732 */
	obj_t BGl_z62run5732z62zz__evaluate_compz00(obj_t BgL_envz00_14653,
		obj_t BgL_sz00_14656)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				BgL_ev_absz00_bglt BgL_i1247z00_14654;
				obj_t BgL_bodyz00_14655;

				BgL_i1247z00_14654 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14653, (int) (((long) 0))));
				BgL_bodyz00_14655 = PROCEDURE_REF(BgL_envz00_14653, (int) (((long) 1)));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_17037;

					BgL_bpz00_17037 = VECTOR_REF(((obj_t) BgL_sz00_14656), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_z12denvz12_17038;
						obj_t BgL_wherez00_17039;
						obj_t BgL_locz00_17040;

						BgL_z12denvz12_17038 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_wherez00_17039 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14654))->
							BgL_wherez00);
						BgL_locz00_17040 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14654))->BgL_locz00);
						{	/* Eval/evaluate_comp.scm 1174 */

							BGL_ENV_PUSH_TRACE(BgL_z12denvz12_17038, BgL_wherez00_17039,
								BgL_locz00_17040);
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_za2za2resza2za2z00_17041;

								BgL_za2za2resza2za2z00_17041 =
									PROCEDURE_ENTRY(BgL_bodyz00_14655) (BgL_bodyz00_14655,
									BgL_sz00_14656, BEOA);
								BGL_ENV_POP_TRACE(BgL_z12denvz12_17038);
								return BgL_za2za2resza2za2z00_17041;
							}
						}
					}
				}
			}
		}

	}



/* &<@anonymous:3738> */
	obj_t BGl_z62zc3z04anonymousza33738ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_14657, obj_t BgL_sz00_14662)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_iboxesz00_14658;
				BgL_ev_absz00_bglt BgL_i1247z00_14659;
				obj_t BgL_bodyz00_14660;
				long BgL_siza7ezd2framez75_14661;

				BgL_iboxesz00_14658 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14657, (int) (((long) 0))));
				BgL_i1247z00_14659 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14657, (int) (((long) 1))));
				BgL_bodyz00_14660 = PROCEDURE_REF(BgL_envz00_14657, (int) (((long) 2)));
				BgL_siza7ezd2framez75_14661 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14657, (int) (((long) 3))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_17042;

					BgL_bpz00_17042 = VECTOR_REF(((obj_t) BgL_sz00_14662), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1174 */

						{	/* Eval/evaluate_comp.scm 1174 */
							obj_t BgL_runz00_17043;

							BgL_runz00_17043 =
								MAKE_FX_PROCEDURE(BGl_z62run5734z62zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 3)));
							PROCEDURE_SET(BgL_runz00_17043,
								(int) (((long) 0)), BgL_iboxesz00_14658);
							PROCEDURE_SET(BgL_runz00_17043,
								(int) (((long) 1)), ((obj_t) BgL_i1247z00_14659));
							PROCEDURE_SET(BgL_runz00_17043,
								(int) (((long) 2)), BgL_bodyz00_14660);
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_mainz00_17044;

								BgL_mainz00_17044 =
									MAKE_FX_PROCEDURE(BGl_z62main5733z62zz__evaluate_compz00,
									(int) (((long) 3)), (int) (((long) 5)));
								PROCEDURE_SET(BgL_mainz00_17044,
									(int) (((long) 0)), BgL_iboxesz00_14658);
								PROCEDURE_SET(BgL_mainz00_17044,
									(int) (((long) 1)), ((obj_t) BgL_i1247z00_14659));
								PROCEDURE_SET(BgL_mainz00_17044,
									(int) (((long) 2)), BgL_bodyz00_14660);
								PROCEDURE_SET(BgL_mainz00_17044,
									(int) (((long) 3)), BgL_runz00_17043);
								PROCEDURE_SET(BgL_mainz00_17044,
									(int) (((long) 4)), BINT(BgL_siza7ezd2framez75_14661));
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_objz00_17045;

									BgL_objz00_17045 =
										BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
									PROCEDURE_ATTR_SET(BgL_runz00_17043, BgL_objz00_17045);
									BgL_objz00_17045;
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_arg3739z00_17046;

									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_arg3740z00_17047;

										BgL_arg3740z00_17047 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14659))->
											BgL_wherez00);
										{	/* Eval/evaluate_comp.scm 683 */
											obj_t BgL_newz00_17048;

											BgL_newz00_17048 =
												create_struct(BGl_symbol5824z00zz__evaluate_compz00,
												(int) (((long) 4)));
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_28359;

												BgL_tmpz00_28359 = (int) (((long) 3));
												STRUCT_SET(BgL_newz00_17048, BgL_tmpz00_28359,
													BgL_arg3740z00_17047);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_28364;
												int BgL_tmpz00_28362;

												BgL_auxz00_28364 = BINT(BgL_siza7ezd2framez75_14661);
												BgL_tmpz00_28362 = (int) (((long) 2));
												STRUCT_SET(BgL_newz00_17048, BgL_tmpz00_28362,
													BgL_auxz00_28364);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_28367;

												BgL_tmpz00_28367 = (int) (((long) 1));
												STRUCT_SET(BgL_newz00_17048, BgL_tmpz00_28367,
													BgL_runz00_17043);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_28372;
												int BgL_tmpz00_28370;

												BgL_auxz00_28372 = BINT(((long) 3));
												BgL_tmpz00_28370 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_17048, BgL_tmpz00_28370,
													BgL_auxz00_28372);
											}
											BgL_arg3739z00_17046 = BgL_newz00_17048;
									}}
									PROCEDURE_ATTR_SET(BgL_mainz00_17044, BgL_arg3739z00_17046);
									BgL_arg3739z00_17046;
								}
								return BgL_mainz00_17044;
							}
						}
					}
				}
			}
		}

	}



/* &main5733 */
	obj_t BGl_z62main5733z62zz__evaluate_compz00(obj_t BgL_envz00_14663,
		obj_t BgL_bz00_14669, obj_t BgL_cz00_14670, obj_t BgL_dz00_14671)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_runz00_14667;
				long BgL_siza7ezd2framez75_14668;

				BgL_runz00_14667 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14663, (int) (((long) 3))));
				BgL_siza7ezd2framez75_14668 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14663, (int) (((long) 4))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_sz00_17049;

					BgL_sz00_17049 = BGl_findzd2statezd2zz__evaluate_compz00();
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_bpz00_17050;

						BgL_bpz00_17050 = VECTOR_REF(((obj_t) BgL_sz00_17049), ((long) 0));
						if (
							(((long) CINT(BgL_bpz00_17050) + BgL_siza7ezd2framez75_14668) <
								VECTOR_LENGTH(((obj_t) BgL_sz00_17049))))
							{	/* Eval/evaluate_comp.scm 1174 */
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3743z00_17051;

									BgL_arg3743z00_17051 =
										((long) CINT(BgL_bpz00_17050) + ((long) 0));
									VECTOR_SET(
										((obj_t) BgL_sz00_17049), BgL_arg3743z00_17051,
										BgL_bz00_14669);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3744z00_17052;

									BgL_arg3744z00_17052 =
										((long) CINT(BgL_bpz00_17050) + ((long) 1));
									VECTOR_SET(
										((obj_t) BgL_sz00_17049), BgL_arg3744z00_17052,
										BgL_cz00_14670);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3745z00_17053;

									BgL_arg3745z00_17053 =
										((long) CINT(BgL_bpz00_17050) + ((long) 2));
									VECTOR_SET(
										((obj_t) BgL_sz00_17049), BgL_arg3745z00_17053,
										BgL_dz00_14671);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_ez00_17054;

									BgL_ez00_17054 = BGL_EXITD_TOP_AS_OBJ();
									BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17054,
										BgL_bpz00_17050);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_accz00_17055;

										BgL_accz00_17055 =
											BGl_catchzd2trampolinezd2zz__evaluate_compz00
											(BgL_runz00_14667, BgL_sz00_17049, BgL_bpz00_17050);
										BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_17054);
										VECTOR_SET(
											((obj_t) BgL_sz00_17049), ((long) 0), BgL_bpz00_17050);
										return BgL_accz00_17055;
									}
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_nsz00_17056;

								BgL_nsz00_17056 = BGl_makezd2statezd2zz__evaluate_compz00();
								VECTOR_SET(BgL_nsz00_17056, ((long) 1), BgL_sz00_17049);
								VECTOR_SET(BgL_nsz00_17056, ((long) 2), BgL_bz00_14669);
								VECTOR_SET(BgL_nsz00_17056, ((long) 3), BgL_cz00_14670);
								VECTOR_SET(BgL_nsz00_17056, ((long) 4), BgL_dz00_14671);
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_z12denvz12_17057;

									BgL_z12denvz12_17057 = BGL_CURRENT_DYNAMIC_ENV();
									BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17057, BgL_nsz00_17056);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_ez00_17058;

										BgL_ez00_17058 = BGL_EXITD_TOP_AS_OBJ();
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17058,
											BgL_sz00_17049);
										{	/* Eval/evaluate_comp.scm 1174 */
											obj_t BgL_____rz00_17059;

											{	/* Eval/evaluate_comp.scm 670 */
												obj_t BgL_savedzd2bpzd2_17060;

												BgL_savedzd2bpzd2_17060 =
													VECTOR_REF(BgL_nsz00_17056, ((long) 0));
												VECTOR_SET(BgL_nsz00_17056, ((long) 0),
													BINT(((long) 2)));
												{
													obj_t BgL_fz00_17062;

													BgL_fz00_17062 = BgL_runz00_14667;
												BgL_recz00_17061:
													{	/* Eval/evaluate_comp.scm 673 */
														obj_t BgL_rz00_17063;

														BgL_rz00_17063 =
															PROCEDURE_ENTRY(BgL_fz00_17062) (BgL_fz00_17062,
															BgL_nsz00_17056, BEOA);
														{	/* Eval/evaluate_comp.scm 674 */
															bool_t BgL_test6634z00_28425;

															if (PROCEDUREP(BgL_rz00_17063))
																{	/* Eval/evaluate_comp.scm 674 */
																	obj_t BgL_arg1702z00_17064;

																	BgL_arg1702z00_17064 =
																		PROCEDURE_ATTR(BgL_rz00_17063);
																	if (STRUCTP(BgL_arg1702z00_17064))
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test6634z00_28425 =
																				(STRUCT_KEY(BgL_arg1702z00_17064) ==
																				BGl_symbol5803z00zz__evaluate_compz00);
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test6634z00_28425 = ((bool_t) 0);
																		}
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	BgL_test6634z00_28425 = ((bool_t) 0);
																}
															if (BgL_test6634z00_28425)
																{
																	obj_t BgL_fz00_28433;

																	BgL_fz00_28433 = BgL_rz00_17063;
																	BgL_fz00_17062 = BgL_fz00_28433;
																	goto BgL_recz00_17061;
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	VECTOR_SET(BgL_nsz00_17056, ((long) 0),
																		BgL_savedzd2bpzd2_17060);
																	BgL_____rz00_17059 = BgL_rz00_17063;
											}}}}}
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_ez00_17058);
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17057, BgL_sz00_17049);
											return BgL_____rz00_17059;
										}
									}
								}
							}
					}
				}
			}
		}

	}



/* &run5734 */
	obj_t BGl_z62run5734z62zz__evaluate_compz00(obj_t BgL_envz00_14672,
		obj_t BgL_sz00_14676)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_iboxesz00_14673;
				BgL_ev_absz00_bglt BgL_i1247z00_14674;
				obj_t BgL_bodyz00_14675;

				BgL_iboxesz00_14673 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14672, (int) (((long) 0))));
				BgL_i1247z00_14674 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14672, (int) (((long) 1))));
				BgL_bodyz00_14675 = PROCEDURE_REF(BgL_envz00_14672, (int) (((long) 2)));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_17065;

					BgL_bpz00_17065 = VECTOR_REF(((obj_t) BgL_sz00_14676), ((long) 0));
					BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_14676,
						BgL_iboxesz00_14673, BgL_bpz00_17065);
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_z12denvz12_17066;
						obj_t BgL_wherez00_17067;
						obj_t BgL_locz00_17068;

						BgL_z12denvz12_17066 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_wherez00_17067 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14674))->
							BgL_wherez00);
						BgL_locz00_17068 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14674))->BgL_locz00);
						{	/* Eval/evaluate_comp.scm 1174 */

							BGL_ENV_PUSH_TRACE(BgL_z12denvz12_17066, BgL_wherez00_17067,
								BgL_locz00_17068);
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_za2za2resza2za2z00_17069;

								BgL_za2za2resza2za2z00_17069 =
									PROCEDURE_ENTRY(BgL_bodyz00_14675) (BgL_bodyz00_14675,
									BgL_sz00_14676, BEOA);
								BGL_ENV_POP_TRACE(BgL_z12denvz12_17066);
								return BgL_za2za2resza2za2z00_17069;
							}
						}
					}
				}
			}
		}

	}



/* &<@anonymous:3750> */
	obj_t BGl_z62zc3z04anonymousza33750ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_14677, obj_t BgL_sz00_14683)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_ifreesz00_14678;
				long BgL_siza7eza7_14679;
				BgL_ev_absz00_bglt BgL_i1247z00_14680;
				obj_t BgL_bodyz00_14681;
				long BgL_siza7ezd2framez75_14682;

				BgL_ifreesz00_14678 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14677, (int) (((long) 0))));
				BgL_siza7eza7_14679 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14677, (int) (((long) 1))));
				BgL_i1247z00_14680 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14677, (int) (((long) 2))));
				BgL_bodyz00_14681 = PROCEDURE_REF(BgL_envz00_14677, (int) (((long) 3)));
				BgL_siza7ezd2framez75_14682 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14677, (int) (((long) 4))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_17070;

					BgL_bpz00_17070 = VECTOR_REF(((obj_t) BgL_sz00_14683), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_valza2za2_17071;

						BgL_valza2za2_17071 =
							BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_14683,
							BgL_bpz00_17070, BgL_ifreesz00_14678);
						{	/* Eval/evaluate_comp.scm 1174 */
							obj_t BgL_runz00_17072;

							BgL_runz00_17072 =
								MAKE_FX_PROCEDURE(BGl_z62run5736z62zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 4)));
							PROCEDURE_SET(BgL_runz00_17072,
								(int) (((long) 0)), BINT(BgL_siza7eza7_14679));
							PROCEDURE_SET(BgL_runz00_17072,
								(int) (((long) 1)), BgL_valza2za2_17071);
							PROCEDURE_SET(BgL_runz00_17072,
								(int) (((long) 2)), ((obj_t) BgL_i1247z00_14680));
							PROCEDURE_SET(BgL_runz00_17072,
								(int) (((long) 3)), BgL_bodyz00_14681);
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_mainz00_17073;

								BgL_mainz00_17073 =
									MAKE_FX_PROCEDURE(BGl_z62main5735z62zz__evaluate_compz00,
									(int) (((long) 3)), (int) (((long) 6)));
								PROCEDURE_SET(BgL_mainz00_17073,
									(int) (((long) 0)), BINT(BgL_siza7eza7_14679));
								PROCEDURE_SET(BgL_mainz00_17073,
									(int) (((long) 1)), BgL_valza2za2_17071);
								PROCEDURE_SET(BgL_mainz00_17073,
									(int) (((long) 2)), ((obj_t) BgL_i1247z00_14680));
								PROCEDURE_SET(BgL_mainz00_17073,
									(int) (((long) 3)), BgL_bodyz00_14681);
								PROCEDURE_SET(BgL_mainz00_17073,
									(int) (((long) 4)), BgL_runz00_17072);
								PROCEDURE_SET(BgL_mainz00_17073,
									(int) (((long) 5)), BINT(BgL_siza7ezd2framez75_14682));
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_objz00_17074;

									BgL_objz00_17074 =
										BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
									PROCEDURE_ATTR_SET(BgL_runz00_17072, BgL_objz00_17074);
									BgL_objz00_17074;
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_arg3751z00_17075;

									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_arg3752z00_17076;

										BgL_arg3752z00_17076 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14680))->
											BgL_wherez00);
										{	/* Eval/evaluate_comp.scm 683 */
											obj_t BgL_newz00_17077;

											BgL_newz00_17077 =
												create_struct(BGl_symbol5824z00zz__evaluate_compz00,
												(int) (((long) 4)));
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_28509;

												BgL_tmpz00_28509 = (int) (((long) 3));
												STRUCT_SET(BgL_newz00_17077, BgL_tmpz00_28509,
													BgL_arg3752z00_17076);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_28514;
												int BgL_tmpz00_28512;

												BgL_auxz00_28514 = BINT(BgL_siza7ezd2framez75_14682);
												BgL_tmpz00_28512 = (int) (((long) 2));
												STRUCT_SET(BgL_newz00_17077, BgL_tmpz00_28512,
													BgL_auxz00_28514);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_28517;

												BgL_tmpz00_28517 = (int) (((long) 1));
												STRUCT_SET(BgL_newz00_17077, BgL_tmpz00_28517,
													BgL_runz00_17072);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_28522;
												int BgL_tmpz00_28520;

												BgL_auxz00_28522 = BINT(((long) 3));
												BgL_tmpz00_28520 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_17077, BgL_tmpz00_28520,
													BgL_auxz00_28522);
											}
											BgL_arg3751z00_17075 = BgL_newz00_17077;
									}}
									PROCEDURE_ATTR_SET(BgL_mainz00_17073, BgL_arg3751z00_17075);
									BgL_arg3751z00_17075;
								}
								return BgL_mainz00_17073;
							}
						}
					}
				}
			}
		}

	}



/* &main5735 */
	obj_t BGl_z62main5735z62zz__evaluate_compz00(obj_t BgL_envz00_14684,
		obj_t BgL_bz00_14691, obj_t BgL_cz00_14692, obj_t BgL_dz00_14693)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_runz00_14689;
				long BgL_siza7ezd2framez75_14690;

				BgL_runz00_14689 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14684, (int) (((long) 4))));
				BgL_siza7ezd2framez75_14690 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14684, (int) (((long) 5))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_sz00_17078;

					BgL_sz00_17078 = BGl_findzd2statezd2zz__evaluate_compz00();
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_bpz00_17079;

						BgL_bpz00_17079 = VECTOR_REF(((obj_t) BgL_sz00_17078), ((long) 0));
						if (
							(((long) CINT(BgL_bpz00_17079) + BgL_siza7ezd2framez75_14690) <
								VECTOR_LENGTH(((obj_t) BgL_sz00_17078))))
							{	/* Eval/evaluate_comp.scm 1174 */
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3755z00_17080;

									BgL_arg3755z00_17080 =
										((long) CINT(BgL_bpz00_17079) + ((long) 0));
									VECTOR_SET(
										((obj_t) BgL_sz00_17078), BgL_arg3755z00_17080,
										BgL_bz00_14691);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3756z00_17081;

									BgL_arg3756z00_17081 =
										((long) CINT(BgL_bpz00_17079) + ((long) 1));
									VECTOR_SET(
										((obj_t) BgL_sz00_17078), BgL_arg3756z00_17081,
										BgL_cz00_14692);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3757z00_17082;

									BgL_arg3757z00_17082 =
										((long) CINT(BgL_bpz00_17079) + ((long) 2));
									VECTOR_SET(
										((obj_t) BgL_sz00_17078), BgL_arg3757z00_17082,
										BgL_dz00_14693);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_ez00_17083;

									BgL_ez00_17083 = BGL_EXITD_TOP_AS_OBJ();
									BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17083,
										BgL_bpz00_17079);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_accz00_17084;

										BgL_accz00_17084 =
											BGl_catchzd2trampolinezd2zz__evaluate_compz00
											(BgL_runz00_14689, BgL_sz00_17078, BgL_bpz00_17079);
										BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_17083);
										VECTOR_SET(
											((obj_t) BgL_sz00_17078), ((long) 0), BgL_bpz00_17079);
										return BgL_accz00_17084;
									}
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_nsz00_17085;

								BgL_nsz00_17085 = BGl_makezd2statezd2zz__evaluate_compz00();
								VECTOR_SET(BgL_nsz00_17085, ((long) 1), BgL_sz00_17078);
								VECTOR_SET(BgL_nsz00_17085, ((long) 2), BgL_bz00_14691);
								VECTOR_SET(BgL_nsz00_17085, ((long) 3), BgL_cz00_14692);
								VECTOR_SET(BgL_nsz00_17085, ((long) 4), BgL_dz00_14693);
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_z12denvz12_17086;

									BgL_z12denvz12_17086 = BGL_CURRENT_DYNAMIC_ENV();
									BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17086, BgL_nsz00_17085);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_ez00_17087;

										BgL_ez00_17087 = BGL_EXITD_TOP_AS_OBJ();
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17087,
											BgL_sz00_17078);
										{	/* Eval/evaluate_comp.scm 1174 */
											obj_t BgL_____rz00_17088;

											{	/* Eval/evaluate_comp.scm 670 */
												obj_t BgL_savedzd2bpzd2_17089;

												BgL_savedzd2bpzd2_17089 =
													VECTOR_REF(BgL_nsz00_17085, ((long) 0));
												VECTOR_SET(BgL_nsz00_17085, ((long) 0),
													BINT(((long) 2)));
												{
													obj_t BgL_fz00_17091;

													BgL_fz00_17091 = BgL_runz00_14689;
												BgL_recz00_17090:
													{	/* Eval/evaluate_comp.scm 673 */
														obj_t BgL_rz00_17092;

														BgL_rz00_17092 =
															PROCEDURE_ENTRY(BgL_fz00_17091) (BgL_fz00_17091,
															BgL_nsz00_17085, BEOA);
														{	/* Eval/evaluate_comp.scm 674 */
															bool_t BgL_test6638z00_28575;

															if (PROCEDUREP(BgL_rz00_17092))
																{	/* Eval/evaluate_comp.scm 674 */
																	obj_t BgL_arg1702z00_17093;

																	BgL_arg1702z00_17093 =
																		PROCEDURE_ATTR(BgL_rz00_17092);
																	if (STRUCTP(BgL_arg1702z00_17093))
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test6638z00_28575 =
																				(STRUCT_KEY(BgL_arg1702z00_17093) ==
																				BGl_symbol5803z00zz__evaluate_compz00);
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test6638z00_28575 = ((bool_t) 0);
																		}
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	BgL_test6638z00_28575 = ((bool_t) 0);
																}
															if (BgL_test6638z00_28575)
																{
																	obj_t BgL_fz00_28583;

																	BgL_fz00_28583 = BgL_rz00_17092;
																	BgL_fz00_17091 = BgL_fz00_28583;
																	goto BgL_recz00_17090;
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	VECTOR_SET(BgL_nsz00_17085, ((long) 0),
																		BgL_savedzd2bpzd2_17089);
																	BgL_____rz00_17088 = BgL_rz00_17092;
											}}}}}
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_ez00_17087);
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17086, BgL_sz00_17078);
											return BgL_____rz00_17088;
										}
									}
								}
							}
					}
				}
			}
		}

	}



/* &run5736 */
	obj_t BGl_z62run5736z62zz__evaluate_compz00(obj_t BgL_envz00_14694,
		obj_t BgL_sz00_14699)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				long BgL_siza7eza7_14695;
				obj_t BgL_valza2za2_14696;
				BgL_ev_absz00_bglt BgL_i1247z00_14697;
				obj_t BgL_bodyz00_14698;

				BgL_siza7eza7_14695 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14694, (int) (((long) 0))));
				BgL_valza2za2_14696 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14694, (int) (((long) 1))));
				BgL_i1247z00_14697 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14694, (int) (((long) 2))));
				BgL_bodyz00_14698 = PROCEDURE_REF(BgL_envz00_14694, (int) (((long) 3)));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_17094;

					BgL_bpz00_17094 = VECTOR_REF(((obj_t) BgL_sz00_14699), ((long) 0));
					BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_14699,
						BgL_valza2za2_14696,
						((long) CINT(BgL_bpz00_17094) + BgL_siza7eza7_14695));
					{	/* Eval/evaluate_comp.scm 1095 */
						obj_t BgL_z12denvz12_17095;
						obj_t BgL_wherez00_17096;
						obj_t BgL_locz00_17097;

						BgL_z12denvz12_17095 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_wherez00_17096 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14697))->
							BgL_wherez00);
						BgL_locz00_17097 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14697))->BgL_locz00);
						{	/* Eval/evaluate_comp.scm 1095 */

							BGL_ENV_PUSH_TRACE(BgL_z12denvz12_17095, BgL_wherez00_17096,
								BgL_locz00_17097);
							{	/* Eval/evaluate_comp.scm 1095 */
								obj_t BgL_za2za2resza2za2z00_17098;

								BgL_za2za2resza2za2z00_17098 =
									PROCEDURE_ENTRY(BgL_bodyz00_14698) (BgL_bodyz00_14698,
									BgL_sz00_14699, BEOA);
								BGL_ENV_POP_TRACE(BgL_z12denvz12_17095);
								return BgL_za2za2resza2za2z00_17098;
							}
						}
					}
				}
			}
		}

	}



/* &<@anonymous:3760> */
	obj_t BGl_z62zc3z04anonymousza33760ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_14700, obj_t BgL_sz00_14707)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_ifreesz00_14701;
				obj_t BgL_iboxesz00_14702;
				long BgL_siza7eza7_14703;
				BgL_ev_absz00_bglt BgL_i1247z00_14704;
				obj_t BgL_bodyz00_14705;
				long BgL_siza7ezd2framez75_14706;

				BgL_ifreesz00_14701 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14700, (int) (((long) 0))));
				BgL_iboxesz00_14702 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14700, (int) (((long) 1))));
				BgL_siza7eza7_14703 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14700, (int) (((long) 2))));
				BgL_i1247z00_14704 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14700, (int) (((long) 3))));
				BgL_bodyz00_14705 = PROCEDURE_REF(BgL_envz00_14700, (int) (((long) 4)));
				BgL_siza7ezd2framez75_14706 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14700, (int) (((long) 5))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_17099;

					BgL_bpz00_17099 = VECTOR_REF(((obj_t) BgL_sz00_14707), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_valza2za2_17100;

						BgL_valza2za2_17100 =
							BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_14707,
							BgL_bpz00_17099, BgL_ifreesz00_14701);
						{	/* Eval/evaluate_comp.scm 1174 */
							obj_t BgL_runz00_17101;

							BgL_runz00_17101 =
								MAKE_FX_PROCEDURE(BGl_z62run5738z62zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 5)));
							PROCEDURE_SET(BgL_runz00_17101,
								(int) (((long) 0)), BgL_iboxesz00_14702);
							PROCEDURE_SET(BgL_runz00_17101,
								(int) (((long) 1)), BINT(BgL_siza7eza7_14703));
							PROCEDURE_SET(BgL_runz00_17101,
								(int) (((long) 2)), BgL_valza2za2_17100);
							PROCEDURE_SET(BgL_runz00_17101,
								(int) (((long) 3)), ((obj_t) BgL_i1247z00_14704));
							PROCEDURE_SET(BgL_runz00_17101,
								(int) (((long) 4)), BgL_bodyz00_14705);
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_mainz00_17102;

								BgL_mainz00_17102 =
									MAKE_FX_PROCEDURE(BGl_z62main5737z62zz__evaluate_compz00,
									(int) (((long) 3)), (int) (((long) 7)));
								PROCEDURE_SET(BgL_mainz00_17102,
									(int) (((long) 0)), BgL_iboxesz00_14702);
								PROCEDURE_SET(BgL_mainz00_17102,
									(int) (((long) 1)), BINT(BgL_siza7eza7_14703));
								PROCEDURE_SET(BgL_mainz00_17102,
									(int) (((long) 2)), BgL_valza2za2_17100);
								PROCEDURE_SET(BgL_mainz00_17102,
									(int) (((long) 3)), ((obj_t) BgL_i1247z00_14704));
								PROCEDURE_SET(BgL_mainz00_17102,
									(int) (((long) 4)), BgL_bodyz00_14705);
								PROCEDURE_SET(BgL_mainz00_17102,
									(int) (((long) 5)), BgL_runz00_17101);
								PROCEDURE_SET(BgL_mainz00_17102,
									(int) (((long) 6)), BINT(BgL_siza7ezd2framez75_14706));
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_objz00_17103;

									BgL_objz00_17103 =
										BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
									PROCEDURE_ATTR_SET(BgL_runz00_17101, BgL_objz00_17103);
									BgL_objz00_17103;
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_arg3761z00_17104;

									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_arg3762z00_17105;

										BgL_arg3762z00_17105 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14704))->
											BgL_wherez00);
										{	/* Eval/evaluate_comp.scm 683 */
											obj_t BgL_newz00_17106;

											BgL_newz00_17106 =
												create_struct(BGl_symbol5824z00zz__evaluate_compz00,
												(int) (((long) 4)));
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_28671;

												BgL_tmpz00_28671 = (int) (((long) 3));
												STRUCT_SET(BgL_newz00_17106, BgL_tmpz00_28671,
													BgL_arg3762z00_17105);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_28676;
												int BgL_tmpz00_28674;

												BgL_auxz00_28676 = BINT(BgL_siza7ezd2framez75_14706);
												BgL_tmpz00_28674 = (int) (((long) 2));
												STRUCT_SET(BgL_newz00_17106, BgL_tmpz00_28674,
													BgL_auxz00_28676);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_28679;

												BgL_tmpz00_28679 = (int) (((long) 1));
												STRUCT_SET(BgL_newz00_17106, BgL_tmpz00_28679,
													BgL_runz00_17101);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_28684;
												int BgL_tmpz00_28682;

												BgL_auxz00_28684 = BINT(((long) 3));
												BgL_tmpz00_28682 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_17106, BgL_tmpz00_28682,
													BgL_auxz00_28684);
											}
											BgL_arg3761z00_17104 = BgL_newz00_17106;
									}}
									PROCEDURE_ATTR_SET(BgL_mainz00_17102, BgL_arg3761z00_17104);
									BgL_arg3761z00_17104;
								}
								return BgL_mainz00_17102;
							}
						}
					}
				}
			}
		}

	}



/* &main5737 */
	obj_t BGl_z62main5737z62zz__evaluate_compz00(obj_t BgL_envz00_14708,
		obj_t BgL_bz00_14716, obj_t BgL_cz00_14717, obj_t BgL_dz00_14718)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_runz00_14714;
				long BgL_siza7ezd2framez75_14715;

				BgL_runz00_14714 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14708, (int) (((long) 5))));
				BgL_siza7ezd2framez75_14715 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14708, (int) (((long) 6))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_sz00_17107;

					BgL_sz00_17107 = BGl_findzd2statezd2zz__evaluate_compz00();
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_bpz00_17108;

						BgL_bpz00_17108 = VECTOR_REF(((obj_t) BgL_sz00_17107), ((long) 0));
						if (
							(((long) CINT(BgL_bpz00_17108) + BgL_siza7ezd2framez75_14715) <
								VECTOR_LENGTH(((obj_t) BgL_sz00_17107))))
							{	/* Eval/evaluate_comp.scm 1174 */
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3765z00_17109;

									BgL_arg3765z00_17109 =
										((long) CINT(BgL_bpz00_17108) + ((long) 0));
									VECTOR_SET(
										((obj_t) BgL_sz00_17107), BgL_arg3765z00_17109,
										BgL_bz00_14716);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3766z00_17110;

									BgL_arg3766z00_17110 =
										((long) CINT(BgL_bpz00_17108) + ((long) 1));
									VECTOR_SET(
										((obj_t) BgL_sz00_17107), BgL_arg3766z00_17110,
										BgL_cz00_14717);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3767z00_17111;

									BgL_arg3767z00_17111 =
										((long) CINT(BgL_bpz00_17108) + ((long) 2));
									VECTOR_SET(
										((obj_t) BgL_sz00_17107), BgL_arg3767z00_17111,
										BgL_dz00_14718);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_ez00_17112;

									BgL_ez00_17112 = BGL_EXITD_TOP_AS_OBJ();
									BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17112,
										BgL_bpz00_17108);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_accz00_17113;

										BgL_accz00_17113 =
											BGl_catchzd2trampolinezd2zz__evaluate_compz00
											(BgL_runz00_14714, BgL_sz00_17107, BgL_bpz00_17108);
										BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_17112);
										VECTOR_SET(
											((obj_t) BgL_sz00_17107), ((long) 0), BgL_bpz00_17108);
										return BgL_accz00_17113;
									}
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_nsz00_17114;

								BgL_nsz00_17114 = BGl_makezd2statezd2zz__evaluate_compz00();
								VECTOR_SET(BgL_nsz00_17114, ((long) 1), BgL_sz00_17107);
								VECTOR_SET(BgL_nsz00_17114, ((long) 2), BgL_bz00_14716);
								VECTOR_SET(BgL_nsz00_17114, ((long) 3), BgL_cz00_14717);
								VECTOR_SET(BgL_nsz00_17114, ((long) 4), BgL_dz00_14718);
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_z12denvz12_17115;

									BgL_z12denvz12_17115 = BGL_CURRENT_DYNAMIC_ENV();
									BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17115, BgL_nsz00_17114);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_ez00_17116;

										BgL_ez00_17116 = BGL_EXITD_TOP_AS_OBJ();
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17116,
											BgL_sz00_17107);
										{	/* Eval/evaluate_comp.scm 1174 */
											obj_t BgL_____rz00_17117;

											{	/* Eval/evaluate_comp.scm 670 */
												obj_t BgL_savedzd2bpzd2_17118;

												BgL_savedzd2bpzd2_17118 =
													VECTOR_REF(BgL_nsz00_17114, ((long) 0));
												VECTOR_SET(BgL_nsz00_17114, ((long) 0),
													BINT(((long) 2)));
												{
													obj_t BgL_fz00_17120;

													BgL_fz00_17120 = BgL_runz00_14714;
												BgL_recz00_17119:
													{	/* Eval/evaluate_comp.scm 673 */
														obj_t BgL_rz00_17121;

														BgL_rz00_17121 =
															PROCEDURE_ENTRY(BgL_fz00_17120) (BgL_fz00_17120,
															BgL_nsz00_17114, BEOA);
														{	/* Eval/evaluate_comp.scm 674 */
															bool_t BgL_test6642z00_28737;

															if (PROCEDUREP(BgL_rz00_17121))
																{	/* Eval/evaluate_comp.scm 674 */
																	obj_t BgL_arg1702z00_17122;

																	BgL_arg1702z00_17122 =
																		PROCEDURE_ATTR(BgL_rz00_17121);
																	if (STRUCTP(BgL_arg1702z00_17122))
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test6642z00_28737 =
																				(STRUCT_KEY(BgL_arg1702z00_17122) ==
																				BGl_symbol5803z00zz__evaluate_compz00);
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test6642z00_28737 = ((bool_t) 0);
																		}
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	BgL_test6642z00_28737 = ((bool_t) 0);
																}
															if (BgL_test6642z00_28737)
																{
																	obj_t BgL_fz00_28745;

																	BgL_fz00_28745 = BgL_rz00_17121;
																	BgL_fz00_17120 = BgL_fz00_28745;
																	goto BgL_recz00_17119;
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	VECTOR_SET(BgL_nsz00_17114, ((long) 0),
																		BgL_savedzd2bpzd2_17118);
																	BgL_____rz00_17117 = BgL_rz00_17121;
											}}}}}
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_ez00_17116);
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17115, BgL_sz00_17107);
											return BgL_____rz00_17117;
										}
									}
								}
							}
					}
				}
			}
		}

	}



/* &run5738 */
	obj_t BGl_z62run5738z62zz__evaluate_compz00(obj_t BgL_envz00_14719,
		obj_t BgL_sz00_14725)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_iboxesz00_14720;
				long BgL_siza7eza7_14721;
				obj_t BgL_valza2za2_14722;
				BgL_ev_absz00_bglt BgL_i1247z00_14723;
				obj_t BgL_bodyz00_14724;

				BgL_iboxesz00_14720 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14719, (int) (((long) 0))));
				BgL_siza7eza7_14721 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14719, (int) (((long) 1))));
				BgL_valza2za2_14722 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14719, (int) (((long) 2))));
				BgL_i1247z00_14723 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14719, (int) (((long) 3))));
				BgL_bodyz00_14724 = PROCEDURE_REF(BgL_envz00_14719, (int) (((long) 4)));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_17123;

					BgL_bpz00_17123 = VECTOR_REF(((obj_t) BgL_sz00_14725), ((long) 0));
					BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_14725,
						BgL_iboxesz00_14720, BgL_bpz00_17123);
					BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_14725,
						BgL_valza2za2_14722,
						((long) CINT(BgL_bpz00_17123) + BgL_siza7eza7_14721));
					{	/* Eval/evaluate_comp.scm 1095 */
						obj_t BgL_z12denvz12_17124;
						obj_t BgL_wherez00_17125;
						obj_t BgL_locz00_17126;

						BgL_z12denvz12_17124 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_wherez00_17125 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14723))->
							BgL_wherez00);
						BgL_locz00_17126 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14723))->BgL_locz00);
						{	/* Eval/evaluate_comp.scm 1095 */

							BGL_ENV_PUSH_TRACE(BgL_z12denvz12_17124, BgL_wherez00_17125,
								BgL_locz00_17126);
							{	/* Eval/evaluate_comp.scm 1095 */
								obj_t BgL_za2za2resza2za2z00_17127;

								BgL_za2za2resza2za2z00_17127 =
									PROCEDURE_ENTRY(BgL_bodyz00_14724) (BgL_bodyz00_14724,
									BgL_sz00_14725, BEOA);
								BGL_ENV_POP_TRACE(BgL_z12denvz12_17124);
								return BgL_za2za2resza2za2z00_17127;
							}
						}
					}
				}
			}
		}

	}



/* &<@anonymous:3678> */
	obj_t BGl_z62zc3z04anonymousza33678ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_14726, obj_t BgL_sz00_14730)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				BgL_ev_absz00_bglt BgL_i1247z00_14727;
				obj_t BgL_bodyz00_14728;
				long BgL_siza7ezd2framez75_14729;

				BgL_i1247z00_14727 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14726, (int) (((long) 0))));
				BgL_bodyz00_14728 = PROCEDURE_REF(BgL_envz00_14726, (int) (((long) 1)));
				BgL_siza7ezd2framez75_14729 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14726, (int) (((long) 2))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_17128;

					BgL_bpz00_17128 = VECTOR_REF(((obj_t) BgL_sz00_14730), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1174 */

						{	/* Eval/evaluate_comp.scm 1174 */
							obj_t BgL_runz00_17129;

							BgL_runz00_17129 =
								MAKE_FX_PROCEDURE(BGl_z62run5740z62zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 2)));
							PROCEDURE_SET(BgL_runz00_17129,
								(int) (((long) 0)), ((obj_t) BgL_i1247z00_14727));
							PROCEDURE_SET(BgL_runz00_17129,
								(int) (((long) 1)), BgL_bodyz00_14728);
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_mainz00_17130;

								BgL_mainz00_17130 =
									MAKE_VA_PROCEDURE(BGl_z62main5739z62zz__evaluate_compz00,
									(int) (((long) -3)), (int) (((long) 4)));
								PROCEDURE_SET(BgL_mainz00_17130,
									(int) (((long) 0)), ((obj_t) BgL_i1247z00_14727));
								PROCEDURE_SET(BgL_mainz00_17130,
									(int) (((long) 1)), BgL_bodyz00_14728);
								PROCEDURE_SET(BgL_mainz00_17130,
									(int) (((long) 2)), BgL_runz00_17129);
								PROCEDURE_SET(BgL_mainz00_17130,
									(int) (((long) 3)), BINT(BgL_siza7ezd2framez75_14729));
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_objz00_17131;

									BgL_objz00_17131 =
										BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
									PROCEDURE_ATTR_SET(BgL_runz00_17129, BgL_objz00_17131);
									BgL_objz00_17131;
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_arg3679z00_17132;

									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_arg3680z00_17133;

										BgL_arg3680z00_17133 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14727))->
											BgL_wherez00);
										{	/* Eval/evaluate_comp.scm 683 */
											obj_t BgL_newz00_17134;

											BgL_newz00_17134 =
												create_struct(BGl_symbol5824z00zz__evaluate_compz00,
												(int) (((long) 4)));
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_28813;

												BgL_tmpz00_28813 = (int) (((long) 3));
												STRUCT_SET(BgL_newz00_17134, BgL_tmpz00_28813,
													BgL_arg3680z00_17133);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_28818;
												int BgL_tmpz00_28816;

												BgL_auxz00_28818 = BINT(BgL_siza7ezd2framez75_14729);
												BgL_tmpz00_28816 = (int) (((long) 2));
												STRUCT_SET(BgL_newz00_17134, BgL_tmpz00_28816,
													BgL_auxz00_28818);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_28821;

												BgL_tmpz00_28821 = (int) (((long) 1));
												STRUCT_SET(BgL_newz00_17134, BgL_tmpz00_28821,
													BgL_runz00_17129);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_28826;
												int BgL_tmpz00_28824;

												BgL_auxz00_28826 = BINT(((long) -3));
												BgL_tmpz00_28824 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_17134, BgL_tmpz00_28824,
													BgL_auxz00_28826);
											}
											BgL_arg3679z00_17132 = BgL_newz00_17134;
									}}
									PROCEDURE_ATTR_SET(BgL_mainz00_17130, BgL_arg3679z00_17132);
									BgL_arg3679z00_17132;
								}
								return BgL_mainz00_17130;
							}
						}
					}
				}
			}
		}

	}



/* &main5739 */
	obj_t BGl_z62main5739z62zz__evaluate_compz00(obj_t BgL_envz00_14731,
		obj_t BgL_cz00_14736, obj_t BgL_dz00_14737, obj_t BgL_lastz00_14738)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_runz00_14734;
				long BgL_siza7ezd2framez75_14735;

				BgL_runz00_14734 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14731, (int) (((long) 2))));
				BgL_siza7ezd2framez75_14735 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14731, (int) (((long) 3))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_sz00_17135;

					BgL_sz00_17135 = BGl_findzd2statezd2zz__evaluate_compz00();
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_bpz00_17136;

						BgL_bpz00_17136 = VECTOR_REF(((obj_t) BgL_sz00_17135), ((long) 0));
						if (
							(((long) CINT(BgL_bpz00_17136) + BgL_siza7ezd2framez75_14735) <
								VECTOR_LENGTH(((obj_t) BgL_sz00_17135))))
							{	/* Eval/evaluate_comp.scm 1174 */
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3683z00_17137;

									BgL_arg3683z00_17137 =
										((long) CINT(BgL_bpz00_17136) + ((long) 0));
									VECTOR_SET(
										((obj_t) BgL_sz00_17135), BgL_arg3683z00_17137,
										BgL_cz00_14736);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3685z00_17138;

									BgL_arg3685z00_17138 =
										((long) CINT(BgL_bpz00_17136) + ((long) 1));
									VECTOR_SET(
										((obj_t) BgL_sz00_17135), BgL_arg3685z00_17138,
										BgL_dz00_14737);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3686z00_17139;

									BgL_arg3686z00_17139 =
										((long) CINT(BgL_bpz00_17136) + ((long) 2));
									VECTOR_SET(
										((obj_t) BgL_sz00_17135), BgL_arg3686z00_17139,
										BgL_lastz00_14738);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_ez00_17140;

									BgL_ez00_17140 = BGL_EXITD_TOP_AS_OBJ();
									BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17140,
										BgL_bpz00_17136);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_accz00_17141;

										BgL_accz00_17141 =
											BGl_catchzd2trampolinezd2zz__evaluate_compz00
											(BgL_runz00_14734, BgL_sz00_17135, BgL_bpz00_17136);
										BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_17140);
										VECTOR_SET(
											((obj_t) BgL_sz00_17135), ((long) 0), BgL_bpz00_17136);
										return BgL_accz00_17141;
									}
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_nsz00_17142;

								BgL_nsz00_17142 = BGl_makezd2statezd2zz__evaluate_compz00();
								VECTOR_SET(BgL_nsz00_17142, ((long) 1), BgL_sz00_17135);
								VECTOR_SET(BgL_nsz00_17142, ((long) 2), BgL_cz00_14736);
								VECTOR_SET(BgL_nsz00_17142, ((long) 3), BgL_dz00_14737);
								VECTOR_SET(BgL_nsz00_17142, ((long) 4), BgL_lastz00_14738);
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_z12denvz12_17143;

									BgL_z12denvz12_17143 = BGL_CURRENT_DYNAMIC_ENV();
									BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17143, BgL_nsz00_17142);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_ez00_17144;

										BgL_ez00_17144 = BGL_EXITD_TOP_AS_OBJ();
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17144,
											BgL_sz00_17135);
										{	/* Eval/evaluate_comp.scm 1174 */
											obj_t BgL_____rz00_17145;

											{	/* Eval/evaluate_comp.scm 670 */
												obj_t BgL_savedzd2bpzd2_17146;

												BgL_savedzd2bpzd2_17146 =
													VECTOR_REF(BgL_nsz00_17142, ((long) 0));
												VECTOR_SET(BgL_nsz00_17142, ((long) 0),
													BINT(((long) 2)));
												{
													obj_t BgL_fz00_17148;

													BgL_fz00_17148 = BgL_runz00_14734;
												BgL_recz00_17147:
													{	/* Eval/evaluate_comp.scm 673 */
														obj_t BgL_rz00_17149;

														BgL_rz00_17149 =
															PROCEDURE_ENTRY(BgL_fz00_17148) (BgL_fz00_17148,
															BgL_nsz00_17142, BEOA);
														{	/* Eval/evaluate_comp.scm 674 */
															bool_t BgL_test6646z00_28879;

															if (PROCEDUREP(BgL_rz00_17149))
																{	/* Eval/evaluate_comp.scm 674 */
																	obj_t BgL_arg1702z00_17150;

																	BgL_arg1702z00_17150 =
																		PROCEDURE_ATTR(BgL_rz00_17149);
																	if (STRUCTP(BgL_arg1702z00_17150))
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test6646z00_28879 =
																				(STRUCT_KEY(BgL_arg1702z00_17150) ==
																				BGl_symbol5803z00zz__evaluate_compz00);
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test6646z00_28879 = ((bool_t) 0);
																		}
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	BgL_test6646z00_28879 = ((bool_t) 0);
																}
															if (BgL_test6646z00_28879)
																{
																	obj_t BgL_fz00_28887;

																	BgL_fz00_28887 = BgL_rz00_17149;
																	BgL_fz00_17148 = BgL_fz00_28887;
																	goto BgL_recz00_17147;
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	VECTOR_SET(BgL_nsz00_17142, ((long) 0),
																		BgL_savedzd2bpzd2_17146);
																	BgL_____rz00_17145 = BgL_rz00_17149;
											}}}}}
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_ez00_17144);
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17143, BgL_sz00_17135);
											return BgL_____rz00_17145;
										}
									}
								}
							}
					}
				}
			}
		}

	}



/* &run5740 */
	obj_t BGl_z62run5740z62zz__evaluate_compz00(obj_t BgL_envz00_14739,
		obj_t BgL_sz00_14742)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				BgL_ev_absz00_bglt BgL_i1247z00_14740;
				obj_t BgL_bodyz00_14741;

				BgL_i1247z00_14740 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14739, (int) (((long) 0))));
				BgL_bodyz00_14741 = PROCEDURE_REF(BgL_envz00_14739, (int) (((long) 1)));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_17151;

					BgL_bpz00_17151 = VECTOR_REF(((obj_t) BgL_sz00_14742), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_z12denvz12_17152;
						obj_t BgL_wherez00_17153;
						obj_t BgL_locz00_17154;

						BgL_z12denvz12_17152 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_wherez00_17153 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14740))->
							BgL_wherez00);
						BgL_locz00_17154 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14740))->BgL_locz00);
						{	/* Eval/evaluate_comp.scm 1174 */

							BGL_ENV_PUSH_TRACE(BgL_z12denvz12_17152, BgL_wherez00_17153,
								BgL_locz00_17154);
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_za2za2resza2za2z00_17155;

								BgL_za2za2resza2za2z00_17155 =
									PROCEDURE_ENTRY(BgL_bodyz00_14741) (BgL_bodyz00_14741,
									BgL_sz00_14742, BEOA);
								BGL_ENV_POP_TRACE(BgL_z12denvz12_17152);
								return BgL_za2za2resza2za2z00_17155;
							}
						}
					}
				}
			}
		}

	}



/* &<@anonymous:3688> */
	obj_t BGl_z62zc3z04anonymousza33688ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_14743, obj_t BgL_sz00_14748)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_iboxesz00_14744;
				BgL_ev_absz00_bglt BgL_i1247z00_14745;
				obj_t BgL_bodyz00_14746;
				long BgL_siza7ezd2framez75_14747;

				BgL_iboxesz00_14744 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14743, (int) (((long) 0))));
				BgL_i1247z00_14745 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14743, (int) (((long) 1))));
				BgL_bodyz00_14746 = PROCEDURE_REF(BgL_envz00_14743, (int) (((long) 2)));
				BgL_siza7ezd2framez75_14747 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14743, (int) (((long) 3))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_17156;

					BgL_bpz00_17156 = VECTOR_REF(((obj_t) BgL_sz00_14748), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1174 */

						{	/* Eval/evaluate_comp.scm 1174 */
							obj_t BgL_runz00_17157;

							BgL_runz00_17157 =
								MAKE_FX_PROCEDURE(BGl_z62run5742z62zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 3)));
							PROCEDURE_SET(BgL_runz00_17157,
								(int) (((long) 0)), BgL_iboxesz00_14744);
							PROCEDURE_SET(BgL_runz00_17157,
								(int) (((long) 1)), ((obj_t) BgL_i1247z00_14745));
							PROCEDURE_SET(BgL_runz00_17157,
								(int) (((long) 2)), BgL_bodyz00_14746);
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_mainz00_17158;

								BgL_mainz00_17158 =
									MAKE_VA_PROCEDURE(BGl_z62main5741z62zz__evaluate_compz00,
									(int) (((long) -3)), (int) (((long) 5)));
								PROCEDURE_SET(BgL_mainz00_17158,
									(int) (((long) 0)), BgL_iboxesz00_14744);
								PROCEDURE_SET(BgL_mainz00_17158,
									(int) (((long) 1)), ((obj_t) BgL_i1247z00_14745));
								PROCEDURE_SET(BgL_mainz00_17158,
									(int) (((long) 2)), BgL_bodyz00_14746);
								PROCEDURE_SET(BgL_mainz00_17158,
									(int) (((long) 3)), BgL_runz00_17157);
								PROCEDURE_SET(BgL_mainz00_17158,
									(int) (((long) 4)), BINT(BgL_siza7ezd2framez75_14747));
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_objz00_17159;

									BgL_objz00_17159 =
										BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
									PROCEDURE_ATTR_SET(BgL_runz00_17157, BgL_objz00_17159);
									BgL_objz00_17159;
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_arg3689z00_17160;

									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_arg3690z00_17161;

										BgL_arg3690z00_17161 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14745))->
											BgL_wherez00);
										{	/* Eval/evaluate_comp.scm 683 */
											obj_t BgL_newz00_17162;

											BgL_newz00_17162 =
												create_struct(BGl_symbol5824z00zz__evaluate_compz00,
												(int) (((long) 4)));
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_28949;

												BgL_tmpz00_28949 = (int) (((long) 3));
												STRUCT_SET(BgL_newz00_17162, BgL_tmpz00_28949,
													BgL_arg3690z00_17161);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_28954;
												int BgL_tmpz00_28952;

												BgL_auxz00_28954 = BINT(BgL_siza7ezd2framez75_14747);
												BgL_tmpz00_28952 = (int) (((long) 2));
												STRUCT_SET(BgL_newz00_17162, BgL_tmpz00_28952,
													BgL_auxz00_28954);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_28957;

												BgL_tmpz00_28957 = (int) (((long) 1));
												STRUCT_SET(BgL_newz00_17162, BgL_tmpz00_28957,
													BgL_runz00_17157);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_28962;
												int BgL_tmpz00_28960;

												BgL_auxz00_28962 = BINT(((long) -3));
												BgL_tmpz00_28960 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_17162, BgL_tmpz00_28960,
													BgL_auxz00_28962);
											}
											BgL_arg3689z00_17160 = BgL_newz00_17162;
									}}
									PROCEDURE_ATTR_SET(BgL_mainz00_17158, BgL_arg3689z00_17160);
									BgL_arg3689z00_17160;
								}
								return BgL_mainz00_17158;
							}
						}
					}
				}
			}
		}

	}



/* &main5741 */
	obj_t BGl_z62main5741z62zz__evaluate_compz00(obj_t BgL_envz00_14749,
		obj_t BgL_cz00_14755, obj_t BgL_dz00_14756, obj_t BgL_lastz00_14757)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_runz00_14753;
				long BgL_siza7ezd2framez75_14754;

				BgL_runz00_14753 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14749, (int) (((long) 3))));
				BgL_siza7ezd2framez75_14754 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14749, (int) (((long) 4))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_sz00_17163;

					BgL_sz00_17163 = BGl_findzd2statezd2zz__evaluate_compz00();
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_bpz00_17164;

						BgL_bpz00_17164 = VECTOR_REF(((obj_t) BgL_sz00_17163), ((long) 0));
						if (
							(((long) CINT(BgL_bpz00_17164) + BgL_siza7ezd2framez75_14754) <
								VECTOR_LENGTH(((obj_t) BgL_sz00_17163))))
							{	/* Eval/evaluate_comp.scm 1174 */
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3693z00_17165;

									BgL_arg3693z00_17165 =
										((long) CINT(BgL_bpz00_17164) + ((long) 0));
									VECTOR_SET(
										((obj_t) BgL_sz00_17163), BgL_arg3693z00_17165,
										BgL_cz00_14755);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3694z00_17166;

									BgL_arg3694z00_17166 =
										((long) CINT(BgL_bpz00_17164) + ((long) 1));
									VECTOR_SET(
										((obj_t) BgL_sz00_17163), BgL_arg3694z00_17166,
										BgL_dz00_14756);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3696z00_17167;

									BgL_arg3696z00_17167 =
										((long) CINT(BgL_bpz00_17164) + ((long) 2));
									VECTOR_SET(
										((obj_t) BgL_sz00_17163), BgL_arg3696z00_17167,
										BgL_lastz00_14757);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_ez00_17168;

									BgL_ez00_17168 = BGL_EXITD_TOP_AS_OBJ();
									BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17168,
										BgL_bpz00_17164);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_accz00_17169;

										BgL_accz00_17169 =
											BGl_catchzd2trampolinezd2zz__evaluate_compz00
											(BgL_runz00_14753, BgL_sz00_17163, BgL_bpz00_17164);
										BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_17168);
										VECTOR_SET(
											((obj_t) BgL_sz00_17163), ((long) 0), BgL_bpz00_17164);
										return BgL_accz00_17169;
									}
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_nsz00_17170;

								BgL_nsz00_17170 = BGl_makezd2statezd2zz__evaluate_compz00();
								VECTOR_SET(BgL_nsz00_17170, ((long) 1), BgL_sz00_17163);
								VECTOR_SET(BgL_nsz00_17170, ((long) 2), BgL_cz00_14755);
								VECTOR_SET(BgL_nsz00_17170, ((long) 3), BgL_dz00_14756);
								VECTOR_SET(BgL_nsz00_17170, ((long) 4), BgL_lastz00_14757);
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_z12denvz12_17171;

									BgL_z12denvz12_17171 = BGL_CURRENT_DYNAMIC_ENV();
									BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17171, BgL_nsz00_17170);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_ez00_17172;

										BgL_ez00_17172 = BGL_EXITD_TOP_AS_OBJ();
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17172,
											BgL_sz00_17163);
										{	/* Eval/evaluate_comp.scm 1174 */
											obj_t BgL_____rz00_17173;

											{	/* Eval/evaluate_comp.scm 670 */
												obj_t BgL_savedzd2bpzd2_17174;

												BgL_savedzd2bpzd2_17174 =
													VECTOR_REF(BgL_nsz00_17170, ((long) 0));
												VECTOR_SET(BgL_nsz00_17170, ((long) 0),
													BINT(((long) 2)));
												{
													obj_t BgL_fz00_17176;

													BgL_fz00_17176 = BgL_runz00_14753;
												BgL_recz00_17175:
													{	/* Eval/evaluate_comp.scm 673 */
														obj_t BgL_rz00_17177;

														BgL_rz00_17177 =
															PROCEDURE_ENTRY(BgL_fz00_17176) (BgL_fz00_17176,
															BgL_nsz00_17170, BEOA);
														{	/* Eval/evaluate_comp.scm 674 */
															bool_t BgL_test6650z00_29015;

															if (PROCEDUREP(BgL_rz00_17177))
																{	/* Eval/evaluate_comp.scm 674 */
																	obj_t BgL_arg1702z00_17178;

																	BgL_arg1702z00_17178 =
																		PROCEDURE_ATTR(BgL_rz00_17177);
																	if (STRUCTP(BgL_arg1702z00_17178))
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test6650z00_29015 =
																				(STRUCT_KEY(BgL_arg1702z00_17178) ==
																				BGl_symbol5803z00zz__evaluate_compz00);
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test6650z00_29015 = ((bool_t) 0);
																		}
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	BgL_test6650z00_29015 = ((bool_t) 0);
																}
															if (BgL_test6650z00_29015)
																{
																	obj_t BgL_fz00_29023;

																	BgL_fz00_29023 = BgL_rz00_17177;
																	BgL_fz00_17176 = BgL_fz00_29023;
																	goto BgL_recz00_17175;
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	VECTOR_SET(BgL_nsz00_17170, ((long) 0),
																		BgL_savedzd2bpzd2_17174);
																	BgL_____rz00_17173 = BgL_rz00_17177;
											}}}}}
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_ez00_17172);
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17171, BgL_sz00_17163);
											return BgL_____rz00_17173;
										}
									}
								}
							}
					}
				}
			}
		}

	}



/* &run5742 */
	obj_t BGl_z62run5742z62zz__evaluate_compz00(obj_t BgL_envz00_14758,
		obj_t BgL_sz00_14762)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_iboxesz00_14759;
				BgL_ev_absz00_bglt BgL_i1247z00_14760;
				obj_t BgL_bodyz00_14761;

				BgL_iboxesz00_14759 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14758, (int) (((long) 0))));
				BgL_i1247z00_14760 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14758, (int) (((long) 1))));
				BgL_bodyz00_14761 = PROCEDURE_REF(BgL_envz00_14758, (int) (((long) 2)));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_17179;

					BgL_bpz00_17179 = VECTOR_REF(((obj_t) BgL_sz00_14762), ((long) 0));
					BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_14762,
						BgL_iboxesz00_14759, BgL_bpz00_17179);
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_z12denvz12_17180;
						obj_t BgL_wherez00_17181;
						obj_t BgL_locz00_17182;

						BgL_z12denvz12_17180 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_wherez00_17181 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14760))->
							BgL_wherez00);
						BgL_locz00_17182 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14760))->BgL_locz00);
						{	/* Eval/evaluate_comp.scm 1174 */

							BGL_ENV_PUSH_TRACE(BgL_z12denvz12_17180, BgL_wherez00_17181,
								BgL_locz00_17182);
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_za2za2resza2za2z00_17183;

								BgL_za2za2resza2za2z00_17183 =
									PROCEDURE_ENTRY(BgL_bodyz00_14761) (BgL_bodyz00_14761,
									BgL_sz00_14762, BEOA);
								BGL_ENV_POP_TRACE(BgL_z12denvz12_17180);
								return BgL_za2za2resza2za2z00_17183;
							}
						}
					}
				}
			}
		}

	}



/* &<@anonymous:3702> */
	obj_t BGl_z62zc3z04anonymousza33702ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_14763, obj_t BgL_sz00_14769)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_ifreesz00_14764;
				long BgL_siza7eza7_14765;
				BgL_ev_absz00_bglt BgL_i1247z00_14766;
				obj_t BgL_bodyz00_14767;
				long BgL_siza7ezd2framez75_14768;

				BgL_ifreesz00_14764 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14763, (int) (((long) 0))));
				BgL_siza7eza7_14765 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14763, (int) (((long) 1))));
				BgL_i1247z00_14766 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14763, (int) (((long) 2))));
				BgL_bodyz00_14767 = PROCEDURE_REF(BgL_envz00_14763, (int) (((long) 3)));
				BgL_siza7ezd2framez75_14768 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14763, (int) (((long) 4))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_17184;

					BgL_bpz00_17184 = VECTOR_REF(((obj_t) BgL_sz00_14769), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_valza2za2_17185;

						BgL_valza2za2_17185 =
							BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_14769,
							BgL_bpz00_17184, BgL_ifreesz00_14764);
						{	/* Eval/evaluate_comp.scm 1174 */
							obj_t BgL_runz00_17186;

							BgL_runz00_17186 =
								MAKE_FX_PROCEDURE(BGl_z62run5744z62zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 4)));
							PROCEDURE_SET(BgL_runz00_17186,
								(int) (((long) 0)), BINT(BgL_siza7eza7_14765));
							PROCEDURE_SET(BgL_runz00_17186,
								(int) (((long) 1)), BgL_valza2za2_17185);
							PROCEDURE_SET(BgL_runz00_17186,
								(int) (((long) 2)), ((obj_t) BgL_i1247z00_14766));
							PROCEDURE_SET(BgL_runz00_17186,
								(int) (((long) 3)), BgL_bodyz00_14767);
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_mainz00_17187;

								BgL_mainz00_17187 =
									MAKE_VA_PROCEDURE(BGl_z62main5743z62zz__evaluate_compz00,
									(int) (((long) -3)), (int) (((long) 6)));
								PROCEDURE_SET(BgL_mainz00_17187,
									(int) (((long) 0)), BINT(BgL_siza7eza7_14765));
								PROCEDURE_SET(BgL_mainz00_17187,
									(int) (((long) 1)), BgL_valza2za2_17185);
								PROCEDURE_SET(BgL_mainz00_17187,
									(int) (((long) 2)), ((obj_t) BgL_i1247z00_14766));
								PROCEDURE_SET(BgL_mainz00_17187,
									(int) (((long) 3)), BgL_bodyz00_14767);
								PROCEDURE_SET(BgL_mainz00_17187,
									(int) (((long) 4)), BgL_runz00_17186);
								PROCEDURE_SET(BgL_mainz00_17187,
									(int) (((long) 5)), BINT(BgL_siza7ezd2framez75_14768));
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_objz00_17188;

									BgL_objz00_17188 =
										BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
									PROCEDURE_ATTR_SET(BgL_runz00_17186, BgL_objz00_17188);
									BgL_objz00_17188;
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_arg3703z00_17189;

									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_arg3704z00_17190;

										BgL_arg3704z00_17190 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14766))->
											BgL_wherez00);
										{	/* Eval/evaluate_comp.scm 683 */
											obj_t BgL_newz00_17191;

											BgL_newz00_17191 =
												create_struct(BGl_symbol5824z00zz__evaluate_compz00,
												(int) (((long) 4)));
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_29099;

												BgL_tmpz00_29099 = (int) (((long) 3));
												STRUCT_SET(BgL_newz00_17191, BgL_tmpz00_29099,
													BgL_arg3704z00_17190);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_29104;
												int BgL_tmpz00_29102;

												BgL_auxz00_29104 = BINT(BgL_siza7ezd2framez75_14768);
												BgL_tmpz00_29102 = (int) (((long) 2));
												STRUCT_SET(BgL_newz00_17191, BgL_tmpz00_29102,
													BgL_auxz00_29104);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_29107;

												BgL_tmpz00_29107 = (int) (((long) 1));
												STRUCT_SET(BgL_newz00_17191, BgL_tmpz00_29107,
													BgL_runz00_17186);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_29112;
												int BgL_tmpz00_29110;

												BgL_auxz00_29112 = BINT(((long) -3));
												BgL_tmpz00_29110 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_17191, BgL_tmpz00_29110,
													BgL_auxz00_29112);
											}
											BgL_arg3703z00_17189 = BgL_newz00_17191;
									}}
									PROCEDURE_ATTR_SET(BgL_mainz00_17187, BgL_arg3703z00_17189);
									BgL_arg3703z00_17189;
								}
								return BgL_mainz00_17187;
							}
						}
					}
				}
			}
		}

	}



/* &main5743 */
	obj_t BGl_z62main5743z62zz__evaluate_compz00(obj_t BgL_envz00_14770,
		obj_t BgL_cz00_14777, obj_t BgL_dz00_14778, obj_t BgL_lastz00_14779)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_runz00_14775;
				long BgL_siza7ezd2framez75_14776;

				BgL_runz00_14775 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14770, (int) (((long) 4))));
				BgL_siza7ezd2framez75_14776 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14770, (int) (((long) 5))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_sz00_17192;

					BgL_sz00_17192 = BGl_findzd2statezd2zz__evaluate_compz00();
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_bpz00_17193;

						BgL_bpz00_17193 = VECTOR_REF(((obj_t) BgL_sz00_17192), ((long) 0));
						if (
							(((long) CINT(BgL_bpz00_17193) + BgL_siza7ezd2framez75_14776) <
								VECTOR_LENGTH(((obj_t) BgL_sz00_17192))))
							{	/* Eval/evaluate_comp.scm 1174 */
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3707z00_17194;

									BgL_arg3707z00_17194 =
										((long) CINT(BgL_bpz00_17193) + ((long) 0));
									VECTOR_SET(
										((obj_t) BgL_sz00_17192), BgL_arg3707z00_17194,
										BgL_cz00_14777);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3708z00_17195;

									BgL_arg3708z00_17195 =
										((long) CINT(BgL_bpz00_17193) + ((long) 1));
									VECTOR_SET(
										((obj_t) BgL_sz00_17192), BgL_arg3708z00_17195,
										BgL_dz00_14778);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3709z00_17196;

									BgL_arg3709z00_17196 =
										((long) CINT(BgL_bpz00_17193) + ((long) 2));
									VECTOR_SET(
										((obj_t) BgL_sz00_17192), BgL_arg3709z00_17196,
										BgL_lastz00_14779);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_ez00_17197;

									BgL_ez00_17197 = BGL_EXITD_TOP_AS_OBJ();
									BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17197,
										BgL_bpz00_17193);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_accz00_17198;

										BgL_accz00_17198 =
											BGl_catchzd2trampolinezd2zz__evaluate_compz00
											(BgL_runz00_14775, BgL_sz00_17192, BgL_bpz00_17193);
										BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_17197);
										VECTOR_SET(
											((obj_t) BgL_sz00_17192), ((long) 0), BgL_bpz00_17193);
										return BgL_accz00_17198;
									}
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_nsz00_17199;

								BgL_nsz00_17199 = BGl_makezd2statezd2zz__evaluate_compz00();
								VECTOR_SET(BgL_nsz00_17199, ((long) 1), BgL_sz00_17192);
								VECTOR_SET(BgL_nsz00_17199, ((long) 2), BgL_cz00_14777);
								VECTOR_SET(BgL_nsz00_17199, ((long) 3), BgL_dz00_14778);
								VECTOR_SET(BgL_nsz00_17199, ((long) 4), BgL_lastz00_14779);
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_z12denvz12_17200;

									BgL_z12denvz12_17200 = BGL_CURRENT_DYNAMIC_ENV();
									BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17200, BgL_nsz00_17199);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_ez00_17201;

										BgL_ez00_17201 = BGL_EXITD_TOP_AS_OBJ();
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17201,
											BgL_sz00_17192);
										{	/* Eval/evaluate_comp.scm 1174 */
											obj_t BgL_____rz00_17202;

											{	/* Eval/evaluate_comp.scm 670 */
												obj_t BgL_savedzd2bpzd2_17203;

												BgL_savedzd2bpzd2_17203 =
													VECTOR_REF(BgL_nsz00_17199, ((long) 0));
												VECTOR_SET(BgL_nsz00_17199, ((long) 0),
													BINT(((long) 2)));
												{
													obj_t BgL_fz00_17205;

													BgL_fz00_17205 = BgL_runz00_14775;
												BgL_recz00_17204:
													{	/* Eval/evaluate_comp.scm 673 */
														obj_t BgL_rz00_17206;

														BgL_rz00_17206 =
															PROCEDURE_ENTRY(BgL_fz00_17205) (BgL_fz00_17205,
															BgL_nsz00_17199, BEOA);
														{	/* Eval/evaluate_comp.scm 674 */
															bool_t BgL_test6654z00_29165;

															if (PROCEDUREP(BgL_rz00_17206))
																{	/* Eval/evaluate_comp.scm 674 */
																	obj_t BgL_arg1702z00_17207;

																	BgL_arg1702z00_17207 =
																		PROCEDURE_ATTR(BgL_rz00_17206);
																	if (STRUCTP(BgL_arg1702z00_17207))
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test6654z00_29165 =
																				(STRUCT_KEY(BgL_arg1702z00_17207) ==
																				BGl_symbol5803z00zz__evaluate_compz00);
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test6654z00_29165 = ((bool_t) 0);
																		}
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	BgL_test6654z00_29165 = ((bool_t) 0);
																}
															if (BgL_test6654z00_29165)
																{
																	obj_t BgL_fz00_29173;

																	BgL_fz00_29173 = BgL_rz00_17206;
																	BgL_fz00_17205 = BgL_fz00_29173;
																	goto BgL_recz00_17204;
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	VECTOR_SET(BgL_nsz00_17199, ((long) 0),
																		BgL_savedzd2bpzd2_17203);
																	BgL_____rz00_17202 = BgL_rz00_17206;
											}}}}}
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_ez00_17201);
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17200, BgL_sz00_17192);
											return BgL_____rz00_17202;
										}
									}
								}
							}
					}
				}
			}
		}

	}



/* &run5744 */
	obj_t BGl_z62run5744z62zz__evaluate_compz00(obj_t BgL_envz00_14780,
		obj_t BgL_sz00_14785)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				long BgL_siza7eza7_14781;
				obj_t BgL_valza2za2_14782;
				BgL_ev_absz00_bglt BgL_i1247z00_14783;
				obj_t BgL_bodyz00_14784;

				BgL_siza7eza7_14781 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14780, (int) (((long) 0))));
				BgL_valza2za2_14782 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14780, (int) (((long) 1))));
				BgL_i1247z00_14783 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14780, (int) (((long) 2))));
				BgL_bodyz00_14784 = PROCEDURE_REF(BgL_envz00_14780, (int) (((long) 3)));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_17208;

					BgL_bpz00_17208 = VECTOR_REF(((obj_t) BgL_sz00_14785), ((long) 0));
					BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_14785,
						BgL_valza2za2_14782,
						((long) CINT(BgL_bpz00_17208) + BgL_siza7eza7_14781));
					{	/* Eval/evaluate_comp.scm 1095 */
						obj_t BgL_z12denvz12_17209;
						obj_t BgL_wherez00_17210;
						obj_t BgL_locz00_17211;

						BgL_z12denvz12_17209 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_wherez00_17210 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14783))->
							BgL_wherez00);
						BgL_locz00_17211 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14783))->BgL_locz00);
						{	/* Eval/evaluate_comp.scm 1095 */

							BGL_ENV_PUSH_TRACE(BgL_z12denvz12_17209, BgL_wherez00_17210,
								BgL_locz00_17211);
							{	/* Eval/evaluate_comp.scm 1095 */
								obj_t BgL_za2za2resza2za2z00_17212;

								BgL_za2za2resza2za2z00_17212 =
									PROCEDURE_ENTRY(BgL_bodyz00_14784) (BgL_bodyz00_14784,
									BgL_sz00_14785, BEOA);
								BGL_ENV_POP_TRACE(BgL_z12denvz12_17209);
								return BgL_za2za2resza2za2z00_17212;
							}
						}
					}
				}
			}
		}

	}



/* &<@anonymous:3712> */
	obj_t BGl_z62zc3z04anonymousza33712ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_14786, obj_t BgL_sz00_14793)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_ifreesz00_14787;
				obj_t BgL_iboxesz00_14788;
				long BgL_siza7eza7_14789;
				BgL_ev_absz00_bglt BgL_i1247z00_14790;
				obj_t BgL_bodyz00_14791;
				long BgL_siza7ezd2framez75_14792;

				BgL_ifreesz00_14787 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14786, (int) (((long) 0))));
				BgL_iboxesz00_14788 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14786, (int) (((long) 1))));
				BgL_siza7eza7_14789 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14786, (int) (((long) 2))));
				BgL_i1247z00_14790 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14786, (int) (((long) 3))));
				BgL_bodyz00_14791 = PROCEDURE_REF(BgL_envz00_14786, (int) (((long) 4)));
				BgL_siza7ezd2framez75_14792 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14786, (int) (((long) 5))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_17213;

					BgL_bpz00_17213 = VECTOR_REF(((obj_t) BgL_sz00_14793), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_valza2za2_17214;

						BgL_valza2za2_17214 =
							BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_14793,
							BgL_bpz00_17213, BgL_ifreesz00_14787);
						{	/* Eval/evaluate_comp.scm 1174 */
							obj_t BgL_runz00_17215;

							BgL_runz00_17215 =
								MAKE_FX_PROCEDURE(BGl_z62run5746z62zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 5)));
							PROCEDURE_SET(BgL_runz00_17215,
								(int) (((long) 0)), BgL_iboxesz00_14788);
							PROCEDURE_SET(BgL_runz00_17215,
								(int) (((long) 1)), BINT(BgL_siza7eza7_14789));
							PROCEDURE_SET(BgL_runz00_17215,
								(int) (((long) 2)), BgL_valza2za2_17214);
							PROCEDURE_SET(BgL_runz00_17215,
								(int) (((long) 3)), ((obj_t) BgL_i1247z00_14790));
							PROCEDURE_SET(BgL_runz00_17215,
								(int) (((long) 4)), BgL_bodyz00_14791);
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_mainz00_17216;

								BgL_mainz00_17216 =
									MAKE_VA_PROCEDURE(BGl_z62main5745z62zz__evaluate_compz00,
									(int) (((long) -3)), (int) (((long) 7)));
								PROCEDURE_SET(BgL_mainz00_17216,
									(int) (((long) 0)), BgL_iboxesz00_14788);
								PROCEDURE_SET(BgL_mainz00_17216,
									(int) (((long) 1)), BINT(BgL_siza7eza7_14789));
								PROCEDURE_SET(BgL_mainz00_17216,
									(int) (((long) 2)), BgL_valza2za2_17214);
								PROCEDURE_SET(BgL_mainz00_17216,
									(int) (((long) 3)), ((obj_t) BgL_i1247z00_14790));
								PROCEDURE_SET(BgL_mainz00_17216,
									(int) (((long) 4)), BgL_bodyz00_14791);
								PROCEDURE_SET(BgL_mainz00_17216,
									(int) (((long) 5)), BgL_runz00_17215);
								PROCEDURE_SET(BgL_mainz00_17216,
									(int) (((long) 6)), BINT(BgL_siza7ezd2framez75_14792));
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_objz00_17217;

									BgL_objz00_17217 =
										BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
									PROCEDURE_ATTR_SET(BgL_runz00_17215, BgL_objz00_17217);
									BgL_objz00_17217;
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_arg3713z00_17218;

									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_arg3714z00_17219;

										BgL_arg3714z00_17219 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14790))->
											BgL_wherez00);
										{	/* Eval/evaluate_comp.scm 683 */
											obj_t BgL_newz00_17220;

											BgL_newz00_17220 =
												create_struct(BGl_symbol5824z00zz__evaluate_compz00,
												(int) (((long) 4)));
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_29261;

												BgL_tmpz00_29261 = (int) (((long) 3));
												STRUCT_SET(BgL_newz00_17220, BgL_tmpz00_29261,
													BgL_arg3714z00_17219);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_29266;
												int BgL_tmpz00_29264;

												BgL_auxz00_29266 = BINT(BgL_siza7ezd2framez75_14792);
												BgL_tmpz00_29264 = (int) (((long) 2));
												STRUCT_SET(BgL_newz00_17220, BgL_tmpz00_29264,
													BgL_auxz00_29266);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_29269;

												BgL_tmpz00_29269 = (int) (((long) 1));
												STRUCT_SET(BgL_newz00_17220, BgL_tmpz00_29269,
													BgL_runz00_17215);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_29274;
												int BgL_tmpz00_29272;

												BgL_auxz00_29274 = BINT(((long) -3));
												BgL_tmpz00_29272 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_17220, BgL_tmpz00_29272,
													BgL_auxz00_29274);
											}
											BgL_arg3713z00_17218 = BgL_newz00_17220;
									}}
									PROCEDURE_ATTR_SET(BgL_mainz00_17216, BgL_arg3713z00_17218);
									BgL_arg3713z00_17218;
								}
								return BgL_mainz00_17216;
							}
						}
					}
				}
			}
		}

	}



/* &main5745 */
	obj_t BGl_z62main5745z62zz__evaluate_compz00(obj_t BgL_envz00_14794,
		obj_t BgL_cz00_14802, obj_t BgL_dz00_14803, obj_t BgL_lastz00_14804)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_runz00_14800;
				long BgL_siza7ezd2framez75_14801;

				BgL_runz00_14800 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14794, (int) (((long) 5))));
				BgL_siza7ezd2framez75_14801 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14794, (int) (((long) 6))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_sz00_17221;

					BgL_sz00_17221 = BGl_findzd2statezd2zz__evaluate_compz00();
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_bpz00_17222;

						BgL_bpz00_17222 = VECTOR_REF(((obj_t) BgL_sz00_17221), ((long) 0));
						if (
							(((long) CINT(BgL_bpz00_17222) + BgL_siza7ezd2framez75_14801) <
								VECTOR_LENGTH(((obj_t) BgL_sz00_17221))))
							{	/* Eval/evaluate_comp.scm 1174 */
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3718z00_17223;

									BgL_arg3718z00_17223 =
										((long) CINT(BgL_bpz00_17222) + ((long) 0));
									VECTOR_SET(
										((obj_t) BgL_sz00_17221), BgL_arg3718z00_17223,
										BgL_cz00_14802);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3719z00_17224;

									BgL_arg3719z00_17224 =
										((long) CINT(BgL_bpz00_17222) + ((long) 1));
									VECTOR_SET(
										((obj_t) BgL_sz00_17221), BgL_arg3719z00_17224,
										BgL_dz00_14803);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3720z00_17225;

									BgL_arg3720z00_17225 =
										((long) CINT(BgL_bpz00_17222) + ((long) 2));
									VECTOR_SET(
										((obj_t) BgL_sz00_17221), BgL_arg3720z00_17225,
										BgL_lastz00_14804);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_ez00_17226;

									BgL_ez00_17226 = BGL_EXITD_TOP_AS_OBJ();
									BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17226,
										BgL_bpz00_17222);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_accz00_17227;

										BgL_accz00_17227 =
											BGl_catchzd2trampolinezd2zz__evaluate_compz00
											(BgL_runz00_14800, BgL_sz00_17221, BgL_bpz00_17222);
										BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_17226);
										VECTOR_SET(
											((obj_t) BgL_sz00_17221), ((long) 0), BgL_bpz00_17222);
										return BgL_accz00_17227;
									}
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_nsz00_17228;

								BgL_nsz00_17228 = BGl_makezd2statezd2zz__evaluate_compz00();
								VECTOR_SET(BgL_nsz00_17228, ((long) 1), BgL_sz00_17221);
								VECTOR_SET(BgL_nsz00_17228, ((long) 2), BgL_cz00_14802);
								VECTOR_SET(BgL_nsz00_17228, ((long) 3), BgL_dz00_14803);
								VECTOR_SET(BgL_nsz00_17228, ((long) 4), BgL_lastz00_14804);
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_z12denvz12_17229;

									BgL_z12denvz12_17229 = BGL_CURRENT_DYNAMIC_ENV();
									BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17229, BgL_nsz00_17228);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_ez00_17230;

										BgL_ez00_17230 = BGL_EXITD_TOP_AS_OBJ();
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17230,
											BgL_sz00_17221);
										{	/* Eval/evaluate_comp.scm 1174 */
											obj_t BgL_____rz00_17231;

											{	/* Eval/evaluate_comp.scm 670 */
												obj_t BgL_savedzd2bpzd2_17232;

												BgL_savedzd2bpzd2_17232 =
													VECTOR_REF(BgL_nsz00_17228, ((long) 0));
												VECTOR_SET(BgL_nsz00_17228, ((long) 0),
													BINT(((long) 2)));
												{
													obj_t BgL_fz00_17234;

													BgL_fz00_17234 = BgL_runz00_14800;
												BgL_recz00_17233:
													{	/* Eval/evaluate_comp.scm 673 */
														obj_t BgL_rz00_17235;

														BgL_rz00_17235 =
															PROCEDURE_ENTRY(BgL_fz00_17234) (BgL_fz00_17234,
															BgL_nsz00_17228, BEOA);
														{	/* Eval/evaluate_comp.scm 674 */
															bool_t BgL_test6658z00_29327;

															if (PROCEDUREP(BgL_rz00_17235))
																{	/* Eval/evaluate_comp.scm 674 */
																	obj_t BgL_arg1702z00_17236;

																	BgL_arg1702z00_17236 =
																		PROCEDURE_ATTR(BgL_rz00_17235);
																	if (STRUCTP(BgL_arg1702z00_17236))
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test6658z00_29327 =
																				(STRUCT_KEY(BgL_arg1702z00_17236) ==
																				BGl_symbol5803z00zz__evaluate_compz00);
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test6658z00_29327 = ((bool_t) 0);
																		}
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	BgL_test6658z00_29327 = ((bool_t) 0);
																}
															if (BgL_test6658z00_29327)
																{
																	obj_t BgL_fz00_29335;

																	BgL_fz00_29335 = BgL_rz00_17235;
																	BgL_fz00_17234 = BgL_fz00_29335;
																	goto BgL_recz00_17233;
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	VECTOR_SET(BgL_nsz00_17228, ((long) 0),
																		BgL_savedzd2bpzd2_17232);
																	BgL_____rz00_17231 = BgL_rz00_17235;
											}}}}}
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_ez00_17230);
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17229, BgL_sz00_17221);
											return BgL_____rz00_17231;
										}
									}
								}
							}
					}
				}
			}
		}

	}



/* &run5746 */
	obj_t BGl_z62run5746z62zz__evaluate_compz00(obj_t BgL_envz00_14805,
		obj_t BgL_sz00_14811)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_iboxesz00_14806;
				long BgL_siza7eza7_14807;
				obj_t BgL_valza2za2_14808;
				BgL_ev_absz00_bglt BgL_i1247z00_14809;
				obj_t BgL_bodyz00_14810;

				BgL_iboxesz00_14806 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14805, (int) (((long) 0))));
				BgL_siza7eza7_14807 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14805, (int) (((long) 1))));
				BgL_valza2za2_14808 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14805, (int) (((long) 2))));
				BgL_i1247z00_14809 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14805, (int) (((long) 3))));
				BgL_bodyz00_14810 = PROCEDURE_REF(BgL_envz00_14805, (int) (((long) 4)));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_17237;

					BgL_bpz00_17237 = VECTOR_REF(((obj_t) BgL_sz00_14811), ((long) 0));
					BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_14811,
						BgL_iboxesz00_14806, BgL_bpz00_17237);
					BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_14811,
						BgL_valza2za2_14808,
						((long) CINT(BgL_bpz00_17237) + BgL_siza7eza7_14807));
					{	/* Eval/evaluate_comp.scm 1095 */
						obj_t BgL_z12denvz12_17238;
						obj_t BgL_wherez00_17239;
						obj_t BgL_locz00_17240;

						BgL_z12denvz12_17238 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_wherez00_17239 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14809))->
							BgL_wherez00);
						BgL_locz00_17240 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14809))->BgL_locz00);
						{	/* Eval/evaluate_comp.scm 1095 */

							BGL_ENV_PUSH_TRACE(BgL_z12denvz12_17238, BgL_wherez00_17239,
								BgL_locz00_17240);
							{	/* Eval/evaluate_comp.scm 1095 */
								obj_t BgL_za2za2resza2za2z00_17241;

								BgL_za2za2resza2za2z00_17241 =
									PROCEDURE_ENTRY(BgL_bodyz00_14810) (BgL_bodyz00_14810,
									BgL_sz00_14811, BEOA);
								BGL_ENV_POP_TRACE(BgL_z12denvz12_17238);
								return BgL_za2za2resza2za2z00_17241;
							}
						}
					}
				}
			}
		}

	}



/* &<@anonymous:3629> */
	obj_t BGl_z62zc3z04anonymousza33629ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_14812, obj_t BgL_sz00_14816)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				BgL_ev_absz00_bglt BgL_i1247z00_14813;
				obj_t BgL_bodyz00_14814;
				long BgL_siza7ezd2framez75_14815;

				BgL_i1247z00_14813 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14812, (int) (((long) 0))));
				BgL_bodyz00_14814 = PROCEDURE_REF(BgL_envz00_14812, (int) (((long) 1)));
				BgL_siza7ezd2framez75_14815 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14812, (int) (((long) 2))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_17242;

					BgL_bpz00_17242 = VECTOR_REF(((obj_t) BgL_sz00_14816), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1174 */

						{	/* Eval/evaluate_comp.scm 1174 */
							obj_t BgL_runz00_17243;

							BgL_runz00_17243 =
								MAKE_FX_PROCEDURE(BGl_z62run5748z62zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 2)));
							PROCEDURE_SET(BgL_runz00_17243,
								(int) (((long) 0)), ((obj_t) BgL_i1247z00_14813));
							PROCEDURE_SET(BgL_runz00_17243,
								(int) (((long) 1)), BgL_bodyz00_14814);
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_mainz00_17244;

								BgL_mainz00_17244 =
									MAKE_FX_PROCEDURE(BGl_z62main5747z62zz__evaluate_compz00,
									(int) (((long) 2)), (int) (((long) 4)));
								PROCEDURE_SET(BgL_mainz00_17244,
									(int) (((long) 0)), ((obj_t) BgL_i1247z00_14813));
								PROCEDURE_SET(BgL_mainz00_17244,
									(int) (((long) 1)), BgL_bodyz00_14814);
								PROCEDURE_SET(BgL_mainz00_17244,
									(int) (((long) 2)), BgL_runz00_17243);
								PROCEDURE_SET(BgL_mainz00_17244,
									(int) (((long) 3)), BINT(BgL_siza7ezd2framez75_14815));
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_objz00_17245;

									BgL_objz00_17245 =
										BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
									PROCEDURE_ATTR_SET(BgL_runz00_17243, BgL_objz00_17245);
									BgL_objz00_17245;
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_arg3631z00_17246;

									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_arg3632z00_17247;

										BgL_arg3632z00_17247 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14813))->
											BgL_wherez00);
										{	/* Eval/evaluate_comp.scm 683 */
											obj_t BgL_newz00_17248;

											BgL_newz00_17248 =
												create_struct(BGl_symbol5824z00zz__evaluate_compz00,
												(int) (((long) 4)));
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_29403;

												BgL_tmpz00_29403 = (int) (((long) 3));
												STRUCT_SET(BgL_newz00_17248, BgL_tmpz00_29403,
													BgL_arg3632z00_17247);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_29408;
												int BgL_tmpz00_29406;

												BgL_auxz00_29408 = BINT(BgL_siza7ezd2framez75_14815);
												BgL_tmpz00_29406 = (int) (((long) 2));
												STRUCT_SET(BgL_newz00_17248, BgL_tmpz00_29406,
													BgL_auxz00_29408);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_29411;

												BgL_tmpz00_29411 = (int) (((long) 1));
												STRUCT_SET(BgL_newz00_17248, BgL_tmpz00_29411,
													BgL_runz00_17243);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_29416;
												int BgL_tmpz00_29414;

												BgL_auxz00_29416 = BINT(((long) 2));
												BgL_tmpz00_29414 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_17248, BgL_tmpz00_29414,
													BgL_auxz00_29416);
											}
											BgL_arg3631z00_17246 = BgL_newz00_17248;
									}}
									PROCEDURE_ATTR_SET(BgL_mainz00_17244, BgL_arg3631z00_17246);
									BgL_arg3631z00_17246;
								}
								return BgL_mainz00_17244;
							}
						}
					}
				}
			}
		}

	}



/* &main5747 */
	obj_t BGl_z62main5747z62zz__evaluate_compz00(obj_t BgL_envz00_14817,
		obj_t BgL_cz00_14822, obj_t BgL_dz00_14823)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_runz00_14820;
				long BgL_siza7ezd2framez75_14821;

				BgL_runz00_14820 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14817, (int) (((long) 2))));
				BgL_siza7ezd2framez75_14821 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14817, (int) (((long) 3))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_sz00_17249;

					BgL_sz00_17249 = BGl_findzd2statezd2zz__evaluate_compz00();
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_bpz00_17250;

						BgL_bpz00_17250 = VECTOR_REF(((obj_t) BgL_sz00_17249), ((long) 0));
						if (
							(((long) CINT(BgL_bpz00_17250) + BgL_siza7ezd2framez75_14821) <
								VECTOR_LENGTH(((obj_t) BgL_sz00_17249))))
							{	/* Eval/evaluate_comp.scm 1174 */
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3635z00_17251;

									BgL_arg3635z00_17251 =
										((long) CINT(BgL_bpz00_17250) + ((long) 0));
									VECTOR_SET(
										((obj_t) BgL_sz00_17249), BgL_arg3635z00_17251,
										BgL_cz00_14822);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3637z00_17252;

									BgL_arg3637z00_17252 =
										((long) CINT(BgL_bpz00_17250) + ((long) 1));
									VECTOR_SET(
										((obj_t) BgL_sz00_17249), BgL_arg3637z00_17252,
										BgL_dz00_14823);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_ez00_17253;

									BgL_ez00_17253 = BGL_EXITD_TOP_AS_OBJ();
									BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17253,
										BgL_bpz00_17250);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_accz00_17254;

										BgL_accz00_17254 =
											BGl_catchzd2trampolinezd2zz__evaluate_compz00
											(BgL_runz00_14820, BgL_sz00_17249, BgL_bpz00_17250);
										BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_17253);
										VECTOR_SET(
											((obj_t) BgL_sz00_17249), ((long) 0), BgL_bpz00_17250);
										return BgL_accz00_17254;
									}
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_nsz00_17255;

								BgL_nsz00_17255 = BGl_makezd2statezd2zz__evaluate_compz00();
								VECTOR_SET(BgL_nsz00_17255, ((long) 1), BgL_sz00_17249);
								VECTOR_SET(BgL_nsz00_17255, ((long) 2), BgL_cz00_14822);
								VECTOR_SET(BgL_nsz00_17255, ((long) 3), BgL_dz00_14823);
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_z12denvz12_17256;

									BgL_z12denvz12_17256 = BGL_CURRENT_DYNAMIC_ENV();
									BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17256, BgL_nsz00_17255);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_ez00_17257;

										BgL_ez00_17257 = BGL_EXITD_TOP_AS_OBJ();
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17257,
											BgL_sz00_17249);
										{	/* Eval/evaluate_comp.scm 1174 */
											obj_t BgL_____rz00_17258;

											{	/* Eval/evaluate_comp.scm 670 */
												obj_t BgL_savedzd2bpzd2_17259;

												BgL_savedzd2bpzd2_17259 =
													VECTOR_REF(BgL_nsz00_17255, ((long) 0));
												VECTOR_SET(BgL_nsz00_17255, ((long) 0),
													BINT(((long) 2)));
												{
													obj_t BgL_fz00_17261;

													BgL_fz00_17261 = BgL_runz00_14820;
												BgL_recz00_17260:
													{	/* Eval/evaluate_comp.scm 673 */
														obj_t BgL_rz00_17262;

														BgL_rz00_17262 =
															PROCEDURE_ENTRY(BgL_fz00_17261) (BgL_fz00_17261,
															BgL_nsz00_17255, BEOA);
														{	/* Eval/evaluate_comp.scm 674 */
															bool_t BgL_test6662z00_29464;

															if (PROCEDUREP(BgL_rz00_17262))
																{	/* Eval/evaluate_comp.scm 674 */
																	obj_t BgL_arg1702z00_17263;

																	BgL_arg1702z00_17263 =
																		PROCEDURE_ATTR(BgL_rz00_17262);
																	if (STRUCTP(BgL_arg1702z00_17263))
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test6662z00_29464 =
																				(STRUCT_KEY(BgL_arg1702z00_17263) ==
																				BGl_symbol5803z00zz__evaluate_compz00);
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test6662z00_29464 = ((bool_t) 0);
																		}
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	BgL_test6662z00_29464 = ((bool_t) 0);
																}
															if (BgL_test6662z00_29464)
																{
																	obj_t BgL_fz00_29472;

																	BgL_fz00_29472 = BgL_rz00_17262;
																	BgL_fz00_17261 = BgL_fz00_29472;
																	goto BgL_recz00_17260;
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	VECTOR_SET(BgL_nsz00_17255, ((long) 0),
																		BgL_savedzd2bpzd2_17259);
																	BgL_____rz00_17258 = BgL_rz00_17262;
											}}}}}
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_ez00_17257);
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17256, BgL_sz00_17249);
											return BgL_____rz00_17258;
										}
									}
								}
							}
					}
				}
			}
		}

	}



/* &run5748 */
	obj_t BGl_z62run5748z62zz__evaluate_compz00(obj_t BgL_envz00_14824,
		obj_t BgL_sz00_14827)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				BgL_ev_absz00_bglt BgL_i1247z00_14825;
				obj_t BgL_bodyz00_14826;

				BgL_i1247z00_14825 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14824, (int) (((long) 0))));
				BgL_bodyz00_14826 = PROCEDURE_REF(BgL_envz00_14824, (int) (((long) 1)));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_17264;

					BgL_bpz00_17264 = VECTOR_REF(((obj_t) BgL_sz00_14827), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_z12denvz12_17265;
						obj_t BgL_wherez00_17266;
						obj_t BgL_locz00_17267;

						BgL_z12denvz12_17265 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_wherez00_17266 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14825))->
							BgL_wherez00);
						BgL_locz00_17267 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14825))->BgL_locz00);
						{	/* Eval/evaluate_comp.scm 1174 */

							BGL_ENV_PUSH_TRACE(BgL_z12denvz12_17265, BgL_wherez00_17266,
								BgL_locz00_17267);
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_za2za2resza2za2z00_17268;

								BgL_za2za2resza2za2z00_17268 =
									PROCEDURE_ENTRY(BgL_bodyz00_14826) (BgL_bodyz00_14826,
									BgL_sz00_14827, BEOA);
								BGL_ENV_POP_TRACE(BgL_z12denvz12_17265);
								return BgL_za2za2resza2za2z00_17268;
							}
						}
					}
				}
			}
		}

	}



/* &<@anonymous:3639> */
	obj_t BGl_z62zc3z04anonymousza33639ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_14828, obj_t BgL_sz00_14833)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_iboxesz00_14829;
				BgL_ev_absz00_bglt BgL_i1247z00_14830;
				obj_t BgL_bodyz00_14831;
				long BgL_siza7ezd2framez75_14832;

				BgL_iboxesz00_14829 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14828, (int) (((long) 0))));
				BgL_i1247z00_14830 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14828, (int) (((long) 1))));
				BgL_bodyz00_14831 = PROCEDURE_REF(BgL_envz00_14828, (int) (((long) 2)));
				BgL_siza7ezd2framez75_14832 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14828, (int) (((long) 3))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_17269;

					BgL_bpz00_17269 = VECTOR_REF(((obj_t) BgL_sz00_14833), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1174 */

						{	/* Eval/evaluate_comp.scm 1174 */
							obj_t BgL_runz00_17270;

							BgL_runz00_17270 =
								MAKE_FX_PROCEDURE(BGl_z62run5750z62zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 3)));
							PROCEDURE_SET(BgL_runz00_17270,
								(int) (((long) 0)), BgL_iboxesz00_14829);
							PROCEDURE_SET(BgL_runz00_17270,
								(int) (((long) 1)), ((obj_t) BgL_i1247z00_14830));
							PROCEDURE_SET(BgL_runz00_17270,
								(int) (((long) 2)), BgL_bodyz00_14831);
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_mainz00_17271;

								BgL_mainz00_17271 =
									MAKE_FX_PROCEDURE(BGl_z62main5749z62zz__evaluate_compz00,
									(int) (((long) 2)), (int) (((long) 5)));
								PROCEDURE_SET(BgL_mainz00_17271,
									(int) (((long) 0)), BgL_iboxesz00_14829);
								PROCEDURE_SET(BgL_mainz00_17271,
									(int) (((long) 1)), ((obj_t) BgL_i1247z00_14830));
								PROCEDURE_SET(BgL_mainz00_17271,
									(int) (((long) 2)), BgL_bodyz00_14831);
								PROCEDURE_SET(BgL_mainz00_17271,
									(int) (((long) 3)), BgL_runz00_17270);
								PROCEDURE_SET(BgL_mainz00_17271,
									(int) (((long) 4)), BINT(BgL_siza7ezd2framez75_14832));
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_objz00_17272;

									BgL_objz00_17272 =
										BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
									PROCEDURE_ATTR_SET(BgL_runz00_17270, BgL_objz00_17272);
									BgL_objz00_17272;
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_arg3640z00_17273;

									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_arg3641z00_17274;

										BgL_arg3641z00_17274 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14830))->
											BgL_wherez00);
										{	/* Eval/evaluate_comp.scm 683 */
											obj_t BgL_newz00_17275;

											BgL_newz00_17275 =
												create_struct(BGl_symbol5824z00zz__evaluate_compz00,
												(int) (((long) 4)));
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_29534;

												BgL_tmpz00_29534 = (int) (((long) 3));
												STRUCT_SET(BgL_newz00_17275, BgL_tmpz00_29534,
													BgL_arg3641z00_17274);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_29539;
												int BgL_tmpz00_29537;

												BgL_auxz00_29539 = BINT(BgL_siza7ezd2framez75_14832);
												BgL_tmpz00_29537 = (int) (((long) 2));
												STRUCT_SET(BgL_newz00_17275, BgL_tmpz00_29537,
													BgL_auxz00_29539);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_29542;

												BgL_tmpz00_29542 = (int) (((long) 1));
												STRUCT_SET(BgL_newz00_17275, BgL_tmpz00_29542,
													BgL_runz00_17270);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_29547;
												int BgL_tmpz00_29545;

												BgL_auxz00_29547 = BINT(((long) 2));
												BgL_tmpz00_29545 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_17275, BgL_tmpz00_29545,
													BgL_auxz00_29547);
											}
											BgL_arg3640z00_17273 = BgL_newz00_17275;
									}}
									PROCEDURE_ATTR_SET(BgL_mainz00_17271, BgL_arg3640z00_17273);
									BgL_arg3640z00_17273;
								}
								return BgL_mainz00_17271;
							}
						}
					}
				}
			}
		}

	}



/* &main5749 */
	obj_t BGl_z62main5749z62zz__evaluate_compz00(obj_t BgL_envz00_14834,
		obj_t BgL_cz00_14840, obj_t BgL_dz00_14841)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_runz00_14838;
				long BgL_siza7ezd2framez75_14839;

				BgL_runz00_14838 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14834, (int) (((long) 3))));
				BgL_siza7ezd2framez75_14839 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14834, (int) (((long) 4))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_sz00_17276;

					BgL_sz00_17276 = BGl_findzd2statezd2zz__evaluate_compz00();
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_bpz00_17277;

						BgL_bpz00_17277 = VECTOR_REF(((obj_t) BgL_sz00_17276), ((long) 0));
						if (
							(((long) CINT(BgL_bpz00_17277) + BgL_siza7ezd2framez75_14839) <
								VECTOR_LENGTH(((obj_t) BgL_sz00_17276))))
							{	/* Eval/evaluate_comp.scm 1174 */
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3645z00_17278;

									BgL_arg3645z00_17278 =
										((long) CINT(BgL_bpz00_17277) + ((long) 0));
									VECTOR_SET(
										((obj_t) BgL_sz00_17276), BgL_arg3645z00_17278,
										BgL_cz00_14840);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3646z00_17279;

									BgL_arg3646z00_17279 =
										((long) CINT(BgL_bpz00_17277) + ((long) 1));
									VECTOR_SET(
										((obj_t) BgL_sz00_17276), BgL_arg3646z00_17279,
										BgL_dz00_14841);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_ez00_17280;

									BgL_ez00_17280 = BGL_EXITD_TOP_AS_OBJ();
									BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17280,
										BgL_bpz00_17277);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_accz00_17281;

										BgL_accz00_17281 =
											BGl_catchzd2trampolinezd2zz__evaluate_compz00
											(BgL_runz00_14838, BgL_sz00_17276, BgL_bpz00_17277);
										BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_17280);
										VECTOR_SET(
											((obj_t) BgL_sz00_17276), ((long) 0), BgL_bpz00_17277);
										return BgL_accz00_17281;
									}
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_nsz00_17282;

								BgL_nsz00_17282 = BGl_makezd2statezd2zz__evaluate_compz00();
								VECTOR_SET(BgL_nsz00_17282, ((long) 1), BgL_sz00_17276);
								VECTOR_SET(BgL_nsz00_17282, ((long) 2), BgL_cz00_14840);
								VECTOR_SET(BgL_nsz00_17282, ((long) 3), BgL_dz00_14841);
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_z12denvz12_17283;

									BgL_z12denvz12_17283 = BGL_CURRENT_DYNAMIC_ENV();
									BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17283, BgL_nsz00_17282);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_ez00_17284;

										BgL_ez00_17284 = BGL_EXITD_TOP_AS_OBJ();
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17284,
											BgL_sz00_17276);
										{	/* Eval/evaluate_comp.scm 1174 */
											obj_t BgL_____rz00_17285;

											{	/* Eval/evaluate_comp.scm 670 */
												obj_t BgL_savedzd2bpzd2_17286;

												BgL_savedzd2bpzd2_17286 =
													VECTOR_REF(BgL_nsz00_17282, ((long) 0));
												VECTOR_SET(BgL_nsz00_17282, ((long) 0),
													BINT(((long) 2)));
												{
													obj_t BgL_fz00_17288;

													BgL_fz00_17288 = BgL_runz00_14838;
												BgL_recz00_17287:
													{	/* Eval/evaluate_comp.scm 673 */
														obj_t BgL_rz00_17289;

														BgL_rz00_17289 =
															PROCEDURE_ENTRY(BgL_fz00_17288) (BgL_fz00_17288,
															BgL_nsz00_17282, BEOA);
														{	/* Eval/evaluate_comp.scm 674 */
															bool_t BgL_test6666z00_29595;

															if (PROCEDUREP(BgL_rz00_17289))
																{	/* Eval/evaluate_comp.scm 674 */
																	obj_t BgL_arg1702z00_17290;

																	BgL_arg1702z00_17290 =
																		PROCEDURE_ATTR(BgL_rz00_17289);
																	if (STRUCTP(BgL_arg1702z00_17290))
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test6666z00_29595 =
																				(STRUCT_KEY(BgL_arg1702z00_17290) ==
																				BGl_symbol5803z00zz__evaluate_compz00);
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test6666z00_29595 = ((bool_t) 0);
																		}
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	BgL_test6666z00_29595 = ((bool_t) 0);
																}
															if (BgL_test6666z00_29595)
																{
																	obj_t BgL_fz00_29603;

																	BgL_fz00_29603 = BgL_rz00_17289;
																	BgL_fz00_17288 = BgL_fz00_29603;
																	goto BgL_recz00_17287;
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	VECTOR_SET(BgL_nsz00_17282, ((long) 0),
																		BgL_savedzd2bpzd2_17286);
																	BgL_____rz00_17285 = BgL_rz00_17289;
											}}}}}
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_ez00_17284);
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17283, BgL_sz00_17276);
											return BgL_____rz00_17285;
										}
									}
								}
							}
					}
				}
			}
		}

	}



/* &run5750 */
	obj_t BGl_z62run5750z62zz__evaluate_compz00(obj_t BgL_envz00_14842,
		obj_t BgL_sz00_14846)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_iboxesz00_14843;
				BgL_ev_absz00_bglt BgL_i1247z00_14844;
				obj_t BgL_bodyz00_14845;

				BgL_iboxesz00_14843 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14842, (int) (((long) 0))));
				BgL_i1247z00_14844 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14842, (int) (((long) 1))));
				BgL_bodyz00_14845 = PROCEDURE_REF(BgL_envz00_14842, (int) (((long) 2)));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_17291;

					BgL_bpz00_17291 = VECTOR_REF(((obj_t) BgL_sz00_14846), ((long) 0));
					BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_14846,
						BgL_iboxesz00_14843, BgL_bpz00_17291);
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_z12denvz12_17292;
						obj_t BgL_wherez00_17293;
						obj_t BgL_locz00_17294;

						BgL_z12denvz12_17292 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_wherez00_17293 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14844))->
							BgL_wherez00);
						BgL_locz00_17294 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14844))->BgL_locz00);
						{	/* Eval/evaluate_comp.scm 1174 */

							BGL_ENV_PUSH_TRACE(BgL_z12denvz12_17292, BgL_wherez00_17293,
								BgL_locz00_17294);
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_za2za2resza2za2z00_17295;

								BgL_za2za2resza2za2z00_17295 =
									PROCEDURE_ENTRY(BgL_bodyz00_14845) (BgL_bodyz00_14845,
									BgL_sz00_14846, BEOA);
								BGL_ENV_POP_TRACE(BgL_z12denvz12_17292);
								return BgL_za2za2resza2za2z00_17295;
							}
						}
					}
				}
			}
		}

	}



/* &<@anonymous:3651> */
	obj_t BGl_z62zc3z04anonymousza33651ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_14847, obj_t BgL_sz00_14853)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_ifreesz00_14848;
				long BgL_siza7eza7_14849;
				BgL_ev_absz00_bglt BgL_i1247z00_14850;
				obj_t BgL_bodyz00_14851;
				long BgL_siza7ezd2framez75_14852;

				BgL_ifreesz00_14848 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14847, (int) (((long) 0))));
				BgL_siza7eza7_14849 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14847, (int) (((long) 1))));
				BgL_i1247z00_14850 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14847, (int) (((long) 2))));
				BgL_bodyz00_14851 = PROCEDURE_REF(BgL_envz00_14847, (int) (((long) 3)));
				BgL_siza7ezd2framez75_14852 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14847, (int) (((long) 4))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_17296;

					BgL_bpz00_17296 = VECTOR_REF(((obj_t) BgL_sz00_14853), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_valza2za2_17297;

						BgL_valza2za2_17297 =
							BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_14853,
							BgL_bpz00_17296, BgL_ifreesz00_14848);
						{	/* Eval/evaluate_comp.scm 1174 */
							obj_t BgL_runz00_17298;

							BgL_runz00_17298 =
								MAKE_FX_PROCEDURE(BGl_z62run5752z62zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 4)));
							PROCEDURE_SET(BgL_runz00_17298,
								(int) (((long) 0)), BINT(BgL_siza7eza7_14849));
							PROCEDURE_SET(BgL_runz00_17298,
								(int) (((long) 1)), BgL_valza2za2_17297);
							PROCEDURE_SET(BgL_runz00_17298,
								(int) (((long) 2)), ((obj_t) BgL_i1247z00_14850));
							PROCEDURE_SET(BgL_runz00_17298,
								(int) (((long) 3)), BgL_bodyz00_14851);
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_mainz00_17299;

								BgL_mainz00_17299 =
									MAKE_FX_PROCEDURE(BGl_z62main5751z62zz__evaluate_compz00,
									(int) (((long) 2)), (int) (((long) 6)));
								PROCEDURE_SET(BgL_mainz00_17299,
									(int) (((long) 0)), BINT(BgL_siza7eza7_14849));
								PROCEDURE_SET(BgL_mainz00_17299,
									(int) (((long) 1)), BgL_valza2za2_17297);
								PROCEDURE_SET(BgL_mainz00_17299,
									(int) (((long) 2)), ((obj_t) BgL_i1247z00_14850));
								PROCEDURE_SET(BgL_mainz00_17299,
									(int) (((long) 3)), BgL_bodyz00_14851);
								PROCEDURE_SET(BgL_mainz00_17299,
									(int) (((long) 4)), BgL_runz00_17298);
								PROCEDURE_SET(BgL_mainz00_17299,
									(int) (((long) 5)), BINT(BgL_siza7ezd2framez75_14852));
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_objz00_17300;

									BgL_objz00_17300 =
										BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
									PROCEDURE_ATTR_SET(BgL_runz00_17298, BgL_objz00_17300);
									BgL_objz00_17300;
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_arg3652z00_17301;

									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_arg3653z00_17302;

										BgL_arg3653z00_17302 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14850))->
											BgL_wherez00);
										{	/* Eval/evaluate_comp.scm 683 */
											obj_t BgL_newz00_17303;

											BgL_newz00_17303 =
												create_struct(BGl_symbol5824z00zz__evaluate_compz00,
												(int) (((long) 4)));
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_29679;

												BgL_tmpz00_29679 = (int) (((long) 3));
												STRUCT_SET(BgL_newz00_17303, BgL_tmpz00_29679,
													BgL_arg3653z00_17302);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_29684;
												int BgL_tmpz00_29682;

												BgL_auxz00_29684 = BINT(BgL_siza7ezd2framez75_14852);
												BgL_tmpz00_29682 = (int) (((long) 2));
												STRUCT_SET(BgL_newz00_17303, BgL_tmpz00_29682,
													BgL_auxz00_29684);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_29687;

												BgL_tmpz00_29687 = (int) (((long) 1));
												STRUCT_SET(BgL_newz00_17303, BgL_tmpz00_29687,
													BgL_runz00_17298);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_29692;
												int BgL_tmpz00_29690;

												BgL_auxz00_29692 = BINT(((long) 2));
												BgL_tmpz00_29690 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_17303, BgL_tmpz00_29690,
													BgL_auxz00_29692);
											}
											BgL_arg3652z00_17301 = BgL_newz00_17303;
									}}
									PROCEDURE_ATTR_SET(BgL_mainz00_17299, BgL_arg3652z00_17301);
									BgL_arg3652z00_17301;
								}
								return BgL_mainz00_17299;
							}
						}
					}
				}
			}
		}

	}



/* &main5751 */
	obj_t BGl_z62main5751z62zz__evaluate_compz00(obj_t BgL_envz00_14854,
		obj_t BgL_cz00_14861, obj_t BgL_dz00_14862)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_runz00_14859;
				long BgL_siza7ezd2framez75_14860;

				BgL_runz00_14859 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14854, (int) (((long) 4))));
				BgL_siza7ezd2framez75_14860 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14854, (int) (((long) 5))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_sz00_17304;

					BgL_sz00_17304 = BGl_findzd2statezd2zz__evaluate_compz00();
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_bpz00_17305;

						BgL_bpz00_17305 = VECTOR_REF(((obj_t) BgL_sz00_17304), ((long) 0));
						if (
							(((long) CINT(BgL_bpz00_17305) + BgL_siza7ezd2framez75_14860) <
								VECTOR_LENGTH(((obj_t) BgL_sz00_17304))))
							{	/* Eval/evaluate_comp.scm 1174 */
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3656z00_17306;

									BgL_arg3656z00_17306 =
										((long) CINT(BgL_bpz00_17305) + ((long) 0));
									VECTOR_SET(
										((obj_t) BgL_sz00_17304), BgL_arg3656z00_17306,
										BgL_cz00_14861);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3658z00_17307;

									BgL_arg3658z00_17307 =
										((long) CINT(BgL_bpz00_17305) + ((long) 1));
									VECTOR_SET(
										((obj_t) BgL_sz00_17304), BgL_arg3658z00_17307,
										BgL_dz00_14862);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_ez00_17308;

									BgL_ez00_17308 = BGL_EXITD_TOP_AS_OBJ();
									BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17308,
										BgL_bpz00_17305);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_accz00_17309;

										BgL_accz00_17309 =
											BGl_catchzd2trampolinezd2zz__evaluate_compz00
											(BgL_runz00_14859, BgL_sz00_17304, BgL_bpz00_17305);
										BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_17308);
										VECTOR_SET(
											((obj_t) BgL_sz00_17304), ((long) 0), BgL_bpz00_17305);
										return BgL_accz00_17309;
									}
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_nsz00_17310;

								BgL_nsz00_17310 = BGl_makezd2statezd2zz__evaluate_compz00();
								VECTOR_SET(BgL_nsz00_17310, ((long) 1), BgL_sz00_17304);
								VECTOR_SET(BgL_nsz00_17310, ((long) 2), BgL_cz00_14861);
								VECTOR_SET(BgL_nsz00_17310, ((long) 3), BgL_dz00_14862);
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_z12denvz12_17311;

									BgL_z12denvz12_17311 = BGL_CURRENT_DYNAMIC_ENV();
									BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17311, BgL_nsz00_17310);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_ez00_17312;

										BgL_ez00_17312 = BGL_EXITD_TOP_AS_OBJ();
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17312,
											BgL_sz00_17304);
										{	/* Eval/evaluate_comp.scm 1174 */
											obj_t BgL_____rz00_17313;

											{	/* Eval/evaluate_comp.scm 670 */
												obj_t BgL_savedzd2bpzd2_17314;

												BgL_savedzd2bpzd2_17314 =
													VECTOR_REF(BgL_nsz00_17310, ((long) 0));
												VECTOR_SET(BgL_nsz00_17310, ((long) 0),
													BINT(((long) 2)));
												{
													obj_t BgL_fz00_17316;

													BgL_fz00_17316 = BgL_runz00_14859;
												BgL_recz00_17315:
													{	/* Eval/evaluate_comp.scm 673 */
														obj_t BgL_rz00_17317;

														BgL_rz00_17317 =
															PROCEDURE_ENTRY(BgL_fz00_17316) (BgL_fz00_17316,
															BgL_nsz00_17310, BEOA);
														{	/* Eval/evaluate_comp.scm 674 */
															bool_t BgL_test6670z00_29740;

															if (PROCEDUREP(BgL_rz00_17317))
																{	/* Eval/evaluate_comp.scm 674 */
																	obj_t BgL_arg1702z00_17318;

																	BgL_arg1702z00_17318 =
																		PROCEDURE_ATTR(BgL_rz00_17317);
																	if (STRUCTP(BgL_arg1702z00_17318))
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test6670z00_29740 =
																				(STRUCT_KEY(BgL_arg1702z00_17318) ==
																				BGl_symbol5803z00zz__evaluate_compz00);
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test6670z00_29740 = ((bool_t) 0);
																		}
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	BgL_test6670z00_29740 = ((bool_t) 0);
																}
															if (BgL_test6670z00_29740)
																{
																	obj_t BgL_fz00_29748;

																	BgL_fz00_29748 = BgL_rz00_17317;
																	BgL_fz00_17316 = BgL_fz00_29748;
																	goto BgL_recz00_17315;
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	VECTOR_SET(BgL_nsz00_17310, ((long) 0),
																		BgL_savedzd2bpzd2_17314);
																	BgL_____rz00_17313 = BgL_rz00_17317;
											}}}}}
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_ez00_17312);
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17311, BgL_sz00_17304);
											return BgL_____rz00_17313;
										}
									}
								}
							}
					}
				}
			}
		}

	}



/* &run5752 */
	obj_t BGl_z62run5752z62zz__evaluate_compz00(obj_t BgL_envz00_14863,
		obj_t BgL_sz00_14868)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				long BgL_siza7eza7_14864;
				obj_t BgL_valza2za2_14865;
				BgL_ev_absz00_bglt BgL_i1247z00_14866;
				obj_t BgL_bodyz00_14867;

				BgL_siza7eza7_14864 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14863, (int) (((long) 0))));
				BgL_valza2za2_14865 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14863, (int) (((long) 1))));
				BgL_i1247z00_14866 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14863, (int) (((long) 2))));
				BgL_bodyz00_14867 = PROCEDURE_REF(BgL_envz00_14863, (int) (((long) 3)));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_17319;

					BgL_bpz00_17319 = VECTOR_REF(((obj_t) BgL_sz00_14868), ((long) 0));
					BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_14868,
						BgL_valza2za2_14865,
						((long) CINT(BgL_bpz00_17319) + BgL_siza7eza7_14864));
					{	/* Eval/evaluate_comp.scm 1095 */
						obj_t BgL_z12denvz12_17320;
						obj_t BgL_wherez00_17321;
						obj_t BgL_locz00_17322;

						BgL_z12denvz12_17320 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_wherez00_17321 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14866))->
							BgL_wherez00);
						BgL_locz00_17322 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14866))->BgL_locz00);
						{	/* Eval/evaluate_comp.scm 1095 */

							BGL_ENV_PUSH_TRACE(BgL_z12denvz12_17320, BgL_wherez00_17321,
								BgL_locz00_17322);
							{	/* Eval/evaluate_comp.scm 1095 */
								obj_t BgL_za2za2resza2za2z00_17323;

								BgL_za2za2resza2za2z00_17323 =
									PROCEDURE_ENTRY(BgL_bodyz00_14867) (BgL_bodyz00_14867,
									BgL_sz00_14868, BEOA);
								BGL_ENV_POP_TRACE(BgL_z12denvz12_17320);
								return BgL_za2za2resza2za2z00_17323;
							}
						}
					}
				}
			}
		}

	}



/* &<@anonymous:3661> */
	obj_t BGl_z62zc3z04anonymousza33661ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_14869, obj_t BgL_sz00_14876)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_ifreesz00_14870;
				obj_t BgL_iboxesz00_14871;
				long BgL_siza7eza7_14872;
				BgL_ev_absz00_bglt BgL_i1247z00_14873;
				obj_t BgL_bodyz00_14874;
				long BgL_siza7ezd2framez75_14875;

				BgL_ifreesz00_14870 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14869, (int) (((long) 0))));
				BgL_iboxesz00_14871 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14869, (int) (((long) 1))));
				BgL_siza7eza7_14872 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14869, (int) (((long) 2))));
				BgL_i1247z00_14873 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14869, (int) (((long) 3))));
				BgL_bodyz00_14874 = PROCEDURE_REF(BgL_envz00_14869, (int) (((long) 4)));
				BgL_siza7ezd2framez75_14875 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14869, (int) (((long) 5))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_17324;

					BgL_bpz00_17324 = VECTOR_REF(((obj_t) BgL_sz00_14876), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_valza2za2_17325;

						BgL_valza2za2_17325 =
							BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_14876,
							BgL_bpz00_17324, BgL_ifreesz00_14870);
						{	/* Eval/evaluate_comp.scm 1174 */
							obj_t BgL_runz00_17326;

							BgL_runz00_17326 =
								MAKE_FX_PROCEDURE(BGl_z62run5754z62zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 5)));
							PROCEDURE_SET(BgL_runz00_17326,
								(int) (((long) 0)), BgL_iboxesz00_14871);
							PROCEDURE_SET(BgL_runz00_17326,
								(int) (((long) 1)), BINT(BgL_siza7eza7_14872));
							PROCEDURE_SET(BgL_runz00_17326,
								(int) (((long) 2)), BgL_valza2za2_17325);
							PROCEDURE_SET(BgL_runz00_17326,
								(int) (((long) 3)), ((obj_t) BgL_i1247z00_14873));
							PROCEDURE_SET(BgL_runz00_17326,
								(int) (((long) 4)), BgL_bodyz00_14874);
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_mainz00_17327;

								BgL_mainz00_17327 =
									MAKE_FX_PROCEDURE(BGl_z62main5753z62zz__evaluate_compz00,
									(int) (((long) 2)), (int) (((long) 7)));
								PROCEDURE_SET(BgL_mainz00_17327,
									(int) (((long) 0)), BgL_iboxesz00_14871);
								PROCEDURE_SET(BgL_mainz00_17327,
									(int) (((long) 1)), BINT(BgL_siza7eza7_14872));
								PROCEDURE_SET(BgL_mainz00_17327,
									(int) (((long) 2)), BgL_valza2za2_17325);
								PROCEDURE_SET(BgL_mainz00_17327,
									(int) (((long) 3)), ((obj_t) BgL_i1247z00_14873));
								PROCEDURE_SET(BgL_mainz00_17327,
									(int) (((long) 4)), BgL_bodyz00_14874);
								PROCEDURE_SET(BgL_mainz00_17327,
									(int) (((long) 5)), BgL_runz00_17326);
								PROCEDURE_SET(BgL_mainz00_17327,
									(int) (((long) 6)), BINT(BgL_siza7ezd2framez75_14875));
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_objz00_17328;

									BgL_objz00_17328 =
										BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
									PROCEDURE_ATTR_SET(BgL_runz00_17326, BgL_objz00_17328);
									BgL_objz00_17328;
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_arg3662z00_17329;

									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_arg3663z00_17330;

										BgL_arg3663z00_17330 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14873))->
											BgL_wherez00);
										{	/* Eval/evaluate_comp.scm 683 */
											obj_t BgL_newz00_17331;

											BgL_newz00_17331 =
												create_struct(BGl_symbol5824z00zz__evaluate_compz00,
												(int) (((long) 4)));
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_29836;

												BgL_tmpz00_29836 = (int) (((long) 3));
												STRUCT_SET(BgL_newz00_17331, BgL_tmpz00_29836,
													BgL_arg3663z00_17330);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_29841;
												int BgL_tmpz00_29839;

												BgL_auxz00_29841 = BINT(BgL_siza7ezd2framez75_14875);
												BgL_tmpz00_29839 = (int) (((long) 2));
												STRUCT_SET(BgL_newz00_17331, BgL_tmpz00_29839,
													BgL_auxz00_29841);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_29844;

												BgL_tmpz00_29844 = (int) (((long) 1));
												STRUCT_SET(BgL_newz00_17331, BgL_tmpz00_29844,
													BgL_runz00_17326);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_29849;
												int BgL_tmpz00_29847;

												BgL_auxz00_29849 = BINT(((long) 2));
												BgL_tmpz00_29847 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_17331, BgL_tmpz00_29847,
													BgL_auxz00_29849);
											}
											BgL_arg3662z00_17329 = BgL_newz00_17331;
									}}
									PROCEDURE_ATTR_SET(BgL_mainz00_17327, BgL_arg3662z00_17329);
									BgL_arg3662z00_17329;
								}
								return BgL_mainz00_17327;
							}
						}
					}
				}
			}
		}

	}



/* &main5753 */
	obj_t BGl_z62main5753z62zz__evaluate_compz00(obj_t BgL_envz00_14877,
		obj_t BgL_cz00_14885, obj_t BgL_dz00_14886)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_runz00_14883;
				long BgL_siza7ezd2framez75_14884;

				BgL_runz00_14883 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14877, (int) (((long) 5))));
				BgL_siza7ezd2framez75_14884 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14877, (int) (((long) 6))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_sz00_17332;

					BgL_sz00_17332 = BGl_findzd2statezd2zz__evaluate_compz00();
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_bpz00_17333;

						BgL_bpz00_17333 = VECTOR_REF(((obj_t) BgL_sz00_17332), ((long) 0));
						if (
							(((long) CINT(BgL_bpz00_17333) + BgL_siza7ezd2framez75_14884) <
								VECTOR_LENGTH(((obj_t) BgL_sz00_17332))))
							{	/* Eval/evaluate_comp.scm 1174 */
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3666z00_17334;

									BgL_arg3666z00_17334 =
										((long) CINT(BgL_bpz00_17333) + ((long) 0));
									VECTOR_SET(
										((obj_t) BgL_sz00_17332), BgL_arg3666z00_17334,
										BgL_cz00_14885);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3668z00_17335;

									BgL_arg3668z00_17335 =
										((long) CINT(BgL_bpz00_17333) + ((long) 1));
									VECTOR_SET(
										((obj_t) BgL_sz00_17332), BgL_arg3668z00_17335,
										BgL_dz00_14886);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_ez00_17336;

									BgL_ez00_17336 = BGL_EXITD_TOP_AS_OBJ();
									BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17336,
										BgL_bpz00_17333);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_accz00_17337;

										BgL_accz00_17337 =
											BGl_catchzd2trampolinezd2zz__evaluate_compz00
											(BgL_runz00_14883, BgL_sz00_17332, BgL_bpz00_17333);
										BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_17336);
										VECTOR_SET(
											((obj_t) BgL_sz00_17332), ((long) 0), BgL_bpz00_17333);
										return BgL_accz00_17337;
									}
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_nsz00_17338;

								BgL_nsz00_17338 = BGl_makezd2statezd2zz__evaluate_compz00();
								VECTOR_SET(BgL_nsz00_17338, ((long) 1), BgL_sz00_17332);
								VECTOR_SET(BgL_nsz00_17338, ((long) 2), BgL_cz00_14885);
								VECTOR_SET(BgL_nsz00_17338, ((long) 3), BgL_dz00_14886);
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_z12denvz12_17339;

									BgL_z12denvz12_17339 = BGL_CURRENT_DYNAMIC_ENV();
									BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17339, BgL_nsz00_17338);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_ez00_17340;

										BgL_ez00_17340 = BGL_EXITD_TOP_AS_OBJ();
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17340,
											BgL_sz00_17332);
										{	/* Eval/evaluate_comp.scm 1174 */
											obj_t BgL_____rz00_17341;

											{	/* Eval/evaluate_comp.scm 670 */
												obj_t BgL_savedzd2bpzd2_17342;

												BgL_savedzd2bpzd2_17342 =
													VECTOR_REF(BgL_nsz00_17338, ((long) 0));
												VECTOR_SET(BgL_nsz00_17338, ((long) 0),
													BINT(((long) 2)));
												{
													obj_t BgL_fz00_17344;

													BgL_fz00_17344 = BgL_runz00_14883;
												BgL_recz00_17343:
													{	/* Eval/evaluate_comp.scm 673 */
														obj_t BgL_rz00_17345;

														BgL_rz00_17345 =
															PROCEDURE_ENTRY(BgL_fz00_17344) (BgL_fz00_17344,
															BgL_nsz00_17338, BEOA);
														{	/* Eval/evaluate_comp.scm 674 */
															bool_t BgL_test6674z00_29897;

															if (PROCEDUREP(BgL_rz00_17345))
																{	/* Eval/evaluate_comp.scm 674 */
																	obj_t BgL_arg1702z00_17346;

																	BgL_arg1702z00_17346 =
																		PROCEDURE_ATTR(BgL_rz00_17345);
																	if (STRUCTP(BgL_arg1702z00_17346))
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test6674z00_29897 =
																				(STRUCT_KEY(BgL_arg1702z00_17346) ==
																				BGl_symbol5803z00zz__evaluate_compz00);
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test6674z00_29897 = ((bool_t) 0);
																		}
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	BgL_test6674z00_29897 = ((bool_t) 0);
																}
															if (BgL_test6674z00_29897)
																{
																	obj_t BgL_fz00_29905;

																	BgL_fz00_29905 = BgL_rz00_17345;
																	BgL_fz00_17344 = BgL_fz00_29905;
																	goto BgL_recz00_17343;
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	VECTOR_SET(BgL_nsz00_17338, ((long) 0),
																		BgL_savedzd2bpzd2_17342);
																	BgL_____rz00_17341 = BgL_rz00_17345;
											}}}}}
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_ez00_17340);
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17339, BgL_sz00_17332);
											return BgL_____rz00_17341;
										}
									}
								}
							}
					}
				}
			}
		}

	}



/* &run5754 */
	obj_t BGl_z62run5754z62zz__evaluate_compz00(obj_t BgL_envz00_14887,
		obj_t BgL_sz00_14893)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_iboxesz00_14888;
				long BgL_siza7eza7_14889;
				obj_t BgL_valza2za2_14890;
				BgL_ev_absz00_bglt BgL_i1247z00_14891;
				obj_t BgL_bodyz00_14892;

				BgL_iboxesz00_14888 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14887, (int) (((long) 0))));
				BgL_siza7eza7_14889 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14887, (int) (((long) 1))));
				BgL_valza2za2_14890 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14887, (int) (((long) 2))));
				BgL_i1247z00_14891 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14887, (int) (((long) 3))));
				BgL_bodyz00_14892 = PROCEDURE_REF(BgL_envz00_14887, (int) (((long) 4)));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_17347;

					BgL_bpz00_17347 = VECTOR_REF(((obj_t) BgL_sz00_14893), ((long) 0));
					BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_14893,
						BgL_iboxesz00_14888, BgL_bpz00_17347);
					BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_14893,
						BgL_valza2za2_14890,
						((long) CINT(BgL_bpz00_17347) + BgL_siza7eza7_14889));
					{	/* Eval/evaluate_comp.scm 1095 */
						obj_t BgL_z12denvz12_17348;
						obj_t BgL_wherez00_17349;
						obj_t BgL_locz00_17350;

						BgL_z12denvz12_17348 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_wherez00_17349 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14891))->
							BgL_wherez00);
						BgL_locz00_17350 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14891))->BgL_locz00);
						{	/* Eval/evaluate_comp.scm 1095 */

							BGL_ENV_PUSH_TRACE(BgL_z12denvz12_17348, BgL_wherez00_17349,
								BgL_locz00_17350);
							{	/* Eval/evaluate_comp.scm 1095 */
								obj_t BgL_za2za2resza2za2z00_17351;

								BgL_za2za2resza2za2z00_17351 =
									PROCEDURE_ENTRY(BgL_bodyz00_14892) (BgL_bodyz00_14892,
									BgL_sz00_14893, BEOA);
								BGL_ENV_POP_TRACE(BgL_z12denvz12_17348);
								return BgL_za2za2resza2za2z00_17351;
							}
						}
					}
				}
			}
		}

	}



/* &<@anonymous:3577> */
	obj_t BGl_z62zc3z04anonymousza33577ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_14894, obj_t BgL_sz00_14898)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				BgL_ev_absz00_bglt BgL_i1247z00_14895;
				obj_t BgL_bodyz00_14896;
				long BgL_siza7ezd2framez75_14897;

				BgL_i1247z00_14895 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14894, (int) (((long) 0))));
				BgL_bodyz00_14896 = PROCEDURE_REF(BgL_envz00_14894, (int) (((long) 1)));
				BgL_siza7ezd2framez75_14897 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14894, (int) (((long) 2))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_17352;

					BgL_bpz00_17352 = VECTOR_REF(((obj_t) BgL_sz00_14898), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1174 */

						{	/* Eval/evaluate_comp.scm 1174 */
							obj_t BgL_runz00_17353;

							BgL_runz00_17353 =
								MAKE_FX_PROCEDURE(BGl_z62run5756z62zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 2)));
							PROCEDURE_SET(BgL_runz00_17353,
								(int) (((long) 0)), ((obj_t) BgL_i1247z00_14895));
							PROCEDURE_SET(BgL_runz00_17353,
								(int) (((long) 1)), BgL_bodyz00_14896);
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_mainz00_17354;

								BgL_mainz00_17354 =
									MAKE_VA_PROCEDURE(BGl_z62main5755z62zz__evaluate_compz00,
									(int) (((long) -2)), (int) (((long) 4)));
								PROCEDURE_SET(BgL_mainz00_17354,
									(int) (((long) 0)), ((obj_t) BgL_i1247z00_14895));
								PROCEDURE_SET(BgL_mainz00_17354,
									(int) (((long) 1)), BgL_bodyz00_14896);
								PROCEDURE_SET(BgL_mainz00_17354,
									(int) (((long) 2)), BgL_runz00_17353);
								PROCEDURE_SET(BgL_mainz00_17354,
									(int) (((long) 3)), BINT(BgL_siza7ezd2framez75_14897));
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_objz00_17355;

									BgL_objz00_17355 =
										BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
									PROCEDURE_ATTR_SET(BgL_runz00_17353, BgL_objz00_17355);
									BgL_objz00_17355;
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_arg3578z00_17356;

									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_arg3580z00_17357;

										BgL_arg3580z00_17357 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14895))->
											BgL_wherez00);
										{	/* Eval/evaluate_comp.scm 683 */
											obj_t BgL_newz00_17358;

											BgL_newz00_17358 =
												create_struct(BGl_symbol5824z00zz__evaluate_compz00,
												(int) (((long) 4)));
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_29973;

												BgL_tmpz00_29973 = (int) (((long) 3));
												STRUCT_SET(BgL_newz00_17358, BgL_tmpz00_29973,
													BgL_arg3580z00_17357);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_29978;
												int BgL_tmpz00_29976;

												BgL_auxz00_29978 = BINT(BgL_siza7ezd2framez75_14897);
												BgL_tmpz00_29976 = (int) (((long) 2));
												STRUCT_SET(BgL_newz00_17358, BgL_tmpz00_29976,
													BgL_auxz00_29978);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_29981;

												BgL_tmpz00_29981 = (int) (((long) 1));
												STRUCT_SET(BgL_newz00_17358, BgL_tmpz00_29981,
													BgL_runz00_17353);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_29986;
												int BgL_tmpz00_29984;

												BgL_auxz00_29986 = BINT(((long) -2));
												BgL_tmpz00_29984 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_17358, BgL_tmpz00_29984,
													BgL_auxz00_29986);
											}
											BgL_arg3578z00_17356 = BgL_newz00_17358;
									}}
									PROCEDURE_ATTR_SET(BgL_mainz00_17354, BgL_arg3578z00_17356);
									BgL_arg3578z00_17356;
								}
								return BgL_mainz00_17354;
							}
						}
					}
				}
			}
		}

	}



/* &main5755 */
	obj_t BGl_z62main5755z62zz__evaluate_compz00(obj_t BgL_envz00_14899,
		obj_t BgL_dz00_14904, obj_t BgL_lastz00_14905)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_runz00_14902;
				long BgL_siza7ezd2framez75_14903;

				BgL_runz00_14902 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14899, (int) (((long) 2))));
				BgL_siza7ezd2framez75_14903 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14899, (int) (((long) 3))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_sz00_17359;

					BgL_sz00_17359 = BGl_findzd2statezd2zz__evaluate_compz00();
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_bpz00_17360;

						BgL_bpz00_17360 = VECTOR_REF(((obj_t) BgL_sz00_17359), ((long) 0));
						if (
							(((long) CINT(BgL_bpz00_17360) + BgL_siza7ezd2framez75_14903) <
								VECTOR_LENGTH(((obj_t) BgL_sz00_17359))))
							{	/* Eval/evaluate_comp.scm 1174 */
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3584z00_17361;

									BgL_arg3584z00_17361 =
										((long) CINT(BgL_bpz00_17360) + ((long) 0));
									VECTOR_SET(
										((obj_t) BgL_sz00_17359), BgL_arg3584z00_17361,
										BgL_dz00_14904);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3585z00_17362;

									BgL_arg3585z00_17362 =
										((long) CINT(BgL_bpz00_17360) + ((long) 1));
									VECTOR_SET(
										((obj_t) BgL_sz00_17359), BgL_arg3585z00_17362,
										BgL_lastz00_14905);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_ez00_17363;

									BgL_ez00_17363 = BGL_EXITD_TOP_AS_OBJ();
									BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17363,
										BgL_bpz00_17360);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_accz00_17364;

										BgL_accz00_17364 =
											BGl_catchzd2trampolinezd2zz__evaluate_compz00
											(BgL_runz00_14902, BgL_sz00_17359, BgL_bpz00_17360);
										BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_17363);
										VECTOR_SET(
											((obj_t) BgL_sz00_17359), ((long) 0), BgL_bpz00_17360);
										return BgL_accz00_17364;
									}
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_nsz00_17365;

								BgL_nsz00_17365 = BGl_makezd2statezd2zz__evaluate_compz00();
								VECTOR_SET(BgL_nsz00_17365, ((long) 1), BgL_sz00_17359);
								VECTOR_SET(BgL_nsz00_17365, ((long) 2), BgL_dz00_14904);
								VECTOR_SET(BgL_nsz00_17365, ((long) 3), BgL_lastz00_14905);
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_z12denvz12_17366;

									BgL_z12denvz12_17366 = BGL_CURRENT_DYNAMIC_ENV();
									BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17366, BgL_nsz00_17365);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_ez00_17367;

										BgL_ez00_17367 = BGL_EXITD_TOP_AS_OBJ();
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17367,
											BgL_sz00_17359);
										{	/* Eval/evaluate_comp.scm 1174 */
											obj_t BgL_____rz00_17368;

											{	/* Eval/evaluate_comp.scm 670 */
												obj_t BgL_savedzd2bpzd2_17369;

												BgL_savedzd2bpzd2_17369 =
													VECTOR_REF(BgL_nsz00_17365, ((long) 0));
												VECTOR_SET(BgL_nsz00_17365, ((long) 0),
													BINT(((long) 2)));
												{
													obj_t BgL_fz00_17371;

													BgL_fz00_17371 = BgL_runz00_14902;
												BgL_recz00_17370:
													{	/* Eval/evaluate_comp.scm 673 */
														obj_t BgL_rz00_17372;

														BgL_rz00_17372 =
															PROCEDURE_ENTRY(BgL_fz00_17371) (BgL_fz00_17371,
															BgL_nsz00_17365, BEOA);
														{	/* Eval/evaluate_comp.scm 674 */
															bool_t BgL_test6678z00_30034;

															if (PROCEDUREP(BgL_rz00_17372))
																{	/* Eval/evaluate_comp.scm 674 */
																	obj_t BgL_arg1702z00_17373;

																	BgL_arg1702z00_17373 =
																		PROCEDURE_ATTR(BgL_rz00_17372);
																	if (STRUCTP(BgL_arg1702z00_17373))
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test6678z00_30034 =
																				(STRUCT_KEY(BgL_arg1702z00_17373) ==
																				BGl_symbol5803z00zz__evaluate_compz00);
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test6678z00_30034 = ((bool_t) 0);
																		}
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	BgL_test6678z00_30034 = ((bool_t) 0);
																}
															if (BgL_test6678z00_30034)
																{
																	obj_t BgL_fz00_30042;

																	BgL_fz00_30042 = BgL_rz00_17372;
																	BgL_fz00_17371 = BgL_fz00_30042;
																	goto BgL_recz00_17370;
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	VECTOR_SET(BgL_nsz00_17365, ((long) 0),
																		BgL_savedzd2bpzd2_17369);
																	BgL_____rz00_17368 = BgL_rz00_17372;
											}}}}}
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_ez00_17367);
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17366, BgL_sz00_17359);
											return BgL_____rz00_17368;
										}
									}
								}
							}
					}
				}
			}
		}

	}



/* &run5756 */
	obj_t BGl_z62run5756z62zz__evaluate_compz00(obj_t BgL_envz00_14906,
		obj_t BgL_sz00_14909)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				BgL_ev_absz00_bglt BgL_i1247z00_14907;
				obj_t BgL_bodyz00_14908;

				BgL_i1247z00_14907 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14906, (int) (((long) 0))));
				BgL_bodyz00_14908 = PROCEDURE_REF(BgL_envz00_14906, (int) (((long) 1)));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_17374;

					BgL_bpz00_17374 = VECTOR_REF(((obj_t) BgL_sz00_14909), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_z12denvz12_17375;
						obj_t BgL_wherez00_17376;
						obj_t BgL_locz00_17377;

						BgL_z12denvz12_17375 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_wherez00_17376 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14907))->
							BgL_wherez00);
						BgL_locz00_17377 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14907))->BgL_locz00);
						{	/* Eval/evaluate_comp.scm 1174 */

							BGL_ENV_PUSH_TRACE(BgL_z12denvz12_17375, BgL_wherez00_17376,
								BgL_locz00_17377);
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_za2za2resza2za2z00_17378;

								BgL_za2za2resza2za2z00_17378 =
									PROCEDURE_ENTRY(BgL_bodyz00_14908) (BgL_bodyz00_14908,
									BgL_sz00_14909, BEOA);
								BGL_ENV_POP_TRACE(BgL_z12denvz12_17375);
								return BgL_za2za2resza2za2z00_17378;
							}
						}
					}
				}
			}
		}

	}



/* &<@anonymous:3587> */
	obj_t BGl_z62zc3z04anonymousza33587ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_14910, obj_t BgL_sz00_14915)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_iboxesz00_14911;
				BgL_ev_absz00_bglt BgL_i1247z00_14912;
				obj_t BgL_bodyz00_14913;
				long BgL_siza7ezd2framez75_14914;

				BgL_iboxesz00_14911 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14910, (int) (((long) 0))));
				BgL_i1247z00_14912 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14910, (int) (((long) 1))));
				BgL_bodyz00_14913 = PROCEDURE_REF(BgL_envz00_14910, (int) (((long) 2)));
				BgL_siza7ezd2framez75_14914 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14910, (int) (((long) 3))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_17379;

					BgL_bpz00_17379 = VECTOR_REF(((obj_t) BgL_sz00_14915), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1174 */

						{	/* Eval/evaluate_comp.scm 1174 */
							obj_t BgL_runz00_17380;

							BgL_runz00_17380 =
								MAKE_FX_PROCEDURE(BGl_z62run5758z62zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 3)));
							PROCEDURE_SET(BgL_runz00_17380,
								(int) (((long) 0)), BgL_iboxesz00_14911);
							PROCEDURE_SET(BgL_runz00_17380,
								(int) (((long) 1)), ((obj_t) BgL_i1247z00_14912));
							PROCEDURE_SET(BgL_runz00_17380,
								(int) (((long) 2)), BgL_bodyz00_14913);
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_mainz00_17381;

								BgL_mainz00_17381 =
									MAKE_VA_PROCEDURE(BGl_z62main5757z62zz__evaluate_compz00,
									(int) (((long) -2)), (int) (((long) 5)));
								PROCEDURE_SET(BgL_mainz00_17381,
									(int) (((long) 0)), BgL_iboxesz00_14911);
								PROCEDURE_SET(BgL_mainz00_17381,
									(int) (((long) 1)), ((obj_t) BgL_i1247z00_14912));
								PROCEDURE_SET(BgL_mainz00_17381,
									(int) (((long) 2)), BgL_bodyz00_14913);
								PROCEDURE_SET(BgL_mainz00_17381,
									(int) (((long) 3)), BgL_runz00_17380);
								PROCEDURE_SET(BgL_mainz00_17381,
									(int) (((long) 4)), BINT(BgL_siza7ezd2framez75_14914));
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_objz00_17382;

									BgL_objz00_17382 =
										BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
									PROCEDURE_ATTR_SET(BgL_runz00_17380, BgL_objz00_17382);
									BgL_objz00_17382;
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_arg3589z00_17383;

									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_arg3590z00_17384;

										BgL_arg3590z00_17384 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14912))->
											BgL_wherez00);
										{	/* Eval/evaluate_comp.scm 683 */
											obj_t BgL_newz00_17385;

											BgL_newz00_17385 =
												create_struct(BGl_symbol5824z00zz__evaluate_compz00,
												(int) (((long) 4)));
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_30104;

												BgL_tmpz00_30104 = (int) (((long) 3));
												STRUCT_SET(BgL_newz00_17385, BgL_tmpz00_30104,
													BgL_arg3590z00_17384);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_30109;
												int BgL_tmpz00_30107;

												BgL_auxz00_30109 = BINT(BgL_siza7ezd2framez75_14914);
												BgL_tmpz00_30107 = (int) (((long) 2));
												STRUCT_SET(BgL_newz00_17385, BgL_tmpz00_30107,
													BgL_auxz00_30109);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_30112;

												BgL_tmpz00_30112 = (int) (((long) 1));
												STRUCT_SET(BgL_newz00_17385, BgL_tmpz00_30112,
													BgL_runz00_17380);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_30117;
												int BgL_tmpz00_30115;

												BgL_auxz00_30117 = BINT(((long) -2));
												BgL_tmpz00_30115 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_17385, BgL_tmpz00_30115,
													BgL_auxz00_30117);
											}
											BgL_arg3589z00_17383 = BgL_newz00_17385;
									}}
									PROCEDURE_ATTR_SET(BgL_mainz00_17381, BgL_arg3589z00_17383);
									BgL_arg3589z00_17383;
								}
								return BgL_mainz00_17381;
							}
						}
					}
				}
			}
		}

	}



/* &main5757 */
	obj_t BGl_z62main5757z62zz__evaluate_compz00(obj_t BgL_envz00_14916,
		obj_t BgL_dz00_14922, obj_t BgL_lastz00_14923)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_runz00_14920;
				long BgL_siza7ezd2framez75_14921;

				BgL_runz00_14920 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14916, (int) (((long) 3))));
				BgL_siza7ezd2framez75_14921 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14916, (int) (((long) 4))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_sz00_17386;

					BgL_sz00_17386 = BGl_findzd2statezd2zz__evaluate_compz00();
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_bpz00_17387;

						BgL_bpz00_17387 = VECTOR_REF(((obj_t) BgL_sz00_17386), ((long) 0));
						if (
							(((long) CINT(BgL_bpz00_17387) + BgL_siza7ezd2framez75_14921) <
								VECTOR_LENGTH(((obj_t) BgL_sz00_17386))))
							{	/* Eval/evaluate_comp.scm 1174 */
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3593z00_17388;

									BgL_arg3593z00_17388 =
										((long) CINT(BgL_bpz00_17387) + ((long) 0));
									VECTOR_SET(
										((obj_t) BgL_sz00_17386), BgL_arg3593z00_17388,
										BgL_dz00_14922);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3594z00_17389;

									BgL_arg3594z00_17389 =
										((long) CINT(BgL_bpz00_17387) + ((long) 1));
									VECTOR_SET(
										((obj_t) BgL_sz00_17386), BgL_arg3594z00_17389,
										BgL_lastz00_14923);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_ez00_17390;

									BgL_ez00_17390 = BGL_EXITD_TOP_AS_OBJ();
									BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17390,
										BgL_bpz00_17387);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_accz00_17391;

										BgL_accz00_17391 =
											BGl_catchzd2trampolinezd2zz__evaluate_compz00
											(BgL_runz00_14920, BgL_sz00_17386, BgL_bpz00_17387);
										BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_17390);
										VECTOR_SET(
											((obj_t) BgL_sz00_17386), ((long) 0), BgL_bpz00_17387);
										return BgL_accz00_17391;
									}
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_nsz00_17392;

								BgL_nsz00_17392 = BGl_makezd2statezd2zz__evaluate_compz00();
								VECTOR_SET(BgL_nsz00_17392, ((long) 1), BgL_sz00_17386);
								VECTOR_SET(BgL_nsz00_17392, ((long) 2), BgL_dz00_14922);
								VECTOR_SET(BgL_nsz00_17392, ((long) 3), BgL_lastz00_14923);
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_z12denvz12_17393;

									BgL_z12denvz12_17393 = BGL_CURRENT_DYNAMIC_ENV();
									BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17393, BgL_nsz00_17392);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_ez00_17394;

										BgL_ez00_17394 = BGL_EXITD_TOP_AS_OBJ();
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17394,
											BgL_sz00_17386);
										{	/* Eval/evaluate_comp.scm 1174 */
											obj_t BgL_____rz00_17395;

											{	/* Eval/evaluate_comp.scm 670 */
												obj_t BgL_savedzd2bpzd2_17396;

												BgL_savedzd2bpzd2_17396 =
													VECTOR_REF(BgL_nsz00_17392, ((long) 0));
												VECTOR_SET(BgL_nsz00_17392, ((long) 0),
													BINT(((long) 2)));
												{
													obj_t BgL_fz00_17398;

													BgL_fz00_17398 = BgL_runz00_14920;
												BgL_recz00_17397:
													{	/* Eval/evaluate_comp.scm 673 */
														obj_t BgL_rz00_17399;

														BgL_rz00_17399 =
															PROCEDURE_ENTRY(BgL_fz00_17398) (BgL_fz00_17398,
															BgL_nsz00_17392, BEOA);
														{	/* Eval/evaluate_comp.scm 674 */
															bool_t BgL_test6682z00_30165;

															if (PROCEDUREP(BgL_rz00_17399))
																{	/* Eval/evaluate_comp.scm 674 */
																	obj_t BgL_arg1702z00_17400;

																	BgL_arg1702z00_17400 =
																		PROCEDURE_ATTR(BgL_rz00_17399);
																	if (STRUCTP(BgL_arg1702z00_17400))
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test6682z00_30165 =
																				(STRUCT_KEY(BgL_arg1702z00_17400) ==
																				BGl_symbol5803z00zz__evaluate_compz00);
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test6682z00_30165 = ((bool_t) 0);
																		}
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	BgL_test6682z00_30165 = ((bool_t) 0);
																}
															if (BgL_test6682z00_30165)
																{
																	obj_t BgL_fz00_30173;

																	BgL_fz00_30173 = BgL_rz00_17399;
																	BgL_fz00_17398 = BgL_fz00_30173;
																	goto BgL_recz00_17397;
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	VECTOR_SET(BgL_nsz00_17392, ((long) 0),
																		BgL_savedzd2bpzd2_17396);
																	BgL_____rz00_17395 = BgL_rz00_17399;
											}}}}}
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_ez00_17394);
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17393, BgL_sz00_17386);
											return BgL_____rz00_17395;
										}
									}
								}
							}
					}
				}
			}
		}

	}



/* &run5758 */
	obj_t BGl_z62run5758z62zz__evaluate_compz00(obj_t BgL_envz00_14924,
		obj_t BgL_sz00_14928)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_iboxesz00_14925;
				BgL_ev_absz00_bglt BgL_i1247z00_14926;
				obj_t BgL_bodyz00_14927;

				BgL_iboxesz00_14925 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14924, (int) (((long) 0))));
				BgL_i1247z00_14926 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14924, (int) (((long) 1))));
				BgL_bodyz00_14927 = PROCEDURE_REF(BgL_envz00_14924, (int) (((long) 2)));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_17401;

					BgL_bpz00_17401 = VECTOR_REF(((obj_t) BgL_sz00_14928), ((long) 0));
					BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_14928,
						BgL_iboxesz00_14925, BgL_bpz00_17401);
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_z12denvz12_17402;
						obj_t BgL_wherez00_17403;
						obj_t BgL_locz00_17404;

						BgL_z12denvz12_17402 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_wherez00_17403 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14926))->
							BgL_wherez00);
						BgL_locz00_17404 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14926))->BgL_locz00);
						{	/* Eval/evaluate_comp.scm 1174 */

							BGL_ENV_PUSH_TRACE(BgL_z12denvz12_17402, BgL_wherez00_17403,
								BgL_locz00_17404);
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_za2za2resza2za2z00_17405;

								BgL_za2za2resza2za2z00_17405 =
									PROCEDURE_ENTRY(BgL_bodyz00_14927) (BgL_bodyz00_14927,
									BgL_sz00_14928, BEOA);
								BGL_ENV_POP_TRACE(BgL_z12denvz12_17402);
								return BgL_za2za2resza2za2z00_17405;
							}
						}
					}
				}
			}
		}

	}



/* &<@anonymous:3600> */
	obj_t BGl_z62zc3z04anonymousza33600ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_14929, obj_t BgL_sz00_14935)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_ifreesz00_14930;
				long BgL_siza7eza7_14931;
				BgL_ev_absz00_bglt BgL_i1247z00_14932;
				obj_t BgL_bodyz00_14933;
				long BgL_siza7ezd2framez75_14934;

				BgL_ifreesz00_14930 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14929, (int) (((long) 0))));
				BgL_siza7eza7_14931 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14929, (int) (((long) 1))));
				BgL_i1247z00_14932 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14929, (int) (((long) 2))));
				BgL_bodyz00_14933 = PROCEDURE_REF(BgL_envz00_14929, (int) (((long) 3)));
				BgL_siza7ezd2framez75_14934 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14929, (int) (((long) 4))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_17406;

					BgL_bpz00_17406 = VECTOR_REF(((obj_t) BgL_sz00_14935), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_valza2za2_17407;

						BgL_valza2za2_17407 =
							BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_14935,
							BgL_bpz00_17406, BgL_ifreesz00_14930);
						{	/* Eval/evaluate_comp.scm 1174 */
							obj_t BgL_runz00_17408;

							BgL_runz00_17408 =
								MAKE_FX_PROCEDURE(BGl_z62run5760z62zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 4)));
							PROCEDURE_SET(BgL_runz00_17408,
								(int) (((long) 0)), BINT(BgL_siza7eza7_14931));
							PROCEDURE_SET(BgL_runz00_17408,
								(int) (((long) 1)), BgL_valza2za2_17407);
							PROCEDURE_SET(BgL_runz00_17408,
								(int) (((long) 2)), ((obj_t) BgL_i1247z00_14932));
							PROCEDURE_SET(BgL_runz00_17408,
								(int) (((long) 3)), BgL_bodyz00_14933);
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_mainz00_17409;

								BgL_mainz00_17409 =
									MAKE_VA_PROCEDURE(BGl_z62main5759z62zz__evaluate_compz00,
									(int) (((long) -2)), (int) (((long) 6)));
								PROCEDURE_SET(BgL_mainz00_17409,
									(int) (((long) 0)), BINT(BgL_siza7eza7_14931));
								PROCEDURE_SET(BgL_mainz00_17409,
									(int) (((long) 1)), BgL_valza2za2_17407);
								PROCEDURE_SET(BgL_mainz00_17409,
									(int) (((long) 2)), ((obj_t) BgL_i1247z00_14932));
								PROCEDURE_SET(BgL_mainz00_17409,
									(int) (((long) 3)), BgL_bodyz00_14933);
								PROCEDURE_SET(BgL_mainz00_17409,
									(int) (((long) 4)), BgL_runz00_17408);
								PROCEDURE_SET(BgL_mainz00_17409,
									(int) (((long) 5)), BINT(BgL_siza7ezd2framez75_14934));
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_objz00_17410;

									BgL_objz00_17410 =
										BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
									PROCEDURE_ATTR_SET(BgL_runz00_17408, BgL_objz00_17410);
									BgL_objz00_17410;
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_arg3601z00_17411;

									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_arg3602z00_17412;

										BgL_arg3602z00_17412 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14932))->
											BgL_wherez00);
										{	/* Eval/evaluate_comp.scm 683 */
											obj_t BgL_newz00_17413;

											BgL_newz00_17413 =
												create_struct(BGl_symbol5824z00zz__evaluate_compz00,
												(int) (((long) 4)));
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_30249;

												BgL_tmpz00_30249 = (int) (((long) 3));
												STRUCT_SET(BgL_newz00_17413, BgL_tmpz00_30249,
													BgL_arg3602z00_17412);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_30254;
												int BgL_tmpz00_30252;

												BgL_auxz00_30254 = BINT(BgL_siza7ezd2framez75_14934);
												BgL_tmpz00_30252 = (int) (((long) 2));
												STRUCT_SET(BgL_newz00_17413, BgL_tmpz00_30252,
													BgL_auxz00_30254);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_30257;

												BgL_tmpz00_30257 = (int) (((long) 1));
												STRUCT_SET(BgL_newz00_17413, BgL_tmpz00_30257,
													BgL_runz00_17408);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_30262;
												int BgL_tmpz00_30260;

												BgL_auxz00_30262 = BINT(((long) -2));
												BgL_tmpz00_30260 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_17413, BgL_tmpz00_30260,
													BgL_auxz00_30262);
											}
											BgL_arg3601z00_17411 = BgL_newz00_17413;
									}}
									PROCEDURE_ATTR_SET(BgL_mainz00_17409, BgL_arg3601z00_17411);
									BgL_arg3601z00_17411;
								}
								return BgL_mainz00_17409;
							}
						}
					}
				}
			}
		}

	}



/* &main5759 */
	obj_t BGl_z62main5759z62zz__evaluate_compz00(obj_t BgL_envz00_14936,
		obj_t BgL_dz00_14943, obj_t BgL_lastz00_14944)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_runz00_14941;
				long BgL_siza7ezd2framez75_14942;

				BgL_runz00_14941 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14936, (int) (((long) 4))));
				BgL_siza7ezd2framez75_14942 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14936, (int) (((long) 5))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_sz00_17414;

					BgL_sz00_17414 = BGl_findzd2statezd2zz__evaluate_compz00();
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_bpz00_17415;

						BgL_bpz00_17415 = VECTOR_REF(((obj_t) BgL_sz00_17414), ((long) 0));
						if (
							(((long) CINT(BgL_bpz00_17415) + BgL_siza7ezd2framez75_14942) <
								VECTOR_LENGTH(((obj_t) BgL_sz00_17414))))
							{	/* Eval/evaluate_comp.scm 1174 */
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3605z00_17416;

									BgL_arg3605z00_17416 =
										((long) CINT(BgL_bpz00_17415) + ((long) 0));
									VECTOR_SET(
										((obj_t) BgL_sz00_17414), BgL_arg3605z00_17416,
										BgL_dz00_14943);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3606z00_17417;

									BgL_arg3606z00_17417 =
										((long) CINT(BgL_bpz00_17415) + ((long) 1));
									VECTOR_SET(
										((obj_t) BgL_sz00_17414), BgL_arg3606z00_17417,
										BgL_lastz00_14944);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_ez00_17418;

									BgL_ez00_17418 = BGL_EXITD_TOP_AS_OBJ();
									BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17418,
										BgL_bpz00_17415);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_accz00_17419;

										BgL_accz00_17419 =
											BGl_catchzd2trampolinezd2zz__evaluate_compz00
											(BgL_runz00_14941, BgL_sz00_17414, BgL_bpz00_17415);
										BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_17418);
										VECTOR_SET(
											((obj_t) BgL_sz00_17414), ((long) 0), BgL_bpz00_17415);
										return BgL_accz00_17419;
									}
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_nsz00_17420;

								BgL_nsz00_17420 = BGl_makezd2statezd2zz__evaluate_compz00();
								VECTOR_SET(BgL_nsz00_17420, ((long) 1), BgL_sz00_17414);
								VECTOR_SET(BgL_nsz00_17420, ((long) 2), BgL_dz00_14943);
								VECTOR_SET(BgL_nsz00_17420, ((long) 3), BgL_lastz00_14944);
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_z12denvz12_17421;

									BgL_z12denvz12_17421 = BGL_CURRENT_DYNAMIC_ENV();
									BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17421, BgL_nsz00_17420);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_ez00_17422;

										BgL_ez00_17422 = BGL_EXITD_TOP_AS_OBJ();
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17422,
											BgL_sz00_17414);
										{	/* Eval/evaluate_comp.scm 1174 */
											obj_t BgL_____rz00_17423;

											{	/* Eval/evaluate_comp.scm 670 */
												obj_t BgL_savedzd2bpzd2_17424;

												BgL_savedzd2bpzd2_17424 =
													VECTOR_REF(BgL_nsz00_17420, ((long) 0));
												VECTOR_SET(BgL_nsz00_17420, ((long) 0),
													BINT(((long) 2)));
												{
													obj_t BgL_fz00_17426;

													BgL_fz00_17426 = BgL_runz00_14941;
												BgL_recz00_17425:
													{	/* Eval/evaluate_comp.scm 673 */
														obj_t BgL_rz00_17427;

														BgL_rz00_17427 =
															PROCEDURE_ENTRY(BgL_fz00_17426) (BgL_fz00_17426,
															BgL_nsz00_17420, BEOA);
														{	/* Eval/evaluate_comp.scm 674 */
															bool_t BgL_test6686z00_30310;

															if (PROCEDUREP(BgL_rz00_17427))
																{	/* Eval/evaluate_comp.scm 674 */
																	obj_t BgL_arg1702z00_17428;

																	BgL_arg1702z00_17428 =
																		PROCEDURE_ATTR(BgL_rz00_17427);
																	if (STRUCTP(BgL_arg1702z00_17428))
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test6686z00_30310 =
																				(STRUCT_KEY(BgL_arg1702z00_17428) ==
																				BGl_symbol5803z00zz__evaluate_compz00);
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test6686z00_30310 = ((bool_t) 0);
																		}
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	BgL_test6686z00_30310 = ((bool_t) 0);
																}
															if (BgL_test6686z00_30310)
																{
																	obj_t BgL_fz00_30318;

																	BgL_fz00_30318 = BgL_rz00_17427;
																	BgL_fz00_17426 = BgL_fz00_30318;
																	goto BgL_recz00_17425;
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	VECTOR_SET(BgL_nsz00_17420, ((long) 0),
																		BgL_savedzd2bpzd2_17424);
																	BgL_____rz00_17423 = BgL_rz00_17427;
											}}}}}
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_ez00_17422);
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17421, BgL_sz00_17414);
											return BgL_____rz00_17423;
										}
									}
								}
							}
					}
				}
			}
		}

	}



/* &run5760 */
	obj_t BGl_z62run5760z62zz__evaluate_compz00(obj_t BgL_envz00_14945,
		obj_t BgL_sz00_14950)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				long BgL_siza7eza7_14946;
				obj_t BgL_valza2za2_14947;
				BgL_ev_absz00_bglt BgL_i1247z00_14948;
				obj_t BgL_bodyz00_14949;

				BgL_siza7eza7_14946 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14945, (int) (((long) 0))));
				BgL_valza2za2_14947 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14945, (int) (((long) 1))));
				BgL_i1247z00_14948 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14945, (int) (((long) 2))));
				BgL_bodyz00_14949 = PROCEDURE_REF(BgL_envz00_14945, (int) (((long) 3)));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_17429;

					BgL_bpz00_17429 = VECTOR_REF(((obj_t) BgL_sz00_14950), ((long) 0));
					BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_14950,
						BgL_valza2za2_14947,
						((long) CINT(BgL_bpz00_17429) + BgL_siza7eza7_14946));
					{	/* Eval/evaluate_comp.scm 1095 */
						obj_t BgL_z12denvz12_17430;
						obj_t BgL_wherez00_17431;
						obj_t BgL_locz00_17432;

						BgL_z12denvz12_17430 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_wherez00_17431 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14948))->
							BgL_wherez00);
						BgL_locz00_17432 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14948))->BgL_locz00);
						{	/* Eval/evaluate_comp.scm 1095 */

							BGL_ENV_PUSH_TRACE(BgL_z12denvz12_17430, BgL_wherez00_17431,
								BgL_locz00_17432);
							{	/* Eval/evaluate_comp.scm 1095 */
								obj_t BgL_za2za2resza2za2z00_17433;

								BgL_za2za2resza2za2z00_17433 =
									PROCEDURE_ENTRY(BgL_bodyz00_14949) (BgL_bodyz00_14949,
									BgL_sz00_14950, BEOA);
								BGL_ENV_POP_TRACE(BgL_z12denvz12_17430);
								return BgL_za2za2resza2za2z00_17433;
							}
						}
					}
				}
			}
		}

	}



/* &<@anonymous:3609> */
	obj_t BGl_z62zc3z04anonymousza33609ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_14951, obj_t BgL_sz00_14958)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_ifreesz00_14952;
				obj_t BgL_iboxesz00_14953;
				long BgL_siza7eza7_14954;
				BgL_ev_absz00_bglt BgL_i1247z00_14955;
				obj_t BgL_bodyz00_14956;
				long BgL_siza7ezd2framez75_14957;

				BgL_ifreesz00_14952 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14951, (int) (((long) 0))));
				BgL_iboxesz00_14953 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14951, (int) (((long) 1))));
				BgL_siza7eza7_14954 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14951, (int) (((long) 2))));
				BgL_i1247z00_14955 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14951, (int) (((long) 3))));
				BgL_bodyz00_14956 = PROCEDURE_REF(BgL_envz00_14951, (int) (((long) 4)));
				BgL_siza7ezd2framez75_14957 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14951, (int) (((long) 5))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_17434;

					BgL_bpz00_17434 = VECTOR_REF(((obj_t) BgL_sz00_14958), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_valza2za2_17435;

						BgL_valza2za2_17435 =
							BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_14958,
							BgL_bpz00_17434, BgL_ifreesz00_14952);
						{	/* Eval/evaluate_comp.scm 1174 */
							obj_t BgL_runz00_17436;

							BgL_runz00_17436 =
								MAKE_FX_PROCEDURE(BGl_z62run5762z62zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 5)));
							PROCEDURE_SET(BgL_runz00_17436,
								(int) (((long) 0)), BgL_iboxesz00_14953);
							PROCEDURE_SET(BgL_runz00_17436,
								(int) (((long) 1)), BINT(BgL_siza7eza7_14954));
							PROCEDURE_SET(BgL_runz00_17436,
								(int) (((long) 2)), BgL_valza2za2_17435);
							PROCEDURE_SET(BgL_runz00_17436,
								(int) (((long) 3)), ((obj_t) BgL_i1247z00_14955));
							PROCEDURE_SET(BgL_runz00_17436,
								(int) (((long) 4)), BgL_bodyz00_14956);
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_mainz00_17437;

								BgL_mainz00_17437 =
									MAKE_VA_PROCEDURE(BGl_z62main5761z62zz__evaluate_compz00,
									(int) (((long) -2)), (int) (((long) 7)));
								PROCEDURE_SET(BgL_mainz00_17437,
									(int) (((long) 0)), BgL_iboxesz00_14953);
								PROCEDURE_SET(BgL_mainz00_17437,
									(int) (((long) 1)), BINT(BgL_siza7eza7_14954));
								PROCEDURE_SET(BgL_mainz00_17437,
									(int) (((long) 2)), BgL_valza2za2_17435);
								PROCEDURE_SET(BgL_mainz00_17437,
									(int) (((long) 3)), ((obj_t) BgL_i1247z00_14955));
								PROCEDURE_SET(BgL_mainz00_17437,
									(int) (((long) 4)), BgL_bodyz00_14956);
								PROCEDURE_SET(BgL_mainz00_17437,
									(int) (((long) 5)), BgL_runz00_17436);
								PROCEDURE_SET(BgL_mainz00_17437,
									(int) (((long) 6)), BINT(BgL_siza7ezd2framez75_14957));
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_objz00_17438;

									BgL_objz00_17438 =
										BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
									PROCEDURE_ATTR_SET(BgL_runz00_17436, BgL_objz00_17438);
									BgL_objz00_17438;
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_arg3611z00_17439;

									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_arg3612z00_17440;

										BgL_arg3612z00_17440 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14955))->
											BgL_wherez00);
										{	/* Eval/evaluate_comp.scm 683 */
											obj_t BgL_newz00_17441;

											BgL_newz00_17441 =
												create_struct(BGl_symbol5824z00zz__evaluate_compz00,
												(int) (((long) 4)));
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_30406;

												BgL_tmpz00_30406 = (int) (((long) 3));
												STRUCT_SET(BgL_newz00_17441, BgL_tmpz00_30406,
													BgL_arg3612z00_17440);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_30411;
												int BgL_tmpz00_30409;

												BgL_auxz00_30411 = BINT(BgL_siza7ezd2framez75_14957);
												BgL_tmpz00_30409 = (int) (((long) 2));
												STRUCT_SET(BgL_newz00_17441, BgL_tmpz00_30409,
													BgL_auxz00_30411);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_30414;

												BgL_tmpz00_30414 = (int) (((long) 1));
												STRUCT_SET(BgL_newz00_17441, BgL_tmpz00_30414,
													BgL_runz00_17436);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_30419;
												int BgL_tmpz00_30417;

												BgL_auxz00_30419 = BINT(((long) -2));
												BgL_tmpz00_30417 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_17441, BgL_tmpz00_30417,
													BgL_auxz00_30419);
											}
											BgL_arg3611z00_17439 = BgL_newz00_17441;
									}}
									PROCEDURE_ATTR_SET(BgL_mainz00_17437, BgL_arg3611z00_17439);
									BgL_arg3611z00_17439;
								}
								return BgL_mainz00_17437;
							}
						}
					}
				}
			}
		}

	}



/* &main5761 */
	obj_t BGl_z62main5761z62zz__evaluate_compz00(obj_t BgL_envz00_14959,
		obj_t BgL_dz00_14967, obj_t BgL_lastz00_14968)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_runz00_14965;
				long BgL_siza7ezd2framez75_14966;

				BgL_runz00_14965 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14959, (int) (((long) 5))));
				BgL_siza7ezd2framez75_14966 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14959, (int) (((long) 6))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_sz00_17442;

					BgL_sz00_17442 = BGl_findzd2statezd2zz__evaluate_compz00();
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_bpz00_17443;

						BgL_bpz00_17443 = VECTOR_REF(((obj_t) BgL_sz00_17442), ((long) 0));
						if (
							(((long) CINT(BgL_bpz00_17443) + BgL_siza7ezd2framez75_14966) <
								VECTOR_LENGTH(((obj_t) BgL_sz00_17442))))
							{	/* Eval/evaluate_comp.scm 1174 */
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3615z00_17444;

									BgL_arg3615z00_17444 =
										((long) CINT(BgL_bpz00_17443) + ((long) 0));
									VECTOR_SET(
										((obj_t) BgL_sz00_17442), BgL_arg3615z00_17444,
										BgL_dz00_14967);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3617z00_17445;

									BgL_arg3617z00_17445 =
										((long) CINT(BgL_bpz00_17443) + ((long) 1));
									VECTOR_SET(
										((obj_t) BgL_sz00_17442), BgL_arg3617z00_17445,
										BgL_lastz00_14968);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_ez00_17446;

									BgL_ez00_17446 = BGL_EXITD_TOP_AS_OBJ();
									BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17446,
										BgL_bpz00_17443);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_accz00_17447;

										BgL_accz00_17447 =
											BGl_catchzd2trampolinezd2zz__evaluate_compz00
											(BgL_runz00_14965, BgL_sz00_17442, BgL_bpz00_17443);
										BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_17446);
										VECTOR_SET(
											((obj_t) BgL_sz00_17442), ((long) 0), BgL_bpz00_17443);
										return BgL_accz00_17447;
									}
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_nsz00_17448;

								BgL_nsz00_17448 = BGl_makezd2statezd2zz__evaluate_compz00();
								VECTOR_SET(BgL_nsz00_17448, ((long) 1), BgL_sz00_17442);
								VECTOR_SET(BgL_nsz00_17448, ((long) 2), BgL_dz00_14967);
								VECTOR_SET(BgL_nsz00_17448, ((long) 3), BgL_lastz00_14968);
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_z12denvz12_17449;

									BgL_z12denvz12_17449 = BGL_CURRENT_DYNAMIC_ENV();
									BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17449, BgL_nsz00_17448);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_ez00_17450;

										BgL_ez00_17450 = BGL_EXITD_TOP_AS_OBJ();
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17450,
											BgL_sz00_17442);
										{	/* Eval/evaluate_comp.scm 1174 */
											obj_t BgL_____rz00_17451;

											{	/* Eval/evaluate_comp.scm 670 */
												obj_t BgL_savedzd2bpzd2_17452;

												BgL_savedzd2bpzd2_17452 =
													VECTOR_REF(BgL_nsz00_17448, ((long) 0));
												VECTOR_SET(BgL_nsz00_17448, ((long) 0),
													BINT(((long) 2)));
												{
													obj_t BgL_fz00_17454;

													BgL_fz00_17454 = BgL_runz00_14965;
												BgL_recz00_17453:
													{	/* Eval/evaluate_comp.scm 673 */
														obj_t BgL_rz00_17455;

														BgL_rz00_17455 =
															PROCEDURE_ENTRY(BgL_fz00_17454) (BgL_fz00_17454,
															BgL_nsz00_17448, BEOA);
														{	/* Eval/evaluate_comp.scm 674 */
															bool_t BgL_test6690z00_30467;

															if (PROCEDUREP(BgL_rz00_17455))
																{	/* Eval/evaluate_comp.scm 674 */
																	obj_t BgL_arg1702z00_17456;

																	BgL_arg1702z00_17456 =
																		PROCEDURE_ATTR(BgL_rz00_17455);
																	if (STRUCTP(BgL_arg1702z00_17456))
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test6690z00_30467 =
																				(STRUCT_KEY(BgL_arg1702z00_17456) ==
																				BGl_symbol5803z00zz__evaluate_compz00);
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test6690z00_30467 = ((bool_t) 0);
																		}
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	BgL_test6690z00_30467 = ((bool_t) 0);
																}
															if (BgL_test6690z00_30467)
																{
																	obj_t BgL_fz00_30475;

																	BgL_fz00_30475 = BgL_rz00_17455;
																	BgL_fz00_17454 = BgL_fz00_30475;
																	goto BgL_recz00_17453;
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	VECTOR_SET(BgL_nsz00_17448, ((long) 0),
																		BgL_savedzd2bpzd2_17452);
																	BgL_____rz00_17451 = BgL_rz00_17455;
											}}}}}
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_ez00_17450);
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17449, BgL_sz00_17442);
											return BgL_____rz00_17451;
										}
									}
								}
							}
					}
				}
			}
		}

	}



/* &run5762 */
	obj_t BGl_z62run5762z62zz__evaluate_compz00(obj_t BgL_envz00_14969,
		obj_t BgL_sz00_14975)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_iboxesz00_14970;
				long BgL_siza7eza7_14971;
				obj_t BgL_valza2za2_14972;
				BgL_ev_absz00_bglt BgL_i1247z00_14973;
				obj_t BgL_bodyz00_14974;

				BgL_iboxesz00_14970 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14969, (int) (((long) 0))));
				BgL_siza7eza7_14971 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14969, (int) (((long) 1))));
				BgL_valza2za2_14972 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14969, (int) (((long) 2))));
				BgL_i1247z00_14973 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14969, (int) (((long) 3))));
				BgL_bodyz00_14974 = PROCEDURE_REF(BgL_envz00_14969, (int) (((long) 4)));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_17457;

					BgL_bpz00_17457 = VECTOR_REF(((obj_t) BgL_sz00_14975), ((long) 0));
					BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_14975,
						BgL_iboxesz00_14970, BgL_bpz00_17457);
					BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_14975,
						BgL_valza2za2_14972,
						((long) CINT(BgL_bpz00_17457) + BgL_siza7eza7_14971));
					{	/* Eval/evaluate_comp.scm 1095 */
						obj_t BgL_z12denvz12_17458;
						obj_t BgL_wherez00_17459;
						obj_t BgL_locz00_17460;

						BgL_z12denvz12_17458 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_wherez00_17459 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14973))->
							BgL_wherez00);
						BgL_locz00_17460 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14973))->BgL_locz00);
						{	/* Eval/evaluate_comp.scm 1095 */

							BGL_ENV_PUSH_TRACE(BgL_z12denvz12_17458, BgL_wherez00_17459,
								BgL_locz00_17460);
							{	/* Eval/evaluate_comp.scm 1095 */
								obj_t BgL_za2za2resza2za2z00_17461;

								BgL_za2za2resza2za2z00_17461 =
									PROCEDURE_ENTRY(BgL_bodyz00_14974) (BgL_bodyz00_14974,
									BgL_sz00_14975, BEOA);
								BGL_ENV_POP_TRACE(BgL_z12denvz12_17458);
								return BgL_za2za2resza2za2z00_17461;
							}
						}
					}
				}
			}
		}

	}



/* &<@anonymous:3534> */
	obj_t BGl_z62zc3z04anonymousza33534ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_14976, obj_t BgL_sz00_14980)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				BgL_ev_absz00_bglt BgL_i1247z00_14977;
				obj_t BgL_bodyz00_14978;
				long BgL_siza7ezd2framez75_14979;

				BgL_i1247z00_14977 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14976, (int) (((long) 0))));
				BgL_bodyz00_14978 = PROCEDURE_REF(BgL_envz00_14976, (int) (((long) 1)));
				BgL_siza7ezd2framez75_14979 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14976, (int) (((long) 2))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_17462;

					BgL_bpz00_17462 = VECTOR_REF(((obj_t) BgL_sz00_14980), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1174 */

						{	/* Eval/evaluate_comp.scm 1174 */
							obj_t BgL_runz00_17463;

							BgL_runz00_17463 =
								MAKE_FX_PROCEDURE(BGl_z62run5764z62zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 2)));
							PROCEDURE_SET(BgL_runz00_17463,
								(int) (((long) 0)), ((obj_t) BgL_i1247z00_14977));
							PROCEDURE_SET(BgL_runz00_17463,
								(int) (((long) 1)), BgL_bodyz00_14978);
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_mainz00_17464;

								BgL_mainz00_17464 =
									MAKE_FX_PROCEDURE(BGl_z62main5763z62zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 4)));
								PROCEDURE_SET(BgL_mainz00_17464,
									(int) (((long) 0)), ((obj_t) BgL_i1247z00_14977));
								PROCEDURE_SET(BgL_mainz00_17464,
									(int) (((long) 1)), BgL_bodyz00_14978);
								PROCEDURE_SET(BgL_mainz00_17464,
									(int) (((long) 2)), BgL_runz00_17463);
								PROCEDURE_SET(BgL_mainz00_17464,
									(int) (((long) 3)), BINT(BgL_siza7ezd2framez75_14979));
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_objz00_17465;

									BgL_objz00_17465 =
										BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
									PROCEDURE_ATTR_SET(BgL_runz00_17463, BgL_objz00_17465);
									BgL_objz00_17465;
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_arg3535z00_17466;

									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_arg3536z00_17467;

										BgL_arg3536z00_17467 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14977))->
											BgL_wherez00);
										{	/* Eval/evaluate_comp.scm 683 */
											obj_t BgL_newz00_17468;

											BgL_newz00_17468 =
												create_struct(BGl_symbol5824z00zz__evaluate_compz00,
												(int) (((long) 4)));
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_30543;

												BgL_tmpz00_30543 = (int) (((long) 3));
												STRUCT_SET(BgL_newz00_17468, BgL_tmpz00_30543,
													BgL_arg3536z00_17467);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_30548;
												int BgL_tmpz00_30546;

												BgL_auxz00_30548 = BINT(BgL_siza7ezd2framez75_14979);
												BgL_tmpz00_30546 = (int) (((long) 2));
												STRUCT_SET(BgL_newz00_17468, BgL_tmpz00_30546,
													BgL_auxz00_30548);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_30551;

												BgL_tmpz00_30551 = (int) (((long) 1));
												STRUCT_SET(BgL_newz00_17468, BgL_tmpz00_30551,
													BgL_runz00_17463);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_30556;
												int BgL_tmpz00_30554;

												BgL_auxz00_30556 = BINT(((long) 1));
												BgL_tmpz00_30554 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_17468, BgL_tmpz00_30554,
													BgL_auxz00_30556);
											}
											BgL_arg3535z00_17466 = BgL_newz00_17468;
									}}
									PROCEDURE_ATTR_SET(BgL_mainz00_17464, BgL_arg3535z00_17466);
									BgL_arg3535z00_17466;
								}
								return BgL_mainz00_17464;
							}
						}
					}
				}
			}
		}

	}



/* &main5763 */
	obj_t BGl_z62main5763z62zz__evaluate_compz00(obj_t BgL_envz00_14981,
		obj_t BgL_dz00_14986)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_runz00_14984;
				long BgL_siza7ezd2framez75_14985;

				BgL_runz00_14984 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14981, (int) (((long) 2))));
				BgL_siza7ezd2framez75_14985 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14981, (int) (((long) 3))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_sz00_17469;

					BgL_sz00_17469 = BGl_findzd2statezd2zz__evaluate_compz00();
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_bpz00_17470;

						BgL_bpz00_17470 = VECTOR_REF(((obj_t) BgL_sz00_17469), ((long) 0));
						if (
							(((long) CINT(BgL_bpz00_17470) + BgL_siza7ezd2framez75_14985) <
								VECTOR_LENGTH(((obj_t) BgL_sz00_17469))))
							{	/* Eval/evaluate_comp.scm 1174 */
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3539z00_17471;

									BgL_arg3539z00_17471 =
										((long) CINT(BgL_bpz00_17470) + ((long) 0));
									VECTOR_SET(
										((obj_t) BgL_sz00_17469), BgL_arg3539z00_17471,
										BgL_dz00_14986);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_ez00_17472;

									BgL_ez00_17472 = BGL_EXITD_TOP_AS_OBJ();
									BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17472,
										BgL_bpz00_17470);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_accz00_17473;

										BgL_accz00_17473 =
											BGl_catchzd2trampolinezd2zz__evaluate_compz00
											(BgL_runz00_14984, BgL_sz00_17469, BgL_bpz00_17470);
										BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_17472);
										VECTOR_SET(
											((obj_t) BgL_sz00_17469), ((long) 0), BgL_bpz00_17470);
										return BgL_accz00_17473;
									}
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_nsz00_17474;

								BgL_nsz00_17474 = BGl_makezd2statezd2zz__evaluate_compz00();
								VECTOR_SET(BgL_nsz00_17474, ((long) 1), BgL_sz00_17469);
								VECTOR_SET(BgL_nsz00_17474, ((long) 2), BgL_dz00_14986);
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_z12denvz12_17475;

									BgL_z12denvz12_17475 = BGL_CURRENT_DYNAMIC_ENV();
									BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17475, BgL_nsz00_17474);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_ez00_17476;

										BgL_ez00_17476 = BGL_EXITD_TOP_AS_OBJ();
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17476,
											BgL_sz00_17469);
										{	/* Eval/evaluate_comp.scm 1174 */
											obj_t BgL_____rz00_17477;

											{	/* Eval/evaluate_comp.scm 670 */
												obj_t BgL_savedzd2bpzd2_17478;

												BgL_savedzd2bpzd2_17478 =
													VECTOR_REF(BgL_nsz00_17474, ((long) 0));
												VECTOR_SET(BgL_nsz00_17474, ((long) 0),
													BINT(((long) 2)));
												{
													obj_t BgL_fz00_17480;

													BgL_fz00_17480 = BgL_runz00_14984;
												BgL_recz00_17479:
													{	/* Eval/evaluate_comp.scm 673 */
														obj_t BgL_rz00_17481;

														BgL_rz00_17481 =
															PROCEDURE_ENTRY(BgL_fz00_17480) (BgL_fz00_17480,
															BgL_nsz00_17474, BEOA);
														{	/* Eval/evaluate_comp.scm 674 */
															bool_t BgL_test6694z00_30599;

															if (PROCEDUREP(BgL_rz00_17481))
																{	/* Eval/evaluate_comp.scm 674 */
																	obj_t BgL_arg1702z00_17482;

																	BgL_arg1702z00_17482 =
																		PROCEDURE_ATTR(BgL_rz00_17481);
																	if (STRUCTP(BgL_arg1702z00_17482))
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test6694z00_30599 =
																				(STRUCT_KEY(BgL_arg1702z00_17482) ==
																				BGl_symbol5803z00zz__evaluate_compz00);
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test6694z00_30599 = ((bool_t) 0);
																		}
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	BgL_test6694z00_30599 = ((bool_t) 0);
																}
															if (BgL_test6694z00_30599)
																{
																	obj_t BgL_fz00_30607;

																	BgL_fz00_30607 = BgL_rz00_17481;
																	BgL_fz00_17480 = BgL_fz00_30607;
																	goto BgL_recz00_17479;
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	VECTOR_SET(BgL_nsz00_17474, ((long) 0),
																		BgL_savedzd2bpzd2_17478);
																	BgL_____rz00_17477 = BgL_rz00_17481;
											}}}}}
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_ez00_17476);
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17475, BgL_sz00_17469);
											return BgL_____rz00_17477;
										}
									}
								}
							}
					}
				}
			}
		}

	}



/* &run5764 */
	obj_t BGl_z62run5764z62zz__evaluate_compz00(obj_t BgL_envz00_14987,
		obj_t BgL_sz00_14990)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				BgL_ev_absz00_bglt BgL_i1247z00_14988;
				obj_t BgL_bodyz00_14989;

				BgL_i1247z00_14988 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14987, (int) (((long) 0))));
				BgL_bodyz00_14989 = PROCEDURE_REF(BgL_envz00_14987, (int) (((long) 1)));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_17483;

					BgL_bpz00_17483 = VECTOR_REF(((obj_t) BgL_sz00_14990), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_z12denvz12_17484;
						obj_t BgL_wherez00_17485;
						obj_t BgL_locz00_17486;

						BgL_z12denvz12_17484 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_wherez00_17485 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14988))->
							BgL_wherez00);
						BgL_locz00_17486 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14988))->BgL_locz00);
						{	/* Eval/evaluate_comp.scm 1174 */

							BGL_ENV_PUSH_TRACE(BgL_z12denvz12_17484, BgL_wherez00_17485,
								BgL_locz00_17486);
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_za2za2resza2za2z00_17487;

								BgL_za2za2resza2za2z00_17487 =
									PROCEDURE_ENTRY(BgL_bodyz00_14989) (BgL_bodyz00_14989,
									BgL_sz00_14990, BEOA);
								BGL_ENV_POP_TRACE(BgL_z12denvz12_17484);
								return BgL_za2za2resza2za2z00_17487;
							}
						}
					}
				}
			}
		}

	}



/* &<@anonymous:3541> */
	obj_t BGl_z62zc3z04anonymousza33541ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_14991, obj_t BgL_sz00_14996)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_iboxesz00_14992;
				BgL_ev_absz00_bglt BgL_i1247z00_14993;
				obj_t BgL_bodyz00_14994;
				long BgL_siza7ezd2framez75_14995;

				BgL_iboxesz00_14992 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14991, (int) (((long) 0))));
				BgL_i1247z00_14993 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14991, (int) (((long) 1))));
				BgL_bodyz00_14994 = PROCEDURE_REF(BgL_envz00_14991, (int) (((long) 2)));
				BgL_siza7ezd2framez75_14995 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14991, (int) (((long) 3))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_17488;

					BgL_bpz00_17488 = VECTOR_REF(((obj_t) BgL_sz00_14996), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1174 */

						{	/* Eval/evaluate_comp.scm 1174 */
							obj_t BgL_runz00_17489;

							BgL_runz00_17489 =
								MAKE_FX_PROCEDURE(BGl_z62run5766z62zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 3)));
							PROCEDURE_SET(BgL_runz00_17489,
								(int) (((long) 0)), BgL_iboxesz00_14992);
							PROCEDURE_SET(BgL_runz00_17489,
								(int) (((long) 1)), ((obj_t) BgL_i1247z00_14993));
							PROCEDURE_SET(BgL_runz00_17489,
								(int) (((long) 2)), BgL_bodyz00_14994);
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_mainz00_17490;

								BgL_mainz00_17490 =
									MAKE_FX_PROCEDURE(BGl_z62main5765z62zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 5)));
								PROCEDURE_SET(BgL_mainz00_17490,
									(int) (((long) 0)), BgL_iboxesz00_14992);
								PROCEDURE_SET(BgL_mainz00_17490,
									(int) (((long) 1)), ((obj_t) BgL_i1247z00_14993));
								PROCEDURE_SET(BgL_mainz00_17490,
									(int) (((long) 2)), BgL_bodyz00_14994);
								PROCEDURE_SET(BgL_mainz00_17490,
									(int) (((long) 3)), BgL_runz00_17489);
								PROCEDURE_SET(BgL_mainz00_17490,
									(int) (((long) 4)), BINT(BgL_siza7ezd2framez75_14995));
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_objz00_17491;

									BgL_objz00_17491 =
										BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
									PROCEDURE_ATTR_SET(BgL_runz00_17489, BgL_objz00_17491);
									BgL_objz00_17491;
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_arg3542z00_17492;

									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_arg3543z00_17493;

										BgL_arg3543z00_17493 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14993))->
											BgL_wherez00);
										{	/* Eval/evaluate_comp.scm 683 */
											obj_t BgL_newz00_17494;

											BgL_newz00_17494 =
												create_struct(BGl_symbol5824z00zz__evaluate_compz00,
												(int) (((long) 4)));
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_30669;

												BgL_tmpz00_30669 = (int) (((long) 3));
												STRUCT_SET(BgL_newz00_17494, BgL_tmpz00_30669,
													BgL_arg3543z00_17493);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_30674;
												int BgL_tmpz00_30672;

												BgL_auxz00_30674 = BINT(BgL_siza7ezd2framez75_14995);
												BgL_tmpz00_30672 = (int) (((long) 2));
												STRUCT_SET(BgL_newz00_17494, BgL_tmpz00_30672,
													BgL_auxz00_30674);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_30677;

												BgL_tmpz00_30677 = (int) (((long) 1));
												STRUCT_SET(BgL_newz00_17494, BgL_tmpz00_30677,
													BgL_runz00_17489);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_30682;
												int BgL_tmpz00_30680;

												BgL_auxz00_30682 = BINT(((long) 1));
												BgL_tmpz00_30680 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_17494, BgL_tmpz00_30680,
													BgL_auxz00_30682);
											}
											BgL_arg3542z00_17492 = BgL_newz00_17494;
									}}
									PROCEDURE_ATTR_SET(BgL_mainz00_17490, BgL_arg3542z00_17492);
									BgL_arg3542z00_17492;
								}
								return BgL_mainz00_17490;
							}
						}
					}
				}
			}
		}

	}



/* &main5765 */
	obj_t BGl_z62main5765z62zz__evaluate_compz00(obj_t BgL_envz00_14997,
		obj_t BgL_dz00_15003)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_runz00_15001;
				long BgL_siza7ezd2framez75_15002;

				BgL_runz00_15001 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14997, (int) (((long) 3))));
				BgL_siza7ezd2framez75_15002 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14997, (int) (((long) 4))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_sz00_17495;

					BgL_sz00_17495 = BGl_findzd2statezd2zz__evaluate_compz00();
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_bpz00_17496;

						BgL_bpz00_17496 = VECTOR_REF(((obj_t) BgL_sz00_17495), ((long) 0));
						if (
							(((long) CINT(BgL_bpz00_17496) + BgL_siza7ezd2framez75_15002) <
								VECTOR_LENGTH(((obj_t) BgL_sz00_17495))))
							{	/* Eval/evaluate_comp.scm 1174 */
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3547z00_17497;

									BgL_arg3547z00_17497 =
										((long) CINT(BgL_bpz00_17496) + ((long) 0));
									VECTOR_SET(
										((obj_t) BgL_sz00_17495), BgL_arg3547z00_17497,
										BgL_dz00_15003);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_ez00_17498;

									BgL_ez00_17498 = BGL_EXITD_TOP_AS_OBJ();
									BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17498,
										BgL_bpz00_17496);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_accz00_17499;

										BgL_accz00_17499 =
											BGl_catchzd2trampolinezd2zz__evaluate_compz00
											(BgL_runz00_15001, BgL_sz00_17495, BgL_bpz00_17496);
										BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_17498);
										VECTOR_SET(
											((obj_t) BgL_sz00_17495), ((long) 0), BgL_bpz00_17496);
										return BgL_accz00_17499;
									}
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_nsz00_17500;

								BgL_nsz00_17500 = BGl_makezd2statezd2zz__evaluate_compz00();
								VECTOR_SET(BgL_nsz00_17500, ((long) 1), BgL_sz00_17495);
								VECTOR_SET(BgL_nsz00_17500, ((long) 2), BgL_dz00_15003);
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_z12denvz12_17501;

									BgL_z12denvz12_17501 = BGL_CURRENT_DYNAMIC_ENV();
									BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17501, BgL_nsz00_17500);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_ez00_17502;

										BgL_ez00_17502 = BGL_EXITD_TOP_AS_OBJ();
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17502,
											BgL_sz00_17495);
										{	/* Eval/evaluate_comp.scm 1174 */
											obj_t BgL_____rz00_17503;

											{	/* Eval/evaluate_comp.scm 670 */
												obj_t BgL_savedzd2bpzd2_17504;

												BgL_savedzd2bpzd2_17504 =
													VECTOR_REF(BgL_nsz00_17500, ((long) 0));
												VECTOR_SET(BgL_nsz00_17500, ((long) 0),
													BINT(((long) 2)));
												{
													obj_t BgL_fz00_17506;

													BgL_fz00_17506 = BgL_runz00_15001;
												BgL_recz00_17505:
													{	/* Eval/evaluate_comp.scm 673 */
														obj_t BgL_rz00_17507;

														BgL_rz00_17507 =
															PROCEDURE_ENTRY(BgL_fz00_17506) (BgL_fz00_17506,
															BgL_nsz00_17500, BEOA);
														{	/* Eval/evaluate_comp.scm 674 */
															bool_t BgL_test6698z00_30725;

															if (PROCEDUREP(BgL_rz00_17507))
																{	/* Eval/evaluate_comp.scm 674 */
																	obj_t BgL_arg1702z00_17508;

																	BgL_arg1702z00_17508 =
																		PROCEDURE_ATTR(BgL_rz00_17507);
																	if (STRUCTP(BgL_arg1702z00_17508))
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test6698z00_30725 =
																				(STRUCT_KEY(BgL_arg1702z00_17508) ==
																				BGl_symbol5803z00zz__evaluate_compz00);
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test6698z00_30725 = ((bool_t) 0);
																		}
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	BgL_test6698z00_30725 = ((bool_t) 0);
																}
															if (BgL_test6698z00_30725)
																{
																	obj_t BgL_fz00_30733;

																	BgL_fz00_30733 = BgL_rz00_17507;
																	BgL_fz00_17506 = BgL_fz00_30733;
																	goto BgL_recz00_17505;
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	VECTOR_SET(BgL_nsz00_17500, ((long) 0),
																		BgL_savedzd2bpzd2_17504);
																	BgL_____rz00_17503 = BgL_rz00_17507;
											}}}}}
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_ez00_17502);
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17501, BgL_sz00_17495);
											return BgL_____rz00_17503;
										}
									}
								}
							}
					}
				}
			}
		}

	}



/* &run5766 */
	obj_t BGl_z62run5766z62zz__evaluate_compz00(obj_t BgL_envz00_15004,
		obj_t BgL_sz00_15008)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_iboxesz00_15005;
				BgL_ev_absz00_bglt BgL_i1247z00_15006;
				obj_t BgL_bodyz00_15007;

				BgL_iboxesz00_15005 =
					((obj_t) PROCEDURE_REF(BgL_envz00_15004, (int) (((long) 0))));
				BgL_i1247z00_15006 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_15004, (int) (((long) 1))));
				BgL_bodyz00_15007 = PROCEDURE_REF(BgL_envz00_15004, (int) (((long) 2)));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_17509;

					BgL_bpz00_17509 = VECTOR_REF(((obj_t) BgL_sz00_15008), ((long) 0));
					BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_15008,
						BgL_iboxesz00_15005, BgL_bpz00_17509);
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_z12denvz12_17510;
						obj_t BgL_wherez00_17511;
						obj_t BgL_locz00_17512;

						BgL_z12denvz12_17510 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_wherez00_17511 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_15006))->
							BgL_wherez00);
						BgL_locz00_17512 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_15006))->BgL_locz00);
						{	/* Eval/evaluate_comp.scm 1174 */

							BGL_ENV_PUSH_TRACE(BgL_z12denvz12_17510, BgL_wherez00_17511,
								BgL_locz00_17512);
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_za2za2resza2za2z00_17513;

								BgL_za2za2resza2za2z00_17513 =
									PROCEDURE_ENTRY(BgL_bodyz00_15007) (BgL_bodyz00_15007,
									BgL_sz00_15008, BEOA);
								BGL_ENV_POP_TRACE(BgL_z12denvz12_17510);
								return BgL_za2za2resza2za2z00_17513;
							}
						}
					}
				}
			}
		}

	}



/* &<@anonymous:3553> */
	obj_t BGl_z62zc3z04anonymousza33553ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_15009, obj_t BgL_sz00_15015)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_ifreesz00_15010;
				long BgL_siza7eza7_15011;
				BgL_ev_absz00_bglt BgL_i1247z00_15012;
				obj_t BgL_bodyz00_15013;
				long BgL_siza7ezd2framez75_15014;

				BgL_ifreesz00_15010 =
					((obj_t) PROCEDURE_REF(BgL_envz00_15009, (int) (((long) 0))));
				BgL_siza7eza7_15011 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15009, (int) (((long) 1))));
				BgL_i1247z00_15012 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_15009, (int) (((long) 2))));
				BgL_bodyz00_15013 = PROCEDURE_REF(BgL_envz00_15009, (int) (((long) 3)));
				BgL_siza7ezd2framez75_15014 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15009, (int) (((long) 4))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_17514;

					BgL_bpz00_17514 = VECTOR_REF(((obj_t) BgL_sz00_15015), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_valza2za2_17515;

						BgL_valza2za2_17515 =
							BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_15015,
							BgL_bpz00_17514, BgL_ifreesz00_15010);
						{	/* Eval/evaluate_comp.scm 1174 */
							obj_t BgL_runz00_17516;

							BgL_runz00_17516 =
								MAKE_FX_PROCEDURE(BGl_z62run5768z62zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 4)));
							PROCEDURE_SET(BgL_runz00_17516,
								(int) (((long) 0)), BINT(BgL_siza7eza7_15011));
							PROCEDURE_SET(BgL_runz00_17516,
								(int) (((long) 1)), BgL_valza2za2_17515);
							PROCEDURE_SET(BgL_runz00_17516,
								(int) (((long) 2)), ((obj_t) BgL_i1247z00_15012));
							PROCEDURE_SET(BgL_runz00_17516,
								(int) (((long) 3)), BgL_bodyz00_15013);
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_mainz00_17517;

								BgL_mainz00_17517 =
									MAKE_FX_PROCEDURE(BGl_z62main5767z62zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 6)));
								PROCEDURE_SET(BgL_mainz00_17517,
									(int) (((long) 0)), BINT(BgL_siza7eza7_15011));
								PROCEDURE_SET(BgL_mainz00_17517,
									(int) (((long) 1)), BgL_valza2za2_17515);
								PROCEDURE_SET(BgL_mainz00_17517,
									(int) (((long) 2)), ((obj_t) BgL_i1247z00_15012));
								PROCEDURE_SET(BgL_mainz00_17517,
									(int) (((long) 3)), BgL_bodyz00_15013);
								PROCEDURE_SET(BgL_mainz00_17517,
									(int) (((long) 4)), BgL_runz00_17516);
								PROCEDURE_SET(BgL_mainz00_17517,
									(int) (((long) 5)), BINT(BgL_siza7ezd2framez75_15014));
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_objz00_17518;

									BgL_objz00_17518 =
										BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
									PROCEDURE_ATTR_SET(BgL_runz00_17516, BgL_objz00_17518);
									BgL_objz00_17518;
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_arg3554z00_17519;

									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_arg3555z00_17520;

										BgL_arg3555z00_17520 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_15012))->
											BgL_wherez00);
										{	/* Eval/evaluate_comp.scm 683 */
											obj_t BgL_newz00_17521;

											BgL_newz00_17521 =
												create_struct(BGl_symbol5824z00zz__evaluate_compz00,
												(int) (((long) 4)));
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_30809;

												BgL_tmpz00_30809 = (int) (((long) 3));
												STRUCT_SET(BgL_newz00_17521, BgL_tmpz00_30809,
													BgL_arg3555z00_17520);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_30814;
												int BgL_tmpz00_30812;

												BgL_auxz00_30814 = BINT(BgL_siza7ezd2framez75_15014);
												BgL_tmpz00_30812 = (int) (((long) 2));
												STRUCT_SET(BgL_newz00_17521, BgL_tmpz00_30812,
													BgL_auxz00_30814);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_30817;

												BgL_tmpz00_30817 = (int) (((long) 1));
												STRUCT_SET(BgL_newz00_17521, BgL_tmpz00_30817,
													BgL_runz00_17516);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_30822;
												int BgL_tmpz00_30820;

												BgL_auxz00_30822 = BINT(((long) 1));
												BgL_tmpz00_30820 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_17521, BgL_tmpz00_30820,
													BgL_auxz00_30822);
											}
											BgL_arg3554z00_17519 = BgL_newz00_17521;
									}}
									PROCEDURE_ATTR_SET(BgL_mainz00_17517, BgL_arg3554z00_17519);
									BgL_arg3554z00_17519;
								}
								return BgL_mainz00_17517;
							}
						}
					}
				}
			}
		}

	}



/* &main5767 */
	obj_t BGl_z62main5767z62zz__evaluate_compz00(obj_t BgL_envz00_15016,
		obj_t BgL_dz00_15023)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_runz00_15021;
				long BgL_siza7ezd2framez75_15022;

				BgL_runz00_15021 =
					((obj_t) PROCEDURE_REF(BgL_envz00_15016, (int) (((long) 4))));
				BgL_siza7ezd2framez75_15022 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15016, (int) (((long) 5))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_sz00_17522;

					BgL_sz00_17522 = BGl_findzd2statezd2zz__evaluate_compz00();
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_bpz00_17523;

						BgL_bpz00_17523 = VECTOR_REF(((obj_t) BgL_sz00_17522), ((long) 0));
						if (
							(((long) CINT(BgL_bpz00_17523) + BgL_siza7ezd2framez75_15022) <
								VECTOR_LENGTH(((obj_t) BgL_sz00_17522))))
							{	/* Eval/evaluate_comp.scm 1174 */
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3558z00_17524;

									BgL_arg3558z00_17524 =
										((long) CINT(BgL_bpz00_17523) + ((long) 0));
									VECTOR_SET(
										((obj_t) BgL_sz00_17522), BgL_arg3558z00_17524,
										BgL_dz00_15023);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_ez00_17525;

									BgL_ez00_17525 = BGL_EXITD_TOP_AS_OBJ();
									BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17525,
										BgL_bpz00_17523);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_accz00_17526;

										BgL_accz00_17526 =
											BGl_catchzd2trampolinezd2zz__evaluate_compz00
											(BgL_runz00_15021, BgL_sz00_17522, BgL_bpz00_17523);
										BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_17525);
										VECTOR_SET(
											((obj_t) BgL_sz00_17522), ((long) 0), BgL_bpz00_17523);
										return BgL_accz00_17526;
									}
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_nsz00_17527;

								BgL_nsz00_17527 = BGl_makezd2statezd2zz__evaluate_compz00();
								VECTOR_SET(BgL_nsz00_17527, ((long) 1), BgL_sz00_17522);
								VECTOR_SET(BgL_nsz00_17527, ((long) 2), BgL_dz00_15023);
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_z12denvz12_17528;

									BgL_z12denvz12_17528 = BGL_CURRENT_DYNAMIC_ENV();
									BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17528, BgL_nsz00_17527);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_ez00_17529;

										BgL_ez00_17529 = BGL_EXITD_TOP_AS_OBJ();
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17529,
											BgL_sz00_17522);
										{	/* Eval/evaluate_comp.scm 1174 */
											obj_t BgL_____rz00_17530;

											{	/* Eval/evaluate_comp.scm 670 */
												obj_t BgL_savedzd2bpzd2_17531;

												BgL_savedzd2bpzd2_17531 =
													VECTOR_REF(BgL_nsz00_17527, ((long) 0));
												VECTOR_SET(BgL_nsz00_17527, ((long) 0),
													BINT(((long) 2)));
												{
													obj_t BgL_fz00_17533;

													BgL_fz00_17533 = BgL_runz00_15021;
												BgL_recz00_17532:
													{	/* Eval/evaluate_comp.scm 673 */
														obj_t BgL_rz00_17534;

														BgL_rz00_17534 =
															PROCEDURE_ENTRY(BgL_fz00_17533) (BgL_fz00_17533,
															BgL_nsz00_17527, BEOA);
														{	/* Eval/evaluate_comp.scm 674 */
															bool_t BgL_test6702z00_30865;

															if (PROCEDUREP(BgL_rz00_17534))
																{	/* Eval/evaluate_comp.scm 674 */
																	obj_t BgL_arg1702z00_17535;

																	BgL_arg1702z00_17535 =
																		PROCEDURE_ATTR(BgL_rz00_17534);
																	if (STRUCTP(BgL_arg1702z00_17535))
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test6702z00_30865 =
																				(STRUCT_KEY(BgL_arg1702z00_17535) ==
																				BGl_symbol5803z00zz__evaluate_compz00);
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test6702z00_30865 = ((bool_t) 0);
																		}
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	BgL_test6702z00_30865 = ((bool_t) 0);
																}
															if (BgL_test6702z00_30865)
																{
																	obj_t BgL_fz00_30873;

																	BgL_fz00_30873 = BgL_rz00_17534;
																	BgL_fz00_17533 = BgL_fz00_30873;
																	goto BgL_recz00_17532;
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	VECTOR_SET(BgL_nsz00_17527, ((long) 0),
																		BgL_savedzd2bpzd2_17531);
																	BgL_____rz00_17530 = BgL_rz00_17534;
											}}}}}
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_ez00_17529);
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17528, BgL_sz00_17522);
											return BgL_____rz00_17530;
										}
									}
								}
							}
					}
				}
			}
		}

	}



/* &run5768 */
	obj_t BGl_z62run5768z62zz__evaluate_compz00(obj_t BgL_envz00_15024,
		obj_t BgL_sz00_15029)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				long BgL_siza7eza7_15025;
				obj_t BgL_valza2za2_15026;
				BgL_ev_absz00_bglt BgL_i1247z00_15027;
				obj_t BgL_bodyz00_15028;

				BgL_siza7eza7_15025 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15024, (int) (((long) 0))));
				BgL_valza2za2_15026 =
					((obj_t) PROCEDURE_REF(BgL_envz00_15024, (int) (((long) 1))));
				BgL_i1247z00_15027 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_15024, (int) (((long) 2))));
				BgL_bodyz00_15028 = PROCEDURE_REF(BgL_envz00_15024, (int) (((long) 3)));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_17536;

					BgL_bpz00_17536 = VECTOR_REF(((obj_t) BgL_sz00_15029), ((long) 0));
					BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_15029,
						BgL_valza2za2_15026,
						((long) CINT(BgL_bpz00_17536) + BgL_siza7eza7_15025));
					{	/* Eval/evaluate_comp.scm 1095 */
						obj_t BgL_z12denvz12_17537;
						obj_t BgL_wherez00_17538;
						obj_t BgL_locz00_17539;

						BgL_z12denvz12_17537 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_wherez00_17538 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_15027))->
							BgL_wherez00);
						BgL_locz00_17539 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_15027))->BgL_locz00);
						{	/* Eval/evaluate_comp.scm 1095 */

							BGL_ENV_PUSH_TRACE(BgL_z12denvz12_17537, BgL_wherez00_17538,
								BgL_locz00_17539);
							{	/* Eval/evaluate_comp.scm 1095 */
								obj_t BgL_za2za2resza2za2z00_17540;

								BgL_za2za2resza2za2z00_17540 =
									PROCEDURE_ENTRY(BgL_bodyz00_15028) (BgL_bodyz00_15028,
									BgL_sz00_15029, BEOA);
								BGL_ENV_POP_TRACE(BgL_z12denvz12_17537);
								return BgL_za2za2resza2za2z00_17540;
							}
						}
					}
				}
			}
		}

	}



/* &<@anonymous:3561> */
	obj_t BGl_z62zc3z04anonymousza33561ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_15030, obj_t BgL_sz00_15037)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_ifreesz00_15031;
				obj_t BgL_iboxesz00_15032;
				long BgL_siza7eza7_15033;
				BgL_ev_absz00_bglt BgL_i1247z00_15034;
				obj_t BgL_bodyz00_15035;
				long BgL_siza7ezd2framez75_15036;

				BgL_ifreesz00_15031 =
					((obj_t) PROCEDURE_REF(BgL_envz00_15030, (int) (((long) 0))));
				BgL_iboxesz00_15032 =
					((obj_t) PROCEDURE_REF(BgL_envz00_15030, (int) (((long) 1))));
				BgL_siza7eza7_15033 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15030, (int) (((long) 2))));
				BgL_i1247z00_15034 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_15030, (int) (((long) 3))));
				BgL_bodyz00_15035 = PROCEDURE_REF(BgL_envz00_15030, (int) (((long) 4)));
				BgL_siza7ezd2framez75_15036 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15030, (int) (((long) 5))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_17541;

					BgL_bpz00_17541 = VECTOR_REF(((obj_t) BgL_sz00_15037), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_valza2za2_17542;

						BgL_valza2za2_17542 =
							BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_15037,
							BgL_bpz00_17541, BgL_ifreesz00_15031);
						{	/* Eval/evaluate_comp.scm 1174 */
							obj_t BgL_runz00_17543;

							BgL_runz00_17543 =
								MAKE_FX_PROCEDURE(BGl_z62run5770z62zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 5)));
							PROCEDURE_SET(BgL_runz00_17543,
								(int) (((long) 0)), BgL_iboxesz00_15032);
							PROCEDURE_SET(BgL_runz00_17543,
								(int) (((long) 1)), BINT(BgL_siza7eza7_15033));
							PROCEDURE_SET(BgL_runz00_17543,
								(int) (((long) 2)), BgL_valza2za2_17542);
							PROCEDURE_SET(BgL_runz00_17543,
								(int) (((long) 3)), ((obj_t) BgL_i1247z00_15034));
							PROCEDURE_SET(BgL_runz00_17543,
								(int) (((long) 4)), BgL_bodyz00_15035);
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_mainz00_17544;

								BgL_mainz00_17544 =
									MAKE_FX_PROCEDURE(BGl_z62main5769z62zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 7)));
								PROCEDURE_SET(BgL_mainz00_17544,
									(int) (((long) 0)), BgL_iboxesz00_15032);
								PROCEDURE_SET(BgL_mainz00_17544,
									(int) (((long) 1)), BINT(BgL_siza7eza7_15033));
								PROCEDURE_SET(BgL_mainz00_17544,
									(int) (((long) 2)), BgL_valza2za2_17542);
								PROCEDURE_SET(BgL_mainz00_17544,
									(int) (((long) 3)), ((obj_t) BgL_i1247z00_15034));
								PROCEDURE_SET(BgL_mainz00_17544,
									(int) (((long) 4)), BgL_bodyz00_15035);
								PROCEDURE_SET(BgL_mainz00_17544,
									(int) (((long) 5)), BgL_runz00_17543);
								PROCEDURE_SET(BgL_mainz00_17544,
									(int) (((long) 6)), BINT(BgL_siza7ezd2framez75_15036));
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_objz00_17545;

									BgL_objz00_17545 =
										BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
									PROCEDURE_ATTR_SET(BgL_runz00_17543, BgL_objz00_17545);
									BgL_objz00_17545;
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_arg3563z00_17546;

									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_arg3564z00_17547;

										BgL_arg3564z00_17547 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_15034))->
											BgL_wherez00);
										{	/* Eval/evaluate_comp.scm 683 */
											obj_t BgL_newz00_17548;

											BgL_newz00_17548 =
												create_struct(BGl_symbol5824z00zz__evaluate_compz00,
												(int) (((long) 4)));
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_30961;

												BgL_tmpz00_30961 = (int) (((long) 3));
												STRUCT_SET(BgL_newz00_17548, BgL_tmpz00_30961,
													BgL_arg3564z00_17547);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_30966;
												int BgL_tmpz00_30964;

												BgL_auxz00_30966 = BINT(BgL_siza7ezd2framez75_15036);
												BgL_tmpz00_30964 = (int) (((long) 2));
												STRUCT_SET(BgL_newz00_17548, BgL_tmpz00_30964,
													BgL_auxz00_30966);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_30969;

												BgL_tmpz00_30969 = (int) (((long) 1));
												STRUCT_SET(BgL_newz00_17548, BgL_tmpz00_30969,
													BgL_runz00_17543);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_30974;
												int BgL_tmpz00_30972;

												BgL_auxz00_30974 = BINT(((long) 1));
												BgL_tmpz00_30972 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_17548, BgL_tmpz00_30972,
													BgL_auxz00_30974);
											}
											BgL_arg3563z00_17546 = BgL_newz00_17548;
									}}
									PROCEDURE_ATTR_SET(BgL_mainz00_17544, BgL_arg3563z00_17546);
									BgL_arg3563z00_17546;
								}
								return BgL_mainz00_17544;
							}
						}
					}
				}
			}
		}

	}



/* &main5769 */
	obj_t BGl_z62main5769z62zz__evaluate_compz00(obj_t BgL_envz00_15038,
		obj_t BgL_dz00_15046)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_runz00_15044;
				long BgL_siza7ezd2framez75_15045;

				BgL_runz00_15044 =
					((obj_t) PROCEDURE_REF(BgL_envz00_15038, (int) (((long) 5))));
				BgL_siza7ezd2framez75_15045 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15038, (int) (((long) 6))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_sz00_17549;

					BgL_sz00_17549 = BGl_findzd2statezd2zz__evaluate_compz00();
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_bpz00_17550;

						BgL_bpz00_17550 = VECTOR_REF(((obj_t) BgL_sz00_17549), ((long) 0));
						if (
							(((long) CINT(BgL_bpz00_17550) + BgL_siza7ezd2framez75_15045) <
								VECTOR_LENGTH(((obj_t) BgL_sz00_17549))))
							{	/* Eval/evaluate_comp.scm 1174 */
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3567z00_17551;

									BgL_arg3567z00_17551 =
										((long) CINT(BgL_bpz00_17550) + ((long) 0));
									VECTOR_SET(
										((obj_t) BgL_sz00_17549), BgL_arg3567z00_17551,
										BgL_dz00_15046);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_ez00_17552;

									BgL_ez00_17552 = BGL_EXITD_TOP_AS_OBJ();
									BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17552,
										BgL_bpz00_17550);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_accz00_17553;

										BgL_accz00_17553 =
											BGl_catchzd2trampolinezd2zz__evaluate_compz00
											(BgL_runz00_15044, BgL_sz00_17549, BgL_bpz00_17550);
										BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_17552);
										VECTOR_SET(
											((obj_t) BgL_sz00_17549), ((long) 0), BgL_bpz00_17550);
										return BgL_accz00_17553;
									}
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_nsz00_17554;

								BgL_nsz00_17554 = BGl_makezd2statezd2zz__evaluate_compz00();
								VECTOR_SET(BgL_nsz00_17554, ((long) 1), BgL_sz00_17549);
								VECTOR_SET(BgL_nsz00_17554, ((long) 2), BgL_dz00_15046);
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_z12denvz12_17555;

									BgL_z12denvz12_17555 = BGL_CURRENT_DYNAMIC_ENV();
									BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17555, BgL_nsz00_17554);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_ez00_17556;

										BgL_ez00_17556 = BGL_EXITD_TOP_AS_OBJ();
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17556,
											BgL_sz00_17549);
										{	/* Eval/evaluate_comp.scm 1174 */
											obj_t BgL_____rz00_17557;

											{	/* Eval/evaluate_comp.scm 670 */
												obj_t BgL_savedzd2bpzd2_17558;

												BgL_savedzd2bpzd2_17558 =
													VECTOR_REF(BgL_nsz00_17554, ((long) 0));
												VECTOR_SET(BgL_nsz00_17554, ((long) 0),
													BINT(((long) 2)));
												{
													obj_t BgL_fz00_17560;

													BgL_fz00_17560 = BgL_runz00_15044;
												BgL_recz00_17559:
													{	/* Eval/evaluate_comp.scm 673 */
														obj_t BgL_rz00_17561;

														BgL_rz00_17561 =
															PROCEDURE_ENTRY(BgL_fz00_17560) (BgL_fz00_17560,
															BgL_nsz00_17554, BEOA);
														{	/* Eval/evaluate_comp.scm 674 */
															bool_t BgL_test6706z00_31017;

															if (PROCEDUREP(BgL_rz00_17561))
																{	/* Eval/evaluate_comp.scm 674 */
																	obj_t BgL_arg1702z00_17562;

																	BgL_arg1702z00_17562 =
																		PROCEDURE_ATTR(BgL_rz00_17561);
																	if (STRUCTP(BgL_arg1702z00_17562))
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test6706z00_31017 =
																				(STRUCT_KEY(BgL_arg1702z00_17562) ==
																				BGl_symbol5803z00zz__evaluate_compz00);
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test6706z00_31017 = ((bool_t) 0);
																		}
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	BgL_test6706z00_31017 = ((bool_t) 0);
																}
															if (BgL_test6706z00_31017)
																{
																	obj_t BgL_fz00_31025;

																	BgL_fz00_31025 = BgL_rz00_17561;
																	BgL_fz00_17560 = BgL_fz00_31025;
																	goto BgL_recz00_17559;
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	VECTOR_SET(BgL_nsz00_17554, ((long) 0),
																		BgL_savedzd2bpzd2_17558);
																	BgL_____rz00_17557 = BgL_rz00_17561;
											}}}}}
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_ez00_17556);
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17555, BgL_sz00_17549);
											return BgL_____rz00_17557;
										}
									}
								}
							}
					}
				}
			}
		}

	}



/* &run5770 */
	obj_t BGl_z62run5770z62zz__evaluate_compz00(obj_t BgL_envz00_15047,
		obj_t BgL_sz00_15053)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_iboxesz00_15048;
				long BgL_siza7eza7_15049;
				obj_t BgL_valza2za2_15050;
				BgL_ev_absz00_bglt BgL_i1247z00_15051;
				obj_t BgL_bodyz00_15052;

				BgL_iboxesz00_15048 =
					((obj_t) PROCEDURE_REF(BgL_envz00_15047, (int) (((long) 0))));
				BgL_siza7eza7_15049 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15047, (int) (((long) 1))));
				BgL_valza2za2_15050 =
					((obj_t) PROCEDURE_REF(BgL_envz00_15047, (int) (((long) 2))));
				BgL_i1247z00_15051 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_15047, (int) (((long) 3))));
				BgL_bodyz00_15052 = PROCEDURE_REF(BgL_envz00_15047, (int) (((long) 4)));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_17563;

					BgL_bpz00_17563 = VECTOR_REF(((obj_t) BgL_sz00_15053), ((long) 0));
					BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_15053,
						BgL_iboxesz00_15048, BgL_bpz00_17563);
					BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_15053,
						BgL_valza2za2_15050,
						((long) CINT(BgL_bpz00_17563) + BgL_siza7eza7_15049));
					{	/* Eval/evaluate_comp.scm 1095 */
						obj_t BgL_z12denvz12_17564;
						obj_t BgL_wherez00_17565;
						obj_t BgL_locz00_17566;

						BgL_z12denvz12_17564 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_wherez00_17565 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_15051))->
							BgL_wherez00);
						BgL_locz00_17566 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_15051))->BgL_locz00);
						{	/* Eval/evaluate_comp.scm 1095 */

							BGL_ENV_PUSH_TRACE(BgL_z12denvz12_17564, BgL_wherez00_17565,
								BgL_locz00_17566);
							{	/* Eval/evaluate_comp.scm 1095 */
								obj_t BgL_za2za2resza2za2z00_17567;

								BgL_za2za2resza2za2z00_17567 =
									PROCEDURE_ENTRY(BgL_bodyz00_15052) (BgL_bodyz00_15052,
									BgL_sz00_15053, BEOA);
								BGL_ENV_POP_TRACE(BgL_z12denvz12_17564);
								return BgL_za2za2resza2za2z00_17567;
							}
						}
					}
				}
			}
		}

	}



/* &<@anonymous:3489> */
	obj_t BGl_z62zc3z04anonymousza33489ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_15054, obj_t BgL_sz00_15058)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				BgL_ev_absz00_bglt BgL_i1247z00_15055;
				obj_t BgL_bodyz00_15056;
				long BgL_siza7ezd2framez75_15057;

				BgL_i1247z00_15055 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_15054, (int) (((long) 0))));
				BgL_bodyz00_15056 = PROCEDURE_REF(BgL_envz00_15054, (int) (((long) 1)));
				BgL_siza7ezd2framez75_15057 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15054, (int) (((long) 2))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_17568;

					BgL_bpz00_17568 = VECTOR_REF(((obj_t) BgL_sz00_15058), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1174 */

						{	/* Eval/evaluate_comp.scm 1174 */
							obj_t BgL_runz00_17569;

							BgL_runz00_17569 =
								MAKE_FX_PROCEDURE(BGl_z62run5772z62zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 2)));
							PROCEDURE_SET(BgL_runz00_17569,
								(int) (((long) 0)), ((obj_t) BgL_i1247z00_15055));
							PROCEDURE_SET(BgL_runz00_17569,
								(int) (((long) 1)), BgL_bodyz00_15056);
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_mainz00_17570;

								BgL_mainz00_17570 =
									MAKE_VA_PROCEDURE(BGl_z62main5771z62zz__evaluate_compz00,
									(int) (((long) -1)), (int) (((long) 4)));
								PROCEDURE_SET(BgL_mainz00_17570,
									(int) (((long) 0)), ((obj_t) BgL_i1247z00_15055));
								PROCEDURE_SET(BgL_mainz00_17570,
									(int) (((long) 1)), BgL_bodyz00_15056);
								PROCEDURE_SET(BgL_mainz00_17570,
									(int) (((long) 2)), BgL_runz00_17569);
								PROCEDURE_SET(BgL_mainz00_17570,
									(int) (((long) 3)), BINT(BgL_siza7ezd2framez75_15057));
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_objz00_17571;

									BgL_objz00_17571 =
										BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
									PROCEDURE_ATTR_SET(BgL_runz00_17569, BgL_objz00_17571);
									BgL_objz00_17571;
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_arg3490z00_17572;

									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_arg3491z00_17573;

										BgL_arg3491z00_17573 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_15055))->
											BgL_wherez00);
										{	/* Eval/evaluate_comp.scm 683 */
											obj_t BgL_newz00_17574;

											BgL_newz00_17574 =
												create_struct(BGl_symbol5824z00zz__evaluate_compz00,
												(int) (((long) 4)));
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_31093;

												BgL_tmpz00_31093 = (int) (((long) 3));
												STRUCT_SET(BgL_newz00_17574, BgL_tmpz00_31093,
													BgL_arg3491z00_17573);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_31098;
												int BgL_tmpz00_31096;

												BgL_auxz00_31098 = BINT(BgL_siza7ezd2framez75_15057);
												BgL_tmpz00_31096 = (int) (((long) 2));
												STRUCT_SET(BgL_newz00_17574, BgL_tmpz00_31096,
													BgL_auxz00_31098);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_31101;

												BgL_tmpz00_31101 = (int) (((long) 1));
												STRUCT_SET(BgL_newz00_17574, BgL_tmpz00_31101,
													BgL_runz00_17569);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_31106;
												int BgL_tmpz00_31104;

												BgL_auxz00_31106 = BINT(((long) -1));
												BgL_tmpz00_31104 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_17574, BgL_tmpz00_31104,
													BgL_auxz00_31106);
											}
											BgL_arg3490z00_17572 = BgL_newz00_17574;
									}}
									PROCEDURE_ATTR_SET(BgL_mainz00_17570, BgL_arg3490z00_17572);
									BgL_arg3490z00_17572;
								}
								return BgL_mainz00_17570;
							}
						}
					}
				}
			}
		}

	}



/* &main5771 */
	obj_t BGl_z62main5771z62zz__evaluate_compz00(obj_t BgL_envz00_15059,
		obj_t BgL_lastz00_15064)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_runz00_15062;
				long BgL_siza7ezd2framez75_15063;

				BgL_runz00_15062 =
					((obj_t) PROCEDURE_REF(BgL_envz00_15059, (int) (((long) 2))));
				BgL_siza7ezd2framez75_15063 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15059, (int) (((long) 3))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_sz00_17575;

					BgL_sz00_17575 = BGl_findzd2statezd2zz__evaluate_compz00();
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_bpz00_17576;

						BgL_bpz00_17576 = VECTOR_REF(((obj_t) BgL_sz00_17575), ((long) 0));
						if (
							(((long) CINT(BgL_bpz00_17576) + BgL_siza7ezd2framez75_15063) <
								VECTOR_LENGTH(((obj_t) BgL_sz00_17575))))
							{	/* Eval/evaluate_comp.scm 1174 */
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3495z00_17577;

									BgL_arg3495z00_17577 =
										((long) CINT(BgL_bpz00_17576) + ((long) 0));
									VECTOR_SET(
										((obj_t) BgL_sz00_17575), BgL_arg3495z00_17577,
										BgL_lastz00_15064);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_ez00_17578;

									BgL_ez00_17578 = BGL_EXITD_TOP_AS_OBJ();
									BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17578,
										BgL_bpz00_17576);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_accz00_17579;

										BgL_accz00_17579 =
											BGl_catchzd2trampolinezd2zz__evaluate_compz00
											(BgL_runz00_15062, BgL_sz00_17575, BgL_bpz00_17576);
										BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_17578);
										VECTOR_SET(
											((obj_t) BgL_sz00_17575), ((long) 0), BgL_bpz00_17576);
										return BgL_accz00_17579;
									}
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_nsz00_17580;

								BgL_nsz00_17580 = BGl_makezd2statezd2zz__evaluate_compz00();
								VECTOR_SET(BgL_nsz00_17580, ((long) 1), BgL_sz00_17575);
								VECTOR_SET(BgL_nsz00_17580, ((long) 2), BgL_lastz00_15064);
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_z12denvz12_17581;

									BgL_z12denvz12_17581 = BGL_CURRENT_DYNAMIC_ENV();
									BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17581, BgL_nsz00_17580);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_ez00_17582;

										BgL_ez00_17582 = BGL_EXITD_TOP_AS_OBJ();
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17582,
											BgL_sz00_17575);
										{	/* Eval/evaluate_comp.scm 1174 */
											obj_t BgL_____rz00_17583;

											{	/* Eval/evaluate_comp.scm 670 */
												obj_t BgL_savedzd2bpzd2_17584;

												BgL_savedzd2bpzd2_17584 =
													VECTOR_REF(BgL_nsz00_17580, ((long) 0));
												VECTOR_SET(BgL_nsz00_17580, ((long) 0),
													BINT(((long) 2)));
												{
													obj_t BgL_fz00_17586;

													BgL_fz00_17586 = BgL_runz00_15062;
												BgL_recz00_17585:
													{	/* Eval/evaluate_comp.scm 673 */
														obj_t BgL_rz00_17587;

														BgL_rz00_17587 =
															PROCEDURE_ENTRY(BgL_fz00_17586) (BgL_fz00_17586,
															BgL_nsz00_17580, BEOA);
														{	/* Eval/evaluate_comp.scm 674 */
															bool_t BgL_test6710z00_31149;

															if (PROCEDUREP(BgL_rz00_17587))
																{	/* Eval/evaluate_comp.scm 674 */
																	obj_t BgL_arg1702z00_17588;

																	BgL_arg1702z00_17588 =
																		PROCEDURE_ATTR(BgL_rz00_17587);
																	if (STRUCTP(BgL_arg1702z00_17588))
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test6710z00_31149 =
																				(STRUCT_KEY(BgL_arg1702z00_17588) ==
																				BGl_symbol5803z00zz__evaluate_compz00);
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test6710z00_31149 = ((bool_t) 0);
																		}
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	BgL_test6710z00_31149 = ((bool_t) 0);
																}
															if (BgL_test6710z00_31149)
																{
																	obj_t BgL_fz00_31157;

																	BgL_fz00_31157 = BgL_rz00_17587;
																	BgL_fz00_17586 = BgL_fz00_31157;
																	goto BgL_recz00_17585;
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	VECTOR_SET(BgL_nsz00_17580, ((long) 0),
																		BgL_savedzd2bpzd2_17584);
																	BgL_____rz00_17583 = BgL_rz00_17587;
											}}}}}
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_ez00_17582);
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17581, BgL_sz00_17575);
											return BgL_____rz00_17583;
										}
									}
								}
							}
					}
				}
			}
		}

	}



/* &run5772 */
	obj_t BGl_z62run5772z62zz__evaluate_compz00(obj_t BgL_envz00_15065,
		obj_t BgL_sz00_15068)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				BgL_ev_absz00_bglt BgL_i1247z00_15066;
				obj_t BgL_bodyz00_15067;

				BgL_i1247z00_15066 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_15065, (int) (((long) 0))));
				BgL_bodyz00_15067 = PROCEDURE_REF(BgL_envz00_15065, (int) (((long) 1)));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_17589;

					BgL_bpz00_17589 = VECTOR_REF(((obj_t) BgL_sz00_15068), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_z12denvz12_17590;
						obj_t BgL_wherez00_17591;
						obj_t BgL_locz00_17592;

						BgL_z12denvz12_17590 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_wherez00_17591 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_15066))->
							BgL_wherez00);
						BgL_locz00_17592 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_15066))->BgL_locz00);
						{	/* Eval/evaluate_comp.scm 1174 */

							BGL_ENV_PUSH_TRACE(BgL_z12denvz12_17590, BgL_wherez00_17591,
								BgL_locz00_17592);
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_za2za2resza2za2z00_17593;

								BgL_za2za2resza2za2z00_17593 =
									PROCEDURE_ENTRY(BgL_bodyz00_15067) (BgL_bodyz00_15067,
									BgL_sz00_15068, BEOA);
								BGL_ENV_POP_TRACE(BgL_z12denvz12_17590);
								return BgL_za2za2resza2za2z00_17593;
							}
						}
					}
				}
			}
		}

	}



/* &<@anonymous:3497> */
	obj_t BGl_z62zc3z04anonymousza33497ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_15069, obj_t BgL_sz00_15074)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_iboxesz00_15070;
				BgL_ev_absz00_bglt BgL_i1247z00_15071;
				obj_t BgL_bodyz00_15072;
				long BgL_siza7ezd2framez75_15073;

				BgL_iboxesz00_15070 =
					((obj_t) PROCEDURE_REF(BgL_envz00_15069, (int) (((long) 0))));
				BgL_i1247z00_15071 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_15069, (int) (((long) 1))));
				BgL_bodyz00_15072 = PROCEDURE_REF(BgL_envz00_15069, (int) (((long) 2)));
				BgL_siza7ezd2framez75_15073 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15069, (int) (((long) 3))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_17594;

					BgL_bpz00_17594 = VECTOR_REF(((obj_t) BgL_sz00_15074), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1174 */

						{	/* Eval/evaluate_comp.scm 1174 */
							obj_t BgL_runz00_17595;

							BgL_runz00_17595 =
								MAKE_FX_PROCEDURE(BGl_z62run5774z62zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 3)));
							PROCEDURE_SET(BgL_runz00_17595,
								(int) (((long) 0)), BgL_iboxesz00_15070);
							PROCEDURE_SET(BgL_runz00_17595,
								(int) (((long) 1)), ((obj_t) BgL_i1247z00_15071));
							PROCEDURE_SET(BgL_runz00_17595,
								(int) (((long) 2)), BgL_bodyz00_15072);
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_mainz00_17596;

								BgL_mainz00_17596 =
									MAKE_VA_PROCEDURE(BGl_z62main5773z62zz__evaluate_compz00,
									(int) (((long) -1)), (int) (((long) 5)));
								PROCEDURE_SET(BgL_mainz00_17596,
									(int) (((long) 0)), BgL_iboxesz00_15070);
								PROCEDURE_SET(BgL_mainz00_17596,
									(int) (((long) 1)), ((obj_t) BgL_i1247z00_15071));
								PROCEDURE_SET(BgL_mainz00_17596,
									(int) (((long) 2)), BgL_bodyz00_15072);
								PROCEDURE_SET(BgL_mainz00_17596,
									(int) (((long) 3)), BgL_runz00_17595);
								PROCEDURE_SET(BgL_mainz00_17596,
									(int) (((long) 4)), BINT(BgL_siza7ezd2framez75_15073));
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_objz00_17597;

									BgL_objz00_17597 =
										BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
									PROCEDURE_ATTR_SET(BgL_runz00_17595, BgL_objz00_17597);
									BgL_objz00_17597;
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_arg3498z00_17598;

									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_arg3500z00_17599;

										BgL_arg3500z00_17599 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_15071))->
											BgL_wherez00);
										{	/* Eval/evaluate_comp.scm 683 */
											obj_t BgL_newz00_17600;

											BgL_newz00_17600 =
												create_struct(BGl_symbol5824z00zz__evaluate_compz00,
												(int) (((long) 4)));
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_31219;

												BgL_tmpz00_31219 = (int) (((long) 3));
												STRUCT_SET(BgL_newz00_17600, BgL_tmpz00_31219,
													BgL_arg3500z00_17599);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_31224;
												int BgL_tmpz00_31222;

												BgL_auxz00_31224 = BINT(BgL_siza7ezd2framez75_15073);
												BgL_tmpz00_31222 = (int) (((long) 2));
												STRUCT_SET(BgL_newz00_17600, BgL_tmpz00_31222,
													BgL_auxz00_31224);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_31227;

												BgL_tmpz00_31227 = (int) (((long) 1));
												STRUCT_SET(BgL_newz00_17600, BgL_tmpz00_31227,
													BgL_runz00_17595);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_31232;
												int BgL_tmpz00_31230;

												BgL_auxz00_31232 = BINT(((long) -1));
												BgL_tmpz00_31230 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_17600, BgL_tmpz00_31230,
													BgL_auxz00_31232);
											}
											BgL_arg3498z00_17598 = BgL_newz00_17600;
									}}
									PROCEDURE_ATTR_SET(BgL_mainz00_17596, BgL_arg3498z00_17598);
									BgL_arg3498z00_17598;
								}
								return BgL_mainz00_17596;
							}
						}
					}
				}
			}
		}

	}



/* &main5773 */
	obj_t BGl_z62main5773z62zz__evaluate_compz00(obj_t BgL_envz00_15075,
		obj_t BgL_lastz00_15081)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_runz00_15079;
				long BgL_siza7ezd2framez75_15080;

				BgL_runz00_15079 =
					((obj_t) PROCEDURE_REF(BgL_envz00_15075, (int) (((long) 3))));
				BgL_siza7ezd2framez75_15080 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15075, (int) (((long) 4))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_sz00_17601;

					BgL_sz00_17601 = BGl_findzd2statezd2zz__evaluate_compz00();
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_bpz00_17602;

						BgL_bpz00_17602 = VECTOR_REF(((obj_t) BgL_sz00_17601), ((long) 0));
						if (
							(((long) CINT(BgL_bpz00_17602) + BgL_siza7ezd2framez75_15080) <
								VECTOR_LENGTH(((obj_t) BgL_sz00_17601))))
							{	/* Eval/evaluate_comp.scm 1174 */
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3504z00_17603;

									BgL_arg3504z00_17603 =
										((long) CINT(BgL_bpz00_17602) + ((long) 0));
									VECTOR_SET(
										((obj_t) BgL_sz00_17601), BgL_arg3504z00_17603,
										BgL_lastz00_15081);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_ez00_17604;

									BgL_ez00_17604 = BGL_EXITD_TOP_AS_OBJ();
									BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17604,
										BgL_bpz00_17602);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_accz00_17605;

										BgL_accz00_17605 =
											BGl_catchzd2trampolinezd2zz__evaluate_compz00
											(BgL_runz00_15079, BgL_sz00_17601, BgL_bpz00_17602);
										BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_17604);
										VECTOR_SET(
											((obj_t) BgL_sz00_17601), ((long) 0), BgL_bpz00_17602);
										return BgL_accz00_17605;
									}
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_nsz00_17606;

								BgL_nsz00_17606 = BGl_makezd2statezd2zz__evaluate_compz00();
								VECTOR_SET(BgL_nsz00_17606, ((long) 1), BgL_sz00_17601);
								VECTOR_SET(BgL_nsz00_17606, ((long) 2), BgL_lastz00_15081);
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_z12denvz12_17607;

									BgL_z12denvz12_17607 = BGL_CURRENT_DYNAMIC_ENV();
									BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17607, BgL_nsz00_17606);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_ez00_17608;

										BgL_ez00_17608 = BGL_EXITD_TOP_AS_OBJ();
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17608,
											BgL_sz00_17601);
										{	/* Eval/evaluate_comp.scm 1174 */
											obj_t BgL_____rz00_17609;

											{	/* Eval/evaluate_comp.scm 670 */
												obj_t BgL_savedzd2bpzd2_17610;

												BgL_savedzd2bpzd2_17610 =
													VECTOR_REF(BgL_nsz00_17606, ((long) 0));
												VECTOR_SET(BgL_nsz00_17606, ((long) 0),
													BINT(((long) 2)));
												{
													obj_t BgL_fz00_17612;

													BgL_fz00_17612 = BgL_runz00_15079;
												BgL_recz00_17611:
													{	/* Eval/evaluate_comp.scm 673 */
														obj_t BgL_rz00_17613;

														BgL_rz00_17613 =
															PROCEDURE_ENTRY(BgL_fz00_17612) (BgL_fz00_17612,
															BgL_nsz00_17606, BEOA);
														{	/* Eval/evaluate_comp.scm 674 */
															bool_t BgL_test6714z00_31275;

															if (PROCEDUREP(BgL_rz00_17613))
																{	/* Eval/evaluate_comp.scm 674 */
																	obj_t BgL_arg1702z00_17614;

																	BgL_arg1702z00_17614 =
																		PROCEDURE_ATTR(BgL_rz00_17613);
																	if (STRUCTP(BgL_arg1702z00_17614))
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test6714z00_31275 =
																				(STRUCT_KEY(BgL_arg1702z00_17614) ==
																				BGl_symbol5803z00zz__evaluate_compz00);
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test6714z00_31275 = ((bool_t) 0);
																		}
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	BgL_test6714z00_31275 = ((bool_t) 0);
																}
															if (BgL_test6714z00_31275)
																{
																	obj_t BgL_fz00_31283;

																	BgL_fz00_31283 = BgL_rz00_17613;
																	BgL_fz00_17612 = BgL_fz00_31283;
																	goto BgL_recz00_17611;
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	VECTOR_SET(BgL_nsz00_17606, ((long) 0),
																		BgL_savedzd2bpzd2_17610);
																	BgL_____rz00_17609 = BgL_rz00_17613;
											}}}}}
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_ez00_17608);
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17607, BgL_sz00_17601);
											return BgL_____rz00_17609;
										}
									}
								}
							}
					}
				}
			}
		}

	}



/* &run5774 */
	obj_t BGl_z62run5774z62zz__evaluate_compz00(obj_t BgL_envz00_15082,
		obj_t BgL_sz00_15086)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_iboxesz00_15083;
				BgL_ev_absz00_bglt BgL_i1247z00_15084;
				obj_t BgL_bodyz00_15085;

				BgL_iboxesz00_15083 =
					((obj_t) PROCEDURE_REF(BgL_envz00_15082, (int) (((long) 0))));
				BgL_i1247z00_15084 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_15082, (int) (((long) 1))));
				BgL_bodyz00_15085 = PROCEDURE_REF(BgL_envz00_15082, (int) (((long) 2)));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_17615;

					BgL_bpz00_17615 = VECTOR_REF(((obj_t) BgL_sz00_15086), ((long) 0));
					BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_15086,
						BgL_iboxesz00_15083, BgL_bpz00_17615);
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_z12denvz12_17616;
						obj_t BgL_wherez00_17617;
						obj_t BgL_locz00_17618;

						BgL_z12denvz12_17616 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_wherez00_17617 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_15084))->
							BgL_wherez00);
						BgL_locz00_17618 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_15084))->BgL_locz00);
						{	/* Eval/evaluate_comp.scm 1174 */

							BGL_ENV_PUSH_TRACE(BgL_z12denvz12_17616, BgL_wherez00_17617,
								BgL_locz00_17618);
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_za2za2resza2za2z00_17619;

								BgL_za2za2resza2za2z00_17619 =
									PROCEDURE_ENTRY(BgL_bodyz00_15085) (BgL_bodyz00_15085,
									BgL_sz00_15086, BEOA);
								BGL_ENV_POP_TRACE(BgL_z12denvz12_17616);
								return BgL_za2za2resza2za2z00_17619;
							}
						}
					}
				}
			}
		}

	}



/* &<@anonymous:3509> */
	obj_t BGl_z62zc3z04anonymousza33509ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_15087, obj_t BgL_sz00_15093)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_ifreesz00_15088;
				long BgL_siza7eza7_15089;
				BgL_ev_absz00_bglt BgL_i1247z00_15090;
				obj_t BgL_bodyz00_15091;
				long BgL_siza7ezd2framez75_15092;

				BgL_ifreesz00_15088 =
					((obj_t) PROCEDURE_REF(BgL_envz00_15087, (int) (((long) 0))));
				BgL_siza7eza7_15089 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15087, (int) (((long) 1))));
				BgL_i1247z00_15090 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_15087, (int) (((long) 2))));
				BgL_bodyz00_15091 = PROCEDURE_REF(BgL_envz00_15087, (int) (((long) 3)));
				BgL_siza7ezd2framez75_15092 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15087, (int) (((long) 4))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_17620;

					BgL_bpz00_17620 = VECTOR_REF(((obj_t) BgL_sz00_15093), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_valza2za2_17621;

						BgL_valza2za2_17621 =
							BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_15093,
							BgL_bpz00_17620, BgL_ifreesz00_15088);
						{	/* Eval/evaluate_comp.scm 1174 */
							obj_t BgL_runz00_17622;

							BgL_runz00_17622 =
								MAKE_FX_PROCEDURE(BGl_z62run5776z62zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 4)));
							PROCEDURE_SET(BgL_runz00_17622,
								(int) (((long) 0)), BINT(BgL_siza7eza7_15089));
							PROCEDURE_SET(BgL_runz00_17622,
								(int) (((long) 1)), BgL_valza2za2_17621);
							PROCEDURE_SET(BgL_runz00_17622,
								(int) (((long) 2)), ((obj_t) BgL_i1247z00_15090));
							PROCEDURE_SET(BgL_runz00_17622,
								(int) (((long) 3)), BgL_bodyz00_15091);
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_mainz00_17623;

								BgL_mainz00_17623 =
									MAKE_VA_PROCEDURE(BGl_z62main5775z62zz__evaluate_compz00,
									(int) (((long) -1)), (int) (((long) 6)));
								PROCEDURE_SET(BgL_mainz00_17623,
									(int) (((long) 0)), BINT(BgL_siza7eza7_15089));
								PROCEDURE_SET(BgL_mainz00_17623,
									(int) (((long) 1)), BgL_valza2za2_17621);
								PROCEDURE_SET(BgL_mainz00_17623,
									(int) (((long) 2)), ((obj_t) BgL_i1247z00_15090));
								PROCEDURE_SET(BgL_mainz00_17623,
									(int) (((long) 3)), BgL_bodyz00_15091);
								PROCEDURE_SET(BgL_mainz00_17623,
									(int) (((long) 4)), BgL_runz00_17622);
								PROCEDURE_SET(BgL_mainz00_17623,
									(int) (((long) 5)), BINT(BgL_siza7ezd2framez75_15092));
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_objz00_17624;

									BgL_objz00_17624 =
										BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
									PROCEDURE_ATTR_SET(BgL_runz00_17622, BgL_objz00_17624);
									BgL_objz00_17624;
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_arg3510z00_17625;

									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_arg3512z00_17626;

										BgL_arg3512z00_17626 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_15090))->
											BgL_wherez00);
										{	/* Eval/evaluate_comp.scm 683 */
											obj_t BgL_newz00_17627;

											BgL_newz00_17627 =
												create_struct(BGl_symbol5824z00zz__evaluate_compz00,
												(int) (((long) 4)));
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_31359;

												BgL_tmpz00_31359 = (int) (((long) 3));
												STRUCT_SET(BgL_newz00_17627, BgL_tmpz00_31359,
													BgL_arg3512z00_17626);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_31364;
												int BgL_tmpz00_31362;

												BgL_auxz00_31364 = BINT(BgL_siza7ezd2framez75_15092);
												BgL_tmpz00_31362 = (int) (((long) 2));
												STRUCT_SET(BgL_newz00_17627, BgL_tmpz00_31362,
													BgL_auxz00_31364);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_31367;

												BgL_tmpz00_31367 = (int) (((long) 1));
												STRUCT_SET(BgL_newz00_17627, BgL_tmpz00_31367,
													BgL_runz00_17622);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_31372;
												int BgL_tmpz00_31370;

												BgL_auxz00_31372 = BINT(((long) -1));
												BgL_tmpz00_31370 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_17627, BgL_tmpz00_31370,
													BgL_auxz00_31372);
											}
											BgL_arg3510z00_17625 = BgL_newz00_17627;
									}}
									PROCEDURE_ATTR_SET(BgL_mainz00_17623, BgL_arg3510z00_17625);
									BgL_arg3510z00_17625;
								}
								return BgL_mainz00_17623;
							}
						}
					}
				}
			}
		}

	}



/* &main5775 */
	obj_t BGl_z62main5775z62zz__evaluate_compz00(obj_t BgL_envz00_15094,
		obj_t BgL_lastz00_15101)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_runz00_15099;
				long BgL_siza7ezd2framez75_15100;

				BgL_runz00_15099 =
					((obj_t) PROCEDURE_REF(BgL_envz00_15094, (int) (((long) 4))));
				BgL_siza7ezd2framez75_15100 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15094, (int) (((long) 5))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_sz00_17628;

					BgL_sz00_17628 = BGl_findzd2statezd2zz__evaluate_compz00();
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_bpz00_17629;

						BgL_bpz00_17629 = VECTOR_REF(((obj_t) BgL_sz00_17628), ((long) 0));
						if (
							(((long) CINT(BgL_bpz00_17629) + BgL_siza7ezd2framez75_15100) <
								VECTOR_LENGTH(((obj_t) BgL_sz00_17628))))
							{	/* Eval/evaluate_comp.scm 1174 */
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3515z00_17630;

									BgL_arg3515z00_17630 =
										((long) CINT(BgL_bpz00_17629) + ((long) 0));
									VECTOR_SET(
										((obj_t) BgL_sz00_17628), BgL_arg3515z00_17630,
										BgL_lastz00_15101);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_ez00_17631;

									BgL_ez00_17631 = BGL_EXITD_TOP_AS_OBJ();
									BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17631,
										BgL_bpz00_17629);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_accz00_17632;

										BgL_accz00_17632 =
											BGl_catchzd2trampolinezd2zz__evaluate_compz00
											(BgL_runz00_15099, BgL_sz00_17628, BgL_bpz00_17629);
										BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_17631);
										VECTOR_SET(
											((obj_t) BgL_sz00_17628), ((long) 0), BgL_bpz00_17629);
										return BgL_accz00_17632;
									}
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_nsz00_17633;

								BgL_nsz00_17633 = BGl_makezd2statezd2zz__evaluate_compz00();
								VECTOR_SET(BgL_nsz00_17633, ((long) 1), BgL_sz00_17628);
								VECTOR_SET(BgL_nsz00_17633, ((long) 2), BgL_lastz00_15101);
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_z12denvz12_17634;

									BgL_z12denvz12_17634 = BGL_CURRENT_DYNAMIC_ENV();
									BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17634, BgL_nsz00_17633);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_ez00_17635;

										BgL_ez00_17635 = BGL_EXITD_TOP_AS_OBJ();
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17635,
											BgL_sz00_17628);
										{	/* Eval/evaluate_comp.scm 1174 */
											obj_t BgL_____rz00_17636;

											{	/* Eval/evaluate_comp.scm 670 */
												obj_t BgL_savedzd2bpzd2_17637;

												BgL_savedzd2bpzd2_17637 =
													VECTOR_REF(BgL_nsz00_17633, ((long) 0));
												VECTOR_SET(BgL_nsz00_17633, ((long) 0),
													BINT(((long) 2)));
												{
													obj_t BgL_fz00_17639;

													BgL_fz00_17639 = BgL_runz00_15099;
												BgL_recz00_17638:
													{	/* Eval/evaluate_comp.scm 673 */
														obj_t BgL_rz00_17640;

														BgL_rz00_17640 =
															PROCEDURE_ENTRY(BgL_fz00_17639) (BgL_fz00_17639,
															BgL_nsz00_17633, BEOA);
														{	/* Eval/evaluate_comp.scm 674 */
															bool_t BgL_test6718z00_31415;

															if (PROCEDUREP(BgL_rz00_17640))
																{	/* Eval/evaluate_comp.scm 674 */
																	obj_t BgL_arg1702z00_17641;

																	BgL_arg1702z00_17641 =
																		PROCEDURE_ATTR(BgL_rz00_17640);
																	if (STRUCTP(BgL_arg1702z00_17641))
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test6718z00_31415 =
																				(STRUCT_KEY(BgL_arg1702z00_17641) ==
																				BGl_symbol5803z00zz__evaluate_compz00);
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test6718z00_31415 = ((bool_t) 0);
																		}
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	BgL_test6718z00_31415 = ((bool_t) 0);
																}
															if (BgL_test6718z00_31415)
																{
																	obj_t BgL_fz00_31423;

																	BgL_fz00_31423 = BgL_rz00_17640;
																	BgL_fz00_17639 = BgL_fz00_31423;
																	goto BgL_recz00_17638;
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	VECTOR_SET(BgL_nsz00_17633, ((long) 0),
																		BgL_savedzd2bpzd2_17637);
																	BgL_____rz00_17636 = BgL_rz00_17640;
											}}}}}
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_ez00_17635);
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17634, BgL_sz00_17628);
											return BgL_____rz00_17636;
										}
									}
								}
							}
					}
				}
			}
		}

	}



/* &run5776 */
	obj_t BGl_z62run5776z62zz__evaluate_compz00(obj_t BgL_envz00_15102,
		obj_t BgL_sz00_15107)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				long BgL_siza7eza7_15103;
				obj_t BgL_valza2za2_15104;
				BgL_ev_absz00_bglt BgL_i1247z00_15105;
				obj_t BgL_bodyz00_15106;

				BgL_siza7eza7_15103 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15102, (int) (((long) 0))));
				BgL_valza2za2_15104 =
					((obj_t) PROCEDURE_REF(BgL_envz00_15102, (int) (((long) 1))));
				BgL_i1247z00_15105 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_15102, (int) (((long) 2))));
				BgL_bodyz00_15106 = PROCEDURE_REF(BgL_envz00_15102, (int) (((long) 3)));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_17642;

					BgL_bpz00_17642 = VECTOR_REF(((obj_t) BgL_sz00_15107), ((long) 0));
					BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_15107,
						BgL_valza2za2_15104,
						((long) CINT(BgL_bpz00_17642) + BgL_siza7eza7_15103));
					{	/* Eval/evaluate_comp.scm 1095 */
						obj_t BgL_z12denvz12_17643;
						obj_t BgL_wherez00_17644;
						obj_t BgL_locz00_17645;

						BgL_z12denvz12_17643 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_wherez00_17644 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_15105))->
							BgL_wherez00);
						BgL_locz00_17645 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_15105))->BgL_locz00);
						{	/* Eval/evaluate_comp.scm 1095 */

							BGL_ENV_PUSH_TRACE(BgL_z12denvz12_17643, BgL_wherez00_17644,
								BgL_locz00_17645);
							{	/* Eval/evaluate_comp.scm 1095 */
								obj_t BgL_za2za2resza2za2z00_17646;

								BgL_za2za2resza2za2z00_17646 =
									PROCEDURE_ENTRY(BgL_bodyz00_15106) (BgL_bodyz00_15106,
									BgL_sz00_15107, BEOA);
								BGL_ENV_POP_TRACE(BgL_z12denvz12_17643);
								return BgL_za2za2resza2za2z00_17646;
							}
						}
					}
				}
			}
		}

	}



/* &<@anonymous:3519> */
	obj_t BGl_z62zc3z04anonymousza33519ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_15108, obj_t BgL_sz00_15115)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_ifreesz00_15109;
				obj_t BgL_iboxesz00_15110;
				long BgL_siza7eza7_15111;
				BgL_ev_absz00_bglt BgL_i1247z00_15112;
				obj_t BgL_bodyz00_15113;
				long BgL_siza7ezd2framez75_15114;

				BgL_ifreesz00_15109 =
					((obj_t) PROCEDURE_REF(BgL_envz00_15108, (int) (((long) 0))));
				BgL_iboxesz00_15110 =
					((obj_t) PROCEDURE_REF(BgL_envz00_15108, (int) (((long) 1))));
				BgL_siza7eza7_15111 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15108, (int) (((long) 2))));
				BgL_i1247z00_15112 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_15108, (int) (((long) 3))));
				BgL_bodyz00_15113 = PROCEDURE_REF(BgL_envz00_15108, (int) (((long) 4)));
				BgL_siza7ezd2framez75_15114 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15108, (int) (((long) 5))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_17647;

					BgL_bpz00_17647 = VECTOR_REF(((obj_t) BgL_sz00_15115), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_valza2za2_17648;

						BgL_valza2za2_17648 =
							BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_15115,
							BgL_bpz00_17647, BgL_ifreesz00_15109);
						{	/* Eval/evaluate_comp.scm 1174 */
							obj_t BgL_runz00_17649;

							BgL_runz00_17649 =
								MAKE_FX_PROCEDURE(BGl_z62run5778z62zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 5)));
							PROCEDURE_SET(BgL_runz00_17649,
								(int) (((long) 0)), BgL_iboxesz00_15110);
							PROCEDURE_SET(BgL_runz00_17649,
								(int) (((long) 1)), BINT(BgL_siza7eza7_15111));
							PROCEDURE_SET(BgL_runz00_17649,
								(int) (((long) 2)), BgL_valza2za2_17648);
							PROCEDURE_SET(BgL_runz00_17649,
								(int) (((long) 3)), ((obj_t) BgL_i1247z00_15112));
							PROCEDURE_SET(BgL_runz00_17649,
								(int) (((long) 4)), BgL_bodyz00_15113);
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_mainz00_17650;

								BgL_mainz00_17650 =
									MAKE_VA_PROCEDURE(BGl_z62main5777z62zz__evaluate_compz00,
									(int) (((long) -1)), (int) (((long) 7)));
								PROCEDURE_SET(BgL_mainz00_17650,
									(int) (((long) 0)), BgL_iboxesz00_15110);
								PROCEDURE_SET(BgL_mainz00_17650,
									(int) (((long) 1)), BINT(BgL_siza7eza7_15111));
								PROCEDURE_SET(BgL_mainz00_17650,
									(int) (((long) 2)), BgL_valza2za2_17648);
								PROCEDURE_SET(BgL_mainz00_17650,
									(int) (((long) 3)), ((obj_t) BgL_i1247z00_15112));
								PROCEDURE_SET(BgL_mainz00_17650,
									(int) (((long) 4)), BgL_bodyz00_15113);
								PROCEDURE_SET(BgL_mainz00_17650,
									(int) (((long) 5)), BgL_runz00_17649);
								PROCEDURE_SET(BgL_mainz00_17650,
									(int) (((long) 6)), BINT(BgL_siza7ezd2framez75_15114));
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_objz00_17651;

									BgL_objz00_17651 =
										BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
									PROCEDURE_ATTR_SET(BgL_runz00_17649, BgL_objz00_17651);
									BgL_objz00_17651;
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_arg3520z00_17652;

									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_arg3522z00_17653;

										BgL_arg3522z00_17653 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_15112))->
											BgL_wherez00);
										{	/* Eval/evaluate_comp.scm 683 */
											obj_t BgL_newz00_17654;

											BgL_newz00_17654 =
												create_struct(BGl_symbol5824z00zz__evaluate_compz00,
												(int) (((long) 4)));
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_31511;

												BgL_tmpz00_31511 = (int) (((long) 3));
												STRUCT_SET(BgL_newz00_17654, BgL_tmpz00_31511,
													BgL_arg3522z00_17653);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_31516;
												int BgL_tmpz00_31514;

												BgL_auxz00_31516 = BINT(BgL_siza7ezd2framez75_15114);
												BgL_tmpz00_31514 = (int) (((long) 2));
												STRUCT_SET(BgL_newz00_17654, BgL_tmpz00_31514,
													BgL_auxz00_31516);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_31519;

												BgL_tmpz00_31519 = (int) (((long) 1));
												STRUCT_SET(BgL_newz00_17654, BgL_tmpz00_31519,
													BgL_runz00_17649);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_31524;
												int BgL_tmpz00_31522;

												BgL_auxz00_31524 = BINT(((long) -1));
												BgL_tmpz00_31522 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_17654, BgL_tmpz00_31522,
													BgL_auxz00_31524);
											}
											BgL_arg3520z00_17652 = BgL_newz00_17654;
									}}
									PROCEDURE_ATTR_SET(BgL_mainz00_17650, BgL_arg3520z00_17652);
									BgL_arg3520z00_17652;
								}
								return BgL_mainz00_17650;
							}
						}
					}
				}
			}
		}

	}



/* &main5777 */
	obj_t BGl_z62main5777z62zz__evaluate_compz00(obj_t BgL_envz00_15116,
		obj_t BgL_lastz00_15124)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_runz00_15122;
				long BgL_siza7ezd2framez75_15123;

				BgL_runz00_15122 =
					((obj_t) PROCEDURE_REF(BgL_envz00_15116, (int) (((long) 5))));
				BgL_siza7ezd2framez75_15123 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15116, (int) (((long) 6))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_sz00_17655;

					BgL_sz00_17655 = BGl_findzd2statezd2zz__evaluate_compz00();
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_bpz00_17656;

						BgL_bpz00_17656 = VECTOR_REF(((obj_t) BgL_sz00_17655), ((long) 0));
						if (
							(((long) CINT(BgL_bpz00_17656) + BgL_siza7ezd2framez75_15123) <
								VECTOR_LENGTH(((obj_t) BgL_sz00_17655))))
							{	/* Eval/evaluate_comp.scm 1174 */
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3525z00_17657;

									BgL_arg3525z00_17657 =
										((long) CINT(BgL_bpz00_17656) + ((long) 0));
									VECTOR_SET(
										((obj_t) BgL_sz00_17655), BgL_arg3525z00_17657,
										BgL_lastz00_15124);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_ez00_17658;

									BgL_ez00_17658 = BGL_EXITD_TOP_AS_OBJ();
									BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17658,
										BgL_bpz00_17656);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_accz00_17659;

										BgL_accz00_17659 =
											BGl_catchzd2trampolinezd2zz__evaluate_compz00
											(BgL_runz00_15122, BgL_sz00_17655, BgL_bpz00_17656);
										BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_17658);
										VECTOR_SET(
											((obj_t) BgL_sz00_17655), ((long) 0), BgL_bpz00_17656);
										return BgL_accz00_17659;
									}
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_nsz00_17660;

								BgL_nsz00_17660 = BGl_makezd2statezd2zz__evaluate_compz00();
								VECTOR_SET(BgL_nsz00_17660, ((long) 1), BgL_sz00_17655);
								VECTOR_SET(BgL_nsz00_17660, ((long) 2), BgL_lastz00_15124);
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_z12denvz12_17661;

									BgL_z12denvz12_17661 = BGL_CURRENT_DYNAMIC_ENV();
									BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17661, BgL_nsz00_17660);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_ez00_17662;

										BgL_ez00_17662 = BGL_EXITD_TOP_AS_OBJ();
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17662,
											BgL_sz00_17655);
										{	/* Eval/evaluate_comp.scm 1174 */
											obj_t BgL_____rz00_17663;

											{	/* Eval/evaluate_comp.scm 670 */
												obj_t BgL_savedzd2bpzd2_17664;

												BgL_savedzd2bpzd2_17664 =
													VECTOR_REF(BgL_nsz00_17660, ((long) 0));
												VECTOR_SET(BgL_nsz00_17660, ((long) 0),
													BINT(((long) 2)));
												{
													obj_t BgL_fz00_17666;

													BgL_fz00_17666 = BgL_runz00_15122;
												BgL_recz00_17665:
													{	/* Eval/evaluate_comp.scm 673 */
														obj_t BgL_rz00_17667;

														BgL_rz00_17667 =
															PROCEDURE_ENTRY(BgL_fz00_17666) (BgL_fz00_17666,
															BgL_nsz00_17660, BEOA);
														{	/* Eval/evaluate_comp.scm 674 */
															bool_t BgL_test6722z00_31567;

															if (PROCEDUREP(BgL_rz00_17667))
																{	/* Eval/evaluate_comp.scm 674 */
																	obj_t BgL_arg1702z00_17668;

																	BgL_arg1702z00_17668 =
																		PROCEDURE_ATTR(BgL_rz00_17667);
																	if (STRUCTP(BgL_arg1702z00_17668))
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test6722z00_31567 =
																				(STRUCT_KEY(BgL_arg1702z00_17668) ==
																				BGl_symbol5803z00zz__evaluate_compz00);
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test6722z00_31567 = ((bool_t) 0);
																		}
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	BgL_test6722z00_31567 = ((bool_t) 0);
																}
															if (BgL_test6722z00_31567)
																{
																	obj_t BgL_fz00_31575;

																	BgL_fz00_31575 = BgL_rz00_17667;
																	BgL_fz00_17666 = BgL_fz00_31575;
																	goto BgL_recz00_17665;
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	VECTOR_SET(BgL_nsz00_17660, ((long) 0),
																		BgL_savedzd2bpzd2_17664);
																	BgL_____rz00_17663 = BgL_rz00_17667;
											}}}}}
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_ez00_17662);
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17661, BgL_sz00_17655);
											return BgL_____rz00_17663;
										}
									}
								}
							}
					}
				}
			}
		}

	}



/* &run5778 */
	obj_t BGl_z62run5778z62zz__evaluate_compz00(obj_t BgL_envz00_15125,
		obj_t BgL_sz00_15131)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_iboxesz00_15126;
				long BgL_siza7eza7_15127;
				obj_t BgL_valza2za2_15128;
				BgL_ev_absz00_bglt BgL_i1247z00_15129;
				obj_t BgL_bodyz00_15130;

				BgL_iboxesz00_15126 =
					((obj_t) PROCEDURE_REF(BgL_envz00_15125, (int) (((long) 0))));
				BgL_siza7eza7_15127 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15125, (int) (((long) 1))));
				BgL_valza2za2_15128 =
					((obj_t) PROCEDURE_REF(BgL_envz00_15125, (int) (((long) 2))));
				BgL_i1247z00_15129 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_15125, (int) (((long) 3))));
				BgL_bodyz00_15130 = PROCEDURE_REF(BgL_envz00_15125, (int) (((long) 4)));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_17669;

					BgL_bpz00_17669 = VECTOR_REF(((obj_t) BgL_sz00_15131), ((long) 0));
					BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_15131,
						BgL_iboxesz00_15126, BgL_bpz00_17669);
					BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_15131,
						BgL_valza2za2_15128,
						((long) CINT(BgL_bpz00_17669) + BgL_siza7eza7_15127));
					{	/* Eval/evaluate_comp.scm 1095 */
						obj_t BgL_z12denvz12_17670;
						obj_t BgL_wherez00_17671;
						obj_t BgL_locz00_17672;

						BgL_z12denvz12_17670 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_wherez00_17671 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_15129))->
							BgL_wherez00);
						BgL_locz00_17672 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_15129))->BgL_locz00);
						{	/* Eval/evaluate_comp.scm 1095 */

							BGL_ENV_PUSH_TRACE(BgL_z12denvz12_17670, BgL_wherez00_17671,
								BgL_locz00_17672);
							{	/* Eval/evaluate_comp.scm 1095 */
								obj_t BgL_za2za2resza2za2z00_17673;

								BgL_za2za2resza2za2z00_17673 =
									PROCEDURE_ENTRY(BgL_bodyz00_15130) (BgL_bodyz00_15130,
									BgL_sz00_15131, BEOA);
								BGL_ENV_POP_TRACE(BgL_z12denvz12_17670);
								return BgL_za2za2resza2za2z00_17673;
							}
						}
					}
				}
			}
		}

	}



/* &<@anonymous:3450> */
	obj_t BGl_z62zc3z04anonymousza33450ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_15132, obj_t BgL_sz00_15136)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				BgL_ev_absz00_bglt BgL_i1247z00_15133;
				obj_t BgL_bodyz00_15134;
				long BgL_siza7ezd2framez75_15135;

				BgL_i1247z00_15133 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_15132, (int) (((long) 0))));
				BgL_bodyz00_15134 = PROCEDURE_REF(BgL_envz00_15132, (int) (((long) 1)));
				BgL_siza7ezd2framez75_15135 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15132, (int) (((long) 2))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_17674;

					BgL_bpz00_17674 = VECTOR_REF(((obj_t) BgL_sz00_15136), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1174 */

						{	/* Eval/evaluate_comp.scm 1174 */
							obj_t BgL_runz00_17675;

							BgL_runz00_17675 =
								MAKE_FX_PROCEDURE(BGl_z62run5780z62zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 2)));
							PROCEDURE_SET(BgL_runz00_17675,
								(int) (((long) 0)), ((obj_t) BgL_i1247z00_15133));
							PROCEDURE_SET(BgL_runz00_17675,
								(int) (((long) 1)), BgL_bodyz00_15134);
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_mainz00_17676;

								BgL_mainz00_17676 =
									MAKE_FX_PROCEDURE(BGl_z62main5779z62zz__evaluate_compz00,
									(int) (((long) 0)), (int) (((long) 4)));
								PROCEDURE_SET(BgL_mainz00_17676,
									(int) (((long) 0)), ((obj_t) BgL_i1247z00_15133));
								PROCEDURE_SET(BgL_mainz00_17676,
									(int) (((long) 1)), BgL_bodyz00_15134);
								PROCEDURE_SET(BgL_mainz00_17676,
									(int) (((long) 2)), BgL_runz00_17675);
								PROCEDURE_SET(BgL_mainz00_17676,
									(int) (((long) 3)), BINT(BgL_siza7ezd2framez75_15135));
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_objz00_17677;

									BgL_objz00_17677 =
										BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
									PROCEDURE_ATTR_SET(BgL_runz00_17675, BgL_objz00_17677);
									BgL_objz00_17677;
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_arg3452z00_17678;

									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_arg3453z00_17679;

										BgL_arg3453z00_17679 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_15133))->
											BgL_wherez00);
										{	/* Eval/evaluate_comp.scm 683 */
											obj_t BgL_newz00_17680;

											BgL_newz00_17680 =
												create_struct(BGl_symbol5824z00zz__evaluate_compz00,
												(int) (((long) 4)));
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_31643;

												BgL_tmpz00_31643 = (int) (((long) 3));
												STRUCT_SET(BgL_newz00_17680, BgL_tmpz00_31643,
													BgL_arg3453z00_17679);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_31648;
												int BgL_tmpz00_31646;

												BgL_auxz00_31648 = BINT(BgL_siza7ezd2framez75_15135);
												BgL_tmpz00_31646 = (int) (((long) 2));
												STRUCT_SET(BgL_newz00_17680, BgL_tmpz00_31646,
													BgL_auxz00_31648);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_31651;

												BgL_tmpz00_31651 = (int) (((long) 1));
												STRUCT_SET(BgL_newz00_17680, BgL_tmpz00_31651,
													BgL_runz00_17675);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_31656;
												int BgL_tmpz00_31654;

												BgL_auxz00_31656 = BINT(((long) 0));
												BgL_tmpz00_31654 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_17680, BgL_tmpz00_31654,
													BgL_auxz00_31656);
											}
											BgL_arg3452z00_17678 = BgL_newz00_17680;
									}}
									PROCEDURE_ATTR_SET(BgL_mainz00_17676, BgL_arg3452z00_17678);
									BgL_arg3452z00_17678;
								}
								return BgL_mainz00_17676;
							}
						}
					}
				}
			}
		}

	}



/* &main5779 */
	obj_t BGl_z62main5779z62zz__evaluate_compz00(obj_t BgL_envz00_15137)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_runz00_15140;
				long BgL_siza7ezd2framez75_15141;

				BgL_runz00_15140 =
					((obj_t) PROCEDURE_REF(BgL_envz00_15137, (int) (((long) 2))));
				BgL_siza7ezd2framez75_15141 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15137, (int) (((long) 3))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_sz00_17681;

					BgL_sz00_17681 = BGl_findzd2statezd2zz__evaluate_compz00();
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_bpz00_17682;

						BgL_bpz00_17682 = VECTOR_REF(((obj_t) BgL_sz00_17681), ((long) 0));
						if (
							(((long) CINT(BgL_bpz00_17682) + BgL_siza7ezd2framez75_15141) <
								VECTOR_LENGTH(((obj_t) BgL_sz00_17681))))
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_ez00_17683;

								BgL_ez00_17683 = BGL_EXITD_TOP_AS_OBJ();
								BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17683,
									BgL_bpz00_17682);
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_accz00_17684;

									BgL_accz00_17684 =
										BGl_catchzd2trampolinezd2zz__evaluate_compz00
										(BgL_runz00_15140, BgL_sz00_17681, BgL_bpz00_17682);
									BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_17683);
									VECTOR_SET(
										((obj_t) BgL_sz00_17681), ((long) 0), BgL_bpz00_17682);
									return BgL_accz00_17684;
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_nsz00_17685;

								BgL_nsz00_17685 = BGl_makezd2statezd2zz__evaluate_compz00();
								VECTOR_SET(BgL_nsz00_17685, ((long) 1), BgL_sz00_17681);
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_z12denvz12_17686;

									BgL_z12denvz12_17686 = BGL_CURRENT_DYNAMIC_ENV();
									BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17686, BgL_nsz00_17685);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_ez00_17687;

										BgL_ez00_17687 = BGL_EXITD_TOP_AS_OBJ();
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17687,
											BgL_sz00_17681);
										{	/* Eval/evaluate_comp.scm 1174 */
											obj_t BgL_____rz00_17688;

											{	/* Eval/evaluate_comp.scm 670 */
												obj_t BgL_savedzd2bpzd2_17689;

												BgL_savedzd2bpzd2_17689 =
													VECTOR_REF(BgL_nsz00_17685, ((long) 0));
												VECTOR_SET(BgL_nsz00_17685, ((long) 0),
													BINT(((long) 2)));
												{
													obj_t BgL_fz00_17691;

													BgL_fz00_17691 = BgL_runz00_15140;
												BgL_recz00_17690:
													{	/* Eval/evaluate_comp.scm 673 */
														obj_t BgL_rz00_17692;

														BgL_rz00_17692 =
															PROCEDURE_ENTRY(BgL_fz00_17691) (BgL_fz00_17691,
															BgL_nsz00_17685, BEOA);
														{	/* Eval/evaluate_comp.scm 674 */
															bool_t BgL_test6726z00_31694;

															if (PROCEDUREP(BgL_rz00_17692))
																{	/* Eval/evaluate_comp.scm 674 */
																	obj_t BgL_arg1702z00_17693;

																	BgL_arg1702z00_17693 =
																		PROCEDURE_ATTR(BgL_rz00_17692);
																	if (STRUCTP(BgL_arg1702z00_17693))
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test6726z00_31694 =
																				(STRUCT_KEY(BgL_arg1702z00_17693) ==
																				BGl_symbol5803z00zz__evaluate_compz00);
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test6726z00_31694 = ((bool_t) 0);
																		}
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	BgL_test6726z00_31694 = ((bool_t) 0);
																}
															if (BgL_test6726z00_31694)
																{
																	obj_t BgL_fz00_31702;

																	BgL_fz00_31702 = BgL_rz00_17692;
																	BgL_fz00_17691 = BgL_fz00_31702;
																	goto BgL_recz00_17690;
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	VECTOR_SET(BgL_nsz00_17685, ((long) 0),
																		BgL_savedzd2bpzd2_17689);
																	BgL_____rz00_17688 = BgL_rz00_17692;
											}}}}}
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_ez00_17687);
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17686, BgL_sz00_17681);
											return BgL_____rz00_17688;
										}
									}
								}
							}
					}
				}
			}
		}

	}



/* &run5780 */
	obj_t BGl_z62run5780z62zz__evaluate_compz00(obj_t BgL_envz00_15142,
		obj_t BgL_sz00_15145)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				BgL_ev_absz00_bglt BgL_i1247z00_15143;
				obj_t BgL_bodyz00_15144;

				BgL_i1247z00_15143 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_15142, (int) (((long) 0))));
				BgL_bodyz00_15144 = PROCEDURE_REF(BgL_envz00_15142, (int) (((long) 1)));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_17694;

					BgL_bpz00_17694 = VECTOR_REF(((obj_t) BgL_sz00_15145), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_z12denvz12_17695;
						obj_t BgL_wherez00_17696;
						obj_t BgL_locz00_17697;

						BgL_z12denvz12_17695 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_wherez00_17696 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_15143))->
							BgL_wherez00);
						BgL_locz00_17697 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_15143))->BgL_locz00);
						{	/* Eval/evaluate_comp.scm 1174 */

							BGL_ENV_PUSH_TRACE(BgL_z12denvz12_17695, BgL_wherez00_17696,
								BgL_locz00_17697);
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_za2za2resza2za2z00_17698;

								BgL_za2za2resza2za2z00_17698 =
									PROCEDURE_ENTRY(BgL_bodyz00_15144) (BgL_bodyz00_15144,
									BgL_sz00_15145, BEOA);
								BGL_ENV_POP_TRACE(BgL_z12denvz12_17695);
								return BgL_za2za2resza2za2z00_17698;
							}
						}
					}
				}
			}
		}

	}



/* &<@anonymous:3457> */
	obj_t BGl_z62zc3z04anonymousza33457ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_15146, obj_t BgL_sz00_15151)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_iboxesz00_15147;
				BgL_ev_absz00_bglt BgL_i1247z00_15148;
				obj_t BgL_bodyz00_15149;
				long BgL_siza7ezd2framez75_15150;

				BgL_iboxesz00_15147 =
					((obj_t) PROCEDURE_REF(BgL_envz00_15146, (int) (((long) 0))));
				BgL_i1247z00_15148 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_15146, (int) (((long) 1))));
				BgL_bodyz00_15149 = PROCEDURE_REF(BgL_envz00_15146, (int) (((long) 2)));
				BgL_siza7ezd2framez75_15150 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15146, (int) (((long) 3))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_17699;

					BgL_bpz00_17699 = VECTOR_REF(((obj_t) BgL_sz00_15151), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1174 */

						{	/* Eval/evaluate_comp.scm 1174 */
							obj_t BgL_runz00_17700;

							BgL_runz00_17700 =
								MAKE_FX_PROCEDURE(BGl_z62run5782z62zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 3)));
							PROCEDURE_SET(BgL_runz00_17700,
								(int) (((long) 0)), BgL_iboxesz00_15147);
							PROCEDURE_SET(BgL_runz00_17700,
								(int) (((long) 1)), ((obj_t) BgL_i1247z00_15148));
							PROCEDURE_SET(BgL_runz00_17700,
								(int) (((long) 2)), BgL_bodyz00_15149);
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_mainz00_17701;

								BgL_mainz00_17701 =
									MAKE_FX_PROCEDURE(BGl_z62main5781z62zz__evaluate_compz00,
									(int) (((long) 0)), (int) (((long) 5)));
								PROCEDURE_SET(BgL_mainz00_17701,
									(int) (((long) 0)), BgL_iboxesz00_15147);
								PROCEDURE_SET(BgL_mainz00_17701,
									(int) (((long) 1)), ((obj_t) BgL_i1247z00_15148));
								PROCEDURE_SET(BgL_mainz00_17701,
									(int) (((long) 2)), BgL_bodyz00_15149);
								PROCEDURE_SET(BgL_mainz00_17701,
									(int) (((long) 3)), BgL_runz00_17700);
								PROCEDURE_SET(BgL_mainz00_17701,
									(int) (((long) 4)), BINT(BgL_siza7ezd2framez75_15150));
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_objz00_17702;

									BgL_objz00_17702 =
										BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
									PROCEDURE_ATTR_SET(BgL_runz00_17700, BgL_objz00_17702);
									BgL_objz00_17702;
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_arg3458z00_17703;

									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_arg3460z00_17704;

										BgL_arg3460z00_17704 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_15148))->
											BgL_wherez00);
										{	/* Eval/evaluate_comp.scm 683 */
											obj_t BgL_newz00_17705;

											BgL_newz00_17705 =
												create_struct(BGl_symbol5824z00zz__evaluate_compz00,
												(int) (((long) 4)));
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_31764;

												BgL_tmpz00_31764 = (int) (((long) 3));
												STRUCT_SET(BgL_newz00_17705, BgL_tmpz00_31764,
													BgL_arg3460z00_17704);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_31769;
												int BgL_tmpz00_31767;

												BgL_auxz00_31769 = BINT(BgL_siza7ezd2framez75_15150);
												BgL_tmpz00_31767 = (int) (((long) 2));
												STRUCT_SET(BgL_newz00_17705, BgL_tmpz00_31767,
													BgL_auxz00_31769);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_31772;

												BgL_tmpz00_31772 = (int) (((long) 1));
												STRUCT_SET(BgL_newz00_17705, BgL_tmpz00_31772,
													BgL_runz00_17700);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_31777;
												int BgL_tmpz00_31775;

												BgL_auxz00_31777 = BINT(((long) 0));
												BgL_tmpz00_31775 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_17705, BgL_tmpz00_31775,
													BgL_auxz00_31777);
											}
											BgL_arg3458z00_17703 = BgL_newz00_17705;
									}}
									PROCEDURE_ATTR_SET(BgL_mainz00_17701, BgL_arg3458z00_17703);
									BgL_arg3458z00_17703;
								}
								return BgL_mainz00_17701;
							}
						}
					}
				}
			}
		}

	}



/* &main5781 */
	obj_t BGl_z62main5781z62zz__evaluate_compz00(obj_t BgL_envz00_15152)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_runz00_15156;
				long BgL_siza7ezd2framez75_15157;

				BgL_runz00_15156 =
					((obj_t) PROCEDURE_REF(BgL_envz00_15152, (int) (((long) 3))));
				BgL_siza7ezd2framez75_15157 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15152, (int) (((long) 4))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_sz00_17706;

					BgL_sz00_17706 = BGl_findzd2statezd2zz__evaluate_compz00();
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_bpz00_17707;

						BgL_bpz00_17707 = VECTOR_REF(((obj_t) BgL_sz00_17706), ((long) 0));
						if (
							(((long) CINT(BgL_bpz00_17707) + BgL_siza7ezd2framez75_15157) <
								VECTOR_LENGTH(((obj_t) BgL_sz00_17706))))
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_ez00_17708;

								BgL_ez00_17708 = BGL_EXITD_TOP_AS_OBJ();
								BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17708,
									BgL_bpz00_17707);
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_accz00_17709;

									BgL_accz00_17709 =
										BGl_catchzd2trampolinezd2zz__evaluate_compz00
										(BgL_runz00_15156, BgL_sz00_17706, BgL_bpz00_17707);
									BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_17708);
									VECTOR_SET(
										((obj_t) BgL_sz00_17706), ((long) 0), BgL_bpz00_17707);
									return BgL_accz00_17709;
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_nsz00_17710;

								BgL_nsz00_17710 = BGl_makezd2statezd2zz__evaluate_compz00();
								VECTOR_SET(BgL_nsz00_17710, ((long) 1), BgL_sz00_17706);
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_z12denvz12_17711;

									BgL_z12denvz12_17711 = BGL_CURRENT_DYNAMIC_ENV();
									BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17711, BgL_nsz00_17710);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_ez00_17712;

										BgL_ez00_17712 = BGL_EXITD_TOP_AS_OBJ();
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17712,
											BgL_sz00_17706);
										{	/* Eval/evaluate_comp.scm 1174 */
											obj_t BgL_____rz00_17713;

											{	/* Eval/evaluate_comp.scm 670 */
												obj_t BgL_savedzd2bpzd2_17714;

												BgL_savedzd2bpzd2_17714 =
													VECTOR_REF(BgL_nsz00_17710, ((long) 0));
												VECTOR_SET(BgL_nsz00_17710, ((long) 0),
													BINT(((long) 2)));
												{
													obj_t BgL_fz00_17716;

													BgL_fz00_17716 = BgL_runz00_15156;
												BgL_recz00_17715:
													{	/* Eval/evaluate_comp.scm 673 */
														obj_t BgL_rz00_17717;

														BgL_rz00_17717 =
															PROCEDURE_ENTRY(BgL_fz00_17716) (BgL_fz00_17716,
															BgL_nsz00_17710, BEOA);
														{	/* Eval/evaluate_comp.scm 674 */
															bool_t BgL_test6730z00_31815;

															if (PROCEDUREP(BgL_rz00_17717))
																{	/* Eval/evaluate_comp.scm 674 */
																	obj_t BgL_arg1702z00_17718;

																	BgL_arg1702z00_17718 =
																		PROCEDURE_ATTR(BgL_rz00_17717);
																	if (STRUCTP(BgL_arg1702z00_17718))
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test6730z00_31815 =
																				(STRUCT_KEY(BgL_arg1702z00_17718) ==
																				BGl_symbol5803z00zz__evaluate_compz00);
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test6730z00_31815 = ((bool_t) 0);
																		}
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	BgL_test6730z00_31815 = ((bool_t) 0);
																}
															if (BgL_test6730z00_31815)
																{
																	obj_t BgL_fz00_31823;

																	BgL_fz00_31823 = BgL_rz00_17717;
																	BgL_fz00_17716 = BgL_fz00_31823;
																	goto BgL_recz00_17715;
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	VECTOR_SET(BgL_nsz00_17710, ((long) 0),
																		BgL_savedzd2bpzd2_17714);
																	BgL_____rz00_17713 = BgL_rz00_17717;
											}}}}}
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_ez00_17712);
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17711, BgL_sz00_17706);
											return BgL_____rz00_17713;
										}
									}
								}
							}
					}
				}
			}
		}

	}



/* &run5782 */
	obj_t BGl_z62run5782z62zz__evaluate_compz00(obj_t BgL_envz00_15158,
		obj_t BgL_sz00_15162)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_iboxesz00_15159;
				BgL_ev_absz00_bglt BgL_i1247z00_15160;
				obj_t BgL_bodyz00_15161;

				BgL_iboxesz00_15159 =
					((obj_t) PROCEDURE_REF(BgL_envz00_15158, (int) (((long) 0))));
				BgL_i1247z00_15160 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_15158, (int) (((long) 1))));
				BgL_bodyz00_15161 = PROCEDURE_REF(BgL_envz00_15158, (int) (((long) 2)));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_17719;

					BgL_bpz00_17719 = VECTOR_REF(((obj_t) BgL_sz00_15162), ((long) 0));
					BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_15162,
						BgL_iboxesz00_15159, BgL_bpz00_17719);
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_z12denvz12_17720;
						obj_t BgL_wherez00_17721;
						obj_t BgL_locz00_17722;

						BgL_z12denvz12_17720 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_wherez00_17721 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_15160))->
							BgL_wherez00);
						BgL_locz00_17722 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_15160))->BgL_locz00);
						{	/* Eval/evaluate_comp.scm 1174 */

							BGL_ENV_PUSH_TRACE(BgL_z12denvz12_17720, BgL_wherez00_17721,
								BgL_locz00_17722);
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_za2za2resza2za2z00_17723;

								BgL_za2za2resza2za2z00_17723 =
									PROCEDURE_ENTRY(BgL_bodyz00_15161) (BgL_bodyz00_15161,
									BgL_sz00_15162, BEOA);
								BGL_ENV_POP_TRACE(BgL_z12denvz12_17720);
								return BgL_za2za2resza2za2z00_17723;
							}
						}
					}
				}
			}
		}

	}



/* &<@anonymous:3467> */
	obj_t BGl_z62zc3z04anonymousza33467ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_15163, obj_t BgL_sz00_15169)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_ifreesz00_15164;
				long BgL_siza7eza7_15165;
				BgL_ev_absz00_bglt BgL_i1247z00_15166;
				obj_t BgL_bodyz00_15167;
				long BgL_siza7ezd2framez75_15168;

				BgL_ifreesz00_15164 =
					((obj_t) PROCEDURE_REF(BgL_envz00_15163, (int) (((long) 0))));
				BgL_siza7eza7_15165 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15163, (int) (((long) 1))));
				BgL_i1247z00_15166 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_15163, (int) (((long) 2))));
				BgL_bodyz00_15167 = PROCEDURE_REF(BgL_envz00_15163, (int) (((long) 3)));
				BgL_siza7ezd2framez75_15168 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15163, (int) (((long) 4))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_17724;

					BgL_bpz00_17724 = VECTOR_REF(((obj_t) BgL_sz00_15169), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_valza2za2_17725;

						BgL_valza2za2_17725 =
							BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_15169,
							BgL_bpz00_17724, BgL_ifreesz00_15164);
						{	/* Eval/evaluate_comp.scm 1174 */
							obj_t BgL_runz00_17726;

							BgL_runz00_17726 =
								MAKE_FX_PROCEDURE(BGl_z62run5784z62zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 4)));
							PROCEDURE_SET(BgL_runz00_17726,
								(int) (((long) 0)), BINT(BgL_siza7eza7_15165));
							PROCEDURE_SET(BgL_runz00_17726,
								(int) (((long) 1)), BgL_valza2za2_17725);
							PROCEDURE_SET(BgL_runz00_17726,
								(int) (((long) 2)), ((obj_t) BgL_i1247z00_15166));
							PROCEDURE_SET(BgL_runz00_17726,
								(int) (((long) 3)), BgL_bodyz00_15167);
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_mainz00_17727;

								BgL_mainz00_17727 =
									MAKE_FX_PROCEDURE(BGl_z62main5783z62zz__evaluate_compz00,
									(int) (((long) 0)), (int) (((long) 6)));
								PROCEDURE_SET(BgL_mainz00_17727,
									(int) (((long) 0)), BINT(BgL_siza7eza7_15165));
								PROCEDURE_SET(BgL_mainz00_17727,
									(int) (((long) 1)), BgL_valza2za2_17725);
								PROCEDURE_SET(BgL_mainz00_17727,
									(int) (((long) 2)), ((obj_t) BgL_i1247z00_15166));
								PROCEDURE_SET(BgL_mainz00_17727,
									(int) (((long) 3)), BgL_bodyz00_15167);
								PROCEDURE_SET(BgL_mainz00_17727,
									(int) (((long) 4)), BgL_runz00_17726);
								PROCEDURE_SET(BgL_mainz00_17727,
									(int) (((long) 5)), BINT(BgL_siza7ezd2framez75_15168));
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_objz00_17728;

									BgL_objz00_17728 =
										BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
									PROCEDURE_ATTR_SET(BgL_runz00_17726, BgL_objz00_17728);
									BgL_objz00_17728;
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_arg3468z00_17729;

									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_arg3470z00_17730;

										BgL_arg3470z00_17730 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_15166))->
											BgL_wherez00);
										{	/* Eval/evaluate_comp.scm 683 */
											obj_t BgL_newz00_17731;

											BgL_newz00_17731 =
												create_struct(BGl_symbol5824z00zz__evaluate_compz00,
												(int) (((long) 4)));
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_31899;

												BgL_tmpz00_31899 = (int) (((long) 3));
												STRUCT_SET(BgL_newz00_17731, BgL_tmpz00_31899,
													BgL_arg3470z00_17730);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_31904;
												int BgL_tmpz00_31902;

												BgL_auxz00_31904 = BINT(BgL_siza7ezd2framez75_15168);
												BgL_tmpz00_31902 = (int) (((long) 2));
												STRUCT_SET(BgL_newz00_17731, BgL_tmpz00_31902,
													BgL_auxz00_31904);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_31907;

												BgL_tmpz00_31907 = (int) (((long) 1));
												STRUCT_SET(BgL_newz00_17731, BgL_tmpz00_31907,
													BgL_runz00_17726);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_31912;
												int BgL_tmpz00_31910;

												BgL_auxz00_31912 = BINT(((long) 0));
												BgL_tmpz00_31910 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_17731, BgL_tmpz00_31910,
													BgL_auxz00_31912);
											}
											BgL_arg3468z00_17729 = BgL_newz00_17731;
									}}
									PROCEDURE_ATTR_SET(BgL_mainz00_17727, BgL_arg3468z00_17729);
									BgL_arg3468z00_17729;
								}
								return BgL_mainz00_17727;
							}
						}
					}
				}
			}
		}

	}



/* &main5783 */
	obj_t BGl_z62main5783z62zz__evaluate_compz00(obj_t BgL_envz00_15170)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_runz00_15175;
				long BgL_siza7ezd2framez75_15176;

				BgL_runz00_15175 =
					((obj_t) PROCEDURE_REF(BgL_envz00_15170, (int) (((long) 4))));
				BgL_siza7ezd2framez75_15176 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15170, (int) (((long) 5))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_sz00_17732;

					BgL_sz00_17732 = BGl_findzd2statezd2zz__evaluate_compz00();
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_bpz00_17733;

						BgL_bpz00_17733 = VECTOR_REF(((obj_t) BgL_sz00_17732), ((long) 0));
						if (
							(((long) CINT(BgL_bpz00_17733) + BgL_siza7ezd2framez75_15176) <
								VECTOR_LENGTH(((obj_t) BgL_sz00_17732))))
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_ez00_17734;

								BgL_ez00_17734 = BGL_EXITD_TOP_AS_OBJ();
								BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17734,
									BgL_bpz00_17733);
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_accz00_17735;

									BgL_accz00_17735 =
										BGl_catchzd2trampolinezd2zz__evaluate_compz00
										(BgL_runz00_15175, BgL_sz00_17732, BgL_bpz00_17733);
									BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_17734);
									VECTOR_SET(
										((obj_t) BgL_sz00_17732), ((long) 0), BgL_bpz00_17733);
									return BgL_accz00_17735;
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_nsz00_17736;

								BgL_nsz00_17736 = BGl_makezd2statezd2zz__evaluate_compz00();
								VECTOR_SET(BgL_nsz00_17736, ((long) 1), BgL_sz00_17732);
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_z12denvz12_17737;

									BgL_z12denvz12_17737 = BGL_CURRENT_DYNAMIC_ENV();
									BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17737, BgL_nsz00_17736);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_ez00_17738;

										BgL_ez00_17738 = BGL_EXITD_TOP_AS_OBJ();
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17738,
											BgL_sz00_17732);
										{	/* Eval/evaluate_comp.scm 1174 */
											obj_t BgL_____rz00_17739;

											{	/* Eval/evaluate_comp.scm 670 */
												obj_t BgL_savedzd2bpzd2_17740;

												BgL_savedzd2bpzd2_17740 =
													VECTOR_REF(BgL_nsz00_17736, ((long) 0));
												VECTOR_SET(BgL_nsz00_17736, ((long) 0),
													BINT(((long) 2)));
												{
													obj_t BgL_fz00_17742;

													BgL_fz00_17742 = BgL_runz00_15175;
												BgL_recz00_17741:
													{	/* Eval/evaluate_comp.scm 673 */
														obj_t BgL_rz00_17743;

														BgL_rz00_17743 =
															PROCEDURE_ENTRY(BgL_fz00_17742) (BgL_fz00_17742,
															BgL_nsz00_17736, BEOA);
														{	/* Eval/evaluate_comp.scm 674 */
															bool_t BgL_test6734z00_31950;

															if (PROCEDUREP(BgL_rz00_17743))
																{	/* Eval/evaluate_comp.scm 674 */
																	obj_t BgL_arg1702z00_17744;

																	BgL_arg1702z00_17744 =
																		PROCEDURE_ATTR(BgL_rz00_17743);
																	if (STRUCTP(BgL_arg1702z00_17744))
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test6734z00_31950 =
																				(STRUCT_KEY(BgL_arg1702z00_17744) ==
																				BGl_symbol5803z00zz__evaluate_compz00);
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test6734z00_31950 = ((bool_t) 0);
																		}
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	BgL_test6734z00_31950 = ((bool_t) 0);
																}
															if (BgL_test6734z00_31950)
																{
																	obj_t BgL_fz00_31958;

																	BgL_fz00_31958 = BgL_rz00_17743;
																	BgL_fz00_17742 = BgL_fz00_31958;
																	goto BgL_recz00_17741;
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	VECTOR_SET(BgL_nsz00_17736, ((long) 0),
																		BgL_savedzd2bpzd2_17740);
																	BgL_____rz00_17739 = BgL_rz00_17743;
											}}}}}
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_ez00_17738);
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17737, BgL_sz00_17732);
											return BgL_____rz00_17739;
										}
									}
								}
							}
					}
				}
			}
		}

	}



/* &run5784 */
	obj_t BGl_z62run5784z62zz__evaluate_compz00(obj_t BgL_envz00_15177,
		obj_t BgL_sz00_15182)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				long BgL_siza7eza7_15178;
				obj_t BgL_valza2za2_15179;
				BgL_ev_absz00_bglt BgL_i1247z00_15180;
				obj_t BgL_bodyz00_15181;

				BgL_siza7eza7_15178 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15177, (int) (((long) 0))));
				BgL_valza2za2_15179 =
					((obj_t) PROCEDURE_REF(BgL_envz00_15177, (int) (((long) 1))));
				BgL_i1247z00_15180 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_15177, (int) (((long) 2))));
				BgL_bodyz00_15181 = PROCEDURE_REF(BgL_envz00_15177, (int) (((long) 3)));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_17745;

					BgL_bpz00_17745 = VECTOR_REF(((obj_t) BgL_sz00_15182), ((long) 0));
					BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_15182,
						BgL_valza2za2_15179,
						((long) CINT(BgL_bpz00_17745) + BgL_siza7eza7_15178));
					{	/* Eval/evaluate_comp.scm 1095 */
						obj_t BgL_z12denvz12_17746;
						obj_t BgL_wherez00_17747;
						obj_t BgL_locz00_17748;

						BgL_z12denvz12_17746 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_wherez00_17747 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_15180))->
							BgL_wherez00);
						BgL_locz00_17748 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_15180))->BgL_locz00);
						{	/* Eval/evaluate_comp.scm 1095 */

							BGL_ENV_PUSH_TRACE(BgL_z12denvz12_17746, BgL_wherez00_17747,
								BgL_locz00_17748);
							{	/* Eval/evaluate_comp.scm 1095 */
								obj_t BgL_za2za2resza2za2z00_17749;

								BgL_za2za2resza2za2z00_17749 =
									PROCEDURE_ENTRY(BgL_bodyz00_15181) (BgL_bodyz00_15181,
									BgL_sz00_15182, BEOA);
								BGL_ENV_POP_TRACE(BgL_z12denvz12_17746);
								return BgL_za2za2resza2za2z00_17749;
							}
						}
					}
				}
			}
		}

	}



/* &<@anonymous:3475> */
	obj_t BGl_z62zc3z04anonymousza33475ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_15183, obj_t BgL_sz00_15190)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_ifreesz00_15184;
				obj_t BgL_iboxesz00_15185;
				long BgL_siza7eza7_15186;
				BgL_ev_absz00_bglt BgL_i1247z00_15187;
				obj_t BgL_bodyz00_15188;
				long BgL_siza7ezd2framez75_15189;

				BgL_ifreesz00_15184 =
					((obj_t) PROCEDURE_REF(BgL_envz00_15183, (int) (((long) 0))));
				BgL_iboxesz00_15185 =
					((obj_t) PROCEDURE_REF(BgL_envz00_15183, (int) (((long) 1))));
				BgL_siza7eza7_15186 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15183, (int) (((long) 2))));
				BgL_i1247z00_15187 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_15183, (int) (((long) 3))));
				BgL_bodyz00_15188 = PROCEDURE_REF(BgL_envz00_15183, (int) (((long) 4)));
				BgL_siza7ezd2framez75_15189 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15183, (int) (((long) 5))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_17750;

					BgL_bpz00_17750 = VECTOR_REF(((obj_t) BgL_sz00_15190), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_valza2za2_17751;

						BgL_valza2za2_17751 =
							BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_15190,
							BgL_bpz00_17750, BgL_ifreesz00_15184);
						{	/* Eval/evaluate_comp.scm 1174 */
							obj_t BgL_runz00_17752;

							BgL_runz00_17752 =
								MAKE_FX_PROCEDURE(BGl_z62run5786z62zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 5)));
							PROCEDURE_SET(BgL_runz00_17752,
								(int) (((long) 0)), BgL_iboxesz00_15185);
							PROCEDURE_SET(BgL_runz00_17752,
								(int) (((long) 1)), BINT(BgL_siza7eza7_15186));
							PROCEDURE_SET(BgL_runz00_17752,
								(int) (((long) 2)), BgL_valza2za2_17751);
							PROCEDURE_SET(BgL_runz00_17752,
								(int) (((long) 3)), ((obj_t) BgL_i1247z00_15187));
							PROCEDURE_SET(BgL_runz00_17752,
								(int) (((long) 4)), BgL_bodyz00_15188);
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_mainz00_17753;

								BgL_mainz00_17753 =
									MAKE_FX_PROCEDURE(BGl_z62main5785z62zz__evaluate_compz00,
									(int) (((long) 0)), (int) (((long) 7)));
								PROCEDURE_SET(BgL_mainz00_17753,
									(int) (((long) 0)), BgL_iboxesz00_15185);
								PROCEDURE_SET(BgL_mainz00_17753,
									(int) (((long) 1)), BINT(BgL_siza7eza7_15186));
								PROCEDURE_SET(BgL_mainz00_17753,
									(int) (((long) 2)), BgL_valza2za2_17751);
								PROCEDURE_SET(BgL_mainz00_17753,
									(int) (((long) 3)), ((obj_t) BgL_i1247z00_15187));
								PROCEDURE_SET(BgL_mainz00_17753,
									(int) (((long) 4)), BgL_bodyz00_15188);
								PROCEDURE_SET(BgL_mainz00_17753,
									(int) (((long) 5)), BgL_runz00_17752);
								PROCEDURE_SET(BgL_mainz00_17753,
									(int) (((long) 6)), BINT(BgL_siza7ezd2framez75_15189));
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_objz00_17754;

									BgL_objz00_17754 =
										BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
									PROCEDURE_ATTR_SET(BgL_runz00_17752, BgL_objz00_17754);
									BgL_objz00_17754;
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_arg3476z00_17755;

									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_arg3477z00_17756;

										BgL_arg3477z00_17756 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_15187))->
											BgL_wherez00);
										{	/* Eval/evaluate_comp.scm 683 */
											obj_t BgL_newz00_17757;

											BgL_newz00_17757 =
												create_struct(BGl_symbol5824z00zz__evaluate_compz00,
												(int) (((long) 4)));
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_32046;

												BgL_tmpz00_32046 = (int) (((long) 3));
												STRUCT_SET(BgL_newz00_17757, BgL_tmpz00_32046,
													BgL_arg3477z00_17756);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_32051;
												int BgL_tmpz00_32049;

												BgL_auxz00_32051 = BINT(BgL_siza7ezd2framez75_15189);
												BgL_tmpz00_32049 = (int) (((long) 2));
												STRUCT_SET(BgL_newz00_17757, BgL_tmpz00_32049,
													BgL_auxz00_32051);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_32054;

												BgL_tmpz00_32054 = (int) (((long) 1));
												STRUCT_SET(BgL_newz00_17757, BgL_tmpz00_32054,
													BgL_runz00_17752);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_32059;
												int BgL_tmpz00_32057;

												BgL_auxz00_32059 = BINT(((long) 0));
												BgL_tmpz00_32057 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_17757, BgL_tmpz00_32057,
													BgL_auxz00_32059);
											}
											BgL_arg3476z00_17755 = BgL_newz00_17757;
									}}
									PROCEDURE_ATTR_SET(BgL_mainz00_17753, BgL_arg3476z00_17755);
									BgL_arg3476z00_17755;
								}
								return BgL_mainz00_17753;
							}
						}
					}
				}
			}
		}

	}



/* &main5785 */
	obj_t BGl_z62main5785z62zz__evaluate_compz00(obj_t BgL_envz00_15191)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_runz00_15197;
				long BgL_siza7ezd2framez75_15198;

				BgL_runz00_15197 =
					((obj_t) PROCEDURE_REF(BgL_envz00_15191, (int) (((long) 5))));
				BgL_siza7ezd2framez75_15198 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15191, (int) (((long) 6))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_sz00_17758;

					BgL_sz00_17758 = BGl_findzd2statezd2zz__evaluate_compz00();
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_bpz00_17759;

						BgL_bpz00_17759 = VECTOR_REF(((obj_t) BgL_sz00_17758), ((long) 0));
						if (
							(((long) CINT(BgL_bpz00_17759) + BgL_siza7ezd2framez75_15198) <
								VECTOR_LENGTH(((obj_t) BgL_sz00_17758))))
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_ez00_17760;

								BgL_ez00_17760 = BGL_EXITD_TOP_AS_OBJ();
								BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17760,
									BgL_bpz00_17759);
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_accz00_17761;

									BgL_accz00_17761 =
										BGl_catchzd2trampolinezd2zz__evaluate_compz00
										(BgL_runz00_15197, BgL_sz00_17758, BgL_bpz00_17759);
									BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_17760);
									VECTOR_SET(
										((obj_t) BgL_sz00_17758), ((long) 0), BgL_bpz00_17759);
									return BgL_accz00_17761;
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_nsz00_17762;

								BgL_nsz00_17762 = BGl_makezd2statezd2zz__evaluate_compz00();
								VECTOR_SET(BgL_nsz00_17762, ((long) 1), BgL_sz00_17758);
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_z12denvz12_17763;

									BgL_z12denvz12_17763 = BGL_CURRENT_DYNAMIC_ENV();
									BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17763, BgL_nsz00_17762);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_ez00_17764;

										BgL_ez00_17764 = BGL_EXITD_TOP_AS_OBJ();
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17764,
											BgL_sz00_17758);
										{	/* Eval/evaluate_comp.scm 1174 */
											obj_t BgL_____rz00_17765;

											{	/* Eval/evaluate_comp.scm 670 */
												obj_t BgL_savedzd2bpzd2_17766;

												BgL_savedzd2bpzd2_17766 =
													VECTOR_REF(BgL_nsz00_17762, ((long) 0));
												VECTOR_SET(BgL_nsz00_17762, ((long) 0),
													BINT(((long) 2)));
												{
													obj_t BgL_fz00_17768;

													BgL_fz00_17768 = BgL_runz00_15197;
												BgL_recz00_17767:
													{	/* Eval/evaluate_comp.scm 673 */
														obj_t BgL_rz00_17769;

														BgL_rz00_17769 =
															PROCEDURE_ENTRY(BgL_fz00_17768) (BgL_fz00_17768,
															BgL_nsz00_17762, BEOA);
														{	/* Eval/evaluate_comp.scm 674 */
															bool_t BgL_test6738z00_32097;

															if (PROCEDUREP(BgL_rz00_17769))
																{	/* Eval/evaluate_comp.scm 674 */
																	obj_t BgL_arg1702z00_17770;

																	BgL_arg1702z00_17770 =
																		PROCEDURE_ATTR(BgL_rz00_17769);
																	if (STRUCTP(BgL_arg1702z00_17770))
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test6738z00_32097 =
																				(STRUCT_KEY(BgL_arg1702z00_17770) ==
																				BGl_symbol5803z00zz__evaluate_compz00);
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test6738z00_32097 = ((bool_t) 0);
																		}
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	BgL_test6738z00_32097 = ((bool_t) 0);
																}
															if (BgL_test6738z00_32097)
																{
																	obj_t BgL_fz00_32105;

																	BgL_fz00_32105 = BgL_rz00_17769;
																	BgL_fz00_17768 = BgL_fz00_32105;
																	goto BgL_recz00_17767;
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	VECTOR_SET(BgL_nsz00_17762, ((long) 0),
																		BgL_savedzd2bpzd2_17766);
																	BgL_____rz00_17765 = BgL_rz00_17769;
											}}}}}
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_ez00_17764);
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17763, BgL_sz00_17758);
											return BgL_____rz00_17765;
										}
									}
								}
							}
					}
				}
			}
		}

	}



/* &run5786 */
	obj_t BGl_z62run5786z62zz__evaluate_compz00(obj_t BgL_envz00_15199,
		obj_t BgL_sz00_15205)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_iboxesz00_15200;
				long BgL_siza7eza7_15201;
				obj_t BgL_valza2za2_15202;
				BgL_ev_absz00_bglt BgL_i1247z00_15203;
				obj_t BgL_bodyz00_15204;

				BgL_iboxesz00_15200 =
					((obj_t) PROCEDURE_REF(BgL_envz00_15199, (int) (((long) 0))));
				BgL_siza7eza7_15201 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15199, (int) (((long) 1))));
				BgL_valza2za2_15202 =
					((obj_t) PROCEDURE_REF(BgL_envz00_15199, (int) (((long) 2))));
				BgL_i1247z00_15203 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_15199, (int) (((long) 3))));
				BgL_bodyz00_15204 = PROCEDURE_REF(BgL_envz00_15199, (int) (((long) 4)));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_17771;

					BgL_bpz00_17771 = VECTOR_REF(((obj_t) BgL_sz00_15205), ((long) 0));
					BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_15205,
						BgL_iboxesz00_15200, BgL_bpz00_17771);
					BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_15205,
						BgL_valza2za2_15202,
						((long) CINT(BgL_bpz00_17771) + BgL_siza7eza7_15201));
					{	/* Eval/evaluate_comp.scm 1095 */
						obj_t BgL_z12denvz12_17772;
						obj_t BgL_wherez00_17773;
						obj_t BgL_locz00_17774;

						BgL_z12denvz12_17772 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_wherez00_17773 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_15203))->
							BgL_wherez00);
						BgL_locz00_17774 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_15203))->BgL_locz00);
						{	/* Eval/evaluate_comp.scm 1095 */

							BGL_ENV_PUSH_TRACE(BgL_z12denvz12_17772, BgL_wherez00_17773,
								BgL_locz00_17774);
							{	/* Eval/evaluate_comp.scm 1095 */
								obj_t BgL_za2za2resza2za2z00_17775;

								BgL_za2za2resza2za2z00_17775 =
									PROCEDURE_ENTRY(BgL_bodyz00_15204) (BgL_bodyz00_15204,
									BgL_sz00_15205, BEOA);
								BGL_ENV_POP_TRACE(BgL_z12denvz12_17772);
								return BgL_za2za2resza2za2z00_17775;
							}
						}
					}
				}
			}
		}

	}



/* &<@anonymous:3933> */
	obj_t BGl_z62zc3z04anonymousza33933ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_15206, obj_t BgL_sz00_15210)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				BgL_ev_absz00_bglt BgL_i1247z00_15207;
				obj_t BgL_bodyz00_15208;
				long BgL_siza7ezd2framez75_15209;

				BgL_i1247z00_15207 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_15206, (int) (((long) 0))));
				BgL_bodyz00_15208 = PROCEDURE_REF(BgL_envz00_15206, (int) (((long) 1)));
				BgL_siza7ezd2framez75_15209 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15206, (int) (((long) 2))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_17776;

					BgL_bpz00_17776 = VECTOR_REF(((obj_t) BgL_sz00_15210), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1174 */

						{	/* Eval/evaluate_comp.scm 1174 */
							obj_t BgL_runz00_17777;

							BgL_runz00_17777 =
								MAKE_FX_PROCEDURE(BGl_z62run5788z62zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 2)));
							PROCEDURE_SET(BgL_runz00_17777,
								(int) (((long) 0)), ((obj_t) BgL_i1247z00_15207));
							PROCEDURE_SET(BgL_runz00_17777,
								(int) (((long) 1)), BgL_bodyz00_15208);
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_mainz00_17778;

								BgL_mainz00_17778 =
									MAKE_VA_PROCEDURE(BGl_z62main5787z62zz__evaluate_compz00,
									(int) (((long) -5)), (int) (((long) 4)));
								PROCEDURE_SET(BgL_mainz00_17778,
									(int) (((long) 0)), BgL_bodyz00_15208);
								PROCEDURE_SET(BgL_mainz00_17778,
									(int) (((long) 1)), ((obj_t) BgL_i1247z00_15207));
								PROCEDURE_SET(BgL_mainz00_17778,
									(int) (((long) 2)), BgL_runz00_17777);
								PROCEDURE_SET(BgL_mainz00_17778,
									(int) (((long) 3)), BINT(BgL_siza7ezd2framez75_15209));
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_objz00_17779;

									BgL_objz00_17779 =
										BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
									PROCEDURE_ATTR_SET(BgL_runz00_17777, BgL_objz00_17779);
									BgL_objz00_17779;
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_arg3934z00_17780;

									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_arg3935z00_17781;
										obj_t BgL_arg3936z00_17782;

										BgL_arg3935z00_17781 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_15207))->
											BgL_arityz00);
										BgL_arg3936z00_17782 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_15207))->
											BgL_wherez00);
										{	/* Eval/evaluate_comp.scm 683 */
											obj_t BgL_newz00_17783;

											BgL_newz00_17783 =
												create_struct(BGl_symbol5824z00zz__evaluate_compz00,
												(int) (((long) 4)));
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_32174;

												BgL_tmpz00_32174 = (int) (((long) 3));
												STRUCT_SET(BgL_newz00_17783, BgL_tmpz00_32174,
													BgL_arg3936z00_17782);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_32179;
												int BgL_tmpz00_32177;

												BgL_auxz00_32179 = BINT(BgL_siza7ezd2framez75_15209);
												BgL_tmpz00_32177 = (int) (((long) 2));
												STRUCT_SET(BgL_newz00_17783, BgL_tmpz00_32177,
													BgL_auxz00_32179);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_32182;

												BgL_tmpz00_32182 = (int) (((long) 1));
												STRUCT_SET(BgL_newz00_17783, BgL_tmpz00_32182,
													BgL_runz00_17777);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_32185;

												BgL_tmpz00_32185 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_17783, BgL_tmpz00_32185,
													BgL_arg3935z00_17781);
											}
											BgL_arg3934z00_17780 = BgL_newz00_17783;
									}}
									PROCEDURE_ATTR_SET(BgL_mainz00_17778, BgL_arg3934z00_17780);
									BgL_arg3934z00_17780;
								}
								return BgL_mainz00_17778;
							}
						}
					}
				}
			}
		}

	}



/* &main5787 */
	obj_t BGl_z62main5787z62zz__evaluate_compz00(obj_t BgL_envz00_15211,
		obj_t BgL_az00_15216, obj_t BgL_bz00_15217, obj_t BgL_cz00_15218,
		obj_t BgL_dz00_15219, obj_t BgL_restz00_15220)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				BgL_ev_absz00_bglt BgL_i1247z00_15213;
				obj_t BgL_runz00_15214;
				long BgL_siza7ezd2framez75_15215;

				BgL_i1247z00_15213 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_15211, (int) (((long) 1))));
				BgL_runz00_15214 =
					((obj_t) PROCEDURE_REF(BgL_envz00_15211, (int) (((long) 2))));
				BgL_siza7ezd2framez75_15215 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15211, (int) (((long) 3))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_sz00_17784;

					BgL_sz00_17784 = BGl_findzd2statezd2zz__evaluate_compz00();
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_bpz00_17785;

						BgL_bpz00_17785 = VECTOR_REF(((obj_t) BgL_sz00_17784), ((long) 0));
						if (
							(((long) CINT(BgL_bpz00_17785) + BgL_siza7ezd2framez75_15215) <
								VECTOR_LENGTH(((obj_t) BgL_sz00_17784))))
							{	/* Eval/evaluate_comp.scm 1174 */
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3939z00_17786;

									BgL_arg3939z00_17786 =
										((long) CINT(BgL_bpz00_17785) + ((long) 0));
									VECTOR_SET(
										((obj_t) BgL_sz00_17784), BgL_arg3939z00_17786,
										BgL_az00_15216);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3940z00_17787;

									BgL_arg3940z00_17787 =
										((long) CINT(BgL_bpz00_17785) + ((long) 1));
									VECTOR_SET(
										((obj_t) BgL_sz00_17784), BgL_arg3940z00_17787,
										BgL_bz00_15217);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3941z00_17788;

									BgL_arg3941z00_17788 =
										((long) CINT(BgL_bpz00_17785) + ((long) 2));
									VECTOR_SET(
										((obj_t) BgL_sz00_17784), BgL_arg3941z00_17788,
										BgL_cz00_15218);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3942z00_17789;

									BgL_arg3942z00_17789 =
										((long) CINT(BgL_bpz00_17785) + ((long) 3));
									VECTOR_SET(
										((obj_t) BgL_sz00_17784), BgL_arg3942z00_17789,
										BgL_dz00_15219);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_arg3943z00_17790;
									long BgL_arg3944z00_17791;
									long BgL_arg3945z00_17792;
									obj_t BgL_arg3946z00_17793;

									BgL_arg3943z00_17790 =
										(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_15213))->
										BgL_wherez00);
									BgL_arg3944z00_17791 =
										((long) CINT(BgL_bpz00_17785) + ((long) 4));
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_arg3947z00_17794;

										BgL_arg3947z00_17794 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_15213))->
											BgL_arityz00);
										if (((long) CINT(BgL_arg3947z00_17794) < ((long) 0)))
											{	/* Eval/evaluate_comp.scm 1059 */
												BgL_arg3945z00_17792 =
													((long) CINT(BgL_arg3947z00_17794) + ((long) 4));
											}
										else
											{	/* Eval/evaluate_comp.scm 1059 */
												BgL_arg3945z00_17792 =
													((long) CINT(BgL_arg3947z00_17794) - ((long) 4));
									}}
									BgL_arg3946z00_17793 =
										(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_15213))->
										BgL_locz00);
									BGl_bindzd2framezd2zz__evaluate_compz00(BgL_sz00_17784,
										BgL_arg3943z00_17790, BgL_arg3944z00_17791,
										BgL_arg3945z00_17792, BgL_restz00_15220,
										BgL_arg3946z00_17793);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_ez00_17795;

									BgL_ez00_17795 = BGL_EXITD_TOP_AS_OBJ();
									BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17795,
										BgL_bpz00_17785);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_accz00_17796;

										BgL_accz00_17796 =
											BGl_catchzd2trampolinezd2zz__evaluate_compz00
											(BgL_runz00_15214, BgL_sz00_17784, BgL_bpz00_17785);
										BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_17795);
										VECTOR_SET(
											((obj_t) BgL_sz00_17784), ((long) 0), BgL_bpz00_17785);
										return BgL_accz00_17796;
									}
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_nsz00_17797;

								BgL_nsz00_17797 = BGl_makezd2statezd2zz__evaluate_compz00();
								VECTOR_SET(BgL_nsz00_17797, ((long) 1), BgL_sz00_17784);
								VECTOR_SET(BgL_nsz00_17797, ((long) 2), BgL_az00_15216);
								VECTOR_SET(BgL_nsz00_17797, ((long) 3), BgL_bz00_15217);
								VECTOR_SET(BgL_nsz00_17797, ((long) 4), BgL_cz00_15218);
								VECTOR_SET(BgL_nsz00_17797, ((long) 5), BgL_dz00_15219);
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_arg3948z00_17798;
									long BgL_arg3949z00_17799;
									obj_t BgL_arg3950z00_17800;

									BgL_arg3948z00_17798 =
										(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_15213))->
										BgL_wherez00);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_arg3951z00_17801;

										BgL_arg3951z00_17801 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_15213))->
											BgL_arityz00);
										if (((long) CINT(BgL_arg3951z00_17801) < ((long) 0)))
											{	/* Eval/evaluate_comp.scm 1059 */
												BgL_arg3949z00_17799 =
													((long) CINT(BgL_arg3951z00_17801) + ((long) 4));
											}
										else
											{	/* Eval/evaluate_comp.scm 1059 */
												BgL_arg3949z00_17799 =
													((long) CINT(BgL_arg3951z00_17801) - ((long) 4));
									}}
									BgL_arg3950z00_17800 =
										(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_15213))->
										BgL_locz00);
									BGl_bindzd2framezd2zz__evaluate_compz00(BgL_nsz00_17797,
										BgL_arg3948z00_17798, ((long) 6), BgL_arg3949z00_17799,
										BgL_restz00_15220, BgL_arg3950z00_17800);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_z12denvz12_17802;

									BgL_z12denvz12_17802 = BGL_CURRENT_DYNAMIC_ENV();
									BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17802, BgL_nsz00_17797);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_ez00_17803;

										BgL_ez00_17803 = BGL_EXITD_TOP_AS_OBJ();
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17803,
											BgL_sz00_17784);
										{	/* Eval/evaluate_comp.scm 1174 */
											obj_t BgL_____rz00_17804;

											{	/* Eval/evaluate_comp.scm 670 */
												obj_t BgL_savedzd2bpzd2_17805;

												BgL_savedzd2bpzd2_17805 =
													VECTOR_REF(BgL_nsz00_17797, ((long) 0));
												VECTOR_SET(BgL_nsz00_17797, ((long) 0),
													BINT(((long) 2)));
												{
													obj_t BgL_fz00_17807;

													BgL_fz00_17807 = BgL_runz00_15214;
												BgL_recz00_17806:
													{	/* Eval/evaluate_comp.scm 673 */
														obj_t BgL_rz00_17808;

														BgL_rz00_17808 =
															PROCEDURE_ENTRY(BgL_fz00_17807) (BgL_fz00_17807,
															BgL_nsz00_17797, BEOA);
														{	/* Eval/evaluate_comp.scm 674 */
															bool_t BgL_test6744z00_32270;

															if (PROCEDUREP(BgL_rz00_17808))
																{	/* Eval/evaluate_comp.scm 674 */
																	obj_t BgL_arg1702z00_17809;

																	BgL_arg1702z00_17809 =
																		PROCEDURE_ATTR(BgL_rz00_17808);
																	if (STRUCTP(BgL_arg1702z00_17809))
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test6744z00_32270 =
																				(STRUCT_KEY(BgL_arg1702z00_17809) ==
																				BGl_symbol5803z00zz__evaluate_compz00);
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test6744z00_32270 = ((bool_t) 0);
																		}
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	BgL_test6744z00_32270 = ((bool_t) 0);
																}
															if (BgL_test6744z00_32270)
																{
																	obj_t BgL_fz00_32278;

																	BgL_fz00_32278 = BgL_rz00_17808;
																	BgL_fz00_17807 = BgL_fz00_32278;
																	goto BgL_recz00_17806;
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	VECTOR_SET(BgL_nsz00_17797, ((long) 0),
																		BgL_savedzd2bpzd2_17805);
																	BgL_____rz00_17804 = BgL_rz00_17808;
											}}}}}
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_ez00_17803);
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17802, BgL_sz00_17784);
											return BgL_____rz00_17804;
										}
									}
								}
							}
					}
				}
			}
		}

	}



/* &run5788 */
	obj_t BGl_z62run5788z62zz__evaluate_compz00(obj_t BgL_envz00_15221,
		obj_t BgL_sz00_15224)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				BgL_ev_absz00_bglt BgL_i1247z00_15222;
				obj_t BgL_bodyz00_15223;

				BgL_i1247z00_15222 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_15221, (int) (((long) 0))));
				BgL_bodyz00_15223 = PROCEDURE_REF(BgL_envz00_15221, (int) (((long) 1)));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_17810;

					BgL_bpz00_17810 = VECTOR_REF(((obj_t) BgL_sz00_15224), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_z12denvz12_17811;
						obj_t BgL_wherez00_17812;
						obj_t BgL_locz00_17813;

						BgL_z12denvz12_17811 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_wherez00_17812 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_15222))->
							BgL_wherez00);
						BgL_locz00_17813 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_15222))->BgL_locz00);
						{	/* Eval/evaluate_comp.scm 1174 */

							BGL_ENV_PUSH_TRACE(BgL_z12denvz12_17811, BgL_wherez00_17812,
								BgL_locz00_17813);
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_za2za2resza2za2z00_17814;

								BgL_za2za2resza2za2z00_17814 =
									PROCEDURE_ENTRY(BgL_bodyz00_15223) (BgL_bodyz00_15223,
									BgL_sz00_15224, BEOA);
								BGL_ENV_POP_TRACE(BgL_z12denvz12_17811);
								return BgL_za2za2resza2za2z00_17814;
							}
						}
					}
				}
			}
		}

	}



/* &<@anonymous:3953> */
	obj_t BGl_z62zc3z04anonymousza33953ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_15225, obj_t BgL_sz00_15230)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_iboxesz00_15226;
				BgL_ev_absz00_bglt BgL_i1247z00_15227;
				obj_t BgL_bodyz00_15228;
				long BgL_siza7ezd2framez75_15229;

				BgL_iboxesz00_15226 =
					((obj_t) PROCEDURE_REF(BgL_envz00_15225, (int) (((long) 0))));
				BgL_i1247z00_15227 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_15225, (int) (((long) 1))));
				BgL_bodyz00_15228 = PROCEDURE_REF(BgL_envz00_15225, (int) (((long) 2)));
				BgL_siza7ezd2framez75_15229 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15225, (int) (((long) 3))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_17815;

					BgL_bpz00_17815 = VECTOR_REF(((obj_t) BgL_sz00_15230), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1174 */

						{	/* Eval/evaluate_comp.scm 1174 */
							obj_t BgL_runz00_17816;

							BgL_runz00_17816 =
								MAKE_FX_PROCEDURE(BGl_z62run5790z62zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 3)));
							PROCEDURE_SET(BgL_runz00_17816,
								(int) (((long) 0)), BgL_iboxesz00_15226);
							PROCEDURE_SET(BgL_runz00_17816,
								(int) (((long) 1)), ((obj_t) BgL_i1247z00_15227));
							PROCEDURE_SET(BgL_runz00_17816,
								(int) (((long) 2)), BgL_bodyz00_15228);
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_mainz00_17817;

								BgL_mainz00_17817 =
									MAKE_VA_PROCEDURE(BGl_z62main5789z62zz__evaluate_compz00,
									(int) (((long) -5)), (int) (((long) 5)));
								PROCEDURE_SET(BgL_mainz00_17817,
									(int) (((long) 0)), BgL_iboxesz00_15226);
								PROCEDURE_SET(BgL_mainz00_17817,
									(int) (((long) 1)), BgL_bodyz00_15228);
								PROCEDURE_SET(BgL_mainz00_17817,
									(int) (((long) 2)), ((obj_t) BgL_i1247z00_15227));
								PROCEDURE_SET(BgL_mainz00_17817,
									(int) (((long) 3)), BgL_runz00_17816);
								PROCEDURE_SET(BgL_mainz00_17817,
									(int) (((long) 4)), BINT(BgL_siza7ezd2framez75_15229));
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_objz00_17818;

									BgL_objz00_17818 =
										BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
									PROCEDURE_ATTR_SET(BgL_runz00_17816, BgL_objz00_17818);
									BgL_objz00_17818;
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_arg3954z00_17819;

									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_arg3955z00_17820;
										obj_t BgL_arg3956z00_17821;

										BgL_arg3955z00_17820 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_15227))->
											BgL_arityz00);
										BgL_arg3956z00_17821 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_15227))->
											BgL_wherez00);
										{	/* Eval/evaluate_comp.scm 683 */
											obj_t BgL_newz00_17822;

											BgL_newz00_17822 =
												create_struct(BGl_symbol5824z00zz__evaluate_compz00,
												(int) (((long) 4)));
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_32341;

												BgL_tmpz00_32341 = (int) (((long) 3));
												STRUCT_SET(BgL_newz00_17822, BgL_tmpz00_32341,
													BgL_arg3956z00_17821);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_32346;
												int BgL_tmpz00_32344;

												BgL_auxz00_32346 = BINT(BgL_siza7ezd2framez75_15229);
												BgL_tmpz00_32344 = (int) (((long) 2));
												STRUCT_SET(BgL_newz00_17822, BgL_tmpz00_32344,
													BgL_auxz00_32346);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_32349;

												BgL_tmpz00_32349 = (int) (((long) 1));
												STRUCT_SET(BgL_newz00_17822, BgL_tmpz00_32349,
													BgL_runz00_17816);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_32352;

												BgL_tmpz00_32352 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_17822, BgL_tmpz00_32352,
													BgL_arg3955z00_17820);
											}
											BgL_arg3954z00_17819 = BgL_newz00_17822;
									}}
									PROCEDURE_ATTR_SET(BgL_mainz00_17817, BgL_arg3954z00_17819);
									BgL_arg3954z00_17819;
								}
								return BgL_mainz00_17817;
							}
						}
					}
				}
			}
		}

	}



/* &main5789 */
	obj_t BGl_z62main5789z62zz__evaluate_compz00(obj_t BgL_envz00_15231,
		obj_t BgL_az00_15237, obj_t BgL_bz00_15238, obj_t BgL_cz00_15239,
		obj_t BgL_dz00_15240, obj_t BgL_restz00_15241)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				BgL_ev_absz00_bglt BgL_i1247z00_15234;
				obj_t BgL_runz00_15235;
				long BgL_siza7ezd2framez75_15236;

				BgL_i1247z00_15234 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_15231, (int) (((long) 2))));
				BgL_runz00_15235 =
					((obj_t) PROCEDURE_REF(BgL_envz00_15231, (int) (((long) 3))));
				BgL_siza7ezd2framez75_15236 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15231, (int) (((long) 4))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_sz00_17823;

					BgL_sz00_17823 = BGl_findzd2statezd2zz__evaluate_compz00();
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_bpz00_17824;

						BgL_bpz00_17824 = VECTOR_REF(((obj_t) BgL_sz00_17823), ((long) 0));
						if (
							(((long) CINT(BgL_bpz00_17824) + BgL_siza7ezd2framez75_15236) <
								VECTOR_LENGTH(((obj_t) BgL_sz00_17823))))
							{	/* Eval/evaluate_comp.scm 1174 */
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3959z00_17825;

									BgL_arg3959z00_17825 =
										((long) CINT(BgL_bpz00_17824) + ((long) 0));
									VECTOR_SET(
										((obj_t) BgL_sz00_17823), BgL_arg3959z00_17825,
										BgL_az00_15237);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3960z00_17826;

									BgL_arg3960z00_17826 =
										((long) CINT(BgL_bpz00_17824) + ((long) 1));
									VECTOR_SET(
										((obj_t) BgL_sz00_17823), BgL_arg3960z00_17826,
										BgL_bz00_15238);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3961z00_17827;

									BgL_arg3961z00_17827 =
										((long) CINT(BgL_bpz00_17824) + ((long) 2));
									VECTOR_SET(
										((obj_t) BgL_sz00_17823), BgL_arg3961z00_17827,
										BgL_cz00_15239);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3962z00_17828;

									BgL_arg3962z00_17828 =
										((long) CINT(BgL_bpz00_17824) + ((long) 3));
									VECTOR_SET(
										((obj_t) BgL_sz00_17823), BgL_arg3962z00_17828,
										BgL_dz00_15240);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_arg3963z00_17829;
									long BgL_arg3964z00_17830;
									long BgL_arg3965z00_17831;
									obj_t BgL_arg3966z00_17832;

									BgL_arg3963z00_17829 =
										(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_15234))->
										BgL_wherez00);
									BgL_arg3964z00_17830 =
										((long) CINT(BgL_bpz00_17824) + ((long) 4));
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_arg3967z00_17833;

										BgL_arg3967z00_17833 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_15234))->
											BgL_arityz00);
										if (((long) CINT(BgL_arg3967z00_17833) < ((long) 0)))
											{	/* Eval/evaluate_comp.scm 1059 */
												BgL_arg3965z00_17831 =
													((long) CINT(BgL_arg3967z00_17833) + ((long) 4));
											}
										else
											{	/* Eval/evaluate_comp.scm 1059 */
												BgL_arg3965z00_17831 =
													((long) CINT(BgL_arg3967z00_17833) - ((long) 4));
									}}
									BgL_arg3966z00_17832 =
										(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_15234))->
										BgL_locz00);
									BGl_bindzd2framezd2zz__evaluate_compz00(BgL_sz00_17823,
										BgL_arg3963z00_17829, BgL_arg3964z00_17830,
										BgL_arg3965z00_17831, BgL_restz00_15241,
										BgL_arg3966z00_17832);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_ez00_17834;

									BgL_ez00_17834 = BGL_EXITD_TOP_AS_OBJ();
									BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17834,
										BgL_bpz00_17824);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_accz00_17835;

										BgL_accz00_17835 =
											BGl_catchzd2trampolinezd2zz__evaluate_compz00
											(BgL_runz00_15235, BgL_sz00_17823, BgL_bpz00_17824);
										BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_17834);
										VECTOR_SET(
											((obj_t) BgL_sz00_17823), ((long) 0), BgL_bpz00_17824);
										return BgL_accz00_17835;
									}
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_nsz00_17836;

								BgL_nsz00_17836 = BGl_makezd2statezd2zz__evaluate_compz00();
								VECTOR_SET(BgL_nsz00_17836, ((long) 1), BgL_sz00_17823);
								VECTOR_SET(BgL_nsz00_17836, ((long) 2), BgL_az00_15237);
								VECTOR_SET(BgL_nsz00_17836, ((long) 3), BgL_bz00_15238);
								VECTOR_SET(BgL_nsz00_17836, ((long) 4), BgL_cz00_15239);
								VECTOR_SET(BgL_nsz00_17836, ((long) 5), BgL_dz00_15240);
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_arg3968z00_17837;
									long BgL_arg3969z00_17838;
									obj_t BgL_arg3970z00_17839;

									BgL_arg3968z00_17837 =
										(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_15234))->
										BgL_wherez00);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_arg3971z00_17840;

										BgL_arg3971z00_17840 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_15234))->
											BgL_arityz00);
										if (((long) CINT(BgL_arg3971z00_17840) < ((long) 0)))
											{	/* Eval/evaluate_comp.scm 1059 */
												BgL_arg3969z00_17838 =
													((long) CINT(BgL_arg3971z00_17840) + ((long) 4));
											}
										else
											{	/* Eval/evaluate_comp.scm 1059 */
												BgL_arg3969z00_17838 =
													((long) CINT(BgL_arg3971z00_17840) - ((long) 4));
									}}
									BgL_arg3970z00_17839 =
										(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_15234))->
										BgL_locz00);
									BGl_bindzd2framezd2zz__evaluate_compz00(BgL_nsz00_17836,
										BgL_arg3968z00_17837, ((long) 6), BgL_arg3969z00_17838,
										BgL_restz00_15241, BgL_arg3970z00_17839);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_z12denvz12_17841;

									BgL_z12denvz12_17841 = BGL_CURRENT_DYNAMIC_ENV();
									BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17841, BgL_nsz00_17836);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_ez00_17842;

										BgL_ez00_17842 = BGL_EXITD_TOP_AS_OBJ();
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17842,
											BgL_sz00_17823);
										{	/* Eval/evaluate_comp.scm 1174 */
											obj_t BgL_____rz00_17843;

											{	/* Eval/evaluate_comp.scm 670 */
												obj_t BgL_savedzd2bpzd2_17844;

												BgL_savedzd2bpzd2_17844 =
													VECTOR_REF(BgL_nsz00_17836, ((long) 0));
												VECTOR_SET(BgL_nsz00_17836, ((long) 0),
													BINT(((long) 2)));
												{
													obj_t BgL_fz00_17846;

													BgL_fz00_17846 = BgL_runz00_15235;
												BgL_recz00_17845:
													{	/* Eval/evaluate_comp.scm 673 */
														obj_t BgL_rz00_17847;

														BgL_rz00_17847 =
															PROCEDURE_ENTRY(BgL_fz00_17846) (BgL_fz00_17846,
															BgL_nsz00_17836, BEOA);
														{	/* Eval/evaluate_comp.scm 674 */
															bool_t BgL_test6750z00_32437;

															if (PROCEDUREP(BgL_rz00_17847))
																{	/* Eval/evaluate_comp.scm 674 */
																	obj_t BgL_arg1702z00_17848;

																	BgL_arg1702z00_17848 =
																		PROCEDURE_ATTR(BgL_rz00_17847);
																	if (STRUCTP(BgL_arg1702z00_17848))
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test6750z00_32437 =
																				(STRUCT_KEY(BgL_arg1702z00_17848) ==
																				BGl_symbol5803z00zz__evaluate_compz00);
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test6750z00_32437 = ((bool_t) 0);
																		}
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	BgL_test6750z00_32437 = ((bool_t) 0);
																}
															if (BgL_test6750z00_32437)
																{
																	obj_t BgL_fz00_32445;

																	BgL_fz00_32445 = BgL_rz00_17847;
																	BgL_fz00_17846 = BgL_fz00_32445;
																	goto BgL_recz00_17845;
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	VECTOR_SET(BgL_nsz00_17836, ((long) 0),
																		BgL_savedzd2bpzd2_17844);
																	BgL_____rz00_17843 = BgL_rz00_17847;
											}}}}}
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_ez00_17842);
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17841, BgL_sz00_17823);
											return BgL_____rz00_17843;
										}
									}
								}
							}
					}
				}
			}
		}

	}



/* &run5790 */
	obj_t BGl_z62run5790z62zz__evaluate_compz00(obj_t BgL_envz00_15242,
		obj_t BgL_sz00_15246)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_iboxesz00_15243;
				BgL_ev_absz00_bglt BgL_i1247z00_15244;
				obj_t BgL_bodyz00_15245;

				BgL_iboxesz00_15243 =
					((obj_t) PROCEDURE_REF(BgL_envz00_15242, (int) (((long) 0))));
				BgL_i1247z00_15244 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_15242, (int) (((long) 1))));
				BgL_bodyz00_15245 = PROCEDURE_REF(BgL_envz00_15242, (int) (((long) 2)));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_17849;

					BgL_bpz00_17849 = VECTOR_REF(((obj_t) BgL_sz00_15246), ((long) 0));
					BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_15246,
						BgL_iboxesz00_15243, BgL_bpz00_17849);
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_z12denvz12_17850;
						obj_t BgL_wherez00_17851;
						obj_t BgL_locz00_17852;

						BgL_z12denvz12_17850 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_wherez00_17851 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_15244))->
							BgL_wherez00);
						BgL_locz00_17852 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_15244))->BgL_locz00);
						{	/* Eval/evaluate_comp.scm 1174 */

							BGL_ENV_PUSH_TRACE(BgL_z12denvz12_17850, BgL_wherez00_17851,
								BgL_locz00_17852);
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_za2za2resza2za2z00_17853;

								BgL_za2za2resza2za2z00_17853 =
									PROCEDURE_ENTRY(BgL_bodyz00_15245) (BgL_bodyz00_15245,
									BgL_sz00_15246, BEOA);
								BGL_ENV_POP_TRACE(BgL_z12denvz12_17850);
								return BgL_za2za2resza2za2z00_17853;
							}
						}
					}
				}
			}
		}

	}



/* &<@anonymous:3976> */
	obj_t BGl_z62zc3z04anonymousza33976ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_15247, obj_t BgL_sz00_15253)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_ifreesz00_15248;
				long BgL_siza7eza7_15249;
				BgL_ev_absz00_bglt BgL_i1247z00_15250;
				obj_t BgL_bodyz00_15251;
				long BgL_siza7ezd2framez75_15252;

				BgL_ifreesz00_15248 =
					((obj_t) PROCEDURE_REF(BgL_envz00_15247, (int) (((long) 0))));
				BgL_siza7eza7_15249 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15247, (int) (((long) 1))));
				BgL_i1247z00_15250 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_15247, (int) (((long) 2))));
				BgL_bodyz00_15251 = PROCEDURE_REF(BgL_envz00_15247, (int) (((long) 3)));
				BgL_siza7ezd2framez75_15252 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15247, (int) (((long) 4))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_17854;

					BgL_bpz00_17854 = VECTOR_REF(((obj_t) BgL_sz00_15253), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_valza2za2_17855;

						BgL_valza2za2_17855 =
							BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_15253,
							BgL_bpz00_17854, BgL_ifreesz00_15248);
						{	/* Eval/evaluate_comp.scm 1174 */
							obj_t BgL_runz00_17856;

							BgL_runz00_17856 =
								MAKE_FX_PROCEDURE(BGl_z62run5792z62zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 4)));
							PROCEDURE_SET(BgL_runz00_17856,
								(int) (((long) 0)), BINT(BgL_siza7eza7_15249));
							PROCEDURE_SET(BgL_runz00_17856,
								(int) (((long) 1)), BgL_valza2za2_17855);
							PROCEDURE_SET(BgL_runz00_17856,
								(int) (((long) 2)), ((obj_t) BgL_i1247z00_15250));
							PROCEDURE_SET(BgL_runz00_17856,
								(int) (((long) 3)), BgL_bodyz00_15251);
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_mainz00_17857;

								BgL_mainz00_17857 =
									MAKE_VA_PROCEDURE(BGl_z62main5791z62zz__evaluate_compz00,
									(int) (((long) -5)), (int) (((long) 6)));
								PROCEDURE_SET(BgL_mainz00_17857,
									(int) (((long) 0)), BINT(BgL_siza7eza7_15249));
								PROCEDURE_SET(BgL_mainz00_17857,
									(int) (((long) 1)), BgL_valza2za2_17855);
								PROCEDURE_SET(BgL_mainz00_17857,
									(int) (((long) 2)), BgL_bodyz00_15251);
								PROCEDURE_SET(BgL_mainz00_17857,
									(int) (((long) 3)), ((obj_t) BgL_i1247z00_15250));
								PROCEDURE_SET(BgL_mainz00_17857,
									(int) (((long) 4)), BgL_runz00_17856);
								PROCEDURE_SET(BgL_mainz00_17857,
									(int) (((long) 5)), BINT(BgL_siza7ezd2framez75_15252));
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_objz00_17858;

									BgL_objz00_17858 =
										BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
									PROCEDURE_ATTR_SET(BgL_runz00_17856, BgL_objz00_17858);
									BgL_objz00_17858;
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_arg3977z00_17859;

									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_arg3978z00_17860;
										obj_t BgL_arg3979z00_17861;

										BgL_arg3978z00_17860 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_15250))->
											BgL_arityz00);
										BgL_arg3979z00_17861 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_15250))->
											BgL_wherez00);
										{	/* Eval/evaluate_comp.scm 683 */
											obj_t BgL_newz00_17862;

											BgL_newz00_17862 =
												create_struct(BGl_symbol5824z00zz__evaluate_compz00,
												(int) (((long) 4)));
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_32522;

												BgL_tmpz00_32522 = (int) (((long) 3));
												STRUCT_SET(BgL_newz00_17862, BgL_tmpz00_32522,
													BgL_arg3979z00_17861);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_32527;
												int BgL_tmpz00_32525;

												BgL_auxz00_32527 = BINT(BgL_siza7ezd2framez75_15252);
												BgL_tmpz00_32525 = (int) (((long) 2));
												STRUCT_SET(BgL_newz00_17862, BgL_tmpz00_32525,
													BgL_auxz00_32527);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_32530;

												BgL_tmpz00_32530 = (int) (((long) 1));
												STRUCT_SET(BgL_newz00_17862, BgL_tmpz00_32530,
													BgL_runz00_17856);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_32533;

												BgL_tmpz00_32533 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_17862, BgL_tmpz00_32533,
													BgL_arg3978z00_17860);
											}
											BgL_arg3977z00_17859 = BgL_newz00_17862;
									}}
									PROCEDURE_ATTR_SET(BgL_mainz00_17857, BgL_arg3977z00_17859);
									BgL_arg3977z00_17859;
								}
								return BgL_mainz00_17857;
							}
						}
					}
				}
			}
		}

	}



/* &main5791 */
	obj_t BGl_z62main5791z62zz__evaluate_compz00(obj_t BgL_envz00_15254,
		obj_t BgL_az00_15261, obj_t BgL_bz00_15262, obj_t BgL_cz00_15263,
		obj_t BgL_dz00_15264, obj_t BgL_restz00_15265)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				BgL_ev_absz00_bglt BgL_i1247z00_15258;
				obj_t BgL_runz00_15259;
				long BgL_siza7ezd2framez75_15260;

				BgL_i1247z00_15258 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_15254, (int) (((long) 3))));
				BgL_runz00_15259 =
					((obj_t) PROCEDURE_REF(BgL_envz00_15254, (int) (((long) 4))));
				BgL_siza7ezd2framez75_15260 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15254, (int) (((long) 5))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_sz00_17863;

					BgL_sz00_17863 = BGl_findzd2statezd2zz__evaluate_compz00();
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_bpz00_17864;

						BgL_bpz00_17864 = VECTOR_REF(((obj_t) BgL_sz00_17863), ((long) 0));
						if (
							(((long) CINT(BgL_bpz00_17864) + BgL_siza7ezd2framez75_15260) <
								VECTOR_LENGTH(((obj_t) BgL_sz00_17863))))
							{	/* Eval/evaluate_comp.scm 1174 */
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3982z00_17865;

									BgL_arg3982z00_17865 =
										((long) CINT(BgL_bpz00_17864) + ((long) 0));
									VECTOR_SET(
										((obj_t) BgL_sz00_17863), BgL_arg3982z00_17865,
										BgL_az00_15261);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3983z00_17866;

									BgL_arg3983z00_17866 =
										((long) CINT(BgL_bpz00_17864) + ((long) 1));
									VECTOR_SET(
										((obj_t) BgL_sz00_17863), BgL_arg3983z00_17866,
										BgL_bz00_15262);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3984z00_17867;

									BgL_arg3984z00_17867 =
										((long) CINT(BgL_bpz00_17864) + ((long) 2));
									VECTOR_SET(
										((obj_t) BgL_sz00_17863), BgL_arg3984z00_17867,
										BgL_cz00_15263);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3985z00_17868;

									BgL_arg3985z00_17868 =
										((long) CINT(BgL_bpz00_17864) + ((long) 3));
									VECTOR_SET(
										((obj_t) BgL_sz00_17863), BgL_arg3985z00_17868,
										BgL_dz00_15264);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_arg3986z00_17869;
									long BgL_arg3987z00_17870;
									long BgL_arg3988z00_17871;
									obj_t BgL_arg3989z00_17872;

									BgL_arg3986z00_17869 =
										(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_15258))->
										BgL_wherez00);
									BgL_arg3987z00_17870 =
										((long) CINT(BgL_bpz00_17864) + ((long) 4));
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_arg3990z00_17873;

										BgL_arg3990z00_17873 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_15258))->
											BgL_arityz00);
										if (((long) CINT(BgL_arg3990z00_17873) < ((long) 0)))
											{	/* Eval/evaluate_comp.scm 1059 */
												BgL_arg3988z00_17871 =
													((long) CINT(BgL_arg3990z00_17873) + ((long) 4));
											}
										else
											{	/* Eval/evaluate_comp.scm 1059 */
												BgL_arg3988z00_17871 =
													((long) CINT(BgL_arg3990z00_17873) - ((long) 4));
									}}
									BgL_arg3989z00_17872 =
										(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_15258))->
										BgL_locz00);
									BGl_bindzd2framezd2zz__evaluate_compz00(BgL_sz00_17863,
										BgL_arg3986z00_17869, BgL_arg3987z00_17870,
										BgL_arg3988z00_17871, BgL_restz00_15265,
										BgL_arg3989z00_17872);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_ez00_17874;

									BgL_ez00_17874 = BGL_EXITD_TOP_AS_OBJ();
									BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17874,
										BgL_bpz00_17864);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_accz00_17875;

										BgL_accz00_17875 =
											BGl_catchzd2trampolinezd2zz__evaluate_compz00
											(BgL_runz00_15259, BgL_sz00_17863, BgL_bpz00_17864);
										BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_17874);
										VECTOR_SET(
											((obj_t) BgL_sz00_17863), ((long) 0), BgL_bpz00_17864);
										return BgL_accz00_17875;
									}
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_nsz00_17876;

								BgL_nsz00_17876 = BGl_makezd2statezd2zz__evaluate_compz00();
								VECTOR_SET(BgL_nsz00_17876, ((long) 1), BgL_sz00_17863);
								VECTOR_SET(BgL_nsz00_17876, ((long) 2), BgL_az00_15261);
								VECTOR_SET(BgL_nsz00_17876, ((long) 3), BgL_bz00_15262);
								VECTOR_SET(BgL_nsz00_17876, ((long) 4), BgL_cz00_15263);
								VECTOR_SET(BgL_nsz00_17876, ((long) 5), BgL_dz00_15264);
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_arg3991z00_17877;
									long BgL_arg3992z00_17878;
									obj_t BgL_arg3993z00_17879;

									BgL_arg3991z00_17877 =
										(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_15258))->
										BgL_wherez00);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_arg3994z00_17880;

										BgL_arg3994z00_17880 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_15258))->
											BgL_arityz00);
										if (((long) CINT(BgL_arg3994z00_17880) < ((long) 0)))
											{	/* Eval/evaluate_comp.scm 1059 */
												BgL_arg3992z00_17878 =
													((long) CINT(BgL_arg3994z00_17880) + ((long) 4));
											}
										else
											{	/* Eval/evaluate_comp.scm 1059 */
												BgL_arg3992z00_17878 =
													((long) CINT(BgL_arg3994z00_17880) - ((long) 4));
									}}
									BgL_arg3993z00_17879 =
										(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_15258))->
										BgL_locz00);
									BGl_bindzd2framezd2zz__evaluate_compz00(BgL_nsz00_17876,
										BgL_arg3991z00_17877, ((long) 6), BgL_arg3992z00_17878,
										BgL_restz00_15265, BgL_arg3993z00_17879);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_z12denvz12_17881;

									BgL_z12denvz12_17881 = BGL_CURRENT_DYNAMIC_ENV();
									BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17881, BgL_nsz00_17876);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_ez00_17882;

										BgL_ez00_17882 = BGL_EXITD_TOP_AS_OBJ();
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17882,
											BgL_sz00_17863);
										{	/* Eval/evaluate_comp.scm 1174 */
											obj_t BgL_____rz00_17883;

											{	/* Eval/evaluate_comp.scm 670 */
												obj_t BgL_savedzd2bpzd2_17884;

												BgL_savedzd2bpzd2_17884 =
													VECTOR_REF(BgL_nsz00_17876, ((long) 0));
												VECTOR_SET(BgL_nsz00_17876, ((long) 0),
													BINT(((long) 2)));
												{
													obj_t BgL_fz00_17886;

													BgL_fz00_17886 = BgL_runz00_15259;
												BgL_recz00_17885:
													{	/* Eval/evaluate_comp.scm 673 */
														obj_t BgL_rz00_17887;

														BgL_rz00_17887 =
															PROCEDURE_ENTRY(BgL_fz00_17886) (BgL_fz00_17886,
															BgL_nsz00_17876, BEOA);
														{	/* Eval/evaluate_comp.scm 674 */
															bool_t BgL_test6756z00_32618;

															if (PROCEDUREP(BgL_rz00_17887))
																{	/* Eval/evaluate_comp.scm 674 */
																	obj_t BgL_arg1702z00_17888;

																	BgL_arg1702z00_17888 =
																		PROCEDURE_ATTR(BgL_rz00_17887);
																	if (STRUCTP(BgL_arg1702z00_17888))
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test6756z00_32618 =
																				(STRUCT_KEY(BgL_arg1702z00_17888) ==
																				BGl_symbol5803z00zz__evaluate_compz00);
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test6756z00_32618 = ((bool_t) 0);
																		}
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	BgL_test6756z00_32618 = ((bool_t) 0);
																}
															if (BgL_test6756z00_32618)
																{
																	obj_t BgL_fz00_32626;

																	BgL_fz00_32626 = BgL_rz00_17887;
																	BgL_fz00_17886 = BgL_fz00_32626;
																	goto BgL_recz00_17885;
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	VECTOR_SET(BgL_nsz00_17876, ((long) 0),
																		BgL_savedzd2bpzd2_17884);
																	BgL_____rz00_17883 = BgL_rz00_17887;
											}}}}}
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_ez00_17882);
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17881, BgL_sz00_17863);
											return BgL_____rz00_17883;
										}
									}
								}
							}
					}
				}
			}
		}

	}



/* &run5792 */
	obj_t BGl_z62run5792z62zz__evaluate_compz00(obj_t BgL_envz00_15266,
		obj_t BgL_sz00_15271)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				long BgL_siza7eza7_15267;
				obj_t BgL_valza2za2_15268;
				BgL_ev_absz00_bglt BgL_i1247z00_15269;
				obj_t BgL_bodyz00_15270;

				BgL_siza7eza7_15267 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15266, (int) (((long) 0))));
				BgL_valza2za2_15268 =
					((obj_t) PROCEDURE_REF(BgL_envz00_15266, (int) (((long) 1))));
				BgL_i1247z00_15269 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_15266, (int) (((long) 2))));
				BgL_bodyz00_15270 = PROCEDURE_REF(BgL_envz00_15266, (int) (((long) 3)));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_17889;

					BgL_bpz00_17889 = VECTOR_REF(((obj_t) BgL_sz00_15271), ((long) 0));
					BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_15271,
						BgL_valza2za2_15268,
						((long) CINT(BgL_bpz00_17889) + BgL_siza7eza7_15267));
					{	/* Eval/evaluate_comp.scm 1095 */
						obj_t BgL_z12denvz12_17890;
						obj_t BgL_wherez00_17891;
						obj_t BgL_locz00_17892;

						BgL_z12denvz12_17890 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_wherez00_17891 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_15269))->
							BgL_wherez00);
						BgL_locz00_17892 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_15269))->BgL_locz00);
						{	/* Eval/evaluate_comp.scm 1095 */

							BGL_ENV_PUSH_TRACE(BgL_z12denvz12_17890, BgL_wherez00_17891,
								BgL_locz00_17892);
							{	/* Eval/evaluate_comp.scm 1095 */
								obj_t BgL_za2za2resza2za2z00_17893;

								BgL_za2za2resza2za2z00_17893 =
									PROCEDURE_ENTRY(BgL_bodyz00_15270) (BgL_bodyz00_15270,
									BgL_sz00_15271, BEOA);
								BGL_ENV_POP_TRACE(BgL_z12denvz12_17890);
								return BgL_za2za2resza2za2z00_17893;
							}
						}
					}
				}
			}
		}

	}



/* &<@anonymous:3997> */
	obj_t BGl_z62zc3z04anonymousza33997ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_15272, obj_t BgL_sz00_15279)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_ifreesz00_15273;
				obj_t BgL_iboxesz00_15274;
				long BgL_siza7eza7_15275;
				BgL_ev_absz00_bglt BgL_i1247z00_15276;
				obj_t BgL_bodyz00_15277;
				long BgL_siza7ezd2framez75_15278;

				BgL_ifreesz00_15273 =
					((obj_t) PROCEDURE_REF(BgL_envz00_15272, (int) (((long) 0))));
				BgL_iboxesz00_15274 =
					((obj_t) PROCEDURE_REF(BgL_envz00_15272, (int) (((long) 1))));
				BgL_siza7eza7_15275 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15272, (int) (((long) 2))));
				BgL_i1247z00_15276 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_15272, (int) (((long) 3))));
				BgL_bodyz00_15277 = PROCEDURE_REF(BgL_envz00_15272, (int) (((long) 4)));
				BgL_siza7ezd2framez75_15278 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15272, (int) (((long) 5))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_17894;

					BgL_bpz00_17894 = VECTOR_REF(((obj_t) BgL_sz00_15279), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_valza2za2_17895;

						BgL_valza2za2_17895 =
							BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_15279,
							BgL_bpz00_17894, BgL_ifreesz00_15273);
						{	/* Eval/evaluate_comp.scm 1174 */
							obj_t BgL_runz00_17896;

							BgL_runz00_17896 =
								MAKE_FX_PROCEDURE(BGl_z62run5794z62zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 5)));
							PROCEDURE_SET(BgL_runz00_17896,
								(int) (((long) 0)), BgL_iboxesz00_15274);
							PROCEDURE_SET(BgL_runz00_17896,
								(int) (((long) 1)), BINT(BgL_siza7eza7_15275));
							PROCEDURE_SET(BgL_runz00_17896,
								(int) (((long) 2)), BgL_valza2za2_17895);
							PROCEDURE_SET(BgL_runz00_17896,
								(int) (((long) 3)), ((obj_t) BgL_i1247z00_15276));
							PROCEDURE_SET(BgL_runz00_17896,
								(int) (((long) 4)), BgL_bodyz00_15277);
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_mainz00_17897;

								BgL_mainz00_17897 =
									MAKE_VA_PROCEDURE(BGl_z62main5793z62zz__evaluate_compz00,
									(int) (((long) -5)), (int) (((long) 7)));
								PROCEDURE_SET(BgL_mainz00_17897,
									(int) (((long) 0)), BgL_iboxesz00_15274);
								PROCEDURE_SET(BgL_mainz00_17897,
									(int) (((long) 1)), BINT(BgL_siza7eza7_15275));
								PROCEDURE_SET(BgL_mainz00_17897,
									(int) (((long) 2)), BgL_valza2za2_17895);
								PROCEDURE_SET(BgL_mainz00_17897,
									(int) (((long) 3)), BgL_bodyz00_15277);
								PROCEDURE_SET(BgL_mainz00_17897,
									(int) (((long) 4)), ((obj_t) BgL_i1247z00_15276));
								PROCEDURE_SET(BgL_mainz00_17897,
									(int) (((long) 5)), BgL_runz00_17896);
								PROCEDURE_SET(BgL_mainz00_17897,
									(int) (((long) 6)), BINT(BgL_siza7ezd2framez75_15278));
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_objz00_17898;

									BgL_objz00_17898 =
										BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
									PROCEDURE_ATTR_SET(BgL_runz00_17896, BgL_objz00_17898);
									BgL_objz00_17898;
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_arg3998z00_17899;

									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_arg3999z00_17900;
										obj_t BgL_arg4000z00_17901;

										BgL_arg3999z00_17900 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_15276))->
											BgL_arityz00);
										BgL_arg4000z00_17901 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_15276))->
											BgL_wherez00);
										{	/* Eval/evaluate_comp.scm 683 */
											obj_t BgL_newz00_17902;

											BgL_newz00_17902 =
												create_struct(BGl_symbol5824z00zz__evaluate_compz00,
												(int) (((long) 4)));
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_32715;

												BgL_tmpz00_32715 = (int) (((long) 3));
												STRUCT_SET(BgL_newz00_17902, BgL_tmpz00_32715,
													BgL_arg4000z00_17901);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_32720;
												int BgL_tmpz00_32718;

												BgL_auxz00_32720 = BINT(BgL_siza7ezd2framez75_15278);
												BgL_tmpz00_32718 = (int) (((long) 2));
												STRUCT_SET(BgL_newz00_17902, BgL_tmpz00_32718,
													BgL_auxz00_32720);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_32723;

												BgL_tmpz00_32723 = (int) (((long) 1));
												STRUCT_SET(BgL_newz00_17902, BgL_tmpz00_32723,
													BgL_runz00_17896);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_32726;

												BgL_tmpz00_32726 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_17902, BgL_tmpz00_32726,
													BgL_arg3999z00_17900);
											}
											BgL_arg3998z00_17899 = BgL_newz00_17902;
									}}
									PROCEDURE_ATTR_SET(BgL_mainz00_17897, BgL_arg3998z00_17899);
									BgL_arg3998z00_17899;
								}
								return BgL_mainz00_17897;
							}
						}
					}
				}
			}
		}

	}



/* &main5793 */
	obj_t BGl_z62main5793z62zz__evaluate_compz00(obj_t BgL_envz00_15280,
		obj_t BgL_az00_15288, obj_t BgL_bz00_15289, obj_t BgL_cz00_15290,
		obj_t BgL_dz00_15291, obj_t BgL_restz00_15292)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				BgL_ev_absz00_bglt BgL_i1247z00_15285;
				obj_t BgL_runz00_15286;
				long BgL_siza7ezd2framez75_15287;

				BgL_i1247z00_15285 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_15280, (int) (((long) 4))));
				BgL_runz00_15286 =
					((obj_t) PROCEDURE_REF(BgL_envz00_15280, (int) (((long) 5))));
				BgL_siza7ezd2framez75_15287 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15280, (int) (((long) 6))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_sz00_17903;

					BgL_sz00_17903 = BGl_findzd2statezd2zz__evaluate_compz00();
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_bpz00_17904;

						BgL_bpz00_17904 = VECTOR_REF(((obj_t) BgL_sz00_17903), ((long) 0));
						if (
							(((long) CINT(BgL_bpz00_17904) + BgL_siza7ezd2framez75_15287) <
								VECTOR_LENGTH(((obj_t) BgL_sz00_17903))))
							{	/* Eval/evaluate_comp.scm 1174 */
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg4003z00_17905;

									BgL_arg4003z00_17905 =
										((long) CINT(BgL_bpz00_17904) + ((long) 0));
									VECTOR_SET(
										((obj_t) BgL_sz00_17903), BgL_arg4003z00_17905,
										BgL_az00_15288);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg4004z00_17906;

									BgL_arg4004z00_17906 =
										((long) CINT(BgL_bpz00_17904) + ((long) 1));
									VECTOR_SET(
										((obj_t) BgL_sz00_17903), BgL_arg4004z00_17906,
										BgL_bz00_15289);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg4005z00_17907;

									BgL_arg4005z00_17907 =
										((long) CINT(BgL_bpz00_17904) + ((long) 2));
									VECTOR_SET(
										((obj_t) BgL_sz00_17903), BgL_arg4005z00_17907,
										BgL_cz00_15290);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg4006z00_17908;

									BgL_arg4006z00_17908 =
										((long) CINT(BgL_bpz00_17904) + ((long) 3));
									VECTOR_SET(
										((obj_t) BgL_sz00_17903), BgL_arg4006z00_17908,
										BgL_dz00_15291);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_arg4007z00_17909;
									long BgL_arg4008z00_17910;
									long BgL_arg4009z00_17911;
									obj_t BgL_arg4010z00_17912;

									BgL_arg4007z00_17909 =
										(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_15285))->
										BgL_wherez00);
									BgL_arg4008z00_17910 =
										((long) CINT(BgL_bpz00_17904) + ((long) 4));
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_arg4011z00_17913;

										BgL_arg4011z00_17913 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_15285))->
											BgL_arityz00);
										if (((long) CINT(BgL_arg4011z00_17913) < ((long) 0)))
											{	/* Eval/evaluate_comp.scm 1059 */
												BgL_arg4009z00_17911 =
													((long) CINT(BgL_arg4011z00_17913) + ((long) 4));
											}
										else
											{	/* Eval/evaluate_comp.scm 1059 */
												BgL_arg4009z00_17911 =
													((long) CINT(BgL_arg4011z00_17913) - ((long) 4));
									}}
									BgL_arg4010z00_17912 =
										(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_15285))->
										BgL_locz00);
									BGl_bindzd2framezd2zz__evaluate_compz00(BgL_sz00_17903,
										BgL_arg4007z00_17909, BgL_arg4008z00_17910,
										BgL_arg4009z00_17911, BgL_restz00_15292,
										BgL_arg4010z00_17912);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_ez00_17914;

									BgL_ez00_17914 = BGL_EXITD_TOP_AS_OBJ();
									BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17914,
										BgL_bpz00_17904);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_accz00_17915;

										BgL_accz00_17915 =
											BGl_catchzd2trampolinezd2zz__evaluate_compz00
											(BgL_runz00_15286, BgL_sz00_17903, BgL_bpz00_17904);
										BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_17914);
										VECTOR_SET(
											((obj_t) BgL_sz00_17903), ((long) 0), BgL_bpz00_17904);
										return BgL_accz00_17915;
									}
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_nsz00_17916;

								BgL_nsz00_17916 = BGl_makezd2statezd2zz__evaluate_compz00();
								VECTOR_SET(BgL_nsz00_17916, ((long) 1), BgL_sz00_17903);
								VECTOR_SET(BgL_nsz00_17916, ((long) 2), BgL_az00_15288);
								VECTOR_SET(BgL_nsz00_17916, ((long) 3), BgL_bz00_15289);
								VECTOR_SET(BgL_nsz00_17916, ((long) 4), BgL_cz00_15290);
								VECTOR_SET(BgL_nsz00_17916, ((long) 5), BgL_dz00_15291);
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_arg4012z00_17917;
									long BgL_arg4013z00_17918;
									obj_t BgL_arg4014z00_17919;

									BgL_arg4012z00_17917 =
										(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_15285))->
										BgL_wherez00);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_arg4015z00_17920;

										BgL_arg4015z00_17920 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_15285))->
											BgL_arityz00);
										if (((long) CINT(BgL_arg4015z00_17920) < ((long) 0)))
											{	/* Eval/evaluate_comp.scm 1059 */
												BgL_arg4013z00_17918 =
													((long) CINT(BgL_arg4015z00_17920) + ((long) 4));
											}
										else
											{	/* Eval/evaluate_comp.scm 1059 */
												BgL_arg4013z00_17918 =
													((long) CINT(BgL_arg4015z00_17920) - ((long) 4));
									}}
									BgL_arg4014z00_17919 =
										(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_15285))->
										BgL_locz00);
									BGl_bindzd2framezd2zz__evaluate_compz00(BgL_nsz00_17916,
										BgL_arg4012z00_17917, ((long) 6), BgL_arg4013z00_17918,
										BgL_restz00_15292, BgL_arg4014z00_17919);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_z12denvz12_17921;

									BgL_z12denvz12_17921 = BGL_CURRENT_DYNAMIC_ENV();
									BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17921, BgL_nsz00_17916);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_ez00_17922;

										BgL_ez00_17922 = BGL_EXITD_TOP_AS_OBJ();
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17922,
											BgL_sz00_17903);
										{	/* Eval/evaluate_comp.scm 1174 */
											obj_t BgL_____rz00_17923;

											{	/* Eval/evaluate_comp.scm 670 */
												obj_t BgL_savedzd2bpzd2_17924;

												BgL_savedzd2bpzd2_17924 =
													VECTOR_REF(BgL_nsz00_17916, ((long) 0));
												VECTOR_SET(BgL_nsz00_17916, ((long) 0),
													BINT(((long) 2)));
												{
													obj_t BgL_fz00_17926;

													BgL_fz00_17926 = BgL_runz00_15286;
												BgL_recz00_17925:
													{	/* Eval/evaluate_comp.scm 673 */
														obj_t BgL_rz00_17927;

														BgL_rz00_17927 =
															PROCEDURE_ENTRY(BgL_fz00_17926) (BgL_fz00_17926,
															BgL_nsz00_17916, BEOA);
														{	/* Eval/evaluate_comp.scm 674 */
															bool_t BgL_test6762z00_32811;

															if (PROCEDUREP(BgL_rz00_17927))
																{	/* Eval/evaluate_comp.scm 674 */
																	obj_t BgL_arg1702z00_17928;

																	BgL_arg1702z00_17928 =
																		PROCEDURE_ATTR(BgL_rz00_17927);
																	if (STRUCTP(BgL_arg1702z00_17928))
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test6762z00_32811 =
																				(STRUCT_KEY(BgL_arg1702z00_17928) ==
																				BGl_symbol5803z00zz__evaluate_compz00);
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test6762z00_32811 = ((bool_t) 0);
																		}
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	BgL_test6762z00_32811 = ((bool_t) 0);
																}
															if (BgL_test6762z00_32811)
																{
																	obj_t BgL_fz00_32819;

																	BgL_fz00_32819 = BgL_rz00_17927;
																	BgL_fz00_17926 = BgL_fz00_32819;
																	goto BgL_recz00_17925;
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	VECTOR_SET(BgL_nsz00_17916, ((long) 0),
																		BgL_savedzd2bpzd2_17924);
																	BgL_____rz00_17923 = BgL_rz00_17927;
											}}}}}
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_ez00_17922);
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17921, BgL_sz00_17903);
											return BgL_____rz00_17923;
										}
									}
								}
							}
					}
				}
			}
		}

	}



/* &run5794 */
	obj_t BGl_z62run5794z62zz__evaluate_compz00(obj_t BgL_envz00_15293,
		obj_t BgL_sz00_15299)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_iboxesz00_15294;
				long BgL_siza7eza7_15295;
				obj_t BgL_valza2za2_15296;
				BgL_ev_absz00_bglt BgL_i1247z00_15297;
				obj_t BgL_bodyz00_15298;

				BgL_iboxesz00_15294 =
					((obj_t) PROCEDURE_REF(BgL_envz00_15293, (int) (((long) 0))));
				BgL_siza7eza7_15295 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15293, (int) (((long) 1))));
				BgL_valza2za2_15296 =
					((obj_t) PROCEDURE_REF(BgL_envz00_15293, (int) (((long) 2))));
				BgL_i1247z00_15297 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_15293, (int) (((long) 3))));
				BgL_bodyz00_15298 = PROCEDURE_REF(BgL_envz00_15293, (int) (((long) 4)));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_17929;

					BgL_bpz00_17929 = VECTOR_REF(((obj_t) BgL_sz00_15299), ((long) 0));
					BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_15299,
						BgL_iboxesz00_15294, BgL_bpz00_17929);
					BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_15299,
						BgL_valza2za2_15296,
						((long) CINT(BgL_bpz00_17929) + BgL_siza7eza7_15295));
					{	/* Eval/evaluate_comp.scm 1095 */
						obj_t BgL_z12denvz12_17930;
						obj_t BgL_wherez00_17931;
						obj_t BgL_locz00_17932;

						BgL_z12denvz12_17930 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_wherez00_17931 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_15297))->
							BgL_wherez00);
						BgL_locz00_17932 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_15297))->BgL_locz00);
						{	/* Eval/evaluate_comp.scm 1095 */

							BGL_ENV_PUSH_TRACE(BgL_z12denvz12_17930, BgL_wherez00_17931,
								BgL_locz00_17932);
							{	/* Eval/evaluate_comp.scm 1095 */
								obj_t BgL_za2za2resza2za2z00_17933;

								BgL_za2za2resza2za2z00_17933 =
									PROCEDURE_ENTRY(BgL_bodyz00_15298) (BgL_bodyz00_15298,
									BgL_sz00_15299, BEOA);
								BGL_ENV_POP_TRACE(BgL_z12denvz12_17930);
								return BgL_za2za2resza2za2z00_17933;
							}
						}
					}
				}
			}
		}

	}



/* &comp-ev_app1437 */
	obj_t BGl_z62compzd2ev_app1437zb0zz__evaluate_compz00(obj_t BgL_envz00_15300,
		obj_t BgL_ez00_15301, obj_t BgL_stkz00_15302)
	{
		{	/* Eval/evaluate_comp.scm 1044 */
			{	/* Eval/evaluate_comp.scm 1046 */
				obj_t BgL__ortest_1233z00_17935;

				BgL__ortest_1233z00_17935 =
					BGl_arithzd2expressionzd2zz__evaluate_compz00(
					((BgL_ev_appz00_bglt) BgL_ez00_15301), BgL_stkz00_15302);
				if (CBOOL(BgL__ortest_1233z00_17935))
					{	/* Eval/evaluate_comp.scm 1046 */
						return BgL__ortest_1233z00_17935;
					}
				else
					{	/* Eval/evaluate_comp.scm 1047 */
						obj_t BgL__ortest_1234z00_17936;

						BgL__ortest_1234z00_17936 =
							BGl_inlinezd2callzd2zz__evaluate_compz00(
							(((BgL_ev_appz00_bglt) COBJECT(
										((BgL_ev_appz00_bglt) BgL_ez00_15301)))->BgL_locz00),
							(((BgL_ev_appz00_bglt) COBJECT(
										((BgL_ev_appz00_bglt) BgL_ez00_15301)))->BgL_funz00),
							(((BgL_ev_appz00_bglt) COBJECT(
										((BgL_ev_appz00_bglt) BgL_ez00_15301)))->BgL_argsz00),
							BgL_stkz00_15302);
						if (CBOOL(BgL__ortest_1234z00_17936))
							{	/* Eval/evaluate_comp.scm 1047 */
								return BgL__ortest_1234z00_17936;
							}
						else
							{	/* Eval/evaluate_comp.scm 1047 */
								if (
									(bgl_list_length(
											(((BgL_ev_appz00_bglt) COBJECT(
														((BgL_ev_appz00_bglt) BgL_ez00_15301)))->
												BgL_argsz00)) > ((long) 4)))
									{	/* Eval/evaluate_comp.scm 1048 */
										return
											BGl_compzd2oldzd2callz00zz__evaluate_compz00(
											((BgL_ev_appz00_bglt) BgL_ez00_15301), BgL_stkz00_15302);
									}
								else
									{	/* Eval/evaluate_comp.scm 1050 */
										obj_t BgL_fz00_17937;
										long BgL_siza7eza7_17938;
										obj_t BgL_symbzd2funzd2_17939;

										BgL_fz00_17937 =
											BGl_compz00zz__evaluate_compz00(
											(((BgL_ev_appz00_bglt) COBJECT(
														((BgL_ev_appz00_bglt) BgL_ez00_15301)))->
												BgL_funz00), BgL_stkz00_15302);
										BgL_siza7eza7_17938 = bgl_list_length(BgL_stkz00_15302);
										BgL_symbzd2funzd2_17939 =
											BGl_uncompilez00zz__evaluate_uncompz00(
											(((BgL_ev_appz00_bglt) COBJECT(
														((BgL_ev_appz00_bglt) BgL_ez00_15301)))->
												BgL_funz00));
										if (NULLP((((BgL_ev_appz00_bglt)
														COBJECT(((BgL_ev_appz00_bglt) BgL_ez00_15301)))->
													BgL_argsz00)))
											{	/* Eval/evaluate_comp.scm 1051 */
												return
													BGl_compzd2call0zd2zz__evaluate_compz00(
													(((BgL_ev_appz00_bglt) COBJECT(
																((BgL_ev_appz00_bglt) BgL_ez00_15301)))->
														BgL_locz00),
													(((BgL_ev_appz00_bglt) COBJECT(((BgL_ev_appz00_bglt)
																	BgL_ez00_15301)))->BgL_funz00),
													BgL_symbzd2funzd2_17939, BgL_fz00_17937,
													(((BgL_ev_appz00_bglt) COBJECT(((BgL_ev_appz00_bglt)
																	BgL_ez00_15301)))->BgL_tailzf3zf3),
													BgL_stkz00_15302, BgL_siza7eza7_17938);
											}
										else
											{	/* Eval/evaluate_comp.scm 1053 */
												obj_t BgL_a1z00_17940;
												obj_t BgL_argsz00_17941;

												{	/* Eval/evaluate_comp.scm 1053 */
													obj_t BgL_arg3431z00_17942;

													BgL_arg3431z00_17942 =
														CAR(
														(((BgL_ev_appz00_bglt) COBJECT(
																	((BgL_ev_appz00_bglt) BgL_ez00_15301)))->
															BgL_argsz00));
													BgL_a1z00_17940 =
														BGl_compz00zz__evaluate_compz00((
															(BgL_ev_exprz00_bglt) BgL_arg3431z00_17942),
														BgL_stkz00_15302);
												}
												BgL_argsz00_17941 =
													CDR(
													(((BgL_ev_appz00_bglt) COBJECT(
																((BgL_ev_appz00_bglt) BgL_ez00_15301)))->
														BgL_argsz00));
												if (NULLP(BgL_argsz00_17941))
													{	/* Eval/evaluate_comp.scm 1053 */
														return
															BGl_compzd2call1zd2zz__evaluate_compz00(
															(((BgL_ev_appz00_bglt) COBJECT(
																		((BgL_ev_appz00_bglt) BgL_ez00_15301)))->
																BgL_locz00),
															(((BgL_ev_appz00_bglt)
																	COBJECT(((BgL_ev_appz00_bglt)
																			BgL_ez00_15301)))->BgL_funz00),
															BgL_symbzd2funzd2_17939, BgL_fz00_17937,
															(((BgL_ev_appz00_bglt)
																	COBJECT(((BgL_ev_appz00_bglt)
																			BgL_ez00_15301)))->BgL_tailzf3zf3),
															BgL_stkz00_15302, BgL_siza7eza7_17938,
															BgL_a1z00_17940);
													}
												else
													{	/* Eval/evaluate_comp.scm 1053 */
														obj_t BgL_a2z00_17943;
														obj_t BgL_argsz00_17944;

														{	/* Eval/evaluate_comp.scm 1053 */
															obj_t BgL_arg3430z00_17945;

															BgL_arg3430z00_17945 =
																CAR(((obj_t) BgL_argsz00_17941));
															BgL_a2z00_17943 =
																BGl_compz00zz__evaluate_compz00(
																((BgL_ev_exprz00_bglt) BgL_arg3430z00_17945),
																BgL_stkz00_15302);
														}
														BgL_argsz00_17944 =
															CDR(((obj_t) BgL_argsz00_17941));
														if (NULLP(BgL_argsz00_17944))
															{	/* Eval/evaluate_comp.scm 1053 */
																return
																	BGl_compzd2call2zd2zz__evaluate_compz00(
																	(((BgL_ev_appz00_bglt) COBJECT(
																				((BgL_ev_appz00_bglt)
																					BgL_ez00_15301)))->BgL_locz00),
																	(((BgL_ev_appz00_bglt)
																			COBJECT(((BgL_ev_appz00_bglt)
																					BgL_ez00_15301)))->BgL_funz00),
																	BgL_symbzd2funzd2_17939, BgL_fz00_17937,
																	(((BgL_ev_appz00_bglt)
																			COBJECT(((BgL_ev_appz00_bglt)
																					BgL_ez00_15301)))->BgL_tailzf3zf3),
																	BgL_stkz00_15302, BgL_siza7eza7_17938,
																	BgL_a1z00_17940, BgL_a2z00_17943);
															}
														else
															{	/* Eval/evaluate_comp.scm 1053 */
																obj_t BgL_a3z00_17946;
																obj_t BgL_argsz00_17947;

																{	/* Eval/evaluate_comp.scm 1053 */
																	obj_t BgL_arg3429z00_17948;

																	BgL_arg3429z00_17948 =
																		CAR(((obj_t) BgL_argsz00_17944));
																	BgL_a3z00_17946 =
																		BGl_compz00zz__evaluate_compz00(
																		((BgL_ev_exprz00_bglt)
																			BgL_arg3429z00_17948), BgL_stkz00_15302);
																}
																BgL_argsz00_17947 =
																	CDR(((obj_t) BgL_argsz00_17944));
																if (NULLP(BgL_argsz00_17947))
																	{	/* Eval/evaluate_comp.scm 1053 */
																		return
																			BGl_compzd2call3zd2zz__evaluate_compz00(
																			(((BgL_ev_appz00_bglt) COBJECT(
																						((BgL_ev_appz00_bglt)
																							BgL_ez00_15301)))->BgL_locz00),
																			(((BgL_ev_appz00_bglt)
																					COBJECT(((BgL_ev_appz00_bglt)
																							BgL_ez00_15301)))->BgL_funz00),
																			BgL_symbzd2funzd2_17939, BgL_fz00_17937,
																			(((BgL_ev_appz00_bglt)
																					COBJECT(((BgL_ev_appz00_bglt)
																							BgL_ez00_15301)))->
																				BgL_tailzf3zf3), BgL_stkz00_15302,
																			BgL_siza7eza7_17938, BgL_a1z00_17940,
																			BgL_a2z00_17943, BgL_a3z00_17946);
																	}
																else
																	{	/* Eval/evaluate_comp.scm 1053 */
																		obj_t BgL_a4z00_17949;
																		obj_t BgL_argsz00_17950;

																		{	/* Eval/evaluate_comp.scm 1053 */
																			obj_t BgL_arg3427z00_17951;

																			BgL_arg3427z00_17951 =
																				CAR(((obj_t) BgL_argsz00_17947));
																			BgL_a4z00_17949 =
																				BGl_compz00zz__evaluate_compz00(
																				((BgL_ev_exprz00_bglt)
																					BgL_arg3427z00_17951),
																				BgL_stkz00_15302);
																		}
																		BgL_argsz00_17950 =
																			CDR(((obj_t) BgL_argsz00_17947));
																		if (NULLP(BgL_argsz00_17950))
																			{	/* Eval/evaluate_comp.scm 1053 */
																				return
																					BGl_compzd2call4zd2zz__evaluate_compz00
																					((((BgL_ev_appz00_bglt)
																							COBJECT(((BgL_ev_appz00_bglt)
																									BgL_ez00_15301)))->
																						BgL_locz00),
																					(((BgL_ev_appz00_bglt)
																							COBJECT(((BgL_ev_appz00_bglt)
																									BgL_ez00_15301)))->
																						BgL_funz00),
																					BgL_symbzd2funzd2_17939,
																					BgL_fz00_17937,
																					(((BgL_ev_appz00_bglt)
																							COBJECT(((BgL_ev_appz00_bglt)
																									BgL_ez00_15301)))->
																						BgL_tailzf3zf3), BgL_stkz00_15302,
																					BgL_siza7eza7_17938, BgL_a1z00_17940,
																					BgL_a2z00_17943, BgL_a3z00_17946,
																					BgL_a4z00_17949);
																			}
																		else
																			{	/* Eval/evaluate_comp.scm 1053 */
																				return
																					BGl_errorz00zz__errorz00
																					(BGl_string5807z00zz__evaluate_compz00,
																					BGl_string5922z00zz__evaluate_compz00,
																					BGl_string5923z00zz__evaluate_compz00);
																			}
																	}
															}
													}
											}
									}
							}
					}
			}
		}

	}



/* &comp-ev_goto1435 */
	obj_t BGl_z62compzd2ev_goto1435zb0zz__evaluate_compz00(obj_t BgL_envz00_15303,
		obj_t BgL_ez00_15304, obj_t BgL_stkz00_15305)
	{
		{	/* Eval/evaluate_comp.scm 604 */
			{	/* Eval/evaluate_comp.scm 607 */
				obj_t BgL_slotz00_17955;
				long BgL_siza7eza7_17956;
				obj_t BgL_lstkz00_17957;

				BgL_slotz00_17955 =
					BGl_assqz00zz__r4_pairs_and_lists_6_3z00(
					((obj_t)
						(((BgL_ev_gotoz00_bglt) COBJECT(
									((BgL_ev_gotoz00_bglt) BgL_ez00_15304)))->BgL_labelz00)),
					(((BgL_ev_labelsz00_bglt) COBJECT(
								(((BgL_ev_gotoz00_bglt) COBJECT(
											((BgL_ev_gotoz00_bglt) BgL_ez00_15304)))->
									BgL_labelsz00)))->BgL_envz00));
				BgL_siza7eza7_17956 = bgl_list_length(BgL_stkz00_15305);
				BgL_lstkz00_17957 =
					(((BgL_ev_labelsz00_bglt) COBJECT(
							(((BgL_ev_gotoz00_bglt) COBJECT(
										((BgL_ev_gotoz00_bglt) BgL_ez00_15304)))->BgL_labelsz00)))->
					BgL_stkz00);
				{	/* Eval/evaluate_comp.scm 609 */
					long BgL_llstkz00_17958;
					obj_t BgL_substkz00_17959;
					obj_t BgL_boxesz00_17960;

					BgL_llstkz00_17958 = bgl_list_length(BgL_lstkz00_17957);
					BgL_substkz00_17959 =
						BGl_subzd2stkzd2zz__evaluate_compz00(BgL_lstkz00_17957,
						BgL_stkz00_15305);
					{	/* Eval/evaluate_comp.scm 609 */
						obj_t BgL_pairz00_17961;

						BgL_pairz00_17961 =
							BGl_assqz00zz__r4_pairs_and_lists_6_3z00(
							((obj_t)
								(((BgL_ev_gotoz00_bglt) COBJECT(
											((BgL_ev_gotoz00_bglt) BgL_ez00_15304)))->BgL_labelz00)),
							(((BgL_ev_labelsz00_bglt) COBJECT(
										(((BgL_ev_gotoz00_bglt) COBJECT(
													((BgL_ev_gotoz00_bglt) BgL_ez00_15304)))->
											BgL_labelsz00)))->BgL_boxesz00));
						BgL_boxesz00_17960 = CDR(BgL_pairz00_17961);
					}
					if (BGl_needzd2shiftzd2zz__evaluate_compz00(
							(((BgL_ev_gotoz00_bglt) COBJECT(
										((BgL_ev_gotoz00_bglt) BgL_ez00_15304)))->BgL_argsz00),
							BgL_substkz00_17959))
						{	/* Eval/evaluate_comp.scm 612 */
							obj_t BgL_argsz00_17962;
							long BgL_nbargsz00_17963;

							BgL_argsz00_17962 =
								BGl_compzd2withzd2pushz00zz__evaluate_compz00(
								(((BgL_ev_gotoz00_bglt) COBJECT(
											((BgL_ev_gotoz00_bglt) BgL_ez00_15304)))->BgL_argsz00),
								BgL_stkz00_15305);
							BgL_nbargsz00_17963 =
								bgl_list_length((((BgL_ev_gotoz00_bglt)
										COBJECT(((BgL_ev_gotoz00_bglt) BgL_ez00_15304)))->
									BgL_argsz00));
							{	/* Eval/evaluate_comp.scm 613 */
								obj_t BgL_zc3z04anonymousza33376ze3z87_17964;

								BgL_zc3z04anonymousza33376ze3z87_17964 =
									MAKE_FX_PROCEDURE
									(BGl_z62zc3z04anonymousza33376ze3ze5zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 7)));
								PROCEDURE_SET(BgL_zc3z04anonymousza33376ze3z87_17964,
									(int) (((long) 0)), BINT(BgL_siza7eza7_17956));
								PROCEDURE_SET(BgL_zc3z04anonymousza33376ze3z87_17964,
									(int) (((long) 1)), BINT(BgL_llstkz00_17958));
								PROCEDURE_SET(BgL_zc3z04anonymousza33376ze3z87_17964,
									(int) (((long) 2)),
									((obj_t) ((BgL_ev_gotoz00_bglt) BgL_ez00_15304)));
								PROCEDURE_SET(BgL_zc3z04anonymousza33376ze3z87_17964,
									(int) (((long) 3)), BgL_argsz00_17962);
								PROCEDURE_SET(BgL_zc3z04anonymousza33376ze3z87_17964,
									(int) (((long) 4)), BgL_boxesz00_17960);
								PROCEDURE_SET(BgL_zc3z04anonymousza33376ze3z87_17964,
									(int) (((long) 5)), BINT(BgL_nbargsz00_17963));
								PROCEDURE_SET(BgL_zc3z04anonymousza33376ze3z87_17964,
									(int) (((long) 6)), BgL_slotz00_17955);
								return BgL_zc3z04anonymousza33376ze3z87_17964;
							}
						}
					else
						{	/* Eval/evaluate_comp.scm 618 */
							obj_t BgL_argsz00_17965;

							{	/* Eval/evaluate_comp.scm 618 */
								obj_t BgL_lz00_17966;
								long BgL_nz00_17967;

								BgL_lz00_17966 =
									(((BgL_ev_gotoz00_bglt) COBJECT(
											((BgL_ev_gotoz00_bglt) BgL_ez00_15304)))->BgL_argsz00);
								BgL_nz00_17967 = (BgL_siza7eza7_17956 - BgL_llstkz00_17958);
								BgL_argsz00_17965 =
									BGl_recze70ze7zz__evaluate_compz00(BgL_stkz00_15305,
									BgL_lz00_17966, BgL_nz00_17967);
							}
							{	/* Eval/evaluate_comp.scm 619 */
								obj_t BgL_zc3z04anonymousza33385ze3z87_17968;

								BgL_zc3z04anonymousza33385ze3z87_17968 =
									MAKE_FX_PROCEDURE
									(BGl_z62zc3z04anonymousza33385ze3ze5zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 5)));
								PROCEDURE_SET(BgL_zc3z04anonymousza33385ze3z87_17968,
									(int) (((long) 0)), BINT(BgL_llstkz00_17958));
								PROCEDURE_SET(BgL_zc3z04anonymousza33385ze3z87_17968,
									(int) (((long) 1)),
									((obj_t) ((BgL_ev_gotoz00_bglt) BgL_ez00_15304)));
								PROCEDURE_SET(BgL_zc3z04anonymousza33385ze3z87_17968,
									(int) (((long) 2)), BgL_argsz00_17965);
								PROCEDURE_SET(BgL_zc3z04anonymousza33385ze3z87_17968,
									(int) (((long) 3)), BgL_boxesz00_17960);
								PROCEDURE_SET(BgL_zc3z04anonymousza33385ze3z87_17968,
									(int) (((long) 4)), BgL_slotz00_17955);
								return BgL_zc3z04anonymousza33385ze3z87_17968;
							}
						}
				}
			}
		}

	}



/* &<@anonymous:3376> */
	obj_t BGl_z62zc3z04anonymousza33376ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_15306, obj_t BgL_sz00_15314)
	{
		{	/* Eval/evaluate_comp.scm 613 */
			{	/* Eval/evaluate_comp.scm 613 */
				long BgL_siza7eza7_15307;
				long BgL_llstkz00_15308;
				BgL_ev_gotoz00_bglt BgL_i1145z00_15309;
				obj_t BgL_argsz00_15310;
				obj_t BgL_boxesz00_15311;
				long BgL_nbargsz00_15312;
				obj_t BgL_slotz00_15313;

				BgL_siza7eza7_15307 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15306, (int) (((long) 0))));
				BgL_llstkz00_15308 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15306, (int) (((long) 1))));
				BgL_i1145z00_15309 =
					((BgL_ev_gotoz00_bglt)
					PROCEDURE_REF(BgL_envz00_15306, (int) (((long) 2))));
				BgL_argsz00_15310 =
					((obj_t) PROCEDURE_REF(BgL_envz00_15306, (int) (((long) 3))));
				BgL_boxesz00_15311 =
					PROCEDURE_REF(BgL_envz00_15306, (int) (((long) 4)));
				BgL_nbargsz00_15312 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15306, (int) (((long) 5))));
				BgL_slotz00_15313 = PROCEDURE_REF(BgL_envz00_15306, (int) (((long) 6)));
				{	/* Eval/evaluate_comp.scm 613 */
					obj_t BgL_bpz00_17969;

					BgL_bpz00_17969 = VECTOR_REF(((obj_t) BgL_sz00_15314), ((long) 0));
					{	/* Eval/evaluate_comp.scm 614 */
						long BgL_spz00_17970;
						long BgL_lspz00_17971;

						BgL_spz00_17970 =
							((long) CINT(BgL_bpz00_17969) + BgL_siza7eza7_15307);
						BgL_lspz00_17971 =
							((long) CINT(BgL_bpz00_17969) + BgL_llstkz00_15308);
						BGl_pushzd2boxeszd2argszd2onzd2spz00zz__evaluate_compz00
							(BgL_sz00_15314, BgL_argsz00_15310, BgL_boxesz00_15311,
							BgL_spz00_17970,
							(((BgL_ev_gotoz00_bglt) COBJECT(BgL_i1145z00_15309))->
								BgL_locz00));
						{	/* Eval/evaluate_comp.scm 616 */
							long BgL_arg3380z00_17972;

							BgL_arg3380z00_17972 = (BgL_spz00_17970 + BgL_nbargsz00_15312);
							BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00(BgL_sz00_15314,
								BgL_lspz00_17971, BgL_sz00_15314, BINT(BgL_spz00_17970),
								BINT(BgL_arg3380z00_17972));
						}
						return CDR(((obj_t) BgL_slotz00_15313));
					}
				}
			}
		}

	}



/* &<@anonymous:3385> */
	obj_t BGl_z62zc3z04anonymousza33385ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_15315, obj_t BgL_sz00_15321)
	{
		{	/* Eval/evaluate_comp.scm 619 */
			{	/* Eval/evaluate_comp.scm 619 */
				long BgL_llstkz00_15316;
				BgL_ev_gotoz00_bglt BgL_i1145z00_15317;
				obj_t BgL_argsz00_15318;
				obj_t BgL_boxesz00_15319;
				obj_t BgL_slotz00_15320;

				BgL_llstkz00_15316 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15315, (int) (((long) 0))));
				BgL_i1145z00_15317 =
					((BgL_ev_gotoz00_bglt)
					PROCEDURE_REF(BgL_envz00_15315, (int) (((long) 1))));
				BgL_argsz00_15318 =
					((obj_t) PROCEDURE_REF(BgL_envz00_15315, (int) (((long) 2))));
				BgL_boxesz00_15319 =
					PROCEDURE_REF(BgL_envz00_15315, (int) (((long) 3)));
				BgL_slotz00_15320 = PROCEDURE_REF(BgL_envz00_15315, (int) (((long) 4)));
				{	/* Eval/evaluate_comp.scm 619 */
					obj_t BgL_bpz00_17973;

					BgL_bpz00_17973 = VECTOR_REF(((obj_t) BgL_sz00_15321), ((long) 0));
					BGl_pushzd2boxeszd2argszd2onzd2spz00zz__evaluate_compz00
						(BgL_sz00_15321, BgL_argsz00_15318, BgL_boxesz00_15319,
						((long) CINT(BgL_bpz00_17973) + BgL_llstkz00_15316),
						(((BgL_ev_gotoz00_bglt) COBJECT(BgL_i1145z00_15317))->BgL_locz00));
					return CDR(((obj_t) BgL_slotz00_15320));
				}
			}
		}

	}



/* &comp-ev_labels1433 */
	obj_t BGl_z62compzd2ev_labels1433zb0zz__evaluate_compz00(obj_t
		BgL_envz00_15322, obj_t BgL_ez00_15323, obj_t BgL_stkz00_15324)
	{
		{	/* Eval/evaluate_comp.scm 572 */
			((((BgL_ev_labelsz00_bglt) COBJECT(
							((BgL_ev_labelsz00_bglt) BgL_ez00_15323)))->BgL_stkz00) =
				((obj_t) BgL_stkz00_15324), BUNSPEC);
			{	/* Eval/evaluate_comp.scm 579 */
				obj_t BgL_envz00_17975;

				{	/* Eval/evaluate_comp.scm 579 */
					obj_t BgL_l1332z00_17976;

					BgL_l1332z00_17976 =
						(((BgL_ev_labelsz00_bglt) COBJECT(
								((BgL_ev_labelsz00_bglt) BgL_ez00_15323)))->BgL_varsz00);
					if (NULLP(BgL_l1332z00_17976))
						{	/* Eval/evaluate_comp.scm 579 */
							BgL_envz00_17975 = BNIL;
						}
					else
						{	/* Eval/evaluate_comp.scm 579 */
							obj_t BgL_head1334z00_17977;

							{	/* Eval/evaluate_comp.scm 579 */
								obj_t BgL_res5203z00_17978;

								BgL_res5203z00_17978 = MAKE_YOUNG_PAIR(BNIL, BNIL);
								BgL_head1334z00_17977 = BgL_res5203z00_17978;
							}
							{
								obj_t BgL_l1332z00_17980;
								obj_t BgL_tail1335z00_17981;

								BgL_l1332z00_17980 = BgL_l1332z00_17976;
								BgL_tail1335z00_17981 = BgL_head1334z00_17977;
							BgL_zc3z04anonymousza33365ze3z87_17979:
								if (NULLP(BgL_l1332z00_17980))
									{	/* Eval/evaluate_comp.scm 579 */
										BgL_envz00_17975 = CDR(BgL_head1334z00_17977);
									}
								else
									{	/* Eval/evaluate_comp.scm 579 */
										obj_t BgL_newtail1336z00_17982;

										{	/* Eval/evaluate_comp.scm 579 */
											obj_t BgL_arg3369z00_17983;

											{	/* Eval/evaluate_comp.scm 579 */
												obj_t BgL_vz00_17984;

												BgL_vz00_17984 = CAR(((obj_t) BgL_l1332z00_17980));
												BgL_arg3369z00_17983 =
													MAKE_YOUNG_PAIR(BgL_vz00_17984,
													BGl_symbol5924z00zz__evaluate_compz00);
											}
											{	/* Eval/evaluate_comp.scm 579 */
												obj_t BgL_res5209z00_17985;

												BgL_res5209z00_17985 =
													MAKE_YOUNG_PAIR(BgL_arg3369z00_17983, BNIL);
												BgL_newtail1336z00_17982 = BgL_res5209z00_17985;
											}
										}
										SET_CDR(BgL_tail1335z00_17981, BgL_newtail1336z00_17982);
										{	/* Eval/evaluate_comp.scm 579 */
											obj_t BgL_arg3368z00_17986;

											BgL_arg3368z00_17986 = CDR(((obj_t) BgL_l1332z00_17980));
											{
												obj_t BgL_tail1335z00_33098;
												obj_t BgL_l1332z00_33097;

												BgL_l1332z00_33097 = BgL_arg3368z00_17986;
												BgL_tail1335z00_33098 = BgL_newtail1336z00_17982;
												BgL_tail1335z00_17981 = BgL_tail1335z00_33098;
												BgL_l1332z00_17980 = BgL_l1332z00_33097;
												goto BgL_zc3z04anonymousza33365ze3z87_17979;
											}
										}
									}
							}
						}
				}
				((((BgL_ev_labelsz00_bglt) COBJECT(
								((BgL_ev_labelsz00_bglt) BgL_ez00_15323)))->BgL_envz00) =
					((obj_t) BgL_envz00_17975), BUNSPEC);
				{	/* Eval/evaluate_comp.scm 582 */
					obj_t BgL_g1340z00_17987;

					BgL_g1340z00_17987 =
						(((BgL_ev_labelsz00_bglt) COBJECT(
								((BgL_ev_labelsz00_bglt) BgL_ez00_15323)))->BgL_valsz00);
					{
						obj_t BgL_ll1337z00_17989;
						obj_t BgL_ll1338z00_17990;

						BgL_ll1337z00_17989 = BgL_envz00_17975;
						BgL_ll1338z00_17990 = BgL_g1340z00_17987;
					BgL_zc3z04anonymousza33348ze3z87_17988:
						if (NULLP(BgL_ll1337z00_17989))
							{	/* Eval/evaluate_comp.scm 582 */
								((bool_t) 1);
							}
						else
							{	/* Eval/evaluate_comp.scm 582 */
								{	/* Eval/evaluate_comp.scm 584 */
									obj_t BgL_slotz00_17991;
									obj_t BgL_valz00_17992;

									BgL_slotz00_17991 = CAR(((obj_t) BgL_ll1337z00_17989));
									BgL_valz00_17992 = CAR(((obj_t) BgL_ll1338z00_17990));
									{	/* Eval/evaluate_comp.scm 585 */
										obj_t BgL_arg3352z00_17993;

										{	/* Eval/evaluate_comp.scm 585 */
											obj_t BgL_arg3353z00_17994;

											{	/* Eval/evaluate_comp.scm 585 */
												obj_t BgL_arg3354z00_17995;
												obj_t BgL_arg3355z00_17996;

												BgL_arg3354z00_17995 = CDR(((obj_t) BgL_valz00_17992));
												{	/* Eval/evaluate_comp.scm 585 */
													obj_t BgL_arg3361z00_17997;

													BgL_arg3361z00_17997 =
														CAR(((obj_t) BgL_valz00_17992));
													BgL_arg3355z00_17996 =
														BGl_appendzd221011zd2zz__evaluate_compz00
														(BgL_stkz00_15324, BgL_arg3361z00_17997);
												}
												BgL_arg3353z00_17994 =
													BGl_compz00zz__evaluate_compz00(
													((BgL_ev_exprz00_bglt) BgL_arg3354z00_17995),
													BgL_arg3355z00_17996);
											}
											{	/* Eval/evaluate_comp.scm 574 */
												obj_t BgL_objz00_17998;

												BgL_objz00_17998 =
													BGl_za2za2azd2labelza2za2zd2zz__evaluate_compz00;
												{	/* Eval/evaluate_comp.scm 574 */
													obj_t BgL_tmpz00_33116;

													BgL_tmpz00_33116 = ((obj_t) BgL_arg3353z00_17994);
													PROCEDURE_ATTR_SET(BgL_tmpz00_33116,
														BgL_objz00_17998);
												}
												BgL_objz00_17998;
											}
											BgL_arg3352z00_17993 = BgL_arg3353z00_17994;
										}
										{	/* Eval/evaluate_comp.scm 584 */
											obj_t BgL_tmpz00_33119;

											BgL_tmpz00_33119 = ((obj_t) BgL_slotz00_17991);
											SET_CDR(BgL_tmpz00_33119, BgL_arg3352z00_17993);
										}
									}
								}
								{	/* Eval/evaluate_comp.scm 582 */
									obj_t BgL_arg3362z00_17999;
									obj_t BgL_arg3363z00_18000;

									BgL_arg3362z00_17999 = CDR(((obj_t) BgL_ll1337z00_17989));
									BgL_arg3363z00_18000 = CDR(((obj_t) BgL_ll1338z00_17990));
									{
										obj_t BgL_ll1338z00_33127;
										obj_t BgL_ll1337z00_33126;

										BgL_ll1337z00_33126 = BgL_arg3362z00_17999;
										BgL_ll1338z00_33127 = BgL_arg3363z00_18000;
										BgL_ll1338z00_17990 = BgL_ll1338z00_33127;
										BgL_ll1337z00_17989 = BgL_ll1337z00_33126;
										goto BgL_zc3z04anonymousza33348ze3z87_17988;
									}
								}
							}
					}
				}
			}
			{	/* Eval/evaluate_comp.scm 589 */
				obj_t BgL_bodyz00_18001;

				BgL_bodyz00_18001 =
					BGl_compz00zz__evaluate_compz00(
					(((BgL_ev_labelsz00_bglt) COBJECT(
								((BgL_ev_labelsz00_bglt) BgL_ez00_15323)))->BgL_bodyz00),
					BgL_stkz00_15324);
				{	/* Eval/evaluate_comp.scm 590 */
					obj_t BgL_zc3z04anonymousza33370ze3z87_18002;

					BgL_zc3z04anonymousza33370ze3z87_18002 =
						MAKE_FX_PROCEDURE
						(BGl_z62zc3z04anonymousza33370ze3ze5zz__evaluate_compz00,
						(int) (((long) 1)), (int) (((long) 1)));
					PROCEDURE_SET(BgL_zc3z04anonymousza33370ze3z87_18002,
						(int) (((long) 0)), BgL_bodyz00_18001);
					return BgL_zc3z04anonymousza33370ze3z87_18002;
				}
			}
		}

	}



/* &<@anonymous:3370> */
	obj_t BGl_z62zc3z04anonymousza33370ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_15325, obj_t BgL_sz00_15327)
	{
		{	/* Eval/evaluate_comp.scm 590 */
			{	/* Eval/evaluate_comp.scm 590 */
				obj_t BgL_bodyz00_15326;

				BgL_bodyz00_15326 = PROCEDURE_REF(BgL_envz00_15325, (int) (((long) 0)));
				{	/* Eval/evaluate_comp.scm 590 */
					obj_t BgL_bpz00_18003;

					BgL_bpz00_18003 = VECTOR_REF(((obj_t) BgL_sz00_15327), ((long) 0));
					{
						obj_t BgL_fz00_18005;

						BgL_fz00_18005 = BgL_bodyz00_15326;
					BgL_recz00_18004:
						{	/* Eval/evaluate_comp.scm 597 */
							obj_t BgL_rz00_18006;

							BgL_rz00_18006 =
								PROCEDURE_ENTRY(BgL_fz00_18005) (BgL_fz00_18005, BgL_sz00_15327,
								BEOA);
							{	/* Eval/evaluate_comp.scm 599 */
								bool_t BgL_test6777z00_33144;

								if (PROCEDUREP(BgL_rz00_18006))
									{	/* Eval/evaluate_comp.scm 599 */
										obj_t BgL_arg1656z00_18007;

										BgL_arg1656z00_18007 = PROCEDURE_ATTR(BgL_rz00_18006);
										if (STRUCTP(BgL_arg1656z00_18007))
											{	/* Eval/evaluate_comp.scm 569 */
												BgL_test6777z00_33144 =
													(STRUCT_KEY(BgL_arg1656z00_18007) ==
													BGl_symbol5801z00zz__evaluate_compz00);
											}
										else
											{	/* Eval/evaluate_comp.scm 569 */
												BgL_test6777z00_33144 = ((bool_t) 0);
											}
									}
								else
									{	/* Eval/evaluate_comp.scm 599 */
										BgL_test6777z00_33144 = ((bool_t) 0);
									}
								if (BgL_test6777z00_33144)
									{
										obj_t BgL_fz00_33152;

										BgL_fz00_33152 = BgL_rz00_18006;
										BgL_fz00_18005 = BgL_fz00_33152;
										goto BgL_recz00_18004;
									}
								else
									{	/* Eval/evaluate_comp.scm 599 */
										return BgL_rz00_18006;
									}
							}
						}
					}
				}
			}
		}

	}



/* &comp-ev_synchronize1431 */
	obj_t BGl_z62compzd2ev_synchroniza7e1431z17zz__evaluate_compz00(obj_t
		BgL_envz00_15328, obj_t BgL_ez00_15329, obj_t BgL_stkz00_15330)
	{
		{	/* Eval/evaluate_comp.scm 552 */
			{	/* Eval/evaluate_comp.scm 554 */
				obj_t BgL_mutexz00_18009;
				obj_t BgL_prelockz00_18010;
				obj_t BgL_bodyz00_18011;

				BgL_mutexz00_18009 =
					BGl_compz00zz__evaluate_compz00(
					(((BgL_ev_synchroniza7eza7_bglt) COBJECT(
								((BgL_ev_synchroniza7eza7_bglt) BgL_ez00_15329)))->
						BgL_mutexz00), BgL_stkz00_15330);
				BgL_prelockz00_18010 =
					BGl_compz00zz__evaluate_compz00((((BgL_ev_synchroniza7eza7_bglt)
							COBJECT(((BgL_ev_synchroniza7eza7_bglt) BgL_ez00_15329)))->
						BgL_prelockz00), BgL_stkz00_15330);
				BgL_bodyz00_18011 =
					BGl_compz00zz__evaluate_compz00((((BgL_ev_synchroniza7eza7_bglt)
							COBJECT(((BgL_ev_synchroniza7eza7_bglt) BgL_ez00_15329)))->
						BgL_bodyz00), BgL_stkz00_15330);
				{	/* Eval/evaluate_comp.scm 557 */
					obj_t BgL_zc3z04anonymousza33341ze3z87_18012;

					BgL_zc3z04anonymousza33341ze3z87_18012 =
						MAKE_FX_PROCEDURE
						(BGl_z62zc3z04anonymousza33341ze3ze5zz__evaluate_compz00,
						(int) (((long) 1)), (int) (((long) 4)));
					PROCEDURE_SET(BgL_zc3z04anonymousza33341ze3z87_18012,
						(int) (((long) 0)), BgL_mutexz00_18009);
					PROCEDURE_SET(BgL_zc3z04anonymousza33341ze3z87_18012,
						(int) (((long) 1)),
						((obj_t) ((BgL_ev_synchroniza7eza7_bglt) BgL_ez00_15329)));
					PROCEDURE_SET(BgL_zc3z04anonymousza33341ze3z87_18012,
						(int) (((long) 2)), BgL_prelockz00_18010);
					PROCEDURE_SET(BgL_zc3z04anonymousza33341ze3z87_18012,
						(int) (((long) 3)), BgL_bodyz00_18011);
					return BgL_zc3z04anonymousza33341ze3z87_18012;
				}
			}
		}

	}



/* &<@anonymous:3341> */
	obj_t BGl_z62zc3z04anonymousza33341ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_15331, obj_t BgL_sz00_15336)
	{
		{	/* Eval/evaluate_comp.scm 557 */
			{	/* Eval/evaluate_comp.scm 557 */
				obj_t BgL_mutexz00_15332;
				BgL_ev_synchroniza7eza7_bglt BgL_i1142z00_15333;
				obj_t BgL_prelockz00_15334;
				obj_t BgL_bodyz00_15335;

				BgL_mutexz00_15332 =
					PROCEDURE_REF(BgL_envz00_15331, (int) (((long) 0)));
				BgL_i1142z00_15333 =
					((BgL_ev_synchroniza7eza7_bglt)
					PROCEDURE_REF(BgL_envz00_15331, (int) (((long) 1))));
				BgL_prelockz00_15334 =
					PROCEDURE_REF(BgL_envz00_15331, (int) (((long) 2)));
				BgL_bodyz00_15335 = PROCEDURE_REF(BgL_envz00_15331, (int) (((long) 3)));
				{	/* Eval/evaluate_comp.scm 557 */
					obj_t BgL_bpz00_18013;

					BgL_bpz00_18013 = VECTOR_REF(((obj_t) BgL_sz00_15336), ((long) 0));
					{	/* Eval/evaluate_comp.scm 558 */
						obj_t BgL_mz00_18014;

						BgL_mz00_18014 =
							PROCEDURE_ENTRY(BgL_mutexz00_15332) (BgL_mutexz00_15332,
							BgL_sz00_15336, BEOA);
						{	/* Eval/evaluate_comp.scm 559 */
							bool_t BgL_test6780z00_33190;

							{	/* Eval/evaluate_comp.scm 559 */
								bool_t BgL_res5200z00_18015;

								BgL_res5200z00_18015 = BGL_MUTEXP(BgL_mz00_18014);
								BgL_test6780z00_33190 = BgL_res5200z00_18015;
							}
							if (BgL_test6780z00_33190)
								{	/* Eval/evaluate_comp.scm 560 */
									obj_t BgL_pz00_18016;

									BgL_pz00_18016 =
										PROCEDURE_ENTRY(BgL_prelockz00_15334) (BgL_prelockz00_15334,
										BgL_sz00_15336, BEOA);
									{	/* Eval/evaluate_comp.scm 562 */
										obj_t BgL_za2za2resza2za2z00_18017;

										if (PAIRP(BgL_pz00_18016))
											{	/* Eval/evaluate_comp.scm 563 */
												obj_t BgL_top6783z00_33199;

												BgL_top6783z00_33199 = BGL_EXITD_TOP_AS_OBJ();
												BGL_MUTEX_LOCK_PRELOCK(BgL_mz00_18014, BgL_pz00_18016);
												BGL_EXITD_PUSH_PROTECT(BgL_top6783z00_33199,
													BgL_mz00_18014);
												BUNSPEC;
												{	/* Eval/evaluate_comp.scm 563 */
													obj_t BgL_tmp6782z00_33198;

													BgL_tmp6782z00_33198 =
														PROCEDURE_ENTRY(BgL_bodyz00_15335)
														(BgL_bodyz00_15335, BgL_sz00_15336, BEOA);
													BGL_EXITD_POP_PROTECT(BgL_top6783z00_33199);
													BUNSPEC;
													BGL_MUTEX_UNLOCK(BgL_mz00_18014);
													BgL_za2za2resza2za2z00_18017 = BgL_tmp6782z00_33198;
												}
											}
										else
											{	/* Eval/evaluate_comp.scm 564 */
												obj_t BgL_top6785z00_33210;

												BgL_top6785z00_33210 = BGL_EXITD_TOP_AS_OBJ();
												BGL_MUTEX_LOCK(BgL_mz00_18014);
												BGL_EXITD_PUSH_PROTECT(BgL_top6785z00_33210,
													BgL_mz00_18014);
												BUNSPEC;
												{	/* Eval/evaluate_comp.scm 564 */
													obj_t BgL_tmp6784z00_33209;

													BgL_tmp6784z00_33209 =
														PROCEDURE_ENTRY(BgL_bodyz00_15335)
														(BgL_bodyz00_15335, BgL_sz00_15336, BEOA);
													BGL_EXITD_POP_PROTECT(BgL_top6785z00_33210);
													BUNSPEC;
													BGL_MUTEX_UNLOCK(BgL_mz00_18014);
													BgL_za2za2resza2za2z00_18017 = BgL_tmp6784z00_33209;
												}
											}
										VECTOR_SET(
											((obj_t) BgL_sz00_15336), ((long) 0), BgL_bpz00_18013);
										return BgL_za2za2resza2za2z00_18017;
									}
								}
							else
								{	/* Eval/evaluate_comp.scm 559 */
									return
										BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_string5926z00zz__evaluate_compz00,
										BGl_string5927z00zz__evaluate_compz00, BgL_mz00_18014,
										(((BgL_ev_synchroniza7eza7_bglt)
												COBJECT(BgL_i1142z00_15333))->BgL_locz00));
								}
						}
					}
				}
			}
		}

	}



/* &comp-ev_with-handler1429 */
	obj_t BGl_z62compzd2ev_withzd2handler1429z62zz__evaluate_compz00(obj_t
		BgL_envz00_15337, obj_t BgL_ez00_15338, obj_t BgL_stkz00_15339)
	{
		{	/* Eval/evaluate_comp.scm 543 */
			{	/* Eval/evaluate_comp.scm 545 */
				obj_t BgL_handlerz00_18019;
				obj_t BgL_bodyz00_18020;

				BgL_handlerz00_18019 =
					BGl_compz00zz__evaluate_compz00(
					(((BgL_ev_withzd2handlerzd2_bglt) COBJECT(
								((BgL_ev_withzd2handlerzd2_bglt) BgL_ez00_15338)))->
						BgL_handlerz00), BgL_stkz00_15339);
				BgL_bodyz00_18020 =
					BGl_compz00zz__evaluate_compz00((((BgL_ev_withzd2handlerzd2_bglt)
							COBJECT(((BgL_ev_withzd2handlerzd2_bglt) BgL_ez00_15338)))->
						BgL_bodyz00), BgL_stkz00_15339);
				{	/* Eval/evaluate_comp.scm 546 */
					obj_t BgL_zc3z04anonymousza33321ze3z87_18021;

					BgL_zc3z04anonymousza33321ze3z87_18021 =
						MAKE_FX_PROCEDURE
						(BGl_z62zc3z04anonymousza33321ze3ze5zz__evaluate_compz00,
						(int) (((long) 1)), (int) (((long) 2)));
					PROCEDURE_SET(BgL_zc3z04anonymousza33321ze3z87_18021,
						(int) (((long) 0)), BgL_handlerz00_18019);
					PROCEDURE_SET(BgL_zc3z04anonymousza33321ze3z87_18021,
						(int) (((long) 1)), BgL_bodyz00_18020);
					return BgL_zc3z04anonymousza33321ze3z87_18021;
				}
			}
		}

	}



/* &<@anonymous:3321> */
	obj_t BGl_z62zc3z04anonymousza33321ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_15340, obj_t BgL_sz00_15343)
	{
		{	/* Eval/evaluate_comp.scm 546 */
			{	/* Eval/evaluate_comp.scm 546 */
				obj_t BgL_handlerz00_15341;
				obj_t BgL_bodyz00_15342;

				BgL_handlerz00_15341 =
					PROCEDURE_REF(BgL_envz00_15340, (int) (((long) 0)));
				BgL_bodyz00_15342 = PROCEDURE_REF(BgL_envz00_15340, (int) (((long) 1)));
				{	/* Eval/evaluate_comp.scm 546 */
					obj_t BgL_bpz00_18022;

					BgL_bpz00_18022 = VECTOR_REF(((obj_t) BgL_sz00_15343), ((long) 0));
					{	/* Eval/evaluate_comp.scm 547 */
						obj_t BgL_hz00_18023;

						BgL_hz00_18023 =
							PROCEDURE_ENTRY(BgL_handlerz00_15341) (BgL_handlerz00_15341,
							BgL_sz00_15343, BEOA);
						{	/* Eval/evaluate_comp.scm 549 */
							obj_t BgL_za2za2resza2za2z00_18024;

							{	/* Eval/evaluate_comp.scm 549 */
								obj_t BgL_res1132z00_18025;

								BgL_res1132z00_18025 = MAKE_CELL(BUNSPEC);
								if (CBOOL(BGl_zc3z04exitza33331ze3ze70z60zz__evaluate_compz00
										(BgL_sz00_15343, BgL_bodyz00_15342, BgL_res1132z00_18025)))
									{	/* Eval/evaluate_comp.scm 549 */
										BgL_za2za2resza2za2z00_18024 =
											PROCEDURE_ENTRY(BgL_hz00_18023) (BgL_hz00_18023,
											CELL_REF(BgL_res1132z00_18025), BEOA);
									}
								else
									{	/* Eval/evaluate_comp.scm 549 */
										BgL_za2za2resza2za2z00_18024 =
											CELL_REF(BgL_res1132z00_18025);
									}
							}
							VECTOR_SET(((obj_t) BgL_sz00_15343), ((long) 0), BgL_bpz00_18022);
							return BgL_za2za2resza2za2z00_18024;
						}
					}
				}
			}
		}

	}



/* <@exit:3331>~0 */
	obj_t BGl_zc3z04exitza33331ze3ze70z60zz__evaluate_compz00(obj_t
		BgL_sz00_15531, obj_t BgL_bodyz00_15530, obj_t BgL_res1132z00_15529)
	{
		{	/* Eval/evaluate_comp.scm 549 */
			jmp_buf_t jmpbuf;
			void *BgL_an_exit1138z00_4216;

			if (SET_EXIT(BgL_an_exit1138z00_4216))
				{
					return BGL_EXIT_VALUE();
				}
			else
				{
#if( SIGSETJMP_SAVESIGS == 0 )
					bgl_restore_signal_handlers();
#endif

					BgL_an_exit1138z00_4216 = (void *) jmpbuf;
					{	/* Eval/evaluate_comp.scm 549 */

						PUSH_EXIT(BgL_an_exit1138z00_4216, ((long) 1));
						{	/* Eval/evaluate_comp.scm 549 */
							obj_t BgL_an_exitd1139z00_4217;

							BgL_an_exitd1139z00_4217 = ((obj_t) (&exitd));
							{	/* Eval/evaluate_comp.scm 549 */
								bool_t BgL_res1141z00_4220;

								{	/* Eval/evaluate_comp.scm 549 */
									obj_t BgL_ohs1130z00_4221;

									BgL_ohs1130z00_4221 = BGL_ERROR_HANDLER_GET();
									{	/* Eval/evaluate_comp.scm 549 */
										obj_t BgL_exitd1135z00_4222;

										BgL_exitd1135z00_4222 = ((obj_t) (&exitd));
										{
											obj_t BgL_zc3z04anonymousza33335ze3z87_14310;

											BgL_zc3z04anonymousza33335ze3z87_14310 =
												MAKE_FX_PROCEDURE
												(BGl_z62zc3z04anonymousza33335ze3ze5zz__evaluate_compz00,
												(int) (((long) 0)), (int) (((long) 1)));
											PROCEDURE_SET(BgL_zc3z04anonymousza33335ze3z87_14310,
												(int) (((long) 0)), BgL_ohs1130z00_4221);
											BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
												(BgL_exitd1135z00_4222,
												BgL_zc3z04anonymousza33335ze3z87_14310);
											{	/* Eval/evaluate_comp.scm 549 */
												bool_t BgL_tmp1137z00_4224;

												{	/* Eval/evaluate_comp.scm 549 */
													obj_t BgL_arg3332z00_4225;

													{	/* Eval/evaluate_comp.scm 549 */
														obj_t BgL_zc3z04anonymousza33334ze3z87_14311;

														BgL_zc3z04anonymousza33334ze3z87_14311 =
															MAKE_FX_PROCEDURE
															(BGl_z62zc3z04anonymousza33334ze3ze5zz__evaluate_compz00,
															(int) (((long) 1)), (int) (((long) 2)));
														PROCEDURE_SET
															(BgL_zc3z04anonymousza33334ze3z87_14311,
															(int) (((long) 0)),
															((obj_t) BgL_res1132z00_15529));
														PROCEDURE_SET
															(BgL_zc3z04anonymousza33334ze3z87_14311,
															(int) (((long) 1)), BgL_an_exitd1139z00_4217);
														BgL_arg3332z00_4225 =
															MAKE_YOUNG_PAIR
															(BgL_zc3z04anonymousza33334ze3z87_14311,
															BgL_ohs1130z00_4221);
													}
													BGL_ERROR_HANDLER_SET(BgL_arg3332z00_4225);
													BUNSPEC;
												}
												{	/* Eval/evaluate_comp.scm 549 */
													obj_t BgL_auxz00_15345;

													BgL_auxz00_15345 =
														PROCEDURE_ENTRY(BgL_bodyz00_15530)
														(BgL_bodyz00_15530, BgL_sz00_15531, BEOA);
													CELL_SET(BgL_res1132z00_15529, BgL_auxz00_15345);
												}
												BgL_tmp1137z00_4224 = ((bool_t) 0);
												BGl_exitdzd2popzd2protectz12z12zz__bexitz00
													(BgL_exitd1135z00_4222);
												BGL_ERROR_HANDLER_SET(BgL_ohs1130z00_4221);
												BUNSPEC;
												BgL_res1141z00_4220 = BgL_tmp1137z00_4224;
								}}}}
								POP_EXIT();
								return BBOOL(BgL_res1141z00_4220);
							}
						}
					}
				}
		}

	}



/* &<@anonymous:3334> */
	obj_t BGl_z62zc3z04anonymousza33334ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_15347, obj_t BgL_ez00_15350)
	{
		{	/* Eval/evaluate_comp.scm 549 */
			{	/* Eval/evaluate_comp.scm 549 */
				obj_t BgL_res1132z00_15348;
				obj_t BgL_an_exitd1139z00_15349;

				BgL_res1132z00_15348 =
					PROCEDURE_REF(BgL_envz00_15347, (int) (((long) 0)));
				BgL_an_exitd1139z00_15349 =
					PROCEDURE_REF(BgL_envz00_15347, (int) (((long) 1)));
				CELL_SET(BgL_res1132z00_15348, BgL_ez00_15350);
				return
					BGl_unwindzd2untilz12zc0zz__bexitz00(BgL_an_exitd1139z00_15349,
					BTRUE);
			}
		}

	}



/* &<@anonymous:3335> */
	obj_t BGl_z62zc3z04anonymousza33335ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_15352)
	{
		{	/* Eval/evaluate_comp.scm 549 */
			{
				obj_t BgL_ohs1130z00_15353;

				BgL_ohs1130z00_15353 =
					PROCEDURE_REF(BgL_envz00_15352, (int) (((long) 0)));
				BGL_ERROR_HANDLER_SET(BgL_ohs1130z00_15353);
				return BUNSPEC;
			}
		}

	}



/* &comp-ev_unwind-prote1427 */
	obj_t BGl_z62compzd2ev_unwindzd2prote1427z62zz__evaluate_compz00(obj_t
		BgL_envz00_15354, obj_t BgL_ez00_15355, obj_t BgL_stkz00_15356)
	{
		{	/* Eval/evaluate_comp.scm 534 */
			{	/* Eval/evaluate_comp.scm 536 */
				obj_t BgL_ez00_18027;
				obj_t BgL_bodyz00_18028;

				BgL_ez00_18027 =
					BGl_compz00zz__evaluate_compz00(
					(((BgL_ev_unwindzd2protectzd2_bglt) COBJECT(
								((BgL_ev_unwindzd2protectzd2_bglt) BgL_ez00_15355)))->BgL_ez00),
					BgL_stkz00_15356);
				BgL_bodyz00_18028 =
					BGl_compz00zz__evaluate_compz00((((BgL_ev_unwindzd2protectzd2_bglt)
							COBJECT(((BgL_ev_unwindzd2protectzd2_bglt) BgL_ez00_15355)))->
						BgL_bodyz00), BgL_stkz00_15356);
				{	/* Eval/evaluate_comp.scm 537 */
					obj_t BgL_zc3z04anonymousza33317ze3z87_18029;

					BgL_zc3z04anonymousza33317ze3z87_18029 =
						MAKE_FX_PROCEDURE
						(BGl_z62zc3z04anonymousza33317ze3ze5zz__evaluate_compz00,
						(int) (((long) 1)), (int) (((long) 2)));
					PROCEDURE_SET(BgL_zc3z04anonymousza33317ze3z87_18029,
						(int) (((long) 0)), BgL_bodyz00_18028);
					PROCEDURE_SET(BgL_zc3z04anonymousza33317ze3z87_18029,
						(int) (((long) 1)), BgL_ez00_18027);
					return BgL_zc3z04anonymousza33317ze3z87_18029;
				}
			}
		}

	}



/* &<@anonymous:3317> */
	obj_t BGl_z62zc3z04anonymousza33317ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_15357, obj_t BgL_sz00_15360)
	{
		{	/* Eval/evaluate_comp.scm 537 */
			{	/* Eval/evaluate_comp.scm 537 */
				obj_t BgL_bodyz00_15358;
				obj_t BgL_ez00_15359;

				BgL_bodyz00_15358 = PROCEDURE_REF(BgL_envz00_15357, (int) (((long) 0)));
				BgL_ez00_15359 = PROCEDURE_REF(BgL_envz00_15357, (int) (((long) 1)));
				{	/* Eval/evaluate_comp.scm 537 */
					obj_t BgL_bpz00_18030;

					BgL_bpz00_18030 = VECTOR_REF(((obj_t) BgL_sz00_15360), ((long) 0));
					{	/* Eval/evaluate_comp.scm 539 */
						obj_t BgL_exitd1126z00_18031;

						BgL_exitd1126z00_18031 = BGL_EXITD_TOP_AS_OBJ();
						{	/* Eval/evaluate_comp.scm 540 */
							obj_t BgL_zc3z04anonymousza33318ze3z87_18032;

							BgL_zc3z04anonymousza33318ze3z87_18032 =
								MAKE_FX_PROCEDURE
								(BGl_z62zc3z04anonymousza33318ze3ze5zz__evaluate_compz00,
								(int) (((long) 0)), (int) (((long) 3)));
							PROCEDURE_SET(BgL_zc3z04anonymousza33318ze3z87_18032,
								(int) (((long) 0)), BgL_sz00_15360);
							PROCEDURE_SET(BgL_zc3z04anonymousza33318ze3z87_18032,
								(int) (((long) 1)), BgL_bpz00_18030);
							PROCEDURE_SET(BgL_zc3z04anonymousza33318ze3z87_18032,
								(int) (((long) 2)), BgL_bodyz00_15358);
							BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
								(BgL_exitd1126z00_18031,
								BgL_zc3z04anonymousza33318ze3z87_18032);
							{	/* Eval/evaluate_comp.scm 539 */
								obj_t BgL_tmp1128z00_18033;

								BgL_tmp1128z00_18033 =
									PROCEDURE_ENTRY(BgL_ez00_15359) (BgL_ez00_15359,
									BgL_sz00_15360, BEOA);
								BGl_exitdzd2popzd2protectz12z12zz__bexitz00
									(BgL_exitd1126z00_18031);
								VECTOR_SET(((obj_t) BgL_sz00_15360), ((long) 0),
									BgL_bpz00_18030);
								PROCEDURE_ENTRY(BgL_bodyz00_15358) (BgL_bodyz00_15358,
									BgL_sz00_15360, BEOA);
								return BgL_tmp1128z00_18033;
							}
						}
					}
				}
			}
		}

	}



/* &<@anonymous:3318> */
	obj_t BGl_z62zc3z04anonymousza33318ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_15361)
	{
		{	/* Eval/evaluate_comp.scm 539 */
			{	/* Eval/evaluate_comp.scm 540 */
				obj_t BgL_sz00_15362;
				obj_t BgL_savedzd2bpzd2_15363;
				obj_t BgL_bodyz00_15364;

				BgL_sz00_15362 = PROCEDURE_REF(BgL_envz00_15361, (int) (((long) 0)));
				BgL_savedzd2bpzd2_15363 =
					PROCEDURE_REF(BgL_envz00_15361, (int) (((long) 1)));
				BgL_bodyz00_15364 = PROCEDURE_REF(BgL_envz00_15361, (int) (((long) 2)));
				VECTOR_SET(
					((obj_t) BgL_sz00_15362), ((long) 0), BgL_savedzd2bpzd2_15363);
				return
					PROCEDURE_ENTRY(BgL_bodyz00_15364) (BgL_bodyz00_15364, BgL_sz00_15362,
					BEOA);
			}
		}

	}



/* &comp-ev_bind-exit1425 */
	obj_t BGl_z62compzd2ev_bindzd2exit1425z62zz__evaluate_compz00(obj_t
		BgL_envz00_15365, obj_t BgL_ez00_15366, obj_t BgL_stkz00_15367)
	{
		{	/* Eval/evaluate_comp.scm 523 */
			{	/* Eval/evaluate_comp.scm 525 */
				long BgL_siza7eza7_18035;
				obj_t BgL_nstkz00_18036;

				BgL_siza7eza7_18035 = bgl_list_length(BgL_stkz00_15367);
				{	/* Eval/evaluate_comp.scm 525 */
					obj_t BgL_arg3315z00_18037;

					{	/* Eval/evaluate_comp.scm 525 */
						BgL_ev_varz00_bglt BgL_arg3316z00_18038;

						BgL_arg3316z00_18038 =
							(((BgL_ev_bindzd2exitzd2_bglt) COBJECT(
									((BgL_ev_bindzd2exitzd2_bglt) BgL_ez00_15366)))->BgL_varz00);
						BgL_arg3315z00_18037 =
							MAKE_YOUNG_PAIR(((obj_t) BgL_arg3316z00_18038), BNIL);
					}
					BgL_nstkz00_18036 =
						BGl_appendzd221011zd2zz__evaluate_compz00(BgL_stkz00_15367,
						BgL_arg3315z00_18037);
				}
				{	/* Eval/evaluate_comp.scm 526 */
					obj_t BgL_bodyz00_18039;
					obj_t BgL_effzf3zf3_18040;

					BgL_bodyz00_18039 =
						BGl_compz00zz__evaluate_compz00(
						(((BgL_ev_bindzd2exitzd2_bglt) COBJECT(
									((BgL_ev_bindzd2exitzd2_bglt) BgL_ez00_15366)))->BgL_bodyz00),
						BgL_nstkz00_18036);
					BgL_effzf3zf3_18040 =
						(((BgL_ev_varz00_bglt) COBJECT((((BgL_ev_bindzd2exitzd2_bglt)
										COBJECT(((BgL_ev_bindzd2exitzd2_bglt) BgL_ez00_15366)))->
									BgL_varz00)))->BgL_effz00);
					{	/* Eval/evaluate_comp.scm 527 */
						obj_t BgL_zc3z04anonymousza33307ze3z87_18041;

						BgL_zc3z04anonymousza33307ze3z87_18041 =
							MAKE_FX_PROCEDURE
							(BGl_z62zc3z04anonymousza33307ze3ze5zz__evaluate_compz00,
							(int) (((long) 1)), (int) (((long) 3)));
						PROCEDURE_SET(BgL_zc3z04anonymousza33307ze3z87_18041,
							(int) (((long) 0)), BINT(BgL_siza7eza7_18035));
						PROCEDURE_SET(BgL_zc3z04anonymousza33307ze3z87_18041,
							(int) (((long) 1)), BgL_effzf3zf3_18040);
						PROCEDURE_SET(BgL_zc3z04anonymousza33307ze3z87_18041,
							(int) (((long) 2)), BgL_bodyz00_18039);
						return BgL_zc3z04anonymousza33307ze3z87_18041;
					}
				}
			}
		}

	}



/* &<@anonymous:3307> */
	obj_t BGl_z62zc3z04anonymousza33307ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_15368, obj_t BgL_sz00_15372)
	{
		{	/* Eval/evaluate_comp.scm 527 */
			{	/* Eval/evaluate_comp.scm 527 */
				long BgL_siza7eza7_15369;
				obj_t BgL_effzf3zf3_15370;
				obj_t BgL_bodyz00_15371;

				BgL_siza7eza7_15369 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15368, (int) (((long) 0))));
				BgL_effzf3zf3_15370 =
					PROCEDURE_REF(BgL_envz00_15368, (int) (((long) 1)));
				BgL_bodyz00_15371 = PROCEDURE_REF(BgL_envz00_15368, (int) (((long) 2)));
				{	/* Eval/evaluate_comp.scm 527 */
					obj_t BgL_bpz00_18042;

					BgL_bpz00_18042 = VECTOR_REF(((obj_t) BgL_sz00_15372), ((long) 0));
					{	/* Eval/evaluate_comp.scm 529 */
						obj_t BgL_za2za2resza2za2z00_18043;

						BgL_za2za2resza2za2z00_18043 =
							BGl_zc3z04exitza33308ze3ze70z60zz__evaluate_compz00
							(BgL_bodyz00_15371, BgL_sz00_15372, BgL_effzf3zf3_15370,
							BgL_siza7eza7_15369, BgL_bpz00_18042);
						VECTOR_SET(((obj_t) BgL_sz00_15372), ((long) 0), BgL_bpz00_18042);
						return BgL_za2za2resza2za2z00_18043;
					}
				}
			}
		}

	}



/* <@exit:3308>~0 */
	obj_t BGl_zc3z04exitza33308ze3ze70z60zz__evaluate_compz00(obj_t
		BgL_bodyz00_15528, obj_t BgL_sz00_15527, obj_t BgL_effzf3zf3_15526,
		long BgL_siza7eza7_15525, obj_t BgL_bpz00_15524)
	{
		{	/* Eval/evaluate_comp.scm 529 */
			jmp_buf_t jmpbuf;
			void *BgL_an_exit1121z00_4151;

			if (SET_EXIT(BgL_an_exit1121z00_4151))
				{
					return BGL_EXIT_VALUE();
				}
			else
				{
#if( SIGSETJMP_SAVESIGS == 0 )
					bgl_restore_signal_handlers();
#endif

					BgL_an_exit1121z00_4151 = (void *) jmpbuf;
					{	/* Eval/evaluate_comp.scm 529 */

						PUSH_EXIT(BgL_an_exit1121z00_4151, ((long) 1));
						{	/* Eval/evaluate_comp.scm 529 */
							obj_t BgL_an_exitd1122z00_4152;

							BgL_an_exitd1122z00_4152 = ((obj_t) (&exitd));
							{	/* Eval/evaluate_comp.scm 529 */
								obj_t BgL_exitz00_14317;

								BgL_exitz00_14317 =
									MAKE_FX_PROCEDURE(BGl_z62exitz62zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 1)));
								PROCEDURE_SET(BgL_exitz00_14317,
									(int) (((long) 0)), BgL_an_exitd1122z00_4152);
								{	/* Eval/evaluate_comp.scm 529 */
									obj_t BgL_res1124z00_4155;

									{	/* Eval/evaluate_comp.scm 530 */
										long BgL_arg3312z00_4156;
										obj_t BgL_arg3313z00_4157;

										BgL_arg3312z00_4156 =
											((long) CINT(BgL_bpz00_15524) + BgL_siza7eza7_15525);
										if (CBOOL(BgL_effzf3zf3_15526))
											{	/* Eval/evaluate_comp.scm 202 */
												obj_t BgL_newz00_10526;

												BgL_newz00_10526 =
													create_struct(BGl_symbol5817z00zz__evaluate_compz00,
													(int) (((long) 1)));
												{	/* Eval/evaluate_comp.scm 202 */
													int BgL_tmpz00_33393;

													BgL_tmpz00_33393 = (int) (((long) 0));
													STRUCT_SET(BgL_newz00_10526, BgL_tmpz00_33393,
														BgL_exitz00_14317);
												}
												BgL_arg3313z00_4157 = BgL_newz00_10526;
											}
										else
											{	/* Eval/evaluate_comp.scm 530 */
												BgL_arg3313z00_4157 = BgL_exitz00_14317;
											}
										VECTOR_SET(
											((obj_t) BgL_sz00_15527), BgL_arg3312z00_4156,
											BgL_arg3313z00_4157);
									}
									BgL_res1124z00_4155 =
										PROCEDURE_ENTRY(BgL_bodyz00_15528) (BgL_bodyz00_15528,
										BgL_sz00_15527, BEOA);
									POP_EXIT();
									return BgL_res1124z00_4155;
								}
							}
						}
					}
				}
		}

	}



/* &exit */
	obj_t BGl_z62exitz62zz__evaluate_compz00(obj_t BgL_envz00_15373,
		obj_t BgL_val1123z00_15375)
	{
		{	/* Eval/evaluate_comp.scm 529 */
			return
				BGl_unwindzd2untilz12zc0zz__bexitz00(PROCEDURE_REF(BgL_envz00_15373,
					(int) (((long) 0))), BgL_val1123z00_15375);
		}

	}



/* &comp-ev_letrec1423 */
	obj_t BGl_z62compzd2ev_letrec1423zb0zz__evaluate_compz00(obj_t
		BgL_envz00_15376, obj_t BgL_ez00_15377, obj_t BgL_stkz00_15378)
	{
		{	/* Eval/evaluate_comp.scm 494 */
			{	/* Eval/evaluate_comp.scm 496 */
				long BgL_siza7eza7_18045;
				obj_t BgL_nstkz00_18046;

				BgL_siza7eza7_18045 = bgl_list_length(BgL_stkz00_15378);
				{	/* Eval/evaluate_comp.scm 496 */
					obj_t BgL_arg3306z00_18047;

					BgL_arg3306z00_18047 =
						(((BgL_ev_binderz00_bglt) COBJECT(
								((BgL_ev_binderz00_bglt)
									((BgL_ev_letrecz00_bglt) BgL_ez00_15377))))->BgL_varsz00);
					BgL_nstkz00_18046 =
						BGl_appendzd221011zd2zz__evaluate_compz00(BgL_stkz00_15378,
						BgL_arg3306z00_18047);
				}
				{	/* Eval/evaluate_comp.scm 497 */
					obj_t BgL_cvalsz00_18048;
					obj_t BgL_bodyz00_18049;

					{	/* Eval/evaluate_comp.scm 497 */
						obj_t BgL_l1318z00_18050;

						BgL_l1318z00_18050 =
							(((BgL_ev_binderz00_bglt) COBJECT(
									((BgL_ev_binderz00_bglt)
										((BgL_ev_letrecz00_bglt) BgL_ez00_15377))))->BgL_valsz00);
						if (NULLP(BgL_l1318z00_18050))
							{	/* Eval/evaluate_comp.scm 497 */
								BgL_cvalsz00_18048 = BNIL;
							}
						else
							{	/* Eval/evaluate_comp.scm 497 */
								obj_t BgL_head1320z00_18051;

								{	/* Eval/evaluate_comp.scm 497 */
									obj_t BgL_res5159z00_18052;

									BgL_res5159z00_18052 = MAKE_YOUNG_PAIR(BNIL, BNIL);
									BgL_head1320z00_18051 = BgL_res5159z00_18052;
								}
								{
									obj_t BgL_l1318z00_18054;
									obj_t BgL_tail1321z00_18055;

									BgL_l1318z00_18054 = BgL_l1318z00_18050;
									BgL_tail1321z00_18055 = BgL_head1320z00_18051;
								BgL_zc3z04anonymousza33294ze3z87_18053:
									if (NULLP(BgL_l1318z00_18054))
										{	/* Eval/evaluate_comp.scm 497 */
											BgL_cvalsz00_18048 = CDR(BgL_head1320z00_18051);
										}
									else
										{	/* Eval/evaluate_comp.scm 497 */
											obj_t BgL_newtail1322z00_18056;

											{	/* Eval/evaluate_comp.scm 497 */
												obj_t BgL_arg3304z00_18057;

												{	/* Eval/evaluate_comp.scm 497 */
													obj_t BgL_vz00_18058;

													BgL_vz00_18058 = CAR(((obj_t) BgL_l1318z00_18054));
													BgL_arg3304z00_18057 =
														BGl_compz00zz__evaluate_compz00(
														((BgL_ev_exprz00_bglt) BgL_vz00_18058),
														BgL_nstkz00_18046);
												}
												{	/* Eval/evaluate_comp.scm 497 */
													obj_t BgL_res5165z00_18059;

													BgL_res5165z00_18059 =
														MAKE_YOUNG_PAIR(BgL_arg3304z00_18057, BNIL);
													BgL_newtail1322z00_18056 = BgL_res5165z00_18059;
												}
											}
											SET_CDR(BgL_tail1321z00_18055, BgL_newtail1322z00_18056);
											{	/* Eval/evaluate_comp.scm 497 */
												obj_t BgL_arg3303z00_18060;

												BgL_arg3303z00_18060 =
													CDR(((obj_t) BgL_l1318z00_18054));
												{
													obj_t BgL_tail1321z00_33429;
													obj_t BgL_l1318z00_33428;

													BgL_l1318z00_33428 = BgL_arg3303z00_18060;
													BgL_tail1321z00_33429 = BgL_newtail1322z00_18056;
													BgL_tail1321z00_18055 = BgL_tail1321z00_33429;
													BgL_l1318z00_18054 = BgL_l1318z00_33428;
													goto BgL_zc3z04anonymousza33294ze3z87_18053;
												}
											}
										}
								}
							}
					}
					{	/* Eval/evaluate_comp.scm 498 */
						BgL_ev_exprz00_bglt BgL_arg3305z00_18061;

						BgL_arg3305z00_18061 =
							(((BgL_ev_binderz00_bglt) COBJECT(
									((BgL_ev_binderz00_bglt)
										((BgL_ev_letrecz00_bglt) BgL_ez00_15377))))->BgL_bodyz00);
						BgL_bodyz00_18049 =
							BGl_compz00zz__evaluate_compz00(BgL_arg3305z00_18061,
							BgL_nstkz00_18046);
					}
					{	/* Eval/evaluate_comp.scm 499 */
						bool_t BgL_test6790z00_33434;

						{
							obj_t BgL_l1323z00_18063;

							BgL_l1323z00_18063 =
								(((BgL_ev_binderz00_bglt) COBJECT(
										((BgL_ev_binderz00_bglt)
											((BgL_ev_letrecz00_bglt) BgL_ez00_15377))))->BgL_valsz00);
						BgL_zc3z04anonymousza33291ze3z87_18062:
							if (NULLP(BgL_l1323z00_18063))
								{	/* Eval/evaluate_comp.scm 499 */
									BgL_test6790z00_33434 = ((bool_t) 1);
								}
							else
								{	/* Eval/evaluate_comp.scm 499 */
									bool_t BgL_test6792z00_33437;

									{	/* Eval/evaluate_comp.scm 499 */
										obj_t BgL_vz00_18064;

										BgL_vz00_18064 = CAR(((obj_t) BgL_l1323z00_18063));
										BgL_test6792z00_33437 =
											BGl_isazf3zf3zz__objectz00(BgL_vz00_18064,
											BGl_ev_absz00zz__evaluate_typesz00);
									}
									if (BgL_test6792z00_33437)
										{
											obj_t BgL_l1323z00_33441;

											BgL_l1323z00_33441 = CDR(((obj_t) BgL_l1323z00_18063));
											BgL_l1323z00_18063 = BgL_l1323z00_33441;
											goto BgL_zc3z04anonymousza33291ze3z87_18062;
										}
									else
										{	/* Eval/evaluate_comp.scm 499 */
											BgL_test6790z00_33434 = ((bool_t) 0);
										}
								}
						}
						if (BgL_test6790z00_33434)
							{	/* Eval/evaluate_comp.scm 500 */
								obj_t BgL_zc3z04anonymousza33255ze3z87_18065;

								BgL_zc3z04anonymousza33255ze3z87_18065 =
									MAKE_FX_PROCEDURE
									(BGl_z62zc3z04anonymousza33255ze3ze5zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 3)));
								PROCEDURE_SET(BgL_zc3z04anonymousza33255ze3z87_18065,
									(int) (((long) 0)), BINT(BgL_siza7eza7_18045));
								PROCEDURE_SET(BgL_zc3z04anonymousza33255ze3z87_18065,
									(int) (((long) 1)), BgL_cvalsz00_18048);
								PROCEDURE_SET(BgL_zc3z04anonymousza33255ze3z87_18065,
									(int) (((long) 2)), BgL_bodyz00_18049);
								return BgL_zc3z04anonymousza33255ze3z87_18065;
							}
						else
							{	/* Eval/evaluate_comp.scm 510 */
								obj_t BgL_zc3z04anonymousza33270ze3z87_18066;

								BgL_zc3z04anonymousza33270ze3z87_18066 =
									MAKE_FX_PROCEDURE
									(BGl_z62zc3z04anonymousza33270ze3ze5zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 3)));
								PROCEDURE_SET(BgL_zc3z04anonymousza33270ze3z87_18066,
									(int) (((long) 0)), BINT(BgL_siza7eza7_18045));
								PROCEDURE_SET(BgL_zc3z04anonymousza33270ze3z87_18066,
									(int) (((long) 1)), BgL_cvalsz00_18048);
								PROCEDURE_SET(BgL_zc3z04anonymousza33270ze3z87_18066,
									(int) (((long) 2)), BgL_bodyz00_18049);
								return BgL_zc3z04anonymousza33270ze3z87_18066;
							}
					}
				}
			}
		}

	}



/* &<@anonymous:3255> */
	obj_t BGl_z62zc3z04anonymousza33255ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_15379, obj_t BgL_sz00_15383)
	{
		{	/* Eval/evaluate_comp.scm 500 */
			{	/* Eval/evaluate_comp.scm 500 */
				long BgL_siza7eza7_15380;
				obj_t BgL_cvalsz00_15381;
				obj_t BgL_bodyz00_15382;

				BgL_siza7eza7_15380 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15379, (int) (((long) 0))));
				BgL_cvalsz00_15381 =
					PROCEDURE_REF(BgL_envz00_15379, (int) (((long) 1)));
				BgL_bodyz00_15382 = PROCEDURE_REF(BgL_envz00_15379, (int) (((long) 2)));
				{	/* Eval/evaluate_comp.scm 500 */
					obj_t BgL_bpz00_18067;

					BgL_bpz00_18067 = VECTOR_REF(((obj_t) BgL_sz00_15383), ((long) 0));
					{	/* Eval/evaluate_comp.scm 501 */
						long BgL_g1115z00_18068;

						BgL_g1115z00_18068 =
							((long) CINT(BgL_bpz00_18067) + BgL_siza7eza7_15380);
						{
							obj_t BgL_lz00_18070;
							long BgL_iz00_18071;

							BgL_lz00_18070 = BgL_cvalsz00_15381;
							BgL_iz00_18071 = BgL_g1115z00_18068;
						BgL_recz00_18069:
							if (NULLP(BgL_lz00_18070))
								{	/* Eval/evaluate_comp.scm 502 */
									((bool_t) 0);
								}
							else
								{	/* Eval/evaluate_comp.scm 502 */
									{	/* Eval/evaluate_comp.scm 503 */
										obj_t BgL_arg3258z00_18072;

										{	/* Eval/evaluate_comp.scm 202 */
											obj_t BgL_newz00_18073;

											BgL_newz00_18073 =
												create_struct(BGl_symbol5817z00zz__evaluate_compz00,
												(int) (((long) 1)));
											{	/* Eval/evaluate_comp.scm 202 */
												int BgL_tmpz00_33482;

												BgL_tmpz00_33482 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_18073, BgL_tmpz00_33482, BUNSPEC);
											}
											BgL_arg3258z00_18072 = BgL_newz00_18073;
										}
										VECTOR_SET(
											((obj_t) BgL_sz00_15383), BgL_iz00_18071,
											BgL_arg3258z00_18072);
									}
									{	/* Eval/evaluate_comp.scm 504 */
										obj_t BgL_arg3260z00_18074;
										long BgL_arg3261z00_18075;

										BgL_arg3260z00_18074 = CDR(((obj_t) BgL_lz00_18070));
										BgL_arg3261z00_18075 = (BgL_iz00_18071 + ((long) 1));
										{
											long BgL_iz00_33491;
											obj_t BgL_lz00_33490;

											BgL_lz00_33490 = BgL_arg3260z00_18074;
											BgL_iz00_33491 = BgL_arg3261z00_18075;
											BgL_iz00_18071 = BgL_iz00_33491;
											BgL_lz00_18070 = BgL_lz00_33490;
											goto BgL_recz00_18069;
										}
									}
								}
						}
					}
					{	/* Eval/evaluate_comp.scm 505 */
						long BgL_g1116z00_18076;

						BgL_g1116z00_18076 =
							((long) CINT(BgL_bpz00_18067) + BgL_siza7eza7_15380);
						{
							obj_t BgL_lz00_18078;
							long BgL_iz00_18079;

							BgL_lz00_18078 = BgL_cvalsz00_15381;
							BgL_iz00_18079 = BgL_g1116z00_18076;
						BgL_recz00_18077:
							if (NULLP(BgL_lz00_18078))
								{	/* Eval/evaluate_comp.scm 506 */
									((bool_t) 0);
								}
							else
								{	/* Eval/evaluate_comp.scm 506 */
									{	/* Eval/evaluate_comp.scm 507 */
										obj_t BgL_arg3264z00_18080;
										obj_t BgL_arg3265z00_18081;

										BgL_arg3264z00_18080 =
											VECTOR_REF(((obj_t) BgL_sz00_15383), BgL_iz00_18079);
										{	/* Eval/evaluate_comp.scm 507 */
											obj_t BgL_fun3266z00_18082;

											BgL_fun3266z00_18082 = CAR(((obj_t) BgL_lz00_18078));
											BgL_arg3265z00_18081 =
												PROCEDURE_ENTRY(BgL_fun3266z00_18082)
												(BgL_fun3266z00_18082, BgL_sz00_15383, BEOA);
										}
										{	/* Eval/evaluate_comp.scm 202 */
											int BgL_auxz00_33506;
											obj_t BgL_tmpz00_33504;

											BgL_auxz00_33506 = (int) (((long) 0));
											BgL_tmpz00_33504 = ((obj_t) BgL_arg3264z00_18080);
											STRUCT_SET(BgL_tmpz00_33504, BgL_auxz00_33506,
												BgL_arg3265z00_18081);
									}}
									{	/* Eval/evaluate_comp.scm 508 */
										obj_t BgL_arg3268z00_18083;
										long BgL_arg3269z00_18084;

										BgL_arg3268z00_18083 = CDR(((obj_t) BgL_lz00_18078));
										BgL_arg3269z00_18084 = (BgL_iz00_18079 + ((long) 1));
										{
											long BgL_iz00_33513;
											obj_t BgL_lz00_33512;

											BgL_lz00_33512 = BgL_arg3268z00_18083;
											BgL_iz00_33513 = BgL_arg3269z00_18084;
											BgL_iz00_18079 = BgL_iz00_33513;
											BgL_lz00_18078 = BgL_lz00_33512;
											goto BgL_recz00_18077;
										}
									}
								}
						}
					}
					return
						PROCEDURE_ENTRY(BgL_bodyz00_15382) (BgL_bodyz00_15382,
						BgL_sz00_15383, BEOA);
				}
			}
		}

	}



/* &<@anonymous:3270> */
	obj_t BGl_z62zc3z04anonymousza33270ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_15384, obj_t BgL_sz00_15388)
	{
		{	/* Eval/evaluate_comp.scm 510 */
			{	/* Eval/evaluate_comp.scm 510 */
				long BgL_siza7eza7_15385;
				obj_t BgL_cvalsz00_15386;
				obj_t BgL_bodyz00_15387;

				BgL_siza7eza7_15385 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15384, (int) (((long) 0))));
				BgL_cvalsz00_15386 =
					PROCEDURE_REF(BgL_envz00_15384, (int) (((long) 1)));
				BgL_bodyz00_15387 = PROCEDURE_REF(BgL_envz00_15384, (int) (((long) 2)));
				{	/* Eval/evaluate_comp.scm 510 */
					obj_t BgL_bpz00_18085;

					BgL_bpz00_18085 = VECTOR_REF(((obj_t) BgL_sz00_15388), ((long) 0));
					{	/* Eval/evaluate_comp.scm 511 */
						long BgL_g1117z00_18086;

						BgL_g1117z00_18086 =
							((long) CINT(BgL_bpz00_18085) + BgL_siza7eza7_15385);
						{
							obj_t BgL_lz00_18088;
							long BgL_iz00_18089;

							BgL_lz00_18088 = BgL_cvalsz00_15386;
							BgL_iz00_18089 = BgL_g1117z00_18086;
						BgL_recz00_18087:
							if (NULLP(BgL_lz00_18088))
								{	/* Eval/evaluate_comp.scm 512 */
									((bool_t) 0);
								}
							else
								{	/* Eval/evaluate_comp.scm 512 */
									{	/* Eval/evaluate_comp.scm 513 */
										obj_t BgL_arg3273z00_18090;

										{	/* Eval/evaluate_comp.scm 202 */
											obj_t BgL_newz00_18091;

											BgL_newz00_18091 =
												create_struct(BGl_symbol5817z00zz__evaluate_compz00,
												(int) (((long) 1)));
											{	/* Eval/evaluate_comp.scm 202 */
												int BgL_tmpz00_33533;

												BgL_tmpz00_33533 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_18091, BgL_tmpz00_33533, BUNSPEC);
											}
											BgL_arg3273z00_18090 = BgL_newz00_18091;
										}
										VECTOR_SET(
											((obj_t) BgL_sz00_15388), BgL_iz00_18089,
											BgL_arg3273z00_18090);
									}
									{	/* Eval/evaluate_comp.scm 514 */
										obj_t BgL_arg3274z00_18092;
										long BgL_arg3275z00_18093;

										BgL_arg3274z00_18092 = CDR(((obj_t) BgL_lz00_18088));
										BgL_arg3275z00_18093 = (BgL_iz00_18089 + ((long) 1));
										{
											long BgL_iz00_33542;
											obj_t BgL_lz00_33541;

											BgL_lz00_33541 = BgL_arg3274z00_18092;
											BgL_iz00_33542 = BgL_arg3275z00_18093;
											BgL_iz00_18089 = BgL_iz00_33542;
											BgL_lz00_18088 = BgL_lz00_33541;
											goto BgL_recz00_18087;
										}
									}
								}
						}
					}
					{	/* Eval/evaluate_comp.scm 515 */
						obj_t BgL_rvalsz00_18094;

						if (NULLP(BgL_cvalsz00_15386))
							{	/* Eval/evaluate_comp.scm 515 */
								BgL_rvalsz00_18094 = BNIL;
							}
						else
							{	/* Eval/evaluate_comp.scm 515 */
								obj_t BgL_head1329z00_18095;

								{	/* Eval/evaluate_comp.scm 515 */
									obj_t BgL_res5185z00_18096;

									BgL_res5185z00_18096 = MAKE_YOUNG_PAIR(BNIL, BNIL);
									BgL_head1329z00_18095 = BgL_res5185z00_18096;
								}
								{
									obj_t BgL_l1327z00_18098;
									obj_t BgL_tail1330z00_18099;

									BgL_l1327z00_18098 = BgL_cvalsz00_15386;
									BgL_tail1330z00_18099 = BgL_head1329z00_18095;
								BgL_zc3z04anonymousza33287ze3z87_18097:
									if (NULLP(BgL_l1327z00_18098))
										{	/* Eval/evaluate_comp.scm 515 */
											BgL_rvalsz00_18094 = CDR(BgL_head1329z00_18095);
										}
									else
										{	/* Eval/evaluate_comp.scm 515 */
											obj_t BgL_newtail1331z00_18100;

											{	/* Eval/evaluate_comp.scm 515 */
												obj_t BgL_arg3290z00_18101;

												{	/* Eval/evaluate_comp.scm 515 */
													obj_t BgL_vz00_18102;

													BgL_vz00_18102 = CAR(((obj_t) BgL_l1327z00_18098));
													BgL_arg3290z00_18101 =
														PROCEDURE_ENTRY(BgL_vz00_18102) (BgL_vz00_18102,
														BgL_sz00_15388, BEOA);
												}
												{	/* Eval/evaluate_comp.scm 515 */
													obj_t BgL_res5191z00_18103;

													BgL_res5191z00_18103 =
														MAKE_YOUNG_PAIR(BgL_arg3290z00_18101, BNIL);
													BgL_newtail1331z00_18100 = BgL_res5191z00_18103;
												}
											}
											SET_CDR(BgL_tail1330z00_18099, BgL_newtail1331z00_18100);
											{	/* Eval/evaluate_comp.scm 515 */
												obj_t BgL_arg3289z00_18104;

												BgL_arg3289z00_18104 =
													CDR(((obj_t) BgL_l1327z00_18098));
												{
													obj_t BgL_tail1330z00_33560;
													obj_t BgL_l1327z00_33559;

													BgL_l1327z00_33559 = BgL_arg3289z00_18104;
													BgL_tail1330z00_33560 = BgL_newtail1331z00_18100;
													BgL_tail1330z00_18099 = BgL_tail1330z00_33560;
													BgL_l1327z00_18098 = BgL_l1327z00_33559;
													goto BgL_zc3z04anonymousza33287ze3z87_18097;
												}
											}
										}
								}
							}
						{	/* Eval/evaluate_comp.scm 516 */
							long BgL_g1118z00_18105;

							BgL_g1118z00_18105 =
								((long) CINT(BgL_bpz00_18085) + BgL_siza7eza7_15385);
							{
								obj_t BgL_lz00_18107;
								long BgL_iz00_18108;

								BgL_lz00_18107 = BgL_rvalsz00_18094;
								BgL_iz00_18108 = BgL_g1118z00_18105;
							BgL_recz00_18106:
								if (NULLP(BgL_lz00_18107))
									{	/* Eval/evaluate_comp.scm 517 */
										((bool_t) 0);
									}
								else
									{	/* Eval/evaluate_comp.scm 517 */
										{	/* Eval/evaluate_comp.scm 518 */
											obj_t BgL_arg3278z00_18109;
											obj_t BgL_arg3281z00_18110;

											BgL_arg3278z00_18109 =
												VECTOR_REF(((obj_t) BgL_sz00_15388), BgL_iz00_18108);
											BgL_arg3281z00_18110 = CAR(((obj_t) BgL_lz00_18107));
											{	/* Eval/evaluate_comp.scm 202 */
												int BgL_auxz00_33571;
												obj_t BgL_tmpz00_33569;

												BgL_auxz00_33571 = (int) (((long) 0));
												BgL_tmpz00_33569 = ((obj_t) BgL_arg3278z00_18109);
												STRUCT_SET(BgL_tmpz00_33569, BgL_auxz00_33571,
													BgL_arg3281z00_18110);
										}}
										{	/* Eval/evaluate_comp.scm 519 */
											obj_t BgL_arg3282z00_18111;
											long BgL_arg3285z00_18112;

											BgL_arg3282z00_18111 = CDR(((obj_t) BgL_lz00_18107));
											BgL_arg3285z00_18112 = (BgL_iz00_18108 + ((long) 1));
											{
												long BgL_iz00_33578;
												obj_t BgL_lz00_33577;

												BgL_lz00_33577 = BgL_arg3282z00_18111;
												BgL_iz00_33578 = BgL_arg3285z00_18112;
												BgL_iz00_18108 = BgL_iz00_33578;
												BgL_lz00_18107 = BgL_lz00_33577;
												goto BgL_recz00_18106;
											}
										}
									}
							}
						}
						return
							PROCEDURE_ENTRY(BgL_bodyz00_15387) (BgL_bodyz00_15387,
							BgL_sz00_15388, BEOA);
					}
				}
			}
		}

	}



/* &comp-ev_let*1421 */
	obj_t BGl_z62compzd2ev_letza21421z12zz__evaluate_compz00(obj_t
		BgL_envz00_15389, obj_t BgL_ez00_15390, obj_t BgL_stkz00_15391)
	{
		{	/* Eval/evaluate_comp.scm 481 */
			{	/* Eval/evaluate_comp.scm 483 */
				long BgL_siza7eza7_18114;
				obj_t BgL_nstkz00_18115;

				BgL_siza7eza7_18114 = bgl_list_length(BgL_stkz00_15391);
				{	/* Eval/evaluate_comp.scm 483 */
					obj_t BgL_arg3250z00_18116;

					BgL_arg3250z00_18116 =
						(((BgL_ev_binderz00_bglt) COBJECT(
								((BgL_ev_binderz00_bglt)
									((BgL_ev_letza2za2_bglt) BgL_ez00_15390))))->BgL_varsz00);
					BgL_nstkz00_18115 =
						BGl_appendzd221011zd2zz__evaluate_compz00(BgL_stkz00_15391,
						BgL_arg3250z00_18116);
				}
				{	/* Eval/evaluate_comp.scm 484 */
					obj_t BgL_valsz00_18117;
					obj_t BgL_bodyz00_18118;

					{	/* Eval/evaluate_comp.scm 484 */
						obj_t BgL_l1313z00_18119;

						BgL_l1313z00_18119 =
							(((BgL_ev_binderz00_bglt) COBJECT(
									((BgL_ev_binderz00_bglt)
										((BgL_ev_letza2za2_bglt) BgL_ez00_15390))))->BgL_valsz00);
						if (NULLP(BgL_l1313z00_18119))
							{	/* Eval/evaluate_comp.scm 484 */
								BgL_valsz00_18117 = BNIL;
							}
						else
							{	/* Eval/evaluate_comp.scm 484 */
								obj_t BgL_head1315z00_18120;

								{	/* Eval/evaluate_comp.scm 484 */
									obj_t BgL_res5148z00_18121;

									BgL_res5148z00_18121 = MAKE_YOUNG_PAIR(BNIL, BNIL);
									BgL_head1315z00_18120 = BgL_res5148z00_18121;
								}
								{
									obj_t BgL_l1313z00_18123;
									obj_t BgL_tail1316z00_18124;

									BgL_l1313z00_18123 = BgL_l1313z00_18119;
									BgL_tail1316z00_18124 = BgL_head1315z00_18120;
								BgL_zc3z04anonymousza33242ze3z87_18122:
									if (NULLP(BgL_l1313z00_18123))
										{	/* Eval/evaluate_comp.scm 484 */
											BgL_valsz00_18117 = CDR(BgL_head1315z00_18120);
										}
									else
										{	/* Eval/evaluate_comp.scm 484 */
											obj_t BgL_newtail1317z00_18125;

											{	/* Eval/evaluate_comp.scm 484 */
												obj_t BgL_arg3246z00_18126;

												{	/* Eval/evaluate_comp.scm 484 */
													obj_t BgL_vz00_18127;

													BgL_vz00_18127 = CAR(((obj_t) BgL_l1313z00_18123));
													BgL_arg3246z00_18126 =
														BGl_compz00zz__evaluate_compz00(
														((BgL_ev_exprz00_bglt) BgL_vz00_18127),
														BgL_nstkz00_18115);
												}
												{	/* Eval/evaluate_comp.scm 484 */
													obj_t BgL_res5154z00_18128;

													BgL_res5154z00_18128 =
														MAKE_YOUNG_PAIR(BgL_arg3246z00_18126, BNIL);
													BgL_newtail1317z00_18125 = BgL_res5154z00_18128;
												}
											}
											SET_CDR(BgL_tail1316z00_18124, BgL_newtail1317z00_18125);
											{	/* Eval/evaluate_comp.scm 484 */
												obj_t BgL_arg3245z00_18129;

												BgL_arg3245z00_18129 =
													CDR(((obj_t) BgL_l1313z00_18123));
												{
													obj_t BgL_tail1316z00_33606;
													obj_t BgL_l1313z00_33605;

													BgL_l1313z00_33605 = BgL_arg3245z00_18129;
													BgL_tail1316z00_33606 = BgL_newtail1317z00_18125;
													BgL_tail1316z00_18124 = BgL_tail1316z00_33606;
													BgL_l1313z00_18123 = BgL_l1313z00_33605;
													goto BgL_zc3z04anonymousza33242ze3z87_18122;
												}
											}
										}
								}
							}
					}
					{	/* Eval/evaluate_comp.scm 485 */
						BgL_ev_exprz00_bglt BgL_arg3247z00_18130;

						BgL_arg3247z00_18130 =
							(((BgL_ev_binderz00_bglt) COBJECT(
									((BgL_ev_binderz00_bglt)
										((BgL_ev_letza2za2_bglt) BgL_ez00_15390))))->BgL_bodyz00);
						BgL_bodyz00_18118 =
							BGl_compz00zz__evaluate_compz00(BgL_arg3247z00_18130,
							BgL_nstkz00_18115);
					}
					{	/* Eval/evaluate_comp.scm 486 */
						obj_t BgL_zc3z04anonymousza33231ze3z87_18131;

						BgL_zc3z04anonymousza33231ze3z87_18131 =
							MAKE_FX_PROCEDURE
							(BGl_z62zc3z04anonymousza33231ze3ze5zz__evaluate_compz00,
							(int) (((long) 1)), (int) (((long) 4)));
						PROCEDURE_SET(BgL_zc3z04anonymousza33231ze3z87_18131,
							(int) (((long) 0)), BINT(BgL_siza7eza7_18114));
						PROCEDURE_SET(BgL_zc3z04anonymousza33231ze3z87_18131,
							(int) (((long) 1)),
							((obj_t) ((BgL_ev_letza2za2_bglt) BgL_ez00_15390)));
						PROCEDURE_SET(BgL_zc3z04anonymousza33231ze3z87_18131,
							(int) (((long) 2)), BgL_valsz00_18117);
						PROCEDURE_SET(BgL_zc3z04anonymousza33231ze3z87_18131,
							(int) (((long) 3)), BgL_bodyz00_18118);
						return BgL_zc3z04anonymousza33231ze3z87_18131;
					}
				}
			}
		}

	}



/* &<@anonymous:3231> */
	obj_t BGl_z62zc3z04anonymousza33231ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_15392, obj_t BgL_sz00_15397)
	{
		{	/* Eval/evaluate_comp.scm 486 */
			{	/* Eval/evaluate_comp.scm 486 */
				long BgL_siza7eza7_15393;
				BgL_ev_letza2za2_bglt BgL_i1112z00_15394;
				obj_t BgL_valsz00_15395;
				obj_t BgL_bodyz00_15396;

				BgL_siza7eza7_15393 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15392, (int) (((long) 0))));
				BgL_i1112z00_15394 =
					((BgL_ev_letza2za2_bglt)
					PROCEDURE_REF(BgL_envz00_15392, (int) (((long) 1))));
				BgL_valsz00_15395 = PROCEDURE_REF(BgL_envz00_15392, (int) (((long) 2)));
				BgL_bodyz00_15396 = PROCEDURE_REF(BgL_envz00_15392, (int) (((long) 3)));
				{	/* Eval/evaluate_comp.scm 486 */
					obj_t BgL_bpz00_18132;

					BgL_bpz00_18132 = VECTOR_REF(((obj_t) BgL_sz00_15397), ((long) 0));
					{	/* Eval/evaluate_comp.scm 487 */
						long BgL_g1113z00_18133;

						BgL_g1113z00_18133 =
							((long) CINT(BgL_bpz00_18132) + BgL_siza7eza7_15393);
						{
							obj_t BgL_lz00_18135;
							long BgL_iz00_18136;
							obj_t BgL_bza2za2_18137;

							BgL_lz00_18135 = BgL_valsz00_15395;
							BgL_iz00_18136 = BgL_g1113z00_18133;
							BgL_bza2za2_18137 =
								(((BgL_ev_letza2za2_bglt) COBJECT(BgL_i1112z00_15394))->
								BgL_boxesz00);
						BgL_recz00_18134:
							if (NULLP(BgL_lz00_18135))
								{	/* Eval/evaluate_comp.scm 488 */
									((bool_t) 0);
								}
							else
								{	/* Eval/evaluate_comp.scm 488 */
									{	/* Eval/evaluate_comp.scm 489 */
										obj_t BgL_valz00_18138;

										{	/* Eval/evaluate_comp.scm 489 */
											obj_t BgL_fun3237z00_18139;

											BgL_fun3237z00_18139 = CAR(((obj_t) BgL_lz00_18135));
											BgL_valz00_18138 =
												PROCEDURE_ENTRY(BgL_fun3237z00_18139)
												(BgL_fun3237z00_18139, BgL_sz00_15397, BEOA);
										}
										{	/* Eval/evaluate_comp.scm 490 */
											obj_t BgL_arg3235z00_18140;

											if (CBOOL(CAR(((obj_t) BgL_bza2za2_18137))))
												{	/* Eval/evaluate_comp.scm 202 */
													obj_t BgL_newz00_18141;

													BgL_newz00_18141 =
														create_struct(BGl_symbol5817z00zz__evaluate_compz00,
														(int) (((long) 1)));
													{	/* Eval/evaluate_comp.scm 202 */
														int BgL_tmpz00_33653;

														BgL_tmpz00_33653 = (int) (((long) 0));
														STRUCT_SET(BgL_newz00_18141, BgL_tmpz00_33653,
															BgL_valz00_18138);
													}
													BgL_arg3235z00_18140 = BgL_newz00_18141;
												}
											else
												{	/* Eval/evaluate_comp.scm 490 */
													BgL_arg3235z00_18140 = BgL_valz00_18138;
												}
											VECTOR_SET(
												((obj_t) BgL_sz00_15397), BgL_iz00_18136,
												BgL_arg3235z00_18140);
										}
									}
									{	/* Eval/evaluate_comp.scm 491 */
										obj_t BgL_arg3238z00_18142;
										long BgL_arg3239z00_18143;
										obj_t BgL_arg3240z00_18144;

										BgL_arg3238z00_18142 = CDR(((obj_t) BgL_lz00_18135));
										BgL_arg3239z00_18143 = (BgL_iz00_18136 + ((long) 1));
										BgL_arg3240z00_18144 = CDR(((obj_t) BgL_bza2za2_18137));
										{
											obj_t BgL_bza2za2_33665;
											long BgL_iz00_33664;
											obj_t BgL_lz00_33663;

											BgL_lz00_33663 = BgL_arg3238z00_18142;
											BgL_iz00_33664 = BgL_arg3239z00_18143;
											BgL_bza2za2_33665 = BgL_arg3240z00_18144;
											BgL_bza2za2_18137 = BgL_bza2za2_33665;
											BgL_iz00_18136 = BgL_iz00_33664;
											BgL_lz00_18135 = BgL_lz00_33663;
											goto BgL_recz00_18134;
										}
									}
								}
						}
					}
					return
						PROCEDURE_ENTRY(BgL_bodyz00_15396) (BgL_bodyz00_15396,
						BgL_sz00_15397, BEOA);
				}
			}
		}

	}



/* &comp-ev_let1419 */
	obj_t BGl_z62compzd2ev_let1419zb0zz__evaluate_compz00(obj_t BgL_envz00_15398,
		obj_t BgL_ez00_15399, obj_t BgL_stkz00_15400)
	{
		{	/* Eval/evaluate_comp.scm 462 */
			{	/* Eval/evaluate_comp.scm 464 */
				long BgL_siza7eza7_18146;
				obj_t BgL_nstkz00_18147;

				BgL_siza7eza7_18146 = bgl_list_length(BgL_stkz00_15400);
				{	/* Eval/evaluate_comp.scm 464 */
					obj_t BgL_arg3230z00_18148;

					BgL_arg3230z00_18148 =
						(((BgL_ev_binderz00_bglt) COBJECT(
								((BgL_ev_binderz00_bglt)
									((BgL_ev_letz00_bglt) BgL_ez00_15399))))->BgL_varsz00);
					BgL_nstkz00_18147 =
						BGl_appendzd221011zd2zz__evaluate_compz00(BgL_stkz00_15400,
						BgL_arg3230z00_18148);
				}
				{	/* Eval/evaluate_comp.scm 465 */
					obj_t BgL_valsz00_18149;
					obj_t BgL_iboxesz00_18150;
					obj_t BgL_bodyz00_18151;

					{	/* Eval/evaluate_comp.scm 466 */
						obj_t BgL_arg3214z00_18152;

						BgL_arg3214z00_18152 =
							(((BgL_ev_binderz00_bglt) COBJECT(
									((BgL_ev_binderz00_bglt)
										((BgL_ev_letz00_bglt) BgL_ez00_15399))))->BgL_valsz00);
						BgL_valsz00_18149 =
							BGl_compzd2withzd2pushz00zz__evaluate_compz00
							(BgL_arg3214z00_18152, BgL_stkz00_15400);
					}
					{	/* Eval/evaluate_comp.scm 467 */
						obj_t BgL_l1308z00_18153;

						BgL_l1308z00_18153 =
							(((BgL_ev_letz00_bglt) COBJECT(
									((BgL_ev_letz00_bglt) BgL_ez00_15399)))->BgL_boxesz00);
						if (NULLP(BgL_l1308z00_18153))
							{	/* Eval/evaluate_comp.scm 467 */
								BgL_iboxesz00_18150 = BNIL;
							}
						else
							{	/* Eval/evaluate_comp.scm 467 */
								obj_t BgL_head1310z00_18154;

								{	/* Eval/evaluate_comp.scm 467 */
									obj_t BgL_res5131z00_18155;

									BgL_res5131z00_18155 = MAKE_YOUNG_PAIR(BNIL, BNIL);
									BgL_head1310z00_18154 = BgL_res5131z00_18155;
								}
								{
									obj_t BgL_l1308z00_18157;
									obj_t BgL_tail1311z00_18158;

									BgL_l1308z00_18157 = BgL_l1308z00_18153;
									BgL_tail1311z00_18158 = BgL_head1310z00_18154;
								BgL_zc3z04anonymousza33216ze3z87_18156:
									if (NULLP(BgL_l1308z00_18157))
										{	/* Eval/evaluate_comp.scm 467 */
											BgL_iboxesz00_18150 = CDR(BgL_head1310z00_18154);
										}
									else
										{	/* Eval/evaluate_comp.scm 467 */
											obj_t BgL_newtail1312z00_18159;

											{	/* Eval/evaluate_comp.scm 467 */
												obj_t BgL_arg3224z00_18160;

												{	/* Eval/evaluate_comp.scm 467 */
													obj_t BgL_vz00_18161;

													BgL_vz00_18161 = CAR(((obj_t) BgL_l1308z00_18157));
													BgL_arg3224z00_18160 =
														BGl__indexz00zz__evaluate_compz00(BgL_vz00_18161,
														BgL_nstkz00_18147);
												}
												{	/* Eval/evaluate_comp.scm 467 */
													obj_t BgL_res5137z00_18162;

													BgL_res5137z00_18162 =
														MAKE_YOUNG_PAIR(BgL_arg3224z00_18160, BNIL);
													BgL_newtail1312z00_18159 = BgL_res5137z00_18162;
												}
											}
											SET_CDR(BgL_tail1311z00_18158, BgL_newtail1312z00_18159);
											{	/* Eval/evaluate_comp.scm 467 */
												obj_t BgL_arg3219z00_18163;

												BgL_arg3219z00_18163 =
													CDR(((obj_t) BgL_l1308z00_18157));
												{
													obj_t BgL_tail1311z00_33696;
													obj_t BgL_l1308z00_33695;

													BgL_l1308z00_33695 = BgL_arg3219z00_18163;
													BgL_tail1311z00_33696 = BgL_newtail1312z00_18159;
													BgL_tail1311z00_18158 = BgL_tail1311z00_33696;
													BgL_l1308z00_18157 = BgL_l1308z00_33695;
													goto BgL_zc3z04anonymousza33216ze3z87_18156;
												}
											}
										}
								}
							}
					}
					{	/* Eval/evaluate_comp.scm 468 */
						BgL_ev_exprz00_bglt BgL_arg3227z00_18164;

						BgL_arg3227z00_18164 =
							(((BgL_ev_binderz00_bglt) COBJECT(
									((BgL_ev_binderz00_bglt)
										((BgL_ev_letz00_bglt) BgL_ez00_15399))))->BgL_bodyz00);
						BgL_bodyz00_18151 =
							BGl_compz00zz__evaluate_compz00(BgL_arg3227z00_18164,
							BgL_nstkz00_18147);
					}
					{	/* Eval/evaluate_comp.scm 469 */
						obj_t BgL_zc3z04anonymousza33199ze3z87_18165;

						BgL_zc3z04anonymousza33199ze3z87_18165 =
							MAKE_FX_PROCEDURE
							(BGl_z62zc3z04anonymousza33199ze3ze5zz__evaluate_compz00,
							(int) (((long) 1)), (int) (((long) 4)));
						PROCEDURE_SET(BgL_zc3z04anonymousza33199ze3z87_18165,
							(int) (((long) 0)), BINT(BgL_siza7eza7_18146));
						PROCEDURE_SET(BgL_zc3z04anonymousza33199ze3z87_18165,
							(int) (((long) 1)), BgL_valsz00_18149);
						PROCEDURE_SET(BgL_zc3z04anonymousza33199ze3z87_18165,
							(int) (((long) 2)), BgL_iboxesz00_18150);
						PROCEDURE_SET(BgL_zc3z04anonymousza33199ze3z87_18165,
							(int) (((long) 3)), BgL_bodyz00_18151);
						return BgL_zc3z04anonymousza33199ze3z87_18165;
					}
				}
			}
		}

	}



/* &<@anonymous:3199> */
	obj_t BGl_z62zc3z04anonymousza33199ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_15401, obj_t BgL_sz00_15406)
	{
		{	/* Eval/evaluate_comp.scm 469 */
			{	/* Eval/evaluate_comp.scm 469 */
				long BgL_siza7eza7_15402;
				obj_t BgL_valsz00_15403;
				obj_t BgL_iboxesz00_15404;
				obj_t BgL_bodyz00_15405;

				BgL_siza7eza7_15402 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15401, (int) (((long) 0))));
				BgL_valsz00_15403 =
					((obj_t) PROCEDURE_REF(BgL_envz00_15401, (int) (((long) 1))));
				BgL_iboxesz00_15404 =
					PROCEDURE_REF(BgL_envz00_15401, (int) (((long) 2)));
				BgL_bodyz00_15405 = PROCEDURE_REF(BgL_envz00_15401, (int) (((long) 3)));
				{	/* Eval/evaluate_comp.scm 469 */
					obj_t BgL_bpz00_18166;

					BgL_bpz00_18166 = VECTOR_REF(((obj_t) BgL_sz00_15406), ((long) 0));
					{	/* Eval/evaluate_comp.scm 470 */
						long BgL_g1111z00_18167;

						BgL_g1111z00_18167 =
							((long) CINT(BgL_bpz00_18166) + BgL_siza7eza7_15402);
						{
							obj_t BgL_lz00_18169;
							long BgL_iz00_18170;

							BgL_lz00_18169 = BgL_valsz00_15403;
							BgL_iz00_18170 = BgL_g1111z00_18167;
						BgL_recz00_18168:
							if (NULLP(BgL_lz00_18169))
								{	/* Eval/evaluate_comp.scm 471 */
									((bool_t) 0);
								}
							else
								{	/* Eval/evaluate_comp.scm 471 */
									{	/* Eval/evaluate_comp.scm 472 */
										obj_t BgL_arg3202z00_18171;

										{	/* Eval/evaluate_comp.scm 472 */
											obj_t BgL_fun3203z00_18172;

											BgL_fun3203z00_18172 = CAR(((obj_t) BgL_lz00_18169));
											BgL_arg3202z00_18171 =
												PROCEDURE_ENTRY(BgL_fun3203z00_18172)
												(BgL_fun3203z00_18172, BgL_sz00_15406, BEOA);
										}
										VECTOR_SET(
											((obj_t) BgL_sz00_15406), BgL_iz00_18170,
											BgL_arg3202z00_18171);
									}
									{	/* Eval/evaluate_comp.scm 473 */
										obj_t BgL_arg3205z00_18173;
										long BgL_arg3206z00_18174;

										BgL_arg3205z00_18173 = CDR(((obj_t) BgL_lz00_18169));
										BgL_arg3206z00_18174 = (BgL_iz00_18170 + ((long) 1));
										{
											long BgL_iz00_33741;
											obj_t BgL_lz00_33740;

											BgL_lz00_33740 = BgL_arg3205z00_18173;
											BgL_iz00_33741 = BgL_arg3206z00_18174;
											BgL_iz00_18170 = BgL_iz00_33741;
											BgL_lz00_18169 = BgL_lz00_33740;
											goto BgL_recz00_18168;
										}
									}
								}
						}
					}
					{
						obj_t BgL_lz00_18176;

						BgL_lz00_18176 = BgL_iboxesz00_15404;
					BgL_recz00_18175:
						if (NULLP(BgL_lz00_18176))
							{	/* Eval/evaluate_comp.scm 475 */
								((bool_t) 0);
							}
						else
							{	/* Eval/evaluate_comp.scm 475 */
								{	/* Eval/evaluate_comp.scm 476 */
									long BgL_iz00_18177;

									BgL_iz00_18177 =
										(
										(long) CINT(BgL_bpz00_18166) +
										(long) CINT(CAR(((obj_t) BgL_lz00_18176))));
									{	/* Eval/evaluate_comp.scm 477 */
										obj_t BgL_arg3210z00_18178;

										{	/* Eval/evaluate_comp.scm 477 */
											obj_t BgL_arg3211z00_18179;

											BgL_arg3211z00_18179 =
												VECTOR_REF(((obj_t) BgL_sz00_15406), BgL_iz00_18177);
											{	/* Eval/evaluate_comp.scm 202 */
												obj_t BgL_newz00_18180;

												BgL_newz00_18180 =
													create_struct(BGl_symbol5817z00zz__evaluate_compz00,
													(int) (((long) 1)));
												{	/* Eval/evaluate_comp.scm 202 */
													int BgL_tmpz00_33753;

													BgL_tmpz00_33753 = (int) (((long) 0));
													STRUCT_SET(BgL_newz00_18180, BgL_tmpz00_33753,
														BgL_arg3211z00_18179);
												}
												BgL_arg3210z00_18178 = BgL_newz00_18180;
										}}
										VECTOR_SET(
											((obj_t) BgL_sz00_15406), BgL_iz00_18177,
											BgL_arg3210z00_18178);
								}}
								{	/* Eval/evaluate_comp.scm 478 */
									obj_t BgL_arg3213z00_18181;

									BgL_arg3213z00_18181 = CDR(((obj_t) BgL_lz00_18176));
									{
										obj_t BgL_lz00_33760;

										BgL_lz00_33760 = BgL_arg3213z00_18181;
										BgL_lz00_18176 = BgL_lz00_33760;
										goto BgL_recz00_18175;
									}
								}
							}
					}
					return
						PROCEDURE_ENTRY(BgL_bodyz00_15405) (BgL_bodyz00_15405,
						BgL_sz00_15406, BEOA);
				}
			}
		}

	}



/* &comp-ev_prog21417 */
	obj_t BGl_z62compzd2ev_prog21417zb0zz__evaluate_compz00(obj_t
		BgL_envz00_15407, obj_t BgL_ez00_15408, obj_t BgL_stkz00_15409)
	{
		{	/* Eval/evaluate_comp.scm 456 */
			{	/* Eval/evaluate_comp.scm 458 */
				obj_t BgL_e1z00_18183;
				obj_t BgL_e2z00_18184;

				BgL_e1z00_18183 =
					BGl_compz00zz__evaluate_compz00(
					(((BgL_ev_prog2z00_bglt) COBJECT(
								((BgL_ev_prog2z00_bglt) BgL_ez00_15408)))->BgL_e1z00),
					BgL_stkz00_15409);
				BgL_e2z00_18184 =
					BGl_compz00zz__evaluate_compz00((((BgL_ev_prog2z00_bglt)
							COBJECT(((BgL_ev_prog2z00_bglt) BgL_ez00_15408)))->BgL_e2z00),
					BgL_stkz00_15409);
				{	/* Eval/evaluate_comp.scm 459 */
					obj_t BgL_zc3z04anonymousza33192ze3z87_18185;

					BgL_zc3z04anonymousza33192ze3z87_18185 =
						MAKE_FX_PROCEDURE
						(BGl_z62zc3z04anonymousza33192ze3ze5zz__evaluate_compz00,
						(int) (((long) 1)), (int) (((long) 2)));
					PROCEDURE_SET(BgL_zc3z04anonymousza33192ze3z87_18185,
						(int) (((long) 0)), BgL_e1z00_18183);
					PROCEDURE_SET(BgL_zc3z04anonymousza33192ze3z87_18185,
						(int) (((long) 1)), BgL_e2z00_18184);
					return BgL_zc3z04anonymousza33192ze3z87_18185;
				}
			}
		}

	}



/* &<@anonymous:3192> */
	obj_t BGl_z62zc3z04anonymousza33192ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_15410, obj_t BgL_sz00_15413)
	{
		{	/* Eval/evaluate_comp.scm 459 */
			{	/* Eval/evaluate_comp.scm 459 */
				obj_t BgL_e1z00_15411;
				obj_t BgL_e2z00_15412;

				BgL_e1z00_15411 = PROCEDURE_REF(BgL_envz00_15410, (int) (((long) 0)));
				BgL_e2z00_15412 = PROCEDURE_REF(BgL_envz00_15410, (int) (((long) 1)));
				{	/* Eval/evaluate_comp.scm 459 */
					obj_t BgL_bpz00_18186;

					BgL_bpz00_18186 = VECTOR_REF(((obj_t) BgL_sz00_15413), ((long) 0));
					PROCEDURE_ENTRY(BgL_e1z00_15411) (BgL_e1z00_15411, BgL_sz00_15413,
						BEOA);
					return PROCEDURE_ENTRY(BgL_e2z00_15412) (BgL_e2z00_15412,
						BgL_sz00_15413, BEOA);
				}
			}
		}

	}



/* &comp-ev_and1415 */
	obj_t BGl_z62compzd2ev_and1415zb0zz__evaluate_compz00(obj_t BgL_envz00_15414,
		obj_t BgL_ez00_15415, obj_t BgL_stkz00_15416)
	{
		{	/* Eval/evaluate_comp.scm 446 */
			{	/* Eval/evaluate_comp.scm 448 */
				obj_t BgL_argsz00_18188;

				{	/* Eval/evaluate_comp.scm 448 */
					obj_t BgL_l1303z00_18189;

					BgL_l1303z00_18189 =
						(((BgL_ev_listz00_bglt) COBJECT(
								((BgL_ev_listz00_bglt)
									((BgL_ev_andz00_bglt) BgL_ez00_15415))))->BgL_argsz00);
					if (NULLP(BgL_l1303z00_18189))
						{	/* Eval/evaluate_comp.scm 448 */
							BgL_argsz00_18188 = BNIL;
						}
					else
						{	/* Eval/evaluate_comp.scm 448 */
							obj_t BgL_head1305z00_18190;

							{	/* Eval/evaluate_comp.scm 448 */
								obj_t BgL_res5120z00_18191;

								BgL_res5120z00_18191 = MAKE_YOUNG_PAIR(BNIL, BNIL);
								BgL_head1305z00_18190 = BgL_res5120z00_18191;
							}
							{
								obj_t BgL_l1303z00_18193;
								obj_t BgL_tail1306z00_18194;

								BgL_l1303z00_18193 = BgL_l1303z00_18189;
								BgL_tail1306z00_18194 = BgL_head1305z00_18190;
							BgL_zc3z04anonymousza33185ze3z87_18192:
								if (NULLP(BgL_l1303z00_18193))
									{	/* Eval/evaluate_comp.scm 448 */
										BgL_argsz00_18188 = CDR(BgL_head1305z00_18190);
									}
								else
									{	/* Eval/evaluate_comp.scm 448 */
										obj_t BgL_newtail1307z00_18195;

										{	/* Eval/evaluate_comp.scm 448 */
											obj_t BgL_arg3191z00_18196;

											{	/* Eval/evaluate_comp.scm 448 */
												obj_t BgL_ez00_18197;

												BgL_ez00_18197 = CAR(((obj_t) BgL_l1303z00_18193));
												BgL_arg3191z00_18196 =
													BGl_compz00zz__evaluate_compz00(
													((BgL_ev_exprz00_bglt) BgL_ez00_18197),
													BgL_stkz00_15416);
											}
											{	/* Eval/evaluate_comp.scm 448 */
												obj_t BgL_res5126z00_18198;

												BgL_res5126z00_18198 =
													MAKE_YOUNG_PAIR(BgL_arg3191z00_18196, BNIL);
												BgL_newtail1307z00_18195 = BgL_res5126z00_18198;
											}
										}
										SET_CDR(BgL_tail1306z00_18194, BgL_newtail1307z00_18195);
										{	/* Eval/evaluate_comp.scm 448 */
											obj_t BgL_arg3188z00_18199;

											BgL_arg3188z00_18199 = CDR(((obj_t) BgL_l1303z00_18193));
											{
												obj_t BgL_tail1306z00_33810;
												obj_t BgL_l1303z00_33809;

												BgL_l1303z00_33809 = BgL_arg3188z00_18199;
												BgL_tail1306z00_33810 = BgL_newtail1307z00_18195;
												BgL_tail1306z00_18194 = BgL_tail1306z00_33810;
												BgL_l1303z00_18193 = BgL_l1303z00_33809;
												goto BgL_zc3z04anonymousza33185ze3z87_18192;
											}
										}
									}
							}
						}
				}
				{	/* Eval/evaluate_comp.scm 449 */
					obj_t BgL_zc3z04anonymousza33179ze3z87_18200;

					BgL_zc3z04anonymousza33179ze3z87_18200 =
						MAKE_FX_PROCEDURE
						(BGl_z62zc3z04anonymousza33179ze3ze5zz__evaluate_compz00,
						(int) (((long) 1)), (int) (((long) 1)));
					PROCEDURE_SET(BgL_zc3z04anonymousza33179ze3z87_18200,
						(int) (((long) 0)), BgL_argsz00_18188);
					return BgL_zc3z04anonymousza33179ze3z87_18200;
				}
			}
		}

	}



/* &<@anonymous:3179> */
	obj_t BGl_z62zc3z04anonymousza33179ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_15417, obj_t BgL_sz00_15419)
	{
		{	/* Eval/evaluate_comp.scm 449 */
			{	/* Eval/evaluate_comp.scm 449 */
				obj_t BgL_argsz00_15418;

				BgL_argsz00_15418 = PROCEDURE_REF(BgL_envz00_15417, (int) (((long) 0)));
				{	/* Eval/evaluate_comp.scm 449 */
					obj_t BgL_bpz00_18201;

					BgL_bpz00_18201 = VECTOR_REF(((obj_t) BgL_sz00_15419), ((long) 0));
					{
						obj_t BgL_lz00_18203;
						obj_t BgL_rz00_18204;

						BgL_lz00_18203 = BgL_argsz00_15418;
						BgL_rz00_18204 = BTRUE;
					BgL_recz00_18202:
						if (NULLP(BgL_lz00_18203))
							{	/* Eval/evaluate_comp.scm 451 */
								return BgL_rz00_18204;
							}
						else
							{	/* Eval/evaluate_comp.scm 453 */
								obj_t BgL_vz00_18205;

								{	/* Eval/evaluate_comp.scm 453 */
									obj_t BgL_fun3183z00_18206;

									BgL_fun3183z00_18206 = CAR(((obj_t) BgL_lz00_18203));
									BgL_vz00_18205 =
										PROCEDURE_ENTRY(BgL_fun3183z00_18206) (BgL_fun3183z00_18206,
										BgL_sz00_15419, BEOA);
								}
								if (CBOOL(BgL_vz00_18205))
									{	/* Eval/evaluate_comp.scm 454 */
										obj_t BgL_arg3182z00_18207;

										BgL_arg3182z00_18207 = CDR(((obj_t) BgL_lz00_18203));
										{
											obj_t BgL_rz00_33833;
											obj_t BgL_lz00_33832;

											BgL_lz00_33832 = BgL_arg3182z00_18207;
											BgL_rz00_33833 = BgL_vz00_18205;
											BgL_rz00_18204 = BgL_rz00_33833;
											BgL_lz00_18203 = BgL_lz00_33832;
											goto BgL_recz00_18202;
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 454 */
										return BFALSE;
									}
							}
					}
				}
			}
		}

	}



/* &comp-ev_or1413 */
	obj_t BGl_z62compzd2ev_or1413zb0zz__evaluate_compz00(obj_t BgL_envz00_15420,
		obj_t BgL_ez00_15421, obj_t BgL_stkz00_15422)
	{
		{	/* Eval/evaluate_comp.scm 437 */
			{	/* Eval/evaluate_comp.scm 439 */
				obj_t BgL_argsz00_18209;

				{	/* Eval/evaluate_comp.scm 439 */
					obj_t BgL_l1298z00_18210;

					BgL_l1298z00_18210 =
						(((BgL_ev_listz00_bglt) COBJECT(
								((BgL_ev_listz00_bglt)
									((BgL_ev_orz00_bglt) BgL_ez00_15421))))->BgL_argsz00);
					if (NULLP(BgL_l1298z00_18210))
						{	/* Eval/evaluate_comp.scm 439 */
							BgL_argsz00_18209 = BNIL;
						}
					else
						{	/* Eval/evaluate_comp.scm 439 */
							obj_t BgL_head1300z00_18211;

							{	/* Eval/evaluate_comp.scm 439 */
								obj_t BgL_res5111z00_18212;

								BgL_res5111z00_18212 = MAKE_YOUNG_PAIR(BNIL, BNIL);
								BgL_head1300z00_18211 = BgL_res5111z00_18212;
							}
							{
								obj_t BgL_l1298z00_18214;
								obj_t BgL_tail1301z00_18215;

								BgL_l1298z00_18214 = BgL_l1298z00_18210;
								BgL_tail1301z00_18215 = BgL_head1300z00_18211;
							BgL_zc3z04anonymousza33175ze3z87_18213:
								if (NULLP(BgL_l1298z00_18214))
									{	/* Eval/evaluate_comp.scm 439 */
										BgL_argsz00_18209 = CDR(BgL_head1300z00_18211);
									}
								else
									{	/* Eval/evaluate_comp.scm 439 */
										obj_t BgL_newtail1302z00_18216;

										{	/* Eval/evaluate_comp.scm 439 */
											obj_t BgL_arg3178z00_18217;

											{	/* Eval/evaluate_comp.scm 439 */
												obj_t BgL_ez00_18218;

												BgL_ez00_18218 = CAR(((obj_t) BgL_l1298z00_18214));
												BgL_arg3178z00_18217 =
													BGl_compz00zz__evaluate_compz00(
													((BgL_ev_exprz00_bglt) BgL_ez00_18218),
													BgL_stkz00_15422);
											}
											{	/* Eval/evaluate_comp.scm 439 */
												obj_t BgL_res5117z00_18219;

												BgL_res5117z00_18219 =
													MAKE_YOUNG_PAIR(BgL_arg3178z00_18217, BNIL);
												BgL_newtail1302z00_18216 = BgL_res5117z00_18219;
											}
										}
										SET_CDR(BgL_tail1301z00_18215, BgL_newtail1302z00_18216);
										{	/* Eval/evaluate_comp.scm 439 */
											obj_t BgL_arg3177z00_18220;

											BgL_arg3177z00_18220 = CDR(((obj_t) BgL_l1298z00_18214));
											{
												obj_t BgL_tail1301z00_33852;
												obj_t BgL_l1298z00_33851;

												BgL_l1298z00_33851 = BgL_arg3177z00_18220;
												BgL_tail1301z00_33852 = BgL_newtail1302z00_18216;
												BgL_tail1301z00_18215 = BgL_tail1301z00_33852;
												BgL_l1298z00_18214 = BgL_l1298z00_33851;
												goto BgL_zc3z04anonymousza33175ze3z87_18213;
											}
										}
									}
							}
						}
				}
				{	/* Eval/evaluate_comp.scm 440 */
					obj_t BgL_zc3z04anonymousza33169ze3z87_18221;

					BgL_zc3z04anonymousza33169ze3z87_18221 =
						MAKE_FX_PROCEDURE
						(BGl_z62zc3z04anonymousza33169ze3ze5zz__evaluate_compz00,
						(int) (((long) 1)), (int) (((long) 1)));
					PROCEDURE_SET(BgL_zc3z04anonymousza33169ze3z87_18221,
						(int) (((long) 0)), BgL_argsz00_18209);
					return BgL_zc3z04anonymousza33169ze3z87_18221;
				}
			}
		}

	}



/* &<@anonymous:3169> */
	obj_t BGl_z62zc3z04anonymousza33169ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_15423, obj_t BgL_sz00_15425)
	{
		{	/* Eval/evaluate_comp.scm 440 */
			{	/* Eval/evaluate_comp.scm 440 */
				obj_t BgL_argsz00_15424;

				BgL_argsz00_15424 = PROCEDURE_REF(BgL_envz00_15423, (int) (((long) 0)));
				{	/* Eval/evaluate_comp.scm 440 */
					obj_t BgL_bpz00_18222;

					BgL_bpz00_18222 = VECTOR_REF(((obj_t) BgL_sz00_15425), ((long) 0));
					{
						obj_t BgL_lz00_18224;

						BgL_lz00_18224 = BgL_argsz00_15424;
					BgL_recz00_18223:
						if (NULLP(BgL_lz00_18224))
							{	/* Eval/evaluate_comp.scm 442 */
								return BFALSE;
							}
						else
							{	/* Eval/evaluate_comp.scm 444 */
								obj_t BgL__ortest_1106z00_18225;

								{	/* Eval/evaluate_comp.scm 444 */
									obj_t BgL_fun3173z00_18226;

									BgL_fun3173z00_18226 = CAR(((obj_t) BgL_lz00_18224));
									BgL__ortest_1106z00_18225 =
										PROCEDURE_ENTRY(BgL_fun3173z00_18226) (BgL_fun3173z00_18226,
										BgL_sz00_15425, BEOA);
								}
								if (CBOOL(BgL__ortest_1106z00_18225))
									{	/* Eval/evaluate_comp.scm 444 */
										return BgL__ortest_1106z00_18225;
									}
								else
									{	/* Eval/evaluate_comp.scm 444 */
										obj_t BgL_arg3172z00_18227;

										BgL_arg3172z00_18227 = CDR(((obj_t) BgL_lz00_18224));
										{
											obj_t BgL_lz00_33874;

											BgL_lz00_33874 = BgL_arg3172z00_18227;
											BgL_lz00_18224 = BgL_lz00_33874;
											goto BgL_recz00_18223;
										}
									}
							}
					}
				}
			}
		}

	}



/* &comp-ev_if1411 */
	obj_t BGl_z62compzd2ev_if1411zb0zz__evaluate_compz00(obj_t BgL_envz00_15426,
		obj_t BgL_ez00_15427, obj_t BgL_stkz00_15428)
	{
		{	/* Eval/evaluate_comp.scm 431 */
			{	/* Eval/evaluate_comp.scm 433 */
				obj_t BgL_pz00_18229;
				obj_t BgL_tz00_18230;
				obj_t BgL_ez00_18231;

				BgL_pz00_18229 =
					BGl_compz00zz__evaluate_compz00(
					(((BgL_ev_ifz00_bglt) COBJECT(
								((BgL_ev_ifz00_bglt) BgL_ez00_15427)))->BgL_pz00),
					BgL_stkz00_15428);
				BgL_tz00_18230 =
					BGl_compz00zz__evaluate_compz00((((BgL_ev_ifz00_bglt)
							COBJECT(((BgL_ev_ifz00_bglt) BgL_ez00_15427)))->BgL_tz00),
					BgL_stkz00_15428);
				BgL_ez00_18231 =
					BGl_compz00zz__evaluate_compz00((((BgL_ev_ifz00_bglt)
							COBJECT(((BgL_ev_ifz00_bglt) BgL_ez00_15427)))->BgL_ez00),
					BgL_stkz00_15428);
				{	/* Eval/evaluate_comp.scm 434 */
					obj_t BgL_zc3z04anonymousza33156ze3z87_18232;

					BgL_zc3z04anonymousza33156ze3z87_18232 =
						MAKE_FX_PROCEDURE
						(BGl_z62zc3z04anonymousza33156ze3ze5zz__evaluate_compz00,
						(int) (((long) 1)), (int) (((long) 3)));
					PROCEDURE_SET(BgL_zc3z04anonymousza33156ze3z87_18232,
						(int) (((long) 0)), BgL_ez00_18231);
					PROCEDURE_SET(BgL_zc3z04anonymousza33156ze3z87_18232,
						(int) (((long) 1)), BgL_tz00_18230);
					PROCEDURE_SET(BgL_zc3z04anonymousza33156ze3z87_18232,
						(int) (((long) 2)), BgL_pz00_18229);
					return BgL_zc3z04anonymousza33156ze3z87_18232;
				}
			}
		}

	}



/* &<@anonymous:3156> */
	obj_t BGl_z62zc3z04anonymousza33156ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_15429, obj_t BgL_sz00_15433)
	{
		{	/* Eval/evaluate_comp.scm 434 */
			{	/* Eval/evaluate_comp.scm 434 */
				obj_t BgL_ez00_15430;
				obj_t BgL_tz00_15431;
				obj_t BgL_pz00_15432;

				BgL_ez00_15430 = PROCEDURE_REF(BgL_envz00_15429, (int) (((long) 0)));
				BgL_tz00_15431 = PROCEDURE_REF(BgL_envz00_15429, (int) (((long) 1)));
				BgL_pz00_15432 = PROCEDURE_REF(BgL_envz00_15429, (int) (((long) 2)));
				{	/* Eval/evaluate_comp.scm 434 */
					obj_t BgL_bpz00_18233;

					BgL_bpz00_18233 = VECTOR_REF(((obj_t) BgL_sz00_15433), ((long) 0));
					if (CBOOL(PROCEDURE_ENTRY(BgL_pz00_15432) (BgL_pz00_15432,
								BgL_sz00_15433, BEOA)))
						{	/* Eval/evaluate_comp.scm 435 */
							return
								PROCEDURE_ENTRY(BgL_tz00_15431) (BgL_tz00_15431, BgL_sz00_15433,
								BEOA);
						}
					else
						{	/* Eval/evaluate_comp.scm 435 */
							return
								PROCEDURE_ENTRY(BgL_ez00_15430) (BgL_ez00_15430, BgL_sz00_15433,
								BEOA);
						}
				}
			}
		}

	}



/* &comp-ev_litt1409 */
	obj_t BGl_z62compzd2ev_litt1409zb0zz__evaluate_compz00(obj_t BgL_envz00_15434,
		obj_t BgL_ez00_15435, obj_t BgL_stkz00_15436)
	{
		{	/* Eval/evaluate_comp.scm 426 */
			{	/* Eval/evaluate_comp.scm 428 */
				obj_t BgL_zc3z04anonymousza33155ze3z87_18235;

				BgL_zc3z04anonymousza33155ze3z87_18235 =
					MAKE_FX_PROCEDURE
					(BGl_z62zc3z04anonymousza33155ze3ze5zz__evaluate_compz00,
					(int) (((long) 1)), (int) (((long) 1)));
				PROCEDURE_SET(BgL_zc3z04anonymousza33155ze3z87_18235,
					(int) (((long) 0)), ((obj_t) ((BgL_ev_littz00_bglt) BgL_ez00_15435)));
				return BgL_zc3z04anonymousza33155ze3z87_18235;
			}
		}

	}



/* &<@anonymous:3155> */
	obj_t BGl_z62zc3z04anonymousza33155ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_15437, obj_t BgL_sz00_15439)
	{
		{	/* Eval/evaluate_comp.scm 428 */
			{	/* Eval/evaluate_comp.scm 428 */
				BgL_ev_littz00_bglt BgL_i1103z00_15438;

				BgL_i1103z00_15438 =
					((BgL_ev_littz00_bglt)
					PROCEDURE_REF(BgL_envz00_15437, (int) (((long) 0))));
				{	/* Eval/evaluate_comp.scm 428 */
					obj_t BgL_bpz00_18236;

					BgL_bpz00_18236 = VECTOR_REF(((obj_t) BgL_sz00_15439), ((long) 0));
					return
						(((BgL_ev_littz00_bglt) COBJECT(BgL_i1103z00_15438))->BgL_valuez00);
				}
			}
		}

	}



/* &comp-ev_defglobal1407 */
	obj_t BGl_z62compzd2ev_defglobal1407zb0zz__evaluate_compz00(obj_t
		BgL_envz00_15440, obj_t BgL_ez00_15441, obj_t BgL_stkz00_15442)
	{
		{	/* Eval/evaluate_comp.scm 395 */
			{	/* Eval/evaluate_comp.scm 397 */
				obj_t BgL_ez00_18238;

				{	/* Eval/evaluate_comp.scm 397 */
					BgL_ev_exprz00_bglt BgL_arg3154z00_18239;

					BgL_arg3154z00_18239 =
						(((BgL_ev_hookz00_bglt) COBJECT(
								((BgL_ev_hookz00_bglt)
									((BgL_ev_defglobalz00_bglt) BgL_ez00_15441))))->BgL_ez00);
					BgL_ez00_18238 =
						BGl_compz00zz__evaluate_compz00(BgL_arg3154z00_18239,
						BgL_stkz00_15442);
				}
				{	/* Eval/evaluate_comp.scm 398 */
					obj_t BgL_zc3z04anonymousza33118ze3z87_18240;

					BgL_zc3z04anonymousza33118ze3z87_18240 =
						MAKE_FX_PROCEDURE
						(BGl_z62zc3z04anonymousza33118ze3ze5zz__evaluate_compz00,
						(int) (((long) 1)), (int) (((long) 2)));
					PROCEDURE_SET(BgL_zc3z04anonymousza33118ze3z87_18240,
						(int) (((long) 0)),
						((obj_t) ((BgL_ev_defglobalz00_bglt) BgL_ez00_15441)));
					PROCEDURE_SET(BgL_zc3z04anonymousza33118ze3z87_18240,
						(int) (((long) 1)), BgL_ez00_18238);
					return BgL_zc3z04anonymousza33118ze3z87_18240;
				}
			}
		}

	}



/* &<@anonymous:3118> */
	obj_t BGl_z62zc3z04anonymousza33118ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_15443, obj_t BgL_sz00_15446)
	{
		{	/* Eval/evaluate_comp.scm 398 */
			{	/* Eval/evaluate_comp.scm 398 */
				BgL_ev_defglobalz00_bglt BgL_i1100z00_15444;
				obj_t BgL_ez00_15445;

				BgL_i1100z00_15444 =
					((BgL_ev_defglobalz00_bglt)
					PROCEDURE_REF(BgL_envz00_15443, (int) (((long) 0))));
				BgL_ez00_15445 = PROCEDURE_REF(BgL_envz00_15443, (int) (((long) 1)));
				{	/* Eval/evaluate_comp.scm 398 */
					obj_t BgL_bpz00_18241;

					BgL_bpz00_18241 = VECTOR_REF(((obj_t) BgL_sz00_15446), ((long) 0));
					{	/* Eval/evaluate_comp.scm 399 */
						obj_t BgL_gz00_18242;

						{	/* Eval/evaluate_comp.scm 399 */
							obj_t BgL_arg3152z00_18243;
							obj_t BgL_arg3153z00_18244;

							BgL_arg3152z00_18243 =
								(((BgL_ev_setglobalz00_bglt) COBJECT(
										((BgL_ev_setglobalz00_bglt) BgL_i1100z00_15444)))->
								BgL_modz00);
							BgL_arg3153z00_18244 =
								(((BgL_ev_setglobalz00_bglt) COBJECT(((BgL_ev_setglobalz00_bglt)
											BgL_i1100z00_15444)))->BgL_namez00);
							BgL_gz00_18242 =
								BGl_evmodulezd2findzd2globalz00zz__evmodulez00
								(BgL_arg3152z00_18243, BgL_arg3153z00_18244);
						}
						if (CBOOL(BgL_gz00_18242))
							{	/* Eval/evaluate_comp.scm 401 */
								{

									{	/* Eval/evaluate_comp.scm 403 */
										int BgL_aux1102z00_18248;

										{	/* Eval/evaluate_comp.scm 403 */
											int BgL_res5109z00_18249;

											BgL_res5109z00_18249 =
												CINT(VECTOR_REF(((obj_t) BgL_gz00_18242), ((long) 0)));
											BgL_aux1102z00_18248 = BgL_res5109z00_18249;
										}
										switch ((long) (BgL_aux1102z00_18248))
											{
											case ((long) 0):

												{	/* Eval/evaluate_comp.scm 405 */
													obj_t BgL_arg3120z00_18250;
													obj_t BgL_arg3122z00_18251;

													BgL_arg3120z00_18250 =
														(((BgL_ev_setglobalz00_bglt) COBJECT(
																((BgL_ev_setglobalz00_bglt)
																	BgL_i1100z00_15444)))->BgL_locz00);
													BgL_arg3122z00_18251 =
														(((BgL_ev_setglobalz00_bglt)
															COBJECT(((BgL_ev_setglobalz00_bglt)
																	BgL_i1100z00_15444)))->BgL_namez00);
													BGl_everrorz00zz__everrorz00(BgL_arg3120z00_18250,
														BGl_string5928z00zz__evaluate_compz00,
														BGl_string5929z00zz__evaluate_compz00,
														BgL_arg3122z00_18251);
												} break;
											case ((long) 1):

												{	/* Eval/evaluate_comp.scm 407 */
													obj_t BgL_arg3123z00_18252;
													obj_t BgL_arg3124z00_18253;

													BgL_arg3123z00_18252 =
														(((BgL_ev_setglobalz00_bglt) COBJECT(
																((BgL_ev_setglobalz00_bglt)
																	BgL_i1100z00_15444)))->BgL_locz00);
													BgL_arg3124z00_18253 =
														(((BgL_ev_setglobalz00_bglt)
															COBJECT(((BgL_ev_setglobalz00_bglt)
																	BgL_i1100z00_15444)))->BgL_namez00);
													{	/* Eval/evaluate_comp.scm 407 */
														obj_t BgL_list3125z00_18254;

														{	/* Eval/evaluate_comp.scm 407 */
															obj_t BgL_arg3126z00_18255;

															{	/* Eval/evaluate_comp.scm 407 */
																obj_t BgL_arg3127z00_18256;

																BgL_arg3127z00_18256 =
																	MAKE_YOUNG_PAIR(BgL_arg3124z00_18253, BNIL);
																BgL_arg3126z00_18255 =
																	MAKE_YOUNG_PAIR
																	(BGl_string5930z00zz__evaluate_compz00,
																	BgL_arg3127z00_18256);
															}
															BgL_list3125z00_18254 =
																MAKE_YOUNG_PAIR
																(BGl_string5807z00zz__evaluate_compz00,
																BgL_arg3126z00_18255);
														}
														BGl_evwarningz00zz__everrorz00(BgL_arg3123z00_18252,
															BgL_list3125z00_18254);
												}}
												{	/* Eval/evaluate_comp.scm 409 */
													obj_t BgL_arg3131z00_18257;
													obj_t BgL_arg3134z00_18258;

													BgL_arg3131z00_18257 =
														VECTOR_REF(((obj_t) BgL_gz00_18242), ((long) 2));
													BgL_arg3134z00_18258 =
														PROCEDURE_ENTRY(BgL_ez00_15445) (BgL_ez00_15445,
														BgL_sz00_15446, BEOA);
													__EVMEANING_ADDRESS_SET(BgL_arg3131z00_18257,
														BgL_arg3134z00_18258);
												} break;
											case ((long) 2):

												{	/* Eval/evaluate_comp.scm 411 */
													obj_t BgL_arg3137z00_18259;

													BgL_arg3137z00_18259 =
														PROCEDURE_ENTRY(BgL_ez00_15445) (BgL_ez00_15445,
														BgL_sz00_15446, BEOA);
													VECTOR_SET(((obj_t) BgL_gz00_18242), ((long) 2),
														BgL_arg3137z00_18259);
												} break;
											case ((long) 3):

												{	/* Eval/evaluate_comp.scm 413 */
													obj_t BgL_arg3138z00_18260;

													BgL_arg3138z00_18260 =
														PROCEDURE_ENTRY(BgL_ez00_15445) (BgL_ez00_15445,
														BgL_sz00_15446, BEOA);
													VECTOR_SET(((obj_t) BgL_gz00_18242), ((long) 2),
														BgL_arg3138z00_18260);
												}
												VECTOR_SET(
													((obj_t) BgL_gz00_18242), ((long) 0),
													BINT(((long) 2)));
												break;
											case ((long) 4):

												{	/* Eval/evaluate_comp.scm 416 */
													obj_t BgL_arg3139z00_18261;

													BgL_arg3139z00_18261 =
														PROCEDURE_ENTRY(BgL_ez00_15445) (BgL_ez00_15445,
														BgL_sz00_15446, BEOA);
													VECTOR_SET(((obj_t) BgL_gz00_18242), ((long) 2),
														BgL_arg3139z00_18261);
												}
												VECTOR_SET(
													((obj_t) BgL_gz00_18242), ((long) 0),
													BINT(((long) 5)));
												break;
											default:
												{	/* Eval/evaluate_comp.scm 419 */
													obj_t BgL_arg3141z00_18246;
													obj_t BgL_arg3142z00_18247;

													BgL_arg3141z00_18246 =
														(((BgL_ev_setglobalz00_bglt) COBJECT(
																((BgL_ev_setglobalz00_bglt)
																	BgL_i1100z00_15444)))->BgL_locz00);
													BgL_arg3142z00_18247 =
														(((BgL_ev_setglobalz00_bglt)
															COBJECT(((BgL_ev_setglobalz00_bglt)
																	BgL_i1100z00_15444)))->BgL_namez00);
													BGl_everrorz00zz__everrorz00(BgL_arg3141z00_18246,
														BGl_string5928z00zz__evaluate_compz00,
														BGl_string5929z00zz__evaluate_compz00,
														BgL_arg3142z00_18247);
												}
											}
									}
								}
								return
									(((BgL_ev_setglobalz00_bglt) COBJECT(
											((BgL_ev_setglobalz00_bglt) BgL_i1100z00_15444)))->
									BgL_namez00);
							}
						else
							{	/* Eval/evaluate_comp.scm 421 */
								obj_t BgL_gz00_18262;

								{	/* Eval/evaluate_comp.scm 421 */
									obj_t BgL_arg3149z00_18263;
									obj_t BgL_arg3150z00_18264;
									obj_t BgL_arg3151z00_18265;

									BgL_arg3149z00_18263 =
										(((BgL_ev_setglobalz00_bglt) COBJECT(
												((BgL_ev_setglobalz00_bglt) BgL_i1100z00_15444)))->
										BgL_namez00);
									BgL_arg3150z00_18264 =
										(((BgL_ev_setglobalz00_bglt)
											COBJECT(((BgL_ev_setglobalz00_bglt)
													BgL_i1100z00_15444)))->BgL_modz00);
									BgL_arg3151z00_18265 =
										(((BgL_ev_setglobalz00_bglt)
											COBJECT(((BgL_ev_setglobalz00_bglt)
													BgL_i1100z00_15444)))->BgL_locz00);
									{	/* Eval/evaluate_comp.scm 421 */
										obj_t BgL_v1376z00_18266;

										BgL_v1376z00_18266 = create_vector(((long) 5));
										VECTOR_SET(BgL_v1376z00_18266, ((long) 0),
											BINT(((long) 2)));
										VECTOR_SET(BgL_v1376z00_18266, ((long) 1),
											BgL_arg3149z00_18263);
										VECTOR_SET(BgL_v1376z00_18266, ((long) 2), BUNSPEC);
										VECTOR_SET(BgL_v1376z00_18266, ((long) 3),
											BgL_arg3150z00_18264);
										VECTOR_SET(BgL_v1376z00_18266, ((long) 4),
											BgL_arg3151z00_18265);
										BgL_gz00_18262 = BgL_v1376z00_18266;
								}}
								{	/* Eval/evaluate_comp.scm 422 */
									obj_t BgL_arg3144z00_18267;

									BgL_arg3144z00_18267 =
										PROCEDURE_ENTRY(BgL_ez00_15445) (BgL_ez00_15445,
										BgL_sz00_15446, BEOA);
									VECTOR_SET(BgL_gz00_18262, ((long) 2), BgL_arg3144z00_18267);
								}
								{	/* Eval/evaluate_comp.scm 423 */
									obj_t BgL_arg3145z00_18268;
									obj_t BgL_arg3147z00_18269;
									obj_t BgL_arg3148z00_18270;

									BgL_arg3145z00_18268 =
										(((BgL_ev_setglobalz00_bglt) COBJECT(
												((BgL_ev_setglobalz00_bglt) BgL_i1100z00_15444)))->
										BgL_modz00);
									BgL_arg3147z00_18269 =
										(((BgL_ev_setglobalz00_bglt)
											COBJECT(((BgL_ev_setglobalz00_bglt)
													BgL_i1100z00_15444)))->BgL_namez00);
									BgL_arg3148z00_18270 =
										(((BgL_ev_setglobalz00_bglt)
											COBJECT(((BgL_ev_setglobalz00_bglt)
													BgL_i1100z00_15444)))->BgL_locz00);
									BGl_evmodulezd2bindzd2globalz12z12zz__evmodulez00
										(BgL_arg3145z00_18268, BgL_arg3147z00_18269, BgL_gz00_18262,
										BgL_arg3148z00_18270);
								}
								return
									(((BgL_ev_setglobalz00_bglt) COBJECT(
											((BgL_ev_setglobalz00_bglt) BgL_i1100z00_15444)))->
									BgL_namez00);
							}
					}
				}
			}
		}

	}



/* &comp-ev_setglobal1405 */
	obj_t BGl_z62compzd2ev_setglobal1405zb0zz__evaluate_compz00(obj_t
		BgL_envz00_15447, obj_t BgL_ez00_15448, obj_t BgL_stkz00_15449)
	{
		{	/* Eval/evaluate_comp.scm 372 */
			{	/* Eval/evaluate_comp.scm 374 */
				obj_t BgL_gz00_18272;
				obj_t BgL_ez00_18273;

				BgL_gz00_18272 =
					BGl_evmodulezd2findzd2globalz00zz__evmodulez00(
					(((BgL_ev_setglobalz00_bglt) COBJECT(
								((BgL_ev_setglobalz00_bglt) BgL_ez00_15448)))->BgL_modz00),
					(((BgL_ev_setglobalz00_bglt) COBJECT(
								((BgL_ev_setglobalz00_bglt) BgL_ez00_15448)))->BgL_namez00));
				{	/* Eval/evaluate_comp.scm 374 */
					BgL_ev_exprz00_bglt BgL_arg3117z00_18274;

					BgL_arg3117z00_18274 =
						(((BgL_ev_hookz00_bglt) COBJECT(
								((BgL_ev_hookz00_bglt)
									((BgL_ev_setglobalz00_bglt) BgL_ez00_15448))))->BgL_ez00);
					BgL_ez00_18273 =
						BGl_compz00zz__evaluate_compz00(BgL_arg3117z00_18274,
						BgL_stkz00_15449);
				}
				if (CBOOL(BgL_gz00_18272))
					{

						{	/* Eval/evaluate_comp.scm 376 */
							int BgL_aux1099z00_18277;

							{	/* Eval/evaluate_comp.scm 376 */
								int BgL_res5108z00_18278;

								BgL_res5108z00_18278 =
									CINT(VECTOR_REF(((obj_t) BgL_gz00_18272), ((long) 0)));
								BgL_aux1099z00_18277 = BgL_res5108z00_18278;
							}
							switch ((long) (BgL_aux1099z00_18277))
								{
								case ((long) 1):

									{	/* Eval/evaluate_comp.scm 378 */
										obj_t BgL_zc3z04anonymousza33077ze3z87_18279;

										BgL_zc3z04anonymousza33077ze3z87_18279 =
											MAKE_FX_PROCEDURE
											(BGl_z62zc3z04anonymousza33077ze3ze5zz__evaluate_compz00,
											(int) (((long) 1)), (int) (((long) 2)));
										PROCEDURE_SET(BgL_zc3z04anonymousza33077ze3z87_18279,
											(int) (((long) 0)), BgL_gz00_18272);
										PROCEDURE_SET(BgL_zc3z04anonymousza33077ze3z87_18279,
											(int) (((long) 1)), BgL_ez00_18273);
										return BgL_zc3z04anonymousza33077ze3z87_18279;
									}
									break;
								case ((long) 0):
								case ((long) 4):
								case ((long) 5):

									return
										BGl_everrorz00zz__everrorz00(
										(((BgL_ev_setglobalz00_bglt) COBJECT(
													((BgL_ev_setglobalz00_bglt) BgL_ez00_15448)))->
											BgL_locz00), BGl_string5928z00zz__evaluate_compz00,
										BGl_string5929z00zz__evaluate_compz00,
										(((BgL_ev_setglobalz00_bglt)
												COBJECT(((BgL_ev_setglobalz00_bglt) BgL_ez00_15448)))->
											BgL_namez00));
									break;
								default:
									{	/* Eval/evaluate_comp.scm 383 */
										obj_t BgL_zc3z04anonymousza33085ze3z87_18276;

										BgL_zc3z04anonymousza33085ze3z87_18276 =
											MAKE_FX_PROCEDURE
											(BGl_z62zc3z04anonymousza33085ze3ze5zz__evaluate_compz00,
											(int) (((long) 1)), (int) (((long) 2)));
										PROCEDURE_SET(BgL_zc3z04anonymousza33085ze3z87_18276,
											(int) (((long) 0)), BgL_ez00_18273);
										PROCEDURE_SET(BgL_zc3z04anonymousza33085ze3z87_18276,
											(int) (((long) 1)), BgL_gz00_18272);
										return BgL_zc3z04anonymousza33085ze3z87_18276;
									}
								}
						}
					}
				else
					{	/* Eval/evaluate_comp.scm 384 */
						obj_t BgL_slotz00_18280;

						BgL_slotz00_18280 = MAKE_CELL(BFALSE);
						if (BGl_evmodulezf3zf3zz__evmodulez00(
								(((BgL_ev_setglobalz00_bglt) COBJECT(
											((BgL_ev_setglobalz00_bglt) BgL_ez00_15448)))->
									BgL_modz00)))
							{	/* Eval/evaluate_comp.scm 386 */
								obj_t BgL_gz00_18281;

								{	/* Eval/evaluate_comp.scm 386 */
									obj_t BgL_arg3099z00_18282;
									obj_t BgL_arg3103z00_18283;
									obj_t BgL_arg3104z00_18284;

									BgL_arg3099z00_18282 =
										(((BgL_ev_setglobalz00_bglt) COBJECT(
												((BgL_ev_setglobalz00_bglt) BgL_ez00_15448)))->
										BgL_namez00);
									BgL_arg3103z00_18283 =
										(((BgL_ev_setglobalz00_bglt)
											COBJECT(((BgL_ev_setglobalz00_bglt) BgL_ez00_15448)))->
										BgL_modz00);
									BgL_arg3104z00_18284 =
										(((BgL_ev_setglobalz00_bglt)
											COBJECT(((BgL_ev_setglobalz00_bglt) BgL_ez00_15448)))->
										BgL_locz00);
									{	/* Eval/evaluate_comp.scm 386 */
										obj_t BgL_v1376z00_18285;

										BgL_v1376z00_18285 = create_vector(((long) 5));
										VECTOR_SET(BgL_v1376z00_18285, ((long) 0),
											BINT(((long) 2)));
										VECTOR_SET(BgL_v1376z00_18285, ((long) 1),
											BgL_arg3099z00_18282);
										VECTOR_SET(BgL_v1376z00_18285, ((long) 2), BUNSPEC);
										VECTOR_SET(BgL_v1376z00_18285, ((long) 3),
											BgL_arg3103z00_18283);
										VECTOR_SET(BgL_v1376z00_18285, ((long) 4),
											BgL_arg3104z00_18284);
										BgL_gz00_18281 = BgL_v1376z00_18285;
								}}
								VECTOR_SET(BgL_gz00_18281, ((long) 0), BINT(((long) 3)));
								BGl_evmodulezd2bindzd2globalz12z12zz__evmodulez00(
									(((BgL_ev_setglobalz00_bglt) COBJECT(
												((BgL_ev_setglobalz00_bglt) BgL_ez00_15448)))->
										BgL_modz00),
									(((BgL_ev_setglobalz00_bglt)
											COBJECT(((BgL_ev_setglobalz00_bglt) BgL_ez00_15448)))->
										BgL_namez00), BgL_gz00_18281,
									(((BgL_ev_setglobalz00_bglt)
											COBJECT(((BgL_ev_setglobalz00_bglt) BgL_ez00_15448)))->
										BgL_locz00));
							}
						else
							{	/* Eval/evaluate_comp.scm 385 */
								BFALSE;
							}
						{	/* Eval/evaluate_comp.scm 389 */
							obj_t BgL_zc3z04anonymousza33106ze3z87_18286;

							BgL_zc3z04anonymousza33106ze3z87_18286 =
								MAKE_FX_PROCEDURE
								(BGl_z62zc3z04anonymousza33106ze3ze5zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 3)));
							PROCEDURE_SET(BgL_zc3z04anonymousza33106ze3z87_18286,
								(int) (((long) 0)),
								((obj_t) ((BgL_ev_setglobalz00_bglt) BgL_ez00_15448)));
							PROCEDURE_SET(BgL_zc3z04anonymousza33106ze3z87_18286,
								(int) (((long) 1)), ((obj_t) BgL_slotz00_18280));
							PROCEDURE_SET(BgL_zc3z04anonymousza33106ze3z87_18286,
								(int) (((long) 2)), BgL_ez00_18273);
							return BgL_zc3z04anonymousza33106ze3z87_18286;
						}
					}
			}
		}

	}



/* &<@anonymous:3077> */
	obj_t BGl_z62zc3z04anonymousza33077ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_15452, obj_t BgL_sz00_15455)
	{
		{	/* Eval/evaluate_comp.scm 378 */
			{	/* Eval/evaluate_comp.scm 378 */
				obj_t BgL_gz00_15453;
				obj_t BgL_ez00_15454;

				BgL_gz00_15453 = PROCEDURE_REF(BgL_envz00_15452, (int) (((long) 0)));
				BgL_ez00_15454 = PROCEDURE_REF(BgL_envz00_15452, (int) (((long) 1)));
				{	/* Eval/evaluate_comp.scm 378 */
					obj_t BgL_bpz00_18287;

					BgL_bpz00_18287 = VECTOR_REF(((obj_t) BgL_sz00_15455), ((long) 0));
					{	/* Eval/evaluate_comp.scm 379 */
						obj_t BgL_arg3079z00_18288;
						obj_t BgL_arg3080z00_18289;

						BgL_arg3079z00_18288 =
							VECTOR_REF(((obj_t) BgL_gz00_15453), ((long) 2));
						BgL_arg3080z00_18289 =
							PROCEDURE_ENTRY(BgL_ez00_15454) (BgL_ez00_15454, BgL_sz00_15455,
							BEOA);
						return __EVMEANING_ADDRESS_SET(BgL_arg3079z00_18288,
							BgL_arg3080z00_18289);
					}
				}
			}
		}

	}



/* &<@anonymous:3085> */
	obj_t BGl_z62zc3z04anonymousza33085ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_15456, obj_t BgL_sz00_15459)
	{
		{	/* Eval/evaluate_comp.scm 383 */
			{	/* Eval/evaluate_comp.scm 383 */
				obj_t BgL_ez00_15457;
				obj_t BgL_gz00_15458;

				BgL_ez00_15457 = PROCEDURE_REF(BgL_envz00_15456, (int) (((long) 0)));
				BgL_gz00_15458 = PROCEDURE_REF(BgL_envz00_15456, (int) (((long) 1)));
				{	/* Eval/evaluate_comp.scm 383 */
					obj_t BgL_bpz00_18290;

					BgL_bpz00_18290 = VECTOR_REF(((obj_t) BgL_sz00_15459), ((long) 0));
					{	/* Eval/evaluate_comp.scm 383 */
						obj_t BgL_arg3088z00_18291;

						BgL_arg3088z00_18291 =
							PROCEDURE_ENTRY(BgL_ez00_15457) (BgL_ez00_15457, BgL_sz00_15459,
							BEOA);
						return VECTOR_SET(((obj_t) BgL_gz00_15458), ((long) 2),
							BgL_arg3088z00_18291);
		}}}}

	}



/* &<@anonymous:3106> */
	obj_t BGl_z62zc3z04anonymousza33106ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_15460, obj_t BgL_sz00_15464)
	{
		{	/* Eval/evaluate_comp.scm 389 */
			{	/* Eval/evaluate_comp.scm 389 */
				BgL_ev_setglobalz00_bglt BgL_i1097z00_15461;
				obj_t BgL_slotz00_15462;
				obj_t BgL_ez00_15463;

				BgL_i1097z00_15461 =
					((BgL_ev_setglobalz00_bglt)
					PROCEDURE_REF(BgL_envz00_15460, (int) (((long) 0))));
				BgL_slotz00_15462 = PROCEDURE_REF(BgL_envz00_15460, (int) (((long) 1)));
				BgL_ez00_15463 = PROCEDURE_REF(BgL_envz00_15460, (int) (((long) 2)));
				{	/* Eval/evaluate_comp.scm 389 */
					obj_t BgL_bpz00_18292;

					BgL_bpz00_18292 = VECTOR_REF(((obj_t) BgL_sz00_15464), ((long) 0));
					if (CBOOL(CELL_REF(BgL_slotz00_15462)))
						{	/* Eval/evaluate_comp.scm 390 */
							BFALSE;
						}
					else
						{	/* Eval/evaluate_comp.scm 390 */
							{	/* Eval/evaluate_comp.scm 391 */
								obj_t BgL_auxz00_18293;

								BgL_auxz00_18293 =
									BGl_evmodulezd2findzd2globalz00zz__evmodulez00(
									(((BgL_ev_setglobalz00_bglt) COBJECT(BgL_i1097z00_15461))->
										BgL_modz00),
									(((BgL_ev_setglobalz00_bglt) COBJECT(BgL_i1097z00_15461))->
										BgL_namez00));
								CELL_SET(BgL_slotz00_15462, BgL_auxz00_18293);
							}
							if (CBOOL(CELL_REF(BgL_slotz00_15462)))
								{	/* Eval/evaluate_comp.scm 392 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 392 */
									BGl_everrorz00zz__everrorz00(
										(((BgL_ev_setglobalz00_bglt) COBJECT(BgL_i1097z00_15461))->
											BgL_locz00), BGl_string5807z00zz__evaluate_compz00,
										BGl_string5931z00zz__evaluate_compz00,
										(((BgL_ev_setglobalz00_bglt) COBJECT(BgL_i1097z00_15461))->
											BgL_namez00));
								}
						}
					{	/* Eval/evaluate_comp.scm 393 */
						obj_t BgL_arg3112z00_18294;

						BgL_arg3112z00_18294 =
							PROCEDURE_ENTRY(BgL_ez00_15463) (BgL_ez00_15463, BgL_sz00_15464,
							BEOA);
						{	/* Eval/evaluate_comp.scm 393 */
							obj_t BgL_evalzd2globalzd2_18295;

							BgL_evalzd2globalzd2_18295 = CELL_REF(BgL_slotz00_15462);
							return
								VECTOR_SET(BgL_evalzd2globalzd2_18295, ((long) 2),
								BgL_arg3112z00_18294);
		}}}}}

	}



/* &comp-ev_global1403 */
	obj_t BGl_z62compzd2ev_global1403zb0zz__evaluate_compz00(obj_t
		BgL_envz00_15466, obj_t BgL_varz00_15467, obj_t BgL_stkz00_15468)
	{
		{	/* Eval/evaluate_comp.scm 339 */
			{	/* Eval/evaluate_comp.scm 341 */
				obj_t BgL_gz00_18297;

				BgL_gz00_18297 =
					BGl_evmodulezd2findzd2globalz00zz__evmodulez00(
					(((BgL_ev_globalz00_bglt) COBJECT(
								((BgL_ev_globalz00_bglt) BgL_varz00_15467)))->BgL_modz00),
					(((BgL_ev_globalz00_bglt) COBJECT(
								((BgL_ev_globalz00_bglt) BgL_varz00_15467)))->BgL_namez00));
				if (CBOOL(BgL_gz00_18297))
					{	/* Eval/evaluate_comp.scm 343 */
						bool_t BgL_test6822z00_34167;

						{	/* Eval/evaluate_comp.scm 343 */
							int BgL_arg3025z00_18298;

							{	/* Eval/evaluate_comp.scm 343 */
								int BgL_res5104z00_18299;

								BgL_res5104z00_18299 =
									CINT(VECTOR_REF(((obj_t) BgL_gz00_18297), ((long) 0)));
								BgL_arg3025z00_18298 = BgL_res5104z00_18299;
							}
							BgL_test6822z00_34167 =
								(BINT(BgL_arg3025z00_18298) == BINT(((long) 1)));
						}
						if (BgL_test6822z00_34167)
							{	/* Eval/evaluate_comp.scm 344 */
								obj_t BgL_zc3z04anonymousza33022ze3z87_18300;

								BgL_zc3z04anonymousza33022ze3z87_18300 =
									MAKE_FX_PROCEDURE
									(BGl_z62zc3z04anonymousza33022ze3ze5zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 1)));
								PROCEDURE_SET(BgL_zc3z04anonymousza33022ze3z87_18300,
									(int) (((long) 0)), BgL_gz00_18297);
								return BgL_zc3z04anonymousza33022ze3z87_18300;
							}
						else
							{	/* Eval/evaluate_comp.scm 346 */
								obj_t BgL_zc3z04anonymousza33024ze3z87_18301;

								BgL_zc3z04anonymousza33024ze3z87_18301 =
									MAKE_FX_PROCEDURE
									(BGl_z62zc3z04anonymousza33024ze3ze5zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 1)));
								PROCEDURE_SET(BgL_zc3z04anonymousza33024ze3z87_18301,
									(int) (((long) 0)), BgL_gz00_18297);
								return BgL_zc3z04anonymousza33024ze3z87_18301;
							}
					}
				else
					{	/* Eval/evaluate_comp.scm 348 */
						obj_t BgL_slotz00_18302;

						BgL_slotz00_18302 = MAKE_CELL(BFALSE);
						if (BGl_evmodulezf3zf3zz__evmodulez00(
								(((BgL_ev_globalz00_bglt) COBJECT(
											((BgL_ev_globalz00_bglt) BgL_varz00_15467)))->
									BgL_modz00)))
							{	/* Eval/evaluate_comp.scm 350 */
								obj_t BgL_gz00_18303;

								{	/* Eval/evaluate_comp.scm 350 */
									obj_t BgL_arg3032z00_18304;
									obj_t BgL_arg3033z00_18305;
									obj_t BgL_arg3034z00_18306;

									BgL_arg3032z00_18304 =
										(((BgL_ev_globalz00_bglt) COBJECT(
												((BgL_ev_globalz00_bglt) BgL_varz00_15467)))->
										BgL_namez00);
									BgL_arg3033z00_18305 =
										(((BgL_ev_globalz00_bglt) COBJECT(((BgL_ev_globalz00_bglt)
													BgL_varz00_15467)))->BgL_modz00);
									BgL_arg3034z00_18306 =
										(((BgL_ev_globalz00_bglt) COBJECT(((BgL_ev_globalz00_bglt)
													BgL_varz00_15467)))->BgL_locz00);
									{	/* Eval/evaluate_comp.scm 350 */
										obj_t BgL_v1376z00_18307;

										BgL_v1376z00_18307 = create_vector(((long) 5));
										VECTOR_SET(BgL_v1376z00_18307, ((long) 0),
											BINT(((long) 2)));
										VECTOR_SET(BgL_v1376z00_18307, ((long) 1),
											BgL_arg3032z00_18304);
										VECTOR_SET(BgL_v1376z00_18307, ((long) 2), BUNSPEC);
										VECTOR_SET(BgL_v1376z00_18307, ((long) 3),
											BgL_arg3033z00_18305);
										VECTOR_SET(BgL_v1376z00_18307, ((long) 4),
											BgL_arg3034z00_18306);
										BgL_gz00_18303 = BgL_v1376z00_18307;
								}}
								VECTOR_SET(BgL_gz00_18303, ((long) 0), BINT(((long) 3)));
								BGl_evmodulezd2bindzd2globalz12z12zz__evmodulez00(
									(((BgL_ev_globalz00_bglt) COBJECT(
												((BgL_ev_globalz00_bglt) BgL_varz00_15467)))->
										BgL_modz00),
									(((BgL_ev_globalz00_bglt) COBJECT(((BgL_ev_globalz00_bglt)
													BgL_varz00_15467)))->BgL_namez00), BgL_gz00_18303,
									(((BgL_ev_globalz00_bglt) COBJECT(((BgL_ev_globalz00_bglt)
													BgL_varz00_15467)))->BgL_locz00));
							}
						else
							{	/* Eval/evaluate_comp.scm 349 */
								BFALSE;
							}
						{	/* Eval/evaluate_comp.scm 353 */
							obj_t BgL_zc3z04anonymousza33036ze3z87_18308;

							BgL_zc3z04anonymousza33036ze3z87_18308 =
								MAKE_FX_PROCEDURE
								(BGl_z62zc3z04anonymousza33036ze3ze5zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 2)));
							PROCEDURE_SET(BgL_zc3z04anonymousza33036ze3z87_18308,
								(int) (((long) 0)),
								((obj_t) ((BgL_ev_globalz00_bglt) BgL_varz00_15467)));
							PROCEDURE_SET(BgL_zc3z04anonymousza33036ze3z87_18308,
								(int) (((long) 1)), ((obj_t) BgL_slotz00_18302));
							return BgL_zc3z04anonymousza33036ze3z87_18308;
						}
					}
			}
		}

	}



/* &<@anonymous:3022> */
	obj_t BGl_z62zc3z04anonymousza33022ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_15471, obj_t BgL_sz00_15473)
	{
		{	/* Eval/evaluate_comp.scm 344 */
			{	/* Eval/evaluate_comp.scm 344 */
				obj_t BgL_gz00_15472;

				BgL_gz00_15472 = PROCEDURE_REF(BgL_envz00_15471, (int) (((long) 0)));
				{	/* Eval/evaluate_comp.scm 344 */
					obj_t BgL_bpz00_18309;

					BgL_bpz00_18309 = VECTOR_REF(((obj_t) BgL_sz00_15473), ((long) 0));
					{	/* Eval/evaluate_comp.scm 345 */
						obj_t BgL_arg3023z00_18310;

						BgL_arg3023z00_18310 =
							VECTOR_REF(((obj_t) BgL_gz00_15472), ((long) 2));
						return __EVMEANING_ADDRESS_REF(BgL_arg3023z00_18310);
					}
				}
			}
		}

	}



/* &<@anonymous:3024> */
	obj_t BGl_z62zc3z04anonymousza33024ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_15474, obj_t BgL_sz00_15476)
	{
		{	/* Eval/evaluate_comp.scm 346 */
			{	/* Eval/evaluate_comp.scm 346 */
				obj_t BgL_gz00_15475;

				BgL_gz00_15475 = PROCEDURE_REF(BgL_envz00_15474, (int) (((long) 0)));
				{	/* Eval/evaluate_comp.scm 346 */
					obj_t BgL_bpz00_18311;

					BgL_bpz00_18311 = VECTOR_REF(((obj_t) BgL_sz00_15476), ((long) 0));
					return VECTOR_REF(((obj_t) BgL_gz00_15475), ((long) 2));
		}}}

	}



/* &<@anonymous:3036> */
	obj_t BGl_z62zc3z04anonymousza33036ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_15477, obj_t BgL_sz00_15480)
	{
		{	/* Eval/evaluate_comp.scm 353 */
			{	/* Eval/evaluate_comp.scm 353 */
				BgL_ev_globalz00_bglt BgL_i1096z00_15478;
				obj_t BgL_slotz00_15479;

				BgL_i1096z00_15478 =
					((BgL_ev_globalz00_bglt)
					PROCEDURE_REF(BgL_envz00_15477, (int) (((long) 0))));
				BgL_slotz00_15479 = PROCEDURE_REF(BgL_envz00_15477, (int) (((long) 1)));
				{	/* Eval/evaluate_comp.scm 353 */
					obj_t BgL_bpz00_18312;

					BgL_bpz00_18312 = VECTOR_REF(((obj_t) BgL_sz00_15480), ((long) 0));
					if (CBOOL(CELL_REF(BgL_slotz00_15479)))
						{	/* Eval/evaluate_comp.scm 354 */
							BFALSE;
						}
					else
						{	/* Eval/evaluate_comp.scm 354 */
							{	/* Eval/evaluate_comp.scm 355 */
								obj_t BgL_auxz00_18313;

								BgL_auxz00_18313 =
									BGl_evmodulezd2findzd2globalz00zz__evmodulez00(
									(((BgL_ev_globalz00_bglt) COBJECT(BgL_i1096z00_15478))->
										BgL_modz00),
									(((BgL_ev_globalz00_bglt) COBJECT(BgL_i1096z00_15478))->
										BgL_namez00));
								CELL_SET(BgL_slotz00_15479, BgL_auxz00_18313);
							}
							if (CBOOL(CELL_REF(BgL_slotz00_15479)))
								{	/* Eval/evaluate_comp.scm 356 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 357 */
									obj_t BgL_idz00_18314;

									if (BGl_evmodulezf3zf3zz__evmodulez00(
											(((BgL_ev_globalz00_bglt) COBJECT(BgL_i1096z00_15478))->
												BgL_modz00)))
										{	/* Eval/evaluate_comp.scm 358 */
											obj_t BgL_arg3045z00_18315;

											{	/* Eval/evaluate_comp.scm 358 */
												obj_t BgL_arg3049z00_18316;
												obj_t BgL_arg3053z00_18317;

												BgL_arg3049z00_18316 =
													(((BgL_ev_globalz00_bglt)
														COBJECT(BgL_i1096z00_15478))->BgL_namez00);
												BgL_arg3053z00_18317 =
													MAKE_YOUNG_PAIR(BGl_evmodulezd2namezd2zz__evmodulez00(
														(((BgL_ev_globalz00_bglt)
																COBJECT(BgL_i1096z00_15478))->BgL_modz00)),
													BNIL);
												BgL_arg3045z00_18315 =
													MAKE_YOUNG_PAIR(BgL_arg3049z00_18316,
													BgL_arg3053z00_18317);
											}
											BgL_idz00_18314 =
												MAKE_YOUNG_PAIR(BGl_symbol5932z00zz__evaluate_compz00,
												BgL_arg3045z00_18315);
										}
									else
										{	/* Eval/evaluate_comp.scm 357 */
											BgL_idz00_18314 =
												(((BgL_ev_globalz00_bglt) COBJECT(BgL_i1096z00_15478))->
												BgL_namez00);
										}
									BGl_everrorz00zz__everrorz00(
										(((BgL_ev_globalz00_bglt) COBJECT(BgL_i1096z00_15478))->
											BgL_locz00), BGl_string5807z00zz__evaluate_compz00,
										BGl_string5931z00zz__evaluate_compz00, BgL_idz00_18314);
								}
						}
					{	/* Eval/evaluate_comp.scm 361 */
						obj_t BgL_vz00_18318;

						{	/* Eval/evaluate_comp.scm 361 */
							obj_t BgL_evalzd2globalzd2_18319;

							BgL_evalzd2globalzd2_18319 = CELL_REF(BgL_slotz00_15479);
							BgL_vz00_18318 =
								VECTOR_REF(BgL_evalzd2globalzd2_18319, ((long) 2));
						}
						if ((BgL_vz00_18318 == BUNSPEC))
							{	/* Eval/evaluate_comp.scm 363 */
								int BgL_tz00_18320;

								{	/* Eval/evaluate_comp.scm 363 */
									int BgL_res5105z00_18321;

									{	/* Eval/evaluate_comp.scm 363 */
										obj_t BgL_evalzd2globalzd2_18322;

										BgL_evalzd2globalzd2_18322 = CELL_REF(BgL_slotz00_15479);
										BgL_res5105z00_18321 =
											CINT(VECTOR_REF(BgL_evalzd2globalzd2_18322, ((long) 0)));
									}
									BgL_tz00_18320 = BgL_res5105z00_18321;
								}
								{	/* Eval/evaluate_comp.scm 364 */
									bool_t BgL_test6828z00_34264;

									if (((long) (BgL_tz00_18320) == ((long) 3)))
										{	/* Eval/evaluate_comp.scm 364 */
											BgL_test6828z00_34264 = ((bool_t) 1);
										}
									else
										{	/* Eval/evaluate_comp.scm 364 */
											BgL_test6828z00_34264 =
												((long) (BgL_tz00_18320) == ((long) 4));
										}
									if (BgL_test6828z00_34264)
										{	/* Eval/evaluate_comp.scm 365 */
											obj_t BgL_idz00_18323;

											if (BGl_evmodulezf3zf3zz__evmodulez00(
													(((BgL_ev_globalz00_bglt)
															COBJECT(BgL_i1096z00_15478))->BgL_modz00)))
												{	/* Eval/evaluate_comp.scm 366 */
													obj_t BgL_arg3066z00_18324;

													{	/* Eval/evaluate_comp.scm 366 */
														obj_t BgL_arg3067z00_18325;
														obj_t BgL_arg3069z00_18326;

														BgL_arg3067z00_18325 =
															(((BgL_ev_globalz00_bglt)
																COBJECT(BgL_i1096z00_15478))->BgL_namez00);
														BgL_arg3069z00_18326 =
															MAKE_YOUNG_PAIR
															(BGl_evmodulezd2namezd2zz__evmodulez00(((
																		(BgL_ev_globalz00_bglt)
																		COBJECT(BgL_i1096z00_15478))->BgL_modz00)),
															BNIL);
														BgL_arg3066z00_18324 =
															MAKE_YOUNG_PAIR(BgL_arg3067z00_18325,
															BgL_arg3069z00_18326);
													}
													BgL_idz00_18323 =
														MAKE_YOUNG_PAIR
														(BGl_symbol5932z00zz__evaluate_compz00,
														BgL_arg3066z00_18324);
												}
											else
												{	/* Eval/evaluate_comp.scm 365 */
													BgL_idz00_18323 =
														(((BgL_ev_globalz00_bglt)
															COBJECT(BgL_i1096z00_15478))->BgL_namez00);
												}
											return
												BGl_everrorz00zz__everrorz00(
												(((BgL_ev_globalz00_bglt) COBJECT(BgL_i1096z00_15478))->
													BgL_locz00), BGl_string5807z00zz__evaluate_compz00,
												BGl_string5934z00zz__evaluate_compz00, BgL_idz00_18323);
										}
									else
										{	/* Eval/evaluate_comp.scm 364 */
											return BgL_vz00_18318;
										}
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 362 */
								return BgL_vz00_18318;
							}
					}
				}
			}
		}

	}



/* &comp-ev_setlocal1399 */
	obj_t BGl_z62compzd2ev_setlocal1399zb0zz__evaluate_compz00(obj_t
		BgL_envz00_15482, obj_t BgL_ez00_15483, obj_t BgL_stkz00_15484)
	{
		{	/* Eval/evaluate_comp.scm 321 */
			{	/* Eval/evaluate_comp.scm 323 */
				obj_t BgL_iz00_18328;
				obj_t BgL_ez00_18329;

				{	/* Eval/evaluate_comp.scm 323 */
					BgL_ev_varz00_bglt BgL_arg3017z00_18330;

					BgL_arg3017z00_18330 =
						(((BgL_ev_setlocalz00_bglt) COBJECT(
								((BgL_ev_setlocalz00_bglt) BgL_ez00_15483)))->BgL_vz00);
					BgL_iz00_18328 =
						BGl__indexz00zz__evaluate_compz00(
						((obj_t) BgL_arg3017z00_18330), BgL_stkz00_15484);
				}
				{	/* Eval/evaluate_comp.scm 323 */
					BgL_ev_exprz00_bglt BgL_arg3019z00_18331;

					BgL_arg3019z00_18331 =
						(((BgL_ev_hookz00_bglt) COBJECT(
								((BgL_ev_hookz00_bglt)
									((BgL_ev_setlocalz00_bglt) BgL_ez00_15483))))->BgL_ez00);
					BgL_ez00_18329 =
						BGl_compz00zz__evaluate_compz00(BgL_arg3019z00_18331,
						BgL_stkz00_15484);
				}
				if (CBOOL(
						(((BgL_ev_varz00_bglt) COBJECT(
									(((BgL_ev_setlocalz00_bglt) COBJECT(
												((BgL_ev_setlocalz00_bglt) BgL_ez00_15483)))->
										BgL_vz00)))->BgL_effz00)))
					{	/* Eval/evaluate_comp.scm 326 */
						obj_t BgL_zc3z04anonymousza33004ze3z87_18332;

						BgL_zc3z04anonymousza33004ze3z87_18332 =
							MAKE_FX_PROCEDURE
							(BGl_z62zc3z04anonymousza33004ze3ze5zz__evaluate_compz00,
							(int) (((long) 1)), (int) (((long) 2)));
						PROCEDURE_SET(BgL_zc3z04anonymousza33004ze3z87_18332,
							(int) (((long) 0)), BgL_iz00_18328);
						PROCEDURE_SET(BgL_zc3z04anonymousza33004ze3z87_18332,
							(int) (((long) 1)), BgL_ez00_18329);
						return BgL_zc3z04anonymousza33004ze3z87_18332;
					}
				else
					{	/* Eval/evaluate_comp.scm 328 */
						obj_t BgL_zc3z04anonymousza33010ze3z87_18333;

						BgL_zc3z04anonymousza33010ze3z87_18333 =
							MAKE_FX_PROCEDURE
							(BGl_z62zc3z04anonymousza33010ze3ze5zz__evaluate_compz00,
							(int) (((long) 1)), (int) (((long) 2)));
						PROCEDURE_SET(BgL_zc3z04anonymousza33010ze3z87_18333,
							(int) (((long) 0)), BgL_iz00_18328);
						PROCEDURE_SET(BgL_zc3z04anonymousza33010ze3z87_18333,
							(int) (((long) 1)), BgL_ez00_18329);
						return BgL_zc3z04anonymousza33010ze3z87_18333;
					}
			}
		}

	}



/* &<@anonymous:3004> */
	obj_t BGl_z62zc3z04anonymousza33004ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_15485, obj_t BgL_sz00_15488)
	{
		{	/* Eval/evaluate_comp.scm 326 */
			{	/* Eval/evaluate_comp.scm 326 */
				obj_t BgL_iz00_15486;
				obj_t BgL_ez00_15487;

				BgL_iz00_15486 = PROCEDURE_REF(BgL_envz00_15485, (int) (((long) 0)));
				BgL_ez00_15487 = PROCEDURE_REF(BgL_envz00_15485, (int) (((long) 1)));
				{	/* Eval/evaluate_comp.scm 326 */
					obj_t BgL_bpz00_18334;

					BgL_bpz00_18334 = VECTOR_REF(((obj_t) BgL_sz00_15488), ((long) 0));
					{	/* Eval/evaluate_comp.scm 327 */
						obj_t BgL_arg3005z00_18335;
						obj_t BgL_arg3006z00_18336;

						{	/* Eval/evaluate_comp.scm 327 */
							long BgL_arg3009z00_18337;

							BgL_arg3009z00_18337 =
								((long) CINT(BgL_bpz00_18334) + (long) CINT(BgL_iz00_15486));
							BgL_arg3005z00_18335 =
								VECTOR_REF(((obj_t) BgL_sz00_15488), BgL_arg3009z00_18337);
						}
						BgL_arg3006z00_18336 =
							PROCEDURE_ENTRY(BgL_ez00_15487) (BgL_ez00_15487, BgL_sz00_15488,
							BEOA);
						{	/* Eval/evaluate_comp.scm 202 */
							obj_t BgL_xz00_18338;

							{	/* Eval/evaluate_comp.scm 202 */
								int BgL_auxz00_34326;
								obj_t BgL_tmpz00_34324;

								BgL_auxz00_34326 = (int) (((long) 0));
								BgL_tmpz00_34324 = ((obj_t) BgL_arg3005z00_18335);
								BgL_xz00_18338 =
									STRUCT_SET(BgL_tmpz00_34324, BgL_auxz00_34326,
									BgL_arg3006z00_18336);
							}
							return BUNSPEC;
						}
					}
				}
			}
		}

	}



/* &<@anonymous:3010> */
	obj_t BGl_z62zc3z04anonymousza33010ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_15489, obj_t BgL_sz00_15492)
	{
		{	/* Eval/evaluate_comp.scm 328 */
			{	/* Eval/evaluate_comp.scm 328 */
				obj_t BgL_iz00_15490;
				obj_t BgL_ez00_15491;

				BgL_iz00_15490 = PROCEDURE_REF(BgL_envz00_15489, (int) (((long) 0)));
				BgL_ez00_15491 = PROCEDURE_REF(BgL_envz00_15489, (int) (((long) 1)));
				{	/* Eval/evaluate_comp.scm 328 */
					obj_t BgL_bpz00_18339;

					BgL_bpz00_18339 = VECTOR_REF(((obj_t) BgL_sz00_15492), ((long) 0));
					{	/* Eval/evaluate_comp.scm 329 */
						long BgL_arg3015z00_18340;
						obj_t BgL_arg3016z00_18341;

						BgL_arg3015z00_18340 =
							((long) CINT(BgL_bpz00_18339) + (long) CINT(BgL_iz00_15490));
						BgL_arg3016z00_18341 =
							PROCEDURE_ENTRY(BgL_ez00_15491) (BgL_ez00_15491, BgL_sz00_15492,
							BEOA);
						return VECTOR_SET(((obj_t) BgL_sz00_15492), BgL_arg3015z00_18340,
							BgL_arg3016z00_18341);
					}
				}
			}
		}

	}



/* &comp-ev_var1397 */
	obj_t BGl_z62compzd2ev_var1397zb0zz__evaluate_compz00(obj_t BgL_envz00_15493,
		obj_t BgL_varz00_15494, obj_t BgL_stkz00_15495)
	{
		{	/* Eval/evaluate_comp.scm 316 */
			{	/* Eval/evaluate_comp.scm 317 */
				obj_t BgL_iz00_18343;

				BgL_iz00_18343 =
					BGl__indexz00zz__evaluate_compz00(
					((obj_t) ((BgL_ev_varz00_bglt) BgL_varz00_15494)), BgL_stkz00_15495);
				{

					if (INTEGERP(BgL_iz00_18343))
						{	/* Eval/evaluate_comp.scm 319 */
							switch ((long) CINT(BgL_iz00_18343))
								{
								case ((long) 0):

									if (CBOOL(
											(((BgL_ev_varz00_bglt) COBJECT(
														((BgL_ev_varz00_bglt) BgL_varz00_15494)))->
												BgL_effz00)))
										{	/* Eval/evaluate_comp.scm 319 */
											return BGl_proc5935z00zz__evaluate_compz00;
										}
									else
										{	/* Eval/evaluate_comp.scm 319 */
											return BGl_proc5936z00zz__evaluate_compz00;
										}
									break;
								case ((long) 1):

									if (CBOOL(
											(((BgL_ev_varz00_bglt) COBJECT(
														((BgL_ev_varz00_bglt) BgL_varz00_15494)))->
												BgL_effz00)))
										{	/* Eval/evaluate_comp.scm 319 */
											return BGl_proc5937z00zz__evaluate_compz00;
										}
									else
										{	/* Eval/evaluate_comp.scm 319 */
											return BGl_proc5938z00zz__evaluate_compz00;
										}
									break;
								case ((long) 2):

									if (CBOOL(
											(((BgL_ev_varz00_bglt) COBJECT(
														((BgL_ev_varz00_bglt) BgL_varz00_15494)))->
												BgL_effz00)))
										{	/* Eval/evaluate_comp.scm 319 */
											return BGl_proc5939z00zz__evaluate_compz00;
										}
									else
										{	/* Eval/evaluate_comp.scm 319 */
											return BGl_proc5940z00zz__evaluate_compz00;
										}
									break;
								case ((long) 3):

									if (CBOOL(
											(((BgL_ev_varz00_bglt) COBJECT(
														((BgL_ev_varz00_bglt) BgL_varz00_15494)))->
												BgL_effz00)))
										{	/* Eval/evaluate_comp.scm 319 */
											return BGl_proc5941z00zz__evaluate_compz00;
										}
									else
										{	/* Eval/evaluate_comp.scm 319 */
											return BGl_proc5942z00zz__evaluate_compz00;
										}
									break;
								default:
								BgL_case_else1091z00_18344:
									if (CBOOL(
											(((BgL_ev_varz00_bglt) COBJECT(
														((BgL_ev_varz00_bglt) BgL_varz00_15494)))->
												BgL_effz00)))
										{	/* Eval/evaluate_comp.scm 319 */
											obj_t BgL_zc3z04anonymousza32993ze3z87_18345;

											BgL_zc3z04anonymousza32993ze3z87_18345 =
												MAKE_FX_PROCEDURE
												(BGl_z62zc3z04anonymousza32993ze3ze5zz__evaluate_compz00,
												(int) (((long) 1)), (int) (((long) 1)));
											PROCEDURE_SET(BgL_zc3z04anonymousza32993ze3z87_18345,
												(int) (((long) 0)), BgL_iz00_18343);
											return BgL_zc3z04anonymousza32993ze3z87_18345;
										}
									else
										{	/* Eval/evaluate_comp.scm 319 */
											obj_t BgL_zc3z04anonymousza33001ze3z87_18346;

											BgL_zc3z04anonymousza33001ze3z87_18346 =
												MAKE_FX_PROCEDURE
												(BGl_z62zc3z04anonymousza33001ze3ze5zz__evaluate_compz00,
												(int) (((long) 1)), (int) (((long) 1)));
											PROCEDURE_SET(BgL_zc3z04anonymousza33001ze3z87_18346,
												(int) (((long) 0)), BgL_iz00_18343);
											return BgL_zc3z04anonymousza33001ze3z87_18346;
										}
								}
						}
					else
						{	/* Eval/evaluate_comp.scm 319 */
							goto BgL_case_else1091z00_18344;
						}
				}
			}
		}

	}



/* &<@anonymous:2981> */
	obj_t BGl_z62zc3z04anonymousza32981ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_15496, obj_t BgL_sz00_15497)
	{
		{	/* Eval/evaluate_comp.scm 319 */
			{	/* Eval/evaluate_comp.scm 319 */
				obj_t BgL_bpz00_18347;

				BgL_bpz00_18347 = VECTOR_REF(((obj_t) BgL_sz00_15497), ((long) 0));
				{	/* Eval/evaluate_comp.scm 319 */
					obj_t BgL_arg2982z00_18348;

					{	/* Eval/evaluate_comp.scm 319 */
						long BgL_arg2983z00_18349;

						BgL_arg2983z00_18349 = ((long) CINT(BgL_bpz00_18347) + ((long) 3));
						BgL_arg2982z00_18348 =
							VECTOR_REF(((obj_t) BgL_sz00_15497), BgL_arg2983z00_18349);
					}
					return STRUCT_REF(((obj_t) BgL_arg2982z00_18348), (int) (((long) 0)));
		}}}

	}



/* &<@anonymous:2984> */
	obj_t BGl_z62zc3z04anonymousza32984ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_15498, obj_t BgL_sz00_15499)
	{
		{	/* Eval/evaluate_comp.scm 319 */
			{	/* Eval/evaluate_comp.scm 319 */
				obj_t BgL_bpz00_18350;

				BgL_bpz00_18350 = VECTOR_REF(((obj_t) BgL_sz00_15499), ((long) 0));
				{	/* Eval/evaluate_comp.scm 319 */
					long BgL_arg2991z00_18351;

					BgL_arg2991z00_18351 = ((long) CINT(BgL_bpz00_18350) + ((long) 3));
					return VECTOR_REF(((obj_t) BgL_sz00_15499), BgL_arg2991z00_18351);
				}
			}
		}

	}



/* &<@anonymous:2974> */
	obj_t BGl_z62zc3z04anonymousza32974ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_15500, obj_t BgL_sz00_15501)
	{
		{	/* Eval/evaluate_comp.scm 319 */
			{	/* Eval/evaluate_comp.scm 319 */
				obj_t BgL_bpz00_18352;

				BgL_bpz00_18352 = VECTOR_REF(((obj_t) BgL_sz00_15501), ((long) 0));
				{	/* Eval/evaluate_comp.scm 319 */
					obj_t BgL_arg2976z00_18353;

					{	/* Eval/evaluate_comp.scm 319 */
						long BgL_arg2977z00_18354;

						BgL_arg2977z00_18354 = ((long) CINT(BgL_bpz00_18352) + ((long) 2));
						BgL_arg2976z00_18353 =
							VECTOR_REF(((obj_t) BgL_sz00_15501), BgL_arg2977z00_18354);
					}
					return STRUCT_REF(((obj_t) BgL_arg2976z00_18353), (int) (((long) 0)));
		}}}

	}



/* &<@anonymous:2978> */
	obj_t BGl_z62zc3z04anonymousza32978ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_15502, obj_t BgL_sz00_15503)
	{
		{	/* Eval/evaluate_comp.scm 319 */
			{	/* Eval/evaluate_comp.scm 319 */
				obj_t BgL_bpz00_18355;

				BgL_bpz00_18355 = VECTOR_REF(((obj_t) BgL_sz00_15503), ((long) 0));
				{	/* Eval/evaluate_comp.scm 319 */
					long BgL_arg2979z00_18356;

					BgL_arg2979z00_18356 = ((long) CINT(BgL_bpz00_18355) + ((long) 2));
					return VECTOR_REF(((obj_t) BgL_sz00_15503), BgL_arg2979z00_18356);
				}
			}
		}

	}



/* &<@anonymous:2968> */
	obj_t BGl_z62zc3z04anonymousza32968ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_15504, obj_t BgL_sz00_15505)
	{
		{	/* Eval/evaluate_comp.scm 319 */
			{	/* Eval/evaluate_comp.scm 319 */
				obj_t BgL_bpz00_18357;

				BgL_bpz00_18357 = VECTOR_REF(((obj_t) BgL_sz00_15505), ((long) 0));
				{	/* Eval/evaluate_comp.scm 319 */
					obj_t BgL_arg2969z00_18358;

					{	/* Eval/evaluate_comp.scm 319 */
						long BgL_arg2970z00_18359;

						BgL_arg2970z00_18359 = ((long) CINT(BgL_bpz00_18357) + ((long) 1));
						BgL_arg2969z00_18358 =
							VECTOR_REF(((obj_t) BgL_sz00_15505), BgL_arg2970z00_18359);
					}
					return STRUCT_REF(((obj_t) BgL_arg2969z00_18358), (int) (((long) 0)));
		}}}

	}



/* &<@anonymous:2971> */
	obj_t BGl_z62zc3z04anonymousza32971ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_15506, obj_t BgL_sz00_15507)
	{
		{	/* Eval/evaluate_comp.scm 319 */
			{	/* Eval/evaluate_comp.scm 319 */
				obj_t BgL_bpz00_18360;

				BgL_bpz00_18360 = VECTOR_REF(((obj_t) BgL_sz00_15507), ((long) 0));
				{	/* Eval/evaluate_comp.scm 319 */
					long BgL_arg2972z00_18361;

					BgL_arg2972z00_18361 = ((long) CINT(BgL_bpz00_18360) + ((long) 1));
					return VECTOR_REF(((obj_t) BgL_sz00_15507), BgL_arg2972z00_18361);
				}
			}
		}

	}



/* &<@anonymous:2959> */
	obj_t BGl_z62zc3z04anonymousza32959ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_15508, obj_t BgL_sz00_15509)
	{
		{	/* Eval/evaluate_comp.scm 319 */
			{	/* Eval/evaluate_comp.scm 319 */
				obj_t BgL_bpz00_18362;

				BgL_bpz00_18362 = VECTOR_REF(((obj_t) BgL_sz00_15509), ((long) 0));
				{	/* Eval/evaluate_comp.scm 319 */
					obj_t BgL_arg2960z00_18363;

					{	/* Eval/evaluate_comp.scm 319 */
						long BgL_arg2964z00_18364;

						BgL_arg2964z00_18364 = ((long) CINT(BgL_bpz00_18362) + ((long) 0));
						BgL_arg2960z00_18363 =
							VECTOR_REF(((obj_t) BgL_sz00_15509), BgL_arg2964z00_18364);
					}
					return STRUCT_REF(((obj_t) BgL_arg2960z00_18363), (int) (((long) 0)));
		}}}

	}



/* &<@anonymous:2965> */
	obj_t BGl_z62zc3z04anonymousza32965ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_15510, obj_t BgL_sz00_15511)
	{
		{	/* Eval/evaluate_comp.scm 319 */
			{	/* Eval/evaluate_comp.scm 319 */
				obj_t BgL_bpz00_18365;

				BgL_bpz00_18365 = VECTOR_REF(((obj_t) BgL_sz00_15511), ((long) 0));
				{	/* Eval/evaluate_comp.scm 319 */
					long BgL_arg2966z00_18366;

					BgL_arg2966z00_18366 = ((long) CINT(BgL_bpz00_18365) + ((long) 0));
					return VECTOR_REF(((obj_t) BgL_sz00_15511), BgL_arg2966z00_18366);
				}
			}
		}

	}



/* &<@anonymous:2993> */
	obj_t BGl_z62zc3z04anonymousza32993ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_15512, obj_t BgL_sz00_15514)
	{
		{	/* Eval/evaluate_comp.scm 319 */
			{	/* Eval/evaluate_comp.scm 319 */
				obj_t BgL_iz00_15513;

				BgL_iz00_15513 = PROCEDURE_REF(BgL_envz00_15512, (int) (((long) 0)));
				{	/* Eval/evaluate_comp.scm 319 */
					obj_t BgL_bpz00_18367;

					BgL_bpz00_18367 = VECTOR_REF(((obj_t) BgL_sz00_15514), ((long) 0));
					{	/* Eval/evaluate_comp.scm 319 */
						obj_t BgL_arg2995z00_18368;

						{	/* Eval/evaluate_comp.scm 319 */
							long BgL_arg3000z00_18369;

							BgL_arg3000z00_18369 =
								((long) CINT(BgL_bpz00_18367) + (long) CINT(BgL_iz00_15513));
							BgL_arg2995z00_18368 =
								VECTOR_REF(((obj_t) BgL_sz00_15514), BgL_arg3000z00_18369);
						}
						return
							STRUCT_REF(((obj_t) BgL_arg2995z00_18368), (int) (((long) 0)));
		}}}}

	}



/* &<@anonymous:3001> */
	obj_t BGl_z62zc3z04anonymousza33001ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_15515, obj_t BgL_sz00_15517)
	{
		{	/* Eval/evaluate_comp.scm 319 */
			{	/* Eval/evaluate_comp.scm 319 */
				obj_t BgL_iz00_15516;

				BgL_iz00_15516 = PROCEDURE_REF(BgL_envz00_15515, (int) (((long) 0)));
				{	/* Eval/evaluate_comp.scm 319 */
					obj_t BgL_bpz00_18370;

					BgL_bpz00_18370 = VECTOR_REF(((obj_t) BgL_sz00_15517), ((long) 0));
					{	/* Eval/evaluate_comp.scm 319 */
						long BgL_arg3002z00_18371;

						BgL_arg3002z00_18371 =
							((long) CINT(BgL_bpz00_18370) + (long) CINT(BgL_iz00_15516));
						return VECTOR_REF(((obj_t) BgL_sz00_15517), BgL_arg3002z00_18371);
					}
				}
			}
		}

	}



/* &comp-ev_trap1395 */
	obj_t BGl_z62compzd2ev_trap1395zb0zz__evaluate_compz00(obj_t BgL_envz00_15518,
		obj_t BgL_ez00_15519, obj_t BgL_stkz00_15520)
	{
		{	/* Eval/evaluate_comp.scm 289 */
			{	/* Eval/evaluate_comp.scm 291 */
				obj_t BgL_ez00_18373;

				{	/* Eval/evaluate_comp.scm 291 */
					BgL_ev_exprz00_bglt BgL_arg2956z00_18374;

					BgL_arg2956z00_18374 =
						(((BgL_ev_hookz00_bglt) COBJECT(
								((BgL_ev_hookz00_bglt)
									((BgL_ev_trapz00_bglt) BgL_ez00_15519))))->BgL_ez00);
					BgL_ez00_18373 =
						BGl_compz00zz__evaluate_compz00(BgL_arg2956z00_18374,
						BgL_stkz00_15520);
				}
				{	/* Eval/evaluate_comp.scm 292 */
					obj_t BgL_zc3z04anonymousza32950ze3z87_18375;

					BgL_zc3z04anonymousza32950ze3z87_18375 =
						MAKE_FX_PROCEDURE
						(BGl_z62zc3z04anonymousza32950ze3ze5zz__evaluate_compz00,
						(int) (((long) 1)), (int) (((long) 1)));
					PROCEDURE_SET(BgL_zc3z04anonymousza32950ze3z87_18375,
						(int) (((long) 0)), BgL_ez00_18373);
					return BgL_zc3z04anonymousza32950ze3z87_18375;
				}
			}
		}

	}



/* &<@anonymous:2950> */
	obj_t BGl_z62zc3z04anonymousza32950ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_15521, obj_t BgL_sz00_15523)
	{
		{	/* Eval/evaluate_comp.scm 292 */
			{	/* Eval/evaluate_comp.scm 292 */
				obj_t BgL_ez00_15522;

				BgL_ez00_15522 = PROCEDURE_REF(BgL_envz00_15521, (int) (((long) 0)));
				{	/* Eval/evaluate_comp.scm 292 */
					obj_t BgL_bpz00_18376;

					BgL_bpz00_18376 = VECTOR_REF(((obj_t) BgL_sz00_15523), ((long) 0));
					{	/* Eval/evaluate_comp.scm 293 */
						obj_t BgL_cmdz00_18377;

						BgL_cmdz00_18377 =
							PROCEDURE_ENTRY(BgL_ez00_15522) (BgL_ez00_15522, BgL_sz00_15523,
							BEOA);
						if ((BgL_cmdz00_18377 == BGl_symbol5943z00zz__evaluate_compz00))
							{	/* Eval/evaluate_comp.scm 294 */
								return BgL_bpz00_18376;
							}
						else
							{	/* Eval/evaluate_comp.scm 294 */
								if ((BgL_cmdz00_18377 == BGl_symbol5945z00zz__evaluate_compz00))
									{	/* Eval/evaluate_comp.scm 294 */
										return BGl_reset_profilez00zz__evaluate_compz00();
									}
								else
									{	/* Eval/evaluate_comp.scm 294 */
										if (
											(BgL_cmdz00_18377 ==
												BGl_symbol5947z00zz__evaluate_compz00))
											{	/* Eval/evaluate_comp.scm 294 */
												return BGl_get_profilez00zz__evaluate_compz00();
											}
										else
											{	/* Eval/evaluate_comp.scm 294 */
												if (
													(BgL_cmdz00_18377 ==
														BGl_symbol5949z00zz__evaluate_compz00))
													{	/* Eval/evaluate_comp.scm 302 */
														obj_t BgL_arg2955z00_18378;

														BgL_arg2955z00_18378 =
															BGl_findzd2statezd2zz__evaluate_compz00();
														return
															VECTOR_SET(
															((obj_t) BgL_arg2955z00_18378), ((long) 0),
															BINT(((long) 2)));
													}
												else
													{	/* Eval/evaluate_comp.scm 294 */
														return
															BGl_errorz00zz__errorz00
															(BGl_string5807z00zz__evaluate_compz00,
															BGl_string5951z00zz__evaluate_compz00,
															BgL_cmdz00_18377);
													}
											}
									}
							}
					}
				}
			}
		}

	}



/* imported-modules-init */
	obj_t BGl_importedzd2moduleszd2initz00zz__evaluate_compz00()
	{
		{	/* Eval/evaluate_comp.scm 15 */
			BGl_modulezd2initializa7ationz75zz__typez00(((long) 121046086),
				BSTRING_TO_STRING(BGl_string5952z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__errorz00(((long) 330490148),
				BSTRING_TO_STRING(BGl_string5952z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__biglooz00(((long) 180158922),
				BSTRING_TO_STRING(BGl_string5952z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__tvectorz00(((long) 135276775),
				BSTRING_TO_STRING(BGl_string5952z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__structurez00(((long) 128218210),
				BSTRING_TO_STRING(BGl_string5952z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__bexitz00(((long) 340267792),
				BSTRING_TO_STRING(BGl_string5952z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__bignumz00(((long) 6519932),
				BSTRING_TO_STRING(BGl_string5952z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__osz00(((long) 251314740),
				BSTRING_TO_STRING(BGl_string5952z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__dssslz00(((long) 443936801),
				BSTRING_TO_STRING(BGl_string5952z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__bitz00(((long) 439353001),
				BSTRING_TO_STRING(BGl_string5952z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__paramz00(((long) 453939141),
				BSTRING_TO_STRING(BGl_string5952z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__objectz00(((long) 193422112),
				BSTRING_TO_STRING(BGl_string5952z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__threadz00(((long) 224967693),
				BSTRING_TO_STRING(BGl_string5952z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__srfi4z00(((long) 467924964),
				BSTRING_TO_STRING(BGl_string5952z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5z00(((long) 68574988),
				BSTRING_TO_STRING(BGl_string5952z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(((long)
					93454137), BSTRING_TO_STRING(BGl_string5952z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_flonumz00(((long)
					437057797), BSTRING_TO_STRING(BGl_string5952z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_flonum_dtoaz00(((long)
					268155843), BSTRING_TO_STRING(BGl_string5952z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__r4_characters_6_6z00(((long)
					198620800), BSTRING_TO_STRING(BGl_string5952z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__r4_equivalence_6_2z00(((long)
					473309430), BSTRING_TO_STRING(BGl_string5952z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__r4_booleans_6_1z00(((long) 459519430),
				BSTRING_TO_STRING(BGl_string5952z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__r4_symbols_6_4z00(((long) 460262918),
				BSTRING_TO_STRING(BGl_string5952z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(((long) -400105135),
				BSTRING_TO_STRING(BGl_string5952z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(((long)
					9614678), BSTRING_TO_STRING(BGl_string5952z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__r4_control_features_6_9z00(((long)
					376927882), BSTRING_TO_STRING(BGl_string5952z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__r5_control_features_6_4z00(((long)
					228151370), BSTRING_TO_STRING(BGl_string5952z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(((long) 127905250),
				BSTRING_TO_STRING(BGl_string5952z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(((long) 331540577),
				BSTRING_TO_STRING(BGl_string5952z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(((long) 86988580),
				BSTRING_TO_STRING(BGl_string5952z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__ppz00(((long) 233942021),
				BSTRING_TO_STRING(BGl_string5952z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__readerz00(((long) 220648206),
				BSTRING_TO_STRING(BGl_string5952z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__prognz00(((long) 177147622),
				BSTRING_TO_STRING(BGl_string5952z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__expandz00(((long) 414007149),
				BSTRING_TO_STRING(BGl_string5952z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__evenvz00(((long) 528345299),
				BSTRING_TO_STRING(BGl_string5952z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__evcompilez00(((long) 492754569),
				BSTRING_TO_STRING(BGl_string5952z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__everrorz00(((long) 375872221),
				BSTRING_TO_STRING(BGl_string5952z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__evmodulez00(((long) 505897955),
				BSTRING_TO_STRING(BGl_string5952z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__evaluate_typesz00(((long) 0),
				BSTRING_TO_STRING(BGl_string5952z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__evaluate_uncompz00(((long) 193509656),
				BSTRING_TO_STRING(BGl_string5952z00zz__evaluate_compz00));
			return BGl_modulezd2initializa7ationz75zz__evaluate_usez00(((long)
					20669940), BSTRING_TO_STRING(BGl_string5952z00zz__evaluate_compz00));
		}

	}

#ifdef __cplusplus
}
#endif
